;File: Rose.Asm
;--------------------------------------------------------------------------
;Rose Curves draws curves expressed as a function of r and theta.
;
;Written by Victor Barger on April 2, 1986.
;--------------------------------------------------------------------------
		INCLUDE	MacTraps.D
		INCLUDE	QuickEqu.D
		INCLUDE	ToolEqu.D
;--------------------------------------------------------------------------
.trap	_FracMul	$A84A
.trap	_FracCos	$A847
.trap	_FracSin	$A848
;--------------------------------------------------------------------------
Radians		EQU	D3
TopButton	EQU	D3
BottomButton	EQU	D4
ModifyReg	EQU	D4
Increment	EQU	D4
MenuReg		EQU	D5
Counter		EQU	D5
CheckBox	EQU	D6
MenuItemReg	EQU	D6
FuncResult	EQU	A4

AppleMenuID	EQU	1
ControlMenuID	EQU	2

ParamDlgID	EQU	2000
DrawWindID	EQU	2001
InfoAlertID	EQU	2002

InitialScale	EQU	13
RealInitScale	EQU	460
;--------------------------------------------------------------------------
Start
	bsr	InitManagers		;initialize managers
	bsr	InitVariables		;initialize variables
	bsr	SetupMenu		;setup the menu
	bsr	SetupWindow		;draw the window

EventLoop
	_SystemTask			;periodic actions for da's
	clr	-(SP)
	move	#$0FFF,-(SP)
	pea	EventRecord
	_GetNextEvent			;get the next event
	move	(SP)+,D0
	beq.s	EventLoop		;no event, loop back
	bsr	HandleEvent		;handle the event
	beq.s	EventLoop		;if 0, continue; else quit
	rts

Beep
	move	#12,-(SP)
	_SysBeep
	rts
;--------------------------------------------------------------------------
InitManagers
	pea	-4(A5)
	_InitGraf
	_InitFonts
	move.l	#$0000FFFF,D0
	_FlushEvents
	_InitWindows
	_InitMenus
	clr.l	-(SP)
	_InitDialogs
	_TEInit
	_InitCursor
	rts
;--------------------------------------------------------------------------
InitVariables
	move	#3,Equation(A5)
	move	#InitialScale,Scale(A5)
	move.l	#RealInitScale,RealScale(A5)
	clr	Multilayered(A5)	;not multilayered
	move.l	#11520,D0
	_NewPtr				;create a new bit map
	lea	windowBitMap,A1
	move.l	A0,(A1)			;remember the pointer
	clr	drawn(A5)		;not drawn yet
	rts
;--------------------------------------------------------------------------
SetupMenu
	clr.l	-(SP)
	move	#AppleMenuID,-(SP)
	_GetRMenu			;get the apple menu
	move.l	(SP),AppleMenu(A5)
	move.l	(SP),-(SP)
	clr	-(SP)
	_InsertMenu			;insert the menu in the menu bar
	move.l	#'DRVR',-(SP)
	_AddResMenu			;add the DA's to the apple menu

	clr.l	-(SP)
	move	#ControlMenuID,-(SP)
	_GetRMenu			;get the control menu
	clr	-(SP)
	_InsertMenu			;insert the menu in the menu bar

	_DrawMenuBar			;draw the new menu bar
	rts
;--------------------------------------------------------------------------
SetupWindow
	clr.l	-(SP)
	move	#DrawWindID,-(SP)
	pea	WindowStorage(A5)
	move.l	#-1,-(SP)
	_GetNewWindow			;get the RoseCurves Window
	move.l	(SP),DrawPtr(A5)
	_SetPort			;set the new grafport
	rts
;--------------------------------------------------------------------------
HandleEvent
	move	Modify,ModifyReg
	move	What,D0
	add	D0,D0
	move	EventTable(D0),D0
	jmp	EventTable(D0)

EventTable
	DC	NextEvent-EventTable
	DC	MouseDown-EventTable
	DC	NextEvent-EventTable
	DC	KeyDown-EventTable
	DC	NextEvent-EventTable
	DC	KeyDown-EventTable
	DC	Update-EventTable
	DC	NextEvent-EventTable
	DC	Activate-EventTable
	DC	NextEvent-EventTable
	DC	NextEvent-EventTable
;--------------------------------------------------------------------------
Activate
	move.l	DrawPtr(A5),D0
	cmp.l	Message,D0		;was it our window?
	bne	NextEvent		;no, get next event
	btst	#0,ModifyReg		;activate?
	beq	NextEvent		;no, deactivate

SetOurPort
	move.l	DrawPtr(A5),-(SP)	;push pointer to draw window
	_SetPort			;set our port
	bra	NextEvent
;--------------------------------------------------------------------------
Update
	move.l	Message,D0		;get the window ptr
	cmp.l	DrawPtr(A5),D0
	bne	NextEvent

	tst	drawn(A5)
	bne.s	copyIt
	move.l	DrawPtr(A5),-(SP)	;push window ptr
	_SetPort			;set the port
	move.l	DrawPtr(A5),-(SP)
	_BeginUpdate
	move.l	DrawPtr(A5),-(SP)
	_EndUpdate
	pea	windowRect
	_EraseRect
	bsr	DrawRose		;draw the rose
	bra	NextEvent

copyIt
	move.l	DrawPtr(A5),-(SP)	;push window ptr
	_SetPort			;set the port
	move.l	DrawPtr(A5),-(SP)
	_BeginUpdate
	pea	windowBitMap		;get the rose from the bitMap
	move.l	drawPtr(A5),A0
	pea	portBits(A0)		;put the rose in our window
	pea	windowRect		;same rect for src and dest
	pea	windowRect
	clr	-(SP)			;srcCopy
	clr.l	-(SP)			;no maskRgn
	_CopyBits			;copy It
	move.l	DrawPtr(A5),-(SP)
	_EndUpdate
	bra	NextEvent
;--------------------------------------------------------------------------
KeyDown
	btst	#8,ModifyReg		;is the command key down?
	beq	NextEvent		;no, exit
	clr.l	-(SP)			;space for menu and item
	move	Message+2,-(SP)		;get character
	_MenuKey			;see if its a command
	move	(SP)+,MenuReg		;preserve menu
	move	(SP)+,MenuItemReg	;and Menu item
	bra.s	Choices
;--------------------------------------------------------------------------
MouseDown
	clr	-(SP)			;space for result
	move.l	Point,-(SP)		;get mouse coordinates
	pea	WWindow			;push event window
	_FindWindow			;find the window
	move	(SP)+,D0		;get region number
	add	D0,D0			;*2 for index into table
	move	WindowTable(D0),D0	;point to routine offset
	jmp	WindowTable(D0)		;jump to routine
	
WindowTable
	DC	NextEvent-WindowTable	;in desk (not used)
	DC	InMenu-WindowTable	;in menu bar
	DC	SystemEvent-WindowTable	;in system window
	DC	NextEvent-WindowTable	;in content (not used)
	DC	NextEvent-WindowTable	;in drag (not used)
	DC	NextEvent-WindowTable	;in grow (not used)
	DC	QuitRoutine-WindowTable	;in go away
;--------------------------------------------------------------------------
SystemEvent
	pea	EventRecord		;ptr to the event record
	move.l	WWindow,-(SP)		;push window ptr
	_SystemClick			;let system take care of it
	bra	NextEvent		;next event
;--------------------------------------------------------------------------
InMenu
	clr.l	-(SP)			;space for menu choice
	move.l	Point,-(SP)		;mouse at time of event
	_MenuSelect			;menu select
	move	(SP)+,MenuReg		;preserve menu
	move	(SP)+,MenuItemReg	;preserve menu item

Choices
	cmp	#2,MenuReg		;was it the control menu?
	bne.s	NotQuit			;no
	cmp	#2,MenuItemReg		;Quit selected?
	bne.s	NotQuit			;no, continue
	bsr	UnHiliteMenu		;unhilight the menu bar
QuitRoutine
	move.l	DrawPtr(A5),-(SP)	;push ptr to the draw window
	_CloseWindow			;close the window
	move.l	windowBitMap,A0
	_DisposPtr			;dispose of the bitmap
	move	#-1,D0			;say it was Quit
	rts

NotQuit
	cmp	#1,MenuReg		;in apple menu?
	beq.s	InAppleMenu		;yes, go do apple menu
	cmp	#2,MenuReg		;in file menu?
	beq	ParameterChange		;yes

ChoiceReturn
	bsr	UnHiliteMenu		;unhilight the menu bar
					;fall through to get next event
;--------------------------------------------------------------------------
NextEvent
	moveq	#0,D0			;say it's not Quit
	rts				;return to event loop
;--------------------------------------------------------------------------
UnhiliteMenu
	clr	-(SP)			;all menus
	_HiLiteMenu			;unhilite every one
	rts
;--------------------------------------------------------------------------
InAppleMenu
	cmp	#1,MenuItemReg
	beq.s	Info

	move.l	AppleMenu(A5),-(SP)
	move	MenuItemReg,-(SP)
	pea	DeskName
	_GetItem			;get name of the desk accessory
	clr	-(SP)
	pea	DeskName
	_OpenDeskAcc			;open the desk accessory
	move	(SP)+,D0

RestoreOurPort
	bsr	SetOurPort
	bra	ChoiceReturn

Info
	clr	-(SP)
	move	#InfoAlertID,-(SP)
	clr.l	-(SP)
	_Alert				;handle the infoAlert
	move	(SP)+,D0
	bra	RestoreOurPort
;--------------------------------------------------------------------------
ParameterChange
	clr.l	-(SP)
	move	#ParamDlgID,-(SP)
	pea	DStorage
	move.l	#-1,-(SP)
	_GetNewDialog			;get the dialog
	move.l	(SP),ParamDlgPtr(A5)	;preserve the dialogPtr

	_SetPort			;set the port

	move	Equation(A5),TopButton	;TopButton = current button
					;highlighted in top section
	move	TopButton,D0
	bsr	FindButton		;sub. to return handle
	move.l	itemHandle(A5),-(SP)
	move	#1,-(SP)
	_SetCtlValue			;highlight the button
	
	move	Scale(A5),BottomButton	;BottomButton = current button in
					;bottom section
	move	BottomButton,D0
	bsr	FindButton
	move.l	itemHandle(A5),-(SP)
	move	#1,-(SP)
	_SetCtlValue			;highlight the button

	move	Multilayered(A5),CheckBox
	move	#17,D0
	bsr	FindButton		;get handle to check-box
	move.l	itemHandle(A5),-(SP)
	move	CheckBox,-(SP)
	_SetCtlValue			;check or uncheck it

RepeatLoop
	clr.l	-(SP)
	pea	ItemHit
	_ModalDialog			;modal dialog

	move	ItemHit,D1
	cmp	#2,D1			;was it Cancel?
	beq	Done			;yes
	cmp	#1,D1			;was it OK?
	beq	SetNewParams		;yes
	cmp	#9,D1			;was it in the bottom set?
	bge.s	BottomSet		;yes

	move	TopButton,D0
	move	D1,TopButton		;set new button number
	bsr	FindButton		;get handle to last button
	move.l	itemHandle(A5),-(SP)
	clr	-(SP)
	_SetCtlValue			;unhighlight last button

	move	TopButton,D0
	bsr	FindButton
	move.l	itemHandle(A5),-(SP)
	move	#1,-(SP)
	_SetCtlValue			;highlight new button
	bra.s	RepeatLoop

BottomSet
	cmp	#14,D1			;in bottom set?
	bge.s	CheckForBox		;no

	move	BottomButton,D0
	move	D1,BottomButton
	bsr	FindButton		;get handle to last button
	move.l	itemHandle(A5),-(SP)
	clr	-(SP)
	_SetCtlValue			;unhighlight last button

	move	BottomButton,D0
	bsr	FindButton
	move.l	itemHandle(A5),-(SP)
	move	#1,-(SP)
	_SetCtlValue			;highlight new button
	bra	RepeatLoop

CheckForBox
	cmp	#17,D1			;click in the check box?
	bne	RepeatLoop
	cmp	#1,CheckBox
	bne.s	NotOne
	move	#0,CheckBox
	bra.s	SetCheck

NotOne
	move	#1,CheckBox
SetCheck
	move	#17,D0
	bsr	FindButton		;get handle to check-box
	move.l	itemHandle(A5),-(SP)
	move	CheckBox,-(SP)
	_SetCtlValue			;check or uncheck it
	bra	RepeatLoop

SetNewParams
	clr	drawn(A5)
	move	TopButton,Equation(A5)	;set new equation number
	move	BottomButton,Scale(A5)	;set new scale
	move	CheckBox,Multilayered(A5)	;set multilayered
	move	Scale(A5),D0
	sub	#9,D0
	asl.l	#2,D0
	move.l	ScaleTable(D0),RealScale(A5)	;look up real scale

Done
	move.l	ParamDlgPtr(A5),-(SP)
	_CloseDialog			;close the dialog
	bra	RestoreOurPort

ScaleTable
	DC.L	140,220,300,380,460
;--------------------------------------------------------------------------
FindButton
	move.l	ParamDlgPtr(A5),-(SP)
	move	D0,-(SP)
	pea	itemType
	pea	itemHandle(A5)
	pea	dispRect
	_GetDItem			;get handle to itemnumber in D0
	rts
;--------------------------------------------------------------------------
;to convert a fractional number to type fract, multipy by 65536
DrawRose
	clr.l	-(SP)
	move	#4,-(SP)
	_GetCursor			;get the watch cursor (ID=4)
	move.l	(SP)+,D0
	move.l	D0,A0
	move.l	(A0),-(SP)
	_SetCursor			;set the new cursor

	move.l	RealScale(A5),-(SP)	;preserve the realScale
DrawRose1
	move	#720,Counter		;721 steps (360 x 2)
	move.l	#572,Increment		;572 = .5 increment in radians
					;(.5/180)*65536
	moveq	#0,Radians		;present degrees

nextDegree
	bsr	EvalFunction		;evaluate fn r(Radians)

	sub	#14,SP
	move.l	Radians,-(SP)
	_FracSin
	move.l	FuncResult,-(SP)
	_FracMul			;y = fn r(Radians) * sin(Radians)
	move.l	RealScale(A5),-(SP)
	_FixMul				;y = y * realScale
	_HiWord
	move	(SP)+,y(A5)		;y = int(y)

	sub	#14,SP
	move.l	Radians,-(SP)
	_FracCos
	move.l	FuncResult,-(SP)
	_FracMul			;x = fn r(Radians) * cos(Radians)
	move.l	RealScale(A5),-(SP)
	_FixMul				;x = x * realScale
	_HiWord
	move	(SP)+,x(A5)		;x = int(x)

	move	x(A5),D0
	add	#154,D0
	move	D0,-(SP)		;x = x + 154

	move	y(A5),D0
	add	#144,D0
	move	D0,-(SP)		;y = y + 144

	tst	Radians
	bne.s	NotFirst
	_MoveTo				;moveto x,y if first point
	bra.s	Skip

NotFirst
	_LineTo				;else lineto x,y
Skip
	add.l	Increment,Radians	;Radians = Radians + Increment
	dbra	Counter,nextDegree	;loop back
	cmp	#1,Multilayered(A5)	;another layer?
	bne.s	NoExtraLayers		;no
	move.l	#20,D0
	sub.l	D0,RealScale(A5)	;decrease the real scale by 20
	cmp.l	RealScale(A5),D0	;is the real scale = 20?
	bne	DrawRose1		;no, do next layer

NoExtraLayers
	move	#1,drawn(A5)		;the rose has been drawn
	move.l	drawPtr(A5),A0
	pea	portBits(A0)		;put the rose in our window
	pea	windowBitMap		;get from offscreen bitmap
	pea	windowRect		;same size windowRect
	pea	windowRect
	clr	-(SP)			;srcCopy
	clr.l	-(SP)			;no mask region
	_CopyBits			;copy the bits
	move.l	(SP)+,RealScale(A5)
	_InitCursor
	rts
;--------------------------------------------------------------------------
EvalFunction
	move	Equation(A5),D0
	sub	#3,D0
	add	D0,D0
	move	EquationTable(D0),D0
	jmp	EquationTable(D0)

EquationTable
	DC	One-EquationTable	;sin 4r
	DC	Two-EquationTable	;cos (2 sin r)
	DC	Three-EquationTable	;cos (2 sin 2r)
	DC	Four-EquationTable	;cos (sin 100r)
	DC	Five-EquationTable	;cos (sin 8 r)
	DC	Six-EquationTable	;cos (4 sin 2r)
;--------------------------------------------------------------------------
None
	move.l	#0,FuncResult
	rts
;--------------------------------------------------------------------------
One
	;sin 4r
	clr.l	-(SP)
	move.l	Radians,D0
	asl.l	#2,D0
	move.l	D0,-(SP)
	_FracSin
	move.l	(SP)+,FuncResult	;fn r(Radians) = sin (Radians * 4)
	rts
;--------------------------------------------------------------------------
Two
	;cos (2 sin r)
	subq	#8,SP
	move.l	Radians,-(SP)
	_FracSin
	move.l	(SP),D0
	asr.l	#7,D0
	asr.l	#6,D0			;convert to fixed x 2
	move.l	D0,(SP)
	_FracCos
	move.l	(SP)+,FuncResult	;fn r(Radians) = cos (2 sin r)
	rts
;--------------------------------------------------------------------------
Three
	;cos (2 sin 2r)
	subq	#8,SP
	move.l	Radians,D0
	asl.l	#1,D0
	move.l	D0,-(SP)
	_FracSin
	move.l	(SP),D0
	asr.l	#7,D0
	asr.l	#6,D0			;convert to fixed x 2
	move.l	D0,(SP)
	_FracCos
	move.l	(SP)+,FuncResult	;fn r(Radians) = cos (2 sin 2r)
	rts
;--------------------------------------------------------------------------
Four
	;cos (sin 100r)
	sub	#12,SP
	move.l	Radians,-(SP)
	move.l	#3276800,-(SP)
	_FixMul
	_FracSin
	move.l	(SP),D0
	asr.l	#7,D0
	asr.l	#7,D0			;convert to fixed
	move.l	D0,(SP)
	_FracCos
	move.l	(SP)+,FuncResult	;fn r(Radians) = cos (sin 100r)
	rts
;--------------------------------------------------------------------------
Five
	;cos (sin 8 r)
	subq	#8,SP
	move.l	Radians,D0
	asl.l	#3,D0
	move.l	D0,-(SP)
	_FracSin
	move.l	(SP),D0
	asr.l	#7,D0
	asr.l	#7,D0
	move.l	D0,(SP)
	_FracCos
	move.l	(SP)+,FuncResult	;fn r(Radians) = cos (sin 8r)
	rts
;--------------------------------------------------------------------------
Six
	;cos (4 sin 2r)
	subq	#8,SP
	move.l	Radians,D0
	asl.l	#1,D0
	move.l	D0,-(SP)
	_FracSin
	move.l	(SP),D0
	asr.l	#7,D0
	asr.l	#5,D0
	move.l	D0,(SP)
	_FracCos
	move.l	(SP)+,FuncResult	;fn r(Radians) = cos (4 sin 2r)
	rts
;--------------------------------------------------------------------------
EventRecord
 What:		DC	0
 Message:	DC.L	0
 When:		DC.L	0
 Point:		DC.L	0
 Modify:	DC	0
 WWindow:	DC.L	0

windowRect	DC	0,0,288,308
windowBitMap	DC.L	0
		DC	40
		DC	0,0,288,308

ItemHit		DC	0
itemType	DC	0
dispRect	DC	0,0,0,0
DStorage	DCB	DWindLen,0
DeskName	DCB	16,0
;--------------------------------------------------------------------------
WindowStorage	DS	WindowSize	;storage for draw window
DrawPtr		DS.L	1		;pointer to draw window
AppleMenu	DS.L	1		;apple menu
Equation	DS	1		;equation number
Scale		DS	1		;scale
RealScale	DS.L	1		;longint real scale
MultiLayered	DS	1		;multilayered (0 = false, 1 = true)
ParamDlgPtr	DS.L	1		;pointer to the parameter dialog
itemHandle	DS.L	1		;itemHandle
y		DS	1		;y-value
x		DS	1		;x-value
drawn		DS	1
;--------------------------------------------------------------------------
		END