/* Copyright  1986 Apple Computer, Inc.  All Rights Reserved. */

#ifdef Debugging
include MacAppRFiles"Debug.rsrc";
#endif
include MacAppRFiles"MacApp.rsrc";
include MacAppRFiles"Printing.rsrc";

include "DemoText" 'CODE';

resource 'WIND' (1004, purgeable) {
	{50, 40, 250, 450},
	zoomDocProc,
	invisible,
	goAway,
	0x0,
	"<<<>>>"
};

resource 'SIZE' (-1) {
	saveScreen,
	acceptSuspendResumeEvents,
#ifdef Debugging
	(307-32) * 1024,
	(247-32) * 1024
#else
	(212-32) * 1024,
	(152-32) * 1024
#endif
};

/*	Printing to the LaserWriter is the time when the most temporary memory
	is in use.  We need the segments in use at that time, plus 40K for
	the driver's needs. */

resource 'seg!' (256, purgeable) {
	{
		"GSelCommand";
		"GPrint";
		"PrintNonRes";
		"ARes"
	}
};

resource 'mem!' (256, purgeable) {
	40 * 1024,			/* Add to temporary reserve */
	0,					/* Add to permanent reserve */
	0					/* Add to stack space */
};

resource 'DITL' (201, purgeable) {
	 {	/* array DITLarray: 3 elements */
		/* [1] */
		{130, 182, 150, 262},
		Button {
			enabled,
			"OK"
		};
		/* [2] */
		{10, 80, 110, 270},
		StaticText {
			disabled,
			"This sample program demonstrates"
			" how to use various features of "
			"the TEView building block of M"
			"acApp."
		};
		/* [3] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			1
		}
	}
};

resource 'ALRT' (201, purgeable) {
	{90, 100, 250, 412},
	201,
	{
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent
	}
};

/* Used when the user attempts to read a file larger than we can handle */

resource 'DITL' (1000, purgeable) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{82, 198, 100, 272},
		Button {
			enabled,
			"OK"
		};
		/* [2] */
		{10, 70, 77, 272},
		StaticText {
			disabled,
			"DemoText cant read the entire file because it is too long."
		};
		/* [3] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			0
		}
	}
};

resource 'ALRT' (1000, purgeable) {
	{100, 110, 210, 402},
	1000,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent;
		/* [2] */
		OK, visible, silent;
		/* [3] */
		OK, visible, silent;
		/* [4] */
		OK, visible, silent
	}
};

resource 'cmnu' (1) {
	1,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	 {	/* array: 2 elements */
		/* [1] */
		"About DemoText", noIcon, noKey, noMark, plain, 1;
		/* [2] */
		"-", noIcon, noKey, noMark, plain, nocommand
	}
};

resource 'cmnu' (2) {
	2,
	textMenuProc,
	0x7FFFEEFB,
	enabled,
	"File",
	 {	/* array: 14 elements */
		/* [1] */
		"New", noIcon, "N", noMark, plain, 10;
		/* [2] */
		"Open", noIcon, noKey, noMark, plain, 20;
		/* [3] */
		"-", noIcon, noKey, noMark, plain, nocommand;
		/* [4] */
		"Close", noIcon, noKey, noMark, plain, 31;
		/* [5] */
		"Save", noIcon, noKey, noMark, plain, 30;
		/* [6] */
		"Save As", noIcon, noKey, noMark, plain, 32;
		/* [7] */
		"Save a Copy In", noIcon, noKey, noMark, plain, 33;
		/* [8] */
		"Revert", noIcon, noKey, noMark, plain, 34;
		/* [9] */
		"-", noIcon, noKey, noMark, plain, nocommand;
		/* [10] */
		"Page Setup", noIcon, noKey, noMark, plain, 176;
		/* [11] */
		"Print One", noIcon, noKey, noMark, plain, 177;
		/* [12] */
		"Print", noIcon, noKey, noMark, plain, 178;
		/* [13] */
		"-", noIcon, noKey, noMark, plain, nocommand;
		/* [14] */
		"Quit", noIcon, "Q", noMark, plain, 36
	}
};

resource 'cmnu' (3) {
	3,
	textMenuProc,
	0x7FFFFEBD,
	enabled,
	"Edit",
	 {	/* array: 10 elements */
		/* [1] */
		"Undo", noIcon, "Z", noMark, plain, 101;
		/* [2] */
		"-", noIcon, noKey, noMark, plain, nocommand;
		/* [3] */
		"Cut", noIcon, "X", noMark, plain, 103;
		/* [4] */
		"Copy", noIcon, "C", noMark, plain, 104;
		/* [5] */
		"Paste", noIcon, "V", noMark, plain, 105;
		/* [6] */
		"Clear", noIcon, noKey, noMark, plain, 106;
		/* [7] */
		"-", noIcon, noKey, noMark, plain, nocommand;
		/* [8] */
		"Select All", noIcon, "A", noMark, plain, 110;
		/* [9] */
		"-", noIcon, noKey, noMark, plain, nocommand;
		/* [10] */
		"Show Clipboard", noIcon, noKey, noMark, plain, 35
	}
};

resource 'cmnu' (4) {
	4,
	textMenuProc,
	0x7FFFFF37,
	enabled,
	"Page",
	 {	/* array: 6 elements */
		/* [1] */
		"Show Page Breaks", noIcon, noKey, noMark, plain, 201;
		/* [2] */
		"Show Page Numbers", noIcon, noKey, noMark, plain, 211;
		/* [3] */
		"Number Pages Top to Bottom", noIcon, noKey, noMark, plain, 206;
		/* [4] */
		"-", noIcon, noKey, noMark, plain, nocommand;
		/* [5] */
		"Draw Frame when Printing", noIcon, noKey, noMark, plain, 202;
		/* [6] */
		"Print Page Numbers when Printing", noIcon, noKey, noMark, plain, 207
	}
};

resource 'cmnu' (5) {
	5,
	textMenuProc,
	0x7FFFFEF7,
	enabled,
	"Text",
	 {	/* array: 12 elements */
		/* [1] */
		"View as wide as frame", noIcon, noKey, noMark, plain, 601;
		/* [2] */
		"View width frozen", noIcon, noKey, noMark, plain, 602;
		/* [3] */
		"View as wide as one page", noIcon, noKey, noMark, plain, 603;
		/* [4] */
		"-", noIcon, noKey, noMark, plain, nocommand;
		/* [5] */
		"View as high as the frame", noIcon, noKey, noMark, plain, 604;
		/* [6] */
		"View height an exact number of p"
		"ages", noIcon, noKey, noMark, plain, 605;
		/* [7] */
		"View as high as its content", noIcon, noKey, noMark, plain, 606;
		/* [8] */
		"View height frozen", noIcon, noKey, noMark, plain, 607;
		/* [9] */
		"-", noIcon, noKey, noMark, plain, nocommand;
		/* [10] */
		"Left justified", noIcon, noKey, noMark, plain, 608;
		/* [11] */
		"Center justified", noIcon, noKey, noMark, plain, 609;
		/* [12] */
		"Right justified", noIcon, noKey, noMark, plain, 610
	}
};

resource 'MENU' (6) {
	6,
	textMenuProc,
	allEnabled,
	enabled,
	"Font",
	 {	/* array: 0 elements */

	}
};

resource 'cmnu' (7) {
	7,
	textMenuProc,
	0x7FFFFFBF,
	enabled,
	"Style",
	 {	/* array: 13 elements */
		/* [1] */
		"9 Point", noIcon, noKey, noMark, plain, 1109;
		/* [2] */
		"10 Point", noIcon, noKey, noMark, plain, 1110;
		/* [3] */
		"12 Point", noIcon, noKey, noMark, plain, 1112;
		/* [4] */
		"14 Point", noIcon, noKey, noMark, plain, 1114;
		/* [5] */
		"18 Point", noIcon, noKey, noMark, plain, 1118;
		/* [6] */
		"24 Point", noIcon, noKey, noMark, plain, 1124;
		/* [7] */
		"-", noIcon, noKey, noMark, plain, nocommand;
		/* [8] */
		"Plain Text", noIcon, "P", noMark, plain, 1201;
		/* [9] */
		"Bold", noIcon, "B", noMark, plain, 1202;
		/* [10] */
		"Italic", noIcon, "I", noMark, plain, 1203;
		/* [11] */
		"Underline", noIcon, "U", noMark, plain, 1204;
		/* [12] */
		"Outline", noIcon, "O", noMark, plain, 1205;
		/* [13] */
		"Shadow", noIcon, "S", noMark, plain, 1206
	}
};

resource 'cmnu' (128) {
	128,
	textMenuProc,
	allEnabled,
	enabled,
	"Buzzwords",
	{	/* array: 6 elements */
		"Typing", noIcon, noKey, noMark, plain, 120;
		"Size Change", noIcon, noKey, noMark, plain, 1100;
		"Style Change", noIcon, noKey, noMark, plain, 1200;
		"Justification Change", noIcon, noKey, noMark, plain, 1300;
		"Font Change", noIcon, noKey, noMark, plain, 1301;
		"Page Setup Change", noIcon, noKey, noMark, plain, 192
	}
};

resource 'MBAR' (128) {
	{1; 2; 3; 4; 5; 6; 7}
};

