#include "VIPtoC.h"

/* Global symbols */

char
	Menu[3],
	Quit,
	Window,
	result;




/*
-------------- main --------------
V.I.P. Demo program for MacTutor
by Bill Luckie   1987

Visual Interactive Programming
V.I.P. by Dominique Lienart, published by Mainstay.*/
main ()
{
VIP_Init ();
vip_DoSetup ();
while (! Quit)
	{
	vip_DoSelect ();
	}
VIP_Exit ();
}


/*
-------------- About --------------
*/
vip_About ()
{

char
	AboutFile;

Rect
	PortRect,
	WindowRect;


VIP_set_rect ((long)(50),(long)(40),(long)(312),(long)(472),&WindowRect);
VIP_set_rect ((long)(0),(long)(0),(long)(1000),(long)(432),&PortRect);
VIP_new_window ((char)(2),(char)(1),(char)(1),WindowRect,PortRect,"About GC_ Dist",
		&Window);
VIP_open_file ("AboutGCDist",(char)(1),"TEXT",&AboutFile);
VIP_load_text ((char)(AboutFile),(char)(Window));
VIP_close_file ((char)(AboutFile));
}


/*
-------------- DoCloseBox --------------
*/
vip_DoCloseBox ()
{
if (Window)
	{
	VIP_kill_window ((char)(Window));
	Window = 0;
	}
}


/*
-------------- DoDialogEvent --------------
*/
vip_DoDialogEvent ()
{
}


/*
-------------- DoEdit --------------
*/
vip_DoEdit (item)
	char item;
{
switch ((long)(item))
	{
	case 3:
		{
		VIP_cut_text ();
		break;
		}
	case 4:
		{
		VIP_copy_text ();
		break;
		}
	case 5:
		{
		VIP_paste_text ();
		break;
		}
	case 6:
		{
		VIP_clear_text ();
		break;
		}
	}
}


/*
-------------- DoFile --------------
*/
vip_DoFile (item)
	char item;
{
switch ((long)(item))
	{
	case 1:
		{
		VIP_set_up_page ();
		break;
		}
	case 2:
		{
		if (Window)
			{
			VIP_print_text ((char)(Window));
			}
		else
			{
			VIP_alert ((char)(1),"There is no window to print from.",&result);
			}
		break;
		}
	case 4:
		{
		Quit = 1;
		break;
		}
	}
}


/*
-------------- DoMenuSelect --------------
*/
vip_DoMenuSelect (menu,item)
	char menu;
	char item;
{
if (menu == Menu[(1) - 1])
	{
	vip_DoFile ((char)(item));
	}
else if (menu == Menu[(2) - 1])
	{
	vip_DoEdit ((char)(item));
	}
else if (menu == Menu[(3) - 1])
	{
	vip_DoOptions ((char)(item));
	}
}


/*
-------------- DoOptions --------------
*/
vip_DoOptions (item)
	char item;
{
switch ((long)(item))
	{
	case 1:
		{
		VIP_alert ((char)(1),"This is the Create_Records routine.",&result);
		break;
		}
	case 2:
		{
		VIP_alert ((char)(1),"This is the View_Records routine.",&result);
		break;
		}
	case 3:
		{
		VIP_alert ((char)(1),"This is the Compute Distance... routine.",
		&result);
		break;
		}
	case 5:
		{
		vip_About ();
		break;
		}
	}
}


/*
-------------- DoSelect --------------
*/
vip_DoSelect ()
{

char
	EventID,
	EventMessage,
	EventType;

Point
	MouseLocation;


VIP_get_next_event (&EventType,&MouseLocation,&EventMessage,&EventID);
switch ((long)(EventType))
	{
	case 1:
		{
		vip_DoMenuSelect ((char)(EventMessage),(char)(EventID));
		break;
		}
	case 4:
		{
		vip_DoCloseBox ();
		break;
		}
	case 5:
		{
		vip_DoDialogEvent ();
		break;
		}
	}
}


/*
-------------- DoSetup --------------
*/
vip_DoSetup ()
{

Rect
	Portrect,
	Windowrect;


VIP_new_menu ("File",&Menu[(1) - 1]);
VIP_append_menu_item ((char)(Menu[(1) - 1]),"Page Setup...;Print...;(-;Quit/Q");
VIP_new_menu ("Edit",&Menu[(2) - 1]);
VIP_append_menu_item ((char)(Menu[(2) - 1]),"(Undo/Z;(-;Cut/X;Copy/C;Paste/V;Clear");
VIP_new_menu ("Options",&Menu[(3) - 1]);
VIP_append_menu_item ((char)(Menu[(3) - 1]),"Create new Records...;View or Edit Records...;Compute Distance...;(-;About GC_Dist");
VIP_set_rect ((long)(60),(long)(60),(long)(120),(long)(450),&Windowrect);
VIP_set_rect ((long)(0),(long)(0),(long)(120),(long)(450),&Portrect);
VIP_new_window ((char)(4),(char)(1),(char)(1),Windowrect,Portrect,"",
		&Window);
VIP_set_text_font ((char)(0));
VIP_move_to ((long)(15),(long)(75));
VIP_draw_string ("V.I.P. Demo program for MacTutor",(char)(0));
VIP_move_to ((long)(30),(long)(145));
VIP_draw_string (" by Bill Luckie.",(char)(0));
VIP_move_to ((long)(45),(long)(168));
VIP_draw_string (" 1987",(char)(0));
VIP_wait ((long)(200));
VIP_kill_window ((char)(Window));
}


vip_draw_port (wndwID)
	char wndwID;
{
}