( Mach 2 background applications under Switcher )
( Feb 1987 J. Langowski / MacTutor )

only forth also assembler also mac 
HEX

( =============== File System Equates ============= )


1	CONSTANT	fsRdPerm	( read-only)
2	CONSTANT	fsWrPerm	( write-only)
3	CONSTANT	fsRdWrPerm	( read-write)

0	CONSTANT	fsAtMark
1	CONSTANT	fsFromStart
2	CONSTANT	fsFromLEOF
3	CONSTANT	fsFromMark

3	CONSTANT	stdFile

0	CONSTANT    rGood
6	CONSTANT    rVolume
A	CONSTANT    rName

C	CONSTANT	ioCompletion
10	CONSTANT	ioResult
12	CONSTANT	ioFileName
16	CONSTANT	ioVRefNum
18	CONSTANT	ioRefNum
1A	CONSTANT	ioFileType
1B	CONSTANT	ioPermssn
1C	CONSTANT	ioMisc
20	CONSTANT	ioBuffer
24	CONSTANT	ioReqCount
28	CONSTANT	ioActCount
2C	CONSTANT	ioPosMode
2E	CONSTANT	ioPosOffset

FFD9	CONSTANT	PastEOF ( error code -39. used in file read operations )	


DECIMAL
HEADER	typeList
	DC.B	'TEXT'

HEADER	sfReplyA
	DC.B	0		( good )
	DC.B	0		( copy   pg.25 PackSF )
	DC.B	'TEXT'		( fType )
	DC.W	0		( vRefNum )
	DC.W	0		( version )
	DCB.B	64,0		( fName [string 63] )
		

HEADER	PortBOut
	DC.B	5
	DC.B	'.Bout'
	

( ====  Various Imagewriter commands ======= )

( Top-Of-Form			CTRL-L  		$0C  		)
( Software Reset		ESC C   		$1B $63  	)
( Add LF's after CR's		ESC D @ CTRL-@   	$1B $44 $80 $00  )
( No LF's after CR's		ESC Z @ CTRL-@   	$1B $5A $80 $00  )
( cancels all unprinted 	CTRL-X  		$18  		)

HEADER AddLFs	
	DC.B	$1B
	DC.B	$44
	DC.B	$80
	DC.B	$00
	
HEADER AddTabs	
	DC.B	$1B
	DC.B	$28
	DC.B	'008,016,024,032,040,048,056,064'
	
HEADER FormFeed
	DC.B	$0C
	
DECIMAL
LABEL	CRCounter
	DS.L	1
	
LABEL	LeavePrintFlag
	DS.W	1
	
LABEL	MyBuffer
	DS.B	512
	
LABEL	FilePBlock
	DS.B	50
	
LABEL	PrintPBlock
	DS.B	50
	

( These are the old routines )
( given by Palo Alto Shipping in the Mach 2.0 examples. )
( Since it's all in assembler, we can be sure that no calls )
( are made to the multitasking system which would interfere )
( with our background processing )

( ====  Get File Info ====== )

( Ask for the file to be converted)

CODE GetFInfo
	MOVE.W	#80,-(A7)	( where.h )
	MOVE.W	#50,-(A7)	( where.v )
	CLR.L	-(A7)		( prompt not used )
	CLR.L	-(A7)		( we don't need filter )
	MOVE.W	#1,-(A7)	( look for 1 type )
	PEA	typeList	( pointer to typeList )
	CLR.L	-(A7)		( no dlgHook )
	PEA	sfReplyA	( push address of reply record )
	MOVE.W	#2,-(A7)	( for SFGetFile )
	_Pack3			( call package )
	LEA	sfReplyA,A0	( Point to sfReply )
	TST.B	rGood(A0)	( If cancel was clicked, return )
	BEQ.S	@2
		
( Open the source file)

	LEA	filePBlock,A1	( Point to parameter block )
	CLR.L	ioCompletion(A1)	( No completion routine )
	PEA	rName(A0)		( Point to file name )
	MOVE.L	(A7)+,ioFileName(A1)	( Store pointer in diskPBlock)
	MOVE.W	rVolume(A0),ioVRefNum(A1) ( Store vRefNum in diskPBlock)
	CLR.B	ioFileType(A1)		( Must set file type = 0 )
	MOVE.B	#fsRdPerm,ioPermssn(A1) ( Open for read only )
	CLR.L	ioMisc(A1)		( Use system buffer  )
	MOVE.L	A1,A0			( A0 points to diskPBlock  )
	_Open					( Open the file )
	TST.B	D0
	BNE.S	@1
	MOVE.W	24(A0),22(A0)	( move ioRefNum into position)
						( this may be confusing)
	MOVE.W	#1,44(A0)		( ioPosMode from beginning)
	CLR.L	46(A0)		( ioPosOffset of 0)
	_SetFPos				( this will reset the file)
	LEA	CRCounter,A0
	CLR.L	(A0)
	RTS
@1	MOVE.W	#1,-(A7)
	_SysBEEP
@2	_ExitToShell
END-CODE


( ======================  Initialize Port B  ==========================)

CODE InitPortB
( SerOpenBOut)	LEA	PrintPBlock,A0	( Head of PBBlock)  
		CLR.L	$C(A0)		( No completion routine )
		LEA	PortBOut,A1	( ioNamePtr )
		MOVE.L	A1,$12(A0)	
		MOVE.B	#0,$1B(A0)	( Ask for all permission )
		MOVE.W	#-9,$18(A0)	( ioRefNum )
		_Open
		
( SerRstBOut)	LEA 	PrintPBlock,A0	( Head of block )
		MOVE.W	#-9,$18(A0)		( ioRefNum  )
		MOVE.W	#$0008,$1A(A0)	( Control number )
		MOVE.W	#$CC0A,$1C(A0)	( 9600 Baud,8d,2s,no parity )
		_Control
		
( Configure)	LEA	PrintPBlock,A0
		CLR.L	12(A0)		( ioCompletion )
		LEA	AddLFs,A1
		MOVE.L	A1,32(A0)		( ioBuffer  )
		MOVE.L	#4,36(A0)		( ioReqCount )
		_Write
		LEA	PrintPBlock,A0
		CLR.L	12(A0)		( ioCompletion )
		LEA	AddTabs,A1
		MOVE.L	A1,32(A0)		( ioBuffer )
		MOVE.L	#34,36(A0)		( ioReqCount )
		_Write
		
( ClrLeaveFlag)	LEA	LeavePrintFlag,A0
		CLR.W	(A0)
		RTS
END-CODE
		
		
( ====   Read a block from the file ======= )

CODE ReadBlock
		LEA	FilePBlock,A0
		CLR.L	12(A0)			( ioCompletion)
		LEA	MyBuffer,A1
		MOVE.L	A1,32(A0)		( ioBuffer)
		MOVE.L	#512,36(A0)		( ioReqCount)
		CLR.W	44(A0)			( ioPosMode, from current mark)
		_Read 
		
@3		CMPI.L	#512,40(A0)		( ioActCount )
		BEQ.S	@2
		
		LEA	LeavePrintFlag,A1
		MOVE.W	#$FF,(A1)
@2		RTS
END-CODE


( ====   Put in the page breaks ======= )

( Search thru MyBuffer for CR's -> $0D. 
  In place of every 60th one, I will insert a $0C, which, when sent to an 
  Imagewriter, will generate a form feed.  )

CODE PutPageBreaks
		LEA	FilePBlock,A0
		MOVE.L	40(A0),D0	( ioActCount is num of times through )
		LEA	MyBuffer,A1
		LEA	CRCounter,A0
		CLR.L	D1
@1		CMPI.B	#$0D,0(A1,D1)	( looking for carriage returns )
		BEQ.S	@2
@3		ADDQ.L	#1,D1		( increment address offset )
		SUBQ.L	#1,D0		( decrement byte counter )
		BNE.S	@1			
		RTS			( ***** this is the exit point *** )
		
@2		ADDQ.L	#1,(A0)
		CMPI.L	#60,(A0)
		BNE.S	@3		( if this is the 60th CR )
		
		MOVE.B	#$0C,0(A1,D1)	( then insert a FF char instead )
		CLR.L	(A0)		( and reset the crcounter )
		BRA.S	@3
		
END-CODE
		
		
( ====  Write out a block to port B ====== )

CODE WriteBlock
		LEA	PrintPBlock,A0
		CLR.L	12(A0)			( ioCompletion)
		LEA	MyBuffer,A1
		MOVE.L	A1,32(A0)		( ioBuffer)
		LEA	FilePBlock,A1
		MOVE.L	40(A1),36(A0)		( move ActCount into ReqCount)
		_Write 
		RTS
END-CODE
		
( ====   Feed the final form feed  ====== )

CODE DoFormFeed
		LEA	PrintPBlock,A0
		CLR.L	12(A0)			( ioCompletion	)
		LEA	FormFeed,A1
		MOVE.L	A1,32(A0)		( ioBuffer	)
		MOVE.L	#1,36(A0)		( ioReqCount	)
		_Write
		RTS
END-CODE
		
		
( ====   Close the file ======= )

CODE ClFile
		LEA	FilePBlock,A0
		CLR.L	12(A0)		( ioCompletion)
		_Close			( ioRefNum should still be there)
		RTS
END-CODE
		
		
( ====  Main Thing ======= )
: Print.bkg
	LeavePrintFlag W@ 0=
	IF 	( 5 call sysbeep )  ( for testing )	
		ReadBlock	( read a block in from file )
		PutPageBreaks	( insert form feeds every 60 lines)
		WriteBlock	( write the block to port B )
	THEN
;


( **** globals )
HEX
282 CONSTANT SwitcherGlobals
286 CONSTANT MemToSwitch
2AA CONSTANT ApplZone
910 CONSTANT CurApName
DECIMAL

( **** Switcher globals )
 0 CONSTANT World0	( pointer )
 4 CONSTANT World1	( pointer )
 8 CONSTANT World2	( pointer )
12 CONSTANT World3	( pointer )
16 CONSTANT World4	( pointer )
20 CONSTANT World5	( pointer )
24 CONSTANT World6	( pointer )
28 CONSTANT World7	( pointer )
32 CONSTANT HostTask	( pointer )
36 CONSTANT TheTask	( pointer )
40 CONSTANT Flags		( word )
50 CONSTANT ArrowEnable	( byte )
51 CONSTANT ClipConvert	( byte )
52 CONSTANT Hibernation	( word )
54 CONSTANT MainZone	( pointer )
58 CONSTANT CoreTable	( 6 LongInts )
90 CONSTANT NextTask	( pointer )
96 CONSTANT SwitcherName	( Str255 )

( **** structure of a world )
 0 CONSTANT PSRPtr	( pointer to PSR )
 4 CONSTANT WorldFlags	( word )
 6 CONSTANT BkgdProc	( pointer to background routine )
10 CONSTANT SavScrBits	( pointer to saved Screenbits )
14 CONSTANT DAPtr		( pointer to virtual DA )
18 CONSTANT StackHeap	( stack & heap starts here... )

( **** Switcher process state record )
 0 CONSTANT Size		( LongInt : PSR size )
 4 CONSTANT myMonkey	( word )
 6 CONSTANT MemTop	( address of end of available RAM for this process )
10 CONSTANT BufPtr	( address of end of jump table )
14 CONSTANT StkLowPt	( lowest stack address )
18 CONSTANT HeapEnd	( address of top of heap )
22 CONSTANT TheZone	( address of current heap zone )
26 CONSTANT ApplLimit	( application heap limit )
30 CONSTANT SEvtEnb	( 4 bytes )
34 CONSTANT MyApplZone	( application heap zone )
38 CONSTANT MinStack
72 CONSTANT GrafBegin
332 CONSTANT MyA5		( hex 14C )
344 CONSTANT MyName
836 CONSTANT DefVCBPtr	( pointer to default VCB )

( **** event record structure )
 0 CONSTANT      what 		( Integer )
 2 CONSTANT      message 	( LongInt )
 6 CONSTANT      when 		( LongInt ) 
10 CONSTANT      where 		( Point )
14 CONSTANT      modifiers 	( Integer )

VARIABLE thisApplZone 

( **** definitions )

: =string { aStr bStr | -- flag }
	aStr count 65536 * bStr count rot + swap
	call CmpString 0=
;

: isSwitcher SwitcherGlobals @ 0> ;

: Worlds { | SwGl -- }
	SwitcherGlobals @ -> SwGl 
	SwGl 0> 
	IF
		8 0 DO
		I 4 * SwGl + @ ?dup ( world # i non-NIL ? )
			IF 
			cr ." World No." i . ." : "
			@ @ MyName + count type 
			THEN
		LOOP
	THEN
;

: ActiveWorld# { | SwGl wn -- world number }
	SwitcherGlobals @ -> SwGl
	-1 -> wn 
	SwGl 0> 
	IF
		8 0 DO 
		I 4 * SwGl + @ ?dup ( world # i non-NIL ? )
			IF 
			@ @ MyApplZone + @ ApplZone @ =
				IF I -> wn leave THEN
			THEN
		LOOP
	THEN
	wn
;

( **** this routine should be called immediately after launch )
: storeApplZone ApplZone @ thisApplZone ! ;

: IamActive thisApplZone @ ApplZone @ = ;

HEADER tempA7 	DC.L 0
HEADER myWorld 	DC.L 0
HEADER myPSRPtr	DC.L 0

CODE Bkg.glue
	MOVE.W  SR,-(A7)
	MOVEM.L D0-D7/A0-A6,-(A7)
	LEA	tempA7,A0
	MOVE.L  A7,(A0)
	LEA	myWorld,A0
	MOVE.L  A1,(A0)
	MOVE.L  (A1),A1	( PSRPtr -> A1 )
	LEA	myPSRPtr,A0
	MOVE.L  (A1),(A0)
	LEA	SwitcherGlobals,A0
	MOVE.L  (A0),A0
	CMPA.L  theTask(A0),A1
	BEQ.S	@1	( we are active, so don't execute background )
	MOVE.L  (A1),A1	( start of PSR )
	MOVE.L  (A1),A0	( size of PSR )
	ADDA.L  A1,A0	
	SUBQ.L  #4,A0	( left stack pointer behind here )
	MOVE.L  (A0),A0
	MOVEM.L (A0)+,D0-D7/A0-A6  ( restore MACH2 register set, except A7 )
	LEA	myPSRPtr,A0
	MOVE.L  (A0),A1		   ( just in case )

	JSR 	  print.bkg

@1	LEA	tempA7,A0
	MOVE.L  (A0),A7
	MOVEM.L (A7)+,D0-D7/A0-A6
	MOVE.W  (A7)+,SR
	RTS
END-CODE MACH


1000 6000 BACKGROUND printer
	
: initBkg
	IamActive IF
		GetFInfo	( open, exit if cancel )
		['] Bkg.Glue
		SwitcherGlobals @ ActiveWorld# 4 * + @
		BkgdProc +
		!
		InitPortB
		THEN
;

: rmvBkg
	IamActive IF
		0
		SwitcherGlobals @ ActiveWorld# 4 * + @
		BkgdProc +
		!
		THEN
;

: startme
	storeapplzone
	BEGIN
		initbkg
		BEGIN PAUSE LeavePrintFlag w@ UNTIL
		rmvbkg
	AGAIN
;

: backgo ACTIVATE startme ;

: main  printer BUILD
	printer backgo
;
