/* Quickdraw Example
 *
 *	Compiled with LightspeedC
 *
 *	Important note for Mac C users:
 *		Every place you see event->where,
 *		replace it with &event->where
 */
 
 #include	"abc.h"
 #include	"Quickdraw.h"
 #include	"EventMgr.h"
 #include	"WindowMgr.h"
 #include	"MenuMgr.h"
 #include	"FontMgr.h"

 /* defines for menu ID's */
 
 #define		Mdesk		100
 #define		Mfile		101
 #define		Medit		102
 #define		Mshape	106
 #define		Mop		107
 
 /* File */
 #define		iNew		1
 #define		iClose	2
 #define		iQuit		3
 
 /* Edit */
 #define		iUndo		1
 #define		iCut		3
 #define		iCopy		4
 #define		iPaste	5
 #define		iClear	6
 
 /* Global variables */
 
 MenuHandle		menuDesk;	/* menu handles */
 MenuHandle		menuFile;
 MenuHandle		menuEdit;
 MenuHandle		menuShape;
 MenuHandle		menuOp;
 
 WindowPtr		theWindow;
 WindowRecord	windowRec;
 Rect				dragbound;
 Rect				screen;
 Rect				boundsRect; 
 
 BitMap			offMap;
 Rect				copyRect;
 Rect				drawRect;
 

main()
{
	initsys();	/* system initialization */
	initapp();	/* application initialization */
	eventloop();
}

crash()
{
	ExitToShell(); /* we are dead folks */
}

/* system initialization */
initsys()		
{					
	InitGraf(&thePort);	/* these two lines done */
	InitFonts();			/* automatically by Mac C */
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(&crash);
	InitCursor();
	FlushEvents(everyEvent,0);
	
	theWindow = Nil;		/*indicates no window */
	screen=screenBits.bounds;
	SetRect(&dragbound,screen.left+4,screen.top+24,screen.right-4,screen.bottom-4);
	SetRect(&boundsRect,screen.left+30,screen.top+50,screen.right-30,screen.bottom-50);
	
}

/*
 *	application initialization
 */
initapp()
{
	setupmenu();
	drinit();
}

setupmenu()
{
	menuDesk = NewMenu(Mdesk,CtoPstr("\24"));
	AddResMenu (menuDesk, 'DRVR');
	InsertMenu (menuDesk, 0);
	
	menuFile = NewMenu(Mfile, CtoPstr("File"));
	AppendMenu (menuFile, 
		CtoPstr("New/N;Close;Quit/Q"));
	InsertMenu (menuFile, 0);
	
	menuEdit = NewMenu(Medit, CtoPstr("Edit"));
	AppendMenu (menuEdit, 
		CtoPstr("Undo/Z;(-;Cut/X;Copy/C;Paste/V;Clear"));
	InsertMenu (menuEdit, 0);
	
	menuShape = NewMenu(Mshape, CtoPstr("Shape"));
	AppendMenu (menuShape,
		CtoPstr("Line;Rectangle;Oval;Round Rectangle;Arc"));
	AppendMenu (menuShape,CtoPstr("Triangle;Pentagon;Hexagon;Pentagram"));
	AppendMenu (menuShape,CtoPstr("Region"));
	InsertMenu (menuShape, 0);
	
	menuOp = NewMenu(Mop, CtoPstr("Operation"));
	AppendMenu (menuOp,
		CtoPstr("Frame;Paint;Erase;Invert"));
	InsertMenu (menuOp, 0);
		
	DrawMenuBar();
}	
	
/*	Event Loop 
 *		Loop forever until Quit
 */
eventloop()
{
	EventRecord		theEvent;
	char				c;
 	
	while(True)
		{
		SystemTask();
		CheckMenus();
		if (GetNextEvent(everyEvent,&theEvent))
			switch(theEvent.what)					
				{						/* only check key and */
				case keyDown: 		/* mouse down events */
					if ((theWindow) and (theWindow equals FrontWindow()) )
						SaveWindow();	
					c = theEvent.message & charCodeMask;
					if (theEvent.modifiers & cmdKey)
						domenu(MenuKey(c));
					else if (theWindow)
						SysBeep(5);
					break;
				case mouseDown:	
					domousedown(&theEvent);
					break;
				case updateEvt:
					doupdate((WindowPtr)theEvent.message);
					break;
				case activateEvt:
					doactivate(&theEvent);
					break;
				default:
					break;
				}
			
		}
}

/*	CheckMenus
 *		Update menu bar if window active
 */
CheckMenus()
{
		if ((theWindow) and (theWindow equals FrontWindow()))
			{								
			EnableItem(menuFile,iClose);	
			DisableItem(menuFile,iNew);
			DisableItem(menuEdit,0);
			EnableItem(menuShape,0);
			EnableItem(menuOp,0);
			CursorAdjust(theWindow);
			}
		else								
			{
			if ((theWindow) and (theWindow notequal FrontWindow()))
				{								
				DisableItem(menuFile,iNew);
				DisableItem(menuFile,iClose);
				EnableItem(menuEdit,0);
				DisableItem(menuShape,0);
				DisableItem(menuOp,0);
				}
			else
				{
				if ((theWindow equals Nil) and (FrontWindow() equals Nil))
					{
					EnableItem(menuFile,iNew);
					DisableItem(menuFile,iClose);
					DisableItem(menuEdit,0);
					DisableItem(menuShape,0);
					DisableItem(menuOp,0);
					}
				else
					{
					EnableItem(menuFile,iNew);
					DisableItem(menuFile,iClose);
					EnableItem(menuEdit,0);
					DisableItem(menuShape,0);
					DisableItem(menuOp,0);
						
					}
				}
			}
}

/* off screen bitmap */
SaveWindow()
{
	CopyBits(&(*theWindow).portBits,&offMap,&drawRect,&copyRect,srcCopy,Nil);	
}
			
/* domousedown
 *		handle mouse down events
 */
domousedown(er)
	EventRecord	*er;
{
	short			windowcode;
	WindowPtr	whichWindow;
	short			ingo;
		
	windowcode = FindWindow(er->where, &whichWindow);						
	switch (windowcode)
		{
		case inDesk:
			if (theWindow notequal 0)
				{
				HiliteWindow(theWindow, False);
				}
			break;
		case inMenuBar:
			if ((theWindow) and (theWindow equals FrontWindow()))
				SaveWindow();	
			domenu(MenuSelect(er->where));
			break;
		case inSysWindow:
			SystemClick(er,whichWindow);
			break;
		case inContent:
			if (whichWindow equals theWindow)
				{
				if (whichWindow notequal FrontWindow())
					SelectWindow(whichWindow);
				else
				if (CursorInUse() equals 2)
					{
					drdraw(whichWindow);
					SaveWindow();	
					}
				}
			break;
		case inDrag:
			DragWindow(whichWindow, 
						  er->where, &dragbound);
			break;
		case inGoAway:
			ingo = TrackGoAway(whichWindow,er->where);
			if (ingo)
				{
				CloseWindow(whichWindow);
				theWindow = Nil;
				}
			break;
		default:
			break;
		}
}

doupdate(updateWindow)
	WindowPtr	updateWindow;
{
GrafPtr		temp;

GetPort(&temp);
SetPort(updateWindow);
BeginUpdate(updateWindow);
if ((theWindow) and (theWindow=updateWindow ))
	CopyBits(&offMap,&(*updateWindow).portBits,&copyRect,&drawRect,srcCopy,Nil);
EndUpdate(updateWindow);
SetPort(temp);
}

doactivate(er)
	EventRecord	*er;
{
WindowPtr	eventwindow;

eventwindow=(WindowPtr)(er->message);
if (er->modifiers & activeFlag)
	{
	}
else	/* deactivate */
	{
	}
}
	
/* domenu
 *		handles menu activity
 *		simply a dispatcher for each
 *		menu.
 */
domenu(mc)
	long			mc;	/* menu result */
{
	short			menuId;
	short			menuitem;
	char			daName[64];	
	GrafPtr		temp;
	short			accItem;
	
	menuId = HiWord(mc);
	menuitem = LoWord(mc);
	
	switch (menuId)
		{
		case Mdesk : {
							GetItem(menuDesk,menuitem,daName);
							GetPort(temp);
							accItem=OpenDeskAcc(daName);
							SetPort(temp);
							break;
							}
		case Mfile : dofile(menuitem);
						 break;
		case Medit :{
						if (not SystemEdit(menuitem-1))
						break;
						}
		case Mshape: doshape(menuitem);
						 break;
		case Mop	  : dooper(menuitem);
						 break;
		default:
				break;
		}
	HiliteMenu(0);
}


doshape(item)
	short		item;
{
	static short	lastitem = 0;
	
	CheckItem (menuShape,lastitem,False);
 	CheckItem (menuShape,item,True);
 	lastitem = item;
 	drshape(item);
}

dooper(item)
	short		item;
{
	static short	lastitem = 0;
	
	CheckItem (menuOp, lastitem,False);
	CheckItem (menuOp, item, True);
	droper(lastitem = item);	
}
 
/* dofile
 *		handles file menu
 */
dofile(item)
	short		item;
{
	char		*title1;			/* first title for window */
	long		mapBytes;
	switch (item)
		{
		case iNew :		/* open the window */
			title1 = "ABC Window";
			theWindow = NewWindow(&windowRec, &boundsRect,
							CtoPstr(title1),True,noGrowDocProc,
							(WindowPtr) -1, True, 0);
			PtoCstr(title1);
			
			drawRect=(*theWindow).portRect;
			copyRect=drawRect;
 			offMap.rowBytes = screenBits.rowBytes;
 			mapBytes = offMap.rowBytes*(screen.bottom-screen.top);
 			offMap.baseAddr=NewPtr(mapBytes);
 			offMap.bounds=screen;
			CopyBits(&offMap,&offMap,&copyRect,&copyRect,srcXor,Nil);		
			break;
		
		case iClose :		/* close the window */
			CloseWindow(theWindow);
			DisposPtr(offMap.baseAddr);
			theWindow = Nil;
			break;
		
		case iQuit :		/* Quit */
			ExitToShell();
			break;
			
		default:
			break;	
		}
}



