UNIT UPalette;
{Popup Palette Sample
 Version 1.0		Scott T. Boyd & Greg B. Marriott
 Copyright 1986 by the MacHax(tm) Group
			 P.O. Box 5678
			 Aggieland, TX 77844
			 (409) 846-4102
 All rights reserved.
 
 We hereby license you to use this code in any way you want.
 If you do use this code in a program, you will receive a license to distribute it 
 when we receive a copy of what you intend to distribute.

 If you get rich with it, you are certainly welcome to send us some money.
  
 Just in case the courts really do decide that a visual feel is protected
 under current copyright and patent laws, we thought of this idea first and claim
 that we deserve to get filthy rich if you make a mint using the concept of
 the pop-up, two-dimensional, random access [scroll bar] menu.
 
 Friday, October 3, 1986 8:03:39 PM
}

INTERFACE

{Compiler Switch Settings}
{$R+}	{range checking on}
{$OV+}	{overflow checking on}

uses 		{$LOAD UP.dump  }
			{$U MemTypes.p  }				MemTypes,
			{$U QuickDraw.p }				QuickDraw,
			{$U OsIntf.p    }				OsIntf,
			{$U ToolIntf.p  }				ToolIntf,
			{$U OverView.p}  				OverView;
			
var
	patternPopUp	: windowPtr;	{for the OverView window record}
	viewRect		: Rect;			{the most current size}
	myBitMap		: BitMap;		{for the OverView offscreen pattern palette}

	sysPatterns		: PatHandle;	{Handle to standard pattern list}
	patternPICT		: PicHandle;	{the palette}
	popupViewRect	: Rect;
	bigpatternPICT	: PicHandle;
	globalPattern	: pattern;

procedure PatternSelect( var patternNumber: integer; where: point);
{ On entry, patternNumber points to the current pattern.
  Valid numbers are 1..38.
  Use the following to get the selected pattern given patternNumber:

		GetIndPattern(globalPattern, sysPatListID, whichPattern);

  Use the following to put a pattern into a window's refCon:
		PatHandle(WindowPeek(TheWindow)^.refCon)^^ := globalPattern;
}
procedure InitPatternPalette;
{----------------------------------------------------------}
IMPLEMENTATION

procedure PatternSelect( var patternNumber: integer; where: point);
var
	scrollPosition,
	oldScrollPosition: Point;
	row, column: longint;
	boxSize : Point;
{------}
	function WhichPattern(scrPosition:point):integer;
	var
		patternPt : Point;
		windowSize : Point;
		thePattern:integer;
	begin
		windowSize.h := thePort^.portRect.right - thePort^.portRect.left; {needed to find}
		windowSize.v := thePort^.portRect.bottom - thePort^.portRect.top; { patternPt}
		patternPt.h := scrPosition.h + windowSize.h div 2;	{patternPt should be at center}
		patternPt.v := scrPosition.v + windowSize.v div 2;	{  of MScope rect.}
		thePattern := (patternPt.h div boxSize.h) 
					+ (patternPt.v div boxSize.v)*8 
					+ 1;
		whichPattern:=thePattern;
	end;
{------}
begin
	boxSize.h := viewRect.right div 8;  {8 patterns across, 5 down}
	boxSize.v := viewRect.bottom div 5;

	row := boxSize.h * ((patternNumber - 1) mod 8) + (boxSize.h div 2);
	column := boxSize.v * ((patternNumber - 1) div 8) + (boxSize.v div 2);
	SetPt( scrollPosition, row, column );
	
	oldScrollPosition := scrollPosition;
	OverViewSelect(where,viewRect,scrollPosition,
		patternPopUp,myBitMap,nil,nil,false); 	{no scroll bars to update!}
	if not EqualPt(oldScrollPosition,scrollPosition)
	then begin {a new selection was made}
		{ now let's figure out which pattern they are in }
		{ all this stuff is a kludge to avoid doing an 
		  action proc to track the mouse in the palette }
		patternNumber := whichPattern(scrollPosition);
	end;
end; {patternSelect}
		
{----------------------------------------------------------}

Procedure DrawPoop;
var
	oldClip:RgnHandle;
	aRect:rect;
begin
	DrawPicture(bigPatternPICT, popUpViewRect);
end;
{----------------------------------------------------------}
procedure MakePalette;
var
	aRect: Rect;			{roving rect to be filled}
	i,j,k: integer;			{just for the taste of it...}
	thePattern: Pattern;	{pattern to fill with}
	oldClip: RgnHandle;
begin
	oldClip:=NewRgn;
	GetClip(oldClip);
	SetRect(aRect,-10000,-10000,10000,10000);
	ClipRect(aRect);
	bigPatternPICT:=OpenPicture(viewRect);
		PenPat(black);
		
		for i:=1 to 5 do {the rows in the pattern palette}
		begin
			SetRect(aRect,0,400*(i-1),400,400*i);
			for j := 1 to 8 do {the column elements}
			begin
				k := (i-1)*8 + j;
				if k < 39
				then begin
					GetIndPattern(thePattern, sysPatListID, k);
					InsetRect(aRect,30,30);
					FillRect(aRect,thePattern);
					InsetRect(aRect,-30,-30);
					OffsetRect(aRect,400,0);
				end;
			end;
		end;
	ClosePicture;
	SetClip(oldClip);
	DisposeRgn(oldClip);

end; {MakePalette}
{----------------------------------------------------------}

procedure InitPatternPalette;
begin
	
	SetRect ( viewRect, 0, 0, 3200, 2000 ); {virtual size of the popup}
	SetRect ( popupViewRect, 0, 0, 160, 100 ); {literal size of the popup}

	sysPatterns := PatHandle(GetResource('PAT#',0));
	
	MakePalette;

	{The number passed in for the ratio
	 is designed to create an exact sized rectangle the size of the palette.
	 Ugly, but it works.}
	NewOverView( myBitMap, patternPopUp, viewRect, 
		(popupViewRect.bottom-popupViewRect.top)/
		(screenBits.bounds.bottom-screenBits.bounds.top-20), plainDBox );
	
	{Draw into the offscreen bitmap with my procedure DrawPoop}
	UpdateOverView ( DrawPoop, myBitMap );
end; {InitPatternPalette}

end.{UNIT}