* Listing 6
* Modified prdefs.inc
*
* This file contains data definitions for use with the FORTRAN print
* manager interface (prport.sub).  This is not a complete set of
* print manager definitions; just enough to set up a basic print
* loop, using the print manager style and job dialogs to fill
* out the records.  See also prport.inc, prdrag.for.
* 20 Jan 86	Sent to Compuserve.				EWG
*
* 9 Apr 87  Modified by Mark E. McBride to add additional print
*           record offsets
*
* Offsets into the universal 120 byte printing record
*
	integer iPrVersion		! Printing software version
	parameter (iPrVersion=0)
	integer prInfo			! the PrInfo data associated with the current style.
	parameter (prInfo=2)
	integer rPaper			! The paper rectangle [offset from rPage].
	parameter (rPaper=16)
	integer prStl			! This print request's style.
	parameter (prStl=24)
	integer prInfoPT		! Print Time Imaging metrics
	parameter (prInfoPT=32)
	integer prXInfo			! Print-time (expanded) Print info record.
	parameter (prXInfo=46)
	integer prJob			! The Print Job request
	parameter (prJob=62)
	integer iPrintSize		! The Print record size.[120 bytes]
	parameter (iPrintSize=120)
*
* Offsets into prInfo subrecord
*
	integer iDev			! driver information
	parameter (iDev=0)
	integer iVRes			! printer vertical resolution
	parameter (iVRes=2)
	integer iHRes			! printer horizontal resolution
	parameter (iHRes=4)
	integer rPage			! page rectangle
	parameter (rPage=6)
*
* Offsets into prJob subrecord
*
	integer iFstPage		! First page to print
	parameter (iFstPage=0)
	integer iLstPage		! Last page to print
	parameter (iLstPage=2)
	integer iCopies			! Number of copies to print
	parameter (iCopies=4)
	
	integer bJDocLoop		! Printing method
	parameter (bJDocLoop=6)
	integer bDraftLoop		! Draft print flag.
	parameter(bDraftLoop=0)
	integer bSpoolLoop		! Spooled print flag.
	parameter (bSpoolLoop=1)
	
	integer iFromUsr		! True from application
	parameter (iFromUsr=7)
	integer pIdleProc		! background procedure
	parameter (pIdleProc=8)
	
	integer iPrStatSize		! The PrStatus record size [26 bytes]
	parameter (iPrStatSize=26)
