* This include file defines a set of bit masks used
* to control PRPORT.SUB, which allows the printer
* to be opened as a grafport from FORTRAN.  
* The operation of these functions and procedures is documented
* in Apple's Inside Macintosh Printer Manager Manual.
* The bit masks are defined as follows:
*
*	bit 31 : Type bit.
*		1 - Special function.  The remainder of
*			the longword specifies an arbitrary
*			routine number in this case.
*		0 - Print manager function.  These functions
*			read in PDEF code segments from a print
*			manager file and jump to routines in them.
*			The rest of the longword contains information
*			on which PDEF resource to read in, the offset
*			to jump to, and how to format the FORTRAN variables
*			passed for use by the PDEF code.  These fields are
*			listed below.
*	bits 24-30 : Resource ID number of PDEF resource to read.
*	bits 16-23 : Number of arguments (all 4 byte integers) passed.
*	bit 15 : Unlock the PDEF resource in memory if set.
*	bits 8-14 : Type of function return:
*			0 - No return value (procedure).
*			1 - Word returned.
*			2 - Longword returned.
*			3 - Boolean word returned.
*	bits 0-7 : Offset into the PDEF code to jump to.
*
* 15 Nov 85							EWG
* 20 Jan 86	Sent to Compuserve.				EWG

* PROCEDURE PrOpen; 
	INTEGER PROPEN
	PARAMETER (PROPEN=Z'80000000')

* PROCEDURE PrClose; 
	INTEGER PRCLOSE
	PARAMETER (PRCLOSE=Z'80000001')

* PROCEDURE PrintDefalut (hPrint: THPrint);
	INTEGER PRINTDEFAULT
	PARAMETER (PRINTDEFAULT=Z'04018000')

* FUNCTION PrValidate (hPrint: THPrint) : BOOLEAN;
	INTEGER PRVALIDATE
	PARAMETER (PRVALIDATE=Z'04018318')

* FUNCTION PrStlDialog (hPrint: THPrint) : BOOLEAN;
	INTEGER PRSTLDIALOG
	PARAMETER (PRSTLDIALOG=Z'04018304')

* FUNCTION PrJobDialog (hPrint: THPrint) : BOOLEAN;
	INTEGER PRJOBDIALOG
	PARAMETER (PRJOBDIALOG=Z'04018308')

* PROCEDURE PrJobMerge (hPrintSrc, hPrintDst: THPrint);
	INTEGER PRJOBMERGE
	PARAMETER (PRJOBMERGE=Z'0402801C')

* FUNCTION PrOpenDoc (hPrint: THPrint; pPrPort: TPPrPort;
*			pIOBuf: Ptr) : TpPrPort;
	INTEGER PROPENDOC
	PARAMETER (PROPENDOC=Z'00030200')

* PROCEDURE PrOpenPage (pPrPort: TPPrPort; pPageFrame: TPRect);
	INTEGER PROPENPAGE
	PARAMETER (PROPENPAGE=Z'00020008')

* PROCEDURE PrClosePage (pPrPort: TPPrPort);
	INTEGER PRCLOSEPAGE
	PARAMETER (PRCLOSEPAGE=Z'0001000C')

* PROCEDURE PrCloseDoc (pPrPort: TPPrPort);
	INTEGER PRCLOSEDOC
	PARAMETER (PRCLOSEDOC=Z'00018004')

* Note: prStatus should actually be passed as a pointer to a TPrStatus
*	record.
* PROCEDURE PrPicFile (hPrint: THPrint; pPrPort: TPPrPort; pIOBuf: Ptr;
*			pDevBuf: Ptr; VAR prStatus: TPrStatus);
	INTEGER PRPICFILE
	PARAMETER (PRPICFILE=Z'05058000')

* FUNCTION PrError : INTEGER;
	INTEGER PRERROR
	PARAMETER (PRERROR=Z'80000002')

* PROCEDURE PrSetError(iErr : INTEGER);
	INTEGER PRSETERROR
	PARAMETER (PRSETERROR=Z'80000003')

