* Listing 5
* file:  PrintGraph.com

*
* PrintGraph Fortran Program
*
* Copyright (c) 1987 Mark E. McBride
*                    211 N. University Ave.
*                    Oxford, OH  45056
*
* This file contains variable definitions
* that will be common to the main program and 
* the non-print related subroutines.
* These include most of the toolbox structures
* used throughout the program
*
*
* general and toolbox variables
*
	integer*4 toolbx		! toolbx.sub interface
	integer*4 prport		! print manager interface
	integer*4 ctlprc		! Create toolbox callable procs.
	integer*4 n,dy,dx,x,y,turn,rder	! Hilbert curve variables
	integer track			! Address of the track proc.
	integer ftrack			! This keeps IMPLICIT NONE happy.

* Declare ftrack as a subroutine.
	external ftrack

*
* handles
*
	integer*4 menuhandle		! handle to menu
	integer*4 pichandle		! handle to picture
	integer*4 oldPort		! handle to oldport
	integer*4 curshandle,cursptr	! handle to cursor
	integer*1 watch(68)		! watch cursor record
*
* print manager structures
*
	integer*4 prrechdl		! Handle to print record
	integer*4 theprport		! Pointer to printer grafport
	integer*1 thestrec(26)		! Status record for PRPICFILE
*
* dialog structures
*
	integer*4 dlg,itemno,itemhdl	! general purpose dialog pointer
	integer*2 ditemh,itemtype	! item hit in dialog
*
* event strucutures
*
	integer*2 eventrecord(8)	! overlying structure
	integer*2 what			! type of event:
	integer*4 message		! extra event information:
	integer*4 when			! time of event in 60ths of seconds
	integer*2 where(2)		! mouse location in global coordinates
	integer*2 modifiers		! state of mouse button and modifier keys:
*
* Menu and other selection constants
*
	integer*4 Apple,File,Edit
	integer*4 About
	integer*4 PSetUp,PrintPic,Quit
	integer*4 Undo,Cut,Copy,Paste,Clear,ShowClip
	integer*4 Black,White,Red,Green,Blue,Cyan,Magenta,Yellow
	integer*4 top,left,bottom,right
*
* Colors and line size
*
	integer*4 colors(8)
	integer*4 colorpick
	integer*4 linepick
*
* Rectangles for general use
*
	integer*2 rect(4),rect1(4),rect2(4),rect3(4)
*
* common variable sets
*
	common /set1/menuhandle,pichandle,rect,rect1,rect2,rect3,
     +  prrechdl,theprport,thestrec,dlg,itemno,itemhdl,ditemh,
     +  itemtype,eventrecord(8),toolbx,ctlprc,track,ftrack,
     +  prport,n,dy,dx,x,y,turn,rder,colorpick,linepick,
     +  curshandle,cursptr,watch,colors,oldPort

*
*  parameters
*
	parameter (top=1,left=2,bottom=3,right=4)
	parameter (Apple=29,File=30,Edit=31)
	parameter (About=1)
	parameter (PSetUp=1,PrintPic=2,Quit=4)
	parameter (Undo=1,Cut=3,Copy=4,Paste=5,Clear=6,ShowClip=8)
	parameter (Black=1,White=2,Red=3,Green=4,Blue=5,Cyan=6)
	parameter (Magenta=7,Yellow=8)
	
