/*
 * AppFont.r -	Application Font Control by Steve Sheets
 *				Control Panel Proc to change the Application Font
 *
 */

#include "Types.r"

type 'apft' as 'STR ';

type 'nrct' {
	integer = $$CountOf(RectArray);
	array RectArray { rect; };
};

type 'mach' {
	unsigned hex integer;
	unsigned hex integer;
};

resource 'apft' (0) {
	"Application Font Control by Steve Sheets 3/18/87"
};

resource 'nrct' (-4064, purgeable) {
	{	/* array RectArray: 1 elements */
		/* [1] */
		{-1,87,200,322}
	}
};

resource 'mach' (-4064, purgeable) {
	0xFFFF,
	0
};

resource 'BNDL' (-4064, purgeable) {
	'apft',
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, -4064
		},
		/* [2] */
		'FREF',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, -4064
		}
	}
};

resource 'FREF' (-4064, purgeable) {
	'cdev',
	0,
	""
};

resource 'DITL' (-4064, purgeable) {
	{	/* array DITLarray: 17 elements */
		/* [1] */
		{25, 100, 44, 170},
		RadioButton {
			enabled,
			"Chicago"
		},
		/* [2] */
		{45, 100, 64, 185},
		RadioButton {
			enabled,
			"New York"
		},
		/* [3] */
		{65, 100, 84, 169},
		RadioButton {
			enabled,
			"Geneva"
		},
		/* [4] */
		{85, 100, 104, 171},
		RadioButton {
			enabled,
			"Monaco"
		},
		/* [5] */
		{105, 100, 124, 164},
		RadioButton {
			enabled,
			"Venice"
		},
		/* [6] */
		{125, 100, 144, 167},
		RadioButton {
			enabled,
			"London"
		},
		/* [7] */
		{145, 100, 164, 165},
		RadioButton {
			enabled,
			"Athens"
		},
		/* [8] */
		{165, 100, 185, 209},
		RadioButton {
			enabled,
			"San Francisco"
		},
		/* [9] */
		{25, 215, 44, 284},
		RadioButton {
			enabled,
			"Toronto"
		},
		/* [10] */
		{45, 215, 64, 270},
		RadioButton {
			enabled,
			"Cairo"
		},
		/* [11] */
		{65, 215, 84, 313},
		RadioButton {
			enabled,
			"Los Angeles"
		},
		/* [12] */
		{85, 215, 104, 272},
		RadioButton {
			enabled,
			"Times"
		},
		/* [13] */
		{105, 215, 124, 297},
		RadioButton {
			enabled,
			"Helvetica"
		},
		/* [14] */
		{125, 215, 144, 283},
		RadioButton {
			enabled,
			"Courier"
		},
		/* [15] */
		{145, 215, 164, 283},
		RadioButton {
			enabled,
			"Symbol"
		},
		/* [16] */
		{165, 215, 184, 284},
		RadioButton {
			enabled,
			"Taliesin"
		},
		/* [17] */
		{5, 129, 23, 364},
		StaticText {
			disabled,
			"Select New Application Font"
		}
	}
};

resource 'ICN#' (-4064, purgeable, preload) {
	{	/* array: 2 elements */
		/* [1] */
		$"1FFF FFF8 2000 0004 4002 0002 8006 0001"
		$"800E 0001 8016 0001 8026 0001 8046 0001"
		$"80FE 0001 8106 0001 8206 0001 8406 0001"
		$"8806 0001 BF1F 8001 8000 0001 8000 8001"
		$"8001 5001 8002 3001 8001 1001 8000 9101"
		$"8001 F281 8000 0441 8000 0821 8000 10D1"
		$"8000 2129 8000 129D 8000 091D 8000 04ED"
		$"8000 0281 4000 0102 2000 0004 1FFF FFF8",
		/* [2] */
		$"1FFF FFF8 3FFF FFFC 7FFF FFFE FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF 7FFF FFFE 3FFF FFFC 1FFF FFF8"
	}
};
