/*
	File: Environs.h

	Copyright Apple Computer, Inc. 1987
	All Rights Reserved

	modifications:
		30 Apr 87	KLH	created from pascal version
		26 Jul 87	DDM created version for LightspeedC
*/


#ifndef _Environ_
#define _Environ_
	
#ifndef	_MacTypes_
#include "MacTypes.h"
#endif


#define envMac			-1
#define envXL			-2
#define envMachUnknown	0
#define env512KE		1
#define envMacPlus		2
#define envSE			3
#define envMacII		4

#define envCPUUnknown	0			/* CPU types */
#define env68000		1
#define env68010		2
#define env68020		3

#define envUnknownKbd	0			/* Keyboard types */
#define envMacKbd		1
#define envMacAndPad	2
#define envMacPlusKbd	3
#define envAExtendKbd	4
#define envStandADBKbd	5

		/* Errors */

#define envNotPresent	-5500		/* returned by glue. Official stuff now */
#define envBadSel		-5501		/* Selector non-positive */
#define envSelTooBig	-5502		/* Selector bigger than call can handle */


typedef struct SysEnvRec {
	short	environsVersion;
	short	machineType;
	short	systemVersion;
	short	processor;
	Boolean	hasFPU;
	Boolean	hasColorQD;
	short	keyBoardType;
	short	atDrvrVersNum;
	short	sysVRefNum;
} SysEnvRec;


pascal OSErr SysEnvirons();
	
#endif
