/*
 * This function fills a print record with defaults, using coded values.
 * It is used only when the default print record stored in the printer
 * resource file is found to be invalid.  It's also for the code to make the 
 * first copy.  According to a compile-time switch, margins are either zero
 * or one inch all around, zero on the right.
 * To support paper which has more than 66 lines per page or 164 columns, 
 * you have to make changes here and in PDEF0.c.
 */
#define ONE_INCH_MARGIN 1
void mkDefault(hPrint)
THPrint hPrint;
{
	(*hPrint)->iPrVersion = VERSION;
	(*hPrint)->prInfo.iDev = IDEV12;
	(*hPrint)->prInfo.iVRes = VREZZ;
	(*hPrint)->prInfo.iHRes = HREZZ12;
	(*hPrint)->prInfo.rPage.top = 0;
	(*hPrint)->prInfo.rPage.left = 0;

#if ONE_INCH_MARGIN
	(*hPrint)->prInfo.rPage.right = HREZZ12 * 7;
	(*hPrint)->prInfo.rPage.bottom = VREZZ * 9;
	(*hPrint)->rPaper.top = -VREZZ;
	(*hPrint)->rPaper.left = -HREZZ12;
	(*hPrint)->rPaper.bottom = VREZZ * 10;
	(*hPrint)->rPaper.right = HREZZ12 * 7 + HREZZ12/2;
#else
	(*hPrint)->prInfo.rPage.right = HREZZ12 * 8 + HREZZ12/2;
	(*hPrint)->prInfo.rPage.bottom = VREZZ * 11;
	(*hPrint)->rPaper = (*hPrint)->prInfo.rPage;
#endif

	(*hPrint)->prStl.wDev = iDevDaisy;
	(*hPrint)->prStl.iPageV = 11 * iPrPgFract;
	(*hPrint)->prStl.iPageH = (int)((float)iPrPgFract * 8.5);
	(*hPrint)->prStl.bPort = 0;
	(*hPrint)->prStl.feed = feedFanfold;
	(*hPrint)->prInfoPT = (*hPrint)->prInfo;
	(*hPrint)->prXInfo.iRowBytes = 0;
	(*hPrint)->prXInfo.iBandV = 0;
	(*hPrint)->prXInfo.iBandH = 0;
	(*hPrint)->prXInfo.iDevBytes = 0;
	(*hPrint)->prXInfo.iBands = 0;
	(*hPrint)->prXInfo.bPatScale = 0;
	(*hPrint)->prXInfo.bULThick = 0;
	(*hPrint)->prXInfo.bULOffset = 0;
	(*hPrint)->prXInfo.bULShadow = 0;
	(*hPrint)->prXInfo.scan = scanLR;
	(*hPrint)->prXInfo.bXInfoX = 0;
	(*hPrint)->prJob.iFstPage = 1;
	(*hPrint)->prJob.iLstPage = iPrPgMax;
	(*hPrint)->prJob.iCopies = 1;
	(*hPrint)->prJob.bJDocLoop = bDraftLoop;
	(*hPrint)->prJob.fFromUsr = TRUE;
	(*hPrint)->prJob.pIdleProc = nil;
	(*hPrint)->prJob.pFileName = nil;
	(*hPrint)->prJob.iFileVol = 0;
	(*hPrint)->prJob.bFileVers = 0;
	(*hPrint)->prJob.bJobX = 0;
	(*hPrint)->printX[0] =
	(*hPrint)->printX[1] =
	(*hPrint)->printX[2] =
	(*hPrint)->printX[3] =
	(*hPrint)->printX[4] =
	(*hPrint)->printX[5] =
	(*hPrint)->printX[6] =
	(*hPrint)->printX[7] =
	(*hPrint)->printX[8] =
	(*hPrint)->printX[9] =
	(*hPrint)->printX[10] =
	(*hPrint)->printX[11] =
	(*hPrint)->printX[12] =
	(*hPrint)->printX[13] =
	(*hPrint)->printX[14] =
	(*hPrint)->printX[15] =
	(*hPrint)->printX[16] =
	(*hPrint)->printX[17] =
	(*hPrint)->printX[18] = 0;
}
