unit About_Dialog;

{File name:About_Dialog.Pas   }
{Function: Handle a dialog}
{History: 6/13/88 Original by Prototyper.   }
{                       }

interface


  procedure D_About_Dialog;

implementation

  const                                 {These are the item numbers for controls in the Dialog}
    I_OK = 1;
    I_Static_Text = 2;
var 
    ExitDialog : boolean;               {Flag used to exit the Dialog}
  procedure D_About_Dialog;
    var
      GetSelection : DialogPtr;         {Name of dialog}
      {*ExitDialog : Boolean; declared global for filter routine *} {Flag to exit dialog}
      tempRect : Rect;                  {Temporary tectangle}
      DType : Integer;                  {Type of dialog item}
      Index : Integer;                  {For looping}
      DItem : Handle;                   {Handle to the dialog item}
      CItem, CTempItem : controlhandle; {Control handle}
      sTemp : Str255;                   {Get text entered, temp holding}
      itemHit : Integer;                {Get selection}
      temp : Integer;                   {Get selection, temp holding}
      Icon_Handle : Handle;             {Temp handle to read an Icon into}
      NewMouse : Point;                 {Mouse location during tracking Icon presses}
      InIcon : boolean;                 {Flag to say pressed in an Icon}
      ThisEditText : TEHandle;          {Handle to get the Dialogs TE record}
      TheDialogPtr : DialogPeek;        {Pointer to Dialogs definition record, contains the TE record}
   
  {This is an update routine for non-controls in the dialog} 
  {This is executed after the dialog is uncovered by an alert} 
  procedure Refresh_Dialog;             {Refresh the dialogs non-controls}
    var 
      rTempRect:Rect;                   {Temp rectangle used for drawing}
   
    begin 
  end; 
   
   
    begin                               {Start of dialog handler}
      GetSelection := GetNewDialog(2, nil,  Pointer(-1) ); {Bring in the dialog resource}
      ShowWindow(GetSelection);         {Open a dialog box}
      SelectWindow(GetSelection);       {Lets see it}
      SetPort(GetSelection);            {Perpare to add conditional text}
       
      TheDialogPtr := DialogPeek(GetSelection); {Get to the inner record}
      ThisEditText := TheDialogPtr^.textH; {Get to the TE record}
      HLock(Handle(ThisEditText));      {Lock it for safety}
      ThisEditText^^.txSize := 12;      {TE Point size}
      TextSize(12);                     {Window Point size}
      ThisEditText^^.txFont := systemFont; {TE Font ID}
      TextFont(systemFont);             {Window Font ID}
      ThisEditText^^.txFont := 0;       {TE Font ID}
      ThisEditText^^.fontAscent := 12;  {Font ascent}
      ThisEditText^^.lineHeight := 12 + 3 + 1; {Font ascent + descent + leading}
      HUnLock(Handle(ThisEditText));    {UnLock the handle when done}
       
      {Setup initial conditions}
       
      ExitDialog:=FALSE;                {Do not exit dialog handle loop yet}
       
      repeat                            {Start of dialog handle loop}
        ModalDialog(nil, itemHit);      {Wait until an item is hit}
        GetDItem(GetSelection, itemHit, DType, DItem, tempRect); {Get item information}
        CItem := Pointer(DItem);        {Get the control handle}
         
        {Handle it real time}
        if (ItemHit =I_OK) then         {Handle the Button being pressed}
          begin
          {?? Code to handle this button goes here}
          ExitDialog:=TRUE;             {Exit the dialog when this selection is made}
          end;                          {End for this item selected}
        
         
      until ExitDialog;                 {Handle dialog items until exit selected}
       
      {Get results after dialog}
      
      DisposDialog(GetSelection);       {Flush the dialog out of memory}
      
    end;                                {End of procedure}
  
  end.                                  {End of unit}
  
