unit  HandleTheMenus;

{File name :HandleTheMenus.Pas}
{Function: Handle all menu selections.}
{          This procedure is called when a menu item is selected.}
{          There is one CASE statement for all Lists.  There is}
{          another CASE for all the commands in each List.}
{History: 6/13/88 Original by Prototyper.   }
{                       }

interface

uses
  About_Dialog,
  Sample_Window,
  InitTheMenus;

  procedure Handle_My_Menu(var doneFlag:boolean; theMenu,theItem:integer; var theInput:TEHandle); {Handle menu selection}

implementation

  procedure Handle_My_Menu;             {Handle menu selections realtime}
    const
      L_Apple = 201;                    {Menu list}
      C_About_this_Sample = 1;
      L_File = 202;                     {Menu list}
      C_Quit = 1;
      L_Edit = 203;                     {Menu list}
      C_Undo = 1;
      C_Cut = 3;
      C_Copy = 4;
      C_Paste = 5;
      C_Clear = 6;
      C_Select_All = 7;
    var
      DNA:integer;                      {For opening DAs}
      BoolHolder:boolean;               {For SystemEdit result}
      DAName:Str255;                    {For getting DA name}
      SavePort:GrafPtr;                 {Save current port when opening DAs}
  
    begin                               {Start of procedure}
      
        case theMenu of                 {Do selected menu list}
      
        L_Apple:
          begin
            case theItem of             {Handle all commands in this menu list}
              C_About_this_Sample:
                begin
                  D_About_Dialog;       {Call a dialog for this menu selection}
                end;
              otherwise                 {Handle the DAs}
                begin                   {Start of Otherwise}
                  GetPort(SavePort);    {Save the current port}
                  GetItem(AppleMenu, theItem, DAName); {Get the name of the DA selected}
                  DNA := OpenDeskAcc(DAName); {Open the DA selected}
                  SetPort(SavePort);    {Restore to the saved port}
                end;                    {End of Otherwise}
             
            end;                        {End of item case}
          end;                          {End for this list}
      
        L_File:
          begin
            case theItem of             {Handle all commands in this menu list}
              C_Quit:
                begin
                  doneFlag := TRUE;
                end;
              otherwise
                begin
                end;
             
            end;                        {End of item case}
          end;                          {End for this list}
      
        L_Edit:
          begin
            BoolHolder := SystemEdit ( theItem - 1 ); {Do DA editing}
            if not (BoolHolder) then    {If not a DA then we get it}
              begin                     {Handle by using a Case statment}
              case theItem of           {Handle all commands in this menu list}
                C_Undo:
                  begin
                    {?? ADD IN HERE WHAT THIS COMMAND SHOULD DO}
                  end;
                C_Cut:
                  begin
                    {?? ADD IN HERE WHAT THIS COMMAND SHOULD DO}
                  end;
                C_Copy:
                  begin
                    {?? ADD IN HERE WHAT THIS COMMAND SHOULD DO}
                  end;
                C_Paste:
                  begin
                    {?? ADD IN HERE WHAT THIS COMMAND SHOULD DO}
                  end;
                C_Clear:
                  begin
                    {?? ADD IN HERE WHAT THIS COMMAND SHOULD DO}
                  end;
                C_Select_All:
                  begin
                    {?? ADD IN HERE WHAT THIS COMMAND SHOULD DO}
                  end;
                otherwise               {Send to a DA}
                  begin                 {Start of the Othersize}
                  end;                  {End of Otherwise}
               
              end;                      {End of item case}
              end;                      {End of not BoolHolder}
          end;                          {End for this list}
      
        otherwise
          begin
          end;
       
      end;                              {End for lists}
      
      HiliteMenu(0);                    {Turn menu selection off}
    end;                                {End of procedure Handle_My_Menu}
  
end.                                    {End of unit}

