/*************************************************************************/
/* 
					MSS Fri May 8, 1987 18:26:05
*/
/*             Corrections to Consulair Mac C Header files               */
/*                      corrections & omissions                          */
/*                                                                       */
/*              created October 15, 1985 David J. Burnard                */
/*                                                                       */
/*               Please add any items you find, and mail                 */
/*                    the additional corrections to                      */
/*                        burnard@lll-crg.ARPA                           */
/*                                 or                                    */
/*                                DJB                                    */  
/*                      c/o 3 Guys with Computers                        */
/*                            PO Box 7457                                */
/*                        Berkeley, CA 94707                             */
/*                                                                       */
/*************************************************************************/

/* always include this file after Consulair's header files,
      but before any custom header files, like IMLib.h */

/* Control.h */
  #ifdef ControlLoaded
  #endif
  
/* Desk.h */
  #ifdef DeskLoaded
  #endif
  
/* Dialog.h */
  #ifdef DialogLoaded
     /* left out DialogPeek */
     typedef   DialogRecord   *DialogPeek;
     /* misspelling again! */
     #define DisposDialog(dialogPointer) DisposeDialog(dialogPointer)
  #endif
/* Events.h*/
#ifdef EventLoaded /* add Char Code and Key Code masks for mess fielsd */

		#define		charCodeMask		0x000000FFL
		#define		keyCodeMask		0x0000FF00L
#endif
/* Font.h */
#ifdef FontLoaded
			/* add constants for new fonts */
		#define   cairo        11
     #define   losAngeles   12
     #define   times        20
     #define   helvetica    21
     #define   courier      22
     #define   symbol       23
     #define   taliesin     24
     #define   kanji        25
     
     /* add Style for normal text...or use NIL */
     #define   normalStyle    0
  #endif

/* MacCDefs.h */
  #ifdef MacCLoaded
  #endif
/* MacDefs.h */
  #ifdef MacdefsLoaded
     /* add OSType definition (4 char literal) */
     typedef   long    OSType;
     
     /* add OSErr type definition and the null error */
     typedef   short   OSErr;
     #define   noErr   0
  #endif
/* add Fixed type and associated traps */
  
 #ifndef FixedLoaded
  
     #define FixedLoaded
     
     typedef   long   Fixed;
     
     #define   FixRound   (short)FixRound
     #define   FixRatio   (Fixed)FixRatio
     #define   FixMul     (Fixed)FixMul
     
  #endif

/* Memory.h */
  #ifdef MemoryLoaded
     /* spelling error...was MaxSize */
     #define   maxSize  0x800000
	 	
  #endif

/* Menu.h */
  #ifdef MenuLoaded
     /* add constants for special chars */
     #define   commandMark   '\021'
     #define   checkMark     '\022'
     #define   diamondMark   '\023'
     #define   appleMark     '\024'
  #endif
  
/* MiscMgr.h */
  #ifdef MiscMgrLoaded
  #endif

/* OsIO.h */
   #ifdef OSioLoaded
     /* spelling error...was rFNumErr */
     #define   rfNumErr   -51
     
     /* add Finder attributes flags - wait till Apple corrects theirs */
     #define   cfInited       0x0100
     #define   cfHasChanged   0x0200
     #define   cfIsBusy       0x0400
     #define   cfNoCopy       0x0800
     #define   cfSystemFile   0x1000
     #define   cfHasBundle    0x2000
     #define   cfInvisible    0x4000
     #define   cfLocked       0x8000
     
     /* add Finder fdFlag values */
     #define   fTrash        -3
     #define   fDeskTop      -2
     #define   fDisk          0
     
     /* add File System attribute flags */
     #define   fsLocked       0x01
     #define   fsNoCopy       0x40
     #define   fsBusy         0x80
     
     
     /* add read/write permissions */
     #define   fsCurPerm    0
     #define   fsRdPerm     1
     #define   fsWrPerm     2
     #define   fsRdWrPerm   3
     
     /* add ioPosMode settings */
     #define   fsAtMark      0       /* at current position of mark - ignore ioPosOffset */
     #define   fsFromStart   1       /* offset relative to beginning of file */
     #define   fsFromLEOF    2       /* offset relative to logical end-of-file */
     #define   fsFromMark    3       /* offset relative to current mark */
     
     /* add an equivalent to ioParam... */
     typedef   struct __IO   IOParam;
     
  #endif

/* Osmisc.h */
   #ifdef OSmiscLoaded
     /* don't use these constants - use those above (OSio.h)... */
     #undef   fHasBundle
     #undef   fInvisible
     
     /* Pointer to a Queue Header */
     typedef   QHdr   *QHdrPtr;
   #endif

/* Packages.h */
  #ifdef PackagesLoaded
  
     /* redefine SFReply to use fName as in IM */
     #undef SFReply
     typedef struct {
       char    good;  
       char    copy;
       OSType  ftype;
       short   vRefNum; 
       short   version;
       char    fName; 
       char    Name[63]; 
     } SFReply;
     
     /* constant for IUDateString() */
     #define   abbrevDate  512         
  #endif

/* pbDefs.h */
  #ifdef pbDefsLoaded
     /* spelling error...was PBGetVInfo() */
     #define PBGetVolInfo(pbBlock, asynchFlag) (short)pbCall(pbBlock, asynchFlag, 0xA007)
  #endif

/* Print.h */
  #ifdef PrintLoaded
  #endif

/* QuickDraw.h */
  #ifdef QuickdrawLoaded


/* QuickDraw global patterns */
#define	gray 			&(QD->gray)
#define	dkGray		&(QD->dkGray)
#define	ltGray		&(QD->ltGray)
#define white		&(QD->white)
#define black		&(QD->black)

 
  #endif

/* Resource.h */
  #ifdef ResourceLoaded
     typedef   long   ResType;
  #endif

/* TextEdit.h */
  #ifdef TextEditLoaded
     /* add constants for justification */
     #define   teJustLeft     0
     #define   teJustCenter   1
     #define   teJustRight   -1
   
     /* change two fields of the TERec data structure: */
     #define  teLength    telength   
     #define  fontAscent  firstBL
	 
	 /* Funny TE Style constants */
   #define	teNormal		0x0000
   #define	teBold			0x0000
   #define	teItalic		0x0000
   #define	teUnderline		0x0000
   #define	teOutline		0x0000
   #define	teShadow		0x0000
   #define	teCondense		0x0000
   #define	teExtend		0x0000
  #endif


/* Window.h */
	#ifdef WindowLoaded
		/*see Vol IV */
		
		#define inZoomIn 		7
		#define inZoomOut 		8
		#define _ZOOMDOCPROC 	8
	 
   	#undef	noShadowDBox
	#endif
