;*******************************************************************
;
;	header.asm
;
;	(c) 1987, 1988 by Clifford Story and Attic Software
;
;	assembler header for Transfer DA.
;
;*******************************************************************

;*******************************************************************
;	includes
;*******************************************************************

	include		sysequ.d

;*******************************************************************
;	imported routines
;*******************************************************************
		
	xref		open	
	xref		close
	xref		ctl

;*******************************************************************
;	exported routines
;*******************************************************************
		
	xdef		killda
	xdef		getdisk
	xdef		setdisk

;*******************************************************************

	dc.w		$3400		; flags 
	dc.w		$0000		; service rate
	dc.w		$ffff		; event mask
	dc.w		$0000		; menuid goes here
	dc.w		ornopen		; open routine
	dc.w		orndone		; prime
	dc.w		ornctl		; control
	dc.w		orndone		; status
	dc.w		ornclose	; close

;*******************************************************************

	dc.w		'Transfer (c) 1988, 1989 '
	dc.w		'by Clifford Story and Attic Software '
	dc.w		'All rights reserved'

;*******************************************************************

ornopen	
	movem.l		A0/A1,-(SP)
	move.l		A1,-(SP)	; stack device
	move.l		A0,-(SP)	; stack param			
	jsr		open
	bra.s		orndone

ornctl		
	movem.l		A0/A1,-(SP)
	move.l		A1,-(SP)	; stack device
	move.l		A0,-(SP)	; stack param			
	jsr		ctl
	movem.l		(SP)+,A0/A1
	move.l		jiodone,-(SP)
	rts

ornclose
	movem.l		A0/A1,-(SP)
	move.l		A1,-(SP)	; stack device
	move.l		A0,-(SP)	; stack param			
	jsr		close
;	bra.s		orndone

orndone
	movem.l		(SP)+,A0/A1
	clr.l		D0
	rts

;*******************************************************************
;
;	procedure killda
;
;	(return)		address		(SP)
;	block			pointer		-4(SP)
;	device			pointer		-8(SP)
;	
;*******************************************************************

killda

	move.l		(SP)+,D0	; return address
	movea.l		(SP)+,A0	; block
	movea.l		(SP)+,A1	; device

	move.l		D0,-(SP)
	clr.l		D0
	move.l		jiodone,-(SP)
	rts

;*******************************************************************

getdisk
	lea		thedata,A0
	move.w		(A0),4(SP)
	rts

setdisk
	lea		thedata,A0
	move.w		4(SP),(A0)
	rts

thedata
	dc.w		''

;*******************************************************************
