/*	resource file for the test editor */ 

#include "Types.r"

/* --- The Menus --- */

resource 'MENU' (128, "Apple", preload) {
	128,
	textMenuProc,
	0x7FFFFFFD,	/* Disable item #2 */
	enabled,
	apple,
	{
		"About Sample",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain
	}
};

resource 'MENU' (129, "File", preload) {
	129,
	textMenuProc,
	0x2F,
	enabled,
	"File",
	{
		"New",
			noicon, "N", nomark, plain;		
		"Open",
			noicon, "O", nomark, plain;		
		"Close",
			noicon, noKey, nomark, plain;		
		"Save",
			noicon, "S", nomark, plain;		
		"-",
			noicon, nokey, nomark, plain;
		"Quit",
			noicon, "Q", nomark, plain
	}
};

resource 'MENU' (130, "Edit", preload) {
	130, textMenuProc,
	0x7FFFFFBD,	/* Disable items #1 & #2 */
	enabled, "Edit",
	 {
		"Undo",
			noicon, "Z", nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Cut",
			noicon, "X", nomark, plain;
		"Copy",
			noicon, "C", nomark, plain;
		"Paste",
			noicon, "V", nomark, plain;
		"Clear",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Hot Copy",
			noicon, nokey, nomark, plain;
		"Hot Paste",
			noicon, nokey, nomark, plain;
		"Remove Link",
			noicon, nokey, nomark, plain
	}
};

resource 'MENU' (131,"OptionsMenu",Preload) {
131,			/* ID */
textMenuProc,	/* menu def proc ID */
0B11,					/* item flags */
enabled,			/* menu enable */
"Options",
	{ "Show links",
	  noIcon,noKey,noMark,plain;
		"Show link info",
	  noIcon,noKey,noMark,plain
	}
};

resource 'MENU' (132,"FontMenu",Preload) {
132,			/* ID */
textMenuProc,	/* menu def proc ID */
allEnabled,		/* item flags */
enabled,			/* menu enable */
"Font",
{ 
}
};

resource 'MENU' (133,"Sizes",Preload) {
133,			/* ID */
textMenuProc,	/* menu def proc ID */
0B11111011111111,		/* item flags */
enabled,			/* menu enable */
"Size",
	{ "9",
	  noIcon,noKey,noMark,plain;
	  "10",
	  noIcon,noKey,noMark,plain;
	  "12",
	  noIcon,noKey,noMark,plain;
	  "14",
	  noIcon,noKey,noMark,plain;
	  "16",
	  noIcon,noKey,noMark,plain;
	  "20",
	  noIcon,noKey,noMark,plain;
	  "24",
	  noIcon,noKey,noMark,plain;
	  "28",
	  noIcon,noKey,noMark,plain;
	  "-",
	  noIcon,noKey,noMark,plain;
	  "Bold",
	  noIcon,"B",noMark,plain;
	  "Italic",
	  noIcon,"I",noMark,plain;
	  "Underlined",
	  noIcon,"U",noMark,plain;
	  "Outline",
	  noIcon,noKey,noMark,plain;
	  "Shadow",
	  noIcon,noKey,noMark,plain
	}
};

resource 'MENU' (134,"Links",Preload) {
134,			/* ID */
textMenuProc,	/* menu def proc ID */
0xFFFFFFFF,		/* item flags */
enabled,			/* menu enable */
"Links",
{ 
}
};

/* --- The Windows --- */

resource 'WIND' (128,"a Window") {
	{64, 60, 314, 460},
	documentProc,
	visible,
	noGoAway,
	0x0,
	"Untitled"
};

/* --- The Alerts/Dialogs (with DITLs) --- */

/* 128 is the about box */
/* 129 is the link info box */

/* 256 is "No IAC" error box */
/* 257 is the IAC error alert */
/* 258 is the "Not in any extents" alert */
/* 259 is the "Sure you want to kill this extent?" Alert */
/* 260 is the "Save changes?" alert */

resource 'DLOG' (128,Purgeable) {
	{61, 80, 301, 420},
	altDBoxProc,
	visible,
	noGoAway,
	0x0,
	128,
	"x"
};

resource 'DITL' (128,Purgeable) {
	{	
		{200, 110, 225, 230},		/* [1] */
		Button {enabled, "Wonderful!"},
		{15, 65, 31, 275},			/* [2] */
		StaticText {disabled,"The Great IAC Sample Program!"},
		{40, 20, 56, 320},			/* [3] */
		StaticText {disabled,"This copy: ^0"},
		{60, 20, 124, 320},			/* [4] */
		StaticText {disabled,"This sample is designed to show off the "
			"var- ious capabilities of the  SAWS Inter- Application "
			"Communications Driver. It may be used freely. Send questions, etc"
			", to: "},
		{124, 119, 140, 219},		/* [5] */
		StaticText {disabled,"Frank Alviani"},
		{140, 120, 188, 220},		/* [6] */
		StaticText {disabled,"P.O. Box 8744 Waukegan Ill 60079"}
	}
};


resource 'DLOG' (129,"link info",Purgeable) {
	{80, 86, 300, 426},
	altDBoxProc,
	visible,
	noGoAway,
	0x0,
	129,
	""
};

resource 'DITL' (129,Purgeable) {
	{	{185, 130, 210, 210},		/* [1] */
		Button {enabled,"OK!"},
		{10, 20, 26, 320},			/* [2] */
		StaticText {disabled,"Information About Current Registered Links"},
		{35, 300, 170, 316},		/* [3] */
		UserItem {enabled},
		{35, 20, 170, 300},			/* [4] */
		UserItem {disabled}
	}
};

/* Scroll bar for link-info dlog */
resource 'CNTL' (129,Purgeable) {
  {35,300,170,316},
  0,	/* value */
  visible,
  0,	/* max */
  0,	/* min */
  scrollBarProc,	/* type */
  0,	/* refcon */
  "x"
};


resource 'ALRT' (256,Purgeable) {
	{100, 100, 220, 400},
	256,
	{	OK, visible, sound1,	/* [1] */
		OK, visible, sound1,	/* [2] */
		OK, visible, sound1,	/* [3] */
		OK, visible, sound1		/* [4] */
	}
};

resource 'DITL' (256,Purgeable) {
	{	{90, 200, 110, 280},	/* [1] */
		Button {enabled, "Rats!" },
		{20, 72, 84, 280},		/* [2] */
		StaticText {disabled,
			"Unfortunately, we cannot find ^0. "
			"Without it, there is no point in going on. Farewell..."};
		{94,20,110,150},			/* [3] */
		StaticText {disabled, "ID=^2"}
	}
};

resource 'ALRT' (257,Purgeable) {
	{100, 100, 240, 400},
	257,
	{	OK, visible, sound1,	/* [1] */
		OK, visible, sound1,	/* [2] */
		OK, visible, sound1,	/* [3] */
		OK, visible, sound1		/* [4] */
	}
};

resource 'DITL' (257,Purgeable) {
	{	{105, 110, 130, 190},		/* [1] */
		Button {enabled,"Rats!"},
		{10, 67, 90, 280},			/* [2] */
		StaticText {disabled,"IAC Error ^0 was encountered during the "
			"^1 operation, which was not completed. Sorry!"}
	}
};


resource 'ALRT' (258,Purgeable) {
	{100, 100, 200, 400},
	258,
	{	OK, visible, sound1,	/* [1] */
		OK, visible, sound1,	/* [2] */
		OK, visible, sound1,	/* [3] */
		OK, visible, sound1		/* [4] */
	}
};

resource 'DITL' (258,Purgeable) {
	{	{70, 110, 95, 190},		/* [1] */
		Button {enabled,"Rats!"},
		{10, 62, 58, 290},		/* [2] */
		StaticText {disabled,"Sorry! You are not in any extent."
			"Therefore no link can be severed."}
	}
};


resource 'ALRT' (259,Purgeable) {
	{100, 100, 200, 400},
	259,
	{	OK, visible, sound1,	/* [1] */
		OK, visible, sound1,	/* [2] */
		OK, visible, sound1,	/* [3] */
		OK, visible, sound1		/* [4] */
	}
};

resource 'DITL' (259,Purgeable) {
	{	{65, 110, 90, 190},		/* [1] */
		Button {enabled,"Rats!"},
		{10, 62, 42, 290},		/* [2] */
		StaticText {disabled,"Are you SURE you want to  remove this "
			"link? This cannot be undone."}
	}
};

resource 'ALRT' (260, Purgeable) {
	{100, 100, 250, 400},
	260,
	{	OK, visible, sound1,	/* [1] */
		OK, visible, sound1,	/* [2] */
		OK, visible, sound1,	/* [3] */
		OK, visible, sound1		/* [4] */
	}
};

resource 'DITL' (260, Purgeable) {
	{	{80, 15, 105, 95},		/* [1] */
		Button {enabled,"Save"},
		{115, 15, 140, 95},		/* [2] */
		Button {enabled,"Cancel"},
		{116, 205, 141, 285},	/* [3] */
		Button {enabled,"No"},
		{15, 75, 63, 285},		/* [4] */
		StaticText {disabled,"Do you want to save the changes made to ^0?"}
	}
};


resource 'ALRT' (261,Purgeable) {
	{100, 100, 200, 400},
	261,
	{	OK, visible, sound1,	/* [1] */
		OK, visible, sound1,	/* [2] */
		OK, visible, sound1,	/* [3] */
		OK, visible, sound1		/* [4] */
	}
};

resource 'DITL' (261,Purgeable) {
	{	{70, 110, 95, 190},		/* [1] */
		Button {enabled,"OK"},
		{10, 62, 58, 290},		/* [2] */
		StaticText {disabled,"Doc_ID = ^0 hatCheck = ^1"}
	}
};


/* --- Miscellaneous Resources --- */

resource 'SIZE' (-1) {
		dontSaveScreen,
		acceptSuspendResumeEvents,
		disableOptionSwitch,
		canBackground,
		multiFinderAware,
		98304,										/* preferrred size = 128K - 32k */
		98304											/* min size = 128K - 32k */
};

type 'IAC1' as 'STR ';

resource 'IAC1' (0) {
	"Sample IAC Application - Version 1.01"
};

resource 'ICN#' (128, Purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0001 0400 0002 8A00 0004 5100 0008 2080"
		$"0010 1140 0022 08A0 0044 BFD0 0089 C288"
		$"0101 C104 02A4 9082 054C 2041 080E 4020"
		$"113C 8010 2249 0008 44A0 3F04 8124 4082"
		$"4248 8041 2093 3022 1123 C814 084E 7F8F"
		$"0412 B007 0221 8007 0100 A007 0080 6007"
		$"0040 1FE7 0020 021F 0010 0417 0008 0820"
		$"0004 1040 0002 2880 0001 4500 0000 8200",
		/* [2] */
		$"0001 0400 0003 8E00 0007 DF00 000F FF80"
		$"001F FFC0 003F FFE0 007F FFF0 00FF FFF8"
		$"01FF FFFC 03FF FFFE 07FF FFFF 0FFF FFFF"
		$"1FFF FFFF 3FFF FFFF 7FFF FFFF FFFF FFFF"
		$"7FFF FFFF 3FFF FFFF 1FFF FFFF 0FFF FFFF"
		$"07FF FFFF 03FF FFFF 01FF FFFF 00FF FFFF"
		$"007F FFFF 003F FFFF 001F FFF7 000F FFE0"
		$"0007 FFC0 0003 EF80 0001 C700 0000 8200"
	}
};

resource 'ICN#' (129, purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0FFF FC00 0800 0600 0800 05C0 0800 04A0"
		$"08F8 0450 0800 0428 081F E7F4 0800 0012"
		$"081F E01F 0800 0011 0803 FC11 0800 001D"
		$"081F 0011 0800 0011 081F FE11 0800 001D"
		$"08FF E011 0800 0011 083C 0019 0800 0011"
		$"080F C011 0800 001D 080F F811 0800 0011"
		$"08FC 0019 0800 0011 083F E011 0800 001D"
		$"0807 FE11 0800 0011 0800 0011 0FFF FFF1",
		/* [2] */
		$"0FFF FC00 0FFF FE00 0FFF FFC0 0FFF FFE0"
		$"0FFF FFF0 0FFF FFF8 0FFF FFFC 0FFF FFFE"
		$"0FFF FFFF 0FFF FFFF 0FFF FFFF 0FFF FFFF"
		$"0FFF FFFF 0FFF FFFF 0FFF FFFF 0FFF FFFF"
		$"0FFF FFFF 0FFF FFFF 0FFF FFFF 0FFF FFFF"
		$"0FFF FFFF 0FFF FFFF 0FFF FFFF 0FFF FFFF"
		$"0FFF FFFF 0FFF FFFF 0FFF FFFF 0FFF FFFF"
		$"0FFF FFFF 0FFF FFFF 0FFF FFFF 0FFF FFFF"
	}
};

resource 'BNDL' (128) {
	'IAC1',
	0,
	{
		'ICN#',
		{
			0, 128;
			1, 129
		},
		'FREF',
		{
			0, 128;
			1, 129
		}
	}
};

resource 'FREF' (128, purgeable) {
	'APPL',
	0,
	""
};

resource 'FREF' (129, purgeable) {
	'TEXT',
	1,
	""
};

include $$Shell("hlxEtc") "editor.code";		/* make sure we get code segments in! */
