### 		general.b - Build any Double Helix auxiliary program.
#
# 	Usage:
#		Set exit [0 | 1];
#		#	If exit == 0, all compiles and assemblies will be completed.  If
#		#								any errors occur, subsequent steps will be skipped.
#		# If exit == 1, the procedure stops after the first error occurs.
#
#		Set hlxSrc "source directory"; Export hlsSrc
#		Set hlxEtc "result directory"; Export hlsEtc
#		Set hlxProg "auxiliary program"; Export hlsProg
# 	general.b [ -r | -m] [makeParams]
# 	# 	-r					Repeat previous build, using existing "{hlxEtc}makeout".
# 	# 								(Actually, this option merely suppresses the "makeout" creation.)
# 	# 								Must be the first (and only) parameter.
# 	# 	-m					Make "{hlxEtc}makeout", but do not execute it.
# 	# 								Must be the first parameter.
# 	# 	makeParams	Additional parameters to make; e.g.:
# 	# 								-d pr="-p"	Report progress
# 	# 								-d e="#"		Suppress log detail
# 	# 								-e					Make everything.
# 	# 								-t					Merely touch dates to bring everything up-to-date.

open "{log}"
#open "{worksheet}"
echo `Date -a -t` `Date -s -d` Start {hlxAlt} >> "{log}"

cd "{hlxSrc}"
set result Done
if "{1}" == "-m"
	set result Made
	shift 1
end
if "{1}" <> "-r"
	If {result} == Done
		echo set err 0 > "{hlxEtc}makeout"
		unset err
		make {"parameters"} -f {hlxprg}.m >> "{hlxEtc}makeout"
	end || Set result Failed
end
if {result} == "Done"
	"{hlxEtc}makeout" || Set result Failed
end
echo `Date -a -t` `Date -s -d` {result} >> "{log}"
beep
exit 1 If result == Failed
