/*****************************************************
Test.r
	Resources for List-Of-Controls example.
*****************************************************/


/***********************Types***********************/
#include "Types.r"
#include "PopMenuCDEF.r"

type 'INT#' {
	integer = $$Countof(IntegerArray);
	
	array IntegerArray {
		integer;
	};
};

/**********************Defines**********************/
#define	RES_ID		128



/*********************Resources********************/
data 'LDEF' (RES_ID, "ControlLDEF") {
	$$resource("ControlLDEF.LDEF", 'LDEF', 1)
};

data 'CDEF' (pmCDEFResID, "popMenus") {
	$$resource("PopMenuCDEF.CDEF", 'CDEF', 1)
};

resource 'DLOG' (RES_ID, "RES_ID") {
	{54, 170, 254, 470},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	RES_ID,
	""
};

resource 'DITL' (RES_ID, "RES_ID") {
	{ /* array DITLarray: 3 elements */
		/* [1] */
		{170, 125, 190, 185},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{10, 10, 72, 290},
		UserItem {
			enabled
		},
		/* [3] */
		{82, 10, 160, 290},
		StaticText {
			disabled,
			"List of Controls LDEF example.  "
			"James Plamondon, Abacus Concepts, "
			"1984 Bonita Avenue, Berkeley, CA  "
			"94704."
		}
	}
};

resource 'INT#' (RES_ID, "Control ID's") {
	{ /* array INTArray: 5 elements */
		/* [1] */
		128,
		/* [2] */
		129,
		/* [3] */
		130,
		/* [4] */
		131,
		/* [5] */
		132
	}
};
	

resource 'CNTL' (128) {
	{0, 0, 0, 0},			/* rect:  contrlRect	*/
	128,				/* value: menu rsrc ID 	*/
	invisible,			/* vis:  standard		*/
	128,				/* max:  default menuID	*/
	2,					/* min:  default item #	*/
	popMenuProc 		/* ProcID:  3 			*/
		+ mCheck,		/* var: Check selection	*/
	0,					/* rfCon: for user's use*/
	"Thanks to: "		/* title: standard		*/
};

resource 'MENU' (128) {
	128,
	textMenuProc,
	allEnabled,
	enabled,
	"Thanks To: ",
	{	/* 11 items */
		"Mark Williams",
			noIcon, noKey, noMark, plain;
		"Mark Bennet",
			noIcon, noKey, appleChar, plain;
		"Joseph Daniel",
			noIcon, noKey, noMark, plain;
		"Dr. Don Morrison",
			noIcon, noKey, noMark, plain;
		"Andrew Stone",
			noIcon, noKey, noMark, plain;
		"Eleanor Plamondon",
			noIcon, noKey, noMark, plain;
		"Bruce Wampler",
			noIcon, noKey, noMark, plain;
		"Patricia Guffey",
			noIcon, noKey, noMark, plain;
		"Greta Shaw",
			noIcon, noKey, noMark, plain;
		"Monty \"Montana-Unit\" Cole",
			noIcon, noKey, noMark, plain;
		"Dr. Bernard Moret",
			noIcon, noKey, noMark, plain
	}
};

resource 'CNTL' (129) {
	{0, 0, 0, 0},		/* rect:  contrlRect	*/
	129,				/* value: rsrc ID		*/
	invisible,			/* vis:  standard		*/
	129,				/* max: default  menuID	*/
	2,					/* min:  default item #	*/
	popMenuProc 		/* ProcID: 3 			*/
		+ mRes			/* var: add res names	*/
		+ mCheck,		/* var: Check selection	*/
	'FONT',				/* rfCon: OSType		*/
	"Fonts: "			/* title: standard		*/
};

resource 'MENU' (129) {
	129,
	textMenuProc,
	allEnabled,
	enabled,
	"Fonts:        ",
	{	/* 0 items */
	}
};

resource 'CNTL' (130) {
	{0, 0, 0, 0},		/* rect:  contrlRect	*/
	130,				/* value: rsrc ID 		*/
	invisible,			/* vis:  standard		*/
	133,				/* max:  default menuID	*/
	1,					/* min: default  item #	*/
	popMenuProc			/* ProcID: 3			*/
		+ mCheck		/* var: Check selection	*/
		+ mSub,			/* var: sub-menus		*/
	0,					/* rfCon: for user's use*/
	"SubMenu: "			/* title: standard		*/
};

resource 'MENU' (130) {
	130,
	textMenuProc,
	allEnabled,
	enabled,
	"Root:          ",
	{	/* 2 items */
		"Root Item1",
			noIcon, parent, "\0D131", plain;
		"Root Item2",
			noIcon, parent, "\0D132", plain
	}
};

resource 'MENU' (131) {
	131,
	textMenuProc,
	allEnabled,
	enabled,
	"",
	{	/* 2 items */
		"Sub-1 Item1",
			noIcon, noKey, noMark, plain;
		"Sub-1 Item2",
			noIcon, noKey, noMark, plain;
		"Sub-1 Item3",
			noIcon, parent, "\0D133", plain
	}
};

resource 'MENU' (132) {
	132,
	textMenuProc,
	allEnabled,
	enabled,
	"",
	{	/* 2 items */
		"Sub-2 Item1",
			noIcon, noKey, noMark, plain;
		"Sub-2 Item2",
			noIcon, noKey, noMark, plain;
		"Sub-2 Item3 (a very, very, very wide item)",
			noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (133) {
	133,
	textMenuProc,
	allEnabled,
	enabled,
	"",
	{	/* 2 items */
		"Sub-3 Item1",
			noIcon, noKey, noMark, plain;
		"Sub-3 Item2",
			noIcon, noKey, noMark, plain;
		"Sub-3 Item3",
			noIcon, noKey, noMark, plain
	}
};
	

resource 'CNTL' (131) {
	{0, 0, 0, 0},		/* rect:  contrlRect	*/
	134,				/* value: menu rsrc ID 	*/
	invisible,			/* vis:  standard		*/
	134,				/* max:  default menuID	*/
	1,					/* min:  default item #	*/
	popMenuProc 		/* ProcID:  3 			*/
		+ mCheck,		/* var: Check selection	*/
	0,					/* rfCon: for user's use*/
	"At Abacus: "		/* title: standard		*/
};

resource 'MENU' (134) {
	134,
	textMenuProc,
	allEnabled,
	enabled,
	"At Abacus: ",
	{	/* 5 items */
		"Dan Feldman",
			noIcon, noKey, noMark, plain;
		"Jim Gagnon",
			noIcon, noKey, noMark, plain;
		"Will Scoggin",
			noIcon, noKey, noMark, plain;
		"James Plamondon",
			noIcon, noKey, noMark, plain;
		"Jay Roth",
			noIcon, noKey, noMark, plain;
		"Tiffiny Fyans",
			noIcon, noKey, noMark, plain;
		"Jeanette Stafford",
			noIcon, noKey, noMark, plain
	}
};
	

resource 'CNTL' (132) {
	{0, 0, 0, 0},		/* rect:  contrlRect	*/
	135,				/* value: menu rsrc ID 	*/
	invisible,			/* vis:  standard		*/
	135,				/* max:  default menuID	*/
	1,					/* min:  default item #	*/
	popMenuProc 		/* ProcID:  3 			*/
		+ mCheck,		/* var: Check selection	*/
	0,					/* rfCon: for user's use*/
	"Programs: "		/* title: standard		*/
};

resource 'MENU' (135) {
	135,
	textMenuProc,
	allEnabled,
	enabled,
	"Programs: ",
	{	/* 5 items */
		"StatView",
			noIcon, noKey, noMark, plain;
		"StatView 512+",
			noIcon, noKey, noMark, plain;
		"StatView SE+Graphics",
			noIcon, noKey, noMark, plain;
		"StatView II",
			noIcon, noKey, noMark, plain;
		"SuperANOVA",
			noIcon, noKey, noMark, plain
	}
};



