/* resources for JamPaint.p */

/***** Makefile for this application *****

Pascal	=	Pascal
POptions	=	-s

.p.o		.p
	Pascal -k "{PLibraries}" {default}.p

JamPaint				JamPaint.r JamPaint.code
	Rez "{RIncludes}"Types.r JamPaint.r -o JamPaint -c JPNT
	SetFile -a B -d . JamPaint
JamPaint.code 		JamPaint.p.o
	Link JamPaint.p.o  
		"{Libraries}"Interface.o 
		"{PLibraries}"Paslib.o 
		"{Libraries}"Runtime.o 
		-o JamPaint.code
*/

Type 'JpNT' as 'STR ';

resource 'JpNT' (0) {"JamPaint by Edgar Circenis and Rod Magnuson -- Dec 28, 1987"};

resource 'FREF' (128) {'APPL', 0, ""};

resource 'BNDL' (128) {
	'JpNT', 0, {'ICN#', {0, 128};'FREF', {0, 128}}};

resource 'MENU' (255, "Apple", preload) {
	255,textMenuProc,0x7FFFFFD,enabled,apple,
	{	"About JamPaint", noIcon, "", "", plain,
		"-", noIcon, "", "", plain}};

resource 'MENU' (256, "File", preload)	{
	256, 0, 0x7FFFFFB7, enabled, "File",
	{	"Open",noicon, "O", nomark, plain;
		"Save",noicon, "S", nomark, plain;
		"Save as",noicon, noKey, nomark, plain;
		"-",noicon, noKey, nomark, plain;
		"Page Setup",noicon, nokey, nomark, plain;
		"Print",noicon, "P", nomark, plain;
		"-",noicon, noKey, nomark, plain;
		"Quit",noicon, "Q", nomark, plain}};

resource 'MENU' (257, "Font", preload)	{
	257, 0, 0x7FFFFFFF, enabled, "Font",{}};

resource 'MENU' (258, "Size", preload) {
	258,textMenuProc,allEnabled,enabled,"Size",
	{
		"9", noIcon, "", "", plain,
		"10", noIcon, "", "", plain,
		"12", noIcon, "", check, plain,
		"14", noIcon, "", "", plain,
		"18", noIcon, "", "", plain,
		"24", noIcon, "", "", plain,
		"36", noIcon, "", "", plain,
		"48", noIcon, "", "", plain,
		"72", noIcon, "", "", plain}};

resource 'MENU' (259, "Style", preload) {
	259,	textMenuProc,allEnabled,enabled,"Style",
	{	
		"Plain", noIcon, "", check, plain,
		"Bold", noIcon, "B", "", 1,
		"Italic", noIcon, "I", "", 2,
		"Underline", noIcon, "U", "", 4,
		"Outline", noIcon, "", "", 8,
		"Shadow", noIcon, "", "", 16,
		"Extend", noIcon, "", "", 64,
		"Condense", noIcon, "", "", 32}};

resource 'MENU' (260, "Effects", preload) {
	260,	textMenuProc,allEnabled,enabled,"Effects",
	{	"Fade In",noicon, noKey, nomark, plain;
		"Fade Out",noicon, noKey, nomark, plain;
		"Fade from/to",noicon, noKey, nomark, plain}};

resource 'MENU' (261, "Edit", preload) {
	261,textMenuProc,0x7FFFFFFC,enabled,"Edit",
	{	"Can't Undo", noIcon, "Z", "", plain,
		"-", noIcon, "", "", plain,
		"Cut", noIcon, "X", "", plain,
		"Copy", noIcon, "C", "", plain,
		"Paste", noIcon, "V", "", plain,
		"Clear", noIcon, "", "", plain}};

resource 'WIND' (129, "Paint Window", preload)	{
	{39,10,341,502},
	noGrowDocProc, visible, nogoaway, 0x0, "Untitled";};

resource 'ALRT' (2000) {
	{78, 122, 234, 364},2000,
	{	Cancel, visible, sound1,
		Cancel, visible, sound1,
		Cancel, visible, sound1,
		Cancel, visible, sound1}};

resource 'DITL' (2000) {
	{	{112, 32, 132, 92},
		Button {enabled,"Discard"},
		{72, 32, 92, 92},
		Button {enabled,"Save"},
		{72, 136, 92, 196},
		Button {enabled,"Cancel"},
		{24, 96, 40, 200},
		StaticText {disabled,"Save changes?"}}};

resource 'DLOG' (1000, "Pattern Editor") {
	{78, 148, 208, 374},
	dBoxProc,visible,noGoAway,0x0,1000,""};

resource 'DITL' (1000) {
	{	{104, 152, 124, 212},
		Button {enabled,"Ok"},
		{104, 80, 124, 140},
		Button {enabled,"Cancel"},
		{8, 24, 88, 104},
		UserItem {enabled},
		{8, 128, 88, 208},UserItem {disabled}}};

resource 'DLOG' (1001, "Resize Spray Kan") {
	{46, 98, 266, 410},
	dBoxProc,visible,noGoAway,0x0,1001,""};

resource 'DITL' (1001, "Resize Spray Kan") {
	{	{176, 232, 196, 292},
		Button {enabled,"OK"},
		{144, 232, 164, 292},
		Button {enabled,"Cancel"},
		{16, 16, 208, 208},
		UserItem {enabled},
		{40, 224, 56, 296},
		StaticText {disabled,"Flow Rate"},
		{70, 234, 84, 288},
		EditText {enabled,""}}};

resource 'DLOG' (1002, "Printing Error!") {
	{36, 108, 80, 392},
	dBoxProc,visible,noGoAway,0x0,1002,""};

resource 'DITL' (1002, "Printing Error!") {
	{	{13, 37, 29, 253},
		StaticText {disabled,"An error while printing occured!"}}};

data 'CLRS' (128,"colors", preload)	{
	$"0000 0000 0000"		/* BLACK */
	$"FFFF FFFF FFFF"		/* WHITE */
	$"FFFF 0000 0000"		/* RED */
	$"0000 FFFF 0000"		/* GREEN */
	$"0000 0000 FFFF"		/* BLUE */
	$"FFFF FFFF 0000"		/* YELLOW */
	$"0000 FFFF FFFF"		/* TURQUOISE */
	$"FFFF 0000 FFFF"		/* MAGENTA */
};

resource 'PAT#' (128,"Patterns", preload) {
	{
		/* [Black] */
		$"FFFF FFFF FFFF FFFF",
		/* [Dk Gray] */
		$"DDFF 77FF DDFF 77FF",
		/* [Med Gray] */
		$"DD77 DD77 DD77 DD77",
		/* [Gray] */
		$"AA55 AA55 AA55 AA55",
		/* [White] */
		$"0000 0000 0000 0000",
		/* [Spot White] */
		$"8000 0800 8000 0800",
		/* [More Spots White] */
		$"8800 2200 8800 2200",
		/* [Still More Spots White] */
		$"8822 8822 8822 8822",
		/* [And Still More Spots White] */
		$"AA00 AA00 AA00 AA00"
	}
};

include "JamPaint.rsrc";	/* additional resources */
include "JamPaint.code";
