#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#include "SysTypes.r"

#if qDebug
include "Debug.rsrc";
#endif
include "MacApp.rsrc";
include "Printing.rsrc";

include "Sample" 'CODE';	/* include CODE resources from compile/link  */

/*  cAboutApp, cNew, etc. defined in "{MARIncludes}MacAppTypes.r"  */
#define  kWindRsrcID 		1001
#define  kPrinterStringID 	1001			/* STR  resource ID */
#define  kMacStringID 		1002			/* STR  resource ID */
#define	kFontStringId 		1003
#define  cMac 					2001			/* menu command number */
#define  cPrinter				2002			/* menu command number */

resource 'vers' (1) {
	0x00, 0x95, beta, 0x2, verUS,
	"0.95b2",
	"0.95 b2 (US), 1989 MacTutor"
};

resource 'vers' (2) {
	0x05, 0x08, development, 0x02, verUS,
	"Vol. 5 No. 8",
	"MacTutor, Vol. 5 No. 8"
};

resource 'STR ' (kPrinterStringID) {
	"This is the printer (Driver)";
};
	
resource 'STR ' (kMacStringID) {
	"This is the Mac";
};

resource 'STR ' (kFontStringID) {
	"times";
};

resource 'cmnu' (1) {
	1,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	 {	
		"About Sample", noIcon, noKey, noMark, plain, cAboutApp;	
		"-", noIcon, noKey, noMark, plain, nocommand
	}
};

resource 'cmnu' (2) {
	2,
	textMenuProc,
	0x7FFFFBBB,
	enabled,
	"File",
	 {
		"New", noIcon, "N", noMark, plain, cNew;
		"Open", noIcon, "O", noMark, plain, cOpen;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Close", noIcon, "W", noMark, plain, cClose;
		"Save", noIcon, "S", noMark, plain, cSave;
		"Save As", noIcon, noKey, noMark, plain, cSaveAs;
		"Save a Copy In", noIcon, noKey, noMark, plain, cSaveCopy;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Page Setup", noIcon, noKey, noMark, plain, cPageSetup;
		"Print One", noIcon, noKey, noMark, plain, cPrintOne;
		"Print", noIcon, "P", noMark, plain, cPrint;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Quit", noIcon, "Q", noMark, plain, cQuit
	}
};

resource 'cmnu' (3) {
	3,
	textMenuProc,
	0x7FFFFFBD,
	enabled,
	"Edit",
	 {
		"Undo", noIcon, "Z", noMark, plain, cUndo;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Cut", noIcon, "X", noMark, plain, cCut;
		"Copy", noIcon, "C", noMark, plain, cCopy;
		"Paste", noIcon, "V", noMark, plain, cPaste;
		"Clear", noIcon, noKey, noMark, plain, cClear;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Show Clipboard", noIcon, noKey, noMark, plain, cShowClipboard
	}
};

resource 'cmnu' (4) {
	4,
	textMenuProc,
	0x7FFFFFBD,
	enabled,
	"Sample",
	 {
		"Query Mac", noIcon, "M", noMark, plain, cMac;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Query Printer", noIcon, "P", noMark, plain, cPrinter;
	}
};

resource 'MBAR' (128) {
	{1; 2; 3; 4}
};

resource 'WIND' (kWindRsrcID, purgeable) {
	{50, 40, 375, 450},
	zoomDocProc,
	invisible,
	goAway,
	0x0,
	"<<<>>>"
};

resource 'SIZE' (-1) {
	saveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	MultiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	reserved, reserved, reserved, reserved, reserved, reserved, reserved,
#if qDebug
	340 * 1024,
	320 * 1024
#else
	150 * 1024,
	120 * 1024
#endif
};

resource 'seg!' (256,
#if qNames
"Sample",
#endif
	purgeable) {
	{	"GTerminate";
		"GNonRes";
		"GOpen";
		"GWriteFile";
		"GFile";
		"GClose";
		"GClipBoard";
		"GDoCommand";
		"MAView";
		"GSelCommand";
	}
};

resource 'mem!' (256,
#if qNames
"Sample",
#endif
	purgeable) {
	43 * 1024,		/* Add to temporary reserve */
	0,					/* Add to permanent reserve */
	0					/* Add to stack space */
};

resource 'DITL' (201, purgeable) {
	 {	/* array DITLarray: 3 elements */
		/* [1] */
		{130, 182, 150, 262},
		Button {
			enabled,
			"OK"
		};
		/* [2] */
		{10, 80, 110, 270},
		StaticText {
			disabled,
			"This program queries the printer & Mac"
			"\n\nThis program was written "
			"with MacApp 2.0b9   1985-1989 Apple Computer, Inc."
		};
		/* [3] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			1
		}
	}
};

resource 'ALRT' (201, purgeable) {
	{90, 100, 250, 412},
	201,
	{
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent
	}
};

