unit HandleTheMenus;

{File name :  HandleTheMenus.Pp  }
{Function: Handle all menu selections.}
{          This procedure is called when a menu item is selected.}
{          There is one CASE statement for all Lists.  There is}
{          another CASE for all the commands in each List.}
{History: 6/10/89 Original by Prototyper.   }
{ Created for MacTutor   }
{ 1989 CopyRight MacTutor  All Rights Reserved   }

interface

	uses
		Globals, About, Options, InitTheMenus;

	procedure Handle_My_Menu (var doneFlag: boolean; theMenu, theItem: integer; var theInput: TEHandle);{Handle menu selection}

implementation

	procedure Handle_My_Menu;   		{Handle menu selections realtime}
		const
			L_Apple = 1001; 			{Menu list}
			C_About_Page_Sizes = 1;
			L_File = 1002;  			{Menu list}
			C_Open = 1;
			C_Save_As = 2;
			C_Set_Page_Setup_Default = 4;
			C_Quit = 6;
			L_Edit = 1003;  			{Menu list}
			C_Undo = 1;
			C_Cut = 3;
			C_Copy = 4;
			C_Paste = 5;
		var
			DNA, Err: integer;  			{For opening DAs}
			BoolHolder: boolean;   	{For SystemEdit result}
			DAName: Str255;    		{For getting DA name}
			SavePort: GrafPtr; 		{Save current port when opening DAs}
			where: point;				{location of SF dialogs}
			prompt, origname, astring: str255;
			typeList: SFTypeList;
			numtypes, count, oldcount: integer;
			Total_length, RefNum, i, j, k: integer;
			PRECHndl, SaveHndl, hndl: handle;

	begin   						{Start of procedure}

		case theMenu of 		{Do selected menu list}

			L_Apple: 
				begin
					case theItem of{Handle all commands in this menu list}
						C_About_Page_Sizes: 
							begin
								D_About;{Call a dialog for this menu selection}
							end;
						otherwise{Handle the DAs}
							begin{Start of Otherwise}
								GetPort(SavePort);{Save the current port}
								GetItem(AppleMenu, theItem, DAName);{Get the name of the DA selected}
								DNA := OpenDeskAcc(DAName);{Open the DA selected}
								SetPort(SavePort);{Restore to the saved port}
							end;{End of Otherwise}

					end;    		{End of item case}
				end;    			{End for this list}

			L_File: 
				begin
					case theItem of{Handle all commands in this menu list}
						C_Open: 
							begin
									{Call the SFGetFile OS routine}
								where.h := 80;
								where.v := 80;
								prompt := '';
								numTypes := -1;
								SFGetFile(where, prompt, nil, numTypes, typeList, nil, reply);
								if reply.good = true then
									begin
										RefNum := OpenRFPerm(reply.fName, reply.VRefNum, 3);
										if (RefNum = -1) or (ResError <> NoErr) then
											SetDefaultPrec
										else
											begin
												Count := CountResources('PREC');
												if Count = 0 then
													SetdefaultPrec
												else
													begin
														UseResFile(RefNum);
														PRECHndl := Get1Resource('PREC', 4);
														if (PRECHndl = nil) or (ResError <> NoErr) then
															SetdefaultPrec
														else
															begin
																HNoPurge(PRECHndl);
																therealprec4hndl := realprec4hndl(PRECHndl);
																for k := 1 to 6 do
																	begin
																		PREC4.Size[k].h := therealprec4hndl^^.Size[k].h;
																		PREC4.Size[k].v := therealprec4hndl^^.Size[k].v;
																	end;
																count := -1;
																for k := 1 to 6 do
																	begin
																		count := count + 1;
																		j := ord(therealprec4hndl^^.title[count]) - 1;
																		count := count + 1;
																		oldcount := count;
																		PREC4.Title[k] := '';
																		for count := oldcount to oldcount + j do
																			begin
																				PREC4.Title[k] := concat(PREC4.Title[k], therealprec4hndl^^.title[count]);
																			end;
																		if PREC4.Title[k] = '' then
																			PREC4.Title[k] := '?';
																		count := oldcount + j;
																	end;
																SetWTitle(MyWindow, reply.fName);
															end;
														CloseResFile(RefNum);
														HPurge(PRECHndl);
														DisposHandle(PRECHndl);
														SetFields;
													end;
											end;
									end;
							end;

						C_Save_As: 
							begin
									{Call the SFPutFile OS routine}
								where.h := 80;
								where.v := 80;
								origname := reply.fName;
								prompt := 'Save PREC4 resource to file:';
								SFPutFile(where, prompt, origName, nil, reply);
								if reply.good then
									begin
										Total_length := 32;  {first half of PREC resource}
										for i := 1 to 6 do
											Total_length := Total_length + length(PREC4.Title[i]);
										SaveHndl := NewHandle(Total_length);  {Create new PREC resource}
										if SaveHndl <> nil then
											begin
												HNoPurge(SaveHndl);
												therealprec4Hndl := realprec4hndl(SaveHndl);
												therealprec4hndl^^.numberofbuttons := 0;
												for i := 1 to 6 do
													if (length(PREC4.Title[i]) <> 0) or (PREC4.Title[i] = '?') then
														therealprec4hndl^^.numberofbuttons := therealprec4hndl^^.numberofbuttons + 1;
												for k := 1 to 6 do
													begin
														therealprec4hndl^^.Size[k].h := PREC4.Size[k].h;
														therealprec4hndl^^.Size[k].v := PREC4.Size[k].v;
													end;
												if length(PREC4.Title[1]) <> 0 then
													astring := PREC4.Title[1]
												else
													astring := concat(chr(1), '?');
												for j := 2 to 6 do
													begin
														if length(PREC4.Title[j]) <> 0 then
															astring := concat(astring, chr(length(PREC4.Title[j])), PREC4.Title[j])
														else
															astring := concat(astring, chr(1), '?');
													end;
												therealprec4hndl^^.Title[0] := chr(length(PREC4.Title[1]));
												for i := 1 to length(astring) do
													begin
														therealprec4hndl^^.Title[i] := astring[i];
													end;
												err := SetVol(nil, reply.VRefNum);
												err := Create(reply.fname, reply.vRefNum, 'PROF', 'TEXT');
												CreateResFile(reply.fname);
												if ResError = dupFNErr then
													begin
														RefNum := OpenRfPerm(reply.fname, reply.VRefNum, 3);
														hndl := Get1Resource('PREC', 4);
														if Hndl <> nil then
															begin
																RmveResource(Hndl);
																ChangedResource(Hndl);
																UpdateResFile(RefNum);
																DisposHandle(Hndl);
															end;
													end;
												begin
													RefNum := OpenRfPerm(reply.fname, reply.VRefNum, 3);
												end;
												addresource(SaveHndl, 'PREC', 4, '');
												writeresource(saveHndl);
												closeresfile(RefNum);
												HPurge(SaveHndl);
												DisposHandle(SaveHndl);
												SetWTitle(MyWindow, reply.fName);
											end;
									end;
							end;

						C_Set_Page_Setup_Default: 
							begin
								SetDefaultPREC;
							end;

						C_Quit: 
							begin
								doneFlag := TRUE;
							end;
						otherwise
							begin{Start of the Otherwise}
							end;{End of Otherwise}

					end;    		{End of item case}
				end;    			{End for this list}

			L_Edit: 
				begin
					BoolHolder := SystemEdit(theItem - 1);{Let the DA do the edit to itself}
					if not (BoolHolder) then{If not a DA then we get it}
						begin   	{Handle by using a Case statment}
							case theItem of{Handle all commands in this menu list}
								C_Undo: 
									begin
										{?? ADD IN HERE WHAT THIS COMMAND SHOULD DO}
									end;
								C_Cut: 
									begin
										{?? ADD IN HERE WHAT THIS COMMAND SHOULD DO}
									end;
								C_Copy: 
									begin
										{?? ADD IN HERE WHAT THIS COMMAND SHOULD DO}
									end;
								C_Paste: 
									begin
										{?? ADD IN HERE WHAT THIS COMMAND SHOULD DO}
									end;
								otherwise{Send to a DA}
									begin{Start of the Otherwise}
									end;{End of Otherwise}

							end;    	{End of not BoolHolder}
						end;    		{End of item case}
				end;    			{End for this list}

			otherwise
				begin   			{Start of the Otherwise}
				end;    			{End of Otherwise}

		end;    					{End for the Lists}

		HiliteMenu(0);  			{Turn menu selection off}
	end;    						{End of procedure Handle_My_Menu}

end.    								{End of unit}