/* Copyright  1988-1989 Apple Computer, Inc.  All rights reserved. */

#if qDebug
include "Debug.rsrc";
#endif
include "MacApp.rsrc";
include "Dialog.rsrc";
include "Printing.rsrc";

include "Plot" 'CODE';

#define kPlotView			1010
#define kViewRsrcID			1005

resource 'seg!' (256, purgeable) {
	{
		"GOpen";
		"GClose";
		"GNonRes";
		"GSelCommand"
	}
};

resource 'SIZE' (-1) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	MultiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
#if qDebug
	368 * 1024,		/* ??? BALLPARK GUESSES!!! ????????????????????????????????????	*/
	320 * 1024
#else
	(300-32) * 1024,		/* ??? BALLPARK GUESSES!!! ????????????????????????????????????	*/
	(200-32) * 1024
#endif
};

resource 'DITL' (201, purgeable) {
	 {
/* [1] */	{160, 182, 180, 262}, Button { enabled, "OK" };
/* [2] */	{10, 75, 150, 316}, StaticText { disabled, 
	"This is an implementation of the MacTutor Plotter Program." 
	"\n\n written "
	"with MacApp  1985-1989 Apple Computer, Inc."};
/* [3] */	{10, 20, 42, 52}, Icon { disabled, 1 }
	}
};

resource 'ALRT' (1000, purgeable) {
	{44, 48, 130, 358},
	1000,
	{
		OK, visible, sound1,
		OK, visible, sound1,
		OK, visible, sound1,
		OK, visible, sound1
	}
};

resource 'ALRT' (201, purgeable) {
	{90, 100, 280, 412},
	201,
	{
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent
	}
};

resource 'cmnu' (1) {
	1,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	 {
/* [1] */	"About Plotter", noIcon, noKey, noMark, plain, cAboutApp;
/* [2] */	"-", noIcon, noKey, noMark, plain, nocommand
	}
};


resource 'cmnu' (2) {
	2,
	textMenuProc,
	0x7FFFEEFB,
	enabled,
	"File",
	 {
		"New", noIcon, "N", noMark, plain, cNew;
		"Open", noIcon, "O", noMark, plain, cOpen;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Close", noIcon, noKey, noMark, plain, cClose;
		"Save", noIcon, "S", noMark, plain, cSave;
		"Save As", noIcon, noKey, noMark, plain, cSaveAs;
		"Save a Copy In", noIcon, noKey, noMark, plain, cSaveCopy;
		"Revert", noIcon, noKey, noMark, plain, cRevert;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Page Setup", noIcon, noKey, noMark, plain, cPageSetup;
		"Print", noIcon, noKey, noMark, plain, cPrint;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Quit", noIcon, "Q", noMark, plain, cQuit
	}
};

resource 'cmnu' (3) {
	3,
	textMenuProc,
	0x7FFFFFBD,
	enabled,
	"Edit",
	 {
/* [1] */	"Undo", noIcon, "Z", noMark, plain, cUndo;
/* [2] */	"-", noIcon, noKey, noMark, plain, nocommand;
/* [3] */	"Cut", noIcon, "X", noMark, plain, cCut;
/* [4] */	"Copy", noIcon, "C", noMark, plain, cCopy;
/* [5] */	"Paste", noIcon, "V", noMark, plain, cPaste;
/* [6] */	"Clear", noIcon, noKey, noMark, plain, cClear;
/* [7] */	"-", noIcon, noKey, noMark, plain, nocommand;
/* [8] */	"Show Clipboard", noIcon, noKey, noMark, plain, cShowClipboard
	}
};


/* Hierarchical  Format menu with Style, Size and Font submenus */
resource 'cmnu' (7) {
	7,
	textMenuProc,
	allEnabled,
	enabled,
	"MacAppPlot",
	 {
/* [ 1] */	"Plot",				noIcon, noKey, noMark, plain, 1401;
/* [ 2] */	"-",				noIcon,	noKey,	noMark,	plain,	nocommand;
/* [ 3] */	"Style",			noIcon, "\0x1B", "\0x08", plain, 2401;
/* [ 4] */	"Size",				noIcon, "\0x1B", "\0x09", plain, 2402;
/* [ 5] */	"Font",				noIcon, "\0x1B", "\0x0A", plain, 2403;
/* [ 6] */	"Color",			noIcon, "\0x1B", "\0x0B", plain, 2404
	}
};

/* Hierarchical Style Sub-menu */
resource 'cmnu' (8) {
	8,
	textMenuProc,
	allEnabled,
	enabled,
	"Style",
	 {
/* [ 1] */	"Plain Text",		noIcon,	"P",	noMark,	plain,		2001;
/* [ 2] */	"Bold",				noIcon,	"B",	noMark,	bold,		2002;
/* [ 3] */	"Italic",			noIcon,	"I",	noMark,	italic,		2003;
/* [ 4] */	"Underline",		noIcon,	"U",	noMark,	underline,	2004;
/* [ 5] */	"Outline",			noIcon,	"O",	noMark,	outline,	2005;
/* [ 6] */	"Shadow",			noIcon,	"S",	noMark,	shadow,		2006;
/* [ 7] */	"Condensed",		noIcon,	noKey,	noMark, condense,	2007;
/* [ 8] */	"Extended",			noIcon,	noKey,	noMark, extend,		2008;
/* [ 9] */	"-",				noIcon,	noKey,	noMark,	plain,	nocommand;
/* [10] */	"Left justified",	noIcon,	noKey,	noMark,	plain,	2201;
/* [11] */	"Center justified",	noIcon,	noKey,	noMark,	plain,	2202;
/* [12] */	"Right justified",	noIcon,	noKey,	noMark,	plain,	2203
	}
};

/* Hierarchical Size Sub-menu */
resource 'cmnu' (9) {
	9,
	textMenuProc,
	AllEnabled,
	enabled,
	"Size",
	 {
/* [ 1] */	"9 Point",			noIcon,	noKey,	noMark,	plain,	2109;
/* [ 2] */	"10 Point",			noIcon,	noKey,	noMark,	plain,	2110;
/* [ 3] */	"12 Point",			noIcon,	noKey,	noMark,	plain,	2112;
/* [ 4] */	"14 Point",			noIcon,	noKey,	noMark,	plain,	1114;
/* [ 5] */	"18 Point",			noIcon,	noKey,	noMark,	plain,	1118;
/* [ 6] */	"24 Point",			noIcon,	noKey,	noMark,	plain,	1124;
/* [ 7] */	"-",				noIcon,	noKey,	noMark,	plain,	nocommand;
/* [ 8] */	"Grow selection",	noIcon,	"]",	noMark,	plain,	1198;
/* [ 9] */	"Shrink selection",	noIcon,	"[",	noMark,	plain,	1199

	 }
};

/* Font menu for hierarchical or non-hierarchical system */
resource 'MENU' (10) {
	10,
	textMenuProc,
	allEnabled,
	enabled,
	"Font",
	{ }
};

resource 'cmnu' (11) {
	11,
	textMenuProc,
	allEnabled,
	enabled,
	"Color",
	{
/* [ 1] */	"Set Graph Color", noIcon,	noKey,	noMark,	plain,	2503;
/* [ 2] */	"Set Axis Color",  noIcon,	noKey,	noMark,	plain,	2504;
/* [ 3] */	"Set Text Color",	noIcon,	noKey,	noMark,	plain,	2501;
/* [ 4] */	"Set Background Color",
								noIcon,	noKey,	noMark,	plain,	2502
	}
};


resource 'cmnu' (128) {
	128,
	textMenuProc,
	allEnabled,
	enabled,
	"Buzzwords",
	{
		"Style Change",			noIcon,	noKey,	noMark,	plain,	cStyleChange;
		"Size Change",			noIcon,	noKey,	noMark,	plain,	2100;
		"Justification Change",	noIcon,	noKey,	noMark,	plain,	2200;
		"Font Change",			noIcon,	noKey,	noMark,	plain,	2300;
		"Color Change",			noIcon,	noKey,	noMark,	plain,	2500;
		"Page Setup Change",	noIcon,	noKey,	noMark,	plain,	cChangePrinterStyle
	}
};


/* Displayed menus on a non-hierarchical system */
resource 'MBAR' (128) {
	{1; 2; 3 ; 8; 9; 10; 11}
};

/* Displayed menus on an hierarchical system */
resource 'MBAR' (131) {
	{1; 2; 3; 7}
};

/* Hierarchial Sub-Menus */
resource 'MBAR' (130) {
	{8; 9; 10; 11}
};

resource 'STR#' (1001, purgeable) {
	{
/* [ 1] */	"Select a new text color",
/* [ 2] */	"Select background color"
/* [ 2] */	"Select graph line color"
/* [ 2] */	"Select axis color"
	}
};

/* a resource for picking up default text, graph and color info */
resource 'view' (kViewRsrcID, purgeable) {{
	root, 'TEVW', { 0, 0 }, { 116, 1020 },
		sizeVariable, sizePage, shown, enabled,
		TEView { "TTEView",
			withStyle, autoWrap, acceptChanges,
			dontFreeText, cTyping, unlimited,
			{ 8, 10, 0, 10 },
			justLeft, plain, 9, {0, 0, 0}, "Geneva" }
} };


/* resource 'MBAR' (129) { {235} }; */
