unit MyGlobals;
interface
	uses
		PrintTraps, Sound;

	const
		L_Apple = 1001; 			{Menu list}
		MI_About_Zoundz = 1;
		L_File = 1002;  			{Menu list}
		MI_New = 1;
		MI_Open = 2;
		MI_Close = 4;
		MI_Save = 5;
		MI_Save_As = 6;
		MI_Page_Setup = 8;
		MI_Print = 9;
		MI_Quit = 11;
		L_Edit = 1003;  			{Menu list}
		MI_Undo = 1;
		MI_Cut = 3;
		MI_Copy = 4;
		MI_Paste = 5;
		L_Extend = 1004;	{Menu list}
		MI_Frequency = 1;
		MI_Amplitude = 2;
		MI_Duration = 3;
		MI_Timbre = 4;

		I_Yes = 1;
		I_Cancel = 2;
		I_No = 3;
	type
		DocPtr = ^DocRec;
		DocRec = record {Sound Doc Structure}
				Freq, Amp, Dur, Timbre: array[1..100] of integer;
				EndValue, StartValue: integer;
			end;

		MySoundRec = packed record {Snd structure}
				format: integer;
				SynthCount: integer;
				SynthType: integer;
				SynthInit: longint;
				CommandCount: integer;
				MySounds: array[1..202] of SndCommand;
			end;

		MySoundPtr = ^MySoundRec;
		MySoundHdl = ^MySoundPtr;

	var
		FreqText, AmpText, DurText, TimbreText: Str255; {Text Strings}
		NoteText, StartText, EndText: Str255;

		NoteIndex, DrawTool: integer; {Indices}

		MyDoc: DocPtr; {Sound Document}
		Dirty: boolean;

		NoteRect, FreqRect, AmpRect, DurRect, TimbreRect: Rect; {Text Rectangles}
		EndRect, StartRect, NotePallete: Rect;

		MyHandle: Handle;  {Various Handles}
		MySoundHandle: MySoundHdl;

		AppleMenu: MenuHandle;   		{Menu handle}
		M_File: MenuHandle;
		M_Edit: MenuHandle;
		M_Extend: MenuHandle;

		MyWindow: WindowPtr;   		{Window pointer}

		FileName: str255;							{File Stuff}
		volRefNum, FileStatus: integer;

		theSquare, theWatch: CursHandle; {Cursor Stuff}

		ThePrintRec: THPrint; {Printing Stuff}
		ThePrintPort: TPPrPort;
		PrintStatus: TPrStatus;
		PageRect: rect;
implementation
end.