unit Untitled;

{File name: Untitled.Pas}
{Function: Handle a Window}
{History: 4/17/89 Original by Prototyper.   }

interface
	uses
		PrintTraps, Sound, MyGlobals, MySound;

	{Initialize us so all our routines can be activated}
	procedure Init_Untitled;

	{Close our window}
	procedure Close_Untitled (whichWindow: WindowPtr);

	{Open our window and draw everything}
	procedure Open_Untitled;

	{Update our window, someone uncovered a part of us}
	procedure Update_Untitled (whichWindow: WindowPtr);

	{Handle action to our window, like controls}
	procedure Do_Untitled (myEvent: EventRecord);

implementation

	const
		B_Play_Sound = 26;  			{Button ID}
		CB_Timbre = 16;  				{Checkbox IDs}
		CB_Duration = 15;
		CB_Amplitude = 14;
		CB_Frequency = 13;
		RB_Timbre = 20; 				{Radio IDs}
		RB_Duration = 19;
		RB_Amplitude = 18;
		RB_Frequency = 17;
		I_DurationScrollbar = 41;   	{Scroll bar IDs}
		I_AmplitudeScrollbar = 40;
		I_FrequencyScrollbar = 39;
		I_TimbreScrollbar = 38;
		I_EndScrollbar = 31;
		I_StartScrollbar = 27;
		I_NoteScrollbar = 12;

	var
		tempRect: Rect;  	{Temporary rectangle}
		sTemp: Str255; 				{Get text entered, temp holding}
		C_EndScrollbar: ControlHandle;
		C_StartScrollbar: ControlHandle;
		C_NoteScrollbar: ControlHandle;
		R1Control: array[1..4] of ControlHandle;{ Radio button handles for group}
		C_Play_Sound: ControlHandle;
		C_Timbre: ControlHandle;
		C_Duration: ControlHandle;
		C_Amplitude: ControlHandle;
		C_Frequency: ControlHandle;
		C_DurationScrollbar: ControlHandle;
		C_AmplitudeScrollbar: ControlHandle;
		C_FrequencyScrollbar: ControlHandle;
		C_TimbreScrollbar: ControlHandle;

{=================================}

	{Initialize us so all our routines can be activated}
	procedure Init_Untitled;
		var
			i: integer;
	begin   							{Start of Window initialize routine}
		MyWindow := nil;

		NoteText := '1'; {Init Texts}
		StartText := '1';
		EndText := '1';
		FreqText := '0';
		AmpText := '0';
		DurText := '0';
		TimbreText := '0';

		NoteIndex := 1; {Init Miscellaneous}
		DrawTool := 1;
		MyDoc^.EndValue := 1;
		MyDoc^.StartValue := 1;
		MySoundHandle := nil;
		MyHandle := nil;
		volRefNum := 0;

		for i := 1 to 100 do {initialize arrays}
			begin
				MyDoc^.freq[i] := 0;
				MyDoc^.amp[i] := 0;
				MyDoc^.dur[i] := 0;
				MyDoc^.timbre[i] := 0;
			end;

	end; {End of Init_Untitled}

{=================================}

	{Close our window}
	procedure Close_Untitled;
	begin
		if (MyWindow <> nil) and ((MyWindow = whichWindow) or (ord4(whichWindow) = -1)) then
			begin
				DisposeWindow(MyWindow);
				MyWindow := nil;
			end;
	end;	{End of Close_Untitled}

{=================================}

	{draws a square according to the pattern}
	procedure DrawSquare (vert, horiz: integer; thePat: pattern);
		var
			theSquare: rect;
	begin
		SetRect(theSquare, horiz, vert, horiz + 10, vert + 10);
		InSetRect(theSquare, 1, 1);
		PenNormal;
		FillRect(theSquare, thePat);
		FrameRect(theSquare);
	end; {of DrawSquare}

{=================================}

	{Takes a point and returns vertical and horizontal values}
	procedure Unconvert (thePoint: Point; range: integer; var value, column: integer);
		var
			Lvalue, Lrange: longint;
	begin
		if thePoint.h < 5 then {out of range}
			column := -1
		else {get column}
			column := (thePoint.h - 5) div 10;
		if column > 22 then {out of range}
			column := -1;

		if (thePoint.v < 5) or (thePoint.v > 260) then
			value := -1 {out of range}
		else
			begin {get value}
				Lvalue := thePoint.v - 5;
				Lrange := range;
				Lvalue := Lvalue * Lrange;
				value := LValue div 255;
			end;
	end; {of unconvert}

{=================================}

{returns vertical position}
	function Convert (value, range: integer): integer;
		var
			Lvalue, Lrange: longint;
	begin
		Lvalue := value;
		LRange := range;
		Convert := ((Lvalue * 245) div Lrange) + 5;
	end; {of Convert}

{=================================}

	{Update our window, someone uncovered a part of us}
	procedure UpDate_Untitled;
		var
			SavePort: WindowPtr;   		{Place to save the last port}
			theValue, theTop, i, rangeStop, RangeStart: integer;
	begin
		if (MyWindow <> nil) and (MyWindow = whichWindow) then
			begin
				GetPort(SavePort);  	{Save the current port}
				SetPort(MyWindow);  	{Set the port to my window}
				TextFont(systemFont);{Set the font to draw in}

				{ Draw DrawGraph Stuff}
				SetRect(TempRect, 245, 20, 355, 105);{left,top,right,bottom}
				FrameRect(TempRect);{Frame this rectangle area}
				SetRect(tempRect, 265, 5, 345, 20);
				sTemp := 'Draw Graph';
				TextBox(Pointer(ord(@sTemp) + 1), length(sTemp), tempRect, teJustLeft);
				SetRect(tempRect, 248, 28, 258, 38);
				FillRect(tempRect, black);
				FrameRect(tempRect);
				SetRect(tempRect, 248, 48, 258, 58);
				FillRect(tempRect, dkgray);
				FrameRect(tempRect);
				SetRect(tempRect, 248, 68, 258, 78);
				FillRect(tempRect, gray);
				FrameRect(tempRect);
				SetRect(tempRect, 248, 88, 258, 98);
				FillRect(tempRect, ltgray);
				FrameRect(tempRect);
				FrameRect(tempRect);
				TextBox(Pointer(ord(@FreqText) + 1), length(FreqText), FreqRect, teJustLeft);
				TextBox(Pointer(ord(@AmpText) + 1), length(AmpText), AmpRect, teJustLeft);
				TextBox(Pointer(ord(@DurText) + 1), length(DurText), DurRect, teJustLeft);
				TextBox(Pointer(ord(@TimbreText) + 1), length(TimbreText), TimbreRect, teJustLeft);

				{ Draw a rectangle, ViewGraphRect }
				SetRect(TempRect, 390, 190, 490, 275);{left,top,right,bottom}
				FrameRect(TempRect);{Frame this rectangle area}
				SetRect(tempRect, 400, 175, 475, 190);
				sTemp := 'View Graph';
				TextBox(Pointer(ord(@sTemp) + 1), length(sTemp), tempRect, teJustLeft);

				{ Draw a rectangle, NotePallete }
				PenPat(white);
				PaintRect(NotePallete);
				PenNormal;
				FrameRect(NotePallete);{Frame this rectangle area}
				RangeStart := GetCtlValue(C_NoteScrollbar);
				RangeStop := RangeStart + 22;
				if RangeStop > 100 then
					RangeStop := 100;
				for i := RangeStart to RangeStop do
					begin
						if GetCtlValue(C_Timbre) = 1 then
							begin
								theValue := MyDoc^.timbre[i];
								theTop := Convert(theValue, 254);
								DrawSquare(theTop, (i - RangeStart) * 10 + 5, ltgray);
							end;
						if GetCtlValue(C_Duration) = 1 then
							begin
								theValue := MyDoc^.dur[i];
								theTop := Convert(theValue, 250);
								DrawSquare(theTop, (i - RangeStart) * 10 + 5, gray);
							end;
						if GetCtlValue(C_Amplitude) = 1 then
							begin
								theValue := MyDoc^.amp[i];
								theTop := Convert(theValue, 255);
								DrawSquare(theTop, (i - RangeStart) * 10 + 5, dkgray);
							end;
						if GetCtlValue(C_Frequency) = 1 then
							begin
								theValue := MyDoc^.freq[i];
								theTop := Convert(theValue, 128);
								DrawSquare(theTop, (i - RangeStart) * 10 + 5, black);
							end;
					end;

				{Music Selection Stuff}
				SetRect(tempRect, 255, 175, 365, 190);
				sTemp := 'Music Selection';
				TextBox(Pointer(ord(@sTemp) + 1), length(sTemp), tempRect, teJustLeft);
				SetRect(TempRect, 245, 190, 375, 275);{left,top,right,bottom}
				FrameRect(TempRect);{Frame this rectangle area}
				TextBox(Pointer(ord(@EndText) + 1), length(EndText), EndRect, teJustLeft);
				TextBox(Pointer(ord(@StartText) + 1), length(StartText), StartRect, teJustLeft);
				SetRect(tempRect, 250, 235, 280, 250);
				sTemp := 'End:';
				TextBox(Pointer(ord(@sTemp) + 1), length(sTemp), tempRect, teJustLeft);
				SetRect(tempRect, 250, 195, 290, 210);
				sTemp := 'Start:';
				TextBox(Pointer(ord(@sTemp) + 1), length(sTemp), tempRect, teJustLeft);

				{Draw NoteIndex}
				SetRect(tempRect, 370, 5, 410, 20);
				sTemp := 'Note:';
				TextBox(Pointer(ord(@sTemp) + 1), length(sTemp), tempRect, teJustLeft);
				TextBox(Pointer(ord(@NoteText) + 1), length(NoteText), NoteRect, teJustLeft);
				TextFont(applFont);{Set the default application font}

				DrawControls(MyWindow);{Draw all the controls}
				SetPort(SavePort);  	{Restore the old port}
			end;    						{End for if (MyWindow<>nil)}
	end; {End of Update_Untitled}

{=================================}

	{Open our window and draw everything}
	procedure Open_Untitled;
	begin

		if (MyWindow = nil) then
			begin
				MyWindow := GetNewWindow(1, nil, Pointer(-1));{Get the window}
				SetPort(MyWindow);

				{ Make a button, Play Sound }
				C_Play_Sound := GetNewControl(B_Play_Sound, MyWindow);

				{ Make a checkboxes }
				C_Timbre := GetNewControl(CB_Timbre, MyWindow);
				C_Duration := GetNewControl(CB_Duration, MyWindow);
				C_Amplitude := GetNewControl(CB_Amplitude, MyWindow);
				C_Frequency := GetNewControl(CB_Frequency, MyWindow);

				{ Make a radio buttons }
				R1Control[4] := GetNewControl(RB_Timbre, MyWindow);
				R1Control[3] := GetNewControl(RB_Duration, MyWindow);
				R1Control[2] := GetNewControl(RB_Amplitude, MyWindow);
				R1Control[1] := GetNewControl(RB_Frequency, MyWindow);

				{ Make a scroll bars }
				C_DurationScrollbar := GetNewControl(I_DurationScrollbar, MyWindow);
				SetCtlValue(C_DurationScrollbar, MyDoc^.dur[NoteIndex]);
				C_AmplitudeScrollbar := GetNewControl(I_AmplitudeScrollbar, MyWindow);
				SetCtlValue(C_AmplitudeScrollbar, MyDoc^.amp[NoteIndex]);
				C_FrequencyScrollbar := GetNewControl(I_FrequencyScrollbar, MyWindow);
				SetCtlValue(C_FrequencyScrollbar, MyDoc^.freq[NoteIndex]);
				C_TimbreScrollbar := GetNewControl(I_TimbreScrollbar, MyWindow);
				SetCtlValue(C_TimbreScrollbar, MyDoc^.timbre[NoteIndex]);

				C_EndScrollbar := GetNewControl(I_EndScrollbar, MyWindow);
				C_StartScrollbar := GetNewControl(I_StartScrollbar, MyWindow);
				SetCtlValue(C_EndScrollbar, MyDoc^.EndValue);
				SetCtlValue(C_StartScrollbar, MyDoc^.StartValue);

				C_NoteScrollbar := GetNewControl(I_NoteScrollbar, MyWindow);

				ShowWindow(MyWindow);
				SelectWindow(MyWindow);
			end
		else
			SelectWindow(MyWindow);
	end; {End of Open_Untitled}

{=================================}

	{Handle action to our window, like controls}
	procedure Do_Untitled;
		var
			RefCon: longint;
			code: integer;
			theValue: integer;
			whichWindow: WindowPtr;
			myPt: Point;
			theControl: ControlHandle;
			MyErr: OSErr;
			tempRect: rect;
			newValue, NewPosition: integer;

		procedure Do_A_Button;  			{Handle a button being pressed}
		begin
			HiliteControl(theControl, 10);{Darken the button}
			RefCon := GetCRefCon(theControl);{get control refcon}

			case RefCon of  				{Select correct button}
				B_Play_Sound:{Play Sound, button}
					begin   	{start for this button}
						CreateSndResource(GetCtlValue(C_StartScrollbar), GetCtlValue(C_EndScrollbar));
						MyErr := SndPlay(nil, MyHandle, false);
						DisposHandle(MyHandle);
						DisposHandle(Handle(MySoundHandle));
						MyHandle := nil;
						MySoundHandle := nil;
					end;    	{end for this button}

				otherwise   		{allow other buttons, trap for debug}
					begin   	{start}
					end;    	{end of otherwise}
			end;    						{end of case}

			HiliteControl(theControl, 0);{Lighten the button}
		end;    							{Handle a button being pressed}


		procedure Do_A_Checkbox;    		{Handle a checkbox being pressed}
			var
				Index: integer;  				{Index used for radios}

			procedure Clear1RadioGroup; 		{Routine to clear radios in group 1}
				var
					Index: integer;  				{Index used for radios}
			begin   							{Start of the clear routine}
				for Index := 1 to 4 do  		{Step thru all radios}
					SetCtlValue(R1Control[Index], 0);{Set this radio to zero}
			end;    							{End of the clear routine}

		begin   							{Handle a checkbox being pressed}
			RefCon := GetCRefCon(theControl);{get control refcon}
			theValue := GetCtlValue(theControl);{Get current value}
			theValue := (theValue + 1) mod 2;{Change value}
			InvalRect(NotePallete);
			case RefCon of  				{Select correct button}
				CB_Timbre, CB_Duration, CB_Amplitude, CB_Frequency:   	{checkbox}
					begin
						SetCtlValue(theControl, theValue);{Set checkbox to new value}
					end;    	{end for this checkbox}

				RB_Timbre:  	{Timbre , radio button}
					begin   	{start for this radio button}
						DrawTool := 4;
						Clear1RadioGroup;{Clear all Radio values in this group}
						SetCtlValue(theControl, 1);{Select this Radio}
						SetCtlValue(C_Timbre, 1);
					end;    	{end for this radio button}

				RB_Duration:{Duration , radio button}
					begin   	{start for this radio button}
						DrawTool := 3;
						Clear1RadioGroup;{Clear all Radio values in this group}
						SetCtlValue(theControl, 1);{Select this Radio}
						SetCtlValue(C_Duration, 1);
					end;    	{end for this radio button}

				RB_Amplitude:{Amplitude , radio button}
					begin   	{start for this radio button}
						DrawTool := 2;
						Clear1RadioGroup;{Clear all Radio values in this group}
						SetCtlValue(theControl, 1);{Select this Radio}
						SetCtlValue(C_Amplitude, 1);
					end;    	{end for this radio button}

				RB_Frequency:{Frequency , radio button}
					begin   	{start for this radio button}
						DrawTool := 1;
						Clear1RadioGroup;{Clear all Radio values in this group}
						SetCtlValue(theControl, 1);{Select this Radio}
						SetCtlValue(C_Frequency, 1);
					end;    	{end for this radio button}

				otherwise   		{allow other checkboxes and radios, trap for debug}
					begin   	{start}
					end;    	{end of otherwise}
			end;    						{end of case}

		end;    							{Handle a checkbox being pressed}


		procedure Do_A_ScrollBar (code: integer);{Handle a ScrollBar being pressed}

			procedure HandleWScrollBar (code, Start, Stop, Increment, LIncrement: integer; theControl: ControlHandle);
				var
					theValue: integer; 		{Value of the scrollbar}
					MaxTick: longint;  		{Timer used for repeat scrolling}
					FirstTime: boolean;    	{Flag to start scrolling}

			begin
				FirstTime := TRUE;   		{Do the scroll the first time also}
				while (StillDown or FirstTime) do{Do the scroll as long as the button is down}
					begin   			{Timer used for repeat scrolling}
						FirstTime := FALSE;  		{Do the scroll the first time only unless auto}
						HiliteControl(theControl, code);	{Darken the arrow}
						theValue := GetCtlValue(theControl);{Get current state}

						if (code = inUpButton) then{See if in the up/left arrow}
							begin
								theValue := theValue - Increment;{Subtract the single decrement}
								if (theValue < Start) then{Check for boundary conditions}
									theValue := Start;{Bump at the start value}
							end;

						if (code = inDownButton) then{See if in the down/right arrow}
							begin
								theValue := theValue + Increment;{Add the single increment}
								if (theValue > Stop) then{Check for boundary conditions}
									theValue := Stop;{Bump at the stop value}
							end;

						if (code = inPageUp) then{See if in the up/left grey area}
							begin
								theValue := theValue - LIncrement;{Subtract the page increment}
								if (theValue < Start) then{Check for boundary conditions}
									theValue := Start;{Bump at the Start value}
							end;

						if (code = inPageDown) then{See if in the down/right grey area}
							begin
								theValue := theValue + LIncrement;{Add the page increment}
								if (theValue > Stop) then{Check for boundary conditions}
									theValue := Stop;{Bump at the Stop value}
							end;

						if (code = inThumb) then{See if in the drag box area}
							begin
								code := TrackControl(theControl, myPt, nil);{Let the OS drag it around}
								theValue := GetCtlValue(theControl);{Get current state}
							end;

						SetCtlValue(theControl, theValue);{Set new state}

						MaxTick := TickCount + 9;{Time delay for auto-scroll}
						repeat 			{Start of delay routine}
						until not (Button) or (TickCount > MaxTick);{Exit when time up or mouse button up}
						HiliteControl(theControl, 0);{Lighten the arrow}
					end;   				{End for StillDown}
			end;    						{End of handle scroll bar}


		begin   							{Handle a ScrollBar being pressed}
			RefCon := GetCRefCon(theControl);{get control refcon}
			TempRect := NotePallete;
			TempRect.left := 6;
			TempRect.right := TempRect.left + 8;
			case RefCon of  				{Select correct scrollbar}
				I_DurationScrollbar:{DurationScrollbar, scroll bar}
					begin   	{start for this scroll bar}
						dirty := true;
						HandleWScrollBar(code, 0, 250, 1, 10, theControl);{code,Min,Max,Inc,PageInc,handle}
						theValue := GetCtlValue(theControl);
						MyDoc^.dur[NoteIndex] := theValue;
						NumToString(theValue, DurText);
						InvalRect(DurRect);
					end;    	{end for this scroll bar}

				I_AmplitudeScrollbar:{AmplitudeScrollbar, scroll bar}
					begin   	{start for this scroll bar}
						dirty := true;
						HandleWScrollBar(code, 0, 255, 1, 10, theControl);{code,Min,Max,Inc,PageInc,handle}
						theValue := GetCtlValue(theControl);
						MyDoc^.amp[NoteIndex] := theValue;
						NumToString(theValue, AmpText);
						InvalRect(AmpRect);
					end;    	{end for this scroll bar}

				I_FrequencyScrollbar:{FrequencyScrollbar, scroll bar}
					begin   	{start for this scroll bar}
						dirty := true;
						HandleWScrollBar(code, 0, 128, 1, 10, theControl);{code,Min,Max,Inc,PageInc,handle}
						theValue := GetCtlValue(theControl);
						MyDoc^.freq[NoteIndex] := theValue;
						if theValue < 128 then
							NumToString(theValue, FreqText)
						else
							FreqText := 'Rest';
						InvalRect(FreqRect);
					end;    	{end for this scroll bar}

				I_TimbreScrollbar:{TimbreScrollbar, scroll bar}
					begin   	{start for this scroll bar}
						dirty := true;
						HandleWScrollBar(code, 0, 254, 1, 10, theControl);{code,Min,Max,Inc,PageInc,handle}
						theValue := GetCtlValue(theControl);
						MyDoc^.timbre[NoteIndex] := theValue;
						NumToString(theValue, TimbreText);
						InvalRect(TimbreRect);
					end;    	{end for this scroll bar}

				I_EndScrollbar:{EndScrollbar, scroll bar}
					begin   	{start for this scroll bar}
						dirty := true;
						HandleWScrollBar(code, GetCtlValue(C_StartScrollbar), 100, 1, 10, theControl);{code,Min,Max,Inc,PageInc,handle}
						theValue := GetCtlValue(theControl);
						MyDoc^.EndValue := theValue;
						NumToString(theValue, EndText);
						TempRect := EndRect;
					end;    	{end for this scroll bar}

				I_StartScrollbar:{StartScrollbar, scroll bar}
					begin   	{start for this scroll bar}
						dirty := true;
						HandleWScrollBar(code, 1, 100, 1, 10, theControl);{code,Min,Max,Inc,PageInc,handle}
						theValue := GetCtlValue(theControl);
						MyDoc^.StartValue := theValue;
						NumToString(theValue, StartText);
						InvalRect(StartRect);
						SetCtlMin(C_EndScrollbar, theValue);
						theValue := GetCtlValue(C_EndScrollbar);
						MyDoc^.EndValue := theValue;
						NumToString(theValue, EndText);
						TempRect := EndRect;
					end;    	{end for this scroll bar}

				I_NoteScrollbar:{NoteScrollbar, scroll bar}
					begin   	{start for this scroll bar}
						HandleWScrollBar(code, 1, 100, 1, 10, theControl);{code,Min,Max,Inc,PageInc,handle}
						theValue := GetCtlValue(theControl);
						NoteIndex := theValue;
						NumToString(theValue, NoteText);
						InvalRect(NoteRect);
						SetCtlValue(C_DurationScrollbar, MyDoc^.dur[NoteIndex]);
						SetCtlValue(C_FrequencyScrollbar, MyDoc^.freq[NoteIndex]);
						SetCtlValue(C_AmplitudeScrollbar, MyDoc^.amp[NoteIndex]);
						SetCtlValue(C_TimbreScrollbar, MyDoc^.timbre[NoteIndex]);
						NumToString(MyDoc^.timbre[NoteIndex], TimbreText);
						NumToString(MyDoc^.dur[NoteIndex], durText);
						NumToString(MyDoc^.amp[NoteIndex], ampText);
						if MyDoc^.freq[NoteIndex] < 128 then
							NumToString(MyDoc^.freq[NoteIndex], FreqText)
						else
							FreqText := 'Rest';
						InvalRect(durRect);
						InvalRect(freqRect);
						InvalRect(ampRect);
						InvalRect(timbreRect);

						TempRect := NotePallete;
						InsetRect(TempRect, 1, 1);
					end;    	{end for this scroll bar}

				otherwise   		{allow other scrollbars (lists), trap for debug}
					begin   	{start}
					end;    	{end of otherwise}
			end;    						{end of case}
			InvalRect(TempRect);
		end;    							{Handle a ScrollBar being pressed}


	begin   							{Start of Window handler}
		if (MyWindow <> nil) then   	{Handle only when the window is valid}
			begin
				code := FindWindow(myEvent.where, whichWindow);{Get where in window and which window}

				if (myEvent.what = MouseDown) and (MyWindow = whichWindow) then{}
					begin   			{}
						myPt := myEvent.where;{Get mouse position}
						GlobalToLocal(myPt);
					end;

				if (MyWindow = whichWindow) and (code = inContent) then{for our window}
					begin

						code := FindControl(myPt, whichWindow, theControl);{Get type of control}

						if (code = inUpButton) or (code = inDownButton) or (code = inThumb) or (code = inPageDown) or (code = inPageUp) then
							Do_A_ScrollBar(code);{Do scrollbars}
						if (code <> 0) then{Check type of control}
							code := TrackControl(theControl, myPt, nil);{Track the control}
						if code = inButton then
							Do_A_Button;{Do buttons}
						if code = inCheckBox then
							Do_A_Checkbox;{Do checkboxes}

						if PtInRect(myPt, NotePallete) then
							repeat
								dirty := true;
								case DrawTool of
									1: 
										UnConvert(myPt, 128, newValue, NewPosition);
									2: 
										UnConvert(myPt, 255, newValue, NewPosition);
									3: 
										UnConvert(myPt, 250, newValue, NewPosition);
									4: 
										UnConvert(myPt, 254, newValue, NewPosition);
								end;
								if (newValue <> -1) and (newPosition <> -1) then
									begin {still in NotePallete?}
										case DrawTool of
											1: 
												begin
													MyDoc^.freq[GetCtlValue(C_NoteScrollbar) + NewPosition] := newValue;
													if NewPosition = 0 then
														begin
															SetCtlValue(C_FrequencyScrollbar, newValue);
															if newValue <> 128 then
																NumToString(newValue, FreqText)
															else
																FreqText := 'Rest';
															InvalRect(FreqRect);
														end;
												end;
											2: 
												begin
													MyDoc^.amp[GetCtlValue(C_NoteScrollbar) + NewPosition] := newValue;
													if NewPosition = 0 then
														begin
															SetCtlValue(C_AmplitudeScrollbar, newValue);
															NumToString(newValue, AmpText);
															InvalRect(AmpRect);
														end;
												end;
											3: 
												begin
													MyDoc^.dur[GetCtlValue(C_NoteScrollbar) + NewPosition] := newValue;
													if NewPosition = 0 then
														begin
															SetCtlValue(C_DurationScrollbar, newValue);
															NumToString(newValue, DurText);
															InvalRect(DurRect);
														end;
												end;
											4: 
												begin
													MyDoc^.timbre[GetCtlValue(C_NoteScrollbar) + NewPosition] := newValue;
													if NewPosition = 0 then
														begin
															SetCtlValue(C_TimbreScrollbar, newValue);
															NumToString(newValue, TimbreText);
															InvalRect(TimbreRect);
														end;
												end;
										end; { of Case}
										SetRect(TempRect, (NewPosition * 10 + 6), 6, (NewPosition * 10 + 5) + 9, 259);
										InvalRect(TempRect);
									end; {end of still in NotePallete}
								BeginUpdate(MyWindow);
								Update_Untitled(MyWindow);
								EndUpdate(MyWindow);
								GetMouse(myPt);
							until not (StillDown);

					end;    			{End for if (MyWindow=whichWindow)}
			end;    					{End for if (MyWindow<>nil)}
	end;    							{End of procedure}

end. {End of unit}