unit Hooks;


interface


	uses
		AppleTalk, Globals, LowLevelATProcs;


	const
		USERTYPE = 'NATH';


	procedure SetUpHooksGlobals;
	procedure SetUpHooksMenus;

	function HookedMenuChoice (menu, item: Integer): Boolean;

	procedure HooksActivateUserWindowProc;
	procedure HooksCloseUserWindowProc;
	procedure HooksDeactivateUserWindowProc;
	procedure HooksUpdateUserWindowProc;
	procedure HooksUserWindowDoContentHit;

	procedure ActivateHooksWindow (theWIndow: WindowPtr);
	procedure CloseHooksWindows;
	procedure DeactivateHooksWindow (theWIndow: WindowPtr);
	procedure DoHooksWindowContentHit;
	function SetUpHooksWindows: Boolean;
	procedure UpdateHooksWindow (theWIndow: WindowPtr);

	procedure HooksAppleTalkCallChecks;
	function HooksAppleTalkGlobalsSetUp: Boolean;
	procedure HooksCloseUpAppleTalk;
	function HooksRegistered: Boolean;


implementation


	procedure SetUpHooksGlobals;
	{This proc allows the hook code to init its globals}
	begin
	end;


	procedure SetUpHooksMenus;
	{This proc allows the hook code to init its menus}
	begin
	end;


	function HookedMenuChoice (menu, item: Integer): Boolean;
	{This proc allows the hook code to override menu choices which the generic code}
	{would normally handle, it returns T if it overrode a menu choice}
	begin
	{Assume we're not handling the menu choice}
		HookedMenuChoice := F;
	end;


	procedure HooksActivateUserWindowProc;
	{This proc is used to override the generic codes activation of the UserWindow}
	begin
	end;


	procedure HooksCloseUserWindowProc;
	{This proc is used to override the generic codes closing of the UserWindow}
	begin
	end;


	procedure HooksDeactivateUserWindowProc;
	{This proc is used to override the generic codes deactivation of the UserWindow}
	begin
	end;


	procedure HooksUpdateUserWindowProc;
	{This proc is used to override the generic codes updating of the UserWindow}
	begin
	end;


	procedure HooksUserWindowDoContentHit;
	{This proc is used to override the generic codes handling of mouse hits}
	{in the UserWindow}
	begin
	end;


	procedure ActivateHooksWindow (theWIndow: WindowPtr);
	{This proc is used to activate any windows the hook code created}
	begin
	end;


	procedure CloseHooksWindows;
	{This proc is used to close any windows the hook code created}
	begin
	end;


	procedure DeactivateHooksWindow (theWIndow: WindowPtr);
	{This proc is used to deactivate any windows the hook code created}
	begin
	end;


	procedure DoHooksWindowContentHit;
	{This proc is used to handle mouse hits in any windows the hook code created}
	begin
	end;


	function SetUpHooksWindows: Boolean;
	{This proc is used to setup any windows the hook code wants to create}
	{and it allows the hook code to set the UserWindowProcsChanged global}
	{it returns T if it succeeds}
	begin
	{Assume error}
		SetUpHooksWindows := F;

	{Set to false to show that we dont change any of the UserWindow procs}
		UserWindowProcsChanged := F;

	{Return T since we succeeded}
		SetUpHooksWindows := T;
	end;


	procedure UpdateHooksWindow (theWIndow: WindowPtr);
	{This proc is used to update any windows the hook code created}
	begin
	end;


	procedure HooksAppleTalkCallChecks;
	{This proc is used to check any ASYNC AppleTalk calls the hook code made}
	begin
	end;


	function HooksAppleTalkGlobalsSetUp: Boolean;
	{This proc does any AppleTalk setups the hook needs to make, it}
	{returns T if it succeeds}
	begin
	{Assume error}
		HooksAppleTalkGlobalsSetUp := F;

	{Return T since we succeeded}
		HooksAppleTalkGlobalsSetUp := T;
	end;


	procedure HooksCloseUpAppleTalk;
	{This proc does any AppleTalk closeups the hook needs to make}
	begin
	end;


	function HooksRegistered: Boolean;
	{This allows the hook code to do any AppleTalk calls its needs to make}
	{after the User had registered.   It returns T if it succeed}
	begin
	{Assume error}
		HooksRegistered := F;

	{Return T since we succeeded}
		HooksRegistered := T;
	end;


end.