/*----------- XDemo.r ----------------*/
/*by Mark Lankton, 1989 for Mac Tutor */
#include "Types.r"

#define AllItems	0x7FFFFFFF	/* 31 flags */
#define MenuItem1	0b00001
#define MenuItem2	0b00010

type 'XDEM' as 'STR ';

/* menus */
resource 'MENU' (128, "Apple", preload) {
	128, textMenuProc,
	AllItems & ~MenuItem2,	/* Disable item #2 */
	enabled, apple,
	{
		/* 1 */
		"About This",
			noicon, nokey, nomark, plain;
			
		/* 2 */
		"-",
			noicon, nokey, nomark, plain
	}
};

resource 'MENU' (129, "File", preload) {
	129, textMenuProc,
	AllEnabled,
	enabled, "File",
	{
		/* 1 */
		"New",
			noicon, "N", nomark, plain;
			
		/* 2 */
		"Close",
			noicon, "W", nomark, plain;
			
		/* 3 */
		"Quit",
			noicon, "Q", nomark, plain
	}
};

resource 'MENU' (130, "Edit", preload) {
	130, textMenuProc,
	AllItems & ~(MenuItem2),	
	enabled, "Edit",
	 {
	 	/* 1 */
		"Undo",
			noicon, "Z", nomark, plain;
		
		/* 2 */
		"-",
			noicon, nokey, nomark, plain;
			
		/* 3 */
		"Cut",
			noicon, "X", nomark, plain;
			
		/* 4 */
		"Copy",
			noicon, "C", nomark, plain;
			
		/* 5 */
		"Paste",
			noicon, "V", nomark, plain
		
	}
};


resource 'MENU' (131,"Externals") {
	131,textMenuProc,
	AllEnabled,
	enabled,"Externals",
	{
	/*No items here until start-up time! */
	}
};


/* Windows */

resource 'WIND' (128) {
	{40, 10, 200, 200},
	zoomDocProc,
	invisible,
	goAway,
	0x0,
	"The Data"
};

/* DLOG */
resource 'DLOG' (128) {
	{40, 40, 240, 380},
	dBoxProc,
	visible,
	goAway,
	0x0,
	128,
	""
};

resource 'DITL' (128) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{67, 56, 85, 289},
		StaticText {
			disabled,
			"External function demo program"
		},
		/* [2] */
		{110, 90, 152, 253},
		StaticText {
			disabled,
			"by Mark Lankton, 1989, for MacTutor."
		}
	}
};


/* SIZE */
resource 'SIZE' (-1) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,			
	multiFinderAware,	
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,	
	24576,
	24576
};


resource 'XDEM' (0) {
	"Demo of external function tricks for MacTutor, 8/89"
};