/* ======================================= *
	file:	BitMapper.r
	date:	11.17.89
* --------------------------------------- *
	Resources for the BitMapper SuperPaint
	plug-in menu command.
* --------------------------------------- *
	Copyright  1989, Michael Ogawa and
	MacTutor  All Rights Reserved.
* ======================================= */

#include "BitMapperRsrc.h"


data 'PiMI' (kOrigBaseID, purgeable)
/*	Plug-in Module Information specifying
version 1 interface. */
/*	m_o 09.13.89 */
{
	$"00 01"
};


resource 'ALRT' (kOrigBaseID + kALRT_Err,
	"errAlrt", purgeable)
/*	Alert template for the error alert.  The
window height and width are based on the
actual items in the dialogs.  The top
coordinate is arbitrary.  The left coordinate
is calculated by: (512 - width) / 2.  The
actual desktop position should be calculated
at runtime depending on the actual desktop
size/configuration. */
/*	m_o 09.30.89 */
{		/*148*/
	{40, 0, 40+92+8, 0+208+8},
	kOrigBaseID + kDITL_Err,
	{	/* array: 4 elements */
		OK, visible, sound1,	/* [1] */
		OK, visible, sound1,	/* [2] */
		OK, visible, sound1,	/* [3] */
		OK, visible, sound1		/* [4] */
	}
};

resource 'DITL' (kOrigBaseID + kDITL_Err,
	"errAlrt", purgeable)
/*	Dialog item list for the error alert.
The param text ^0 in the prompt text should
be filled in with the error code or some
other message at runtime. */
/*	m_o 09.30.89 */
{
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{72, 8, 92, 78}, Button
			{enabled, "Darn!" },
		/* [2] */
		{8, 64, 56, 208}, StaticText
			{disabled,
			"Oops!  Something went "
			"wrong.  Sorry about that.  "
			"(^0)"
		}
	}
};

resource 'actb' (kOrigBaseID + kactb_Err,
	"errAlrt", purgeable)
/*	This is a default color table for the
error alert */
/*	m_o 09.30.89 */
{
	0x0,
	0,
	{}	/* array ColorSpec: 0 elements */
};


data 'TEXT' (kOrigBaseID, "about", purgeable)
/*	Provides information about BitMapper to
the user from within SuperPaints About Box.
	Utilizes the constants kCopyright,
kVersionStr, and kAnnotate. */
/*	m_o 09.30.89 */
{
	"BitMapper takes snapshots of your "
	"active SuperPaint document window and "
	"turns them into 'BTMP' resources "
	"which it places on the clipboard.  "
	"It also places a 'PICT' copy of the "
	"selection on the clipboard so that "
	"you can see what the 'BTMP' looks "
	"like.\n"
	"The 'BTMP' resource type consists "
	"of a BitMap data structure followed "
	"by a bit image.  "
	"The baseAddr field of the saved "
	"resource is set to Nil.  "
	"The bounds field is set to a "
	"rectangle the size of the selection "
	"rectangle with its top left corner "
	"set to (0,0).  "
	"RowBytes is the actual width of the "
	"selection (in bytes), rounded up "
	"to an even width if necessary.  "
	"The actual bit image then follows.\n"
	"For details on using 'BTMP' "
	"resources, see Mike Scanlins article "
	"in MacTutor magazine.\n"
	"Please send comments to: Michael "
	"Ogawa, 619-224-3058, 619-721-7000 "
	"(Palomar Software), or AppleLink "
	"M.O.\n\n"
	"BitMapper by\n"
	"Michael Ogawa\n"
	"Special thanks to\n"
	"Dana Gregory\n"
	"Linda McClennan\n"
	"Mike Scanlin\n\n"
	"Copyright  1989 Michael Ogawa  All "
	"Rights Reserved.\n"
	"May not be redistributed for "
	"commercial purposes.  May be freely "
	"distributed on electronic bulletin "
	"boards provided no additional charges "
	"above the boards standard connect "
	"charges are imposed.  May be freely "
	"distributed by non-profit "
	"organizations on disk provided that "
	"any charges for the distribution disk "
	"does not exceed actual disk, "
	"labelling materials, reproduction, "
	"and shipping charges incurred by the "
	"organization.\n"
	"This software is provided as is, "
	"with no warranties, either express or "
	"implied, being made regarding its "
	"fitness for any particular purpose.\n"
	"v1.00"
};


resource 'vers' (1, purgeable)
/*	Finder get info resource providing
version information about our plug-in menu
command to the user. */
/*	m_o 11.13.89 */
{
	0x01,
	0x00,
	release,
	0x00,
	verUs,
	"1.00",
	"1.00 (US),  1989 Michael Ogawa"
};
