/* ======================================= *
	file:	BitMapperRsrc.h
	date:	11.17.89
* --------------------------------------- *
	Header file for C and Rez for the
	BitMapper SuperPaint plug-in tool.
	Contains symbolic constants, data type
	and resource type definitions that are
	common to both the C and Rez components
	of the project.  Utilizes the Rez
	compiler symbol, REZ, to conditionally
	include/exclude definition lines as
	necessary.
* --------------------------------------- *
	Copyright  1989, Michael Ogawa and
	MacTutor  All Rights Reserved.
* ======================================= */

#ifndef _H_BitMapperRsrc
#define _H_BitMapperRsrc

#ifdef REZ
#	ifndef bold
#		include "Types.r"
#		include "SysTypes.r"
#	endif bold
#endif REZ


/* constants ============================= */

#define kOrigBaseID		16000
/*	All resources of plug-in tools should be
numbered consecutively from a base resource
ID.  This is the ID# we are using as our base
ID. */
/*	m_o 09.13.89 */


#define kType_BitMap	'BTMP'
/*	Resource type of our custom bitmap and
image resource that we create with
BitMapper. */
/*	m_o 09.13.89 */


#define kALRT_Err	0		/* + baseID */
#define kDITL_Err	kALRT_Err	/* + baseID */
#define kactb_Err	kALRT_Err	/* + baseID */
/*	ID offsets for the error alert
resources, based off of the base resource ID.
The resources are Rez compiled with these
resource IDs plus kOrigBaseID.  They are
calculated at runtime based on the value in
the toolID field of the menu command data
record that is passed in to our tool. */
/*	m_o 09.17.89 */


/* data types ============================ */

#ifndef REZ
typedef struct {
	BitMap	map;
	short	image[];		
} TBTMP, *TBTMPPeek, **TBTMPPkHndl;
typedef BitMap	*TBTMPPtr, **TBTMPHndl;
#else
type kType_BitMap {
	unsigned longint = 0; /* map.baseAddr */
	integer;			/* map.rowBytes */
	rect;			/* map.bounds */
	hex string;		/* image */
};
#endif REZ
/*	Data structure for our custom bitmap and
image resource type. */
/*	mps 06.22.89/m_o 06.25.89 */


#endif _H_BitMapperRsrc
