/* ======================================= *
	file:	BitMapper.h
	date:	10.01.89
* --------------------------------------- *
	Main header file for the BitMapper
	SuperPaint plug-in menu command.
* --------------------------------------- *
	Copyright  1989, Michael Ogawa and
	MacTutor  All Rights Reserved.
* ======================================= */

#ifndef _H_BitMapper
#define _H_BitMapper

#ifdef applec
#	include <Types.h>
#	include <Menus.h>
#	include <Dialogs.h>
#endif

#include "BitMapper_goodies.h"
#include "BitMapperRsrc.h"
#include "SPMenu.h"
#include "CenterWindowIntf.h"


/* data types ============================ */

typedef struct {
	MenuDataPtr	pToolInfo;
	long			*pRefCon;
	GrafPtr		drawGptr;
} TBitMapperRec, *TBitMapperPtr;
/*	The BitMapper record is used to pass all
pertinent information for our command in one
data structure.  PToolInfo is a pointer to
the menu data structure that was passed in by
SuperPaint when we were called.  PRefCon is
a pointer to the refCon word passed in, and
that we can modify and use as we desire.
(BitMapper does not use the refCon.)
DrawGptr is the current grafPort set up by
SuperPaint that contains the selection our
command works on. */
/*	m_o 09.17.89 */


/* function prototypes =================== */

#ifdef applec
extern pascal void BitMapper(short selector,
	MenuDataPtr toolInfo, long *refCon,
	short *returnCode);
#endif applec

extern pascal void main(short selector,
	MenuDataPtr toolInfo, long *refCon,
	short *returnCode);


#endif _H_BitMapper
