/* ================================================================================================== *
	file:	BTMP.h
	version:	1.00.00
	date:	11.20.89
	history:	m_o 11.20.89
* ------------------------------------------------------------------------+-----------+--------------- *
	Copyright  1989, Michael Ogawa  All Rights Reserved.
	May not be redistributed for commercial purposes.  May not be
	redistributed if altered in any way, or without accompanying
	documents.  May be freely distributed on electronic bulletin boards
	provided no additional charges above the boards standard connect
	charges are imposed.  May be freely distributed by non-profit
	organizations on disk provided that any charges for the distribution
	disk does not exceed actual disk, labelling materials, reproduction,
	and shipping charges incurred by the organization.
	This software is provided as is, with no warranties, either express
	or implied, being made regarding its fitness for any particular
	purpose.
* ================================================================================================== */

#ifndef _H_BTMP
#define _H_BTMP

#ifdef THINK_C
/*	#include <MacHeaders> */
#elif defined (applec)
#	include <Quickdraw.h>
#endif


/* data types ======================================================================================= */

#ifdef THINK_C
#	ifndef const
#		define const	/* not yet implemented in ThinkC */
#	endif const
#endif THINK_C


#ifndef REZ
typedef struct {
	BitMap	map;
	short	image[];		
} TBTMP, *TBTMPPeek, **TBTMPPkHndl;
typedef BitMap	*TBTMPPtr, **TBTMPHndl;
#else
type kType_BitMap {
	unsigned longint = 0; /* map.baseAddr */
	integer;			/* map.rowBytes */
	rect;			/* map.bounds */
	hex string;		/* image */
};
#endif REZ
/*	Data structure for our custom bitmap and image resource type. */
/*	mps 06.22.89/m_o 06.25.89 */


#ifndef REZ
typedef struct {
	short	szEntry;
	TBTMP	theBTMP;
} TBTMNEntry, *TBTMNEntryPtr;
#endif REZ
/*	An entry in the 'BTM#' resource data type consists of a field
containing the size of the entry in bytes, followed by the 'BTMP' resource
data.
	Note that you may want to change the szEntry field to type Size to
deal with very large bit images. */
/*	mps 06.22.89/m_o 11.17.89 */

#ifndef REZ
typedef struct {
	short		count;
	TBTMNEntry	theBTMNEntries[];
} *TBMPN, *TBTMNPtr, **TBTMNHndl;
#endif REZ
/*	The 'BTM#' resource data type consists of a field indicating the
number of entries in the resource, followed by the entries. */
/*	mps 06.22.89/m_o 11.13.89 */


/* function prototypes ============================================================================== */

#ifndef REZ
extern void PlotPBitMap(const Rect *r, TBTMPPtr pTheBitMap, short mode);
extern char LockBitMap(TBTMPHndl hTheBitMap);
extern void PlotBitMap(const Rect *r, TBTMPHndl hTheBitMap, short mode);
#endif REZ


#endif _H_BTMP
