#include <Types.h>
#include <QuickDraw.h>
#include <Events.h>
#include <StdLib.h>

#include "DisplList.h"

TObjLink::TObjLink(TObjLink *n, TDisplObj *v)
{
	fNext = n; fmyObj = v;
}

TObjList::TObjList(void)
{
	fHeader = nil; fNumObjs = 0;
}

void TObjList::AddObj(TDisplObj* obj)
{
	if (obj != nil)
	{
		TObjLink* temp;
		temp = new TObjLink(fHeader,obj);
		fHeader = temp;
		fNumObjs++;
	}
}

void TObjList::RemoveObj(TDisplObj* obj)
{
	if (obj != nil)
	{
		TObjLink* temp;
		TObjLink* last;
	
		last = nil;
		for (temp = fHeader; temp != nil; temp = temp->GetNext())
		  if (temp->GetmyObj() == obj)
			{
			  if (last == nil) // if first item in list, just set first
				fHeader = temp->GetNext();
			  else last->SetNext(temp->GetNext());
			  delete temp;	// free the TObjLink
			  fNumObjs--;
			  return;
			}
		  else last = temp;
	}
}

TDisplObj::TDisplObj(Rect r)  { fBoundRect = r; }

TRoundRect::TRoundRect(Rect r) : (r) // Calls base class constructor
{	fOvalWidth = 20;
	fOvalHeight = 15;	}

void TRoundRect::Draw(Pattern pat)
{	PenNormal();
	FillRoundRect(&fBoundRect, fOvalWidth, fOvalHeight, pat);
	FrameRoundRect(&fBoundRect, fOvalWidth, fOvalHeight); 	}

void TRoundRect::Erase()
{	EraseRoundRect(&fBoundRect, fOvalWidth, fOvalHeight);	}

TRect::TRect(Rect r) : (r) {}

void TRect::Draw(Pattern pat)
{	PenNormal();
	FillRect(&fBoundRect, pat);
	FrameRect(&fBoundRect); 	}

void TRect::Erase()
{	EraseRect(&fBoundRect);		}

TOval::TOval(Rect r) : (r) {}

void TOval::Draw(Pattern pat)
{	PenNormal();
	FillOval(&fBoundRect, pat);
	FrameOval(&fBoundRect);		}

void TOval::Erase()
{	EraseOval(&fBoundRect);		}
