	program Plot
!!G Toolbox.finc
!!MP Inlines.f

	real*4 x(500),y(500)
	integer*4 ndata,plotType,nil
	parameter (nil=0)
	
	record /WindowPtr/ wPtr	
	common /windows/ wPtr
	common /theData/ x,y,ndata,plotType
	
	record /Rect/ myRect
	string title
	external OutWindowClear,MyIdleProc
	
	call MoveOutWindow (20,260,500,342)
	
	call addmenuitem ('Graph','Read',readData)
	call addmenuitem ('Graph','Display Graph',plotGraph)
	call addmenuitem ('Graph','Erase Graph',clearGraph)
	call addmenuitem ('Graph','Hide Graph',hideGraph)
	call addmenuitem ('Graph','Erase Text',OutWindowClear)
	call addmenuitem ('Graph','(-',dummy)
	call addmenuitem ('Graph','By item #',byItem)
	call addmenuitem ('Graph','By x value',byXval)
	call addmenuitem ('Graph','(-',dummy)
	call addmenuitem ('Graph','Draw a string',DrawAString)
	call addmenuitem ('Graph','Sort data',sortData)
	
	type *	! shows text output window
	
	title = 'Graphics Window'
	call SetRect (%ref(myRect),int2(20),int2(40),int2(500),int2(235))

	wPtr.wp = NewWindow (nil,myRect,title,int2(.true.),
	1							noGrowDocProc,nil,int2(.false.),int4(0))
	
	call DoMenu ('Graph','By item #')
	
c	call SetIdleProc(MyIdleProc)
	
	end
	
	subroutine MyIdleProc
	call sysbeep(1)
	return
	end
	
	subroutine dummy
	return
	end
	
	
	subroutine readData
	
	real*4 x(500),y(500)
	integer*4 ndata,plotType,iores
	common /theData/ x,y,ndata,plotType
	
	open (10,file=*,status='OLD',iostat=iores)
	
	if (iores.eq.0) then
		ndata = 0
		do while (iores.eq.0)
			ndata = ndata + 1
			read (10,*,iostat=iores) x(ndata),y(ndata)
		end do
		
		if (iores .lt. 0) then
			type *,ndata,' points read.'
		else
			type *,'Read error - nothing read.'
		end if
		close (unit=10)
		
	end if
	
	return
	end
	
	
	subroutine plotGraph
	record /WindowPtr/ wPtr	
	common /windows/ wPtr
	
	real*4 x(500),y(500)
	real*4 maxx,minx,maxy,miny,deltax,deltay
	integer*2 xplot,yplot,winh,winw
	integer*4 ndata,plotType
	common /theData/ x,y,ndata,plotType
	
	call ShowWindow(wPtr)
	call SelectWindow(wPtr)
	maxx = x(1)
	minx=maxx
	maxy=y(1)
	miny=maxy
	
	do i=2,ndata
		maxx = max(x(i),maxx)
		minx = min(x(i),minx)
		maxy = max(y(i),maxy)
		miny = min(y(i),miny)
	end do
	
c	type *,minx,maxx,miny,maxy
	
	deltax = maxx-minx
	deltay = maxy-miny
	winh = wPtr.wp^.portRect.bottom - wPtr.wp^.portRect.top - 4
	winw = wPtr.wp^.portRect.right  - wPtr.wp^.portRect.left - 4
	
c	type *,deltax,deltay,winh,winw
	
	call SetPort(wPtr)
	call PenNormal
	call MoveTo(int2(0),int2(0))
	
	do i=1,ndata
		yplot = winh*(1.-(y(i)-miny)/deltay) + 2
		select case (plotType)
			case (0)
				xplot = winw*(i/(ndata*1.)) + 2
			case (1)
				xplot = winw*(x(i)-minx)/deltax + 2
			case default
		end select
		call lineto(xplot,yplot)
	end do
	
	return
	end
	
	
	subroutine clearGraph
	record /WindowPtr/ wPtr	
	common /windows/ wPtr
	
	call SetPort(wPtr)
	call EraseRect(wPtr.wp^.portRect)
	return
	end
	
	
	subroutine hideGraph
	record /WindowPtr/ wPtr	
	common /windows/ wPtr
	
	call HideWindow(wPtr)
	return
	end
	
	
	subroutine byItem
	real*4 x(500),y(500)
	integer*4 ndata,plotType
	common /theData/ x,y,ndata,plotType
	record /MenuHandle/ GraphMenu

	integer*2 menuGraph,itemNum,xVal
	parameter(menuGraph=5,itemNum=7,xVal=8)
	
	plotType = 0
	GraphMenu.MenuH = GetMHandle(menuGraph)
	call CheckItem(GraphMenu.MenuH,itemNum,int2(.true.))
	call CheckItem(GraphMenu.MenuH,xVal,int2(.false.))

	return
	end
	
	
	subroutine byXval
	real*4 x(500),y(500)
	integer*4 ndata,plotType
	common /theData/ x,y,ndata,plotType
	record /MenuHandle/ GraphMenu

	integer*2 menuGraph,itemNum,xVal
	parameter(menuGraph=5,itemNum=7,xVal=8)
	
	plotType = 1
	GraphMenu.MenuH = GetMHandle(menuGraph)
	call CheckItem(GraphMenu.MenuH,itemNum,int2(.false.))
	call CheckItem(GraphMenu.MenuH,xVal,int2(.true.))

	return
	end
	
	
	subroutine drawAString
	string st
	record /WindowPtr/ wPtr	
	common /windows/ wPtr
	pexternal DrawMyString
	
	st = 'This String comes from Fortran.'
	call DrawMyString(wPtr,st)
	return
	end
	

	subroutine sortData
	
	call AlertBox ('Not implemented yet.')
	return
	end
	