UNIT PictToScrp;

    (***********************************************************      

  This XCMD demodnstrates a method to plot and calculate in Pascal
  (perhaps with floating point processor enabled) and then
  copy and paste the picture in the card
  
  compile and link as follows (assuming Fourier is an existing stack):
  
  TMLPascal Fourier.p
or:  ( for really fast on a mac II)
  TMLPascal Fourier.p  -MC68020 -MC68881 -d Elems881=true

  Link -w -t 'STAK' -c 'WILD' 
  -m FOURIER -rt XCMD=1282 -sg Fourier 
   Fourier.p.o 
   "{Libraries}"Runtime.o 
   "{Libraries}"Interface.o 
   "{TMLPLibraries}"TMLPasLib.o 
   "{Libraries}"HyperXLib.o 
   -o "Fourier"


 Hypercard call :
  set the lockscreen to true
  -- prevents flicker
  Fourier  330,14,480,319, 20,10,5,3,4,1
  -- 330,14,480 is the area to draw into
  -- 20,10,5,3,1 are the fourier factors times 10
  set the lockscreen to false
   
 ******************************************************************)

INTERFACE

  USES MemTypes, QuickDraw, OSIntf, ToolIntf, PackIntf, PasLibIntf, HyperXCMD;

  PROCEDURE Fourier(ParamPtr: XCMDPtr);

IMPLEMENTATION

  PROCEDURE PictScrap(ParamPtr: XCMDPtr); FORWARD;

  PROCEDURE Fourier(ParamPtr: XCMDPtr);

    BEGIN
      PictScrap(ParamPtr);
    END;

  PROCEDURE PictScrap(ParamPtr: XCMDPtr);

    VAR
      thePoint     : Point;
      hPicture     : PicHandle;
      rg           : rect;
      Piclength    : LONGINT;
      xoffset, yoffset: integer;
      str          : str255;
      xLeft, bot, top, xRight: LONGINT;
      one, two, three, four, five: LONGINT;
      x, y         : extended;
      z1, z2, z3, z4, z5: extended;

    PROCEDURE MyDrawing; { all your drawing stuff goes here }

      VAR
        i            : integer;
        maxim, offset: extended;

      FUNCTION Sinus(x: extended): extended;

        BEGIN
          Sinus := sin(x) * z1 + sin(2 * x) * z2 + sin(3 * x) * z3 + sin(4 * x)
                   * z4 + sin(5 * x) * z5 { the more, the better }
        END;

      BEGIN
        eraserect(rg);
        Framerect(rg); { optional }
        offset := top + (bot - top) / 2.0;
        z1 := one / 10.0;
        z2 := two / 10.0;
        z3 := three / 10.0;
        z4 := four / 10.0;
        z5 := five / 10.0;
        x := 0.02 {1 / 50} ;
        maxim := Sinus(x);
        FOR i := 2 TO 314 DO
          BEGIN
          IF i MOD 10 = 0 THEN
            SendCardMessage(ParamPtr, 'set cursor to busy');
          x := i / 50;
          y := Sinus(x);
          IF maxim < y THEN
            maxim := y;
          END;

        x := 1 / 50;
        y := Sinus(x);
        maxim := 100 / maxim;
        SendCardMessage(ParamPtr, 'set cursor to busy');
        moveto(xLeft + 1, round(y * maxim + offset));
        FOR i := 2 TO 314 DO
          BEGIN { for two pi }
          x := i / 50;
          y := Sinus(x);
          lineto(i + xLeft + 1, round(y * maxim + offset))
          END;
        SendCardMessage(ParamPtr, 'set cursor to busy');
        penpat(ltgray);
        moveto(xLeft + 1, round(offset));
        lineto(xRight - 2, round(offset));
        pennormal
      END;

    FUNCTION GetParameter(n: integer): LONGINT;

      VAR
        tmp          : LONGINT;

      BEGIN
        ZeroToPas(ParamPtr, ParamPtr^.params[n]^, str);
        stringToNum(str, tmp);
        GetParameter := tmp
      END;

    BEGIN
      IF ParamPtr^.paramCount <> 9 THEN
        SendCardMessage(ParamPtr, 'put "wrong number of parameters" into msg')
		  { I think a more convenient way of error report than by ParamPtr^.ReturnValue }
      ELSE
        BEGIN
        { get the drawing rectangle coordinates from hypercard }
        xLeft := GetParameter(1);
        top := GetParameter(2);
        xRight := GetParameter(3);
        bot := GetParameter(4);

        { In this example : get the Fourier cofficients from hypercard }
        one := GetParameter(5);
        two := GetParameter(6);
        three := GetParameter(7);
        four := GetParameter(8);
        five := GetParameter(9);
        setrect(rg, xLeft, top, xRight, bot);
        xoffset := xLeft + 5;
        yoffset := top + 5;
        cliprect(rg);
        hPicture := OpenPicture(rg);
        Showpen;
        MyDrawing; { here all your drawing }
        closepicture;
        Piclength := GethandleSize(handle(hPicture));
        IF ZeroScrap + putscrap(Piclength, 'PICT', ptr(hPicture^)) = NoErr THEN
          ParamPtr^.ReturnValue := PasToZero(ParamPtr, '')
        ELSE
          ParamPtr^.ReturnValue := PasToZero(ParamPtr, 'something wrong');
        SendCardMessage(ParamPtr, 'choose select tool');
        SendCardMessage(ParamPtr, 'domenu "Paste Picture"');
        SendCardMessage(ParamPtr, 'choose browse tool');
        END
    END;

END.
