/************************************/
/* File: Control XFCN.c				*/
/* 									*/
/* Parameters:						*/
/* params[0] == control type		*/
/* params[1] == control Rect		*/
/* params[2] == control title		*/
/* params[3] == control setting		*/
/* params[4] == control min			*/
/* params[5] == control max			*/	
/*									*/
/* --------------------------------	*/
/*  1989 Donald Koscheka			*/
/* All Rights Reserved				*/
/************************************/

#define		UsingHypercard

#include	<MacTypes.h>
#include	<OSUtil.h>
#include	<ControlMgr.h>
#include 	<HyperXCmd.h>
#include	<HyperUtils.h>
#include	"Control XFCN.h"

#define		ScrollSize			15
#define		CONTROL_TYPES		6000

#include	"miniParser.c"

pascal void main( paramPtr )
	XCmdBlockPtr	paramPtr;
{
	short			procID			= pushButProc;
	WindowPtr		theWindow		= FrontWindow();
	Rect			boundsRect;
	short			min				= 0;
	short			max				= 1;
	short			value			= 0;
	char			title[256];
	ControlHandle	theControl		= NIL;
	
	if( paramPtr->params[0] )
		procID = (short)matchToken( paramPtr->params[0], CONTROL_TYPES );
		
	parseRect( paramPtr->params[1], &boundsRect );
	
	paramtoPString( paramPtr, 2, title );
	
	value = (short)paramtoNum( paramPtr, 3 );
	min = (short)paramtoNum( paramPtr, 4 );
	max = (short)paramtoNum( paramPtr, 5 );
	if( !max )
		max = 1;
	
	theControl = NewControl( theWindow, &boundsRect,
							 title, TRUE, value,
							 min, max, procID, NIL );


	if( validHandle( theControl ) ){	/*** install the event patch ***/
		wdGlobalsHand	windH;
		Handle			event_handler;			
		Handle			sysPlace;					
		void			*oldTrap;
		long			hSiz;

		SetCtlValue( theControl, value );
		
		if( !(windH = (wdGlobalsHand)GetSystemResource(CONTROL_INFO, CONTROL_PATCH))){
			windH = (wdGlobalsHand)NewSysHandle( (long)sizeof( wdGlobals ));
			if( validHandle( (Handle)windH ) ){
			
				/*** 11.26.89 							***/
				AddSystemResource((Handle)windH, CONTROL_INFO, CONTROL_PATCH,"\p control record" );
				event_handler = GetResource( 'EXEC', CONTROL_PATCH );
		
				if( validHandle( event_handler  ) ){	
					/*** copy our handler into the system heap	***/
					hSiz = GetHandleSize( event_handler );
					
					sysPlace = NewHandle( hSiz );		/*** would like this in system heap	***/
					
					if( validHandle( sysPlace ) ){
						MoveHHi( sysPlace );
						HLock( sysPlace );				/*** our code can't move			***/
						HNoPurge( sysPlace );			/*** must stay put in the heap		***/
					
						BlockMove( *event_handler, *sysPlace, hSiz );
		
						oldTrap = (void *)NGetTrapAddress( EVENT_TRAP, ToolTrap);
		
						NSetTrapAddress( *sysPlace, EVENT_TRAP, ToolTrap );
						
						/*** need to save off oldTrap where 	***/
						/*** everyone can find it				***/
						(*windH)->evtProc	= sysPlace;
						(*windH)->oldTrap	= oldTrap;
						(*windH)->userData	= NIL;		/*** initialize this for the user	***/
					}
				}/*** if validHandle( event_handler ) ***/
			}
		}
	}
	
	paramPtr->returnValue = NumToParam( paramPtr, (long)theControl );
}

