/*.h2 Aesthete */
/*.fo 1989 David Dunham */
/*
Change an ICN# resource (so its aesthetic when shrunken)
*/

#include "aesthete.h"

void aesthetize(handle,sicn, creators) Handle handle, sicn; SIGNATURE **creators; {
	word			sicnNum = -1;
	word			id;
	OSType			type;
	Str255			name;
	FCBPBRec		fcb;
	HParamBlockRec	pb;
	OSErr			error;
	register word	i;

	GetResInfo(handle,&id,&type,&name);
	if (type == 'ICN#') {
		/* Be sure ICN# is owned by this application (or may be System) */
		if (HomeResFile(handle) != CurApRefNum && id != 3) return;
		
		/* Get applications name and directory */
		fcb.ioNamePtr = name;
		fcb.ioRefNum = CurApRefNum;
		fcb.ioFCBIndx = 0;		/* Look up by ioRefNum */
		error = PBGetFCBInfo(&fcb,FALSE);
		
		/* Get applications signature */
		pb.fileParam.ioNamePtr = fcb.ioNamePtr;
		pb.fileParam.ioVRefNum = fcb.ioFCBVRefNum;
		pb.fileParam.ioDirID = fcb.ioFCBParID;
		pb.fileParam.ioFVersNum = 0;
		pb.fileParam.ioFDirIndex = 0;
		error = PBHGetFInfo(&pb,FALSE);
		
		/* Scan our creator list */
		if (error == noErr) {
			for (i = 0; i < (GetHandleSize(creators) / 6); i++) {
				if (pb.fileParam.ioFlFndrInfo.fdCreator == (*creators)[i].creator) {
					if (id == (*creators)[i].rsrcID) sicnNum = i;
					break;
				}
			}
		}
		if (sicnNum == -1) return;
		/* Replace the original ICN# */
		BlockMove(*sicn + (sicnNum << 7),*handle,128L);
	}
}

/*
Get and double the size of the SICNs
*/
Handle double_SICN() {
	register Handle	sicn, bigSicn;
	register word	sicnNum;
	Size			size, bigSize;
	BitMap			sicnBits, icnBits;
	GrafPtr			savePort;
	GrafPort		port;

	sicn = GetResource('SICN',0);
	/* Get enough space */
	size = GetHandleSize(sicn);
	bigSize = size * 4;
asm {
	move.l	bigSize,D0
	_NewHandle SYS			; put it in system heap
	move.l	A0,bigSicn
}
	GetPort(&savePort);
	OpenPort(&port);		/* Give a valid QuickDraw environment */
	SetPort(&port);
	HLock(sicn);
	HLock(bigSicn);
	for (sicnNum = (size >> 5) - 1; sicnNum >= 0; sicnNum--) {
		/* Set up the bit map */
		sicnBits.rowBytes = 2;
		SetRect(&sicnBits.bounds,0,0,16,16);
		sicnBits.baseAddr = *sicn + (sicnNum << 5);
		icnBits.rowBytes = 4;
		SetRect(&icnBits.bounds,0,0,32,32);
		icnBits.baseAddr = *bigSicn + (sicnNum << 7);
		CopyBits(&sicnBits,&icnBits,&sicnBits.bounds,&icnBits.bounds,srcCopy,NIL);
	}
	HUnlock(sicn);
	HUnlock(bigSicn);
	ClosePort(&port);
	SetPort(savePort);
	return(bigSicn);
}
