%token	NUM

%%

prob	:	expr '\n'
			{
			printf("\t= %d\n", $1);
			return(0);
			}
		
		;

expr	:	expr '+' term
			{
			$$ = $1 + $3;
			}
		
		|	expr '-' term
			{
			$$ = $1 - $3;
			}
		
		|	term
			{
			$$ = $1;
			}
		
		;
		
term	:	term '*' NUM
			{
			$$ = $1 * $3;
			}
		
		|	term '/' NUM
			{
			$$ = $1 / $3;
			}
		
		|	'(' expr ')'
			{
			$$ = $2;
			}
		
		|	NUM
			{
			$$ = $1;
			}
		
		;

%%

/****************************************************************/

#include "stdio.h"
#include "ctype.h"
#include "string.h"
	
/****************************************************************/

char				*input;
char				*token;
	
/****************************************************************/

#define yyerror(x) {printf("\t%s [%s]\n", x, token); return(0);}

yyparse();
int yylex();
	
/****************************************************************/

void main(int argc, char *argv[])
	{
	
	char				thestring[256];
	
	if (argc < 1)
		printf("\tMajor serious real bad impossible error!\n");
	else if (argc > 2)
		printf("\tHey!  One at a time!\n");
	else if (argc == 2)
		{
		input = argv[1];
		yyparse();
		}
	else
		{
		printf("? ");
		while (strlen(gets(thestring)) > 2)
			{
			input = &thestring[2];
			yyparse();
			printf("? ");
			}
		}
	
	}
	
/****************************************************************/
	
int yylex()
	{
	
	token = strtok(input, " ");
	input = 0;
	
	if (token == 0)
		return('\n');
	else if (sscanf(token, "%d", &yylval) == 1)
		return(NUM);
	else
		return(token[0]);
	
	}
	
/****************************************************************/

