%token	ILLEGAL
%token	NUM
%left		'+' '-'
%left		'*' '/'
%left		MINUS

%%

prob	:	expr '\n'
			{
			printf("\t= %d\n", $1);
			return(0);
			}
		
		;

expr	:	expr '+' expr
			{
			$$ = $1 + $3;
			}
		
		|	expr '-' expr
			{
			$$ = $1 - $3;
			}
		
		|	expr '*' expr
			{
			$$ = $1 * $3;
			}
		
		|	expr '/' expr
			{
			if ($3 != 0)
				$$ = $1 / $3;
			else
				{
				printf("Attempt to divide by zero!\n");
				return(0);
				}
			}
		
		|	'-' expr %prec MINUS
			{
			$$ = - $2;
			}
		
		|	'(' expr ')'
			{
			$$ = $2;
			}
		
		|	NUM
			{
			$$ = $1;
			}
		
		;

%%

/****************************************************************/

#include "stdio.h"
#include "ctype.h"
#include "string.h"
	
/****************************************************************/

char				*input;
char				*token;
	
/****************************************************************/

#define yyerror(x) {errordisplay(tmpstate, pcyytoken); return(0);}

yyparse();
int yylex();
void errordisplay(int state, int tokentype);
	
/****************************************************************/

void main(int argc, char *argv[])
	{
	
	char				thestring[256];
	
	if (argc < 1)
		printf("\tMajor serious real bad impossible error!\n");
	else if (argc > 2)
		printf("\tHey!  One at a time!\n");
	else if (argc == 2)
		{
		input = argv[1];
		yyparse();
		}
	else
		{
		printf("? ");
		while (strlen(gets(thestring)) > 2)
			{
			input = &thestring[2];
			yyparse();
			printf("? ");
			}
		}
	
	}
	
/****************************************************************/
	
int yylex()
	{
	
	token = strtok(input, " ");
	input = 0;
	
	if (token == 0)
		return('\n');
	else if (sscanf(token, "%x", &yylval) == 1)
		return(NUM);
	else switch(token[0])
		{
		case '\n':
		case '(':
		case ')':
		case '+':
		case '-':
			return(token[0]);
		default:
			return(ILLEGAL);
		}
	
	}
	
/****************************************************************/
	
void errordisplay(int state, int tokentype)
	{
	
	if (tokentype == ILLEGAL)
		printf("\tIllegal character!\n");
	else switch (state)
		{
		
		case 0:
		case 3:
		case 4:
		case 7:
		case 8:
		case 9:
		case 10:
			printf("\tExpecting a number, - or (!\n");
			break;
		
		case 2:
			printf("\tExpecting an operator or end of input!\n");
			break;
		
		case 12:
			printf("\tExpecting an operator or )!\n");
			break;
		
		case 13:
		case 14:
			printf("\tExpecting a * or /!\n");
			break;
		
		default:
			printf("\tImpossible error!  State = %d, token = %d\n",
							state, tokentype);
			break;
		
		}
	
	}
	
/****************************************************************/

