UNIT PlaySoundUnit;
{   Called from QuickBASIC as:               }
{     CALL PlaySound (SndResNum%, ratio%)    }
{   in THINK Pascal by Rob Spencer   1/6/90  }

INTERFACE
	USES
		BasicLib;
	PROCEDURE Main;

IMPLEMENTATION

	PROCEDURE PlaySnd (SndResNum, Ratio: Integer);
      {   Thanks to Allan Wootton, The Complete MacTutor II, 230-235  }
      {         and Todd Carper, The Definitive MacTutor IV, 356-363  }
		TYPE
			FFSynthHandle = ^FFSynthPtr;
		VAR
			MySndHandle: FFSynthHandle;
			MyPtr: Ptr;
			MyFFPtr: FFSynthPtr;
			MyRatio: integer;

	BEGIN
		IF (Ratio > 0) AND (Ratio < 5) THEN       	{ ratio must be 1..4 }
			MyRatio := Ratio
		ELSE
			MyRatio := 2;   { an arbitrary default }

		MySndHandle := FFSynthHandle(GetResource('snd ', SndResNum));
		IF MySndHandle <> NIL THEN
			BEGIN
				Hlock(Handle(MySndHandle));
				MyPtr := Ptr(MySndHandle^);
				MyFFPtr := FFSynthPtr(MyPtr);
				MyFFPtr^.mode := FFMode;
				MyFFPtr^.count := FixRatio(1, MyRatio);
				MyFFPtr^.wavebytes[0] := 0;
				StartSound(MyPtr, GetHandleSize(Handle(MySndHandle)) - 6, pointer(-1));
				StopSound;
				HUnlock(Handle(MySndHandle));
				DisposPtr(MyPtr);
			END;
	END;  { of PlaySnd }

 {------------------ main -------------------}
	PROCEDURE main;
		VAR
			tempflag, argtype: INT16;
			valptr: LIBARGPTR;
			SndResNum, ratio: integer;
	BEGIN
		argtype := GetNextLibArg(valptr, tempflag);
		SndResNum := IntegerArg;                       	{ get argument 1 }
		argtype := GetNextLibArg(valptr, tempflag);
		ratio := IntegerArg;                            { get argument 2 }
		PlaySnd(SndResNum, ratio);
	END;
END.