/*******************************
File: HandleTheMenus
********************************/
/**********************
Include files
***********************/
#include "String.h"
#include "MyWindow.h"

/**********************
Constants
***********************/
#define      TRUE   1
#define      FALSE  0
#define      NIL    0

/**** Menus *******/
#define AppleMenuID 1001
	#define Item_About_PrintWindow  1
	
#define FileMenuID 1002
	#define Item_Test_Dialog	1
	#define Item_Page_Setup	2
	#define Item_Print  3
	#define Item_Quit  5

#define EditMenuID 1003

/**********************
Globals
***********************/
MenuHandle   AppleMenu;

/**********************
InitMyMenus() initializes my menus
***********************/
void InitMyMenus()
{ /* InitMyMenus() */
MenuHandle   tempMenu;
 
ClearMenuBar();
 
/* Apple menu */
tempMenu = GetMenu(AppleMenuID);
InsertMenu (tempMenu,0);
AddResMenu(tempMenu,'DRVR');
AppleMenu = tempMenu;
 
/* File menu */
tempMenu = GetMenu(FileMenuID);
InsertMenu (tempMenu,0);
 
/* Edit menu */
tempMenu = GetMenu(EditMenuID);
InsertMenu (tempMenu,0);
 
DrawMenuBar();
} /* InitMyMenus() */

/**********************
HandleMenu() Handles menu selections
***********************/
void HandleMenu(doneFlag,theMenu,theItem,theInput)
char     *doneFlag;
short   theMenu,theItem;
TEHandle   *theInput;
{ /* HandleMenu() */
GrafPtr   SavePort; 
Str255    DAName; 
short     DNA; 
char      BoolHolder; 

switch (theMenu) {
	case AppleMenuID: /* Apple Menu */
		switch (theItem) {
			case Item_About_PrintWindow:
				D_About(); /* Do "About" box */
				break;
			default:
				GetPort(&SavePort); /* Handle DA */
				GetItem(AppleMenu, theItem, &DAName);
				DNA = OpenDeskAcc(DAName);
				SetPort(SavePort);
				break;
			}
		break;

	case FileMenuID: /* File Menu */
		switch (theItem) {
			case Item_Test_Dialog:
				D_TestDialog(); /* Do "Test" Dialog */
				break;
			case Item_Page_Setup:
				doPageSetUp(); /* Do Page Setup */
				break;
			case Item_Print:
				PrintWindow(FrontWindow()); /* Print Window */
				break;
			case Item_Quit:
				*doneFlag = TRUE; /* flag for quitting */
				break;
			default:
				break;
			}
		break;

	case EditMenuID: /* Edit Menu */
		BoolHolder = SystemEdit (theItem - 1); /* Send to DA */
		break;

	default:
		break;
	}

HiliteMenu(0);
} /* HandleMenu() */