{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]}
{ Copyright  1989 Fred J. Condo Jr.
    All rights reserved. }

UNIT USavedMe;
    {[f-]}
{ This unit defines the object type
TAutoSaveDocument, a MacApp abstract type from
which you should descend your application's
actual document object class(es).

 When a TAutoSaveDocument is in the command
chain, MacApp calls its DoIdle method, which
determines whether auto-saving is on, and, if
so, whether the user-requested interval since the
last auto-save has elapsed. If that is so, the
document is saved by sending itself a
DoMenuCommand(cSave) message.

 When a TAutoSaveDocument is not in the command
chain, DoIdle is not called. A future version of
this unit may implement auto-saving in the
background. That would install the document as a
cohandler, which would remain installed until
such time as it saved itself, and then de-
install itself as a cohandler. Of course, if
fChangeCount =0, or if auto-saving is off, then
it would not install itself as a cohandler in
the first place, since auto-saving would never be
called for. A de-installed auto-saver would re-
install itself when brought to the front.

 The user interface to this unit is by means of a
modeless dialog.

 If you are already working on your MacApp
application, you need simply change the ancestor
of your document classes from (TDocument) to
(TAutoSaveDocument).

 Be sure to call InitUTEView, InitUDialog, and
InitUSavedMe in your main program.

 Call IAutoSaveDocument in IYourDocument.

 If your document has a DoIdle method, be sure to
call INHERITED DoIdle. Also, to keep your idle
frequency from getting clobbered, set
fRespectsIdleTime to TRUE immediately after
calling IAutoSaveDocument. If you don't care about
your idle frequency, you can accept the default
(FALSE).

 In the USES clause of your main program, insert
"UTEView, UDialog, USavedMe," and make the same
insertion in the USES clause of UYourProgram.p.

 The name of this unit is a pun. Sorry. I
couldn't help it. }
{[f+]}

    INTERFACE

        USES UMacApp, UTEView, UDialog, SANE, Script, ToolUtils;

        CONST
            cToggleAutoSave     = 5000;                 { Change these here and in USavedMe.r }
            cSetAutoSave        = 5001;                 { if they conflict with your application. }
            kAutoSaveDialogID   = 5000;
            kMinutesID          = 18950;                { Resource ID of STR# containing singular
                                                         and plural of 'minute'. }

        TYPE
            TAutoSaveDocument   = OBJECT (TDocument)
                fSaving:            Boolean;            { Whether autosaving is on. }
                fHasEverBeenSet:    Boolean;            { Whether the dialog has ever been summoned.
                                                         }
                fRespectIdleTime:   Boolean;            { Default FALSE. If TRUE, TAutoSaveDocument
                                                         won't stomp on your idle frequency. This
                                                         is useful if your document is a cohandler
                                                         or otherwise needs idle processing. }
                fLastSave:          Longint;            { Time that doc was last autosaved. }
                fDesiredInterval:   Longint;            { Time in ticks set by user. }
                fAutoSaveWindow:    TWindow;            { AutoSave dialog window. }

                                { Init & Free }

                PROCEDURE TAutoSaveDocument.IAutoSaveDocument(itsFileType, itsCreator: OSType;
                                                              usesDataFork, usesRsrcFork: Boolean;
                                                              keepsDataOpen,
                                                              keepsRsrcOpen: Boolean);

                PROCEDURE TAutoSaveDocument.Free; OVERRIDE;

                { Meat & Potatoes }
                FUNCTION TAutoSaveDocument.DoIdle(phase: IdlePhase): Boolean; OVERRIDE;

                PROCEDURE TAutoSaveDocument.DoSetupMenus; OVERRIDE;

                FUNCTION TAutoSaveDocument.DoMenuCommand(aCmdNumber: CmdNumber): TCommand; OVERRIDE;

                PROCEDURE TAutoSaveDocument.PoseAutoSaveDialog;

                { Debugging }
                PROCEDURE TAutoSaveDocument.Fields(PROCEDURE
                                                   DoToField(fieldName: Str255; fieldAddr: Ptr;
                                                             fieldType: Integer)); OVERRIDE;
                END;

            TAutoSaveDialogView = OBJECT (TDialogView)
                fAutoSaveDocument:  TAutoSaveDocument;  { The autosaver this dialog will modify. }

                                { Init & Free }

                PROCEDURE TAutoSaveDialogView.Free; OVERRIDE;
                PROCEDURE TAutoSaveDialogView.Close; OVERRIDE;

                { A nice fish dinner }
                PROCEDURE TAutoSaveDialogView.DismissDialog(dismisser: IDType;
                                                            flashDismisser: Boolean); OVERRIDE;

                PROCEDURE TAutoSaveDialogView.UpdateDocumentName;

                PROCEDURE TAutoSaveDialogView.Fields(PROCEDURE
                                                     DoToField(fieldName: Str255; fieldAddr: Ptr;
                                                               fieldType: Integer)); OVERRIDE;
                END;

            { GLOBAL PROCEDURE }

        PROCEDURE InitUSavedMe;

    IMPLEMENTATION

        {$I USavedMe.inc1.p}

END.
