/***********************************************
 *
 *	FCodeDispatchLib.c
 *
 *	Library code and dispatch table for code resource library.
 *	Written by David Burggraaf, 1990.
 *
 ***********************************************/
 
#include <math.h>

#define NOCODELIBDEF
#include "CodeLib.h"

typedef void (*Function)(void);

long returnAddr, oldA4, returnStruct;
int funcIndex;
void dispatchErr(void);
Function funcTable[FROUTINES+1];
	
void main(/*CodeLib routine*/void)
	{
	asm	{
		move.l a4, a1;		/*	setup a4	*/
		move.l a0, a4;
		move.l a1, oldA4;
		};
	funcTable[CLdispatchErr]=dispatchErr;
	funcTable[CLsqrt]=(Function)sqrt;
	asm	{
		move.l (a7)+, returnAddr;		/*	save return address	*/
		move.l (a7)+, returnStruct;	/*	save return StructPtr	*/
		move.w (a7)+, a1;				/*	remove index	*/
		move.l returnStruct, -(a7);	/*	put return StructPtr	*/
		lea funcTable, a0;				/*	do jump to indexed subroutine	*/
		jsr ([0,a0,a1.w*4],0);
		move.l (a7)+, returnStruct;	/*	get return structPtr	*/
		move.w a1, -(a7);				/*	restore stack and return	*/
		move.l	returnStruct, -(a7);
		move.l returnAddr, -(a7);
		move.l oldA4, a4;				/*	restore a4	*/
		}
#ifdef MULTISEG
	UnloadA4Seg(0L);
#endif
	}

void dispatchErr(void)
	{
	SysBeep(5);
	}

