
;  MacFortran interface for hypercard XFCNs.
;  It calls fortran character functions.
;  Calling syntax:  "Put Letsgo(arg1,arg2,arg3[arg4,...,arg16<optional>])
;		       into ..." 
	
	;Arg1 = runtime library name:
		;1 = f77.rl
		;2 = hdw.rl
		;3 = m81.rl
	   ;if arg is positive, console window is called up
	   ;if arg is negative, console window is suppressed
	;Arg2 = Size of result which the fortran character function will
	        ;return. Size has to be < 32k to fit into a hypercard container.
	;Arg3 = Name of Fortran character function to be called.

	RESOURCE	'XFCN'	1010	'Letsgo'

;-----------------Includes---------------
INCLUDE		Traps.D

;--------------Equates--------------------
;registers


;booleans
badsubname	EQU	70

;stack frame
numericSizeResult	EQU	-2		;numeric form of sizeResult
errorFlags	EQU	numericSizeResult-4	;storage for a handle holding the function result on error
FortranHeapPtr	EQU	errorFlags-4
toolbx		EQU	FortranHeapPtr-4
stackframe	EQU	toolbx

;XCmdBlock
XCmdBlock	EQU	8
paramCount	EQU	0
params		EQU	paramCount+2
returnValue	EQU	params+64
passFlag	EQU	returnValue+4

entryPoint	EQU	passFlag+2
request		EQU	entrypoint+4
result		EQU	request+2
inArgs		EQU	result+2
outArgs		EQU	inArgs+32

;mnemonics for some of the args in the XCmdBlock
nameruntime	EQU	params		;handle to first arg
sizeResult	EQU	nameruntime+4	;handle to second arg
nameroutine	EQU	sizeResult+4	;handle to third arg
arg16		EQU	nameroutine+52	;handle to sixteenth arg



Letsgo:
;	DC.W	$A9FF			;gee, how did this get here
	LINK	A6,#stackframe
	MOVEM.L	A0-A4/D0-D7,-(A7)	;save the world
	
;------disable initmenus, initwindows, etc. in runtime library startup------------

  ;modify the first instruction in init.asm from MOVEQ #0,D7 to MOVEQ #1,D7	
  ;have to do this up here because instruction prefetching screws this boy
  ;up if he's right before the instruction to be modified!
    	LEA	modify,A0		;load address of the MOVEQ		
	MOVE.W	#$7e01,(A0)		;change it
       
;----------create an error message in a zero-terminated string in a handle------
;--------------and check that we got enough arguments from Hyper------------

	MOVE.L	#2,D0
	_NewHandle			;get a handle for an error message
;	BNE	error0
  ;if we get an error here, we'll bomb if we try to cope with it,
  ;so the hell with it -- there shouldn't be one!
	MOVE.L	(A0),A1			;deref the handle
	MOVE.W	#0,(A1)			;make the handle point to a null string
		
    ;put errorhandle in returnValue of XCmdBlock to give a polite exit 
    ;if there aren't >=3 args. 
	MOVE.L	XCmdBlock(A6),A2	;retrieve pointer for XCmdBlock
	MOVE.L	A0,returnValue(A2)	;put errorhandle in returnValue	

    ;get number of args
	MOVE.W	paramCount(A2),D3	;move number of args to D3
	CMPI.W	#3,D3			;exit if there are fewer than 3 args
	BLT		badnumargs
	
    ;retrieve errorhandle and substitute 3rd arg in returnValue
	MOVE.L	returnValue(A2),A0
	MOVE.L	params+8(A2),returnValue(A2)
	
    ;trash errorhandle
	_DisposHandle
	BNE		error1
	

;----------------- lock args 4 - 16   -------------------------------------	

    ;pull args from XCmdBlock, move high and lock
	SUBQ.W	#3,D3			;don't lock first three args
	BEQ.S		endlock
	SUBQ.W	#1,D3			;prepare numargs for dbra
	MOVE.L	#12,D4			;load offset for arg4
loop1	MOVE.L	params(A2,D4),A0	;get arg, move it high & lock it
	MOVE.L	A0,-(A7)
	_MoveHHi
	CMPI.W	#0,D0
	BLT		error2
	MOVE.L	params(A2,D4),A0
	_HLock
	BNE		error3
	ADDQ.W	#4,D4			;increment arg offset
	DBRA	D3,	loop1
endlock:
	
	
;----set flag for init.asm's handling of different runtime libraries------
    ;and disable initialization of MacFortran's default window

	CLR.L	D5    
	MOVE.L	nameruntime(A2),A0	;get handle to runtime libray name code
	MOVE.L	(A0),A0			;get ptr to name code
	MOVE.B	(A0)+,D5		;get first char of runtime name
	CMPI.B	#'-',D5			;see if no window flag is set
	BNE.S   havewindow
	MOVE.L   #$FFFF0000,D5		;set highword of D5 to instruct 
					;init.asm to not use default window
	MOVE.B	(A0),D5			;get second char of runtime name
havewindow:
	SUBI.B	#49,D5			;convert to numeric
	       ;Init.asm wants RuntimeArg to be 0, 1, or 2.  But if the user
	       ;passes us "-0", Hyper strips the leading "-" if there 
	       ;are no quotation marks.  Thus have user load RuntimeArg as
	       ;1, 2, or 3, not 0, 1, or 2
	BMI		badRuntimeArg	;it's bad if runtime name code < |1|
	CMPI.B	#2,D5
	BHI		badRuntimeArg	;it's bad if runtime name code > |3|
	
	
;--convert sizeResult set by user to numeric so can allocate result storage--

	MOVE.L	sizeResult(A2),A1	;get handle to sizeResult
	MOVE.L	(A1),A1			;deref it
	JSR		arglength	;pass arg in A1, returns length in D1
 	MOVE.L 	D1,D3
	SUBQ.W	#1,D3			;subtract 1 for tailing nil			
	BEQ	       badResultSizeArg	;sizeResult has to have at least one char
	
      ;convert sizeResult to numeric, check that all chars are numeric
	SUBQ.W	#1,D3			;D3 is number of chars, prep for dbra
	MOVEQ.L	#1,D2			;D2 is multiplier for position of char in number
	CLR.L	D1			;D1 will be numeric form of ResultSize
	SUBQ.W	#1,A1			;back off of end of string
loop3	CLR.L	D0			;we multiply by large #s, clr first
	MOVE.B	-(A1),D0		;get rightmost char in string		
	SUBI.B	#48,D0			;convert to numeric
	BMI		badResultSizeArg;ascii code of char < 48 (ascii 0 = 48)
	CMPI.B	#9,D0			;all chars have to be numbers
	BGT		badResultSizeArg;ascii code of char > 57 (ascii 9 = 57)
	MULU	D2,D0			;second char gets multiplied by 10, 3rd by 100, etc
	MULU	#10,D2			;increment D2
	ADD.L	D0,D1			;compute size of FunctionResult
	DBRA	D3,	loop3
	
     ;store numeric form of sizeResult for use in fortran calling proc (.WILLGO)
	MOVE.W	D1,numericSizeResult(A6)
	
	
;-------allocate handle to store function result and pass back to hyper----

	MOVE.L	D1,D3			;save length in non-trashable reg
	MOVE.L	D1,D0			;prepare for NewHandle
	ADDQ.L	#1,D0			;have to add trailing 0
	CMPI.L	#$8000,D0
	BGE		resultSizeGT32k ;Hyper restricted to 32k containers
	_NewHandle
	BNE		couldnotAllocateResultSize
	MOVE.L	A0,A2			;save in non-trashable reg
	_MoveHHi
	BNE		error4
	MOVE.L	A2,A0
	_HLock
	BNE		error5
	MOVE.L	XCmdBlock(A6),A3
	MOVE.L	A2,returnValue(A3)	;put in returnValue of XCmdBlock
	
      ;put spaces in handle so it will be a valid character variable
	MOVE.L	(A2),A2			;deref returnValue
      	SUBQ.W	#1,D3			;want to put nil in last byte
clrloop:MOVE.B	#32,(A2)+				
	DBRA	D3,clrloop
	MOVE.B	#0,(A2)+		;make it a valid hyper container
					
					
;-------call a modified version of an assembled fortran main program------
	
	CLR.L	FortranHeapPtr(A6)	;this will be filled if got to .WILLGO
	CLR.L	D4		;set flag that couldn't allocate heap.
				;Init.asm will fill this reg if it does
				;succeed in allocating the heap
	CLR.L	errorFlags(A6)		;we'll fill this in .WILLGO if
					;function name has bad chars in it
	MOVE.L	A6,-(A7)		;save A6

	JSR	.START
	
	MOVE.L	(A7)+,A6		;restore A6

	MOVE.L	FortranHeapPtr(A6),D5	;find out if got heap and runtime
	BNE.S		trashheap
	CMPI.L	#0,D4			;check that could allocate heap
	BEQ		noHeapAlloc	;if heapPtr = 0 and D4 = 0
	BRA		noRuntimeLib	;if heapPtr = 0 and D4 ne 0
	

;------------trash fortran heap gook (traverse a linked list)--------------
 
trashheap:
	MOVE.L	-8(A0),D3		;ptr to first non-relocatable block
	BEQ.S		endgook		;fortran has put on heap
moregook:
	MOVE.L	D3,A0
	MOVE.L	(A0),D3			;ptr to next non-relocatable block
	_DisposPtr
	BNE		error6a		;problems trashing gook
	TST.L	D3
	BNE.S		moregook
endgook:
	
	MOVE.L	D5,A0
	_DisposPtr			;trash fortran heap
	BNE		error6		;problems trashing it
	
	CMPI.W	#badsubname,errorFlags(A6)
	BEQ		badSubroutineName
	

;------------cleanup & exit-------------------------------

	BSR	unlockArgHandles
	BSR	unlockResultHandle
	
dondon	MOVEM.L	(A7)+,A0-A4/D0-D7	;restore the world
	UNLK	A6
	MOVE.L	(A7)+,(A7)
	RTS
	
;----------------error handling----------------------------

error1		
	LEA	serror1,A0
	BRA	errs
error2				
	LEA	serror2,A0
	BRA	errs
error3
	LEA	serror3,A0
	BRA	errs
error4				
	LEA	serror4,A0
	BRA.S	errs
error5
	LEA	serror5,A0		
	BRA.S	errs
error6
	LEA	serror6,A0		
	BRA.S	errs
error6a
	LEA	serror6a,A0		
	BRA.S	errs
error7
	LEA	serror7,A0		
	BRA.S	errs
error8
	LEA	serror8,A0		
	BRA.S	errs
badNumArgs			;there are fewer than 3 args		
	LEA	sbadNumArgs,A0	
	BRA.S	errs
badRuntimeArg			;has to equal 1, 2, or 3	
	BSR	unlockArgHandles
	LEA	sbadRuntimeArg,A0   
	BRA.S	errs
badResultSizeArg		;arg for FunctionResultSize was bad	
	BSR	unlockArgHandles
	LEA	sbadResultSizeArg,A0	
	BRA.S	errs
resultSizeGT32k
	BSR	unlockArgHandles
	LEA	sresultSizeGT32k,A0	
	BRA.S	errs
couldnotAllocateResultSize
	BSR	unlockArgHandles
	LEA	scouldnotAllocateResultSize,A0	
	BRA.S	errs
noHeapAlloc
	BSR	unlockArgHandles
	BSR	unlockResultHandle	
	LEA	snoHeapAlloc,A0	
	BRA.S	errs
noRuntimeLib
	BSR	unlockArgHandles
	BSR	unlockResultHandle	
	LEA	snoRuntimeLib,A0	
	BRA.S	errs			
badSubroutineName
	BSR	unlockArgHandles
	BSR	unlockResultHandle	
	LEA	sbadSubroutineName,A0	
	BRA	errs			


;----code to have HyperCard's callback routine put up the Answer Dialog---
errs	MOVEA.L	XCmdBlock(A6),A1	;retrieve pointer for XCmdBlock
	MOVE.L	A0,inArgs(A1)		;load the answer string's address
	MOVE.W	#1,request(A1)		;request the Answer Dialog box
	BSR.S	callHyper		;heh, it works!
	BRA.S	dondon			;get out of here
	

;---------------subroutine to do a HyperCard call back--------------------
callHyper:
	MOVE.L	entryPoint(A1),A0	;load the entry point to Hyper
	JMP	(A0)			;go to Hyper -- thanks Andy
	

;--------------------------error strings----------------------------------
	STRING_FORMAT 2			;add leading length byte to LEAd string
serror1		DC.B	'answer "Letsgo error #1, you''d better reboot now"',0
		.ALIGN	2		;hyper wants word-aligned strings
serror2		DC.B	'answer "Letsgo error #2, you''d better reboot now"',0
		.ALIGN	2
serror3		DC.B	'answer "Letsgo error #3, you''d better reboot now"',0
		.ALIGN	2
serror4		DC.B	'answer "Letsgo error #4, you''d better reboot now"',0
		.ALIGN	2
serror5		DC.B	'answer "Letsgo error #5, you''d better reboot now"',0
		.ALIGN	2
serror6		DC.B	'answer "Letsgo error #6, you''d better reboot now"',0
		.ALIGN	2
serror6a	DC.B	'answer "Letsgo error #6a, you''d better reboot now"',0
		.ALIGN	2
serror7		DC.B	'answer "Letsgo error #7, you''d better reboot now"',0
		.ALIGN	2
serror8		DC.B	'answer "Letsgo error #8, you''d better reboot now"',0
		.ALIGN	2
sbadNumArgs	DC.B	'answer "Letsgo takes at least 3 args."',0
		.ALIGN	2
sbadRuntimeArg	DC.B	'answer "Letsgo''s 1st argument has to be 1, 2, or 3."',0
		.ALIGN	2
sbadResultSizeArg	
		DC.B	'answer "Letsgo''s 2nd argument has to be numeric."',0
		.ALIGN	2
sresultSizeGT32k
		DC.B	'answer "Letsgo''s result has to be < 32 k."',0
		.ALIGN	2
scouldnotAllocateResultSize
		DC.B	'answer "Letsgo out of memory - Result size too big."',0
		.ALIGN	2
snoHeapAlloc	DC.B	'answer "Letsgo out of memory - couldn''t load Fortran."',0
		.ALIGN  2
snoRuntimeLib	DC.B	'answer "Letsgo couldn''t find Fortran''s runtime library."',0
		.ALIGN  2
sbadSubroutineName
		DC.B	'answer "Bad chars in function name passed to Letsgo."',0
		.ALIGN  2
		DC.B	'Copyright 1988 by Fred Hebard'
		.ALIGN  2
	STRING_FORMAT	0	;restore original for fortran init.asm
	
	
	
;-------------Subroutine to count number of chars in arg---------------------

arglength:				; arg ptr in A1, return num chars in D1
  	CLR.L	D1			;D1 is number of chars
charct:	MOVE.B	(A1)+,D0
	ADDQ.W	#1,D1
	CMPI.B	#0,D0
	BNE.S		charct		;exit when hit end of string
	RTS


;-----Subroutine to unlock handles passed from hyper prior to exit----------

unlockArgHandles:
	MOVE.L	XCmdBlock(A6),A2	;retrieve pointer for XCmdBlock
	CLR.L	D3
	MOVE.W	paramcount(A2),D3
	SUBQ.W	#3,D3			;1st 3 handles are not locked
	BEQ.S	endunlock
	SUBQ.W	#1,D3			;prepare numargs for dbra
	MOVE.L	#12,D4			;prepare offset to handles of other args
loop4:	MOVE.L	params(A2,D4),A0	;get arg
	_HUnLock
	BNE		error7
	ADDQ.W	#4,D4			;increment offset
	DBRA	D3,	loop4
endunlock:
	RTS
	
	
;-----Subroutine to unlock the handle of the result being passed to hyper--

unlockResultHandle:
	MOVE.L	XCmdBlock(A6),A2	;retrieve pointer for XCmdBlock
	MOVE.L	returnValue(A2),A0
	_HUnLock
	BNE		error8
	RTS


;------Subroutine to startup Fortran and call a character function----------------	
;------------A modified assembled Fortran main program----------------------	

;stack frame
string		EQU	-6		;character form of name of function to be called
rad50		EQU	string-4	;rad50 form (integer) of function to be called
amtDecrementedStack	EQU	rad50-4	;know how much to increment stack on return
sframe		EQU	amtDecrementedStack

originalA6	EQU	8		;4 for return address, 4 for link A6


	.ALIGN	4			;init.asm seems to want this
	
.START: LEA     .START(PC),A1
	ADDA.L  #.WILLGO-.START,A1   
modify					;Disable initmngrs here
        INCLUDE INIT.ASM		;will startup fortran then return here




        XDEF    .WILLGO
.WILLGO:        MOVE.L  #L00001-L00002,D1
L00002: LEA     L00002(PC,D1.L),A1	;? they trash A1 below
        LINK    A6,#sframe
	
        MOVEA.L A7,A3			;let A3 point to current stack
        MOVE.L  #0,54(A0)		;? - tell comunications area something
					;probably that we're a main program

	MOVE.L	originalA6(A6),A2	;get A6 from main so can use mnemonics
	MOVE.L	A4,FortranHeapPtr(A2)	;A4 has ptr to heap, we'll need to
					;trash it in the main program
	
;         program letsgo


;-strip leading blanks from name passed from Hyper & pad right side with spaces
;         string = '      '  

        LEA     string(A6),A1
        MOVE.B  #32,(A1)+
        MOVE.B  #32,(A1)+
        MOVE.B  #32,(A1)+
        MOVE.B  #32,(A1)+
        MOVE.B  #32,(A1)+
        MOVE.B  #32,(A1)+
	
;         string = file name passed from hyper 
	MOVE.L	XCmdBlock(A2),A3
	MOVE.L	nameroutine(A3),A1	;get name handle
	MOVE.L	(A1),A1			;deref
	LEA	string(A6),A3		

strip	CMPI.B	#32,(A1)
	BNE.S		subname		;strip leading blanks
	ADDA.W	#1,A1
	CMPI.B	#0,(A1)			;better not hit end of string with all
	BNE.S		strip		;blank chars!
	MOVE.W	#badsubname,errorflags(A2)
	JMP	20(A4)			;we're outta here!
	
	MOVEQ.L	#5,D2			;prepare to dbra, only move 6 bytes	
subname:
	MOVE.B	(A1)+,(A3)+		;move 1
	CMPI.B	#0,(A1)
	BEQ.S	endsubname		;exit when hit end of subroutine name
	DBRA 	D2,	subname		;loop if D2 >= 0
endsubname:
	MOVE.L	A7,A3			;restore A3 - don't know why Fortran
					;does this

;         call rad50(string,rad50)

        MOVE.L  A5,-(A7)		;save only A5 on entry to local proc
        SUBQ.W  #4,A7			;make room for lengths (word) of two args
        PEA     string(A6)		;push first arg
        MOVE.W  #6,4(A7)		;move length word since its a char variable
        PEA     rad50(A6)		;push second arg
        MOVE.L  #.RAD50-L00003,D1	;put offset in D1
L00003: JSR     L00003(PC,D1.L)		;jsr to rad50
        ADDA.W  #12,A7			;=numargs*6, clr loaded args
        MOVEA.L (A7)+,A5		;restore A5
        MOVEA.L A7,A3			;restore current stack to A3


;-----------call sub(arg4-16, depending on number of args)----------------

        MOVEM.L A0/A4/A5,-(A7)		;save critical regs for dynamically loaded routine

;         get the number of args hyper has passed to us
	MOVE.L XCmdBlock(A2),A1
	CLR.L	D3
	MOVE.W paramCount(A1),D3	;move numargs to D3
	SUBQ.W	#3,D3			;first 3 args don't go to fortran function
	
;	  prepare stack for numargs + result arg = 6*(numargs+1)
	MOVE.L	D3,D5
	ADDQ.W	#1,D5			;make room for result too
	MULU	#6,D5
	MOVE.W	D5,amtDecrementedStack(A6)	;store so can decrement stack at end
	SUBA.W	D5,A7
	
;	  offset of last arg from arg16(XCmdBlock) = -(16 - 3 - numargs)*4
	MOVE.L	D3,D5			;move num args to D5
	MOVE.L	#13,D4
	SUB.W	D5,D4
	MULU	#4,D4
	NEG.W	D4			;D4 will be offset of last arg from arg16
	
;	  compute A7 offset of length of last arg. = (numargs+1)*6 - 2
	MOVE.L	D3,D6
	ADDQ.W	#1,D6			;will be passing function result too
	MULU	#6,D6
	SUBQ.W	#2,D6			;store A7 length offset in D6
	
;	  A7 offset of last arg pointer = 0
	CLR.L	D7			;store A7 arg offset in D7
	
;	  push function result and its length	
	MOVE.L	returnValue(A1),A1	;get function result handle
	MOVE.L	(A1),(A7,D7)		;push function result pointer
	MOVE.W	numericSizeResult(A2),D1
	SUBQ.W	#1,D1			;don't let fortran see tailing 0
	MOVE.W	D1,(A7,D6)		;push function length
	ADDQ.W	#4,D7			;increment A7 arg offset
	SUBQ.W	#2,D6			;increment A7 length offset
	
;	  prepare an index for pushing dbra (loop6) & don't push if only 3 args from hyper	  
	MOVE.L	D3,D5			;move num args
	BEQ		endpushing	;no args to subroutine
	SUBQ.W	#1,D5			;prepare D5 for dbra
	
;	  push args and their lengths
	MOVE.L	XCmdBlock(A2),A2
loop6	MOVE.L	arg16(A2,D4),A1		;get arg handle
	MOVE.L	(A1),A1			;deref
	MOVE.L	A1,(A7,D7)		;push arg pointer
	BSR		arglength	;A1 is pointer to arg. Returns length in D1 
	SUBQ.W	#1,D1			;don't let Fortran see tailing 0
	MOVE.W	D1,(A7,D6)		;push length
	ADDQ.W	#4,D7			;prepare A7 arg offset for next loop
	SUBQ.W	#2,D6			;prepare A7 length offset for next loop
	SUBQ.W	#4,D4			;prepare offset from arg16(XCmdBlock) for next loop
	DBRA	D5,	loop6
endpushing

;	  blastoff!
        MOVE.L   D3,D0			;move # args to D0
        MOVE.L  rad50(A6),D1		;move rad50(subroutine name) to D1
        JSR     4(A4)
	MOVE.W	amtDecrementedStack(A6),D1
        ADDA.W  D1,A7			;clr stack ((#args+resultArg) * 6)	
        MOVEM.L (A7)+,A0/A4/A5		;restore regs
        MOVEA.L A7,A3			;let A3 point to stack
	
;         stop

        JMP     20(A4)

;         end

        JMP     20(A4)

L00001: DC.W    0
        DC.W    0
	
	

;-----------------modified RAD50 subroutine, on error, sets errorFlag------

;       subroutine RAD50 (string,rad50)
.RAD50: MOVE.L  #L00004-L00005,D1
L00005: LEA     L00005(PC,D1.L),A1
        LINK    A6,#-24
        MOVEA.L A7,A3

;            rad50(0)=0; rad50(1)=0

        MOVEA.L 8(A6),A1
        CLR.W   (A1)
        CLR.W   2(A1)

;              do (i=1,6)

        MOVE.L  #1,8(A3)
        MOVEQ   #5,D6
L00006: 

;                  select case (string(i))

        MOVE.L  8(A3),D4
        MOVEA.L 12(A6),A1
        MOVEQ   #1,D1
        MOVE.L  D1,D5
        MOVE.B  -1(A1,D4.L),-(A5)
        PEA     L00010(PC)
        MOVEQ   #2,D4
        BSR.S   L00012
        DC.B    65,32
L00012: MOVEA.L (A7)+,A1
        MOVEQ   #2,D1
        JSR     368(A4)
        BGT.S   L00011
        BSR.S   L00013
        DC.B    90,32
L00013: MOVEA.L (A7)+,A1
        MOVEQ   #2,D1
        JSR     368(A4)
        BLT.S   L00011
        RTS
L00011: ADDQ.L  #2,D4
        BSR.S   L00015
        DC.B    97,32
L00015: MOVEA.L (A7)+,A1
        MOVEQ   #2,D1
        JSR     368(A4)
        BGT.S   L00014
        BSR.S   L00016
        DC.B    122,32
L00016: MOVEA.L (A7)+,A1
        MOVEQ   #2,D1
        JSR     368(A4)
        BLT.S   L00014
        RTS
L00014: ADDQ.L  #2,D4
        BSR.S   L00018
        DC.B    48,32
L00018: MOVEA.L (A7)+,A1
        MOVEQ   #2,D1
        JSR     368(A4)
        BGT.S   L00017
        BSR.S   L00019
        DC.B    57,32
L00019: MOVEA.L (A7)+,A1
        MOVEQ   #2,D1
        JSR     368(A4)
        BLT.S   L00017
        RTS
L00017: ADDQ.L  #2,D4
        BSR.S   L00021
        DC.B    32,32
L00021: MOVEA.L (A7)+,A1
        MOVEQ   #2,D1
        JSR     368(A4)
        BNE.S   L00020
        RTS
L00020: ADDQ.L  #2,D4
        BSR.S   L00023
        DC.B    46,32
L00023: MOVEA.L (A7)+,A1
        MOVEQ   #2,D1
        JSR     368(A4)
        BNE.S   L00022
        RTS
L00022: ADDQ.L  #2,D4
        BSR.S   L00025
        DC.B    36,32
L00025: MOVEA.L (A7)+,A1
        MOVEQ   #2,D1
        JSR     368(A4)
        BNE.S   L00024
        RTS
L00024: ADDQ.W  #4,A7
        CLR.L   D4
L00010: ADDA.L  D5,A5
        LEA     L00027(PC,D4.L),A1
        ADDA.W  (A1),A1
        JMP     (A1)
L00027: DC.W    L00028-L00027
L00030: DC.W    L00031-L00030
L00032: DC.W    L00033-L00032
L00034: DC.W    L00035-L00034
L00036: DC.W    L00037-L00036
L00038: DC.W    L00039-L00038
L00040: DC.W    L00041-L00040

;                    case ("A":"Z")

L00031: 

;                      l = 64

        MOVE.L  #64,20(A3)

;                    case ("a":"z")

        BRA.S   L00029
L00033: 

;                      l = 96

        MOVE.L  #96,20(A3)

;                    case ("0":"9")

        BRA.S   L00029
L00035: 

;                      l = 18

        MOVE.L  #18,20(A3)

;                    case (" ")

        BRA.S   L00029
L00037: 

;                      l = 32

        MOVE.L  #32,20(A3)

;                    case (".")

        BRA.S   L00029
L00039: 

;                      l = 18

        MOVE.L  #18,20(A3)

;                    case ("$")

        BRA.S   L00029
L00041: 

;                      l = 9

        MOVE.L  #9,20(A3)

;                    case default

        BRA.S   L00029
L00028: 

;                      write (9,101) string(i)   !console window not open
				;have to use hyper to tell user
	MOVE.W	#badsubname,errorflags(A2)


;                      stop

        JMP     20(A4)

;                  end select

        BRA.S   L00029
        MOVEQ   #79,D1
        JSR     16(A4)
L00029: 

;                j = (i-1)/3

        MOVE.L  8(A3),D0
        SUBQ.L  #1,D0
        MOVEQ   #3,D1
        JSR     68(A4)
        MOVE.L  D0,12(A3)

;                k = RADIX**mod(6-i,3)

        MOVEQ   #40,D0
        MOVE.L  D0,-(A7)
        MOVEQ   #6,D0
        SUB.L   8(A3),D0
        MOVE.L  D0,-(A7)
        MOVEQ   #3,D0
        MOVE.L  D0,D1
        MOVE.L  (A7),D0
        JSR     68(A4)
        JSR     64(A4)
        NEG.L   D0
        ADD.L   (A7)+,D0
        MOVE.L  D0,D1
        MOVE.L  (A7)+,D0
        JSR     148(A4)
        MOVE.L  D0,16(A3)

;                rad50(j) = rad50(j) + (ichar(string(i))-l)*k

        MOVE.L  12(A3),D4
        ADD.L   D4,D4
        MOVEA.L 8(A6),A1
        PEA     0(A1,D4.L)
        MOVE.L  8(A3),D4
        MOVEA.L 12(A6),A1
        MOVEQ   #1,D1
        MOVE.L  D1,D5
        MOVE.B  -1(A1,D4.L),-(A5)
        MOVEQ   #0,D0
        MOVE.B  (A5),D0
        ADDA.L  D1,A5
        SUB.L   D1,D5
        SUB.L   20(A3),D0
        MOVE.L  16(A3),D1
        JSR     64(A4)
        MOVE.L  12(A3),D4
        ADD.L   D4,D4
        MOVEA.L 8(A6),A1
        MOVE.W  0(A1,D4.L),D1
        EXT.L   D1
        ADD.L   D1,D0
        MOVEA.L (A7)+,A1
        MOVE.W  D0,(A1)

;              repeat

L00007: ADDQ.L  #1,8(A3)
L00008: SUBQ.L  #1,D6
        BGE.W   L00006
L00009: 

;       return

        UNLK    A6
        RTS

L00044: 

;       end

        UNLK    A6
        RTS

L00004: DC.W    0
        DC.W    0

        END

