/********************************/
/* File: WindowCommands.h		*/
/* 								*/
/* Prototypes and data declares	*/
/* for windowing system			*/
/*								*/
/********************************/

#define		INSTALL_CMD		0			/* Install the window handlers			*/
#define		OPEN_CMD		1			/* open window with the params			*/
#define		CLOSE_CMD		2			/* close the window with name			*/
#define		SHOW_CMD		3			/* show window by name					*/
#define		HIDE_CMD		4			/* hide window by name					*/
#define		ADD_CMD			5			/* Move window on the screen			*/
#define		DELETE_CMD		6			/* Draw contents of window				*/
#define		CLEAR_CMD		7			/* clear out the contents of the window	*/
#define		REMOVE_CMD		8			/* respond to mouseup in window			*/


#define		PASS_CMD		-1			/* pass request back to caller			*/
#define		IN_FRONT		-1L
#define		GO_AWAY			1
#define		NO_GO_AWAY		0

#define		WIND_GLOBALS	'winf'		/* resource type for window info record	*/
#define		WIND_ID			128			/* reosource id of this element.		*/

/*** Traps we patch		***/
#define 	EVENT_TRAP   	0xA970

/*** Exec reources for trap patches	***/
#define		EVENT_EXEC		1000



/*** Window Commands	***/
long	do_init( void );
long	do_remove( XCmdBlockPtr paramPtr, wdGlobalsPtr windH );
long	do_open( char *name, XCmdBlockPtr paramPtr,	wdGlobalsPtr windP );
long	do_close(char *name, XCmdBlockPtr paramPtr,	wdGlobalsPtr windP );
long	do_show( char *name, XCmdBlockPtr paramPtr,	wdGlobalsPtr windP );			
long	do_hide( char *name, XCmdBlockPtr paramPtr, wdGlobalsPtr windP );
long	do_draw( char *name, XCmdBlockPtr paramPtr, wdGlobalsPtr windP );
