/* File CmdoRect.R */
/* W. Powell, 1988 */
/* Include File to generate commando input for rectangles */

/* This file is meant to be included in other Rez files
 * This file contains 5 Commando control items
 * Parameters RLeft, RTop, RTit, RDep are to be defined in
 * the calling source file.
 *	RTop	= vertical component of top of the RECT dialog area
 *	RLeft	= horizontal component of left of RECT input area
 *	RTit	= short title to describe rectangle
 *	RDef	= a control list enclosed in one set of {}'s.
 *			 	The RECT input area has OR dependency on this 
 *				set of controls.  Build more complicated 
 *				dependency with dummy items.
 */

#ifndef RTop
	#printf ("### CmdoRect.R Error:\n")
	#printf ("### Variable RTop (vert. coord of top left) undefined\n")
#endif
#ifndef RLeft
	#printf ("### CmdoRect.R Error:\n")
	#printf ("### Variable RLeft (horiz. coord. of top left) undefined\n")
#endif
#ifndef RDep
	#printf ("### CmdoRect.R Error:\n")
	#printf ("### Variable RDep (list of control dependencies) undefined\n")
#endif
#ifndef RTit
	#define RTit ""
#endif

OR { RDep }, RegularEntry {
	"Top",
	{RTop+7,RLeft+10,RTop+23,RLeft+50},
	{RTop+27,RLeft+10,RTop+43,RLeft+50},
	"",keepCase,"-t",
	"Top coordinate of rectangle" },
OR { RDep }, RegularEntry {
	"Left",
	{RTop+7,RLeft+60,RTop+23,RLeft+100},
	{RTop+27,RLeft+60,RTop+43,RLeft+100},
	"",keepCase,"-l",
	"Left coordinate of rectangle" },
OR { RDep }, RegularEntry {
	"Bottom",
	{RTop+7,RLeft+106,RTop+23,RLeft+156},
	{RTop+27,RLeft+110,RTop+43,RLeft+150},
	"",keepCase,"-b",
	"Bottom coordinate of rectangle" },
OR { RDep }, RegularEntry {
	"Right",
	{RTop+7,RLeft+162,RTop+23,RLeft+200},
	{RTop+27,RLeft+160,RTop+43,RLeft+200},
	"",keepCase,"-r",
	"Right coordinate of rectangle" },
NotDependent {}, TextBox {
	gray,
	{RTop,RLeft,RTop+51,RLeft+210},
	RTit
	},
	
/* End of file CmdoRect.R */
	
