/* File RezC.ALRT.Cmdo.R */
/* Rez input for the Rezc.ALRT Commando interface */
/* W. Powell 1988 */

/* Rez definitions for Rez-building Commando interfaces */
#include "Cmdo.R"

Resource 'cmdo' (200) {
	{ 255,
	"Rezc.ALRT produces Rez input for an Alert resource",
	{
/* This include file has a standard arrangement of items
 *   common to all resources: ID#, attributes, name, 
 * 	 and redirection of output from the Rezc. script		*/
#include "CmdoReztStart.R"

/* Set up parameters for a Rectangle entry area				*/	
	#define RTop 85
	#define RLeft 30
	#define RTit "Window Rectangle"
	#define RDep {1}
/* This include file has a standard arrangement of edit boxes
 *   for input of rectangles								*/
#include "CmdoRect.R"

/* other items particular to this case */	
	/* Item 11 */
	OR {{1}}, RegularEntry {
		"DITL ID#:",
		{90,265,106,340},
		{90,350,106,435},
		"",keepCase,"-DITL",
		"Resource ID of the alert's item list" },
	/* Item 12 */
	OR {{1}}, NestedDialog {
		4, /* Nested dialog number */
		{115,270,135,430},
		"Alert Stages",
		"Define actions at alert stages 1 through 4" },
	AND {{1,6,7,8,9,11}}, DoItButton {},
	},
/* Dialog 2 */
/* Include the standard resource attributes dialog */
#include "CmdoReztAttr.R"

/* Dialog 3 */
/* Include a redirection dialog */
#include "CmdoReztRdir.R"

/* Dialog 4 */
/* The alert stages */
	255, 
	"Define action to take for each stage of this Alert",
	{
	NotDependent {}, CheckOption {
		Set,
		{20,25,36,300},
		"All alert stages the same",
		"-as14",
		"Click here to produce the same response at all alert stages."
		},
	NotDependent {}, RadioButtons {{
		{72,50,88,113},
			"Visible","-V1",NotSet,"Show alert window.",
		{72,120,88,196},
			"Invisible","-I1",NotSet,"Don't show alert window.",
		}},
	NotDependent {}, RadioButtons {{
		{72,210,88,245},
			"OK","-OK1",NotSet,"Make OK button the default.",
		{72,255,88,320},
			"Cancel","-Can1",NotSet,
			"Make Cancel button the default." 
		}},
	NotDependent {}, RadioButtons {{
		{72,330,88,364},"0","-S01",NotSet,
			"Make Alert silent at this stage.",
		{72,365,88,399},"1","-S11",NotSet,
			"Alert sound 1 (1 beep).",
		{72,400,88,434},"2","-S21",NotSet,
			"Alert sound 2 (2 beeps).",
		{72,435,88,469},"3","-S31",NotSet,
			"Alert sound 3 (3 beeps)."
		}},
	/* Stage 2 */
	OR { {-1} }, RadioButtons {{
		{88,50,104,113},
			"Visible","-V2",NotSet,"Show alert window.",
		{88,120,104,196},
			"Invisible","-I2",NotSet,"Don't show alert window.",
		}},
	OR { {-1} }, RadioButtons {{
		{88,210,104,245},
			"OK","-OK2",NotSet,"Make OK button the default.",
		{88,255,104,320},
			"Cancel","-Can2",NotSet,
			"Make Cancel button the default." 
		}},
	OR { {-1} }, RadioButtons {{
		{88,330,104,364},"0","-S02",NotSet,
			"Make Alert silent at this stage.",
		{88,365,104,399},"1","-S12",NotSet,
			"Alert sound 1 (1 beep).",
		{88,400,104,434},"2","-S22",NotSet,
			"Alert sound 2 (2 beeps).",
		{88,435,104,469},"3","-S32",NotSet,
			"Alert sound 3 (3 beeps)."
		}},
	/* Stage 3 */
	OR { {-1} }, RadioButtons {{
		{104,50,120,113},
			"Visible","-V3",NotSet,"Show alert window.",
		{104,120,120,196},
			"Invisible","-I3",NotSet,"Don't show alert window.",
		}},
	OR { {-1} }, RadioButtons {{
		{104,210,120,245},
			"OK","-OK3",NotSet,"Make OK button the default.",
		{104,255,120,320},
			"Cancel","-Can3",NotSet,
			"Make Cancel button the default." 
		}},
	OR { {-1} }, RadioButtons {{
		{104,330,120,364},"0","-S03",NotSet,
			"Make Alert silent at this stage.",
		{104,365,120,399},"1","-S13",NotSet,
			"Alert sound 1 (1 beep).",
		{104,400,120,434},"2","-S23",NotSet,
			"Alert sound 2 (2 beeps).",
		{104,435,120,469},"3","-S33",NotSet,
			"Alert sound 3 (3 beeps)."
		}},
	/* Stage 4 */
	OR { {-1} }, RadioButtons {{
		{120,50,136,113},
			"Visible","-V4",NotSet,"Show alert window.",
		{120,120,136,196},
			"Invisible","-I4",NotSet,"Don't show alert window.",
		}},
	OR { {-1} }, RadioButtons {{
		{120,210,136,245},
			"OK","-OK4",NotSet,"Make OK button the default.",
		{120,255,136,320},
			"Cancel","-Can4",NotSet,
			"Make Cancel button the default." 
		}},
	OR { {-1} }, RadioButtons {{
		{120,330,136,364},"0","-S04",NotSet,
			"Make Alert silent at this stage.",
		{120,365,136,399},"1","-S14",NotSet,
			"Alert sound 1 (1 beep).",
		{120,400,136,434},"2","-S24",NotSet,
			"Alert sound 2 (2 beeps).",
		{120,435,136,469},"3","-S34",NotSet,
			"Alert sound 3 (3 beeps)."
		}},
	NotDependent {}, Box {
		Gray, {45,48,145,49} },
	NotDependent {}, Box {
		Gray, {45,204,145,205} },
	NotDependent {}, Box {
		Gray, {45,324,145,325} },
	NotDependent {}, TextTitle {
		plain, 
		{50,8,66,44},
		systemFont, systemSize, 
		"Stage" },
	NotDependent {}, TextTitle {
		Plain, 
		{50,105,66,175},
		systemFont, systemSize, 
		"Window" },
	NotDependent {}, TextTitle {
		Plain, 
		{50,240,66,290},
		systemFont, systemSize, 
		"Default Button" },
	NotDependent {}, TextTitle {
		Plain, 
		{50,380,66,420},
		systemFont, systemSize, 
		"Sound" },
	NotDependent {}, TextTitle {
		Outline, 
		{72,20,88,35},
		systemFont, systemSize, 
		"1" },
	OR { {-1} }, TextTitle {
		Outline, 
		{88,20,104,35},
		systemFont, systemSize, 
		"2" },
	OR { {-1} }, TextTitle {
		Outline, 
		{104,20,120,35},
		systemFont, systemSize, 
		"3" },
	OR { {-1} }, TextTitle {
		Outline, 
		{120,20,136,35},
		systemFont, systemSize, 
		"4" },
	},
}
}; 
