/* File RezC.BNDL.Cmdo.R */
/* Rez input for the Rezc.BNDL Commando interface */
/* W. Powell 1988 */

/* Rez definitions for Rez-building Commando interfaces */
#include "Cmdo.R"

Resource 'cmdo' (200) {
	{ 248,
	"Rezc.BNDL produces Rez input for a Bundle resource."
	"\nNOTE:  Input will automatically continue with another"
	" Commando dialog.",
	{
/* This include file has a standard arrangement of items
 *   common to all resources: ID#, attributes, name, 
 * 	 and redirection of output from the Rezc. script		*/
#include "CmdoReztStart.R"

/* other items particular to this case */	
	/* Item 6 */
	OR {{1}}, RegularEntry {
		"Signature:",
		{87,20,103,95},
		{87,100,103,150},
		"",keepCase,"",
		"The autograph:  4 characters" },
	/* Item 7 */
	OR {{1}}, RegularEntry {
		"Signature ID#:",
		{87,170,103,260},
		{87,265,103,315},
		"",keepCase,"",
		"The signature version ID" },
	/* Item 8 */ 
	OR {{1}}, CheckOption {
		NotSet,
		{87,325,103,465},
		"Build autograph.",
		"-autogr",
		"Automatically create autograph resource as a string" },
	/* Item 9 */
	OR {{8}}, RegularEntry {
		"String:",
		{115,30,131,100},
		{115,105,131,450},
		"",keepCase,"",
		"A string to store in the autograph resource.  "
		"Usually contains version identification and "
		"copyright notices.\nNOTE: Use \\n for new line." },
	/* Item 10 */
	OR {{-8, 9}}, Dummy {},
	/* Item 11 */
	AND {{1,6,7,10}}, DoItButton {},
	},
	
/* Dialog 2 */
/* Include the standard resource attributes dialog */
#include "CmdoReztAttr.R"

/* Dialog 3 */
/* Include a redirection dialog */
#include "CmdoReztRdir.R"

}
}; 
