/* File RezC.BNDL.more.Cmdo.R */
/* Rez input for the Rezc.BNDL.more Commando interface */
/* W. Powell 1988 */

/* Rez definitions for Rez-building Commando interfaces */
#include "Cmdo.R"

Resource 'cmdo' (200) {
	{ 240,
	"This is for continuation of commando interface for"
	" building BNDL resources.",
	{
	/* Item 1 */
	NotDependent {}, RegularEntry {
		"",
		{1,1,1,1},
		{35,30,51,80},
		"",keepCase,"",
		"Resource type for bundled resource" },
	/* Item 2 */
	OR {{1}}, RegularEntry {
		"",
		{1,1,1,1},
		{35,100,51,130},
		"",keepCase,"",
		"Local ID number for resource bundle" },
	/* Item 3 */
	OR {{1}}, RegularEntry {
		"",{1,1,1,1},
		{35,150,51,210},
		"",keepCase,"",
		"Resource ID# for this bundled resource" },
	/* Item 4 */ 
	AND {{2,3}}, Dummy {},
	/* Item 5 */
	OR {{-1,4}}, Dummy {},
	
	/* Item 6 */
	NotDependent {}, RegularEntry {
		"",
		{1,1,1,1},
		{35,270,51,320},
		"",keepCase,"",
		"Resource type for bundled resource" },
	/* Item 7 */
	OR {{6}}, RegularEntry {
		"",
		{1,1,1,1},
		{35,340,51,370},
		"",keepCase,"",
		"Local ID number for resource bundle" },
	/* Item 8 */
	OR {{6}}, RegularEntry {
		"",{1,1,1,1},
		{35,390,51,450},
		"",keepCase,"",
		"Resource ID# for this bundled resource" },
	/* Item 9 */ 
	AND {{7,8}}, Dummy {},
	/* Item 10 */
	OR {{-6,9}}, Dummy {},
	
	/* Item 11 */
	NotDependent {}, RegularEntry {
		"",
		{1,1,1,1},
		{61,30,78,80},
		"",keepCase,"",
		"Resource type for bundled resource" },
	/* Item 12 */
	OR {{11}}, RegularEntry {
		"",
		{1,1,1,1},
		{61,100,78,130},
		"",keepCase,"",
		"Local ID number for resource bundle" },
	/* Item 13 */
	OR {{11}}, RegularEntry {
		"",{1,1,1,1},
		{61,150,78,210},
		"",keepCase,"",
		"Resource ID# for this bundled resource" },
	/* Item 14 */ 
	AND {{12,13}}, Dummy {},
	/* Item 15 */
	OR {{-11,14}}, Dummy {},
	
	/* Item 16 */
	NotDependent {}, RegularEntry {
		"",
		{1,1,1,1},
		{61,270,78,320},
		"",keepCase,"",
		"Resource type for bundled resource" },
	/* Item 17 */
	OR {{16}}, RegularEntry {
		"",
		{1,1,1,1},
		{61,340,78,370},
		"",keepCase,"",
		"Local ID number for resource bundle" },
	/* Item 18 */
	OR {{16}}, RegularEntry {
		"",{1,1,1,1},
		{61,390,78,450},
		"",keepCase,"",
		"Resource ID# for this bundled resource" },
	/* Item 19 */ 
	AND {{17,18}}, Dummy {},
	/* Item 20 */
	OR {{-16,19}}, Dummy {},
	
	/* Item 21 */
	NotDependent {}, RegularEntry {
		"",
		{1,1,1,1},
		{88,30,104,80},
		"",keepCase,"",
		"Resource type for bundled resource" },
	/* Item 22 */
	OR {{21}}, RegularEntry {
		"",
		{1,1,1,1},
		{88,100,104,130},
		"",keepCase,"",
		"Local ID number for resource bundle" },
	/* Item 23 */
	OR {{21}}, RegularEntry {
		"",{1,1,1,1},
		{88,150,104,210},
		"",keepCase,"",
		"Resource ID# for this bundled resource" },
	/* Item 24 */ 
	AND {{22,23}}, Dummy {},
	/* Item 15 */
	OR {{-21,24}}, Dummy {},
	
	/* Item 26 */
	NotDependent {}, RegularEntry {
		"",
		{1,1,1,1},
		{88,270,104,320},
		"",keepCase,"",
		"Resource type for bundled resource" },
	/* Item 27 */
	OR {{26}}, RegularEntry {
		"",
		{1,1,1,1},
		{88,340,104,370},
		"",keepCase,"",
		"Local ID number for resource bundle" },
	/* Item 28 */
	OR {{26}}, RegularEntry {
		"",{1,1,1,1},
		{88,390,104,450},
		"",keepCase,"",
		"Resource ID# for this bundled resource" },
	/* Item 29 */ 
	AND {{27,28}}, Dummy {},
	/* Item 30 */
	OR {{-26,29}}, Dummy {},
	
	/* Item 31 */
	OR {{1,6,11,16,21,26}}, CheckOption {	
		NotSet, 
		{110,200,126,300},
		"Last bundle",
		"-DONE",
		"Check if items shown are the last contained in this"
		"BNDL.\nAll blanks has same effect." },
	/* Item 32 */
	AND {{5,10,15,20,25,30}}, DoItButton {},
	
	NotDependent {}, TextTitle {
		plain,
		{14,35,30,75},
		systemFont,systemSize,
		"Type" },
	NotDependent {}, TextTitle {
		plain,
		{14,275,30,315},
		systemFont,systemSize,
		"Type" },
	NotDependent {}, TextTitle {
		plain,
		{14,82,30,135},
		systemFont,systemSize,
		"Local ID" },
	NotDependent {}, TextTitle {
		plain,
		{14,322,30,374},
		systemFont,systemSize,
		"Local ID" },
	NotDependent {}, TextTitle {
		plain,
		{14,150,30,210},
		systemFont,systemSize,
		"Actual ID" },
	NotDependent {}, TextTitle {
		plain,
		{14,390,30,460},
		systemFont,systemSize,
		"Actual ID" },
	},
}
}; 
