/* File RezC.DLOG.Cmdo.R */ 
/* Commando interface to build DLOG Rez input */
/* W. Powell 1988 */

/* Rez definitions for Rez-building Commando interfaces */
#include "Types.R"
#include "Cmdo.R"

Resource 'cmdo' (200) {
	{ 295,
	"Rezc.DLOG produces Rez input for a Dialog resource",
	{
/* This include file has a standard arrangement of items
 *   common to all resources: ID#, attributes, name, 
 * 	 and redirection of output from the Rezc. script		*/
#include "CmdoReztStart.R"

/* Set up parameters for a Rectangle entry area				*/	
	#define RTop 85
	#define RLeft 30
	#define RTit "Window Rectangle"
	#define RDep {1}
/* This include file has a standard arrangement of edit boxes
 *   for input of rectangles								*/
#include "CmdoRect.R"

/* other items particular to this case */	
	/* Item 11 */
	OR {{1}}, NestedDialog {
		4, /* Dialog number */
		{85,250,106,370},
		"Window Type",
		"Select style of window for dialog." },
	/* Item 12 */
	OR {{1}}, RadioButtons {{
		{80,380,96,460},
			"Visible","-V",NotSet,"Make dialog visible.",
		{97,380,113,460},
			"Invisible","-I",NotSet,"Make dialog invisible."
		}},
	/* Item 13 */
	OR {{1}}, RegularEntry {
		"DITL ID#:",
		{114,250,130,310},
		{114,315,130,370},
		"",keepCase,"",
		"Resource ID # of this dialogs item list." },
	/* Item 14 */
	OR {{1}}, RegularEntry {
		"RefCon:",
		{138,250,154,310},
		{138,315,154,430},
		"",keepCase,"-const",
		"User-defined constant.\nHEX long word." },
	/* Item 15 */
	OR {{1}}, RegularEntry {
		"Title:",
		{162,30,178,90},
		{162,100,178,440},
		"",keepCase,"-title",
		"Title for window." },
	/* Item 16 */
	AND {{6,7,8,9,13}}, DoItButton {},
	}, 
/* Dialog 2 */
/* Include the standard resource attributes dialog */
#include "CmdoReztAttr.R"

/* Dialog 3 */
/* Include a redirection dialog */
#include "CmdoReztRdir.R"

/* Dialog 4 */
	270,
	"Select style of window.",
	{
	/* Item 1 */
	NotDependent {}, RadioButtons {{
		{55,54,71,70},
			"","documentProc",NotSet,"",
		{55,156,71,172},
			"","dBoxProc",NotSet,
			"NOTE: This window type inhibits"
			" MultiFinder context switching.",
		{55,258,71,274},
			"","plainDBox",NotSet,"",
		{55,360,71,376},
			"","altDBoxProc",NotSet,"",
		{115,54,131,70},
			"","noGrowDocProc",NotSet,"",
		{115,156,131,172},
			"","zoomDocProc",NotSet,"",
		{115,258,131,274},
			"","zoomNoGrow",NotSet,"",
		{115,360,131,376},
			"","rDocProc",NotSet,""
		}},
	/* Item 2 */
	NotDependent{}, RadioButtons {{
		{140,100,156,210},
			"Has Close Box","-goAway",NotSet,
			"Window has a close box.",
		{140,280,156,390},
			"No Close Box","-NoGoAway",NotSet,
			"Window does not have a close box."
		}},
	/* Item 3 */
	NotDependent {}, Box {
		gray, 
		{135,80,160,400} },
	/* Item 4 */
	NotDependent {}, TextTitle {
		plain,
		{56,71,70,137},
		3,9,
		"documentProc" },
	NotDependent {}, TextTitle {
		plain,
		{56,173,70,234},
		3,9,
		"dBoxProc" },
	NotDependent {}, TextTitle {
		plain,
		{56,275,70,336},
		3,9,
		"plainDBox" },
	NotDependent {}, TextTitle {
		plain,
		{56,377,70,438},
		3,9,
		"altDBoxProc" },
	NotDependent {}, TextTitle {
		plain,
		{116,71,130,150},
		3,9,
		"noGrowDocProc" },
	NotDependent {}, TextTitle {
		plain,
		{116,173,130,234},
		3,9,
		"zoomDocProc" },
	NotDependent {}, TextTitle {
		plain,
		{116,275,130,336},
		3,9,
		"zoomNoGrow" },
	NotDependent {}, TextTitle {
		plain,
		{116,377,130,438},
		3,9,
		"rDocProc" },
	NotDependent {}, PictOrIcon {
		Icon, 200, {20,70,52,102} },
	NotDependent {}, PictOrIcon {
		Icon, 201, {20,172,52,204} },
	NotDependent {}, PictOrIcon {
		Icon, 202, {20,274,52,306} },
	NotDependent {}, PictOrIcon {
		Icon, 203, {20,376,52,408} },
	
	NotDependent {}, PictOrIcon {
		Icon, 204, {80,70,112,102} },
	NotDependent {}, PictOrIcon {
		Icon, 205, {80,172,112,204} },
	NotDependent {}, PictOrIcon {
		Icon, 206, {80,274,112,306} },
	NotDependent {}, PictOrIcon {
		Icon, 207, {80,376,112,408} },
	},
}
}; 


resource 'ICON' (200, "documentProc") {
	$"FFFF FFFF 8000 0001 BEFF FFF1 A200 0001"
	$"A2FF FFF1 A200 0001 BEFF FFF1 8000 0001"
	$"FFFF FFFF 8000 0041 8000 0001 8000 0041"
	$"8000 0001 8000 0041 8000 0001 8000 0041"
	$"8000 0001 8000 0041 8000 0001 8000 0041"
	$"8000 0001 8000 0041 8000 0001 8000 0041"
	$"8000 0001 D555 5555 8000 0001 8000 0041"
	$"8000 0001 8000 0041 8000 0001 FFFF FFFF"
};

resource 'ICON' (201, "dBoxProc") {
	$"FFFF FFFF 8000 0001 8000 0001 9FFF FFF9"
	$"9FFF FFF9 9800 0019 9800 0019 9800 0019"
	$"9800 0019 9800 0019 9800 0019 9800 0019"
	$"9800 0019 9800 0019 9800 0019 9800 0019"
	$"9800 0019 9800 0019 9800 0019 9800 0019"
	$"9800 0019 9800 0019 9800 0019 9800 0019"
	$"9800 0019 9800 0019 9800 0019 9FFF FFF9"
	$"9FFF FFF9 8000 0001 8000 0001 FFFF FFFF"
};

resource 'ICON' (202, "PlainDBox") {
	$"FFFF FFFF 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 FFFF FFFF"
};

resource 'ICON' (203, "AltDBoxProc") {
	$"FFFF FFFE 8000 0003 8000 0003 8000 0003"
	$"8000 0003 8000 0003 8000 0003 8000 0003"
	$"8000 0003 8000 0003 8000 0003 8000 0003"
	$"8000 0003 8000 0003 8000 0003 8000 0003"
	$"8000 0003 8000 0003 8000 0003 8000 0003"
	$"8000 0003 8000 0003 8000 0003 8000 0003"
	$"8000 0003 8000 0003 8000 0003 8000 0003"
	$"8000 0003 8000 0003 FFFF FFFF 3FFF FFFF"
};

resource 'ICON' (204, "noGrowDocProc") {
	$"FFFF FFFF 8000 0001 BEFF FFF1 A200 0001"
	$"A2FF FFF1 A200 0001 BEFF FFF1 8000 0001"
	$"FFFF FFFF 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 FFFF FFFF"
};

resource 'ICON' (205, "zoomDocProc") {
	$"FFFF FFFF 8000 0001 BEFF FEF9 A200 0089"
	$"A2FF FE89 A200 0089 BEFF FEF9 8000 0001"
	$"FFFF FFFF 8000 0041 8000 0001 81FF 0041"
	$"8002 0001 8004 0041 8008 0001 8010 0041"
	$"8020 0001 8040 0041 8080 0001 81FF 0041"
	$"8000 0001 8000 0041 8000 0001 8000 0041"
	$"8000 0001 D555 5555 8000 0001 8000 0041"
	$"8000 0001 8000 0041 8000 0001 FFFF FFFF"
};

resource 'ICON' (206, "zoomNoGrow") {
	$"FFFF FFFF 8000 0001 BEFF FEF9 A200 0089"
	$"A2FF FE89 A200 0089 BEFF FEF9 8000 0001"
	$"FFFF FFFF 8000 0001 8000 0001 8000 0001"
	$"8000 0001 803F F001 8000 2001 8000 4001"
	$"8000 8001 8001 0001 8002 0001 8004 0001"
	$"8008 0001 8010 0001 803F F001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 FFFF FFFF"
};

resource 'ICON' (207, "rDocProc") {
	$"0FFF FFF0 3FFF FFFC 707F FFFE 777F FFFE"
	$"F77F FFFF F77F FFFF F07F FFFF FFFF FFFF"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"4000 0002 4000 0002 3000 000C 0FFF FFF0"
};
