/* File RezC.FREF.Cmdo.R */
/* Rez input for the Rezc.FREF Commando interface */
/* W. Powell 1988 */

/* Rez definitions for Rez-building Commando interfaces */
#include "Cmdo.R"

Resource 'cmdo' (200) {
	{ 240,
	"Rezc.FREF produces Rez input for a File Ref resource"
	" for Finder icons.",
	{
/* This include file has a standard arrangement of items
 *   common to all resources: ID#, attributes, name, 
 * 	 and redirection of output from the Rezc. script		*/
#include "CmdoReztStart.R"

	/* Item 6 */
	OR {{1}}, RegularEntry {
		"File Type",
		{80,60,96,120},
		{80,125,96,175},
		"",keepCase,"",
		"File type for this icon (4 characters)" },
	/* Item 7 */
	OR {{1}}, RegularEntry {
		"Icon Local ID",
		{80,275,96,365},
		{80,370,96,420},
		"",keepCase,"",
		"Local ID, as defined in BNDL resource, of the "
		"ICN# resource for the file." },
	/* Item 8 */
	OR {{1}}, RegularEntry {
		"File Name",
		{110,30,126,100},
		{110,105,126,450},
		"",keepCase,"-file",
		"Particular file name using this icon (optional)" },
	/* Item 9 */
	AND {{6,7}}, DoItButton {}, 
	}, 
/* Dialog 2 */
/* Include the standard resource attributes dialog */
#include "CmdoReztAttr.R"

/* Dialog 3 */
/* Include a redirection dialog */
#include "CmdoReztRdir.R"

}
};