/* File RezC.MENU.Cmdo.R */ 
/* Commando interface to build MENU Rez input */
/* W. Powell 1988 */

/* Rez definitions for Rez-building Commando interfaces */
#include "Types.R"
#include "Cmdo.R"

Resource 'cmdo' (200) {
	{ 265,
	"RezC.MENU produces Rez input for a Menu resource.\n"
	"NOTE: Input of menu items continues in subsequent dialogs.",
	{
/* This include file has a standard arrangement of items
 *   common to all resources: ID#, attributes, name, 
 * 	 and redirection of output from the Rezc. script		*/
#include "CmdoReztStart.R"

/* other items particular to this case */	
	/* Item 6 */
	OR {{1}}, RadioButtons {{
		{132,160,148,235},
			"Enabled","enabled",NotSet,"Entire menu is enabled.",
		{132,250,148,325},
			"Disabled","disabled",NotSet,"Entire menu is disabled."
		}},
	/* Item 7 */
	AND {{1,-8}}, RegularEntry {
		"Menu Title:",
		{85,30,101,110},
		{85,115,101,330},
		"",keepCase,"",
		"Title for menu.\nClick the apple for DA menu." },
	/* Item 8 */
	OR {{1}}, CheckOption {
		NotSet, {85,340,101,440},
		"","apple","Click here to get apple DA menu." },
	/* Item 9 */
	OR {{1}}, RegularEntry {
		"Proc ID#:",
		{112,45,128,105},
		{112,115,128,235},
		"",keepCase,"",
		"Menu Definition Proc ID # of this menu.\nNOTE:"
		" Enter nothing to get default text menus." },
	/* Item 10 */
	OR {{-9}}, RadioButtons {{
		{40,1000,41,1001},
		"","textMenuProc",NotSet,"" }},
	/* Item 11 */
	OR {{7,8}}, DoItButton {},
	/* Item 11 */
	OR { {1} }, TextTitle {
		plain, {132,50,148,155},
		systemFont, systemSize,
		"Entire menu is:" },
	}, 
/* Dialog 2 */
/* Include the standard resource attributes dialog */
#include "CmdoReztAttr.R"

/* Dialog 3 */
/* Include a redirection dialog */
#include "CmdoReztRdir.R"

}
}; 

/* End File RezC.MENU.Cmdo.R */

