/* File RezC.MENU1.more.Cmdo.R */ 
/* Commando interface to build MENU Rez input */
/* W. Powell 1988 */

/* Rez definitions for Rez-building Commando interfaces */
#include "Types.R"
#include "Cmdo.R"

Resource 'cmdo' (200) {
	{ 295,
	"RezC.MENU1 produces Rez input for one item in a "
	"MENU resource.\n"
	"NOTE: Input of menu items continues in subsequent dialogs.",
	{
/* other items particular to this case */	
	/* Item 1 */
	OR {{-((3<<12)+16)}}, RegularEntry {
		"Item Text:",
		{25,30,41,110},
		{25,115,41,430},
		"",keepCase,"",
		"Text of menu item." },
	/* Item 2 */
	OR {{1}}, RegularEntry {
		"Icon #",
		{50,40,66,90},{69,40,85,90},
		"",keepCase,"-icon",
		"Index number for icon.\nIndex=[ICONID#]-256" },
	/* Item 3 */
	AND {{1,-4}}, RegularEntry {
		"-Key",
		{50,130,66,180},{69,130,85,180},
		"",keepCase,"-key",
		"Command key equivalent." },
	/* Item 4 */
	OR {{1}}, CheckOption {
		NotSet,{125,80,141,220},
		"Hierarchical Menu","hierarchicalMenu",
		"Check here if item is a hierarchical menu."} ; 
		
	/* Item 5 */
	AND {{1,-6,-4}}, RegularEntry {
		"Mark",
		{50,220,66,270},{69,220,85,270},
		"",keepCase,"-mark",
		"Mark the item with this character.\nClick the "
		"Check item to mark with a check." }, 
	/* Item 6 */
	AND {{1,-4}}, CheckOption {
		NotSet,{90,215,106,277},
		"Check","-mark check","Mark item with check." }, 
	/* Item 7 */
	OR {{4}}, RegularEntry {
		"SubMenu ID:",
		{125,250,141,350},
		{125,355,141,405},
		"",keepCase,"-sub",
		"Resource ID of Hierarchical submenu." }, 
	/* Item 8 */
	OR {{1}}, NestedDialog {
		2,	/* Dialog number */
		{57,303,75,353},
		"Style" ,
		"Select type style for items text."},
	/* Item 9 */
	OR {{1}}, RadioButtons {{
		{67,380,83,455},
			"Enabled","enabled",NotSet,"Menu item is initially enabled.",
		{83,380,99,455},
			"Disabled","disabled",NotSet,"Menu item is initially disabled."
		}},
	/* Item 10 */ 
	NotDependent {}, TextBox {
		gray, {57,375,104,460},"Item is:" },
	/* Item 11 */
	AND {{4,7}}, Dummy {}, 
	/* Item 12 */ 
	OR {{-4,11}}, Dummy {},
	/* Item 13 */
	AND { {1,12} }, Dummy {},
	/* Item 14 */
	OR {{13,(3<<12)+16}}, DoItButton {}, 
	/* Item 15 */
	NotDependent {}, Box {
		gray, {117,45,149,435} }, 
	/* Item 16 */
	NotDependent {}, RadioButtons {{
		{162,105,178,160},
			"More items","-OK",NotSet,
			"Continue prompting for items with more dialogs.",
		{162,185,178,270},
			"Last item","-LAST",NotSet,
			"This is the last item on the menu.  "
			"Dont need to prompt for more.",
		{162,295,178,345},
			"Done","-DONE",NotSet,
			"Previous string was the last.  Ignore any "
			"input in this dialog." 
		}},
	/* Item 17 */
	NotDependent {}, Box {
		black, {159,90,181,390} },
	
	}, 
/* Dialog 2 */
	205,
	"Text style for menu item.",
	{
	/* Item 1 is hidden */
	AND {{-3,-4,-5,-6,-7,-8,-9}}, RadioButtons {{ 
		{30,1000,50,1001},
			"","plain",NotSet,"" }}, 
	/* Item 2 */
	NotDependent {}, CheckOption {
		Set,{20,100,36,200},
		"Plain","",""},
	OR {{-2}}, CheckOption {
		NotSet,{36,100,52,200},
		"Bold","+ bold",""},
	OR {{-2}}, CheckOption {
		NotSet,{52,100,68,200},
		"Italic","+ italic",""},
	OR {{-2}}, CheckOption {
		NotSet,{68,100,84,200},
		"Underline","+ underline",""},
		
	OR {{-2}}, CheckOption {
		NotSet,{20,280,36,380},
		"Outline","+ outline",""},
	OR {{-2}}, CheckOption {
		NotSet,{36,280,52,380},
		"Shadow","+ shadow",""},
	OR {{-2}}, CheckOption {
		NotSet,{52,280,68,380},
		"Condense","+ condense",""},
	OR {{-2}}, CheckOption {
		NotSet,{68,280,84,380},
		"Extend","+ extend",""},
	}, 
}
}; 

/* End File RezC.MENU1.more.Cmdo.R */

