/* File RezC.SIZE.Cmdo.R */
/* Rez input for the Rezc.SIZE Commando interface */
/* W. Powell 1988 */

/* Rez definitions for Rez-building Commando interfaces */
#include "Cmdo.R"

Resource 'cmdo' (200) {
	{ 280,
	"Rezc.SIZE produces Rez input for a SIZE resource.\nSIZE "
	"-1 is used by MultiFinder/Switcher.",
	{
/* This include file has a standard arrangement of items
 *   common to all resources: ID#, attributes, name, 
 * 	 and redirection of output from the Rezc. script		*/
#include "CmdoReztStart.R"

	/* Item 6 */
	OR {{1}}, RegularEntry {
		"Preferred Kb",
		{120,30,136,150},
		{120,155,136,220},
		"",keepCase,"",
		"Best memory size for program.\nNOTE: Excludes the "
		"32K Switcher overhead." },
	/* Item 7 */
	OR {{1}}, RegularEntry {
		"Minimum Kb",
		{151,30,167,150},
		{151,155,167,220},
		"",keepCase,"",
		"Minimum memory size for program.\nNOTE: Excludes the "
		"32K Switcher overhead." },
	/* Item 8 */
	OR {{1}}, CheckOption {
		Set,{93,30,109,135},
		"MultiFinder","","Set up for MultiFinder." },
	/* Item 9 */
	OR {{1}}, CheckOption {
		NotSet,{93,140,109,220},
		"Switcher","","Set up for Switcher." },
	/* Item 10 */
	OR {{8,9}}, Dummy {},
	/* Item 11 */
	OR {{9}}, CheckOption {
		NotSet, {80,260,96,465},
		"Save Screen","saveScreen",
		"Save screen contents before switching to minimize "
		"waiting for window updates." },
	/* Item 12 */
	OR {{-11}}, RadioButtons {{
		{40,1000,41,1001},
		"","dontSaveScreen",NotSet,"" }},
	/* Item 13 */
	OR {{8,9}}, CheckOption {
		NotSet, {96,260,112,465},
		"Accept Suspend/Resume","acceptSuspendResumeEvents",
		"Program accepts and uses Suspend/Resume events to "
		"prepare for switching." },
	/* Item 14 */
	OR {{-13}}, RadioButtons {{
		{40,1000,41,1001},
		"","ignoreSuspendResumeEvents",NotSet, "" }},
	/* Item 15 */
	OR {{9}}, CheckOption {
		NotSet,{112,260,128,465},
		"Enable Option Switch","enableOptionSwitch",
		"Flag not defined in Inside Switcher document" },
	/* Item 16 */
	OR {{-15}}, RadioButtons { {
		{40,1000,41,1001},
		"","disableOptionSwitch",NotSet, "" }},
	/* Item 17 */
	OR {{8}}, CheckOption {
		NotSet, {128,260,144,465},
		"Works in Background","canBackground",
		"Program performs some tasks in background, so "
		"needs background null events." },
	/* Item 18 */
	OR {{-17}}, RadioButtons { {
		{40,1000,41,1001},
		"","cannotBackground",NotSet, "" }},
	/* Item 19 */
	OR {{8}}, CheckOption {
		NotSet, {144,260,161,465},
		"MultiFinder Aware","doOwnActivate",
		"Program activates/deactivates windows for switching "
		"when suspend/resume events have been received.  "
		"Otherwise, will use Switcher-style DA scrap coercion."
		},
	/* Item 20 */
	OR {{-19}}, RadioButtons { {
		{40,1000, 41,1001},
		"","dontDoOwnActivate",NotSet, "" }},
	/* Item 21 */
	AND {{6,7,10}}, DoItButton {}, 
	/* Item 22 */
	NotDependent {}, TextBox {
		gray, {85,25,112,225},
		"Set for" }, 
		
	}, 
/* Dialog 2 */
/* Include the standard resource attributes dialog */
#include "CmdoReztAttr.R"

/* Dialog 3 */
/* Include a redirection dialog */
#include "CmdoReztRdir.R"

}
};