/********************************/
/* HyperUtils.H					*/
/* 								*/
/* Header file for HyperUtils.c	*/
/* routines...					*/
/* 								*/
/********************************/

#define		UPFRONT		-1L
#define		SPACE		32
#define		SYS_RES		0			/*** resource id of the system 	***/

#ifndef NIL        					/*** standard definition of NIL	***/
	#define NIL ( (void *)0 )
#endif

#ifndef empty        				/*** an alias for nil			***/
	#define empty ( (void *)0 )
#endif


#define isUpper( c ) ( (c >= 'A' && c <= 'Z') ? 1 : 0 )
#define isLower( c ) ( (c >= 'a' && c <= 'z') ? 1 : 0 )
#define	toUpper( c ) ( (isLower( c )) ? c - 'a' + 'A': c )
#define toLower( c ) ( (isUpper( c )) ? c + 'a' - 'A': c )
#define isAlpha( c ) ( ((c >= 'A' && c <= 'Z') || (c >= 'a' && c <= 'z')) ? 1 : 0 )

#ifdef UsingHypercard
void	paramtoPString( XCmdBlockPtr paramPtr, short i, char *n);
long 	paramtoNum();
Handle 	NumToParam( XCmdBlockPtr paramPtr, long num );
#endif

void	*sys_alloc( long len );
short	validHandle( void *h );
void	TrashHandle( Handle h );
Handle	NewSysHandle( long len );
Handle	GetSystemResource( ResType typ, short id );
void	RemoveSystemResource( Handle h );
void	AddSystemResource( Handle h, ResType typ, short id, char *name );


void	appendChar( char *theStr, char	theChar );
void 	CopyStrToHandle( char *theStr, Handle hand );
void	CopyDataToHandle( char *theData, long theLen, Handle theHand, char delim );
char	*CopyAscii( char *outStr, char	theChar );
void	AppendCharToHandle( Handle theHand, char theChar );

short	pStrToField( char *str, char delim, Handle list );
void	DataToField( char *str,	short len, char delim, Handle list );

void 	ClimbTree( long child, CInfoPBPtr cpb, char *fullName );
void	CenterWindow( WindowPtr wptr );
void 	Concat( char * str1, char * str2 );
void	CopyPStr( char * pStr1, char * pStr2 );
short	GetFileNameToOpen(SFTypeList typs,short typcnt, char *theName, short *theWDID);
OSErr	CopyFile( char *inFile, short inWD, char *outFile, short outWD );

Handle	ErrorReturn( OSErr theErr );

