(******************************************************)
(*													  *)
(*	file:  Pen.m									  *)
(*													  *)
(*	Pen methods - see definition module for			  *)
(*	descriptions.									  *)
(*													  *)
(*	Written in SemperSoft Modula-2 v.1.1.2			  *)
(*													  *)
(*	Allen Stenger	August 1989  					  *)
(*													  *)
(******************************************************)

IMPLEMENTATION MODULE Pen;

FROM Terminal	IMPORT ClearScreen;
FROM InOut		IMPORT Write;
FROM MathLib0 	IMPORT sin, cos, entier, real, pi;
FROM InsideMac	IMPORT Line, MoveTo, PenSize;

CONST
	DegreesToRadians = pi / 180.;	
							(* conversion factor *)

VAR
	currentDegrees	:	[0..359];	
							(* direction we are
							facing -- 0 = right. *)

PROCEDURE Go( distance : CARDINAL );
VAR
	currentRadians	:	REAL;
	realDistance	:	REAL;
BEGIN
	currentRadians := DegreesToRadians 
						* real( currentDegrees );
	realDistance := real( distance );
	Line( 	entier( realDistance 
						* cos( currentRadians ) ),
			entier( realDistance 
						* sin( currentRadians ) )
		);
END Go;

PROCEDURE Turn( degrees : INTEGER );
VAR
	tempDegrees	:	INTEGER; 
BEGIN
	tempDegrees := INTEGER(currentDegrees) + degrees;
	DEC( tempDegrees, 360 * ( tempDegrees DIV 360 ) );
	IF tempDegrees < 0 
	THEN INC( tempDegrees, 360 );
	END; (* IF *)
	currentDegrees := tempDegrees;
END Turn;

PROCEDURE Home;
BEGIN
	MoveTo( 110, 200 );
	currentDegrees := 270; (* facing up *)
END Home;

BEGIN
	ClearScreen;
	Write( 0C );	(* graphics initialization kludge *)
	PenSize( 4, 4 );
END Pen.