(******************************************************)
(*													  *)
(*	file:  Pen.m									  *)
(*													  *)
(*	Pen methods - see definition module for			  *)
(*	descriptions.									  *)
(*													  *)
(*	This version contains improvements suggested by	  *)
(*	running MPW performance analysis tools.			  *)
(*													  *)
(*	Written in SemperSoft Modula-2 v.1.1.2			  *)
(*													  *)
(*	Allen Stenger	August 1989  					  *)
(*													  *)
(******************************************************)

IMPLEMENTATION MODULE Pen;

FROM Terminal	IMPORT ClearScreen;
FROM InOut		IMPORT Write;
FROM InsideMac 	IMPORT FillRect, SetRect;
FROM InsideMac 	IMPORT black, Rect;

VAR
	currentDegrees	:	[0..359];	
							(* direction we are
							facing -- 0 = right. *)
	currentH,
	currentV		:	CARDINAL;	(* where situated *)
	
PROCEDURE Go( distance : CARDINAL );
CONST
	LineSize 	=	4;
VAR
	lineRect	:	Rect;
BEGIN
	CASE currentDegrees OF
		0:		SetRect( lineRect, currentH, currentV, 
						currentH + distance + LineSize,
						currentV + LineSize ); 
				INC( currentH, distance );	|
		90:		SetRect( lineRect, currentH, currentV, 
						currentH + LineSize,
						currentV + distance + LineSize
						); 
				INC( currentV, distance );	|
		180:	SetRect( lineRect, currentH - distance,
						currentV, 
						currentH + LineSize,
						currentV + LineSize ); 
				DEC( currentH, distance );	|
		270:	SetRect( lineRect, currentH, 
						currentV - distance, 
						currentH + LineSize,
						currentV + LineSize ); 
				DEC( currentV, distance );	
	END; (* CASE *)
	FillRect( lineRect, black );
END Go;

PROCEDURE Turn( degrees : INTEGER );
VAR
	tempDegrees	:	INTEGER; 
BEGIN
	tempDegrees := INTEGER(currentDegrees) + degrees;
	DEC( tempDegrees, 360 * ( tempDegrees DIV 360 ) );
	IF tempDegrees < 0 
	THEN INC( tempDegrees, 360 );
	END; (* IF *)
	currentDegrees := tempDegrees;
END Turn;

PROCEDURE Home;
BEGIN
	currentH := 110;
	currentV := 200;
	currentDegrees := 270; (* facing up *)
END Home;

BEGIN
	ClearScreen;
	Write( 0C );	(* graphics initialization kludge *)
END Pen.