/********************************************************************/
/*																	*/
/*	Source  - RoundVBL.c											*/
/*	Author  - Alexander S. Colwell, Copyright (C) 1988				*/
/*																	*/
/*	Purpose - This is VBL definition for "Debugger" DA's demo.		*/
/*																	*/
/*	Routine - Main : Main entry point module.						*/
/*																	*/
/*	Revisions - None.												*/
/*																	*/
/********************************************************************/

#include <VRetraceMgr.h>			/* Vertical Retrace Manager defs*/
#include <SetupA4.h>				/* Setup Register A4 defs		*/
#include "Debugger.h"				/* Debugger defs				*/

typedef struct {					/* VBL data structure			*/
	VBLTask	vblTask;				/* VBL							*/
	DBGHDL	dbgHdl;					/* Debugger handler				*/
	short	counter;				/* Tick counter					*/
	} VBL;
typedef VBL	*VBLPTR;

main()

	{
	
		register VBLPTR	vblPtr;		/* Working VBL data block		*/
		
		asm { MOVE.L d0,vblPtr };	/* Move to vblPtr				*/
		
		RememberA0();				/* Remember global pointer		*/
		
		SetUpA4();					/* Setup register A4			*/
		
									/* Output entry message			*/
		DbgBufPrint(vblPtr->dbgHdl,"VBL: entry\n");
		
									/* Reset timer					*/
		vblPtr->vblTask.vblCount = vblPtr->counter;	
		
		RestoreA4();				/* Restore register A4			*/
		
	}
