/****
 * CDataPane.h
 *
 *
 ****/

#define _H_CDataPane			/* Include this file only once */
#include <CPanorama.h>
#include "CHeapInfo.h"

struct CDataPane : CPanorama {

									/** Contruction/Destruction **/
	void		IDataPane(CView *anEnclosure, CBureaucrat *aSupervisor,
							short aWidth, short aHeight,
							short aHEncl, short aVEncl,
							SizingOption aHSizing, SizingOption aVSizing);

									/** Drawing **/
	void		Draw(Rect *area);
	void		WriteWindow (heapEntry block);
	void		WriteGrafPort (heapEntry block);
	void		WriteControl (heapEntry block);
	void		WriteMenu (heapEntry block);
	void		WriteMenuList (heapEntry block);
	void		WriteResMap (heapEntry block, Rect *area);
	void		WritePString (heapEntry block);
	void		WriteCString (heapEntry block);
	void		WriteStringList (heapEntry block, Rect *area);
	void		WriteMPtrBlock (heapEntry block, Rect *area);
	void		WriteByte (heapEntry block, Rect *area);
	void		SetPaneSize (void);
};

typedef struct ResourceMap
{
	char		resHeader[16];
	long		nextResMap;
	int			fileRefNum;
	int			attrs;
	int			typeListOffset;
	int			nameListOffset;
}
ResourceMap;

typedef struct ResTypeDef
{
	ResType		resourceType;
	int			totalResources;
	int			refListOffset;
}
ResTypeDef;

typedef struct ResourceTypeList
{
	int			totalTypes;
	ResTypeDef	typeDef[];
}
ResourceTypeList;

typedef struct ResourceRefList
{
	int			resourceID;
	int			nameOffset;
	long		refData;
	long		dataHandle;
}
ResourceRefList;
