#include "CHeaderPane.h"
#include "CHeapInfo.h"
#include <DPMUtilities.h>

extern CHeapInfo	*gHeap;

#define TAB1		100
#define TAB2		250
#define TAB3		360
#define TAB4		395

#define LINE1		12
#define LINE2		24
#define LINE3		36

/****************************************/
/*		IHeaderPane						*/
/****************************************/

void CHeaderPane::IHeaderPane (CView *anEnclosure, CBureaucrat *aSupervisor,
							short aWidth, short aHeight,
							short aHEncl, short aVEncl,
							SizingOption aHSizing, SizingOption aVSizing)
{
	CPane::IPane (anEnclosure, aSupervisor, aWidth, aHeight,
							aHEncl, aVEncl, aHSizing, aVSizing);
}

/****************************************/
/*		Draw							*/
/****************************************/

void CHeaderPane::Draw (Rect *area)

{
	THz				zonePtr;
	blkHdr			*hdrPtr;
	FontInfo		info;
	int				lineHeight;
	heapHdr			heapHeader;
	
	TextFont (geneva);
	TextSize (9);
	
	if (gHeap->GetHeapZone () == 0)
		zonePtr = SystemZone ();
	else
		zonePtr = GetZone ();
		
	hdrPtr = (blkHdr*) &zonePtr->heapData;
	
	heapHeader = gHeap->GetHeader ();
/*
 * Underline the pane
*/
	PenSize (2, 2);
	MoveTo (0, height - 2);
	LineTo (width, height - 2);
	PenSize (1, 1);		/* is this necessary? */
/*
 * Column 1
*/
	Write (TAB1, LINE1, "Current heap zone :", 0, 0);
	WriteAddress ((Ptr)heapHeader.zonePtr, 6, 0);
	Write (TAB1, LINE2, "Zone start :", 0, 0);
	WriteAddress ((Ptr)hdrPtr, 6, 0);
	Write (TAB1, LINE3, "Zone end :", 0, 0);
	WriteAddress ((Ptr)heapHeader.lastUsed, 6, 0);
/*
 * Column 2
*/
	Write (TAB2, LINE1, "Total blocks :", heapHeader.totalBlocks, 8);
	Write (TAB2, LINE2, "Total bytes :", heapHeader.totalBUsed, 8);
	Write (TAB2, LINE3, "Identified blocks :", heapHeader.totalKnown, 8);
/*
 * Column 3
*/
	Write (TAB3, LINE1, "Free :", heapHeader.totalFree, 4);
	Write (TAB3, LINE2, "NonRel :", heapHeader.totalNonRel, 4);
	Write (TAB3, LINE3, "Rel :", heapHeader.totalRel, 4);
/*
 * Column 4
*/
	Write (TAB4, LINE1, ":", heapHeader.totalFreeBytes, 7);
	Write (TAB4, LINE2, ":", heapHeader.totalNonRelBytes, 7);
	Write (TAB4, LINE3, ":", heapHeader.totalRelBytes, 7);
}
