#include <CBartender.h>
#include <Commands.h>
#include <Constants.h>
#include "CHeapListerApp.h"
#include "CHeapListerDoc.h"

extern	OSType		gSignature;
extern	CBartender	*gBartender;

/****************************************/
/*		IHeapListerApp					*/
/****************************************/

void CHeapListerApp::IHeapListerApp (void)

{
	CApplication::IApplication(4, 20480L, 2048L);
}

/****************************************/
/*		SetUpFileParameters				*/
/****************************************/

void CHeapListerApp::SetUpFileParameters (void)

{
	inherited::SetUpFileParameters();

	sfNumTypes = 1;
	sfFileTypes[0] = 'TEXT';

	gSignature = '*DPM';
}

/****************************************/
/*		DoCommand						*/
/****************************************/
 
void CHeapListerApp::DoCommand (long theCommand)
{
	switch (theCommand) {
	
		case cmdAbout:
					ParamText ("\pHeapLister application - ",
								"\pwritten by Denis Molony ",
								"\pusing the Think Class Library",
								"\p (March 1990)");
					Alert (ALRTgeneral, NULL);
					break;
	
		default:	inherited::DoCommand(theCommand);
					break;
	}
}

/****************************************/
/*		SetUpMenus						*/
/****************************************/

void CHeapListerApp::SetUpMenus ()
{
	inherited::SetUpMenus ();
	gBartender->SetUnchecking (21, TRUE);
	gBartender->SetUnchecking (22, TRUE);
	gBartender->SetUnchecking (23, TRUE);
}

/****************************************/
/*		UpdateMenus						*/
/****************************************/

void CHeapListerApp::UpdateMenus ()
{
	inherited::UpdateMenus ();
	gBartender->DisableCmd (cmdOpen);
}

/****************************************/
/*		CreateDocument					*/
/****************************************/

void CHeapListerApp::CreateDocument ()

{
	CHeapListerDoc	*theDocument;
	
	theDocument = new(CHeapListerDoc);
	theDocument->IHeapListerDoc(this, TRUE);
	theDocument->NewFile();
}
