#include "Neural Network.h"
#include <math.h>

extern FILE * Jac;

extern NeuralNet *	theNet;
extern DTypeVector 	yData;
extern DTypeMatrix	XData;
extern DTypeVector 	Alpha[];
extern DTypeVector	Pi;
extern DTypeVector	Diag;

/*-----------------------
	Restore the weight parameters in vector Pi to W[i] for use in line search algorithm.
*/
RestoreParms(vec)
	DTypeVector * vec;
{
	int j,k,N;
	DataType * v;
	DataType * w;
	
	v = *vec->cells;
	for(j=0; j<theNet->OutLayer; j++)
	{	N = (theNet->W[j].rows)*(theNet->W[j].cols);
		w = *theNet->W[j].cells;
		for(k=0; k<N; k++, w++, v++)
			*w = *v;
	}
}	

/*-----------------------
	Save the weight parameters in vector Pi for use in line search algorithm.
*/
SaveParms(vec)
	DTypeVector * vec;
{
	int j,k,N;
	DataType * v;
	DataType * w;
	
	v = *vec->cells;
	for(j=0; j<theNet->OutLayer; j++)
	{	N = (theNet->W[j].rows)*(theNet->W[j].cols);
		w = *theNet->W[j].cells;
		for(k=0; k<N; k++, w++, v++)
			*v = *w;
	}
}	

NotYetAvail()
{
	printf("chosen method not yet available") , ExitToShell();
}

HandleOutOfMem()
{
	printf("Out of memory") , ExitToShell();
}
