#include "Neural Network.h"
#include <math.h>

extern DTypeVector 	yData;
extern DTypeMatrix	XData;
extern DTypeVector	Alpha[];

SetTestNet(net)		/* setup specification for test network */
	NeuralNet * net;
{	
	net->OutLayer = 2;	/* default network must have 2 layers		*/
	
	net->Units[0] = 3;	/* number of input units, must have at least two */
	net->Units[1] = 2;		
	net->Units[2] = 1;	/* must be single output unit for Compute_SS function	*/
	
	net->method = GaussNew;
	net->maxstep = 1.0;
	
}

testData(net)
	NeuralNet * net;
{
	int	i,j,k,m;
	DataType * cell;
	DataType * ycell;
	int Obs = 16;
	int grid = 4;
	int Parms = net->Units[0];
	DataType data;
	
	AllotDTypeMatrix(&XData,Obs,net->Units[0]);
	AllotDTypeVector(&yData,Obs);

	HLock(XData.cells);
	HLock(yData.cells);	
	cell = *XData.cells;	
	ycell = *yData.cells;
	for(j=0; j<Obs; j++)
		*(cell + (j*XData.cols + 0)) = 1.0;
	for(j=0, k=1, m=0; j<Obs; j++, k++)
	{	if(k==Obs/grid+1) k=1;
		if(k==1) m += 1;
		*(cell + (j*XData.cols + 1)) = 10*m;
		*(cell + (j*XData.cols + 2)) = 10*k;
	}	
	for(j=0; j<Obs; j++)
		ycell[j] = pow(*(cell+(j*XData.cols+1)),.2)*pow(*(cell+(j*XData.cols+2)),.8);

	HUnlock(XData.cells);
	HUnlock(yData.cells);
}

