		iflist	0		; Do NOT list un-assembled
					;   statements [optional].


;***********************************************
; "LinkMacros.asm"
: -- Some macros to handle Procedures & Functions:
;
; Note: a "loc" clears ALL local parameters 
;       from memory and starts fresh.
;***********************************************


proc		macrox
		loc
		pframe
		endm
;--------------
; First, determine size of the result
; and THEN set up the parameter frame:
func		macrox	&1
		loc	
		
		dsec	0
.getSize	&1
		
		if	&&1 = "byte"
		byte			; Align to word boundary.	
		endi
		
		dend	.sizeResult
		
		pframe
.result		byte	.sizeResult
		endm
;--------------	
endParms	macrox
		endp	.parambytes
		endm
;--------------		
noParms		macrox
		endp	.parambytes
		endm
;--------------		
locals		macrox

		ifndef	.parambytes	; Just in case you forgot !!
		endParms
		endi
		
		lframe
		endm
;--------------	
endLocals	macrox
		endl	.localbytes
		endm
;--------------
noLocals	macrox
.localbytes	set	0
		endm
;--------------
enter		macrox

		ifndef	.parambytes	; Just in case you forgot !!
		endParms
		endi
		
		ifndef	.localbytes	; Just in case you forgot !!
		noLocals
		endi
		
		if	.parambytes <> 0 OR .localbytes <> 0 
		link	a6,#-.localbytes
		endi
		
		endm
;--------------
exit		macrox			; If a Function, result
					;   stays on the Stack !!
		
		if	.parambytes <> 0 OR .localbytes <> 0 
		unlk	a6
		endi
		
		ifndef	.sizeResult	; a PROCEDURE.
.sizeResult	set	0
		endi
		
		if	.parambytes <> 0
		move.l	(sp)+,a0
		addi.l	#.parambytes-.sizeResult,sp
		jmp	(a0)
		else
		rts
		endi
		
		endm

;***********************************************
; These allow calls to be structured as follows:
;***********************************************
;
;	aFunct	func	long
;	.var1	integer		; Optional stack variables go here.
;	.var2	var
;		endParms
;	
;		locals
;	.var3	boolean		; Optional local variables go here.
;	.var4	long
;		endLocals
;	
;      [On entry, do the link (if necessary).  Upon
; 	exit, unlink (if necessary) & then return.
;	The actual code, of course, goes inbetween.
;	IF the "bsr" call is to a Function, be sure
;	to "move" from (sp)+ to a location of your
;	choice AFTER you return from the "bsr" call.]
;
;		enter
;
;		exit
;
;***********************************************
;
;	aProc	proc
;		noParms		; Optional.
;		noLocals	; Optional.
;		
;		enter
;
;		exit
;
;***********************************************
;
;	Another	proc
;	.var1	handle
;	.var2	pointer
;		endParms
;
;		noLocals	; Optional.
;	
;		enter
;
;		exit
