{ ******************************************************** }
{ "rotGlobals.p"                                           }
{                                                          }
{ by John A. Love, III [ Washington Apple Pi Users' Group] }
{                                                          }
{ using Symantec's "THINK Lightspeed Pascal", v 3.00       }
{                                                          }
{ ******************************************************** }


UNIT rotGlobals;

INTERFACE

	USES
		Palettes;



{ --------------------- }
{   Global constants:   }
{ --------------------- }

	CONST

		CR = 13;                                  { General constants ... }
		Enter = 3;
		SP = ' ';
		Null = '';

		CurrentA5 = $904;                         { low-memory globals ... }
		GrayRgn = $9EE;                           { Handle to region drawn as desktop. }
		ROM85Loc = $28E;
		mBarHeightLoc = $BAA;

		AppleMenuID = 1001;                       { Specific constants ... }
		AboutItem = 1;
		AdisabledItem = 2;

		EditMenuID = 1002;
		UndoItem = 1;
		EdisabledItem = 2;
		CutItem = 3;
		CopyItem = 4;
		PasteItem = 5;
		ClearItem = 6;

		GraphicsMenuID = 1003;
		RotateItem = 1;
		DissolveItem = 2;
		GdisabledItem = 3;
		QuitItem = 4;

		monsterID = 128;                          { picFrame :=  25,202,297,476 }
		bwGigantorID = 129;                       {             221,213,377,527 }
		colorGigantorID = 130;                    {              61,177,213,491 }
		logoID = 131;                             {              54,126,251,540 }

		acurWorld = 128;                          { Rotating CURSors ... }
		acurDogCow = 129;

		mainWindowID = 128;
		horizScrollID = 128;                      { ... also, the CNTL's refCon. }
		vertScrollID = 129;
		growBoxSize = 15;
		scrollWidth = 16;                         { Samo-Samo }
		scrollHeight = 16;
  { ----- }
		logoWindowID = 129;

		pmWhite = 0;                              { Palette Manager stuff ... }
		pmBlack = 1;
		pmYellow = 2;
		pmMagenta = 3;
		pmRed = 4;
		pmCyan = 5;
		pmGreen = 6;
		pmBlue = 7;
		pmLtBlue = 8;
		pmLtGray = 9;

		IACScicnID = 128;
		HANDcrsrID = 129;

{ ------------------------------------------------------- }
{ ... for Error handling in my Off-screen map routine(s): }
{ ------------------------------------------------------- }

		NewPtrError = -10000;
		NewHdlError = -15000;
		CloneHdlError = -20000;
		MaxDevError = -25000;

{ ------------------ }
{ MultiFinder stuff: }
{ ------------------ }

		_WaitNextEvent = $A860;
		_Unimplemented = $A89F;
		SysEnvironsVersion = 1;

{ OSEvent is the event number of the suspend/resume and mouse-moved Events sent }
{ by MultiFinder.  Once you determine that an event is an OSEvent, look at the  }
{ High byte of the message sent with the event to determine which kind it is.   }
{ To differentiate between suspend & resume, look at the resumeMask bit.        }

		OSEvent = app4Evt;
		suspendResumeMessage = 1;
		mouseMovedMessage = $FA;
		resumeMask = 1;



{ ------------------------------------------ }
{                Global types:               }
{ ------------------------------------------ }

	TYPE

		RgnHandlePtr = ^RgnHandle;
		wordPtr = ^INTEGER;
		longPtr = ^LONGINT;
		BitMapPtr = ^BitMap;

		MyVBLType = RECORD
				CurrA5: LONGINT;                     { Lost & Found !! }
				MyVBL: VBLTask;                      { The actual VBL Task. }
			END;   { MyVBLType }

		acurType = RECORD                       { Poetry in motion !! }
				nbrCursors: INTEGER;
				frameCounter: INTEGER;
				cursorIDs: ARRAY[0..0] OF LONGINT;  { ... in High word. }
			END;   { acurType }
		acurPtr = ^acurType;
		acurHandle = ^acurPtr;

		WStatePtr = ^WStateData;                 { For zooming the window in }
		WStateHdl = ^WStatePtr;                  { response to a keypress.   }



{ ------------------------------ }
{  Any missing stuff goes here:  }
{ ------------------------------ }




{ --------------------- }
{   Global variables:   }
{ --------------------- }

	VAR

		screen: Rect;
		ROM: wordPtr;
		mBarHt: INTEGER;
		AppleMenu, EditMenu, GraphicsMenu: MenuHandle;
		aMac2: BOOLEAN;
		colorDepth: INTEGER;
		monsterPicHdl: PicHandle;
		fullPICTrect, windPICTrect: Rect;
		TheWindow: WindowPtr;
		windDef: INTEGER;                         { Variation Code }
		horizControl, vertControl: ControlHandle;
		Event: EventRecord;
		windowLoc: INTEGER;
		daWind, applWind: BOOLEAN;
		currEdit, currGraphics: BOOLEAN;
		myVBLRec: MyVBLType;
		acurHdl: Handle;
		CURS_ID0, nbrGlobe: INTEGER;
		Done, InWindow: BOOLEAN;
		WNE, InForeGround, justOpened, justBragging: BOOLEAN;
		Sleep, finalTicks: LONGINT;
		colorHandCrsr: CCrsrHandle;
		stillColorCrsr: BOOLEAN;
		CreateOffScreenError: OSErr;              { The usual off-screen stuff ... }
		oldDevice, myMaxDevice: GDHandle;
		offBitMapPtr, onScreenBitsPtr: BitMapPtr;
		myBits: Ptr;
		offGrafPort: GrafPort;
		offGrafPtr, onBWScreen: GrafPtr;
		offCGrafPort: CGrafPort;
		offCGrafPtr, onCScreen: CGrafPtr;
		ourCTHandle: CTabHandle;
		scrolledFullPICTrect: Rect;               { For scrolling. }
		zoomBackIn: Rect;                         { For zooming ... }
		nextState: INTEGER;
		stateHandle: WStateHdl;
		saveWindPICTrect, saveFullPICTrect, saveScrolledFullPICTrect: Rect;




IMPLEMENTATION

END.   { UNIT = rotGlobals }