{ ******************************************************** }
{ "rotInterface.p"                                         }
{                                                          }
{ by John A. Love, III [ Washington Apple Pi Users' Group] }
{                                                          }
{ using Symantec's "THINK Lightspeed Pascal", v 3.00       }
{                                                          }
{ ******************************************************** }


UNIT rotInterface;

INTERFACE



{ ----------------------}
{ Memory Manager stuff: }
{ ----------------------}

	FUNCTION NewClearHandle (logicalSize: Size): Handle;
	INLINE

{ The PASCAL-supplied interface is denoted with "***":                   }
{                                                                        }
{ ***            subq.w    #4,sp                                         }
{ ***            move.l    logicalSize,-(sp)                             }
{ $201F:         move.l    (sp)+,d0          ; Size                      }
{ $A322:         _NewHandle,clear                                        }
{ $31C00220:     move.w    d0,MemErr                                     }
{ $2E88:         move.l    a0,(sp)           ; FUNCTION result on Stack. }
{ ***            move.l    (sp)+,xxxx                                    }

		$201F, $A322, $31C0, $0220, $2E88;


	FUNCTION NewSysHandle (logicalSize: Size): Handle;
	INLINE
		$201F, $A522, $31C0, $0220, $2E88;


	FUNCTION NewSysClearHandle (logicalSize: Size): Handle;
	INLINE
		$201F, $A722, $31C0, $0220, $2E88;


	FUNCTION NewClearPtr (logicalSize: Size): Ptr;
	INLINE
		$201F, $A31E, $31C0, $0220, $2E88;


	FUNCTION NewSysPtr (logicalSize: Size): Ptr;
	INLINE
		$201F, $A51E, $31C0, $0220, $2E88;


	FUNCTION NewSysClearPtr (logicalSize: Size): Ptr;
	INLINE
		$201F, $A71E, $31C0, $0220, $2E88;



{ ------------------ }
{ Keeping A5 around: }
{ ------------------ }

	PROCEDURE PushA5;     { Push A5 onto the Stack. }
	INLINE
		$2F0D;               { MOVE.L A5,-(SP) }


	PROCEDURE PopA5;      { Pop the Stack into A5. }
	INLINE
		$2A5F;               { MOVE.L (SP)+,A5 }


{ Get the value of A5 we've stored before the parameter block and put it in A5. }
{ We know that when the VBL task is called, A0 will point to our parameter      }
{ block.  Therefore, the value of CurrentA5 that we stored will be at - 4(A0).  }

	PROCEDURE GetMyA5;
	INLINE
		$2A68, $FFFC;        { MOVE.L -4(A0),A5 }



{ -----------------------------------------------}
{ Assembly Language routines -> in "rotAsm.Lib": }
{ -----------------------------------------------}

	FUNCTION RotateBits (srcBits, dstBits: BitMap): OSErr;
	PROCEDURE DissBits (srcBits, dstBits: BitMap; srcRect, dstRect: Rect);



IMPLEMENTATION



	FUNCTION RotateBits (srcBits, dstBits: BitMap): OSErr;
	external;

	PROCEDURE DissBits (srcBits, dstBits: BitMap; srcRect, dstRect: Rect);
	external;



END.   { UNIT = rotInterface }