UNIT ToolWindows;

{$S Seg2}

INTERFACE

USES
	MemTypes, QuickDraw, OSIntf, ToolIntf, PackIntf;

CONST
	SystemKind = -1;
	ToolKind = 30000;
	AnyKind = 30001;

	Alone = 0;
	BeforeDialog = 1;
	BeforeSystem = 2;
	BeforeTool = 3;
	BeforeDocument = 4;
	BehindFrontSystem = 5;
	BetweenTools = 6;
	BehindTools = 7;
	BehindSystem = 8;
	BetweenDocuments = 9;

	DeactivFlag = 0;
	NoDrag = -32768;
	Invisible = False;
	PostPoneCalc = True;
	NormalCalc = False;

{--------------------------------------------------------------------}

TYPE
	WINDRecord = RECORD
			BoundsRect: Rect;
			ProcId: Integer;
			Visible: Boolean;
			Fillter1: Char;
			GoAwayFlag: Boolean;
			Filter2: Char;
			RefCon: LongInt;
			Title: Str255;
		END;
	WINDData = WINDRecord;
	WINDPtr = ^WINDRecord;
	WINDHandle = ^WINDPtr;

	WDEFRecord = RECORD
			Branch: Integer;
			Flags: Integer;
			Types: LongInt;
			ID: Integer;
			Version: Integer;
		END;
	WDEFHeader = WDEFRecord;
	WDEFPtr = ^WDEFRecord;
	WDEFHandle = ^WDEFPtr;

{--------------------------------------------------------------------}

VAR
	ToBeActivated, ToBeDeactivated, FrontToolWindow, BackToolWindow, FrontDocWindow: WindowPeek;
	InFront: Integer;

	FirstRgn, SecondRgn: RgnHandle;

	TheWorld: SysEnvRec;
	CurVersion: Integer;

{--------------------------------------------------------------------}


PROCEDURE FlushActivateEvents;
FUNCTION WindowExists (ThePWindow: WindowPeek): Boolean;
PROCEDURE TInitWindows;
FUNCTION TGetNewWindow (WindowKind, WindowID: Integer; WStorage: Ptr; Behind: WindowPtr): WindowPtr;
FUNCTION TNewWindow (WindowKind: Integer; WStorage: Ptr; boundsRect: Rect; title: Str255; visible: Boolean; procID: Integer; behind: WindowPtr; goAwayFlag: Boolean; refCon: LongInt): WindowPtr;
PROCEDURE TCloseWindow (TheWindow: WindowPtr);
PROCEDURE TDisposeWindow (TheWindow: WindowPtr);
PROCEDURE TDisposDialog (TheWindow: WindowPtr);
PROCEDURE TSelectWindow (TheWindow: WindowPtr);
PROCEDURE THideWindow (TheWindow: WindowPtr);
PROCEDURE TShowWindow (TheWindow: WindowPtr);
FUNCTION TFrontWindow (WantedKind: Integer): WindowPtr;
PROCEDURE TDragWindow (TheWindow: WindowPtr; VAR TheEvent: EventRecord; VAR BoundsRect: Rect);
FUNCTION TGetNextEvent (EventMask: Integer; VAR TheEvent: EventRecord): Boolean;
FUNCTION TWaitNextEvent (EventMask: Integer; VAR TheEvent: EventRecord; Sleep: Longint; MouseRgn: RgnHandle): Boolean;
FUNCTION TGetWKind (TheWindow: WindowPtr): Integer;


{--------------------------------------------------------------------}

IMPLEMENTATION

PROCEDURE FlushActivateEvents;

	VAR
		Result: Boolean;
		TheEvent: EventRecord;

	BEGIN

		ToBeActivated := NIL;
		ToBeDeActivated := NIL;
		Result := WaitNextEvent(ActivMask, TheEvent, 0, NIL);
		Result := WaitNextEvent(ActivMask, TheEvent, 0, NIL);

	END;


FUNCTION WindowExists; {(ThePWindow : WindowPeek) : Boolean}

	VAR
		LoopWindow: WindowPeek;
		Done: Boolean;

	BEGIN

		Done := False;
		BlockMove(Ptr($9D6), @LoopWindow, SizeOf(Handle));
		WHILE (Done = False) AND (LoopWindow <> NIL) DO
			BEGIN
				IF (LoopWindow = ThePWindow) THEN
					Done := True
				ELSE
					LoopWindow := LoopWindow^.NextWindow;
			END;
		WindowExists := Done;

	END;


FUNCTION NextVisWindow (WantedKind: Integer; ThePWindow: WindowPeek): WindowPeek;

	VAR
		LoopWindow, WantedWindow: WindowPeek;

	BEGIN

		IF (ThePWindow = WindowPeek(InFront)) THEN
			BEGIN
				ThePWindow := WindowPeek(FrontWindow);
				IF (ThePWindow = NIL) THEN
					BEGIN
						NextVisWindow := ThePWindow;
						Exit(NextVisWindow);
					END
				ELSE IF (WantedKind = AnyKind) OR (WantedKind = TGetWKind(WindowPtr(ThePWindow))) THEN
					BEGIN
						NextVisWindow := ThePWindow;
						Exit(NextVisWindow);
					END;
			END;
		WantedWindow := NIL;
		LoopWindow := ThePWindow^.NextWindow;
		WHILE ((WantedWindow = NIL) AND (LoopWindow <> NIL)) DO
			BEGIN
				IF (LoopWindow^.Visible <> False) THEN
					IF (wantedKind = AnyKind) OR (WantedKind = TGetWKind(WindowPtr(LoopWindow))) THEN
						WantedWindow := LoopWindow;
				LoopWindow := LoopWindow^.NextWindow;
			END;
		NextVisWindow := WantedWindow;

	END;


FUNCTION PrevVisWindow (ThePWindow: WindowPeek): WindowPeek;

	VAR
		LoopWindow, PrevWindow, TheFrontWindow: WindowPeek;
		Done: Boolean;

	BEGIN

		TheFrontWindow := WindowPeek(FrontWindow);
		IF (ThePWindow = TheFrontWindow) OR (TheFrontWindow = NextVisWindow(AnyKind, ThePWindow)) THEN
			BEGIN
				PrevVisWindow := NIL;
				Exit(PrevVisWindow);
			END;
		PrevWindow := TheFrontWindow;
		LoopWindow := PrevWindow^.NextWindow;
		Done := False;
		WHILE (Done = False) DO
			BEGIN
				IF (LoopWindow = ThePWindow) THEN
					Done := True
				ELSE IF (LoopWindow^.Visible <> False) THEN
					PrevWindow := LoopWindow;
				LoopWindow := LoopWindow^.NextWindow;
			END;
		PrevVisWindow := PrevWindow;

	END;


FUNCTION GetWPosition (ThePWindow: WindowPeek; VAR FrontWKind: Integer): Integer;

	VAR
		TheFrontWindow, NewFrontWindow, LoopWindow: WindowPeek;
		Done: Boolean;
		Result, LoopWKind: Integer;

	BEGIN

		TheFrontWindow := WindowPeek(FrontWindow);
		IF (ThePWindow^.Visible <> False) AND (TheFrontWindow = ThePWindow) THEN
			NewFrontWindow := NextVisWindow(AnyKind, TheFrontWindow)
		ELSE
			NewFrontWindow := TheFrontWindow;
		IF (NewFrontWindow = NIL) THEN
			BEGIN
				GetWPosition := Alone;
				Exit(GetWPosition);
			END;
		FrontWKind := TGetWKind(WindowPtr(NewFrontWindow));
		IF (ThePWindow^.Visible <> False) AND (TheFrontWindow = ThePWindow) OR (TheFrontWindow = NextVisWindow(AnyKind, ThePWindow)) THEN
			BEGIN
				IF (FrontWKind = SystemKind) THEN
					Result := BeforeSystem
				ELSE IF (FrontWKind = DialogKind) THEN
					Result := BeforeDialog
				ELSE IF (FrontWKind = ToolKind) THEN
					Result := BeforeTool
				ELSE
					Result := BeforeDocument;
			END
		ELSE
			BEGIN
				IF (ThePWindow^.Visible <> False) THEN
					ThePWindow := PrevVisWindow(ThePWindow);
				Done := False;
				LoopWindow := TheFrontWindow;
				WHILE (NOT Done) DO
					BEGIN
						LoopWKind := TGetWKind(WindowPtr(LoopWindow));
						IF (LoopWindow = TheFrontWindow) AND (LoopWKind = SystemKind) THEN
							Result := BehindFrontSystem
						ELSE IF (loopWindow = FrontToolWindow) AND (BackToolWindow <> FrontToolWindow) THEN
							Result := BetweenTools
						ELSE IF (LoopWindow = BackToolWindow) THEN
							Result := BehindTools
						ELSE IF ((LoopWKind = SystemKind) AND (LoopWindow^.Visible <> False) AND (Result = BehindTools)) THEN
							Result := BehindSystem
						ELSE IF (LoopWindow = FrontDocWindow) THEN
							Result := BetweenDocuments;

						IF (LoopWindow = ThePWindow) THEN
							Done := True;
						LoopWindow := LoopWindow^.NextWindow;
					END;
			END;
		GetWPosition := Result;

	END;


PROCEDURE BringForward (ThePWindow, BehindWindow: WindowPeek; WaitWithCalc: Boolean);

	BEGIN

		CopyRgn(ThePWindow^.StrucRgn, FirstRgn);
		OffsetRgn(ThePWindow^.Port.VisRgn, -ThePWindow^.Port.PortBits.Bounds.Left, -ThePWindow^.Port.PortBits.Bounds.Top);
		DiffRgn(FirstRgn, ThePWindow^.Port.VisRgn, FirstRgn);
		OffsetRgn(ThePWindow^.Port.VisRgn, ThePWindow^.Port.PortBits.Bounds.Left, ThePWindow^.Port.PortBits.Bounds.Top);
		SendBehind(WindowPtr(ThePWindow), WindowPtr(BeHindWindow));
		PaintOne(ThePWindow, FirstRgn);
		IF (WaitWithCalc = False) THEN
			CalcVisBehind(ThePWindow, ThePWindow^.StrucRgn);
		SetEmptyRgn(FirstRgn);

	END;


FUNCTION BringToolsForward (ThePWindow: WindowPeek): Boolean;

	VAR
		ToolWindow, LoopWindow: WindowPeek;

	BEGIN

		IF (ThePWindow = WindowPeek(InFront)) THEN
			BEGIN
				ToolWindow := NextVisWindow(ToolKind, WindowPeek(FrontWindow));
				IF (ToolWindow <> NIL) THEN
					BEGIN
						LoopWindow := ToolWindow^.NextWindow;
						SelectWindow(WindowPtr(ToolWindow));
						FrontToolWindow := ToolWindow;
						BackToolWindow := ToolWindow;
					END
				ELSE
					BEGIN
						BringToolsForward := False;
						Exit(BringToolsForward);
					END;
			END
		ELSE
			BEGIN
				LoopWindow := ThePWindow^.NextWindow;
				BackToolWindow := ThePWindow;
			END;
		SetEmptyRgn(SecondRgn);
		ThePWindow := NIL;
		WHILE (LoopWindow <> NIL) DO
			BEGIN
				IF (LoopWindow^.WindowKind = ToolKind) AND (LoopWindow^.Visible <> False) THEN
					BEGIN
						ToolWindow := LoopWindow;
						ToolWindow^.Hilited := True;
						BringForward(ToolWindow, BackToolWindow, PostponeCalc);
						UnionRgn(SecondRgn, ToolWindow^.StrucRgn, SecondRgn);
						BackToolWindow := ToolWindow;
						IF (ThePWindow = NIL) THEN
							ThePWindow := ToolWindow;
					END;
				LoopWindow := LoopWindow^.NextWindow;
			END;
		CalcVisBehind(ThePWindow, SecondRgn);
		SetEmptyRgn(SecondRgn);
		BringToolsForward := True;

	END;


PROCEDURE HiliteTools (Hilite: Boolean);

	VAR
		LoopWindow: WindowPeek;
		Done: Boolean;

	BEGIN

		IF (FrontToolWindow <> NIL) THEN
			BEGIN
				Done := False;
				LoopWindow := FrontToolWindow;
				WHILE ((Done = False) AND (LoopWindow <> NIL)) DO
					BEGIN
						IF (TGetWKind(WindowPtr(LoopWindow)) = ToolKind) AND (LoopWindow^.Visible <> False) THEN
							BEGIN
								HiliteWindow(WindowPtr(LoopWindow), Hilite);
								IF (LoopWindow = BackToolWindow) THEN
									Done := True;
							END;
						LoopWindow := LoopWindow^.NextWindow;
					END;
			END;


	END;


PROCEDURE TInitWindows;

	VAR
		Err: OSErr;

	BEGIN

		FrontToolWindow := NIL;
		BackToolWindow := NIL;
		FrontDocWindow := NIL;
		ToBeActivated := NIL;
		ToBeDeactivated := NIL;
		InFront := -1;
		FirstRgn := NewRgn;
		SecondRgn := NewRgn;
		Err := SysEnvirons(CurVersion, TheWorld);

	END;


FUNCTION TGetNewWindow; {(WindowKind, WindowID : Integer;}
{                          WStorage : Ptr; Behind : WindowPtr) : WindowPtr}

	VAR
		boundsRect: Rect;
		title: Str255;
		visible: Boolean;
		procID: Integer;
		goAwayFlag: Boolean;
		refCon: LongInt;
		TheWindow: WindowPtr;
		TheWINDHandle: WINDHandle;
		TheWINDPtr: WINDPtr;
		TempWinPtr: WindowPeek;

	BEGIN

		TheWINDHandle := WINDHandle(GetResource('WIND', WindowID));
		IF NOT (TheWINDHandle = NIL) THEN
			BEGIN
				TheWINDPtr := TheWINDHandle^;
				BoundsRect := TheWINDPtr^.BoundsRect;
				Visible := TheWINDPtr^.Visible;
				ProcID := TheWINDPtr^.ProcID;
				GoAwayFlag := TheWINDPtr^.GoAwayFlag;
				RefCon := TheWINDPtr^.RefCon;
				TheWindow := NewWindow(WStorage, BoundsRect, TheWINDPtr^.Title, Invisible, ProcID, Behind, GoAwayFlag, RefCon);
				IF NOT (TheWindow = NIL) THEN
					BEGIN
						TempWinPtr := WindowPeek(TheWindow);
						TempWinPtr^.WindowKind := WindowKind;
						IF Visible THEN
							TShowWindow(TheWindow);
					END;
			END
		ELSE
			TGetNewWindow := NIL;
		ReleaseResource(Handle(TheWINDHandle));

	END;


FUNCTION TNewWindow;{(WindowKind :Integer; WStorage : Ptr; }
{                      boundsRect : Rect; title : Str255;}
{                      visible : Boolean; procID : Integer;}
{                      behind : WindowPtr; goAwayFlag : Boolean;}
{                      refCon : LongInt) : WindowPtr}

	VAR
		TheWindow: WindowPtr;
		TempWPeek: WindowPeek;

	BEGIN

		TheWindow := NewWindow(WStorage, BoundsRect, Title, Invisible, ProcID, Behind, GoAwayFlag, RefCon);
		IF (TheWindow <> NIL) THEN
			BEGIN
				TempWPeek := WindowPeek(TheWindow);
				TempWPeek^.WindowKind := WindowKind;
				IF (Visible <> False) THEN
					TShowWindow(TheWindow);
			END;
		TNewWindow := WindowPtr(TempWPeek);

	END;


PROCEDURE TCloseWindow;{(TheWindow : WindowPtr)}

	BEGIN

		THideWindow(TheWindow);
		CloseWindow(TheWindow);
		IF (TheWindow = WindowPtr(ToBeDeactivated)) THEN
			ToBeDeactivated := NIL;

	END;


PROCEDURE TDisposeWindow;{(TheWindow : WindowPtr)}

	BEGIN

		THideWindow(TheWindow);
		DisposeWindow(TheWindow);
		IF (TheWindow = WindowPtr(ToBeDeactivated)) THEN
			ToBeDeactivated := NIL;

	END;


PROCEDURE TDisposDialog;{(TheWindow : WindowPtr)}

	BEGIN

		THideWindow(TheWindow);
		DisposDialog(TheWindow);
		IF (TheWindow = WindowPtr(ToBeDeactivated)) THEN
			ToBeDeactivated := NIL;

	END;


PROCEDURE TSelectWindow;{(TheWindow : WindowPtr)}

	VAR
		ThePWindow, TheFrontWindow: WindowPeek;
		TheWKind, FrontWKind: Integer;
		ToolsVisible: Boolean;
		Ignore: Boolean;

	BEGIN

		ThePWindow := WindowPeek(TheWindow);
		TheFrontWindow := WindowPeek(FrontWindow);
		TheWKind := TGetWKind(TheWindow);
		FrontWKind := TGetWKind(WindowPtr(TheFrontWindow));

		IF (TheWKind = ToolKind) THEN
			BEGIN
				IF (FrontWKind = SystemKind) THEN
					BEGIN
						SelectWindow(TheWindow);
						Ignore := BringToolsForward(ThePWindow);
						IF NOT (FrontDocWindow = NIL) THEN
							BEGIN
								FrontDocWindow^.Hilited := True;
								BringForward(FrontDocWindow, BackToolWindow, NormalCalc);
								ToBeActivated := FrontDocWindow;
							END;
						FrontToolWindow := ThePWindow;
					END
				ELSE
					BEGIN
						IF NOT (ThePWindow = FrontToolWindow) THEN
							BEGIN
								IF NOT (ThePWindow = BackToolWindow) THEN
									BEGIN
										BackToolWindow := NextVisWindow(ToolKind, ThePWindow);
										IF (BackToolWindow = NIL) THEN
											BackToolWindow := PrevVisWindow(ThePWindow);
									END;
								BringToFront(TheWindow);
								FrontToolWindow := ThePWindow;
							END;
					END;
			END
		ELSE IF (TheWKind = UserKind) THEN
			BEGIN
				IF (FrontWKind = SystemKind) THEN
					BEGIN
						ToolsVisible := BringToolsForward(WindowPeek(InFront));
						IF (ToolsVisible = False) THEN
							SelectWindow(TheWindow)
						ELSE
							BEGIN
								ThePWindow^.Hilited := True;
								BringForward(WindowPeek(TheWindow), BackToolWindow, NormalCalc);
							END;
						ToBeActivated := ThePWindow;
						FrontDocWindow := ThePWindow;
					END
				ELSE
					BEGIN
						IF NOT (ThePWindow = FrontDocWindow) THEN
							BEGIN
								IF (FrontToolWindow = NIL) THEN
									SelectWindow(TheWindow)
								ELSE
									BEGIN
										HiliteWindow(WindowPtr(FrontDocWindow), False);
										ThePWindow^.Hilited := True;
										BringForward(ThePWindow, BackToolWindow, NormalCalc);
									END;
								ToBeDeactivated := FrontDocWindow;
								ToBeActivated := ThePWindow;
								FrontDocWindow := ThePWindow;
							END;
					END;
			END;

	END;


PROCEDURE THideWindow;{(TheWindow : WindowPtr)}

	VAR
		ThePWindow, BehindWindow, TempPWindow: WindowPeek;
		TheWKind, ThePosition, FrontWKind: Integer;

	BEGIN

		TempPWindow := WindowPeek(TheWindow);
		IF NOT (TempPWindow^.Visible = False) THEN
			BEGIN
				ThePWindow := WindowPeek(TheWindow);
				TheWKind := TGetWKind(TheWindow);
				ThePosition := GetWPosition(ThePWindow, FrontWKind);
				IF (TheWKind = ToolKind) THEN
					BEGIN
						CASE (ThePosition) OF
							Alone, BeforeSystem: 
								BEGIN
									HideWindow(TheWindow);
									FrontToolWindow := NIL;
									BackToolWindow := NIL;
								END;
							BeforeTool: 
								BEGIN
									ShowHide(TheWindow, False);
									FrontToolWindow := WindowPeek(FrontWindow);
								END;
							BehindFrontSystem: 
								BEGIN
									ShowHide(TheWindow, False);
									FrontToolWindow := NextVisWindow(ToolKind, ThePWindow);
									IF (FrontToolWindow = NIL) THEN
										BackToolWindow := NIL;
								END;
							BeforeDocument: 
								BEGIN
									FrontToolWindow := NIL;
									BackToolWindow := NIL;
									ShowHide(TheWindow, False);
								END;
							BetweenTools: 
								BEGIN
									ShowHide(TheWindow, False);
									IF (ThePWindow = BackToolWindow) THEN
										BackToolWindow := PrevVisWindow(ThePWindow);
								END;
						END;
					END
				ELSE IF (TheWKind = UserKind) THEN
					BEGIN
						ThePWindow^.Hilited := False;
						CASE (ThePosition) OF
							Alone, BeforeSystem: 
								BEGIN
									ToBeDeactivated := ThePWindow;
									FrontDocWindow := NIL;
								END;
							BetweenDocuments: 
								BEGIN
									HideWindow(TheWindow);
								END;
							BeforeDocument: 
								BEGIN
									HideWindow(TheWindow);
									ToBeDeactivated := ThePWindow;
									ToBeActivated := WindowPeek(FrontWindow);
									FrontDocWindow := ToBeActivated;
								END;
							BehindFrontSystem: 
								BEGIN
									ShowHide(TheWindow, False);
									FrontDocWindow := NextVisWindow(UserKind, WindowPeek(TheWindow));
								END;
							BehindTools: 
								BEGIN
									FrontDocWindow := NextVisWindow(UserKind, WindowPeek(TheWindow));
									BehindWindow := NextVisWindow(AnyKind, WindowPeek(TheWindow));
									ShowHide(TheWindow, False);
									IF (BehindWindow = NIL) THEN
										ToBeDeactivated := ThePWindow
									ELSE
										BEGIN
											IF NOT (BehindWindow = FrontDocWindow) THEN
												BEGIN
													IF (FrontWKind = ToolKind) THEN
														BEGIN
															HiliteTools(False);
															SelectWindow(WindowPtr(BehindWindow));
															ToBeDeactivated := ThePWindow;
														END;
													IF NOT (FrontDocWindow = NIL) THEN
														BringForward(FrontDocWindow, BackToolWindow, NormalCalc);
												END
											ELSE
												BEGIN
													IF (FrontWKind = ToolKind) THEN
														BEGIN
															HiliteWindow(WindowPtr(FrontDocWindow), True);
															ToBeActivated := FrontDocWindow;
															ToBeDeactivated := ThePWindow;
														END;
												END;
										END;
								END;
						END;
					END
				ELSE
					BEGIN
						CASE (ThePosition) OF
							Alone, BeforeSystem, BeforeDialog: 
								BEGIN
									HideWindow(TheWindow);
								END;
							BeforeTool, BeforeDocument: 
								BEGIN
									ShowHide(TheWindow, False);
									HiliteTools(True);
									IF NOT (FrontDocWindow = NIL) THEN
										BEGIN
											ToBeDeactivated := ThePWindow;
											ToBeActivated := FrontDocWindow;
											HiliteWindow(WindowPtr(FrontDocWindow), True);
										END;
								END;
						END;
					END;
			END;
		FlushActivateEvents;

	END;


PROCEDURE TShowWindow;{(TheWindow : WindowPtr)}

	VAR
		ThePWindow, TheFrontWindow, Behind, TempPWindow: WindowPeek;
		TheWKind, FrontWKind, ThePosition: Integer;
		ToolsExist, Ignore: Boolean;

	BEGIN

		TempPWindow := WindowPeek(TheWindow);
		IF (TempPWindow^.Visible = False) THEN
			BEGIN
				ThePWindow := WindowPeek(TheWindow);
				TheFrontWindow := WindowPeek(FrontWindow);
				TheWKind := TGetWKind(TheWindow);
				ThePosition := GetWPosition(ThePWindow, FrontWKind);
				IF (TheWKind = ToolKind) THEN
					BEGIN
						ThePWindow^.Hilited := True;
						CASE (ThePosition) OF
							BeforeSystem: 
								BEGIN
									ShowWindow(TheWindow);
									Ignore := BringToolsForward(ThePWindow);
									IF (FrontDocWindow <> NIL) THEN
										BEGIN
											FrontDocWindow^.Hilited := True;
											BringForward(FrontDocWindow, BackToolWindow, NormalCalc);
											ToBeActivated := FrontDocWindow;
										END;
									FrontToolWindow := ThePWindow;
								END;
							BehindFrontSystem, Alone, BeforeDocument, BeforeTool: 
								BEGIN
									IF (ThePosition = BehindFrontSystem) THEN
										ThePWindow^.Hilited := False;
									IF ((ThePosition = Alone) OR (ThePosition = BeforeDocument)) THEN
										IF (BackToolWindow = NIL) THEN
											BackToolWindow := ThePWindow;
									ShowHide(TheWindow, True);
									FrontToolWindow := ThePWindow;
								END;
							BehindTools, BetweenTools: 
								BEGIN
									IF (ThePosition = BehindTools) THEN
										BackToolWindow := ThePWindow;
									IF (FrontWKind = SystemKind) THEN
										ThePWindow^.Hilited := False;
									ShowHide(TheWindow, True);
								END;
							BehindSystem: 
								BEGIN
									SendBehind(TheWindow, WindowPtr(BackToolWindow));
									IF (FrontWKind = SystemKind) THEN
										ThePWindow^.Hilited := True;
									ShowHide(theWindow, True);
									BackToolWindow := ThePWindow;
								END;
							BetweenDocuments: 
								BEGIN
									IF (BackToolWindow <> NIL) THEN
										Behind := BackToolWindow
									ELSE
										BEGIN
											Behind := PrevVisWindow(FrontDocWindow);
											FrontToolWindow := ThePWindow;
										END;
									IF (Behind = NIL) THEN
										BringToFront(TheWindow)
									ELSE
										BEGIN
											SendBehind(TheWindow, WindowPtr(Behind));
											IF (FrontWKind = SystemKind) THEN
												ThePWindow^.Hilited := False;
										END;
									ShowHide(TheWindow, True);
									BackToolWindow := ThePWindow;
								END;
						END;
					END
				ELSE IF (TheWKind = UserKind) THEN
					BEGIN
						CASE (ThePosition) OF
							BeforeSystem, Alone: 
								BEGIN
									IF (ThePosition = BeforeSystem) THEN
										BEGIN
											ToolsExist := BringToolsForward(WindowPeek(InFront));
											IF (ToolsExist) THEN
												ThePWindow^.hilited := True;
										END;
									ShowWindow(TheWindow);
									ToBeActivated := ThePWindow;
									FrontDocWindow := ThePWindow;
								END;
							BeforeTool: 
								BEGIN
									IF (FrontDocWindow <> NIL) THEN
										BEGIN
											HiliteWindow(WindowPtr(FrontDocWindow), False);
											ToBeDeactivated := FrontDocWindow;
										END;
									SendBehind(TheWindow, WindowPtr(BackToolWindow));
									ThePWindow^.Hilited := True;
									ShowHide(TheWindow, True);
									ToBeActivated := ThePWindow;
									FrontDocWindow := ThePWindow;
								END;
							BeforeDocument: 
								BEGIN
									HiliteWindow(WindowPtr(FrontDocWindow), False);
									HiliteWindow(TheWindow, True);
									ShowHide(TheWindow, True);
									ToBeDeactivated := FrontDocWindow;
									ToBeActivated := ThePWindow;
									FrontDocWindow := ThePWindow;
								END;
							BehindFrontSystem: 
								BEGIN
									IF (BackToolWindow <> NIL) THEN
										SendBehind(TheWindow, WindowPtr(BackToolWindow));
									ShowHide(TheWindow, True);
									FrontDocWindow := ThePWindow;
								END;
							BetweenTools, BehindTools: 
								BEGIN
									IF (ThePosition = BetweenTools) THEN
										SendBehind(TheWindow, WindowPtr(BackToolWindow));
									IF (FrontWKind = ToolKind) THEN
										BEGIN
											ThePWindow^.Hilited := True;
											ToBeActivated := ThePWindow;
											IF (FrontDocWindow <> NIL) THEN
												BEGIN
													HiliteWindow(WindowPtr(FrontDocWindow), False);
													ToBeDeactivated := FrontDocWindow;
												END;
										END;
									ShowHide(TheWindow, True);
									FrontDocWindow := ThePWindow;
								END;
							BehindSystem: 
								BEGIN
									SendBehind(TheWindow, WindowPtr(BackToolWindow));
									IF (FrontWKind = ToolKind) THEN
										BEGIN
											ThePWindow^.Hilited := True;
											ToBeActivated := ThePWindow;
										END;
									ShowHide(TheWindow, True);
									FrontDocWindow := ThePWindow;
								END;
							BetweenDocuments: 
								BEGIN
									ShowHide(TheWindow, True);
								END;
						END;
					END
				ELSE
					BEGIN
						CASE (ThePosition) OF
							Alone, BeforeSystem, BeforeDialog: 
								BEGIN
									ShowWindow(TheWindow);
								END;
							BeforeTool, BeforeDocument: 
								BEGIN
									HiliteTools(False);
									IF (FrontDocWindow <> NIL) THEN
										BEGIN
											ToBeDeactivated := FrontDocWindow;
											HiliteWindow(WindowPtr(FrontDocWindow), False);
										END;
									ShowHide(TheWindow, True);
								END;
						END;
					END;
			END;
		FlushActivateEvents;

	END;


FUNCTION TFrontWindow;{(WantedKind : Integer) : WindowPtr}

	VAR
		TheWindow: WindowPtr;
		TheWKind: Integer;

	BEGIN

		TheWindow := FrontWindow;
		TheWKind := TGetWKind(TheWindow);
		IF (TheWKind = SystemKind) OR (TheWKind = DialogKind) THEN
			TFrontWindow := TheWindow
		ELSE
			BEGIN
				CASE (WantedKind) OF
					ToolKind: 
						TFrontWindow := WindowPtr(FrontToolWindow);
					UserKind: 
						TFrontWindow := WindowPtr(FrontDocWindow);
					AnyKind: 
						TFrontWindow := TheWindow;
				END;
			END;

	END;


PROCEDURE TDragWindow;{(TheWindow : WindowPtr; Var TheEvent : EventRecord; Var BoundsRect : Rect)}

	VAR
		SavePort, WPort: GrafPtr;
		LimitRect, SlopRect: Rect;
		DeskTopRgn: RgnHandle;
		Result: Longint;
		HDrag, VDrag: Integer;
		ThePoint: Point;
		GrayRgn: Ptr;
		TempWPeek: WindowPeek;

	BEGIN

		IF (BitAnd(TheEvent.Modifiers, CmdKey) = 0) THEN
			BEGIN
				TSelectWindow(TheWindow);
				IF (StillDown = False) THEN
					Exit(TDragWindow);
			END;
		GetPort(SavePort);
		GetWMgrPort(WPort);
		SetPort(WPort);

		IF ((TheWorld.MachineType = EnvMac) OR (TheWorld.MachineType = EnvXL)) THEN
			BEGIN
				GrayRgn := Ptr($9EE);
				BlockMove(GrayRgn, @DeskTopRgn, SizeOf(Handle));
			END
		ELSE
			DeskTopRgn := GetGrayRgn;


		GetClip(FirstRgn);
		SetClip(DeskTopRgn);
		ClipAbove(WindowPeek(TheWindow));
		TempWPeek := WindowPeek(TheWindow);
		CopyRgn(TempWPeek^.StrucRgn, SecondRgn);
		SetPt(ThePoint, TheEvent.Where.H, TheEvent.Where.V);
		GlobalToLocal(ThePoint);
		Result := DragGrayRgn(SecondRgn, ThePoint, BoundsRect, BoundsRect, NoConstraint, ProcPtr(NIL));
		SetClip(FirstRgn);
		VDrag := HiWord(Result);
		HDrag := LoWord(Result);
		IF (NOT ((VDrag = NoDrag) AND (HDrag = NoDrag))) THEN
			BEGIN
				SetPort(TheWindow);
				SetPt(ThePoint, TheWindow^.PortRect.Left, TheWindow^.PortRect.Top);
				LocalToGlobal(ThePoint);
				MoveWindow(TheWindow, ThePoint.H + HDrag, ThePoint.V + VDrag, False);
			END;
		SetPort(SavePort);
		SetEmptyRgn(FirstRgn);
		SetEmptyRgn(SecondRgn);

	END;


FUNCTION TGetNextEvent;{(EventMask : Integer; Var TheEvent : EventRecord) : Boolean}

	VAR
		Result: Boolean;
		TheWKind: Integer;

	BEGIN

		IF ((EventAvail(EventMask, TheEvent) <> False) AND (TheEvent.What = ActivateEvt)) THEN
			BEGIN
				Result := GetNextEvent(EventMask, TheEvent);
				TheWKind := TGetWKind(WindowPtr(TheEvent.Message));
				IF (NOT (BitAnd(TheEvent.Modifiers, ActiveFlag) = ActiveFlag)) THEN
					BEGIN
						IF (TheEvent.Message <> Longint(ToBeDeactivated)) THEN
							BEGIN
								IF (ToBeDeactivated <> NIL) THEN
									TheEvent.Message := Longint(ToBeDeactivated)
								ELSE
									BEGIN
										IF (TheWKind = UserKind) OR (TheWKind = ToolKind) THEN
											BEGIN
												IF (TheWKind = ToolKind) THEN
													HiliteTools(False);
												IF (FrontDocWindow <> NIL) THEN
													BEGIN
														HiliteWindow(WindowPtr(FrontDocWindow), False);
														TheEvent.Message := Longint(FrontDocWindow);
													END
												ELSE
													result := TGetNextEvent(EventMask, TheEvent);
											END;
									END;
							END;
						ToBeDeactivated := NIL;
					END
				ELSE
					BEGIN
						IF (TheEvent.Message <> Longint(ToBeActivated)) THEN
							BEGIN
								IF (ToBeActivated <> NIL) THEN
									TheEvent.Message := Longint(ToBeActivated)
								ELSE
									BEGIN
										IF (TheWKind = UserKind) OR (TheWKind = ToolKind) THEN
											BEGIN
												IF (TheWKind = ToolKind) THEN
													HiliteTools(True);
												IF (FrontDocWindow <> NIL) THEN
													BEGIN
														HiliteWindow(WindowPtr(FrontDocWindow), True);
														TheEvent.Message := Longint(FrontDocWindow);
													END
												ELSE
													result := TGetNextEvent(EventMask, TheEvent);
											END;
									END;
							END;
						ToBeActivated := NIL;
					END;
			END
		ELSE
			BEGIN
				IF (ToBeDeactivated <> NIL) AND (BitAnd(EventMask, ActivMask) <> 0) THEN
					BEGIN
						IF (WindowExists(ToBeDeactivated)) THEN
							BEGIN
								TheEvent.What := ActivateEvt;
								TheEvent.Message := Longint(ToBeDeactivated);
								TheEvent.Modifiers := DeactivFlag;
								ToBeDeactivated := NIL;
								Result := True;
							END
						ELSE
							BEGIN
								ToBeDeactivated := NIL;
								Result := TGetNextEvent(EventMask, TheEvent);
							END;
					END
				ELSE IF (ToBeActivated <> NIL) AND (BitAnd(EventMask, ActivMask) <> 0) THEN
					BEGIN
						TheEvent.What := ActivateEvt;
						TheEvent.Message := Longint(ToBeActivated);
						TheEvent.Modifiers := activeFlag;
						ToBeActivated := NIL;
						Result := True;
					END
				ELSE
					Result := GetNextEvent(EventMask, TheEvent);
			END;
		TGetNextEvent := Result;

	END;


FUNCTION TWaitNextEvent (EventMask: Integer; VAR TheEvent: EventRecord; Sleep: Longint; MouseRgn: RgnHandle): Boolean;

	VAR
		Result: Boolean;
		TheWKind: Integer;

	BEGIN

		IF ((EventAvail(EventMask, TheEvent) <> False) AND (TheEvent.What = ActivateEvt)) THEN
			BEGIN
				Result := WaitNextEvent(EventMask, TheEvent, Sleep, MouseRgn);
				TheWKind := TGetWKind(WindowPtr(TheEvent.Message));
				IF (NOT (BitAnd(TheEvent.Modifiers, ActiveFlag) = ActiveFlag)) THEN
					BEGIN
						IF (TheEvent.Message <> Longint(ToBeDeactivated)) THEN
							BEGIN
								IF (ToBeDeactivated <> NIL) THEN
									TheEvent.Message := Longint(ToBeDeactivated)
								ELSE
									BEGIN
										IF (TheWKind = UserKind) OR (TheWKind = ToolKind) THEN
											BEGIN
												IF (TheWKind = ToolKind) THEN
													HiliteTools(False);
												IF (FrontDocWindow <> NIL) THEN
													BEGIN
														HiliteWindow(WindowPtr(FrontDocWindow), False);
														TheEvent.Message := Longint(FrontDocWindow);
													END
												ELSE
													result := TWaitNextEvent(EventMask, TheEvent, Sleep, MouseRgn);
											END;
									END;
							END;
						ToBeDeactivated := NIL;
					END
				ELSE
					BEGIN
						IF (TheEvent.Message <> Longint(ToBeActivated)) THEN
							BEGIN
								IF (ToBeActivated <> NIL) THEN
									TheEvent.Message := Longint(ToBeActivated)
								ELSE
									BEGIN
										IF (TheWKind = UserKind) OR (TheWKind = ToolKind) THEN
											BEGIN
												IF (TheWKind = ToolKind) THEN
													HiliteTools(True);
												IF (FrontDocWindow <> NIL) THEN
													BEGIN
														HiliteWindow(WindowPtr(FrontDocWindow), True);
														TheEvent.Message := Longint(FrontDocWindow);
													END
												ELSE
													result := TWaitNextEvent(EventMask, TheEvent, Sleep, MouseRgn);
											END;
									END;
							END;
						ToBeActivated := NIL;
					END;
			END
		ELSE
			BEGIN
				IF (ToBeDeactivated <> NIL) AND (BitAnd(EventMask, ActivMask) <> 0) THEN
					BEGIN
						IF (WindowExists(ToBeDeactivated)) THEN
							BEGIN
								TheEvent.What := ActivateEvt;
								TheEvent.Message := Longint(ToBeDeactivated);
								TheEvent.Modifiers := DeactivFlag;
								ToBeDeactivated := NIL;
								Result := True;
							END
						ELSE
							BEGIN
								ToBeDeactivated := NIL;
								Result := TWaitNextEvent(EventMask, TheEvent, Sleep, MouseRgn);
							END;
					END
				ELSE IF (ToBeActivated <> NIL) AND (BitAnd(EventMask, ActivMask) <> 0) THEN
					BEGIN
						TheEvent.What := ActivateEvt;
						TheEvent.Message := Longint(ToBeActivated);
						TheEvent.Modifiers := activeFlag;
						ToBeActivated := NIL;
						Result := True;
					END
				ELSE
					Result := WaitNextEvent(EventMask, TheEvent, Sleep, MouseRgn);
			END;
		TWaitNextEvent := Result;

	END;


FUNCTION TGetWKind;{(TheWindow : WindowPtr) : Integer}

	VAR
		TheWKind, VarCode, WindowID: Integer;
		DefProc, TempDefProc: WDEFHandle;
		TempWPeek: WindowPeek;

	BEGIN

		IF (TheWindow <> NIL) THEN
			BEGIN
				TempWPeek := WindowPeek(TheWindow);
				TheWKind := TempWPeek^.WindowKind;
				IF (TheWKind <= SystemKind) THEN
					TheWKind := SystemKind
				ELSE IF (TheWKind = DialogKind) THEN
					BEGIN
						DefProc := WDEFHandle(TempWPeek^.WindowDefProc);
						VarCode := BitAnd(BitShift(Longint(DefProc), 24), $F);
						IF (((DefProc <> NIL) AND (DefProc^ <> NIL)) AND (DefProc^^.Types = $57444546)) THEN
							WindowID := DefProc^^.ID * 16 + VarCode
						ELSE
							WindowID := DBoxProc;
						IF ((WindowID = DocumentProc) OR (WindowID = NoGrowDocProc) OR (WindowID = ZoomDocProc)) THEN
							TheWKind := UserKind;
					END
				ELSE IF (TheWKind = ToolKind) THEN { Do Nothing }
				ELSE IF (TheWKind >= UserKind) THEN
					TheWKind := UserKind;
			END;
		TGetWKind := TheWKind;

	END;


END.