{ ******************************************************** }
{ "Rotate.p"                                               }
{                                                          }
{ by John A. Love, III [ Washington Apple Pi Users' Group] }
{                                                          }
{ using Symantec's "THINK Lightspeed Pascal", v 3.00       }
{                                                          }
{ ******************************************************** }




PROGRAM Rotate;

{$I-}

	USES
		Palettes, rotInterface, rotGlobals, rotMiscSubs, OffscreenSubs, rotScrollSubs, rotWindowSubs;


	LABEL
		100;




{ ----------------------- }
{ Guess what this does ?? }
{ ----------------------- }

	PROCEDURE HandleCursor;

		CONST
			IBeamCURS_ID = 1;
			WatchCURS_ID = 4;

		VAR
			mouse: Point;
			CURS_Hdl: CursHandle;

	BEGIN

		IF daWind OR NOT InForeGround THEN
			EXIT(HandleCursor);          { DAs & other applications roll their own }

		GetMouse(mouse);
		IF PtInRect(mouse, FrontWindow^.portRect) THEN
		BEGIN
			InWindow := TRUE;
			;
			IF aMac2 THEN
			BEGIN
				IF colorHandCrsr <> NIL THEN     { Activate Event first !! }
					IF NOT stillColorCrsr THEN     { ROM problem. }
					BEGIN
						SetCCursor(colorHandCrsr);
						stillColorCrsr := TRUE;
					END;   { IF...IF }
			END   { IF aMac2 }

			ELSE   { NOT aMac2 }
				InitCursor;

		END   { IF PtInRect(...) }

		ELSE   { NOT PtInRect() }

		BEGIN
			InWindow := FALSE;
			InitCursor;
			stillColorCrsr := FALSE;
		END;   { ELSE }

	END;   { HandleCursor }



{ --------------------- }
{ To be or not to be !! }
{ --------------------- }

	PROCEDURE SetEnable (menu: MenuHandle; item: INTEGER; enabled: BOOLEAN);

	BEGIN
		IF enabled THEN
			EnableItem(menu, item)
		ELSE
			DisableItem(menu, item);
	END;   { SetEnable }



{------------------------------------------------------------------- }
{ PeriodicMenus is called before action is taken on menu commands    }
{ to correctly enable or disable the "Edit" Menu in case a Desk      }
{ Accessory owns the  front window or no window is up, respectively. }
{ The latter also affects individual items in the other Menu(s).     }
{------------------------------------------------------------------- }

	PROCEDURE PeriodicMenus;

		VAR
			FW: WindowPeek;

	BEGIN
		FW := WindowPeek(FrontWindow);
		daWind := (FW <> NIL) & (FW^.windowKind < 0);     { Used by HandleCursor. }
		applWind := (FW <> NIL) & (NOT daWind);

		IF applWind <> currGraphics THEN          { No need to repeat yourself !! }
		BEGIN
			SetEnable(GraphicsMenu, RotateItem, applWind);
			SetEnable(GraphicsMenu, DissolveItem, applWind);
			currGraphics := applWind;                { Reset. }
		END;

		IF daWind = currEdit THEN                 { Avoid a flickering Menu Bar. }
			EXIT(PeriodicMenus);
		currEdit := daWind;                        { Reset. }

		IF daWind THEN                            { the WHOLE thing !! }
			EnableItem(EditMenu, 0)
		ELSE
			DisableItem(EditMenu, 0);
		DrawMenuBar;

	END;   { PeriodicMenus }



{ ----------- }
{ Bye-Bye !!  }
{ ----------- }

	PROCEDURE DoQuit;

	BEGIN

		HUnlock(Handle(monsterPicHdl));
		ReleaseResource(Handle(monsterPicHdl));
		IF aMac2 & (colorHandCrsr <> NIL) THEN
			DisposCCursor(colorHandCrsr);
		DoCloseAll;
		;
		Done := TRUE;

	END;   { DoQuit }



{ ---------}
{ Enjoy !! }
{ ---------}

	PROCEDURE SpiffyRoll;

		LABEL
			100, 200, 300;

		VAR
			bragging: WindowPtr;
			logoPicHdl: PicHandle;
			bragRect: Rect;
			tempX, tempY: INTEGER;
			rollRect: Rect;
			maskPercent: INTEGER;

	BEGIN

		bragging := FrontWindow;                { I get here ONLY when I have a window. }
		IF bragging = NIL THEN                 { ... but just in case !! }
			GOTO 300;
		;
		logoPicHdl := PicHandle(GetWRefCon(bragging));
		IF logoPicHdl = NIL THEN
			GOTO 200;

		bragRect := bragging^.portRect;

		WITH bragRect DO
		BEGIN
			IF (ScrollVert(bragging) <> NIL) | (ScrollHoriz(bragging) <> NIL) THEN
			BEGIN
				right := (right + 1) - scrollWidth;
				bottom := (bottom + 1) - scrollHeight;
			END;   { IF there are Scroll Bar(s) }
			;
			tempX := right - left;
			tempY := bottom - top;
		END;   { WITH bragRect }

  { Because I know my WINDow & PICT sizes, tempX & tempY are always > 0: }
		WITH logoPicHdl^^.picFrame DO
		BEGIN
			tempX := tempX - (right - left);
			tempY := tempY - (bottom - top);
		END;   { WITH logoPicHdl^^.picFrame }

		WITH bragRect DO
		BEGIN
			top := top + tempY DIV 2;
			bottom := top + (logoPicHdl^^.picFrame.bottom - logoPicHdl^^.picFrame.top);
			left := left + tempX DIV 2;
			right := left + (logoPicHdl^^.picFrame.right - logoPicHdl^^.picFrame.left);
		END;   { WITH bragRect }

  { ------------------------------------------- }
  { Place my PICTure into an off screen BitMap. }
  { ------------------------------------------- }

  { Local window coordinates are input; local screen coordinates are returned. }
		CreateOffScreenError := CreateOffScreen(bragRect);
		IF CreateOffScreenError <> noErr THEN
			GOTO 100;

		ClipRect(bragRect);                      { Draw off-screen ... }
		EraseRect(bragRect);                     { Eliminate all stray matter. }
		DrawPicture(logoPicHdl, bragRect);

		ToOnScreen;                              { Back to "Square 1". }

		BackColor(whiteColor);
		ForeColor(blackColor);
  { ---------- }
		ClipRect(bragRect);
		rollRect := bragRect;
		maskPercent := 1;
		WHILE maskPercent <= 100 DO
		BEGIN
			WITH bragRect DO
				rollRect.bottom := top + ((bottom - top) * maskPercent) DIV 100;
			CopyBits(offBitMapPtr^, onScreenBitsPtr^, rollRect, rollRect, srcCopy, NIL);
			;
			IF colorDepth = 1 THEN
				Delay(10, finalTicks)               { Black-and-white too doggone fast !! }
			ELSE
				Delay(7, finalTicks);               { Color a tad better. }
			;
			maskPercent := maskPercent + 1;
		END;   { WHILE maskPercent <= 100 }
  { ---------- }
		Delay(240, finalTicks);                 { Take a gander at its beauty !! }

100:
		DisposOffScreen;

		HUnlock(Handle(logoPicHdl));
		ReleaseResource(Handle(logoPicHdl));
200:
		CloseOurWindow(bragging);               { Activates the window behind it. }

300:
		RemoveVBLTask;

		SysBeep(10);                            { Wake Up Call !! }

	END;   { SpiffyRoll }



{ ------------------------------------------------- }
{ Now for Mike Morton's spiffy dissolve stuff ...   }
{ ------------------------------------------------- }

	PROCEDURE SpiffyDissolve;

		LABEL
			100;

		VAR
			oldPort: GrafPtr;
			gigantorPicHdl: picHandle;
			gigantorRect: Rect;
			tempX, tempY: INTEGER;
			offBitMap, onScreenBits: BitMap;

	BEGIN

  { EXIT(SpiffyDissolve);     ---     Mac IIci ??? }

		GetPort(oldPort);

		IF colorDepth > 1 THEN
			gigantorPicHdl := GetPicture(colorGigantorID)   { They're SO ugly, they're cute !! }
		ELSE
			gigantorPicHdl := GetPicture(bwGigantorID);
		;
		IF gigantorPicHdl = NIL THEN
			EXIT(SpiffyDissolve);

		HLock(Handle(gigantorPicHdl));

		WITH gigantorPicHdl^^.picFrame DO                { First, center the PICTure ... }
		BEGIN
			tempX := right - left;
			tempY := bottom - top;
		END;

		WITH oldPort^.portRect DO
		BEGIN
			tempX := right - left - tempX;
			tempX := left + tempX DIV 2;
			tempY := bottom - top - tempY;
			tempY := top + tempY DIV 2;
		END;

  { I already know that the portRect of the attached WINDow is larger than }
  { the PICT, so I did NOT need to test above for being able to fit ...    }

		WITH gigantorRect DO
		BEGIN
			top := tempY;
			left := tempX;
			bottom := top + gigantorPicHdl^^.picFrame.bottom - gigantorPicHdl^^.picFrame.top;
			right := left + gigantorPicHdl^^.picFrame.right - gigantorPicHdl^^.picFrame.left;
		END;

  { ------------------------------------------ }
  { Place my PICTure into an off screen BitMap }
  { ------------------------------------------ }

		CreateOffScreenError := CreateOffScreen(gigantorRect);
		IF CreateOffScreenError <> noErr THEN
			GOTO 100;

		ClipRect(gigantorRect);                     { Draw off-screen ... }
		EraseRect(gigantorRect);
		DrawPicture(gigantorPicHdl, gigantorRect);

		ToOnScreen;                                 { Then, back to "Square 1" ... }

		ClipRect(gigantorRect);

		BackColor(whiteColor);                      { So funny colorization doesn't happen. }
		ForeColor(blackColor);
		;
		DissBits(offBitMapPtr^, onScreenBitsPtr^, gigantorRect, gigantorRect);

  { ------------------------------- }
  { Now, wasn't that neat, folks !! }
  { ------------------------------- }

100:
		DisposOffScreen;

		SetPort(oldPort);

		HUnlock(Handle(gigantorPicHdl));
		ReleaseResource(Handle(gigantorPicHdl));

		Delay(60, finalTicks);

	END;   { SpiffyDissolve }



{ ------------------------------------------------------ }
{ DoApple is the code for the "Apple" Menu.              }
{ The other two Menus follow.                            }
{                                                        }
{ NOTE: CanNOT use "TheWindow" from the _FindWindow call }
{       in the MainEventLoop because TheWindow = NIL     }
{       for a windowLoc = inMenuBar:                     }
{ ------------------------------------------------------ }

	PROCEDURE DoApple (item: INTEGER);

		CONST
			MyString = 'Programming by IACS Software and John A. Love, III of the Washington Apple Pi Users Group';

		VAR
			oldPort: GrafPtr;
			window, bragging: WindowPtr;
			logoPicHdl: PicHandle;
			skipScroll: BOOLEAN;
			scrollStr: Str255;
			IACSBuffer: QDPtr;
			IACSBox: Rect;
			tempX, tempY: INTEGER;
			accName: Str255;
			accNumber: INTEGER;
			oldForeColor, oldBackColor, contentColor: RGBColor;


	BEGIN

		CASE item OF

			AboutItem: 
			BEGIN

				IF NOT applWind THEN                   { NO window. }
					EXIT(DoApple);

				skipScroll := FALSE;                     { Everything's cool !! }
				window := FrontWindow;

      { Determine the visible part of the window's }
      { content region, LESS any Scroll Bar(s):    }

				IACSBox := window^.portRect;             { For starters ... }
				;
				WITH IACSBox DO
				BEGIN
					IF (ScrollVert(window) <> NIL) | (ScrollHoriz(window) <> NIL) THEN
					BEGIN
						right := (right + 1) - scrollWidth;
						bottom := (bottom + 1) - scrollHeight;
					END;   { IF }
				END;   { WITH IACSBox }
				;
				LocalGlobal(IACSBox);
				WITH screenBits.bounds DO
				BEGIN
					IF IACSBox.top < top THEN
						IACSBox.top := top;
					IF IACSBox.left < left THEN
						IACSBox.left := left;
					IF IACSBox.bottom > bottom THEN
						IACSBox.bottom := bottom;
					IF IACSBox.right > right THEN
						IACSBox.right := right;
				END;   { WITH screenBits.bounds }
				GlobalLocal(IACSBox);
				;
				WITH IACSBox DO
				BEGIN
					tempX := right - left;
					tempY := bottom - top;
					top := top + (tempY - 20) DIV 2;
					bottom := top + 20;
					left := left + 10;
					right := right - 10;
				END;
				;
				IF (tempX < 40) OR (tempY < 20) THEN   { NOT wide or tall enough !! }
					skipScroll := TRUE;

				InstallVBLTask(acurWorld);

      { ========== }
				IF NOT skipScroll THEN
				BEGIN

					scrollStr := MyString;
					IACSBuffer := QDPtr(ORD4(@scrollStr));

					IF colorDepth > 1 THEN
					BEGIN
						GetBackColor(oldBackColor);
						PmBackColor(pmLtGray);
						GetForeColor(oldForeColor);
						PmForeColor(pmRed);
					END;   { IF colorDepth > 1 }

					ScrollText(IACSBuffer, IACSBox);      { ********** }

					IF colorDepth > 1 THEN
					BEGIN

						IF GetWindowPartColor(window, wContentColor, contentColor) THEN
							RGBBackColor(contentColor)
						ELSE
							RGBBackColor(oldBackColor);

						RGBForeColor(oldForeColor);
					END;   { IF colorDepth > 1 }
					;
					EraseRect(IACSBox);                   { ... in above background color. }
					InvalRect(IACSBox);                   { --> an Update Event. }

				END;   { IF NOT skipScroll }
      { ========== }

				bragging := GetNewWindow(logoWindowID, NIL, WindowPtr(-1));

      { ////////// }
				IF bragging <> NIL THEN
				BEGIN

					logoPicHdl := GetPicture(logoID);
					SetWRefCon(bragging, LONGINT(logoPicHdl));   { Save for retrieval in "SpiffyRoll". }

					IF logoPicHdl <> NIL THEN
					BEGIN
						HLock(Handle(logoPicHdl));
						;
						SetPort(bragging);
						DisplayWindow(bragging);
						;
						justBragging := TRUE;
						ValidRect(bragging^.portRect);      { ... so we don't draw in the darn thing !! }
					END;  { IF logoPicHdl <> NIL }

				END;  { IF bragging <> NIL }
      { ////////// }

			END;   { AboutItem }

			AdisabledItem:                          { NEVER seen -- shown for completeness, only. }
			BEGIN
			END;   { AdisabledItem }

			OTHERWISE
			BEGIN
				GetPort(oldPort);
				;
				GetItem(AppleMenu, item, accName);
				accNumber := OpenDeskAcc(accName);
				;
				SetPort(oldPort);
			END;   { OTHERWISE }

		END;   { CASE...OF }

	END;   { DoApple }



	PROCEDURE DoEdit (item: INTEGER);

	BEGIN

		IF SystemEdit(item - 1) THEN
			EXIT(DoEdit);                    { DAs do their own thing !! }

		CASE item OF
			UndoItem, EdisabledItem, CutItem, CopyItem, PasteItem, ClearItem: 
			BEGIN
			END;
		END;   { CASE...OF }

	END;   { DoEdit }



{ ---------------------------------------------- }
{ Jon Zap definitely scored a homer on this one: }
{ This is truly a journey into CopyBits 'Hell'   }
{ ---------------------------------------------- }


	PROCEDURE DoGraphics (item: INTEGER);

		LABEL
			100, 200, 300;

		VAR
			oldPort: GrafPtr;
			kFullPICTrect, gWindPICTrect, kWindPICTrect: Rect;   {g:global & k:local}
			offBitMap, rotBitMap1, rotBitMap2, rotBitMap3, rotBitMap4: BitMap;
			rotBitMapPtr1, rotBitMapPtr2, rotBitMapPtr3, rotBitMapPtr4: BitMapPtr;
			onScreenRgn: RgnHandle;
			copyRect: Rect;
			myRotHdl1, myRotHdl2, myRotHdl3, myRotHdl4: Handle;
			rotPixMap1, rotPixMap2, rotPixMap3, rotPixMap4: PixMapHandle;
			err: OSErr;
			toooooFast, ignore: BOOLEAN;

		PROCEDURE ErrorOut (iteration: INTEGER; rotBitMap: BitMap; error: OSErr);

			VAR
				rotHandle: Handle;

		BEGIN

			IF iteration > 1 THEN          { Disposes of stuff even if NO error. }
			BEGIN
				rotHandle := RecoverHandle(rotBitMap.baseAddr);
				HUnlock(rotHandle);
				DisposHandle(rotHandle);
			END;   { IF }

			IF error = memFullErr THEN
				GOTO 100;

		END;   { ErrorOut }


	BEGIN   { DoGraphics }

		CASE item OF

			RotateItem: 
			BEGIN

				IF NOT applWind THEN               { Whoops !! }
					EXIT(DoGraphics);
				;
				GetPort(oldPort);                    { Where in the ?!*!? are we }

      { ------------------------------------------ }
      { Place my PICTure into an off screen BitMap }
      { so we can rotate this dude !!              }
      {                                            }
      { ... should be old-hat by now.              }
      { ------------------------------------------ }

				SetPort(FrontWindow);
				InstallVBLTask(acurDogCow);          { Round-and-around she goes ... }

      { We're about to switch the Port to off-screen:     }
      {                                                   }
      { NOTE: keep original rects intact by using copies. }

				kFullPICTrect := scrolledFullPICTrect;
				gWindPICTrect := windPICTrect;
				LocalGlobal(gWindPICTrect);
				;
				CreateOffScreenError := CreateOffScreen(kFullPICTrect);
				IF CreateOffScreenError <> noErr THEN
					GOTO 200;
				;
				offBitMap := offBitMapPtr^;

      { We canNOT call _GlobalToLocal here because we've changed the }
      { the portBits.bounds rect of our off-screen port within       }
      { "CreateOffScreen".  See "_GlobalToLocal" within Inside Mac.  }

				kWindPICTrect := gWindPICTrect;
				WITH screenBits.bounds DO           { Bounds BEFORE change. }
					OffsetRect(kWindPICTrect, left, top);

				IF colorDepth > 1 THEN
				BEGIN

					rotPixMap1 := NewPixMap;                             { Everything but ...         }
					CopyPixMap(offCGrafPtr^.portPixMap, rotPixMap1);     { ... & now the Color Table. }
					rotBitMapPtr1 := BitMapPtr(rotPixMap1^);
					;
					rotPixMap2 := NewPixMap;
					CopyPixMap(offCGrafPtr^.portPixMap, rotPixMap2);
					rotBitMapPtr2 := BitMapPtr(rotPixMap2^);
					;
					rotPixMap3 := NewPixMap;
					CopyPixMap(offCGrafPtr^.portPixMap, rotPixMap3);
					rotBitMapPtr3 := BitMapPtr(rotPixMap3^);
					;
					rotPixMap4 := NewPixMap;
					CopyPixMap(offCGrafPtr^.portPixMap, rotPixMap4);
					rotBitMapPtr4 := BitMapPtr(rotPixMap4^);

				END   { IF colorDepth > 1 }

				ELSE

				BEGIN
					rotBitMapPtr1 := BitMapPtr(NewClearPtr(SIZEOF(BitMap)));
					rotBitMapPtr2 := BitMapPtr(NewClearPtr(SIZEOF(BitMap)));
					rotBitMapPtr3 := BitMapPtr(NewClearPtr(SIZEOF(BitMap)));
					rotBitMapPtr4 := BitMapPtr(NewClearPtr(SIZEOF(BitMap)));
				END;   { ELSE }

				rotBitMap1 := rotBitMapPtr1^;
				rotBitMap2 := rotBitMapPtr2^;
				rotBitMap3 := rotBitMapPtr3^;
				rotBitMap4 := rotBitMapPtr4^;

      { ------------------- }
      { Draw off-screen ... }
      { ------------------- }

				ClipRect(kFullPICTrect);
				EraseRect(kFullPICTrect);                    { Eliminate all stray matter. }
				DrawPicture(monsterPicHdl, kFullPICTrect);

      { ---------------------- }
      { Back to "Square 1" ... }
      { ---------------------- }

				ToOnScreen;

				ClipRect(kWindPICTrect);

      { -------------------------- }
      { Now, for the fun stuff ... }
      { -------------------------- }

				BackColor(whiteColor);                      { So funny colorization doesn't happen. }
				ForeColor(blackColor);
				toooooFast := aMac2 & (colorDepth = 1);     { Black-and-white TOOOOO fast !! }

				err := RotateBits(offBitMap, rotBitMap1);
				ErrorOut(1, offBitMap, err);
				IF colorDepth > 1 THEN
					BlockMove(Ptr(@rotBitMap1), Ptr(rotPixMap1^), SIZEOF(BitMap));
				EraseRect(kWindPICTrect);
				copyRect := rotBitMap1.bounds;
				IF colorDepth = 1 THEN
					CopyBits(rotBitMap1, onBWScreen^.portBits, copyRect, copyRect, srcCopy, NIL)
				ELSE
					CopyBits(BitMapPtr(rotPixMap1^)^, BitMapPtr(onCScreen^.portPixMap^)^, copyRect, copyRect, srcCopy, NIL);
				IF toooooFast THEN
					Delay(90, finalTicks);
      { +++++ }
				err := RotateBits(rotBitMap1, rotBitMap2);
				ErrorOut(2, rotBitMap1, err);
				IF colorDepth > 1 THEN
					BlockMove(Ptr(@rotBitMap2), Ptr(rotPixMap2^), SIZEOF(BitMap));
				EraseRect(kWindPICTrect);
				copyRect := rotBitMap2.bounds;
				IF colorDepth = 1 THEN
					CopyBits(rotBitMap2, onBWScreen^.portBits, copyRect, copyRect, srcCopy, NIL)
				ELSE
					CopyBits(BitMapPtr(rotPixMap2^)^, BitMapPtr(onCScreen^.portPixMap^)^, copyRect, copyRect, srcCopy, NIL);
				IF toooooFast THEN
					Delay(90, finalTicks);
      { +++++ }
				err := RotateBits(rotBitMap2, rotBitMap3);
				ErrorOut(3, rotBitMap2, err);
				IF colorDepth > 1 THEN
					BlockMove(Ptr(@rotBitMap3), Ptr(rotPixMap3^), SIZEOF(BitMap));
				EraseRect(kWindPICTrect);
				copyRect := rotBitMap3.bounds;
				IF colorDepth = 1 THEN
					CopyBits(rotBitMap3, onBWScreen^.portBits, copyRect, copyRect, srcCopy, NIL)
				ELSE
					CopyBits(BitMapPtr(rotPixMap3^)^, BitMapPtr(onCScreen^.portPixMap^)^, copyRect, copyRect, srcCopy, NIL);
				IF toooooFast THEN
					Delay(90, finalTicks);
      { +++++ }
				err := RotateBits(rotBitMap3, rotBitMap4);
				ErrorOut(4, rotBitMap3, err);
				IF colorDepth > 1 THEN
					BlockMove(Ptr(@rotBitMap4), Ptr(rotPixMap4^), SIZEOF(BitMap));
				EraseRect(kWindPICTrect);
				copyRect := rotBitMap4.bounds;
				IF colorDepth = 1 THEN
					CopyBits(rotBitMap4, onBWScreen^.portBits, copyRect, copyRect, srcCopy, NIL)
				ELSE
					CopyBits(BitMapPtr(rotPixMap4^)^, BitMapPtr(onCScreen^.portPixMap^)^, copyRect, copyRect, srcCopy, NIL);

				myRotHdl4 := RecoverHandle(rotBitMap4.baseAddr);   { The last straggler ... }
				HUnlock(myRotHdl4);
				DisposHandle(myRotHdl4);

      { ------------------------------- }
      { Now, wasn't that neat, folks !! }
      { ------------------------------- }

100:
				IF colorDepth > 1 THEN
				BEGIN
					DisposHandle(Handle(ourCTHandle));
					DisposPixMap(rotPixMap1);            { The one & only original ... }
					DisposPixMap(rotPixMap2);
					DisposPixMap(rotPixMap3);
					DisposPixMap(rotPixMap4);
				END   { IF colorDepth > 1 }

				ELSE

				BEGIN
					DisposPtr(Ptr(rotBitMapPtr1));
					DisposPtr(Ptr(rotBitMapPtr2));
					DisposPtr(Ptr(rotBitMapPtr3));
					DisposPtr(Ptr(rotBitMapPtr4));
				END;   { ELSE }
200:
				DisposOffScreen;

				SetPort(oldPort);

				RemoveVBLTask;

			END;   { RotateItem }

			DissolveItem: 
			BEGIN

				IF NOT applWind THEN               { Whoops !! }
					EXIT(DoGraphics);
				;
				GetPort(oldPort);

      { ------------------- }
      { Here we go again !! }
      { ------------------- }

				kFullPICTrect := scrolledFullPICTrect;
				LocalGlobal(kFullPICTrect);
				;
				kWindPICTrect := windPICTrect;
				CreateOffScreenError := CreateOffScreen(kWindPICTrect);
				IF CreateOffScreenError <> noErr THEN
					GOTO 300;
				;
				WITH screenBits.bounds DO           { _GlobalToLocal }
					OffsetRect(kFullPICTrect, left, top);

				ClipRect(kWindPICTrect);
				EraseRect(kWindPICTrect);            { ... a clean slate. }
				;
				BackColor(whiteColor);
				ForeColor(blackColor);
				;
				onScreenRgn := NewRgn;
				RectRgn(onScreenRgn, screenBits.bounds);
				CopyBits(oldPort^.portBits, offBitMapPtr^, windPICTrect, kWindPICTrect, srcCopy, onScreenRgn);
				DisposeRgn(onScreenRgn);

				ToOnScreen;

				ClipRect(kWindPICTrect);
				EraseRect(kWindPICTrect);

				WITH screenBits.bounds DO           { Bomb-aroo if dissolving OFF screen !! }
				BEGIN
					IF kWindPICTrect.top < top THEN
						kWindPICTrect.top := top;
					IF kWindPICTrect.left < left THEN
						kWindPICTrect.left := left;
					IF kWindPICTrect.bottom > bottom THEN
						kWindPICTrect.bottom := bottom;
					IF kWindPICTrect.right > right THEN
						kWindPICTrect.right := right;
				END;   { WITH }
				;
				ignore := SectRect(kWindPICTrect, kFullPICTrect, kFullPICTrect);   { Just the pic. }

				DissBits(offBitMapPtr^, onScreenBitsPtr^, kFullPICTrect, kFullPICTrect);
300:
				DisposOffScreen;

				SetPort(oldPort);

			END;   { DissolveItem }

			GdisabledItem: 
			BEGIN
			END;   { GdisabledItem }

			QuitItem: 
				DoQuit;

			OTHERWISE
			BEGIN
			END;   { OTHERWISE }

		END;   { CASE...OF }

	END;   { DoGraphics }



{ ---------------------------------------------------------------- }
{ HandleMenu is the top level dispatch routine for menu commands.  }
{ The item selected is passed to the appropriate menu handler.     }
{ ---------------------------------------------------------------- }

	PROCEDURE HandleMenu;

		VAR
			menuCode: LONGINT;
			charCode: INTEGER;

	BEGIN
		IF Event.what = MouseDown THEN
			menuCode := MenuSelect(Event.where)
		ELSE
		BEGIN
			charCode := BitAnd(Event.message, CharCodeMask);
			menuCode := MenuKey(CHR(charCode));
		END;   { ELSE }

		CASE HiWord(menuCode) OF
			AppleMenuID: 
				DoApple(LoWord(menuCode));
			EditMenuID: 
				DoEdit(LoWord(menuCode));
			GraphicsMenuID: 
				DoGraphics(LoWord(menuCode));
			OTHERWISE
				IF Event.what = KeyDown THEN
					SysBeep(10);
		END;   { CASE }

		HiLiteMenu(0)
	END;   { HandleMenu }



	PROCEDURE SetUpMenus;

	BEGIN

		AppleMenu := GetMenu(AppleMenuID);
		InsertMenu(AppleMenu, 0);
		AddResMenu(AppleMenu, 'DRVR');              { + DAs }
		;
		EditMenu := GetMenu(EditMenuID);
		InsertMenu(EditMenu, 0);
		DisableItem(EditMenu, 0);                   { The WHOLE thing !! }
		currEdit := FALSE;
		;
		GraphicsMenu := GetMenu(GraphicsMenuID);
		InsertMenu(GraphicsMenu, 0);
		currGraphics := TRUE;

		DrawMenuBar;

	END;   { SetUpMenus }



{ ------------------------------------------------------------ }
{ Quantify two rectangles for our PICTure.  The 1st is the     }
{ window's portRect, less any Scroll Bar area.  The 2nd is for }
{ the full PICTure centered in the window.  If the PICTure is  }
{ too large to fit, then the topLeft of this "fullPICTrect" is }
{ shoved toward the window portRect's topLeft.                 }
{ ------------------------------------------------------------ }

	PROCEDURE GetPicRects (window: WindowPtr);

		LABEL
			100;

		VAR
			myWindowPic: picHandle;
			tempX, tempY: INTEGER;

	BEGIN

		windPICTrect := window^.portRect;
		;
		WITH windPICTrect DO                       { Clip to this before drawing PICT. }
		BEGIN
			IF (ScrollVert(window) <> NIL) | (ScrollHoriz(window) <> NIL) THEN
			BEGIN
				right := (right + 1) - scrollWidth;
				bottom := (bottom + 1) - scrollHeight;
			END;   { IF }
		END;   { WITH }

		myWindowPic := picHandle(GetWRefCon(window));
		IF myWindowPic = NIL THEN
		BEGIN
			fullPICTrect := windPICTrect;
			GOTO 100;
		END;   { IF myWindowPic = NIL }

		WITH windPICTrect DO
		BEGIN
			tempX := right - left;
			tempY := bottom - top;
		END;   { WITH }

		WITH myWindowPic^^.picFrame DO
		BEGIN
			tempX := tempX - (right - left);          { window width  - PICT width  }
			tempY := tempY - (bottom - top);          { window height - PICT height }
		END;   { WITH }

		IF tempX < 0 THEN
			tempX := 0;
		IF tempY < 0 THEN
			tempY := 0;

		WITH fullPICTrect DO                       { _DrawPicture within this for 1:1 }
		BEGIN
			top := windPICTrect.top + tempY DIV 2;
			bottom := top + (myWindowPic^^.picFrame.bottom - myWindowPic^^.picFrame.top);
			left := windPICTrect.left + tempX DIV 2;
			right := left + (myWindowPic^^.picFrame.right - myWindowPic^^.picFrame.left);
		END;   { WITH }
100:
		scrolledFullPICTrect := fullPICTrect;       { I lied ... a 3rd rect for scrolling. }

	END;   { GetPicRects }



	PROCEDURE RememberPicRects;

	BEGIN

		saveWindPICTrect := windPICTrect;
		saveFullPICTrect := fullPICTrect;
		saveScrolledFullPICTrect := scrolledFullPICTrect;

	END;   { RememberPicRects }
{ ---------- }
	PROCEDURE ResetPicRects;

	BEGIN

		windPICTrect := saveWindPICTrect;
		fullPICTrect := saveFullPICTrect;
		scrolledFullPICTrect := saveScrolledFullPICTrect;

	END;   { ResetPicRects }
{ ---------- }
	PROCEDURE ResetCtls (windPtr: WindowPtr);

		VAR
			oldClip: RgnHandle;
			HCtlValue, VCtlValue: INTEGER;

		PROCEDURE SetMyCtlValue (ctlHndl: ControlHandle; value: INTEGER);

			VAR
				temp: Rect;

		BEGIN
			IF ctlHndl = NIL THEN
				EXIT(SetMyCtlValue);
			;
			temp := ctlHndl^^.contrlRect;
			InsetRect(temp, 1, 1);
			ClipRect(temp);
			SetCtlValue(ctlHndl, value);
		END;   { SetMyCtlValue }

	BEGIN   { ResetCtls }

		oldClip := NewRgn;
		GetClip(oldClip);
		;
		HCtlValue := -(scrolledFullPICTrect.left - fullPICTrect.left) DIV 12;
		VCtlValue := -(scrolledFullPICTrect.top - fullPICTrect.top) DIV 12;
		SetMyCtlValue(ScrollHoriz(windPtr), HCtlValue);
		SetMyCtlValue(ScrollVert(windPtr), VCtlValue);
		;
		SetClip(oldClip);
		DisposeRgn(oldClip);

	END;   { ResetCtls }



{ --------------------------------------------------------------- }
{ Make a separate PROC so we can zoom independently of _TrackBox, }
{ for example, in response to a Menu selection or a keypress:     }
{ --------------------------------------------------------------- }

	PROCEDURE doZoom (window: WindowPtr; partCode: INTEGER);

		VAR
			oldPort: GrafPtr;
			tempRect, srcZoomRect, dstZoomRect: Rect;

		PROCEDURE AdjustWindRect (window: WindowPtr; VAR r: Rect);

			CONST
				frame = 1;
				shadow = 1;
				title = 18;

			VAR
				windDef: INTEGER;

		BEGIN   { AdjustWindRect }

			windDef := GetWVariant(window);
			InsetRect(r, -frame, -frame);
    { ----- }
			IF (windDef = 0) OR (windDef > 3) THEN
				r.top := r.top - title;   { Window has a title bar. }
    { ----- }
			IF (windDef = documentProc) OR (windDef = altDBoxProc) OR (windDef = noGrowDocProc) OR (windDef = zoomDocProc) THEN
				WITH r DO   { Window has a shadow frame. }
				BEGIN
					bottom := bottom + shadow;
					right := right + shadow;
				END;   { WITH r }

		END;   { AdjustWindRect }


	BEGIN   { doZoom }

		IF NOT applWind THEN
			EXIT(doZoom);
		;
		GetPort(oldPort);
		SetPort(window);

		CASE partCode OF

			inZoomOut: 
			BEGIN

				IF NOT WindowPeek(window)^.spareFlag THEN
				BEGIN   { no Zoom box. }
					tempRect := screen;
					InsetRect(tempRect, 2, 2);               { Max zoom rect. }
					;
					CalcWindowFrame(window, srcZoomRect);
					LocalGlobal(srcZoomRect);
					zoomBackIn := srcZoomRect;               { Save for ... }
					dstZoomRect := tempRect;
				END

				ELSE   { has a Zoom box. }

				BEGIN
					stateHandle := WStateHdl(WindowPeek(window)^.dataHandle);
					;
					WITH stateHandle^^ DO
					BEGIN
						srcZoomRect := userState;
						dstZoomRect := stdState;
						;
						AdjustWindRect(window, srcZoomRect);   { ONLY portRects ... so we  }
						AdjustWindRect(window, dstZoomRect);   { need to adjust the sizes: }
					END;   { WITH stateHandle^^ }
				END;   { ELSE has a Zoom box }
      { ---------- }
				ZoomRect(srcZoomRect, dstZoomRect);
				PlaySound('ZoomOut');

				ShowHide(window, FALSE);                   { NOW, wave the magic wand. }
				InvalidScroll(window);
				;
				RememberPicRects;
				ZoomWindow(window, partCode, TRUE);
				GetPicRects(window);                       { ... for NEW portRect. }
				ScrollResize(window);
				;
				InvalidScroll(window);
				ShowHide(window, TRUE);

				nextState := inZoomIn;

			END;   { inZoomOut }

			inZoomIn: 
			BEGIN

				IF NOT WindowPeek(window)^.spareFlag THEN
				BEGIN
					tempRect := screen;
					InsetRect(tempRect, 2, 2);               { Max zoom rect. }
					;
					srcZoomRect := tempRect;
					dstZoomRect := zoomBackIn;
				END   { no Zoom box. }

				ELSE

				BEGIN
					stateHandle := WStateHdl(WindowPeek(window)^.dataHandle);
					;
					WITH stateHandle^^ DO
					BEGIN
						srcZoomRect := stdState;
						dstZoomRect := userState;
						;
						AdjustWindRect(window, srcZoomRect);
						AdjustWindRect(window, dstZoomRect);
					END;   { WITH stateHandle^^ }
				END;   { ELSE has a Zoom box }
      { ---------- }
				ZoomRect(srcZoomRect, dstZoomRect);
				PlaySound('ZoomIn');

				ShowHide(window, FALSE);                { Magic wand time !! }
				InvalidScroll(window);
				;
				ZoomWindow(window, partCode, TRUE);
				ScrollResize(window);
				ResetPicRects;
				SetMaxCtls(window);                     { For IMMEDIATE seeing of          }
				ResetCtls(window);                      { former control values -- SIGH !! }
				;
				InvalidScroll(window);
				ShowHide(window, TRUE);

				nextState := inZoomOut;

			END;   { inZoomIn }

			OTHERWISE               { Nada !! }
			BEGIN
			END;

		END;   { CASE }

		SetPort(oldPort);

	END;   { doZoom }



	PROCEDURE HandleMouse;

		VAR
			tempRect: rect;
			newSize: LONGINT;
			windWidth, windHt: INTEGER;
			mouseLoc: Point;
			theControl: ControlHandle;
			partControl: INTEGER;


	BEGIN

		CASE windowLoc OF

			inDesk: 
			BEGIN

			END;   { inDesk }

			inMenuBar: 
				HandleMenu;

			inSysWindow: 
				SystemClick(Event, TheWindow);          { TheWindow = DA window }

			inContent: 
			BEGIN

				IF TheWindow <> FrontWindow THEN
				BEGIN
					SelectWindow(TheWindow);              { Generates an Activate Event. }
					EXIT(HandleMouse);
				END;   { IF TheWindow <> FrontWindow }

				mouseLoc := Event.where;
				GlobalToLocal(mouseLoc);
				partControl := FindControl(mouseLoc, TheWindow, theControl);
				IF partControl <> 0 THEN
					Scroll(theControl, partControl, mouseLoc)
				ELSE IF DoubleClick THEN
					DoGraphics(QuitItem);

			END;   { inContent }

			inDrag: 
			BEGIN

				IF DoubleClick & (nextState = inZoomOut) THEN
				BEGIN
					doZoom(TheWindow, inZoomOut);
					EXIT(HandleMouse);
				END;   { IF ... }

				tempRect := screen;
				;
				WITH TheWindow^.portRect DO
				BEGIN
					windWidth := right - left;
					windHt := bottom - top;
				END;   { WITH TheWindow^.portRect }
				;
				WITH tempRect DO
				BEGIN
					left := left + windWidth DIV 10;
					right := right - windWidth DIV 10;
					IF (windHt DIV 10 > mBarHt) THEN
					BEGIN
						top := top + windHt DIV 10;
						bottom := bottom - windHt DIV 10;
					END
					ELSE
					BEGIN
						top := top + mBarHt;
						bottom := bottom - mBarHt;
					END;   { ELSE }
				END;   { WITH tempRect }

      { _DragWindow forces the Mouse to stay inside of tempRect. }
				DragWindow(TheWindow, Event.where, tempRect);

      { This craziness ????? is required because I zoom the window in   }
      { response to a keypress.  I call _SizeWindow with NO effective   }
      { change just to re-quantify the userState in the WStateRec(ord). }

				WITH TheWindow^.portRect DO
					SizeWindow(TheWindow, right - left, bottom - top, FALSE);   { NO update !! }

				GetMouse(mouseLoc);
				LocalToGlobal(mouseLoc);
				IF PtInRect(mouseLoc, tempRect) THEN          { It's a drag, allright !! }
					nextState := inZoomOut;
      { ELSE NO change !! }

			END;   { inDrag }

			inGrow: 
			BEGIN

				WITH screen DO
				BEGIN
					SetRect(tempRect, left, top, right - left, bottom - top);
					InsetRect(tempRect, mBarHt, mBarHt);
				END;   { WITH screen }

				newSize := GrowWindow(TheWindow, Event.where, tempRect);
				IF newSize = 0 THEN
					EXIT(HandleMouse);                     { NO change. }

				EraseRect(TheWindow^.portRect);          { The OLD portRect. }
      { InvalRect(TheWindow^.portRect);   --   passed TRUE to _SizeWindow. }
				SizeWindow(TheWindow, LoWord(newSize), HiWord(newSize), TRUE);
				GetPicRects(TheWindow);          { _SizeWindow's NEW portRect affects our picFrame. }
				ScrollResize(TheWindow);
				SetCtlsToMin(TheWindow);
				InvalRect(TheWindow^.portRect);

				nextState := inZoomOut;

			END;   { inGrow }

			inGoAway: 
			BEGIN

				IF TrackGoAway(TheWindow, Event.where) THEN
					DoQuit;

			END;   { inGoAway }

			inZoomOut, inZoomIn: 
				IF TrackBox(TheWindow, Event.where, windowLoc) THEN
					doZoom(TheWindow, windowLoc);

		END;   { CASE }

	END;   { HandleMouse }



	PROCEDURE HandleKey;

		VAR
			keyASCII: INTEGER;
			key: char;

	BEGIN

		IF NOT applWind THEN
			EXIT(HandleKey);

		IF BitAnd(Event.modifiers, $0F00) = cmdKey THEN     { ONLY the Command Key }
			HandleMenu
		ELSE
		BEGIN
			keyASCII := BitAnd(Event.message, CharCodeMask);
			key := CHR(keyASCII);
			IF (key = 'z') | (key = 'Z') THEN
				doZoom(FrontWindow, nextState)
			ELSE
				SysBeep(10);
		END;   { ELSE no Command Key }

	END;   { HandleKey }



{ ================================================== }
{ HandleUpdate re-draws any controls, text, or PICTs }
{ as well as the Grow Icon.                          }
{ ================================================== }

	PROCEDURE HandleUpdate;

		VAR
			oldPort: GrafPtr;
			window: WindowPtr;
			HcntlHdl, VcntlHdl: ControlHandle;

	BEGIN
		GetPort(oldPort);
		window := WindowPtr(Event.message);
		SetPort(window);
		HcntlHdl := ScrollHoriz(window);
		VcntlHdl := ScrollVert(window);

		BeginUpDate(window);
		;
		ClipRect(window^.portRect);
		EraseRect(window^.portRect);
		DrawControls(window);
		IF (HcntlHdl <> NIL) | (VcntlHdl <> NIL) THEN
			DrawGrowIcon(window);
		ClipRect(windPICTrect);                     { Clip to the window, LESS Scroll Bar(s). }
		DrawPicture(monsterPicHdl, scrolledFullPICTrect);   { ... but still draw 1:1          }
		ClipRect(window^.portRect);                 { Reset to see Scroll Bars move }
		;                                           { and be highlighted -- Sigh !! }
		EndUpdate(window);

		SetPort(oldPort)
	END;   { HandleUpdate }



{ ----------------------------------------------- }
{ Need to separate them because we're trying to   }
{ make this blasted thing MultiFinder-compatible: }
{ ----------------------------------------------- }

	PROCEDURE DoActivate (window: WindowPtr);

		VAR
			HcntlHdl, VcntlHdl: ControlHandle;

	BEGIN

		SetPort(window);
		windDef := GetWVariant(window);          { In DisplayWindow, also. }

		HcntlHdl := ScrollHoriz(window);
		IF HcntlHdl <> NIL THEN
			HiliteControl(HcntlHdl, 0);
		;
		VcntlHdl := ScrollVert(window);
		IF VcntlHdl <> NIL THEN
			HiliteControl(VcntlHdl, 0);

		IF (HcntlHdl <> NIL) | (VcntlHdl <> NIL) THEN
			DrawGrowIcon(window);

		IF aMac2 & (colorHandCrsr = NIL) THEN   { Color me paranoid !! }
			colorHandCrsr := GetCCursor(HANDcrsrID);

	END;   { DoActivate }



	PROCEDURE DoDeactivate (window: WindowPtr);

		VAR
			HcntlHdl, VcntlHdl: ControlHandle;

	BEGIN

		HcntlHdl := ScrollHoriz(window);
		IF HcntlHdl <> NIL THEN
			HiliteControl(HcntlHdl, 255);
		;
		VcntlHdl := ScrollVert(window);
		IF VcntlHdl <> NIL THEN
			HiliteControl(VcntlHdl, 255);

		IF (HcntlHdl <> NIL) | (VcntlHdl <> NIL) THEN
			DrawGrowIcon(window);

		IF aMac2 & (colorHandCrsr <> NIL) THEN
		BEGIN
			DisposCCursor(colorHandCrsr);
			colorHandCrsr := NIL;           { Mark as gone !! }
			stillColorCrsr := FALSE;
		END;   { IF aMac2 & () }

	END;   { DoDeactivate }



	PROCEDURE HandleActivate;

		VAR
			window: WindowPtr;

	BEGIN

		window := WindowPtr(Event.message);

		IF ODD(Event.modifiers) THEN
			DoActivate(window)
		ELSE
			DoDeactivate(window);

	END;   { HandleActivate }



	PROCEDURE DoPeriodic;

		VAR
			ignoreError: OSErr;

	BEGIN

		IF NOT WNE THEN
			SystemTask;

		colorDepth := TestForColor;
		PeriodicMenus;                    { Feeds HandleCursor. }
		HandleCursor;
		;
		IF Sleep = 1 THEN
			Sleep := GetCaretTime;          { Reset after special effects. }
		;
		IF applWind & InForeGround THEN
		BEGIN

			SetMaxCtls(FrontWindow);

			IF justOpened THEN
			BEGIN
				justOpened := FALSE;          { Just once, Sam !! }
				SpiffyDissolve;

      { Retrieve Scroll Bars AFTER the dissolve so they don't get in the way: }

				horizControl := GetNewControl(horizScrollID, TheWindow);
				vertControl := GetNewControl(vertScrollID, TheWindow);
				ScrollResize(TheWindow);
				GetPicRects(TheWindow);

				InvalRect(TheWindow^.portRect);   { NOW do the Update !! }
			END;   { IF justOpened }

			IF justBragging THEN
			BEGIN
				justBragging := FALSE;
				SpiffyRoll;
			END;   { IF justBragging }

		END;   { IF applWind & InForeGround }

	END;   { DoPeriodic }



	PROCEDURE MainEventLoop;

		VAR
			ignoreResult: BOOLEAN;

	BEGIN

		REPEAT

			IF WNE THEN
				ignoreResult := WaitNextEvent(everyEvent, Event, Sleep, NIL)
			ELSE
				ignoreResult := GetNextEvent(everyEvent, Event);

			CASE Event.what OF

				NullEvent: 
					DoPeriodic;

				MouseDown: 
				BEGIN
					windowLoc := FindWindow(Event.where, TheWindow);     { Fills in 'TheWindow'. }
					HandleMouse;
				END;

				MouseUp: 
				BEGIN
				END;

				KeyDown, AutoKey: 
					HandleKey;

				KeyUp: 
				BEGIN
				END;

				UpdateEvt: 
					HandleUpdate;

				DiskEvt: 
				BEGIN
				END;

				ActivateEvt: 
					HandleActivate;

				NetworkEvt, DriverEvt: 
				BEGIN
				END;

				App1Evt, App2Evt, App3Evt: 
				BEGIN
				END;

				OSEvent:                                   { MultiFinder Event = app4Evt }

				BEGIN

					CASE BSR(Event.message, 24) OF          { High byte }

						mouseMovedMessage: 
							HandleCursor;

						suspendResumeMessage: 

						BEGIN

							IF BAND(Event.message, resumeMask) <> 0 THEN
							BEGIN
								InForeGround := TRUE;
								DoActivate(FrontWindow)
							END   { Resume }
							ELSE   { Suspend }
							BEGIN
								InForeGround := FALSE;
								DoDeactivate(FrontWindow);
							END;   { ELSE }

						END;   { suspendResumeMessage }

						OTHERWISE
					END;   { CASE BSR(Event.message, 24) OF }

				END;   { MultiFinder Event }

				OTHERWISE
			END;  { CASE Event.what OF }

		UNTIL Done;

	END;   { MainEventLoop }




BEGIN   { Program }

	InitManagers;                  { The usual stuff ... }
	;
	PlaySound('Oops');

	Done := FALSE;
	aMac2 := TestForMac2;
	colorHandCrsr := NIL;
	stillColorCrsr := FALSE;
	InForeGround := TRUE;          { Assume UniFinder. }
	WNE := WNEisImplemented;
	Sleep := GetCaretTime;
	acurHdl := NIL;               { See "RemoveVBLTask". }
	nextState := inZoomOut;
	SetUpMenus;

	screen := RgnHandlePtr(GrayRgn)^^^.rgnBBox;
	;
	ROM := wordPtr(ROM85Loc);
	IF ROM^ > 0 THEN
		mBarHt := wordPtr(mBarHeightLoc)^
	ELSE
		mBarHt := 20;

	monsterPicHdl := GetPicture(monsterID);
	IF Handle(monsterPicHdl) = NIL THEN
		GOTO 100;
	HLock(Handle(monsterPicHdl));

	IF aMac2 THEN
		TheWindow := GetNewCWindow(mainWindowID, NIL, WindowPtr(-1))
	ELSE
		TheWindow := GetNewWindow(mainWindowID, NIL, WindowPtr(-1));

	IF TheWindow = NIL THEN
	BEGIN
		HUnlock(Handle(monsterPicHdl));
		ReleaseResource(Handle(monsterPicHdl));
		GOTO 100;
	END;   { IF TheWindow = NIL }
	SetPort(TheWindow);

{ Retrieve Scroll Bars AFTER the dissolve so they don't get drawn pre-maturely. }

	SetWindowPalette(TheWindow, mainWindowID);        { Palette ID = Window ID. }
	SetWRefCon(TheWindow, LONGINT(monsterPicHdl));    { Save for scrolling later. }
	DisplayWindow(TheWindow);

	ValidRect(TheWindow^.portRect);   { Postpone Update until AFTER the dissolve. }
	justOpened := TRUE;               { See "DoPeriodic" ... }
	justBragging := FALSE;

	MainEventLoop;
	;
	PlaySound('Moof');

100:
	ExitToShell;



END.   { Program }