{ MPW Pascal 3.0 program to test the execution speed of IF-THIN-ELSE }
{ and CASE statements.  Written from a discussion in MacTutor magazine }
{ (Sept. 1990, pp. 4-5). }

{ written by David T. Craig -- 30 Sept 1990 }
{ 9939 Locust, Apt. 4013, Kansas City, Missouri 64131 }

program p_tester;

USES
  MemTypes,   { Macintosh common types }
  OSIntf,     { Macintosh Operating System interface }
  ToolIntf,   { Macintosh ToolBox interface }
  Packages,   { Macintosh Package interface }
  SANE,       { Macintosh FP interface }
  PasLibIntf, { Pascal runtime libary interface }
  IntEnv,     { MPW integrated environment interface }
  CursorCtl;  { MPW shell cursor unit }

var global_b : integer;

{ ########################################################################## }

{$s seg_ifthenelse}

procedure test_if_then_else (b: integer);

  const iteration_max = 1000000; { one million }
  
  var start_time,stop_time : longint;
      elapsed_secs         : real;
      i                    : longint;
  
  begin
    start_time := TickCount; { accurate to 1/60 of a second }
    
    for i := 1 to iteration_max do
      begin
        if b =  1 then begin end else
	if b =  2 then begin end else
	if b =  3 then begin end else
	if b =  4 then begin end else
	if b =  5 then begin end else
	if b =  6 then begin end else
	if b =  7 then begin end else
	if b =  8 then begin end else
	if b =  9 then begin end else
	if b = 10 then begin end else
	if b = 11 then begin end else
	if b = 12 then begin end else
	if b = 13 then begin end else
	if b = 14 then begin end else
	if b = 15 then begin end;
      end; { for i }
    
    stop_time := TickCount;
    
    elapsed_secs := (stop_time - start_time) / 60.0;
    
    WRITELN('  IF-THEN-ELSE Test [b=',b:2,'] : ',elapsed_secs:0:3,' seconds');
  end;

{ ########################################################################## }

{$s seg_case}

procedure test_case (b: integer);

  const iteration_max = 1000000; { one million }
  
  var start_time,stop_time : longint;
      elapsed_secs         : real;
      i                    : longint;

  begin
    start_time := TickCount; { accurate to 1/60 of a second }
    
    for i := 1 to iteration_max do
      begin
        case b of
	   1 : begin end;
	   2 : begin end;
	   3 : begin end;
	   4 : begin end;
	   5 : begin end;
	   6 : begin end;
	   7 : begin end;
	   8 : begin end;
	   9 : begin end;
	  10 : begin end;
	  11 : begin end;
	  12 : begin end;
	  13 : begin end;
	  14 : begin end;
	  15 : begin end;
	  
	  otherwise begin end;
	end; { case b }
      end; { for i }
    
    stop_time := TickCount;
    
    elapsed_secs := (stop_time - start_time) / 60.0;
    
    WRITELN('  CASE Test time [b=',b:2,'] : ',elapsed_secs:0:3,' seconds');
  end;

{ ########################################################################## }

{$s Main}

begin { --- p_tester --- }

  PLSetVBuf(OUTPUT,NIL,_IOLBF,0); { Apple Macintosh MPW Shell system call }
  
  WRITELN('Starting the IF-THEN-ELSE Test ...');
  WRITELN;
  
  for global_b := 1 to 20 do
    test_if_then_else(global_b);
  
  WRITELN;
  WRITELN('Starting the CASE Test ...');
  WRITELN;
  
  for global_b := 1 to 20 do
    test_case(global_b);
  
  WRITELN;
  WRITELN('That''s all folks ...');
  
end.  { --- p_tester --- }

{ ########################################################################## }
{                                    finis                                   }
{ ########################################################################## }