/*
 * File:	PieUtils.c
 *
 * Purpose: This file contains utility functions
 *			used by the Pie Popup Menu routines.
 */


/* The separating character between menu items. */
#define	MENU_SEPARATOR	';'

int	
ConvertMenuList(char *menuList)
{
	char	*cp1;
	char	*cp2;
	int	num_items;
	int	in_item = FALSE;
	
	/* 
	 * Scan the menu list eliminating any of
	 * the native Mac Menu Manager's special
	 * characters.
	 */
	for (cp1 = cp2 = menuList, 
		 num_items = 0; *cp2 != '\0'; 
		 cp2++) {
		switch (*cp2) {
			/*
			 * For the following types of items
			 * discard the argument character that
			 * follows.
			 */
			case '^':	/* icon */
			case '!':	/* mark */
			case '<':	/* special style */
			case '/':	/* keyboard equivalent */
						cp2++;
						/* Don't go past the end */
						if (*cp2 == '\0')
							cp2--;
						break;
			
			/* Ignore requests to dim the item. */
			case '(':
						break;
			
			/* For menu separators copy the item */
			case MENU_SEPARATOR:
						++num_items;
						*cp1++ = *cp2;
						in_item = FALSE;
						break;
			
			/* Default is to just copy the char */
			default:
					*cp1++ = *cp2;
					in_item = TRUE;
					break;
		}
	}
	
	/* 
	 * The last item isn't required to have a
	 * separator.
	 */
	if (in_item)
		++num_items;
		
	/*
	 * We've built the modified menu list in 
	 * place, so discard the rest of the list.
	 */
	*cp1 = '\0';
	
	return (num_items);
}

