#include	<MacTypes.h>
#include	<MenuMgr.h>
#include	<QuickDraw.h>
#include	<SetUpA4.h>
#include	"HyperXCmd.h"

#define	ERRORFLAG			(short)	-1


/*
 *  Local function prototypes.
 */
int		GetLocOfCardWindow(XCmdBlockPtr, Point *);
Handle	CopyStrToHand(char *);
long	HandleToNum(XCmdBlockPtr, Handle);
void	HandleToPstr(Str255, Handle);
char	*ToCstr(char *);
char	*ToPstr(char *);

/********************************************************************************/
/* The following routines are from the book:	XCMD's for HyperCard			*/
/*												by: Gary Bond					*/
/*												ISBN: 0-943518-85-7				*/
/********************************************************************************/

int
GetLocOfCardWindow(paramPtr, loc)
	XCmdBlockPtr	paramPtr;
	Point			*loc;
{
	Handle	hndl;
	char	str[256];
	
	strcpy(str, "item 1 of rect of card window");
	hndl = EvalExpr(paramPtr, (StringPtr) CtoPstr(str));
	if (paramPtr->result != noErr) {
		SysBeep(5);
		paramPtr->returnValue = (Handle) CopyStrToHand("Can't get rect of card window");
		return((int) ERRORFLAG);
	}
	if (paramPtr->result == noErr) {
		loc->h = HandleToNum(paramPtr, hndl);
		DisposHandle(hndl);
		
		strcpy(str, "item 2 of rect of card window");
		hndl = EvalExpr(paramPtr, (StringPtr) CtoPstr(str));
		if (paramPtr->result == noErr) {
			loc->v = HandleToNum(paramPtr, hndl);
			DisposHandle(hndl);
			return(noErr);
		}
	}
	paramPtr->returnValue = (Handle) CopyStrToHand("Can't get rect of card window");
	return ((int) ERRORFLAG);
}



Handle
CopyStrToHand(str)
	char *str;
{
	Handle newHndl;
	
	newHndl = (Handle) NewHandle((long) strlen(str) + 1);
	strcpy((char *) (*newHndl) , str);
	return(newHndl);
}



long
HandleToNum(paramPtr, hndl)
	XCmdBlockPtr	paramPtr;
	Handle			hndl;
{
	char	str[32];
	long	num;
	
	strcpy(str, *hndl);
	num = StrToLong(paramPtr, (unsigned char *) ToPstr(str));
	return(num);
}



char *
ToCstr(str)
	char *str;
{
	unsigned char	length,i;
	
	length = str[0];
	for (i = 0; i < length; ++i)
		str[i] = str[i+1];
	str[length] = 0;
	return(str);
}



char *
ToPstr(str)
	char *str;
{
	unsigned char	length, i;
	
	for (i = 0, length = 0; str[i] != 0; ++i)
		++length;
	
	while (i--)
		str[i+1] = str[i];
	
	str[0] = length;
	return(str);
}

