/************************************************************************/
/*				  														*/
/*	Source   - 4th Debugger.r											*/
/*	Author   - Alexander S. Colwell, Copyright  1990					*/
/*																		*/
/*	Purpose	 - This is 4th Debugger resource file.						*/
/*																		*/
/************************************************************************/

#include "Types.r"
#include "SysTypes.r"

type 'EA4h' { pstring; };

resource 'BNDL' (128, purgeable) {
	'EA4h', 0,
	{	
		'ICN#', { 0, 128 },
		'FREF', { 0, 128 }
	}
};

resource 'FREF' (128) {
	'APPL', 0, ""
};

resource 'EA4h' (0) {
	"External Area Debugger"
};

resource 'MBAR' (1, preload) {
	{ 1, 2, 3, 128 }
};

resource 'MENU' (1, "Apple") {
	1, textMenuProc, 0x7FFFFFFD, enabled, apple,
	{
		"About 4th Dim Debugger#256", noIcon, noKey, noMark, plain,
		"-", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (2, "File") {
	2, textMenuProc, allEnabled, enabled, "File",
	{
		"Page Setup#8", noIcon, noKey, noMark, plain,
		"Print#9", noIcon, "P", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Quit#1", noIcon, "Q", noMark, plain
	}
};

resource 'MENU' (3, "Edit", preload) {
	3, textMenuProc, 0x7FFFFF80, enabled, "Edit",
	{
		"Undo#16", noIcon, "Z", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Cut#18", noIcon, "X", noMark, plain,
		"Copy#19", noIcon, "C", noMark, plain,
		"Paste#20", noIcon, "V", noMark, plain,
		"Clear#21", noIcon, noKey, noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Select All#1035", noIcon, "A", noMark, plain,
		"Hide Debugger#1036", noIcon, "D", noMark, plain,
		"Show Clipboard#22", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (128, "Emulate") {
	128, textMenuProc, allEnabled, enabled, "Emulate",
	{
		"Open External Area#1024", noIcon, "O", noMark, plain,
		"Close External Area#1025", noIcon, "W", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Run External Procedure 1#1026", noIcon, "1", noMark, plain,
		"Run External Procedure 2#1027", noIcon, "2", noMark, plain,
		"Run External Procedure 3#1028", noIcon, "3", noMark, plain,
		"Run External Procedure 4#1029", noIcon, "4", noMark, plain,
		"Run External Procedure 5#1030", noIcon, "5", noMark, plain,
		"Run External Procedure 6#1031", noIcon, "6", noMark, plain,
		"Run External Procedure 7#1032", noIcon, "7", noMark, plain,
		"Run External Procedure 8#1033", noIcon, "8", noMark, plain,
		"Run External Procedure 9#1034", noIcon, "9", noMark, plain
	}
};

resource 'WIND' (500, "4th External Area") {
	{40, 4, 210, 352},
	zoomDocProc, invisible, goAway, 0,
	"4th External Area"
};

resource 'WIND' (501, "4th External Debugger") {
	{235, 4, 335, 352},
	zoomDocProc, visible, goAway, 0,
	"Debugger"
};

resource 'DLOG' (500, "About This...") {
	{40, 40, 128, 304},
	dBoxProc, visible, noGoAway, 0, 500,
	"About This..."
};

resource 'DITL' (500, "About This...") {
	{
		{8, 52, 26, 216},
		StaticText { enabled, "4th Dimension Debugger" },
		{27, 95, 45, 173},
		StaticText { enabled, "Version 1.0" },
		{46, 29, 64, 240},
		StaticText { enabled, "Written by Alexander S. Colwell" },
		{65, 76, 83, 194},
		StaticText { enabled, "Copyright  1990" }
	}
};

resource 'STR#' (1036, "Hide/Show Debugger") {
	{
		"Hide Debugger",
		"Show Debugger"
	}
};

resource 'ICN#' (128, purgeable) {
	{
		$"00 00 00 00 72 00 1F E0 45 00 20 20 67 7F C0 7F"
		$"45 00 80 F8 75 01 01 F0 00 02 03 E0 FF FC 07 FF"
		$"00 08 0F 80 00 10 1F 00 00 20 3E 00 FF C0 7F FF"
		$"00 80 FF F8 01 01 F0 10 02 03 E0 20 FC 07 C0 7F"
		$"08 0F 80 F8 10 1F 01 FC 20 00 00 04 C0 00 00 0F"
		$"40 00 00 1F 40 00 00 3E 40 00 00 7C FF E0 3F FF"
		$"3F C0 7F F0 3F 80 FF E0 3F 01 FF C0 FF FF FF FF"
		$"00 7F C0 00 00 FF 80 00 01 FF 00 00 FF FF FF FF",

		$"FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF"
		$"FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF"
	}
};

/************************************************************************/
/*				  														*/
/* Think C Object Resources 											*/
/*																		*/
/************************************************************************/

type 'Estr' { pstring; };

resource 'WIND' (200, "Clipboard", purgeable, preload) {
	{130, 158, 238, 444},
	zoomDocProc, invisible, goAway, 0,
	"Clipboard"
};

resource 'ALRT' (128, "General", purgeable) {
	{32, 10, 164, 328},
	128,
	{
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent
	}
};

resource 'ALRT' (150, "Confirm Revert", purgeable) {
	{100, 120, 190, 420},
	150,
	{
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent
	}
};

resource 'ALRT' (151, "Save Changes", purgeable) {
	{42, 34, 184, 350},
	151,
	{
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent
	}
};

resource 'ALRT' (200, "Severe Error", purgeable) {
	{32, 10, 168, 352},
	200,
	{
		OK, visible, sound1,
		OK, visible, sound1,
		OK, visible, sound1,
		OK, visible, sound1
	}
};

resource 'ALRT' (250, "No Printer", purgeable) {
	{40, 40, 156, 382},
	250,
	{
		OK, visible, sound1,
		OK, visible, sound1,
		OK, visible, sound1,
		OK, visible, sound1
	}
};

resource 'ALRT' (300, "OS Error", purgeable) {
	{32, 10, 168, 352},
	300,
	{
		OK, visible, sound1,
		OK, visible, sound1,
		OK, visible, sound1,
		OK, visible, sound1
	}
};

resource 'DITL' (128, "General", purgeable) {
	{
		{98, 231, 118, 291},
		Button { enabled, "OK" },
		{14, 25, 82, 299},
		StaticText { disabled, "^0" }
	}
};

resource 'DITL' (150, "Confirm Revert", purgeable) {
	{
		{60, 208, 80, 290},
		Button { enabled, "OK" },
		{60, 105, 80, 187},
		Button { enabled, "Cancel" },
		{5, 113, 45, 293},
		StaticText { disabled, "Revert to the last version saved ?" },
		{47, 10, 64, 66},
		StaticText { disabled, "Caution" }
	}
};

resource 'DITL' (151, "Save Changes", purgeable) {
	{
		{74, 35, 94, 117},
		Button { enabled, "Yes" },
		{111, 35, 131, 117},
		Button { enabled, "No" },
		{111, 205, 131, 287},
		Button { enabled, "Cancel" },
		{14, 25, 55, 291},
		StaticText { disabled, "Save changes to ^0 before ^1?" }
	}
};

resource 'DITL' (200, "Severe Error", purgeable) {
	{
		{104, 264, 124, 324},
		Button { enabled, "Proceed" },
		{104, 168, 124, 228},
		Button { enabled, "Quit" },
		{16, 80, 87, 332},
		StaticText { disabled, "^0\n\nResult Code = ^1" }
	}
};

resource 'DITL' (250, "No Printer", purgeable) {
	{
		{85, 262, 105, 327},
		Button { enabled, "OK" },
		{14, 84, 67, 327},
		StaticText { disabled, "Printing operations are not possible "
			         "until you have selected a Printer using the"
			         " Chooser. " }
	}
};

resource 'DITL' (300, "OS Error", purgeable) {
	{
		{104, 264, 124, 324},
		Button { enabled, "OK" },
		{16, 80, 87, 332},
		StaticText { disabled, "^0\n\nResult Code = ^1" }
	}
};

resource 'CNTL' (300, "Scroll Bar", preload) {
	{0, 0, 0, 0},
	0, invisible, 0, 0, scrollBarProc, 0,
	""
};

resource 'STR#' (128, "Common") {
	{
		"quitting",
		"closing",
		"Undo ",
		"Redo ",
		"Untitled",
		"Show Clipboard",
		"Hide Clipboard"
	}
};

resource 'STR#' (129, "Memory Warnings") {
	{
		"Memory is running low. Please close "
		"windows and save documents to avoid losing "
		"data."
	}
};

resource 'STR#' (130, "Task Names") {
	{
	}
};

resource 'STR ' (150, "SaveAs Prompt", purgeable) {
	"Save File As:"
};

resource 'STR ' (300, "OS Error", purgeable) {
	"Mac OS Error Encountered"
};

resource 'Estr' (-192, "resNotFound", purgeable) {
	"Tried to get a nonexistent resource"
};

resource 'SICN' (200, "Grow Box", preload) {
	{
		$"FF FF 80 01 80 01 9F C1 90 41 90 7D 90 45 90 45"
		$"90 45 9F C5 84 05 84 05 84 05 87 FD 80 01 FF FF"
	}
};

