/************************************************************************/
/*				  														*/
/*	Source   - CalendarDebugger.c										*/
/*	Author   - Alexander S. Colwell, Copyright  1990					*/
/*																		*/
/*	Purpose	 - This is Calendar simulator.								*/
/*																		*/
/************************************************************************/

#include "Calendar.h"				/* Calendar defs					*/
#include "4th Debugger.h"			/* 4th Debugger						*/

pascal void SetCalendar(),GetCalendar();/* Define external references	*/
void		DoSetCalendar(),DoGetCalendar();

void C4thDbgApp::InitExtArea(void)	/* Initialized for debugging		*/
	{
		Str255	item;				/* Working item string				*/
		
		SetExtArea(65,25,265,127);	/* Set external rect area			*/
		SetExtName("\pCalendarArea");/* Set ext area name				*/
		
		InstallExtProc(ep1,(ProcPtr)(DoSetCalendar));/* Install ext procs*/
		InstallExtProc(ep2,(ProcPtr)(DoGetCalendar));
		
									/* Setup external procedure items	*/
		BlockMove("\pSet Calender Data",item,18L);
		gBartender->SetCmdText(ep1,item);
		BlockMove("\pGet Calendar Data",item,18L);
		gBartender->SetCmdText(ep2,item);
		
		gBartender->RemoveMenuCmd(ep3);/* Remove remainding ext proc items*/
		gBartender->RemoveMenuCmd(ep4);
		gBartender->RemoveMenuCmd(ep5);
		gBartender->RemoveMenuCmd(ep6);
		gBartender->RemoveMenuCmd(ep7);
		gBartender->RemoveMenuCmd(ep8);
		gBartender->RemoveMenuCmd(ep9);
	}

void	DoSetCalendar(CCalendar **eaObject)
	{
		short	itsMonth = 1;		/* Working month					*/
		short	itsYear = 1990;		/* Working year						*/
		long	itsSelect = 0L;		/* Working day selection			*/
		
									/* Set new calendar date/selection	*/
		SetCalendar(eaObject,&itsMonth,&itsYear,&itsSelect);
	}

void	DoGetCalendar(CCalendar **eaObject)
	{
		short	itsMonth;			/* Working month					*/
		short	itsYear;			/* Working year						*/
		long	itsSelect;			/* Working day selection			*/
		
									/* Set new calendar date/selection	*/
		GetCalendar(eaObject,&itsMonth,&itsYear,&itsSelect);
		
									/* Output debugging information		*/
		DbgPrint("month - %d, year - %d, select - %lx\n",
			itsMonth,itsYear,itsSelect);
	}

