/********************************************************************/
/*																	*/
/*	Include  - Debugger.h											*/
/*	Author   - Alexander S. Colwell, Copyright  1988, 1989			*/
/*																	*/
/*	Purpose  - This is the "Debugger" desk accessory include file.	*/
/*																	*/
/*	Revisions - None.												*/
/*																	*/
/********************************************************************/

#ifndef _Debugger_
#define	_Debugger_

#define	debuggerType	'Dbgr'		/* Debugger resource type		*/
#define	debuggerName	"\pDebugger Reference"/* Debugger res name	*/

typedef enum {						/* Debugger error types			*/
	dbgNoOvrFlw,					/* No, overflow					*/
	dbgTableOvrFlw,					/* Table overflow				*/
	dbgDataOvrFlw,					/* Data buffer overflow			*/
	dbgBufOvrFlw					/* Buffer size overflow			*/
	} DBGERROR;
	
typedef enum {						/* Debugger types				*/
	accDbgPrint = 128,				/* Perform LSC debugging line	*/
	accDbgDump						/* Perform debugging dump		*/
	} DBGTYPE;

typedef struct {					/* Debugger Interface defs		*/
	short	daRefNbr;				/* DA's reference number		*/
	DBGERROR bufError;				/* Buffer error indicator		*/
	long	bufTableIdx;			/* Buffer index					*/
	long	bufNextIdx;				/* Next buffer index			*/
	long	bufDataIdx;				/* Buffer data index			*/
	long	bufTableSize;			/* Buffer index table size		*/
	long	bufDataSize;			/* Buffer data handle size		*/
	long	**bufTable;				/* Buffer index table			*/
	char	**bufData;				/* Buffer data handle			*/
	} DBGINTERFACE;
typedef DBGINTERFACE	*DBGPTR;
typedef	DBGPTR			*DBGHDL;
									
#ifdef  DbgPrint					/* Check if it's defined		*/
#undef  DbgPrint					/* Kill DbgPrint definition		*/
#endif

DBGHDL	DbgGetRefHdl();				/* Debugging proto-types		*/
void	DbgPrint(/* DBGHDL dbgRefHdl, char *fmt, var-args... */);
void	DbgBufPrint(/* DBGHDL dbgRefHdl, char *fmt, var-args... */);
void	DbgDump(DBGHDL dbgRefHdl, char *buffer, long size);
void	DbgBufDump(DBGHDL dbgRefHdl, char *buffer, long size);
long	DbgStrLen(char *str);

#endif
