program AsynchSoundDemo;
{This program was written to demonstrate}
{asnchronous sound generation on the Macintosh}
{using the Sound Manager.  Written in THINK}
{Pascal v3.0 by Aaron E. Walsh, expressly for}
{publication by MacTutor magazine.   6/1/90}


	uses
		Sound;

	var
		mySoundDone: boolean;
		mySoundHandle: handle;
		SndResource: integer;
		mySoundChannel: SndChannelPtr;
		error: OSerr;
		mySoundCommand: Sndcommand;

{=========================}
	procedure DisposeMusic;
		var
			quietnow: boolean;
	begin

		quietnow := false;
		hpurge(mySoundHandle);
		error := SndDisposeChannel(mySoundChannel, quietnow);

		if error <> NoErr then
			FlashMenuBar(0);

		if gethandlesize(mySoundHandle) > 0 then
			ReleaseResource(mySoundHandle);

	end;
{=========================}
	procedure myCallBack (chan: SndChannelPtr;
									cmd: SndCommand);
{userRoutine to be called when the last sound}
{command has been processed. A5 code used	}
{to access globalsfrom S.M. documentation.	}
		var
			theA5: Longint;
	begin
		theA5 := SetA5(cmd.param2);
{Get/Set A5 so globals are available}

		mySoundDone := true;
		theA5 := SetA5(theA5);
{Set A5, as in S.M. documentation}

	end; {DisposeMusic}
{=========================}
	function LoadMusic: boolean;

	begin

		SndResource := 15944;
{Resource ID of the 'snd ' resource to play}

		mySoundHandle := GetResource('snd ', SndResource);
{we need a handle to the resource}

		movehhi(mySoundHandle);
{move into high memory}

		hlock(mySoundHandle);
{lock it down, call me paranoid}

		hnopurge(mySoundHandle);
{make it unpurgeable, call me untrusting}

		mySoundChannel := nil;

		error := SndNewChannel(mySoundChannel, 0, 0, @myCallBack);
{create our own sound channel for asnch. ability}

		if error <> NoErr then
			LoadMusic := False
		else
			LoadMusic := True;

	end;
{=========================}
	procedure PlayMusic;
		var
			noWait: boolean;

	begin

		with mySoundCommand do
			begin
				cmd := callBackCmd;
				param1 := 0;
				param2 := SetCurrentA5;
{use param2 to stash A5.  We will use need}
{globals in the callback routine}

			end;

		noWait := False;

		if error = NoErr then
			error := SndPlay(mySoundChannel, mySoundHandle, TRUE);
{begin asynchronous sound play}

		if error = NoErr then
			error := SndDoCommand(mySoundChannel, mySoundCommand, noWait);
{add the callBack command to the sound channel queue}

	end; {PlayMusic}
{=========================}
begin  {main}

	mySoundDone := false;

	if LoadMusic then
		PlayMusic;

	repeat
		flashmenubar(0);
{flash menubar to demonstrate}
{asyncronous sound generation}
	until button or mySoundDone;

	DisposeMusic;
{clean up, or crash}

end.