      SUBROUTINE MXMPY (A, B, C, L, M, N)
C-------------------------------------------------
C  Performs the matrix multiplication A * B = C.
C
C  Input:  A - an L x M matrix.
C          B - an M x N matrix.
C          L, M, N - dimensions of the matrices
C  Output: C - an L x N matrix.
C
C  April 1990
C  Jon Bell, Dept. of Physics & Computer Science
C  Presbyterian College, Clinton SC 29325
C
C  Written in Language Systems FORTRAN, v2.0
C-------------------------------------------------
      IMPLICIT NONE
      INTEGER I, J, K, L, M, N
      EXTENDED A(L,M), B(M,N), C(L,N), SUM
      DO I = 1, L
         DO J = 1, N
            SUM = 0.0X0
            DO K = 1, M
               SUM = SUM + A(I,K) * B(K,J)
            END DO
            C(I,J) = SUM
         END DO
      END DO
      END
