/* 
	1987-89 Apple Computer. All Rights Reserved.
*/

#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __SYSTYPES.R__
#include "SysTypes.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif


#if qDebug
include "Debug.rsrc";
#endif

include "MacApp.rsrc";
include "Printing.rsrc";

include "TEOther.rsrc";	/* DLOG & DITL 1001; ICON 256,257; ICN# 128,129 */
include "TEDrag" 'CODE';

#define cHelp 		1001
#define cDrawBox	2001
#define cDragBox	3001
#define cSizer		4001

#define cBlack 	5001
#define cBlue 		5002
#define cGreen 	5003
#define cRed 		5004
#define cWhite 	5005

#define kSignature		'JLMT'
#define kDocFileType		'JL01'
#define getInfoString	"1991 J.Langowski/MacTutor. Parts translated from MacApp Pascal."

/* ------------------------------------------------------------------------------------*/
resource 'WIND' (1001, purgeable) {
	{50, 20, 250, 450},
	zoomDocProc,
	invisible,
	goAway,
	0x0,
	"<<<>>>"
};


/* ------------------------------------------------------------------------------------*/
resource 'DITL' (201, purgeable) {
	 {	/* array DITLarray: 3 elements */
		/* [1] */
		{130, 182, 150, 262},
		Button {
			enabled,
			"OK"
		};
		/* [2] */
		{10, 80, 110, 270},
		StaticText {
			disabled,
			"Displays text and graphics objects"
			"\n\nThis program was written "
			"with MacApp  1985-1989 Apple Computer, Inc."
		};
		/* [3] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			1
		}
	}
};

resource 'ALRT' (201, purgeable) {
	{90, 100, 250, 412},
	201,
	{
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent
	}
};


/* ------------------------------------------------------------------------------------*/
resource 'cmnu' (1) {
	1,
	textMenuProc,
	0x7FFFFFFB,
	enabled,
	apple,
	 {
		"About TEDemo", noIcon, noKey, noMark, plain, cAboutApp;
		"Help", noIcon, "H", noMark, plain, cHelp;
		"-", noIcon, noKey, noMark, plain, nocommand
	}
};

resource 'cmnu' (2) {
	2,
	textMenuProc,
	allEnabled,
	enabled,
	"File",
	 {
		"New", noIcon, "N", noMark, plain, 10;
		"Open", noIcon, "O", noMark, plain, 20;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Close", noIcon, noKey, noMark, plain, 31;
		"Save", noIcon, "S", noMark, plain, 30;
		"Save As", noIcon, noKey, noMark, plain, 32;
		"Save a Copy In", noIcon, noKey, noMark, plain, 33;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Page Setup", noIcon, noKey, noMark, plain, 176;
		"Print One", noIcon, "P", noMark, plain, 177;
		"Print", noIcon, noKey, noMark, plain, 178;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Quit", noIcon, "Q", noMark, plain, 36
	}
};

resource 'cmnu' (3) {
	3,
	textMenuProc,
	allEnabled,
	enabled,
	"Edit",
	 {
		"Undo", noIcon, "Z", noMark, plain, 101;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Cut", noIcon, "X", noMark, plain, 103;
		"Copy", noIcon, "C", noMark, plain, 104;
		"Paste", noIcon, "V", noMark, plain, 105;
		"Clear", noIcon, noKey, noMark, plain, 106;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Show Clipboard", noIcon, noKey, noMark, plain, 35
	}
};

resource 'cmnu' (4) {
	4,
	textMenuProc,
	allEnabled,
	enabled,
	"TextColor",
	 {
		"Black", noIcon, noKey, noMark, plain, cBlack;
		"Blue", noIcon, "B", noMark, plain, cBlue;
		"Green", noIcon, "G", noMark, plain, cGreen;
		"Red", noIcon, "R", noMark, plain, cRed;
		"White", noIcon, noKey, noMark, outline, cWhite
	}
};

resource 'cmnu' (128) {
	128,
	textMenuProc,
	allEnabled,
	enabled,
	"Buzzwords",	/* these words appear after Undo in the Edit menu */
	 {
		"Page Setup Change", noIcon, noKey, noMark, plain, cChangePrinterStyle;
		"Typing", noIcon, noKey, noMark, plain, cTyping;
		"Drawing",  noIcon, noKey, noMark, plain, cDrawBox;
		"Dragging",  noIcon, noKey, noMark, plain, cDragBox;
		"Resize",  noIcon, noKey, noMark, plain, cSizer
	}
};

resource 'MBAR' (128) {
	{1; 2; 3; 4}
};


resource 'mctb' (128) {
	{
	/* Blue */
	4, 2,
		{
		0x0000, 0x0000, 0xFFFF;			/* Mark color */
		0x0000, 0x0000, 0xFFFF;			/* Name color */
		0x0000, 0x0000, 0xFFFF;			/* Command Key color */
		0xFFFF, 0xFFFF, 0xFFFF			/* Background color */
		};
	/* Green */
	4, 3,
		{
		0x0000, 0xDB00, 0x0000;			/* Mark color */
		0x0000, 0xDB00, 0x0000;			/* Name color */
		0x0000, 0xDB00, 0x0000;			/* Command Key color */
		0xFFFF, 0xFFFF, 0xFFFF			/* Background color */
		};
	/* Red */
	4, 4,
		{
		0xDB00, 0x0000, 0x0000;			/* Mark color */
		0xDB00, 0x0000, 0x0000;			/* Name color */
		0xDB00, 0x0000, 0x0000;			/* Command Key color */
		0xFFFF, 0xFFFF, 0xFFFF			/* Background color */
		}
	}
};


/* --------------------------- memory usage ----------------------------------------*/
resource 'SIZE' (-1) {
	saveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	MultiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
#if qDebug
	640 * 1024,
	512 * 1024
#else
	240 * 1024,
	220 * 1024
#endif
};


resource 'seg!' (256, purgeable) {
	{
		"GClose";
		"GDoCommand";
		"GNonRes";
		"GFile";
		"GOpen";
		"GSelCommand";
	}
};

resource 'mem!' (256, purgeable) {
	30 * 1024,		/* Add to temporary reserve */
	0,					/* Add to permanent reserve */
	0					/* Add to stack space */
};


/* -------------------------- Bundle resources -------------------------------------*/
type kSignature as 'STR ';

resource kSignature (0) {
	getInfoString;
};

resource 'FREF' (128) {
	'APPL', 0, "TEDrag"	/* Show application file with ICN# with local ID 0 */
};

resource 'FREF' (129) {
	kDocFileType, 1, "TEDrag"	/* Show document files with ICN# with local ID 1 */
};

resource 'BNDL' (128) {
	kSignature,		/* Application signature (creator) */
	0,				/* Resource ID of version data */
	{
		'ICN#',	/* This is how to map local ICN# ids into resource IDs */
		{
			0, 128;	/* Local ICN# 0 is in resource 128 */
			1, 129	/* Local ICN# 1 is in resource 129 */
		};
		'FREF',	/* This is how to map local FREF ids into resource IDs */
		{
			0, 128;	/* Local FREF 0 (arbitrary) is in resource 128 */
			1, 129	/* Local FREF 1 (also arbitrary) is in resource 129 */
		}
	}
};

/*--------------------------------------------------------------------------------
 The overall package version
--------------------------------------------------------------------------------*/
RESOURCE 'vers' (2,
#if qNames
"Package Version",
#endif
	purgeable) {
	0x02,
	0x00,
	beta,
	0x06,
	verUs,
	"2.09",
	"MacApp 2.09, Apple Computer, Inc. 1989"
};


/*--------------------------------------------------------------------------------
 The revision of this particular file
--------------------------------------------------------------------------------*/
RESOURCE 'vers' (1,
#if qNames
"File Version",
#endif
	purgeable) {
	0x01,
	0x00,
	beta,
	0x05,
	verUs,
	"TEDrag",
	"v 0.0, JL/MacTutor 1990"
};

/* =============================== debug window ================================= */
resource 'dbug' (kDebugParamsID,
#if qNames
"Debug",
#endif
	purgeable) {
		{350, 4, 474, 636},		/* Bounding rect for debug window */
		1, 							/* Debug window font rsrc ID (normal = monaco) */
		9,				 				/* Debug window font size (normal = 9) */
		100,							/* Number of lines */
		100,							/* Width of lines in characters */
		true,							/* open initially */
		"Jrg's Debug Window"	/* Window title */
};

