/*------------------------------------------------------------------------------
#
#	Non-Standard File Resources
#		Created by Steve Sheets
#
#		Provides 4 different new user interfaces for
#		the Get & Put dialogs.
#
#		This resource file contains resource needed
#		for the Unit as well as the resources needed
#		for the test program, Non-Standard File Test.
#
#		Compile this file into resource file with command:
#
#		Rez 'NonStandard File.r' -o 'NonStandard File Resources'
#
------------------------------------------------------------------------------*/

#include "Types.r"

/* Dialog Template & Dialog item list resources	*/
/* required for the Unit.	*/

resource 'DLOG' (500, purgeable) {
	{0, 0, 256, 348},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	500,
	""
};

resource 'DLOG' (501, purgeable) {
	{0, 0, 200, 304},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	501,
	""
};

resource 'DLOG' (502, purgeable) {
	{0, 0, 220, 304},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	502,
	""
};

resource 'DLOG' (503, purgeable) {
	{0, 0, 268, 304},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	503,
	""
};

resource 'DITL' (500, purgeable) {
	{	/* array DITLarray: 13 elements */
		/* [1] */
		{138, 256, 156, 336},
		Button {
			enabled,
			"Open"
		},
		/* [2] */
		{0, 699, 80, 717},
		Button {
			enabled,
			"Hidden"
		},
		/* [3] */
		{163, 256, 181, 336},
		Button {
			enabled,
			"Cancel"
		},
		/* [4] */
		{39, 232, 59, 347},
		UserItem {
			disabled
		},
		/* [5] */
		{68, 256, 86, 336},
		Button {
			enabled,
			"Eject"
		},
		/* [6] */
		{93, 256, 111, 336},
		Button {
			enabled,
			"Drive"
		},
		/* [7] */
		{39, 12, 185, 230},
		UserItem {
			enabled
		},
		/* [8] */
		{39, 229, 185, 246},
		UserItem {
			enabled
		},
		/* [9] */
		{124, 252, 125, 340},
		UserItem {
			disabled
		},
		/* [10] */
		{0, 660, 101, 756},
		StaticText {
			disabled,
			""
		},
		/* [11] */
		{227, 62, 247, 246},
		UserItem {
			enabled
		},
		/* [12] */
		{200, 12, 218, 336},
		StaticText {
			disabled,
			""
		},
		/* [13] */
		{227, 12, 247, 61},
		StaticText {
			disabled,
			"Show:"
		}
	}
};

resource 'DITL' (501, purgeable) {
	{	/* array DITLarray: 8 elements */
		/* [1] */
		{132, 218, 150, 288},
		Button {
			enabled,
			"Save"
		},
		/* [2] */
		{158, 218, 176, 288},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{136, 14, 168, 197},
		StaticText {
			disabled,
			"Save as:"
		},
		/* [4] */
		{29, 198, 49, 302},
		UserItem {
			disabled
		},
		/* [5] */
		{56, 218, 74, 288},
		Button {
			enabled,
			"Eject"
		},
		/* [6] */
		{82, 218, 100, 288},
		Button {
			enabled,
			"Drive"
		},
		/* [7] */
		{173, 17, 189, 194},
		EditText {
			enabled,
			""
		},
		/* [8] */
		{29, 14, 127, 197},
		UserItem {
			disabled
		}
	}
};

resource 'DITL' (502, purgeable) {
	{	/* array DITLarray: 10 elements */
		/* [1] */
		{132, 218, 150, 288},
		Button {
			enabled,
			"Save"
		},
		/* [2] */
		{158, 218, 176, 288},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{136, 14, 168, 197},
		StaticText {
			disabled,
			"Save as:"
		},
		/* [4] */
		{29, 198, 49, 302},
		UserItem {
			disabled
		},
		/* [5] */
		{56, 218, 74, 288},
		Button {
			enabled,
			"Eject"
		},
		/* [6] */
		{82, 218, 100, 288},
		Button {
			enabled,
			"Drive"
		},
		/* [7] */
		{173, 17, 189, 194},
		EditText {
			enabled,
			""
		},
		/* [8] */
		{29, 14, 127, 197},
		UserItem {
			disabled
		},
		/* [9] */
		{199, 17, 217, 103},
		RadioButton {
			enabled,
			"Document"
		},
		/* [10] */
		{199, 113, 217, 194},
		RadioButton {
			enabled,
			"Selection"
		}
	}
};

resource 'DITL' (503, purgeable) {
	{	/* array DITLarray: 12 elements */
		/* [1] */
		{132, 218, 150, 288},
		Button {
			enabled,
			"Save"
		},
		/* [2] */
		{158, 218, 176, 288},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{136, 14, 168, 197},
		StaticText {
			disabled,
			"Save as:"
		},
		/* [4] */
		{29, 198, 49, 302},
		UserItem {
			disabled
		},
		/* [5] */
		{56, 218, 74, 288},
		Button {
			enabled,
			"Eject"
		},
		/* [6] */
		{82, 218, 100, 288},
		Button {
			enabled,
			"Drive"
		},
		/* [7] */
		{173, 17, 189, 194},
		EditText {
			enabled,
			""
		},
		/* [8] */
		{29, 14, 127, 197},
		UserItem {
			disabled
		},
		/* [9] */
		{209, 10, 258, 81},
		UserItem {
			enabled
		},
		/* [10] */
		{209, 81, 258, 152},
		UserItem {
			enabled
		},
		/* [11] */
		{209, 152, 258, 223},
		UserItem {
			enabled
		},
		/* [12] */
		{209, 223, 258, 294},
		UserItem {
			enabled
		}
	}
};

/* Icon resources (MacPaint, Text & PICT) used in */
/* the Test program with the NSGetFile call.	*/

resource 'ICN#' (1002) {
	{	/* array: 2 elements */
		/* [1] */
		$"0F FF FE 00 08 00 03 00 08 00 02 80 08 00 02 40"
		$"08 00 02 20 08 00 02 10 08 7F C3 F8 08 40 40 08"
		$"08 40 40 08 08 40 40 08 08 40 40 08 08 40 78 08"
		$"08 41 04 08 08 42 02 08 08 7C 01 08 08 04 01 08"
		$"08 04 01 08 08 04 01 08 08 02 02 08 08 01 04 08"
		$"08 00 F8 08 08 00 00 08 08 04 00 08 08 0A 00 08"
		$"08 11 00 08 08 20 80 08 08 40 40 08 08 80 20 08"
		$"09 FF F0 08 08 00 00 08 08 00 00 08 0F FF FF F8",
		/* [2] */
		$"0F FF FE 00 0F FF FF 00 0F FF FF 80 0F FF FF C0"
		$"0F FF FF E0 0F FF FF F0 0F FF FF F8 0F FF FF F8"
		$"0F FF FF F8 0F FF FF F8 0F FF FF F8 0F FF FF F8"
		$"0F FF FF F8 0F FF FF F8 0F FF FF F8 0F FF FF F8"
		$"0F FF FF F8 0F FF FF F8 0F FF FF F8 0F FF FF F8"
		$"0F FF FF F8 0F FF FF F8 0F FF FF F8 0F FF FF F8"
		$"0F FF FF F8 0F FF FF F8 0F FF FF F8 0F FF FF F8"
		$"0F FF FF F8 0F FF FF F8 0F FF FF F8 0F FF FF F8"
	}
};

resource 'ICN#' (1001) {
	{	/* array: 2 elements */
		/* [1] */
		$"0F FF FC 00 08 00 06 00 08 00 05 00 08 00 04 80"
		$"08 F8 04 40 08 00 04 20 08 1F E7 F0 08 00 00 10"
		$"08 1F E0 10 08 00 00 10 08 03 FC 10 08 00 00 10"
		$"08 1F 00 10 08 00 00 10 08 1F FE 10 08 00 00 10"
		$"08 FF E0 10 08 00 00 10 08 3C 00 10 08 00 00 10"
		$"08 0F C0 10 08 00 00 10 08 0F F8 10 08 00 00 10"
		$"08 FC 00 10 08 00 00 10 08 3F E0 10 08 00 00 10"
		$"08 07 FE 10 08 00 00 10 08 00 00 10 0F FF FF F0",
		/* [2] */
		$"0F FF FC 00 0F FF FE 00 0F FF FF 00 0F FF FF 80"
		$"0F FF FF C0 0F FF FF E0 0F FF FF F0 0F FF FF F0"
		$"0F FF FF F0 0F FF FF F0 0F FF FF F0 0F FF FF F0"
		$"0F FF FF F0 0F FF FF F0 0F FF FF F0 0F FF FF F0"
		$"0F FF FF F0 0F FF FF F0 0F FF FF F0 0F FF FF F0"
		$"0F FF FF F0 0F FF FF F0 0F FF FF F0 0F FF FF F0"
		$"0F FF FF F0 0F FF FF F0 0F FF FF F0 0F FF FF F0"
		$"0F FF FF F0 0F FF FF F0 0F FF FF F0 0F FF FF F0"
	}
};

resource 'ICN#' (1000) {
	{	/* array: 2 elements */
		/* [1] */
		$"0F FF FE 00 08 00 03 00 09 D0 02 80 09 D0 02 40"
		$"09 D0 02 20 09 D0 02 10 09 D0 03 F8 09 D0 00 08"
		$"09 D0 00 08 09 D0 00 08 09 D0 00 08 09 D0 00 08"
		$"09 F0 00 08 09 10 00 08 09 10 00 08 09 10 00 08"
		$"09 10 00 08 09 10 00 08 08 E0 00 08 09 F0 00 08"
		$"09 F0 00 08 09 F8 00 08 09 F8 00 08 09 E8 5F E8"
		$"09 F8 0B E8 08 D0 3F E8 08 F0 FF E8 08 70 3F E8"
		$"08 19 FF E8 08 00 00 08 08 00 00 08 0F FF FF F8",
		/* [2] */
		$"0F FF FE 00 0F FF FF 00 0F FF FF 80 0F FF FF C0"
		$"0F FF FF E0 0F FF FF F0 0F FF FF F8 0F FF FF F8"
		$"0F FF FF F8 0F FF FF F8 0F FF FF F8 0F FF FF F8"
		$"0F FF FF F8 0F FF FF F8 0F FF FF F8 0F FF FF F8"
		$"0F FF FF F8 0F FF FF F8 0F FF FF F8 0F FF FF F8"
		$"0F FF FF F8 0F FF FF F8 0F FF FF F8 0F FF FF F8"
		$"0F FF FF F8 0F FF FF F8 0F FF FF F8 0F FF FF F8"
		$"0F FF FF F8 0F FF FF F8 0F FF FF F8 0F FF FF F8"
	}
};

