PROGRAM ROMRes;
(*		ROMRes.Make

ROMRes.p.o  ROMRes.Make 
	ROMRes.p
		Pascal ROMRes.p  

ROMRes    ROMRes.Make 
	ROMRes.p.o
		Link -w -t 'MPST' -c 'MPS ' 
			ROMRes.p.o 
			"{Libraries}"Runtime.o 
			"{Libraries}"Interface.o 
			"{PLibraries}"PasLib.o 
			"{Libraries}"ToolLibs.o 
			-o ROMRes
*)
USES
	MemTypes,
	QuickDraw,
	OSIntf,
	ToolIntf,
	PackIntf,
	SysEqu,
	Signal,
	PasLibIntf,
	IntEnv;
TYPE
	IntPtr = ^INTEGER;
VAR
	printUsage:	BOOLEAN;
	flagPtr:	IntPtr;
	numTypes:	INTEGER;
	theType:	ResType;
	aType:		ResType;
	numOfType:	INTEGER;
	index:		INTEGER;
	aHandle:	Handle;
	theID:		INTEGER;
	name:		Str255;
	{=========================}
	PROCEDURE ListROMResources;
	VAR
		i:		INTEGER;
		k:		INTEGER;
	BEGIN
		flagPtr^ := mapTrue;
		numTypes := CountTypes;
		{ Scan all types of resources }
		FOR i := 1 TO numTypes DO
			BEGIN
			flagPtr^ := mapTrue;
			GetIndType(theType, i);
			flagPtr^ := mapTrue;
			numOfType := CountResources(theType);
			{ Scan all resources of each type }
			FOR k := 1 TO numOfType DO
				BEGIN
				flagPtr^ := mapFalse;
				aHandle := GetIndResource(theType, k);
				GetResInfo(aHandle, theID, aType, name);
				flagPtr^ := mapFalse;
				{ Only print the ROM resources }
				IF HomeResFile(aHandle) = 1 THEN
				 Writeln(theType,' ',theID,' ',name);
				END;
			END;
	END;
	{=========================}
	PROCEDURE ListROvResources;
	TYPE
		OneROv = PACKED RECORD
			rType:	ResType;
			rID:	INTEGER;
			END;
		ROvType = PACKED RECORD
			romVersion:		INTEGER;
			count:			INTEGER;
			rovs:			PACKED ARRAY [0..32000] OF OneROv;
			END;
		ROvTypePtr = ^ROvType;
		ROvTypeHdl = ^ROvTypePtr;
	VAR
		i:			INTEGER;
		k:			INTEGER;
		rovHandle:	ROvTypeHdl;
	BEGIN
		numOfType := CountResources('ROv#');
		FOR k := 1 TO numOfType DO
			BEGIN
			aHandle := GetIndResource('ROv#', k);
			GetResInfo(aHandle, theID, aType, name);
			rovHandle := ROvTypeHdl(aHandle);
			Writeln('ROv# ', theID:0);
			Write('  Rom version ',rovHandle^^.romVersion:0,' - ');
			{ Identify ROM version type }
			CASE rovHandle^^.romVersion OF
				117:	Writeln('Mac Plus');	
				376:	Writeln('Mac II');	
				630:	Writeln('Mac SE');	
				890:	Writeln('Mac Portable');	
				1660:	Writeln('Mac IIci');
				OTHERWISE
						Writeln(' Unknown');
				END;
			{ List contents of each Rov# }
			FOR i := 0 TO rovHandle^^.count DO
				BEGIN
				Writeln('  ', rovHandle^^.rovs[i].rType,' ',
					rovHandle^^.rovs[i].rID:0);
				END;
			Writeln;
			END;
	END;
	{===========================}
	PROCEDURE ExtractROMResource;
	VAR
		rType:		ResType;
		rTypePtr:	StringPtr;
		value:		LongInt;
		rID:		INTEGER;
		fileName:	Str255;
		i:			INTEGER;
		refNum:		INTEGER;
	BEGIN
		{ Get desired type from command line }
		rType := '    ';
		rTypePtr := StringPtr(@rType);
		FOR i := 1 TO Ord(argV^[2]^[0]) DO
			rTypePtr^[i - 1] := argV^[2]^[i];
		{ Get ID number from command line }
		StringToNum(argV^[3]^, value);
		rID := INTEGER(value);
		{ Get output file name from command line }
		fileName := argV^[4]^;
		{ Get ROM resource, if there }
		flagPtr^ := mapTrue;
		aHandle := GetResource(rType, rID);
		IF aHandle = NIL THEN
			Writeln('No such resource')
		ELSE
			BEGIN
			Writeln('Extracting ',rType, ' ', rID:0, ' to file ',fileName);
			GetResInfo(aHandle, theID, aType, name);
			HNoPurge(aHandle);
			DetachResource(aHandle);
			{ Open output file; create it if it doesn't exist }
			refNum := OpenResFile(fileName);
			IF refNum = -1 THEN
				BEGIN
				IF Create(fileName, 0, 'RSED', 'rsrc') = noErr THEN
					BEGIN
					CreateResFile(fileName);
					refNum := OpenResFile(fileName);
					END;
				END;
			IF refNum = -1 THEN
				Writeln('Problem with file')
			ELSE
				BEGIN
				AddResource(aHandle, rType, rID, name);
				CloseResFile(refNum);
				END;
			END;
	END;
BEGIN
	{ if error in command line, print instructions }
	printUsage := TRUE;
	{ save pointer to low-mem global, for convenience }
	flagPtr := IntPtr(RomMapInsert);
	{ act on option: -l -r or -x }
	IF argC > 1 THEN
		IF (Ord(argV^[1]^[0]) > 1) AND (argV^[1]^[1] = '-') THEN
			CASE argV^[1]^[2] OF
				'l':
					BEGIN
					ListROMResources;
					printUsage := FALSE;
					END;
				'r':
					BEGIN
					ListRovResources;
					printUsage := FALSE;
					END;
				'x':
					IF argC > 4 THEN
						BEGIN
						ExtractROMResource;
						printUsage := FALSE;
						END;
				END;
	{ print instructions if problem with command line }
	IF printUsage THEN
		BEGIN
		Writeln('ROMRes [option]');
		Write('    -l                            #');
		Writeln(' list types and ids of ROM resources');
		Write('    -r                            #');
		Writeln(' list all overridden resources');
		Write('    -x resType resID outputFile   #');
		Writeln(' extract a ROM resource and write to file');
		END;
END.
