/*
**	File mfile.h
**	Header file for MultiFile dialog.
**
**	Copyright  Eric Schlegel 1987, 1988
*/


typedef struct fstruct {
	OSType		ftype;			/* the file type						*/
	short		vrefnum;		/* a vrefnum (or wdrefnum) for the file	*/
	short		fver;			/* the file's version					*/
	String(63)	fname;			/* the file's name in Pascal form		*/
} FSTRUCT;

extern void get_tl();
/* args:
	Point	*where;		Pass in a pointer to a point; get_tl will figure out
						for you where the top left corner of the multifile dlg
						should be so that it is centered half-way across the 
						screen and one-third down, and return that point. You
						can then pass in the point as the "where" argument of
						multifile().
   return val:
   	None.
*/

extern Boolean	multifile();
/* args:
	Point		*where;		The top left corner of the multifile dialog.
	char		*prompt;	A prompt string to label the file list. For example, 
							"Files to process:". The string should be at most
							255 chars long, plus the ending null.
	ProcPtr		filefilt;	Your file filter function.
	short		numtypes;	How many types are in the typelist.
	SFTypeList	*typelist;	A list of types to display.
	
   return val:
   	Multifile returns true if the user clicked in the Done button, or false if
	he clicked in the cancel button.
*/

extern int	 	numfiles();
/* args:
	None.
	
   return val:
	Numfiles returns the number of files that the user collected. This number
	will be valid even if the user exited by clicking on Cancel, but in that
	case you usually wouldn't want to retrieve the files anyway.
*/

extern void		getfile();
/* args:
	short			fileno;		The number of the file to retrieve. The first
								file is number 1.
	struct fstruct	*fstrct;	A pointer to an fstruct. The fields of the 
								fstruct will be filled with info about the
								selected file.
								
  return val:
  	None.
*/

extern void		freemf();
/* args:
	None.
	
   return val:
   	None.
	
   Call this once you've retrieved all the file names using getfile().
*/