#include <UMacApp.h>
#include <UPrinting.h>
#include <UTEView.h>
#include <Fonts.h>
#include <ToolUtils.h>

#include "editor.h"

const OSType kSignature 	= 'JLMT';
const OSType kFileType 		= 'JL01';
const int	kWindowID		=	1001;	

pascal TEditor::TEditor(OSType itsMainFileType)
{
	TTEView				*aTEView;
	TStdPrintHandler	*aStdPrintHandler;
	TWindow				*aWindow;
	
	IApplication(itsMainFileType);
	
	aWindow = NewTemplateWindow(kWindowID,nil);
	FailNIL(aWindow);
	aTEView = (TTEView*) aWindow->FindSubView('edit');
	FailNIL(aTEView);
	aStdPrintHandler = new TStdPrintHandler;
	FailNIL(aStdPrintHandler);
	aStdPrintHandler->IStdPrintHandler(
					nil,
					aTEView,
					kSquareDots,
					kFixedSize,
					!kFixedSize);
	aWindow->Open();
}

pascal void TEditor::HandleFinderRequest()  {};

#ifdef qDebug
pascal void TEditor::IdentifySoftware()
{
	ProgramReport("\pEditor J.Langowski/MacTutor March 1991",false);
	inherited::IdentifySoftware();
}
#endif

	
TEditor *gEditor;

int main()
{
	InitToolBox();
	if (ValidateConfiguration(&gConfiguration))
	{
		InitUMacApp(8);
		InitUPrinting();
		InitUTEView();
		gEditor = new TEditor(kFileType);
		FailNIL(gEditor);
		gEditor->Run();
	}
	else StdAlert(phUnsupportedConfiguration);
	return 0;
}
