#include <UMacApp.h>
#include <UPrinting.h>
#include <UTEView.h>
#include <Fonts.h>
#include <ToolUtils.h>

#include "editor2.h"

const OSType kSignature 	= 'JLMT';
const OSType kFileType 		= 'JL01';

const int	kTEViewID		=	1002;	

pascal TEditor::TEditor(OSType itsMainFileType)
{
	IApplication(itsMainFileType);
	
	fTEView = (TTEView*) DoCreateViews(nil,nil,kTEViewID,&gZeroVPt);
	FailNIL(fTEView);

	fWindow = NewSimpleWindow(kDefaultWindowID, kWantHScrollBar,
			kWantVScrollBar, nil, fTEView);
	FailNIL(fWindow);

	fStdPrintHandler = new TStdPrintHandler;
	FailNIL(fStdPrintHandler);

	fStdPrintHandler->IStdPrintHandler(
					nil,
					fTEView,
					kSquareDots,
					kFixedSize,
					!kFixedSize);
	
	fWindow->SetTitleForDoc("\pMacTutor Editor Window");
	fWindow->Open();
}

pascal void TEditor::HandleFinderRequest()  {};

#ifdef qDebug
pascal void TEditor::IdentifySoftware()
{
	ProgramReport("\pEditor J.Langowski/MacTutor March 1991",false);
	inherited::IdentifySoftware();
}
#endif

	
TEditor *gEditor;

int main()
{
	InitToolBox();
	if (ValidateConfiguration(&gConfiguration))
	{
		InitUMacApp(8);
		InitUPrinting();
		InitUTEView();
		gEditor = new TEditor(kFileType);
		FailNIL(gEditor);
		gEditor->Run();
	}
	else StdAlert(phUnsupportedConfiguration);
	return 0;
}
