/* *******************************
File: Mixed_Colors.c
	Handles color selection dialog
******************************* */

static pascal char MyFilter(DialogPtr theDialog
	,EventRecord *theEvent,short *itemHit);

#define	TRUE   1
#define	FALSE  0
#define NIL 0L

#define  I_OK   1
#define  I_Cancel   2
#define  Item1stColor   3
#define  Item2ndColor   4
#define  Item3rdColor   5
#define  Item4thColor   6

extern int colorSelection[4];
extern WindowPtr MyWindow;

static char   ExitDialog; 

int oqdColors[9] = {0, 33, 30, 205, 341, 409, 273, 137, 69};

static int OQDIndex2Color(theIndex)
int theIndex;
/* convert menu selection to color */
{
return(oqdColors[theIndex]);
}

static int OQDColor2Index(theColor)
int theColor;
/* convert color to menu selection */
{
int i;

for (i=0; i<9; i++)
	if (oqdColors[i] == theColor) return(i);

return(0);
}

static pascal char  MyFilter (theDialog, theEvent, itemHit)
/* filter for drawing bold button */
DialogPtr   theDialog; 
EventRecord   *theEvent;
short  *itemHit; 
{
Rect    tempRect;
short    DType;
Handle    DItem;
PenState oldPen;

if (theEvent->what == updateEvt) { /* draw bold button */
	GetDItem(theDialog,I_OK, &DType, &DItem, &tempRect);
	GetPenState(&oldPen);
	PenSize(3, 3);
	InsetRect(&tempRect, -4, -4);
	FrameRoundRect(&tempRect, 16, 16); 
	SetPenState(&oldPen);
	}
return (FALSE);
} 
 
void   D_Mixed_Colors()
/* allows selection of colors for mixing */
{
DialogPtr    GetSelection;
Rect    tempRect;
short    DType;
Handle    DItem;
ControlHandle    CItem;
short    itemHit;

/* place dialog */
GetSelection = GetNewDialog(2, NIL, (WindowPtr)-1);
tempRect.top = GetSelection->portRect.top;
tempRect.left = GetSelection->portRect.left;
tempRect.bottom = GetSelection->portRect.bottom;
tempRect.right = GetSelection->portRect.right;
tempRect.top = ((screenBits.bounds.bottom - screenBits.bounds.top) - (tempRect.bottom - tempRect.top)) / 2;
tempRect.left = ((screenBits.bounds.right - screenBits.bounds.left) - (tempRect.right - tempRect.left)) / 2;
MoveWindow(GetSelection, tempRect.left, tempRect.top, TRUE);

/* set Pop-Up menus to color, uses Chris Faigle's PopUp CDEF */
GetDItem(GetSelection,Item1stColor, &DType,(Handle) &CItem, &tempRect);
SetCtlValue (CItem, OQDColor2Index(colorSelection[0]));
SetDItem(GetSelection,Item1stColor, DType,(Handle) CItem, &tempRect);

GetDItem(GetSelection,Item2ndColor, &DType,(Handle) &CItem, &tempRect);
SetCtlValue (CItem, OQDColor2Index(colorSelection[1]));
SetDItem(GetSelection,Item2ndColor, DType,(Handle) CItem, &tempRect);

GetDItem(GetSelection,Item3rdColor, &DType,(Handle) &CItem, &tempRect);
SetCtlValue (CItem, OQDColor2Index(colorSelection[2]));
SetDItem(GetSelection,Item3rdColor, DType,(Handle) CItem, &tempRect);

GetDItem(GetSelection,Item4thColor, &DType,(Handle) &CItem, &tempRect);
SetCtlValue (CItem, OQDColor2Index(colorSelection[3]));
SetDItem(GetSelection,Item4thColor, DType,(Handle) CItem, &tempRect);

ShowWindow(GetSelection);
SelectWindow(GetSelection);
SetPort(GetSelection);
 	 
ExitDialog = FALSE; 
 
do { /* dialog loop */
	ModalDialog(&MyFilter, &itemHit);
	 
	if (itemHit == I_OK ) { /* get colors and quit */
		GetDItem(GetSelection,Item1stColor, &DType,(Handle) &CItem, &tempRect);
		colorSelection[0] = OQDIndex2Color(GetCtlValue(CItem));
		GetDItem(GetSelection,Item2ndColor, &DType,(Handle) &CItem, &tempRect);
 		colorSelection[1] = OQDIndex2Color(GetCtlValue(CItem));
 		GetDItem(GetSelection,Item3rdColor, &DType,(Handle) &CItem, &tempRect);
		colorSelection[2] = OQDIndex2Color(GetCtlValue(CItem));
		GetDItem(GetSelection,Item4thColor, &DType,(Handle) &CItem, &tempRect);
 		colorSelection[3] = OQDIndex2Color(GetCtlValue(CItem));
		ExitDialog =TRUE;
		}
	
	if (itemHit == I_Cancel)
		ExitDialog =TRUE;
} while (ExitDialog == FALSE);
	
DisposDialog(GetSelection); 
SetPort(MyWindow);
InvalRect(&(MyWindow->portRect));
}


