/*	editor.r 
	Rez file for MacTutor C++/MacApp Editor example
	J. Langowski March 1991
*/

#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __SYSTYPES.R__
#include "SysTypes.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif

#if qDebug
include "Debug.rsrc";
#endif

include "MacApp.rsrc";
include "Printing.rsrc";

include "Defaults.rsrc" 'SIZE'(-1);
include "Defaults.rsrc" 'ALRT'(phAboutApp);
include "Defaults.rsrc" 'DITL'(phAboutApp);
include "Defaults.rsrc" 'cmnu'(mApple);
include "Defaults.rsrc" 'cmnu'(mEdit);
include "Defaults.rsrc" 'cmnu'(mBuzzWords);

include "Editor" 'CODE';

include "editor.rsrc";

#define kSignature		'JLMT'
#define kDocFileType		'JL01'
#define getInfoString	"1991 J.Langowski/MacTutor. "

/* ------------------------------------------------------------------------------------*/

resource 'cmnu' (2) {
	2,
	textMenuProc,
	allEnabled,
	enabled,
	"File",
	 {
		"Close", noIcon, noKey, noMark, plain, 31;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Page Setup", noIcon, noKey, noMark, plain, 176;
		"Print One", noIcon, "P", noMark, plain, 177;
		"Print", noIcon, noKey, noMark, plain, 178;
		"-", noIcon, noKey, noMark, plain, nocommand;
		"Quit", noIcon, "Q", noMark, plain, 36
	}
};


resource 'MBAR' (kMBarDisplayed,purgeable) 
{
	{mApple; 2; mEdit;}
};


/*--------------------------------------------------------------------------------
 The overall package version
--------------------------------------------------------------------------------*/
RESOURCE 'vers' (2,
#if qNames
"Package Version",
#endif
	purgeable) {
	0x02,
	0x00,
	beta,
	0x06,
	verUs,
	"2.0",
	"MacApp 2.0, Apple Computer, Inc. 1990"
};


/*--------------------------------------------------------------------------------
 The revision of this particular file
--------------------------------------------------------------------------------*/
RESOURCE 'vers' (1,
#if qNames
"File Version",
#endif
	purgeable) {
	0x01,
	0x00,
	beta,
	0x05,
	verUs,
	"Editor",
	"v 0.8, JL/MacTutor 1991"
};

/* =============================== debug window ================================= */
resource 'dbug' (kDebugParamsID,
#if qNames
"Debug",
#endif
	purgeable) {
		{350, 4, 474, 636},		/* Bounding rect for debug window */
		1, 							/* Debug window font rsrc ID (normal = monaco) */
		9,				 				/* Debug window font size (normal = 9) */
		100,							/* Number of lines */
		100,							/* Width of lines in characters */
		true,							/* open initially */
		"Jrg's Debug Window"	/* Window title */
};

