/**************************************
	cDotsTask.h
**************************************/
 
#define _H_cDotsTask

#include "cDotsDoc.h"
#include "cDotsPane.h"
#include "dotsTypes.h"

struct cDotsTask : CMouseTask {

		/** Instance Variables **/
	cDotsDoc	*fDotsDoc;		/* Document in charge of panes */
	cDotsPane	*fDotsPane;		/* Pane where mouse action occured */
	Boolean		fPlayerMoved;	/* Player who is making move */
	Boolean		fValidMove;		/* True if previously unselected line is selected */
	
					/* The next 3 fields record line chosen by user */
	tLineDir	fDirection;
	int			fRow;
	int			fCol;
	
		/** Initialization **/
	void		IDotsTask(short aNameIndex, cDotsPane *theDotsPane, cDotsDoc *theDotsDoc);
	
		/** Overrides **/
	void		BeginTracking(Point *startPt);
	void		KeepTracking(Point *currPt, Point *prevPt, Point *startPt);
	void		EndTracking(Point *currPt, Point *prevPt, Point *startPt);
	void		Do(void);
	void		Undo(void);
	void		Redo(void);

		/** Additions **/
	Boolean		validMove(void);
};