{****************************************************}
{}
{		StarterIntf.p																		}
{}
{		Interface file for the Starter application.										}
{}
{		Copyright  1989, Symantec Corporation.  All rights reserved.			}
{}
{****************************************************}


UNIT StarterIntf;

INTERFACE

USES
	TCL, CSFDialogs;

CONST

	CSFOpenCmd = 9998;
	CSFSaveCmd = 9999;

	dummyCmd = 2000;		{ Used in example DoCommand methods 	}
	WINDStarter = 500;		{ Resource ID for WIND template 			}


{****}
{ * CStarterApp}
{ *}
{ *	Application class for a typical application.}
{ *}
{ ****}

TYPE
	CStarterApp = OBJECT(CSFApplication)

	{ Declare your application's instance variables here 	}
	{ (there are none in this example)						}

	{ CStarterApp's methods follow:						}

			PROCEDURE IStarterApp;

			PROCEDURE SetUpFileParameters;
			override;

			PROCEDURE SetUpMenus;
			override;

			PROCEDURE DoCommand (theCommand: longint);
			override;

			PROCEDURE UpdateMenus;
			override;

			PROCEDURE CreateDocument;
			override;

			PROCEDURE OpenDocument (macSFReply: SFReply);
			override;

			PROCEDURE Exit;
			override;

		END;


{***}
{ * CStarterDoc}
{ *}
{ *	Document class for a typical application.}
{ *}
{ ***}

TYPE
	CStarterDoc = OBJECT(CDocument)

	{ Declare your document's instance variables here 	}
	{ (there are none in this example)						}

	{ CStarterDoc's methods follow:						}

									{* Construction/Destruction *}

			PROCEDURE IStarterDoc (aSupervisor: CApplication; printable: Boolean);
			PROCEDURE Free;
			override;

			PROCEDURE DoCommand (theCommand: longint);
			override;

			PROCEDURE UpdateMenus;
			override;

			PROCEDURE NewFile;
			override;
			PROCEDURE OpenFile (macSFReply: SFReply);
			override;
			PROCEDURE BuildWindow (theData: Handle);

									{* Filing *}

			FUNCTION DoSave: Boolean;
			override;
			FUNCTION DoSaveAs (macSFReply: SFReply): Boolean;
			override;
			PROCEDURE DoRevert;
			override;
		END;



{***}
{ * CStarterPane}
{ *}
{ *	Pane class for a typical application.}
{ *}
{ ***}

TYPE
	CStarterPane = OBJECT(CPanorama)

	{ Declare your pane's instance variables here 			}
	{ (there are none in this example)						}

	{ CStarterPane's methods follow:						}

									{* Construction/Destruction *}

			PROCEDURE IStarterPane (anEnclosure: CView; aSupervisor: CBureaucrat; aWidth, aHeight, aHEncl, aVEncl: integer; aHSizing, aVSizing: SizingOption);

									{* Drawing *}

			PROCEDURE Draw (VAR area: Rect);
			override;

									{* Mouse *}

			PROCEDURE DoClick (hitPt: Point; modifierKeys: integer; when: longint);
			override;
			FUNCTION HitSamePart (VAR pointA, pointB: Point): Boolean;
			override;

									{* Cursor *}

			PROCEDURE AdjustCursor (where: Point; mouseRgn: RgnHandle);
			override;

									{* Scrolling *}

			PROCEDURE ScrollToSelection;
			override;
		END;


IMPLEMENTATION

END.