class TEditor : public TApplication {
public:
	pascal TEditor(OSType itsMainFileType);
	virtual pascal struct TDocument *DoMakeDocument(CmdNumber itsCmdNumber);
	pascal void HandleFinderRequest();
#ifdef qDebug
	virtual pascal void IdentifySoftware();
#endif
};

class TEditView;

class TBoxView : public TTEView {
public:
	pascal struct TCommand *DoMouseCommand(Point *theMouse,
					EventInfo *info, Point *hysteresis);
#ifdef qDebug
	virtual pascal void Fields(pascal void (*DoToField) (StringPtr fieldName,
					Ptr fieldAddr, short fieldType, void *link), void *link);
#endif
};

class TEditDocument : public TDocument {
public:
	TEditView	*fEditView;
	pascal TEditDocument();
	pascal void DoMakeViews(Boolean forPrinting);
	pascal void DoNeedDiskSpace(long *dataForkBytes, long *rsrcForkBytes);
	pascal void DoRead(short aRefNum, Boolean rsrcExists, Boolean forPrinting);
	pascal void DoWrite(short aRefNum, Boolean makingCopy);
	pascal void Free();

#ifdef qDebug
	virtual pascal void Fields(pascal void (*DoToField) (StringPtr fieldName,
					Ptr fieldAddr, short fieldType, void *link), void *link);
#endif
};

class TBox : public TObject {
public:
	Rect	fLocation;
	Boolean	fSelected;
	RgnHandle	fTagRgn;
	Rect	fTL,fTR,fBL,fBR,
			fT,fB,fL,fR;
	pascal TBox(Rect *itsLocation);
	virtual pascal void DrawShape();
#ifdef qDebug
	virtual pascal void Fields(pascal void (*DoToField) (StringPtr fieldName,
							 Ptr fieldAddr, short fieldType, void *link), void *link);
#endif
};

class TShape : public TBox {
public:
	short	fPenSize;
	Pattern	fPenPat;
	Pattern	fFillPat;
	pascal TShape(Rect *itsLocation);

#ifdef qDebug
	virtual pascal void Fields(pascal void (*DoToField) (StringPtr fieldName,
							 Ptr fieldAddr, short fieldType, void *link), void *link);
#endif
};

class TEditBox : public TShape {
public:
	TBoxView		*fBoxView;
	TEditDocument 	*fEditDocument;
	
	pascal TEditBox(Rect *itsLocation, 
			TBoxView *itsView, TEditDocument *itsDocument);
	pascal void DrawShape();
#ifdef qDebug
	virtual pascal void Fields(pascal void (*DoToField) (StringPtr fieldName,
							 Ptr fieldAddr, short fieldType, void *link), void *link);
#endif
};

class TEditView : public TScroller {
public:
	TEditDocument *fDocument;
	TList	*fShapeList;	// list of shapes (TEditView, boxes)
	pascal void IEditView(TEditDocument *itsDocument);
	pascal void AddShape(TBox *aBox); 
	pascal void DeleteShape();
	pascal void ForEachShapeDo(pascal void (*DoToItem)
				(TObject *item, void *DoToItem_Staticlink),void *DoToItem_Staticlink);
	pascal void Draw(Rect *area);
	pascal void Free();
#ifdef qDebug
	virtual pascal void Fields(pascal void (*DoToField) (StringPtr fieldName,
					Ptr fieldAddr, short fieldType, void *link), void *link);
#endif
};

// --- global definitions ---

typedef pascal void (*DoToObject) (TObject *aObject, void *DoToObject_staticlink);

