UNIT MenuTest;

INTERFACE
	USES Menus, Resources, OSUtils, Desk, SegLoad, Memory, Dialogs, ToolUtils, Lists, QuickDraw, 
				Errors, Files, Sound, SSU;
	
	CONST
		{ Regular Menus }
		kAppleMenu 	= 1;
			kApAbout 	= 1;
		kFileMenu	= 2;
			kFiQuit		= 1;
		kEditMenu	= 3;
			kEdUn			= 1;
			{---------------}
			kEdCut		= 3;
			kEdCopy		= 4;
			kEdPaste		= 5;
			kEdClear		= 6;
		kSSUMenu = 4;
			TrySSU		= 1;		
			
		{}
		kFirstMenu = kAppleMenu;
		kLastMenu = kSSUMenu;
		{}
		
		kAboutDlog 	= 27088;
		kSSUDlog 	= 31878;
			kFileType 		= 4;
			kFileCreator	= 5;
			kRsrcType		= 6;
		kListDlog 	= 129;
			kFileList = 3;
		kTextDlog 	= 130;
			kTextArea	= 3;
		kErrAlrt		= 132;
		
		kErrStrL 	= 128;
			kOSAlrtStr 	= 1;
			kTextStr 	= 2;
			kFileList1	= 3;
			kFileList2 	= 4;
			kSSUText		= 5;
			kNoFiles1	= 6;
			kNoFiles2	= 7;
		
		kSoundResType	=	'snd ';
		kEdPict			= 128;

		
	TYPE
		Generic	=	PACKED RECORD CASE Integer OF
							0: (ch0:	Char;
								 ch1:	Char;
								 ch2:	Char;
								 ch3:	Char);
							1: (b0:	Byte;
								 b1:	Byte;
								 b2:	Byte;
								 b3:	Byte);
							2: (sb0:	SignedByte;
								 sb1:	SignedByte;
								 sb2:	SignedByte;
								 sb3:	SignedByte);
							3: (i0:	Integer;
								 i1:	Integer);
							4: (l0:	LongInt);
							5:	(p:	Ptr);
							6:	(h:	Handle);
						END;
		GPtr				=	^Generic;

			
	VAR
		gMenuRay		: ARRAY[kFirstMenu..kLastMenu] OF MenuHandle;
		gSSUList		: SSUInfoRec;
		gNilOSType	: OSType;
		gListHdl		: ListHandle;
	

	
	FUNCTION SetUpMenus:Boolean;
	PROCEDURE DoSSUDlog;
	PROCEDURE DoMenuCommand (menuResult: LONGINT);
	
IMPLEMENTATION	
	{--------------------------------------------------------}
	PROCEDURE GetDiaItemText (theDialog: DialogPtr; itemNum: Integer; VAR theStr: Str255);
	
	VAR	itTyp:		Integer;
			itHandle:	Handle;
			itBox:		Rect;
	
	BEGIN	GetDItem (theDialog, itemNum, itTyp, itHandle, itBox);
			GetIText (itHandle, theStr);
	END;

	{--------------------------------------------------------}
	FUNCTION SetUpMenus:Boolean;
	
		VAR
			i			: Integer;
			beforeID	: Integer;
	
		BEGIN
			SetUpMenus := True;
			
			FOR i := kFirstMenu TO kLastMenu DO BEGIN
				gMenuRay[i] := GetMenu (i);
				IF (gMenuRay[i] = NIL) THEN BEGIN
					SetUpMenus := False;
					SysBeep (1);
				END;
				
				IF i = kAppleMenu THEN
					AddResMenu(gMenuRay[kAppleMenu], 'DRVR');	{add DA names to Apple menu}
					
				InsertMenu (gMenuRay[i], 0);
			END;
						
			DrawMenuBar;
		END; { FUNCTION SetUpMenus }
		
	{----------------------------------------------------}
	PROCEDURE CenterWindow (theWindow:windowPtr);
		
		VAR
			theGDHdl		: GDHandle;
			vOff,
			hOff			: Integer;
	
		BEGIN
			theGDHdl := GetMainDevice;
			WITH theGDHdl^^.gdRect DO BEGIN
				vOff := ((bottom - top) - (theWindow^.portRect.bottom - theWindow^.portRect.top)) DIV 3;
				hOff := ((right - left) - (theWindow^.portRect.right - theWindow^.portRect.left)) DIV 2;
			END;
			MoveWindow (theWindow, hOff, vOff, False);
		END;


	{--------------------------------------------------------}
	FUNCTION CenteredNoteAlert (alertID:INTEGER; filterProc:ProcPtr):INTEGER;	
	
		VAR
			resHdl		: Handle;
			alrtLeft		: Integer;
			alrtTop		: Integer;
			alertParams	: AlertTHndl;
			theGDHdl		: GDHandle;
			alrtWidth	: Integer;
			alrtHgt		: Integer;
		
		BEGIN
			resHdl := Get1Resource ('ALRT', alertID);
	
			IF resHdl <> NIL THEN BEGIN
				theGDHdl := GetMainDevice;
				alertParams := AlertTHndl (resHdl);
				WITH alertParams^^, theGDHdl^^ DO BEGIN
					alrtWidth := boundsRect.right - boundsRect.left;
					alrtHgt := boundsRect.bottom - boundsRect.top;
					
					alrtTop := ((gdRect.bottom - gdRect.top) - alrtHgt) DIV 3;
					alrtLeft := ((gdRect.right - gdRect.left) - alrtWidth) DIV 2;
					
					SetRect (boundsRect, alrtLeft, alrtTop, (alrtLeft + alrtWidth), 
																			(alrtTop + alrtHgt));
				END;
				CenteredNoteAlert := NoteAlert (alertID, filterProc);
			END;
		END;
		
	{--------------------------------------------------------}
	{ Get, center, and show a dialog that has been saved in a template }
	{ DLOG template must be marked as invisible }
	FUNCTION GetNewCenteredDlog (dialogID:INTEGER; dStorage:Ptr; behind:WindowPtr):DialogPtr;
	
		VAR
			tempDlogPtr : DialogPtr;
			
		BEGIN
			tempDlogPtr := GetNewDialog (dialogID, dStorage, behind);
			CenterWindow (windowPtr (tempDlogPtr));
			ShowWindow (tempDlogPtr);
			GetNewCenteredDlog := tempDlogPtr;
		END;
		
		
	{--------------------------------------------------------}
	{ Outline the default button }
	PROCEDURE OutlineButton (theDialog:DialogPtr; itemNumber:Integer);
		
		VAR
			itemType		: Integer;
			itemHdl		: Handle;
			itemBox		: Rect;
			oldPenState	: PenState;
			oldPort		: GrafPtr;
	
		BEGIN
			GetPort (oldPort);
			SetPort (theDialog);
			GetDItem (theDialog, itemNumber, itemType, itemHdl, itemBox);
			GetPenState (oldPenState);
			PenNormal;
			PenSize (3,3);
			InsetRect (itemBox, -4, -4);
			FrameRoundRect (itemBox, 16, 16);
			SetPenState (oldPenState);
			SetPort (oldPort);
		END;
		
	{--------------------------------------------------------}
	{ Update File List }
	PROCEDURE UpdateList (theDialog:DialogPtr; itemNumber:Integer);
		
		VAR
			itemType		: Integer;
			itemHdl		: Handle;
			itemBox		: Rect;
			oldPenState	: PenState;
			oldPort		: GrafPtr;
			updateRgn	: RgnHandle;
	
		BEGIN
			GetDItem (theDialog, itemNumber, itemType, itemHdl, itemBox);
			GetPort (oldPort);
			SetPort (theDialog);
			GetPenState (oldPenState);
			PenNormal;
			LDoDraw (True, gListHdl);
			updateRgn := NewRgn;
			RectRgn (updateRgn, itemBox);
			LUpdate (updateRgn, gListHdl);
			DisposeRgn (updateRgn);
			itemBox.right := itemBox.right - 15;
			InsetRect (itemBox, -1, -1);
			FrameRect (itemBox);
			SetPort (oldPort);
			SetPenState (oldPenState);
		END;
	

	{--------------------------------------------------------}
	{ Standard filter proc for dialogs. }
	{ Outlines the #1 button, and treats Enter and Return as a hit in the default button. }
	FUNCTION StdDlogFltr (theDialog:DialogPtr; VAR theEvent:EventRecord; VAR itemHit:Integer):Boolean;
		
		CONST
			kReturn 	= $24;
			kEnter 	= $4C;
			
		VAR
			keyCode		: Integer;
			chCode		: Integer;
			
			finalTicks	: LongInt;
			theType		: Integer;
			okItemHdl	: Handle;
			itemBox		: Rect;
	
	BEGIN
		WITH theEvent DO BEGIN
			StdDlogFltr := False;
			
			CASE what OF 
				keyDown: BEGIN
					keyCode := BAND (message, KeyCodeMask);
					keyCode := BSR (keyCode, 8);
					
					IF keyCode IN [kReturn, kEnter] THEN BEGIN
						GetDItem(theDialog, ok, theType, okItemHdl, itemBox);
						HiliteControl (ControlHandle (okItemHdl), inButton);
						Delay (8, finalTicks);
						HiliteControl (ControlHandle (okItemHdl), 0);
						itemHit := ok;
						StdDlogFltr := True;
					END;
				END; { keyDown in CASE what }
				
				updateEvt: OutlineButton (theDialog, Ok);

			END; { CASE what }
		END; { WITH theEvent }
	END; { FUNCTION StdDlogFltr }


	
	{--------------------------------------------------------}
	PROCEDURE DoAboutDlog;
	
		VAR
			dlogPtr		: DialogPtr;
			theItem		: Integer;
	
		BEGIN
			dlogPtr := GetNewCenteredDlog (kAboutDlog, NIL, WindowPtr (-1));
			ModalDialog (@StdDlogFltr, theItem);
			DisposDialog (dlogPtr);
		END;

	{--------------------------------------------------------}
	FUNCTION ListFilter  (theDialog:DialogPtr; VAR theEvent:EventRecord; VAR itemHit:Integer):Boolean;
	
		CONST
			kReturn 	= $24;
			kEnter 	= $4C;
			
		VAR
			keyCode		: Integer;
			chCode		: Integer;
			
			finalTicks	: LongInt;
			theType		: Integer;
			itemHdl		: Handle;
			itemBox		: Rect;

			localPt		: Point;
			oldPort		: GrafPtr;
			clickCell	: Cell;
			i				: Integer;
			infoHdl		: ItemInfoHdl;
			
			theFileRef	: Integer;
			theOSErr		: OSErr;
			fileData		: Str255;
			count			: LongInt;
			dlogPtr		: DialogPtr;	
			theItem		: Integer;
			
			resourceHdl		: Handle;
			theCurResFile	: Integer;
			paramText1		: Str255;
			dummyInt			: Integer;
			didSomething	: Boolean;
			
		BEGIN
			WITH theEvent DO BEGIN
				ListFilter := False;
				
				CASE what OF 
					keyDown: BEGIN
						keyCode := BAND (message, KeyCodeMask);
						keyCode := BSR (keyCode, 8);
						
						IF keyCode IN [kReturn, kEnter] THEN BEGIN
							GetDItem(theDialog, ok, theType, itemHdl, itemBox);
							HiliteControl (ControlHandle (itemHdl), inButton);
							Delay (8, finalTicks);
							HiliteControl (ControlHandle (itemHdl), 0);
							itemHit := ok;
							ListFilter := True;
						END;
					END; { keyDown in CASE what }
					
					updateEvt: BEGIN
						GetPort (oldPort);
						SetPort (theDialog);
						PenNormal;
						InvalRect(theDialog^.portRect);
						OutlineButton (theDialog, Ok);
						UpdateList (theDialog, kFileList);
						SetPort (oldPort);
					END; { updateEvt in CASE what }
					
					mouseDown: BEGIN
						GetPort (oldPort);
						SetPort (theDialog);
						GetDItem(theDialog, kFileList, theType, itemHdl, itemBox);
						localPt := theEvent.where;
						GlobalToLocal (localPt);

						IF PtInRect (localPt, itemBox) THEN							
							IF LClick (localPt, theEvent.modifiers, gListHdl) THEN BEGIN
								clickCell := LLastClick (gListHdl);
								infoHdl := gSSUList.ssu_firstItemInfo;
								i := 0;
								WHILE i < clickCell.v DO BEGIN
									infoHdl := infoHdl^^.il_nextItemInfo;
									i := i + 1;
								END;
								didSomething := false;
								
								IF LongInt(infoHdl^^.il_resourceType) = LongInt(kSoundResType) THEN BEGIN
									IF SSU_OpenFile (infoHdl, theFileRef, fsRdPerm, True) = noErr THEN BEGIN
										theCurResFile := CurResFile;
										UseResFile(theFileRef);
										resourceHdl := Get1Resource(kSoundResType,infoHdl^^.il_resID);
										IF resourceHdl <> NIL THEN BEGIN
											HLock(resourceHdl);
											theOSErr := SndPlay (NIL, resourceHdl,False);
											HUnLock(resourceHdl);
											ReleaseResource(resourceHdl);
											didSomething := true;
										END;
										UseResFile(theCurResFile);
										theOSErr := SSU_CloseFile (theFileRef, True);
									END;
								END;
								
								IF LongInt(infoHdl^^.il_resourceType) = LongInt('PICT') THEN BEGIN
									IF SSU_OpenFile (infoHdl, theFileRef, fsRdPerm, True) = noErr THEN BEGIN
										theCurResFile := CurResFile;
										UseResFile(theFileRef);
										resourceHdl := Get1Resource('PICT',infoHdl^^.il_resID);
										IF resourceHdl <> NIL THEN BEGIN
											HLock(resourceHdl);
											EraseRect(theDialog^.portRect);
											DrawPicture(PicHandle(resourceHdl),theDialog^.portRect);
											HUnLock(resourceHdl);
											ReleaseResource(resourceHdl);
											PenNormal;
											Delay(50,finalTicks);
											EraseRect (theDialog^.portRect);
											didSomething := true;
										END;
										UseResFile(theCurResFile);
										theOSErr := SSU_CloseFile (theFileRef, True);
									END;
								END;

								IF (LongInt(infoHdl^^.il_fileType) = LongInt('TEXT')) THEN BEGIN
									IF SSU_OpenFile (infoHdl, theFileRef, fsRdPerm, False) = noErr THEN BEGIN
										count := 255;
										theOSErr := SetFPos (theFileRef, fsFromStart, 0);
										theOSErr := FSRead (theFileRef, count, @fileData[1]);
										fileData[0] := Chr (count);
										dlogPtr := GetNewCenteredDlog (kTextDlog, NIL, WindowPtr (-1));
										
										SetPort (dlogPtr);
										GetDItem(dlogPtr, kTextArea, theType, itemHdl, itemBox);
										SetIText (itemHdl, fileData);
										REPEAT
											ModalDialog (@StdDlogFltr, theItem);
										UNTIL theItem = 1;
										
										SetPort (theDialog);
										DisposDialog (dlogPtr);
										theOSErr := SSU_CloseFile (theFileRef, False);
										didSomething := true;
									END;
								END;
																
								IF NOT didSomething THEN BEGIN
									GetIndString (paramText1, kErrStrL, kTextStr);
									ParamText (paramText1, '', '', '');
									dummyInt := CenteredNoteAlert (kErrAlrt, NIL);
								END;
							END; 
						SetPort (oldPort);
					END;{ mouseDown in CASE what }
	
				END; { CASE what }
			END; { WITH theEvent }
		END; { FUNCTION ListFilter }

	{--------------------------------------------------------}
	PROCEDURE DoListWork (theFileType,theCreatorType,theRsrcType:OSType);
	
		VAR
			requestArray	: BuildItemInfoAT;
			listDlogPtr 	: DialogPtr;
			dummyInt			: Integer;
			paramText1		: Str255;
			paramText2		: Str255;
			paramText3		: Str255;
			
			itemType			: Integer;
			itemHdl			: Handle;
			itemBox			: Rect;
			theItem			: Integer;
			
			dataBounds		: Rect;
			cSize				: Point;
			currInfoHdl		: ItemInfoHdl;
			currCell			: Cell;
			itemText			: Str63;
			
		BEGIN
			SSU_DisposList (gSSUList, NIL);
				
			BlockClear (@requestArray, SizeOf (requestArray));
			requestArray[1].bi_fileType := theFileType;
			requestArray[1].bi_crtrType := theCreatorType;
			requestArray[1].bi_resType	 := theRsrcType;
			
			SSU_BuildList (@requestArray, 1, gSSUList, NIL);
			IF gSSUList.ssu_firstItemInfo <> NIL THEN BEGIN
				listDlogPtr := GetNewDialog (kListDlog, NIL, WindowPtr (-1));
				CenterWindow (windowPtr (listDlogPtr));
	
				GetDItem (listDlogPtr, kFileList, itemType, itemHdl, itemBox);
				itemBox.right := itemBox.right -15;
				BlockClear (@dataBounds, SizeOf (Rect));
				dataBounds.botRight.h := 1;
				cSize.h := itemBox.right - itemBox.left;
				cSize.v := 16;
				gListHdl := LNew (itemBox, dataBounds, cSize, 0, WindowPtr (listDlogPtr), False, False,
											False, True);
											
				gListHdl^^.selFlags := lOnlyOne + lNoNilHilite;
				
				currInfoHdl := gSSUList.ssu_firstItemInfo;
				currCell := Cell(0);				
				WHILE currInfoHdl <> NIL DO BEGIN
					itemText := currInfoHdl^^.il_fileSpec.cf_fileName;
					currCell.v := LAddRow (1, 32000, gListHdl);
					currCell.h := 0;
					LSetCell (@itemText[1], Length (itemText), currCell, gListHdl);
					currInfoHdl := currInfoHdl^^.il_nextItemInfo;
				END;
				
				ShowWindow (windowPtr (listDlogPtr));
				GetIndString (paramText1, kErrStrL, kFileList1);
				GetIndString (paramText3, kErrStrL, kFileList2);
				paramText2[0] := chr (4);
				BlockMove (@theFileType, @paramText2[1], SizeOf (OSType));
				ParamText (paramText1, paramText2, paramText3, '');
				
				REPEAT
					ModalDialog (@ListFilter, theItem);
				UNTIL theItem = 1;
				
				LDispose (gListHdl);
				DisposDialog (listDlogPtr);
			END ELSE BEGIN
				GetIndString (paramText1, kErrStrL, kNoFiles1);
				GetIndString (paramText3, kErrStrL, kNoFiles2);
				paramText2[0] := chr (4);
				BlockMove (@theFileType, @paramText2[1], SizeOf (OSType));
				ParamText (paramText1, paramText2, paramText3, '');
				dummyInt := CenteredNoteAlert (kErrAlrt, NIL);
			END;
		END;
		
	{--------------------------------------------------------}
	PROCEDURE DoSSUDlog;
	
		CONST
			kUserAbout = TRUE;
	
		VAR
			dlogPtr					: DialogPtr;
			theItem					: Integer;
			itemType					: Integer;
			item						: Handle;
			box						: Rect;
			
			theFileTypeString		: Str255;
			theFileType				: OSType;
			
			theCreatorTypeString	: Str255;
			theCreatorType			: OSType;
			
			theRsrcTypeString		: Str255;
			theRsrcType				: OSType;
			
			dummyInt					: Integer;
			everythingOK			: Boolean;
			errStr					: STR255;
			
		BEGIN
			dlogPtr := GetNewCenteredDlog (kSSUDlog, NIL, WindowPtr (-1));

			REPEAT
				SelIText (dlogPtr, kFileType, 0, 32767);
				GetIndString (errStr, kErrStrL, kSSUText);
				ParamText (errStr, '','','');
				REPEAT
					ModalDialog (@StdDlogFltr, theItem);
				UNTIL theItem <= 2;
				
				everythingOK := theItem = 1;
				
				IF everythingOK THEN BEGIN
					GetDiaItemText(dlogPtr, kFileType, theFileTypeString);
					GetDiaItemText(dlogPtr, kFileCreator, theCreatorTypeString);
					GetDiaItemText(dlogPtr, kRsrcType, theRsrcTypeString);
										
					IF (Length(theFileTypeString) <>4)	| 
						(Length(theCreatorTypeString)>4) |
						(Length(theRsrcTypeString)>4) THEN BEGIN
						GetIndString (errStr, kErrStrL, kOSAlrtStr);
						ParamText (errStr, '','','');
						dummyInt := CenteredNoteAlert (kErrAlrt, NIL);						
						everythingOK := False;
					END ELSE BEGIN
						BlockMove(@theFileTypeString[1], @theFileType, 4);

						IF Length(theCreatorTypeString) = 0 THEN BEGIN
							theCreatorType := OSType(NIL);
						END ELSE BEGIN
							theCreatorType := OSType('    ');
							BlockMove(@theCreatorTypeString[1], @theCreatorType, Length(theCreatorTypeString));
						END;
							
						IF Length(theRsrcTypeString) = 0 THEN BEGIN
							theRsrcType := OSType(NIL);
						END ELSE BEGIN
							theRsrcType := OSType('    ');
							BlockMove(@theRsrcTypeString[1], @theRsrcType, Length(theRsrcTypeString));
						END;
						
					END;
				END ELSE BEGIN
					everythingOK := kUserAbout; 		{Yea, everything's OK.  Who can argue with the user?}
				END;
			UNTIL everythingOK;
			
			DisposDialog (dlogPtr);
			
			IF theItem = 1 THEN BEGIN
				DoListWork (theFileType,theCreatorType,theRsrcType);
			END;
		END;
	
	{--------------------------------------------------------}	
	PROCEDURE DoMenuCommand (menuResult: LONGINT);
		 
		VAR
			menuID, menuItem	: Integer;
			daRefNum				: Integer;
			daName				: Str255;
		BEGIN
			menuID := Generic(menuResult).i0;	
			menuItem := Generic(menuResult).i1;	
			CASE menuID OF
				kAppleMenu:
					IF menuItem = kApAbout THEN BEGIN
						DoAboutDlog;
					END ELSE BEGIN
						GetItem(GetMHandle(kAppleMenu), menuItem, daName);
						daRefNum := OpenDeskAcc(daName);
					END;
				kFileMenu:	ExitToShell;
				kSSUMenu:	DoSSUDlog;
			END;
			HiliteMenu(0);	
		END; {DoMenuCommand}
END.