unit CommentMain;
interface
	procedure Main;
implementation

{>Finds/returns first two strings of<}
{>STR# resource 'SBulkInit'<}
{>Returns true if 1 of them isnt empty<}
{>-----------------------------------<}
	function RetStrs (var pre, suf: str255): boolean;
		var
			ILst: handle;
			TID: integer;
			TType: ResType;
			TName: str255;
	begin
		RetStrs := false;
{>Looks for needed resource.<}
		ILst := GetNamedResource('STR#', 'SBulkInit');
		if ILst <> nil then
		begin
{>Resource was found<}
			GetResInfo(ILst, TID, TType, TName);
			GetIndString(pre, TID, 1);
			GetIndString(suf, TID, 2);
			releaseresource(ILst);
			if (pre <> '') | (suf <> '') then
{>Boolean OR operation.<}
{>at least one wasn't empty<}
				RetStrs := true;
		end;
	end;

{>Returns true if scrap contains text<}
{>and returns a handle to the text<}
{>-----------------------------------<}
	function RetTScp (var THand: handle): boolean;
		var
			length, offset: longint;
	begin
{>Create handle for scrap manager<}
		THand := NewHandle(0);
{>Look for text in desk scrap<}
		length := GetScrap(THand, 'TEXT', offset);
{>Was there any text?<}
		RetTScp := (length > 0);
{If there was no text the handle}
{we allocated must be disposed of}
		if not (length > 0) then
			DisposHandle(THand);
	end;


{>Returns line index from the text<}
{>referred to by handle THandle, var More<}
{>returns true if there is more<}
{>text that follows this line<}
{>-----------------------------------<}
	function RetLNum (Index: integer;
									THandle: Handle;
									var More: boolean): str255;
		type
			StringArray = packed array[0..0] of char;
			SAPtr = ^StringArray;
			SAHandle = ^SAPtr;
		var
			TLength, y, x: integer;
			nchar: char;
			answer: str255;
	begin
{>How many charcters in the handle?<}
		Tlength := GetHandleSize(THandle);
		y := -1;
		answer := '';
{>go through the interceding lines<}
		for x := 1 to index - 1 do
			repeat
				y := y + 1;
			until (ord(SAHandle(THandle)^^[y]) = $0D) | (y = Tlength - 1);
{>Copy chars of line index into str255<}
		repeat
			y := y + 1;
			nchar := SAHandle(THandle)^^[y];
			if ord(NChar) <> $0D then
				answer := concat(answer, NChar);
		until (ord(NChar) = $0D) | (y = Tlength - 1);
{>If its not the end then there is more<}
		more := not (y = (TLength - 1));
		RetLNum := answer;
	end;

{>Resizes handle CatHandle to include the<}
{>string CatString&places it at the end<}
{>-----------------------------------<}
	procedure HandleConcat (var CHandle: handle;
									CString: str255);
		var
			StrLgt, HSize: integer;
			BlockStart: longint;
	begin
		HSize := GetHandleSize(CHandle);
		StrLgt := length(CString);
{>Resize handle to include string<}
		SetHandleSize(CHandle, HSize + StrLgt);
{Dereferencing handle so lock it down<}
		HLock(CHandle);
		BlockStart := ord(CHandle^);
{>Check to be sure handle was enlarged<}
		if GetHandleSize(CHandle) = HSize + StrLgt then
{>Yes,move string into handle!<}
			BlockMove(ptr(ord(@CString) + 1), ptr(BlockStart + HSize), strLgt)
		else
{>Memory outage,beep in displeasure!<}
			sysbeep(2);
		HUnLock(CHandle);
	end;

{>Cycles through each line in AHand,<}
{>commenting or decommenting as necessary.<}
{>-----------------------------------<}
	function ConvertText (pre, suf: str255;
									var AHand: handle): handle;
		var
			morelines: boolean;
			x: integer;
			AnswerHandle: handle;
			ILine, Oline: str255;
	begin
{>Allocate memory for converted text<}
		AnswerHandle := NewHandle(0);
		x := 0;
		repeat
			x := x + 1;
{>Get line x from text<}
			ILine := RetLNum(x, AHand, morelines);
{>Has it already been commented<}
			if (pos(pre, ILine) = 1) & (length(ILine) - length(suf) = pos(suf, ILine) - 1) then
{>Already commented.Remove end parts<}
				OLine := concat(copy(ILine, length(pre) + 1, length(ILine) - length(suf) - length(pre)), chr($0D))
			else
{>Raw text.Commentize.<}
				OLine := concat(pre, ILine, suf, chr($0D));
{>Add OLine to the end of handle<}
			HandleConcat(AnswerHandle, OLine);
		until not morelines;
{>No more text.Return handle<}
		ConvertText := AnswerHandle;
	end;

{Clears the scrap and replaces it<}
{with the new text handle<}
{>-----------------------------------<}
	procedure InstallNewScrap (Handler: handle);
		var
			err: longint;
	begin
		err := ZeroScrap;
{>After scrap is cleared just replace<}
		err := PutScrap(GetHandleSize(Handler), 'TEXT', Handler^);
	end;

{>The Top level procedure called MAIN as<}
{>dictated by THINK Pascal.<}
{>-----------------------------------<}
	procedure MAIN;
		var
			pre, Suf: str255;
			THand, OHand: handle;
	begin
		if RetStrs(pre, suf) then
			if RetTScp(THand) then
			begin
{>We have the strings and text to work with<}
				OHand := ConvertText(pre, suf, THand);
				InstallNewScrap(OHand);
{>Must clean up the mess!<}
				DisposHandle(Ohand);
				DisposHandle(THand);
			end;
	end;
end.



{>This should be kept in a separate<}
{>unit for testing/debugging<}
{>Remove before final compile<}
{>-----------------------------------<}
program CommentTester;
	uses
		CommentMain;
begin
	Main;
end.