{ ******************************************************** }
{ "wBMGlobals.p"                                           }
{                                                          }
{ by John A. Love, III [ Washington Apple Pi Users' Group] }
{                                                          }
{ using Symantec's "THINK Lightspeed Pascal", v 3.02       }
{                                                          }
{ ******************************************************** }


UNIT wBMGlobals;

INTERFACE

	USES
		QuickDraw;



{ --------------------- }
{   Global constants:   }
{ --------------------- }

	CONST

  { General constants ... }
		Enter = 3;
		ohFudge = 1;                              { Guess what ????? }

  { low-memory global: }
		ROM85Loc = $28E;

  { Specific constants ... }

  { Stuff for main Menu ... }
		kMBarDisplayed = 128;
		mainMBARID = kMBarDisplayed;

		AppleMenuID = 1;
		AboutItem = 1;
		AdisabledItem = 2;
  { ----- }
		FileMenuID = 2;
		NewWindowItem = 1;
		CloseWindowItem = 2;
		FdisabledItem = 3;
		QuitItem = 4;
  { ----- }
		EditMenuID = 3;
		UndoItem = 1;
		EdisabledItem = 2;
		CutItem = 3;
		CopyItem = 4;
		PasteItem = 5;
		ClearItem = 6;

  { Stuff for Window Menu ... }
		kMBarNotDisplayed = 129;
		wMBARID = kMBarNotDisplayed;

		wAppleMenuID = 1001;
		wAboutItem = 1;
		wAdisabledItem = 2;
  { ----- }
		wFileMenuID = 1002;
		wNewWindowItem = 1;
		wCloseWindowItem = 2;
		wFdisabledItem = 3;
		wQuitItem = 4;
  { ----- }
		wEditMenuID = 1003;
		wUndoItem = 1;
		wEdisabledItem = 2;
		wCutItem = 3;
		wCopyItem = 4;
		wPasteItem = 5;
		wClearItem = 6;
  { ---------------------- }
  { Hierarchical Menus ... }
  { ---------------------- }
		wNewHierMenuID = 104;
		wNewHierItem = 1;
		wCloseHierMenuID = 105;
		wCloseHierItem = 1;
		wHierHierMenuID = 106;
		wHierHierItem = 1;

  { Window goodies ... }
		maxWindows = 20;                      { A # subject only to memory. }
		kDefaultWindowID = 1001;
		mainWindowID = kDefaultWindowID;
		newWindowID = mainWindowID + 1;
		frame = 1;                            { Window parts in Pixels ... }
		shadow = 1;
		title = 18;
		horizScrollID = 128;
		vertScrollID = 129;
		scrollWidth = 16;
		scrollHeight = scrollWidth;
		growBoxSize = scrollWidth - frame;

  { Miscellaneous stuff ... }
		logoID = 131;

  { ------------------------------------------------------- }
  { ... for Error handling in my Off-screen map routine(s): }
  { ------------------------------------------------------- }

		NewCOSHdlError = -10000;
		MaxDevError = -15000;
		NewBaseAddrPtrError = -20000;
		CloneHdlError = -25000;

  { ------------------ }
  { MultiFinder stuff: }
  { ------------------ }

  { _WaitNextEvent = $A860;   --  in new "Traps.p" interface file }
  { _Unimplemented = $A89F;                                       }
		SysEnvironsVersion = 1;

  { OSEvt is the event number of the suspend/resume and mouse-moved Events sent }
  { by MultiFinder.  Once you determine that an event is an OSEvt, look at the  }
  { High byte of the message sent with the event to determine which kind it is. }
  { To differentiate between suspend & resume, look at the resumeFlag bit.      }

  {       in "Events.p":      }
  { OSEvt = app4Evt;          }
  { suspendResumeMessage = 1; }
  { mouseMovedMessage = $FA;  }
  { resumeFlag = 1;           }

  { --------------------------------- }
  { ... for Window Menu Bar routines: }
  { --------------------------------- }

		noneHilited = -1;            { Stored in "wMenuBar.hilited" if nada.       }
		menuTitleBit = 31;           { Offset for Menu title bit in "enableFlags". }
		flashDelay = 10;             { For blinking Menu title and Menu item.      }
		normalSize = 12;             { Radius FPD stuff ...                        }
		chicago16 = 16;              { Special FONT.                               }
		dontScrollMenu = 0;          { Pass to wDrawMenuBar if appropriate.        }
		atEnd = 0;                   { ... as in InsertMenu(MenuHdl, 0);           }
		noMBARrsrc = -1;             { There 'aint' any ...                        }
		mceMenuBar = 0;              { mctID & mctItem for color Menus ...         }
		mceMenuTitle = 0;
		zooming = TRUE;
		regMenu = 0;                 { NOT a Hierarchical Menu.                    }
		mainMenu = 0;                { NO parent Menu.                             }



{ ------------------------------------------ }
{                Global types:               }
{ ------------------------------------------ }

	TYPE

  { General stuff: }
		RgnHandlePtr = ^RgnHandle;
		wordPtr = ^INTEGER;
		longPtr = ^LONGINT;
  { BitMapPtr = ^BitMap;   --   in new "QuickDraw.p" interface file }

  { The following is required to avoid calling }
  { _GetNewWindow with NIL as the "wStroage"   }
  { parameter.  Otherwise, we risk fragmenting }
  { the Application Heap.                      }
  {                                            }
  { [Adapted from Dan Weston's Assembly Code]  }
		oneWStorage = RECORD
				inUse: BOOLEAN;
				fill: BOOLEAN;
				ws: WindowRecord;
			END;

		allWStorage = RECORD
				ones: ARRAY[1..maxWindows] OF oneWStorage;
			END;

		allWSPtr = ^allWStorage;
		allWSHdl = ^allWSPtr;

  { Off Screen stuff: }
		OffScreenRec = RECORD
				CreateOffScreenError: OSErr;
				oldDevice: GDHandle;
				origPort: GrafPtr;
				drawingRect: Rect;
				myMaxDevice: GDHandle;
				myBits: Handle;
				offGrafPort: GrafPort;
				offGrafPtr: GrafPtr;
				offCGrafPort: CGrafPort;
				offCGrafPtr: CGrafPtr;
				ourCTHandle: CTabHandle;
				offBitMapPtr: BitMapPtr;
			END;

		OffScreenRecPtr = ^OffScreenRec;
		OffScreenRecHdl = ^OffScreenRecPtr;

  { ... for Window Menus: }
		wMenuRec = RECORD
				mh: MenuHandle;
				menuType: INTEGER;             { Regular or Hierarchical. }
				parentID: INTEGER;             { Hierarchical stuff ...   }
				menuParentRgn, cumParentRgn: RgnHandle;
				titleRect: Rect;
      { MenuDownOSHdl: OffScreenRecHdl;  --  local in wMenuSelect }
			END;

		wMenuBar = RECORD
				numMenus: INTEGER;
				barLength: INTEGER;
				titleHilited: INTEGER;         { Menu # or "noneHilited". }
				leftScrollPoly, rightScrollPoly: PolyHandle;
                                       { ........ to Menu Scroll Activators (MSA). }
				saveCumScrollMenuX: INTEGER;
				barOSHdl: OffScreenRecHdl;
				wp: WindowPtr;
				wMCTable: MCTableHandle;
				wMenus: ARRAY[0..0] OF wMenuRec;
			END;

		wMenuBarPtr = ^wMenuBar;
		wMenuBarHandle = ^wMenuBarPtr;
  { ---------- }
		wMenuBarList = RECORD
				numWindows: INTEGER;
				wMBars: ARRAY[0..0] OF wMenuBarHandle;
			END;

		wMenuBarListPtr = ^wMenuBarList;
		wMenuBarListHdl = ^wMenuBarListPtr;

		aDynamicBalloon = RECORD          { ... for my NEW dynamic windows. }
				dynamicStrID: INTEGER;
				dynamicStrIndex: INTEGER;
				dynamicR: Rect;
			END;

  { The BIG guys: }

		RadBWStatus = PACKED RECORD
				Signature, CPFlags, SSDelay, VertOffset: Char;  { For Internal use, ONLY !! }
				LargeFontEn, PluggedIn: Char;     { PluggedIn = DontRepos }
				MacBits: BitMapPtr;
				BigTicksPtr: Ptr;
				BigTicks: LONGINT;
				Reserved1: LONGINT;
				TopBigRAM, IdleHook: Ptr;
				Reserved2: LONGINT;
				CursorHook: Ptr;
			END;

		RadBWStatPtr = ^RadBWStatus;
		RadBWStatHdl = ^RadBWStatPtr;
  { ---------- }
		RadIIStatus = PACKED RECORD
				AutoCenter, AutoLower, TearOffMenus, ScreenDump: Char;
				LargeMenus, ScreenSaver, SaverActive, Reserved: Char;
				ScreenSaverDelay, InitVers: INTEGER;
				CardID: PACKED ARRAY[0..5] OF Char;
				ROMVers: PACKED ARRAY[0..5] OF INTEGER;
			END;

		RadIIStatPtr = ^RadIIStatus;
		RadIIStatHdl = ^RadIIStatPtr;
  { ---------- }
		PivotDataStruct = PACKED RECORD
				flipped, command, dLogFlags, xInternal, topOffset, bottomOffset: Char;
				tileFactor: INTEGER;
				reserved: PACKED ARRAY[0..4] OF Char;
				movementFlags: Char;
				parameter, result: LONGINT;
				resultRect: Rect;
			END;

		PivotDSPtr = ^PivotDataStruct;
		PivotDSHand = ^PivotDSPtr;
  { ---------- }
		radiusType = (none, radBW, radII);

		RadiusData = RECORD
				PivotHdl: PivotDSHand;
				CASE radType : radiusType OF
					none: (

					);
					radBW: (
							BWHdl: RadBWStatHdl;
					);
					radII: (
							IIHdl: RadIIStatHdl;
					);
			END;

		RadiusDataPtr = ^RadiusData;
		RadiusDataHdl = ^RadiusDataPtr;



{ --------------------- }
{   Global variables:   }
{ --------------------- }

	VAR

  { ... for Main PROGRAM: }
		gStripAddressMask: LONGINT;
		oldPort: GrafPtr;
		lScreen, gScreen, visRect, updateRect: Rect;
		ROM: wordPtr;
		mBarHt: INTEGER;
		gInitPPCToolbox, gInitAppleEvents: OSErr;
		AppleMenu, FileMenu, EditMenu: MenuHandle;
		aMac2, hasGrowIcon: BOOLEAN;
		colorDepth: INTEGER;
		TheWindow, FW: WindowPtr;
		windowCount, newCount, windType: INTEGER;
		windowStorage: allWSHdl;
		Event: EventRecord;
		windowLoc: INTEGER;
		ignore, moreNew, brandNew: BOOLEAN;
		offset, deltaOffset: Point;
    { ... to avoid flickering Menu Bar: }
		prevDA, prevWind, currDA, myAppl, applWind: BOOLEAN;
		Done, InWindow, InWBMenu: BOOLEAN;
		WNE, InForeGround: BOOLEAN;
		Sleep, finalTicks: LONGINT;
		ourControl: ControlHandle;

  { Window Menus ... }
		pnState: PenState;
		WBMrect, leftMSArect, rightMSArect, gWBMrect: Rect;
		mbHState: SignedByte;
		oldClip, onScreenRgn: RgnHandle;
		oldForeColor, oldBackColor: RGBColor;     { Color stuff ... }
		oldMCTable, newMCTable: MCTableHandle;
		found: BOOLEAN;
		mBarList: wMenuBarListHdl;
		mBar: wMenuBarHandle;
		newBarListSize, newWMBSize: Size;
		titleWidth, scrollPolyDXY: INTEGER;
		betweenTitles, invertOverlap: INTEGER;    { Pixels between adjacent Menus & }
                                              { Pixels to invert on each side   }
                                              {   of Menu title.                }
		aboveBelowItem, menuFrame, menuShadow, frameShad: INTEGER;
		whichMenu, whichItem: INTEGER;

  { Radius' BIG screens ... }
		WMgrPort: GrafPtr;
		FPDRsrc: RadiusData;
		BIGfont: Handle;
		sizeFont: INTEGER;

  { System 7.0 ... }
		startBalloons, balloonsUp, saveBalloons: BOOLEAN;
		HelpMenu: MenuHandle;
		origNumHelpItems: INTEGER;
		dynamicBalloons: ARRAY[0..2] OF aDynamicBalloon;
		lastBalloon: INTEGER;





IMPLEMENTATION

END.   { UNIT = wBMGlobals }