// "wBarMenu(SARez).r"
// -- the Resources for "wBarMenu DEMO"
//
// -- using "SARez" { v 3.2 }



// The new "Types.r" resource description file for System 7
// adds an unsigned integer field to each of the following.
// The added field pertains to window positioning:
//
//		type	'ALRT'
//		type	'DLOG'
//		type	'WIND'
//
// For this application, I do not have a 'DLOG' resource.  For my
// 'WIND' resources,  my Pascal source handles positioning, so I
// specify "noAutoCenter" in this field.  For my 'ALRT' resource,
// I let System 7 handle it by specifying "centerMainScreen".
//
// Note that my application is definitely "System 7 friendly".
// Not only does it work, but it takes advantage of some of
// the Help Manager features, in particular, Balloon Help:

#define	SystemSevenOrLater	true
#define	oldTemp	true			/* "Somin" so I do NOT have to specify */
								/*		0x0,		{ wCSeed }		   */
								/*		0,			{ wCReserved }     */
								/* for every Color Table			   */
								/* ... but I wanna !!!	So sue me !!!  */

#ifndef	_TYPES_
#include	"Types.r"
#endif

#ifndef	_MACAPPTYPES_
#include	"MacAppTypes.r"
#endif

// #ifndef	_VIEWTYPES_
// #include	"ViewTypes.r"
// #endif

#ifndef	_BALLOONTYPES.R_
#include	"BalloonTypes.r"
#endif

/* ----- my stuff ... ----- */

include	"System 7";
include	"Bush Inauguration Speech";
include	"MoofSND";
include	"ZoomSNDs";
include	"LogoPICT";
include	"Bill (B&W)";			/* Help Manager has problems with PICTs */
								/* in 'hfdr' resource that do NOT have  */
								/* a rect whose topLeft = (0, 0).       */



/* ----- Constants ----- */

#define	kMainWindowID		kDefaultWindowID	/* = 1001 */
#define	kNewWindowID		kMainWindowID + 1
#define	cUndoNewWindow		3010				/* = 3000 + cNew        */
												/* for "BuzzWords" cmnu */
#define	kHorizScrollBarID	128
#define	kVertScrollBarID	129
#define	kWBMApple			1001
#define	mySicnRsrc			300					/* rsrc ID */
#define	mySicn				mySicnRsrc - 256	/* Item Icon's # */
#define	kWBMFile			1002
#define	myIconRsrc			400					/* rsrc ID */
#define	myIcon				myIconRsrc - 256	/* Item Icon's # */
#define	kWBMEdit			1003
#define	kWBMHierNew			104					/* IDs of Hierarchical Menus */
#define	kWBMHierClose		105					/*   must fit into a byte.   */
#define	kWBMHierHier		106
#define cHier				1004
#define	kVersID				0					/* Finder stuff ... */
#define	kTopStringID		2
#define	kBottomStringID		1
#define	kLocalID			0
#define	kBNDL_ID			128
#define	kFREF_ID			128
#define	kICN_ID				128
//
#define	kBragWindowID		999
#define	kSystem7			132					/* ID of "System 7" PICT */


type	'JAL3'	{							/* TYPE = Signature */
	pstring;
};

type	'vers'	{
	byte		defaultVersion = 1;			/* version            */
	byte		defaultRevision = 5;		/* revision           */
	byte		defaultRevStage = 128;		/* revStage           */
	byte		defaultBuildNbr = 2;		/* buildNbr           */
	integer		defaultLang = 0;			/* languageInt        */
	pstring;								/* abbreviated string */
	align	word;
	pstring;
};

/////////////////////

resource	'JAL3'	(kVersID, "Version", purgeable)	{
	"Window Bar Menu DEMO {v 1.}"
};

resource	'BNDL'	(kBNDL_ID, purgeable)	{
	'JAL3',								/* Signature  */
	kVersID,
	{ 
		'FREF',
		{
			kLocalID, kICN_ID;			/* Local, Actual ID(s) */
		};

		'ICN#',
		{
			kLocalID, kICN_ID;
		};
	};
};
	
resource	'FREF'	(kFREF_ID, "Application", purgeable)	{
	'APPL',
	kLocalID,
	"Window Bar Menu DEMO"
};

resource	'ICN#'	(kICN_ID, "IACS", purgeable)	{
	{	/* Data */
		$"00000000 00000000 6040FC7E 60E0FC7E"
		$"61B0C060 6318C060 6318C060 6318C060"
		$"6318C060 6318C060 6318C060 6318C060"
		$"63F8C07E 63F8C07E 6318C006 6318C006"
		$"6318C006 6318C006 6318C006 6318C006"
		$"6318C006 6318C006 6318C006 6318FC7E"
		$"6318FC7E 00000000 00000000 00000000"
		$"7FFFFFFE 7FFFFFFE 00000000 00000000";

		/* Mask */
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF";
	};
};

resource	'vers'	(kTopStringID, purgeable)	{
	defaultVersion,
	defaultRevision,
	defaultRevStage,
	defaultBuildNbr,
	defaultLang,
	"90",
	"1990   IACS Software"
};

resource	'vers'	(kBottomStringID, purgeable)	{
	defaultVersion, defaultRevision, defaultRevStage,defaultBuildNbr, defaultLang,
	"1.",
	"1. ... in color too, folks !!"
};

resource	'SIZE'	(-1, purgeable)		{
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,				/* ... when suspended */
	ignoreChildDiedEvents,
	not32BitCompatible,
	isHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	384*1024,
	224*1024
};

/////////////////////

resource	'cmnu'	(mApple)	{
	mApple,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{
	/* [ 1] */ "About Window Bar Menu Demo ...",
			   mySicn, "\0x1E", noMark, plain, cAboutApp;
	/* [ 2] */ "-", noIcon, noKey, noMark, plain, noCommand;
	}
};

/* ----- */

resource	'cmnu'	(mFile)	{
	mFile,
	textMenuProc,
	0x7FFFFFFB,
	enabled,
	"File",
	{
	/* [ 1] */ "New Window", noIcon, "N", noMark, plain, cNew;
	/* [ 2] */ "Close Window", noIcon, "W", noMark, plain, cClose;
	/* [ 3] */ "-", noIcon, noKey, noMark, plain, noCommand;
	/* [ 4] */ "Quit", myIcon, "Q", noMark, italic, cQuit;
	}
};

/* ----- */

resource	'cmnu'	(mEdit)	{
	mEdit,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"Edit",
	{
	/* [ 1] */ "Undo", noIcon, "Z", noMark, plain, cUndo;
	/* [ 2] */ "-", noIcon, noKey, noMark, plain, noCommand;
	/* [ 3] */ "Cut", noIcon, "X", noMark, plain, cCut;
	/* [ 4] */ "Copy", noIcon, "C", noMark, plain, cCopy;
	/* [ 5] */ "Paste", noIcon, "V", noMark, plain, cPaste;
	/* [ 6] */ "Clear", noIcon, noKey, noMark, plain, cClear;
	}
};

resource	'cmnu'	(mBuzzWords)	{
	mBuzzWords,
	textMenuProc,
	allEnabled,
	enabled,
	"Buzzwords",
	{
	/* [ 1] */ "New Window", noIcon, noKey, noMark, plain, cUndoNewWindow;
	}
};

/* ----- */

resource	'MBAR'	(kMBarDisplayed)	{ {mApple, mFile, mEdit} };

/////////////////////

resource	'cmnu'	(kWBMApple)	{
	kWBMApple,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"IACS",		/* _GetRMenu messes up if title = apple symbol & menuID <> 1 */
	{
	/* [ 1] */ "About Window Bar Menu Demo ...",
			   mySicn, "\0x1E", noMark, plain, cAboutApp;
	/* [ 2] */ "-", noIcon, noKey, noMark, plain, noCommand;
	}
};

/* ----- */

resource	'cmnu'	(kWBMFile)	{
	kWBMFile,
	textMenuProc,
	0x7FFFFFFB,
	enabled,
	"File",
	{
	/* [ 1] */ "New Window", noIcon,
			   hierarchicalMenu,
			   "\0x68",					/* ID of hierarchical Menu = 104 */
			   plain, cNew;
	/* [ 2] */ "Close Window", noIcon, hierarchicalMenu, "\0x69", plain, cClose;
	/* [ 3] */ "-", noIcon, noKey, noMark, plain, noCommand;
	/* [ 4] */ "Quit", myIcon, "Q", noMark, italic, cQuit;
	}
};

/* ----- */

resource	'cmnu'	(kWBMEdit)	{
	kWBMEdit,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"Edit",
	{
	/* [ 1] */ "Undo", noIcon, "Z", noMark, plain, cUndo;
	/* [ 2] */ "-", noIcon, noKey, noMark, plain, noCommand;
	/* [ 3] */ "Cut", noIcon, "X", noMark, plain, cCut;
	/* [ 4] */ "Copy", noIcon, "C", noMark, plain, cCopy;
	/* [ 5] */ "Paste", noIcon, "V", noMark, plain, cPaste;
	/* [ 6] */ "Clear", noIcon, noKey, noMark, plain, cClear;
	}
};

/* ----- */

resource	'cmnu'	(kWBMHierNew)	{
	kWBMHierNew,
	textMenuProc,
	allEnabled,
	enabled,
	"",                             /* No title. */
	{
	/* [ 1] */ "Use Main Menu !!!", noIcon, noKey, noMark, bold, cHier;
	}
};

/* ----- */

resource	'cmnu'	(kWBMHierClose)	{
	kWBMHierClose,
	textMenuProc,
	allEnabled,
	enabled,
	"",
	{
	/* [ 1] */ "Use Main Menu", noIcon, noKey, noMark, bold, cHier;
	/* [ 2] */ "Recursion anyone !!!", myIcon,
				hierarchicalMenu, "\0x6A",
				italic, cHier;
	}
};

/* ----- */

resource	'cmnu'	(kWBMHierHier)	{
	kWBMHierHier,
	textMenuProc,
	allEnabled,
	enabled,
	"",
	{
	/* [ 1] */ "*** God Bless the USA ***", mySicn, "\0x1E", noMark, bold, cHier;
	}
};

/* ----- */

resource	'MBAR'  (kMBarNotDisplayed) { {kWBMApple, kWBMFile, kWBMEdit} };

/////////////////////

resource	'mctb'  (kWBMApple)	{

	{
		// MenuBar entry:

		0,						/* mctID for the MenuBar.   */
		0,						/* mctItem for the MenuBar. */
		{   
				0,	30000,		0;  /* mctRGB1 = dflt color for title (med green). */
			57344,	57344,	57344;  /* mctRGB2 = dflt color for background         */
									/*           of pulled-down Menu (lt gray).    */
				0,		0,  65535;  /* mctRGB3 = dflt color for items (blue).      */
			64512,	62333,   1327;  /* mctRGB4 = color of MenuBar (yellow).        */
		};

		// Different-from-normal title & item entries may follow here.
		// Otherwise, the MenuBar entry above takes care of them all.

        /*++++++++*/

		mctbLast,               /* last entry marker (ID = -99) ... */
		0,
		{
				0,		0,		0;
				0,		0,		0;
				0,		0,		0;
				0,		0,		0;
		};                      /* End of last element in MCTBArray */
	};                  /* End of MCTBArray */
};              /* End of resource */

/* ----- */

resource	'mctb'	(kWBMFile)	{

	{
		0,
		0,
		{   
				0,	30000,		0;
			57344,	57344,	57344;
				0,		0,  65535;
            64512,	62333,   1327;
        };

        /*++++++++*/

        mctbLast,
        0,
        {
				0,		0,		0;
				0,		0,		0;
				0,		0,		0;
				0,		0,		0;
        };
    };
};

/* ----- */

resource	'mctb'	(kWBMEdit)	{

	{
		0,
		0,
		{   
				0,	30000,		0;
			57344,	57344,	57344;
				0,		0,  65535;
            64512,	62333,   1327;
        };

        /*++++++++*/

        mctbLast,
        0,
        {
				0,		0,		0;
				0,		0,		0;
				0,		0,		0;
				0,		0,		0;
        };
    };
};

/* ----- */

resource	'mctb'	(kWBMHierNew)	{

	{
		0,
		0,
		{   
				0,	30000,		0;
			57344,	57344,	57344;
				0,		0,  65535;
			64512,	62333,   1327;
        };

        /*++++++++*/

        mctbLast,
        0,
        {
				0,		0,		0;
				0,		0,		0;
				0,		0,		0;
				0,		0,		0;
        };
    };
};

/* ----- */

resource	'mctb'	(kWBMHierClose)	{

	{
		0,
		0,
		{   
				0,	30000,		0;
			57344,	57344,	57344;
				0,		0,  65535;
			64512,	62333,   1327;
        };

        /*++++++++*/

        mctbLast,
        0,
        {
				0,		0,		0;
				0,		0,		0;
				0,		0,		0;
				0,		0,		0;
        };
    };
};

/* ----- */

resource	'mctb'	(kWBMHierHier)	{

	{
		0,
		0,
		{   
				0,	30000,		0;
			57344,	57344,	57344;
				0,		0,  65535;
			64512,	62333,   1327;
        };

        /*++++++++*/

        mctbLast,
        0,
        {
				0,		0,		0;
				0,		0,		0;
				0,		0,		0;
				0,		0,		0;
        };
    };
};

/* ----- */

resource	'mctb'	(kMBarNotDisplayed)	{

	{
		0,
		0,
		{   
				0,	30000,		0;
			57344,	57344,	57344;
				0,		0,  65535;
			64512,	62333,   1327;
        };

        /*++++++++*/

        mctbLast,
        0,
        {
				0,		0,		0;
				0,		0,		0;
				0,		0,		0;
				0,		0,		0;
        };
    };
};

/////////////////////

resource	'WIND'	(kMainWindowID, "the Main Window", purgeable)	{
	{30, 40, 280, 390},
	rDocProc,
	invisible,
	goAway,
	0x0,								/* refCon */
	"Window Bar Menu Demo",
	noAutoCenter
};

/*--------*/

resource	'wctb'	(kMainWindowID, "the Main Window", nonpurgeable)	{
	0x0,					// wCSeed
	0,						// wCReserved
	{
		// Text color = color of window's title.
		// Hilite color = color of horizontal lines, close box and
		//                grow box in title bar.
		// Color of title bar = color around horizontal lines and
		//                      the two boxes in the title bar.
		//
		// Howsomever, rDocProc is a special case:
		//
		// a) text color = content color.
		// b) hilite color must ALWAYS be white.
		// c) color of title bar = frame color.
		//
		// Please note that these ColorSpecs for wTextColor,
		// wHiliteColor and wTitleBarColor are commented out because
		// Mommy ROM takes care of the above conversions !!

		wContentColor,	65535,  65535,  65535;		/* white */
		wFrameColor, 	65535, 		0, 		0;		/* red   */
	//	wTextColor, 	65535,  65535,  65535;		/* white */
	//	wHiliteColor,	65535,  65535,  65535;		/* white */
	//	wTitleBarColor, 65535, 		0, 		0;		/* red   */
	}
};

/////////////////////

resource	'WIND'	(kNewWindowID, "a New Window", purgeable)	{
	{30, 40, 280, 390},
	zoomDocProc,
	invisible,
	goAway,
	0x0,								/* refCon */
	Untitled,
	noAutoCenter
};

/*--------*/

resource	'wctb'	(kNewWindowID, "a New Window", nonpurgeable)	{
	0x0,					// wCSeed
	0,						// wCReserved
	{
		wContentColor,	65535,	65535,	65535;		/* white       */
		wFrameColor, 	65535, 		0, 		0;		/* red         */
		wTextColor, 		0, 		0,	65535;		/* blue        */
		wHiliteColor,		0, 		0, 		0;		/* black       */
		wTitleBarColor, 45056,	45056,	45056;		/* medium gray */
	}
};

//////////

resource	'CNTL'	(kHorizScrollBarID, "horizontal", purgeable)	{
	{284, 0, 300, 385},				// 300-scrollHeight,0,300,400-growBoxSize
									// ( Resized by program. )
	0,								// Initial value
	invisible,
	1,								// Maximum value (normally set by the program)
	0,								// Minimum value
	scrollBarProc,
	128,							// User-defined value for refCon.
	""								// no title
};

/*--------*/

resource	'cctb'	(kHorizScrollBarID, "horizontal", purgeable)	{
	0x0,					// ccSeed
	0,						// ccReserved
	{
		//
		// Frame color = also, the foreground/body color for highlighted Arrows.
		// Body color = also, the shaft's color for a de-activated control.
		// Text color = unused for a Scroll Bar.
		// Thumb color = its fill color.
		//
		cFrameColor,	65535, 		0, 		0;			/* red   */
		cBodyColor,		65535,	65535,	65535;			/* white */
		cTextColor, 		0, 		0, 		0;			/* black */
		cElevatorColor, 	0, 		0, 		65535;		/* blue  */
	};
};

//////////

resource	'CNTL'	(kVertScrollBarID, "vertical", purgeable)	{
	{0, 384, 285, 400},				// 0,400-scrollWidth,300-growBoxSize,400
									// ( Resized by program. )
	0, invisible, 1, 0, scrollBarProc, 129, ""
};

/*--------*/

resource	'cctb'	(kVertScrollBarID, "vertical", purgeable)	{
	0x0,
	0,
	{
		cFrameColor,	65535, 		0, 		0;
		cBodyColor,		65535,	65535,	65535;
		cTextColor, 		0, 		0, 		0;
		cElevatorColor, 	0, 		0, 	65535;
	};
};

/////////////////////

resource	'WIND'	(kBragWindowID, "Brag", purgeable)	{
	{60, 40, 285, 480},
	altDBoxProc,
	visible,
	nogoAway,
	0x0,								/* Refcon */
	"",									/* NO title for this type */
	centerMainScreen					/* An exception ... */
};

resource	'WIND'	(kSystem7, "System 7", purgeable)	{
	{91, 206, 251, 306},
	plainDBox,
	visible,
	nogoAway,
	0x0,
	"",
	centerMainScreen
};

/////////////////////

resource	'ALRT'	(777, "AppleEvents", purgeable)	{

	{50, 50, 50+120, 50+288},
	777,								/* ID of corresponding DITL. */
	{
		OK, visible, sound1;			/* Stage #4 */
		OK, visible, sound1;			/* Stage #3 */
		OK, visible, sound1;			/* Stage #2 */
		OK, visible, sound1				/* Stage #1 */
	},
	centerMainScreen

};

resource	'DITL'	(777, "AppleEvents", purgeable)	{

	{
	 /* {10,  20,  42,  52}, Icon		{ enabled,  noteIconID=1}. */
		{90, 110, 110, 168}, Button     { enabled,  "OK"};
		{10,  72,  30, 268}, StaticText { disabled, "^0"};
		{30,  72,  50, 268}, StaticText { disabled, "^1"};
		{50,  72,  70, 268}, StaticText { disabled, "^2"};
	};

};

/////////////////////

resource	'cicn'	(myIconRsrc, "Face", purgeable)	{
	// *
	// ********** IconPMap **********
	// *
	// $00000000		/* fill long = pBaseAddr 				  */
	// unsigned bitstring[1] = 1	pRowBytes = $8000 +
	// unsigned bitstring[2] = 0
	$0010,				/* pMapRowBytes = pixelSize * rowBytes(4) */
	{ 0, 0, 32, 32 },	/* bounds 								  */
	0,					/* pmVersion 							  */
	0,					/* packType 							  */
	0,					/* packSize 							  */
	$00480000,			/* hRes 								  */
	$00480000,			/* vRes 								  */
	chunky,				/* pixelType 							  */
	4,					/* pixelSize 							  */
	1,					/* cmpCount 							  */
	4,					/* cmpSize = pixelSize 					  */
	0,					/* planeBytes 							  */
	0,					/* pmTable 								  */
	// 00000000			/* fill long = pmReserved 				  */
	// *
	// ********** IconMask **********
	// *
	// 00000000			/* fill long = mBaseAddr */
	4,					/* maskRowBytes 		 */
	{ 0, 0, 32, 32 },	/* mbounds    			 */
	// *
	// ********** IconBMap **********
	// *
	// 00000000			/* fill long = 1BaseAddr */
	4,					/* iconBMapRowBytes		 */
	{ 0, 0, 32, 32 },	/* 1bounds    			 */
	// *
	// ********** IconData **********
	// *
	// 00000000			/* fill long = Placeholder for Handle. */
	// *
	// ********** MaskData **********
	// *
	// hex string [$$Word(maskRowBytes) * ($$BitField(Bounds, 32, 16) /*bottom*/ -
	//									   $$BitField(Bounds, 0, 16)  /*top*/      ]
	$"00BFEF80 01BFBFC0 03FFFFE0 0EFFFFF0"
	$"07FFFFF8 0FFFFFF0 0FFFFFF8 1FFFFFF8"
	$"0FFFFFFC 3FFFFFFE 3FFFFFFE 1FFFFFFE"
	$"7FFFFFFE 3FFFFFFC 7FFFFFFE 3FFFFFFE"
	$"7FFFFFFE 1FFFFFFE 0FFFFFFE 1FFFFFFE"
	$"0FFFFFFF 07FFFFF8 01FFFFF0 00FFFFC0"
	$"00FFFEC0 00FFFFF8 01FFFFFF 03FFFFFF"
	$"1FFFFFFE 7FFFFFE0 FFFFFFC0 01FFFF00",
	// *
	// ********** BMapData **********
	// *
	// hex string [$$Word(iconBMapRowBytes) * ($$BitField(Bounds, 32, 16) /*bottom*/ -
	//									   	   $$BitField(Bounds, 0, 16)  /*top*/      ]
	$"0017C300 00BFAF80 01B7FFC0 06EFB7E0"
	$"03F73AF0 07D40960 05C20330 0FA00230"
	$"07800138 1D8001FC 178000DC 0F8000FC"
	$"3FBA2F6C 1BBDDC88 3B566A4C 190A1D4C"
	$"3C024054 0C8640BC 07742E3C 0F034034"
	$"058FF87A 029BECD0 009C1CA0 0043E080"
	$"0061C280 00400070 0050044E 00C80861"
	$"0783E060 18800040 20C000C0 00600300",
	// *
	// ********** PMapCTab **********
	// *
	0x0,									/* ictSeed */
	0,										/* ictFlags */
	// integer = $$Countof(ColorSpec) - 1	/* ctSize */
	// *
	// ********** startICT **********
	// *
	{
		0, $FFFF, $FFFF, $FFFF;		/* white       */
		1, $FFFF, $B95B, $AD15;		/* light flesh */
		2, $FFFF, $8978, $70E4;		/* dark flesh  */
		3, $DD6B, $08C2, $06A2;		/* red         */
		4, $7EFF, $41F2, $22FD;		/* brown       */
		5, $0000, $0000, $D400;		/* blue        */
		6, $0000, $0000, $0000;		/* black       */
	},
	// *
	// ********** endICT **********
	// *
	// ********** PMapData **********
	// *
	// hex string [$$BitField(pMapRowBytes, 0, 13) * 
	//			   ($$BitField(Bounds, 32, 16) /*bottom*/ -
	//			    $$BitField(Bounds, 0, 16)  /*top*/      ]
	$"00000000 00060666 66000066 00000000"
	$"00000000 60666666 60606666 60000000"
	$"00000006 60660666 66666666 66000000"
	$"00000660 66616666 61661666 66600000"
	$"00000066 66661666 11666161 66660000"
	$"00000666 66161611 11116116 16600000"
	$"00000606 66111161 11111166 11660000"
	$"00006666 61611111 11111161 11660000"
	$"00000666 61111111 11111116 11666000"
	$"00066606 61111111 11111116 66666600"
	$"00060666 61111111 11111111 66166600"
	$"00006666 61111111 11111111 66666600"
	$"00666666 33333131 13333331 16616600"
	$"00066163 41444313 34144413 61116000"
	$"00666163 14141321 34414143 16116600"
	$"00066113 11114321 31144413 16116600"
	$"00666613 11111321 31111113 16160600"
	$"00006611 33333121 13333331 61666600"
	$"00000666 11111211 11111111 11666600"
	$"00006666 11111122 12111111 11660600"
	$"00000606 11112222 22222111 16666060"
	$"00000060 11122122 22212211 66060000"
	$"00000000 11122211 11122211 10600000"
	$"00000000 01111122 22211111 10000000"
	$"00000000 01111112 22111121 10000000"
	$"00000000 02111111 11111211 55550000"
	$"00000000 51121111 11112111 55555550"
	$"00000005 51112111 11121111 55555550"
	$"00005555 11111222 22111111 55555500"
	$"00555555 55555555 55555555 55000000"
	$"05555555 55555555 55555555 50000000"
	$"00000000 55555555 55555550 00000000"
};

/////////////////////

// Mac SE-&-below-version for the above:

resource	'ICON'	(myIconRsrc, "Face", purgeable)	{
	$"0017C300 00BFAF80 01B7FFC0 06EFB7E0 03F73AF0 07D40960 05C20330 0FA00230"
	$"07800138 1D8001FC 178000DC 0F8000FC 3FBA2F6C 1BBDDC88 3B566A4C 190A1D4C"
	$"3C024054 0C8640BC 07742E3C 0F034034 058FF87A 029BECD0 009C1CA0 0043E080"
	$"0061C280 00400070 0050044E 00C80861 0783E060 18800040 20C000C0 00600300"
};

/////////////////////

resource    'SICN'  (mySicnRsrc, "IACS", purgeable) {
    {
        $"FFFF"
        $"FFFF"
        $"B311"
        $"AD77"
        $"AD77"
        $"AD77"
        $"AD77"
        $"AD77"
        $"A171"
        $"AD7D"
        $"AD7D"
        $"AD7D"
        $"AD7D"
        $"AD11"
        $"FFFF"
        $"FFFF"
    };
};

/////////////////////   Balloon Help goodies ... /////////////////////

resource	'hfdr'	(kHMHelpID, "Finder help", purgeable)	{

	HelpMgrVersion,
	hmDefaultOptions,
	0,							/* balloon definition function */
	0,							/* variation code */
	{	/* HFdrArrays ... */
		HMPictItem	{
			999					/* Picture Resource ID */
		};
	};

};

// Only the NEW windows can be dynamically sized.  The initial rDocProc
// window is a static window; however, both window types have hot rects
// that vary in size with the presence of a Radius BIG screen.
// Therefore, I do NOT have 'hwin' and 'hrct' resources in this file.

/////////////////////

resource	'STR#'	(128, "Window content help text", purgeable)	{
	{
	/* [1] 												*/
	/* Now, part of my 'hfdr' HMPictItem PICT resource. */
	/* So, this string is no longer used.               */
	"Aint he cute?!*!?\n"
	"   Courtesy of:\n"
	"IACS Software";
	/* [2] */
	"This is the famous Window Bar Menu\n"
	"   ... or ...\n"
	"Window Menu Bar\n"
	"   ... or ...\n"
	"any other name that comes to mind !!!";
	/* [3] */
	"This is the left Menu Scroll Activator(MSA).  "
	"Learn more about it by creating a new window!!!";
	/* [4] */
	"This is the right Menu Scroll Activator(MSA).  "
	"Learn more about it by creating a new window!!!";
	/* [5] */
	"This is the famous Window Bar Menu\n"
	"   ... or ...\n"
	"Window Menu Bar\n"
	"   ... or ...\n"
	"any other name that comes to mind !!!";
	/* [6] */
	"Resize the window and then click on this MSA to scroll the Window "
	"Menu Bar to the right.  Now, zoom the window and watch the magic !!!";
	/* [7] */
	"Resize the window and then click on this MSA to scroll the Window "
	"Menu Bar to the left.  Now, zoom the window and watch the magic !!!";
	}
};

/////////////////////

resource	'hmnu'	(kHMHelpMenuID, "my Help Menu item", purgeable)	{

	HelpMgrVersion,
	hmDefaultOptions,
	0,							/* balloon definition function */
	0,							/* variation code */
	HMSkipItem	{
	/* no missing items */
	},
	/* NO Menu Title items for this special case. */
	/* The Help Manager processes Balloons for    */
	/* all the standard Help Menu items.          */
	{	/* my added item */
		HMStringItem	{
			"Watch the spiffy fireworks !!!",	/* enabled */
			"Item is dimmed.",
			"Item is checked.",
			""									/* Item canNOT be otherwise marked. */
		};
	};			/* End of Menu Title + items */

};
