unit lists;
interface
uses
	ObjIntf, iterators;

type
	listObj = object (TObject)
		first : listElementObj;
		procedure init;
		procedure append (e : listElementObj);
		procedure appendList (l : listObj);
		procedure insert (e : listElementObj);
		procedure head (var e : univ listElementObj);
		procedure release;
		end;
	
	listElementObj = object (TObject)
		next : listElementObj;
		procedure init;
		function release : boolean;
		end;

	listIterator = object (iterator)
		function another (var anObject : univ TObject) : boolean; override;
		end;
		
implementation

procedure listObj.init;
begin
	first := nil end;

procedure listObj.append (e : listElementObj);
var
	t : listElementObj;
begin
	if first = nil
	then first := e
	else begin
		t := first;
		while t.next <> nil do t := t.next;
		t.next := e end end;
	
procedure listObj.appendList (l : listObj);
var
	p : listElementObj;
begin
	append (l.first);
	l.first := nil;
	l.release end;
	
procedure listObj.insert (e : listElementObj);
begin
	e.next := first;
	first := e end;

procedure listObj.head (var e : univ listElementObj);
begin
	e := first;
	if first <> nil { guards both potential nil references, e and first }
	then begin
		first := first.next;
		e.next := nil end end;

procedure listObj.release;
var
	t, t2 : listElementObj;
begin
	t := first;
	while t <> nil do begin
		t2 := t;
		t := t.next;
		{ release list element storage, if it has any }
		if t2.release 
		then dispose (t2) end;
	dispose (self) end;

procedure listElementObj.init;
begin
	next := nil end;

{ Override this if your list element must release storage before
  being disposed of.  Return true if the element can be disposed of.
  If other references to the element still exist, return false.  This
  generic release assumes that only 1 reference to any element exist.}
function listElementObj.release : boolean;
begin 
	release := true end;
	
function listIterator.another (var anObject : univ TObject) : boolean;
begin
	if i = nil
	then i := listObj(subject).first
	else i := listElementObj(i).next;
	anObject := i;
	another := i <> nil end;
	
end.