program testLists (input, output);
uses
	ObjIntf, iterators, lists, memCheck, PasLibIntf;
	
type
	testListObj = object (listObj)
		procedure dump;
	end;
	
	testListElementObj = object (listElementObj)
		data : integer;
		procedure dump;
	end;
	
var
	testList, testList2 : testListObj; { some lists to test with }
	t : testListElementObj; { a temporary }

procedure testListObj.dump;
var
	dumping : listIterator;
	dumperand : testListElementObj;
begin
	repeat new (dumping) until memCheck.gotObject(dumping);
	dumping.init(self);
	writeln (output, 'Dump:');
	while dumping.another(dumperand) do
		dumperand.dump;
	writeln (output) end;

procedure testListElementObj.dump;
begin 
	writeln (output, data) end;

begin
	PLSetHeapType(true); { allow dispose }
	
	new (memCheck);
	initMemCheck (memCheck, 0); { start up the allocation checker }
	
	repeat new (testList) until memCheck.gotObject(testList); testList.init;
	
	write (output, 'Should be empty -- '); testList.dump;
	
	repeat new (t) until memCheck.gotObject(t); t.init;
	t.data := 1;
	testList.insert(t);
	write (output, 'One element(1) -- '); testList.dump;

	repeat new (t) until memCheck.gotObject(t); t.init;
	t.data := 2;
	testList.insert(t);
	write (output, 'Two elements(2 1) -- '); testList.dump;
	
	repeat new (t) until memCheck.gotObject(t); t.init;
	t.data := 3;
	testList.append(t);
	write (output, 'Three elements(2 1 3) -- '); testList.dump;
	
	testList.head(t);
	write (output, 'Two elements(1 3) -- '); testList.dump;
	
	repeat new (testList2) until memCheck.gotObject(testList2); testList2.init;
	testList2.append(t); { test append to an empty list }
	write (output, 'List 2, one element (2) -- '); testList2.dump;
	
	testList.appendList (testList2); { this disposes testList2 }
	write (output, 'Three elements (1 3 2) -- ');
	testList.dump;
	
	testList.release;
	
	end.
	
