/* Copyright  1988-1990 Apple Computer, Inc.  All rights reserved. */

/*  Auto-Include the requirements for this source */
#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#if qDebug
include "Debug.r.o";
#endif
include "MacApp.r.o";
include "Dialog.r.o";

/* Resource IDs */


/* Command numbers */

#define cNewWindow		1001

resource 'seg!' (256, purgeable) {
	{
		"GOpen";
		"GClose";
		"GNonRes";
		"GSelCommand";
		"GDoCommand"
	}
};

resource 'SIZE' (-1) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	MultiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
#if qDebug
	500 * 1024,
	400 * 1024
#else
	290 * 1024,
	218 * 1024
#endif
};

resource 'DITL' (phAboutApp, purgeable) {
	 {
/* [1] */	{160, 182, 180, 262}, Button { enabled, "OK" };
/* [2] */	{8, 70, 152, 316}, StaticText { disabled, 
	"This program demonstrates simultaneous updating of several TextEdits." 
	"\n\nThis program was written by Scott Steketee "
	"with MacApp  1985-1990 Apple Computer, Inc."};
/* [3] */	{10, 20, 42, 52}, Icon { disabled, 1 }
	}
};

resource 'ALRT' (1000, purgeable) {
	{44, 48, 130, 358},
	1000,
	{
		OK, visible, sound1,
		OK, visible, sound1,
		OK, visible, sound1,
		OK, visible, sound1
	}
};

include "Defaults.r.o"  'ALRT' (phAboutApp);	// Grab the default about box

include "Defaults.r.o" 'cmnu' (mApple);		// Grab the default Apple menu

resource 'cmnu' (mFile) {
	mFile,
	textMenuProc,
	0x7FFFFBBB,
	enabled,
	"File",
	 {
/* [1] */	"Quit",		noIcon, "Q",	noMark, plain, cQuit
	}
};

include "Defaults.r.o" 'cmnu' (mEdit);		// Grab the default Edit menus

resource 'cmnu' (4) {
	4,
	textMenuProc,
	0x7FFFFFBD,
	enabled,
	"LinkDemo",
	 {
/* [1] */	"New Window",		noIcon, noKey, noMark, plain, cNewWindow;
	}
};

include "Defaults.r.o" 'cmnu' (mBuzzwords);	// Get the default buzzwords menu


resource 'MBAR' (kMBarDisplayed) { {mApple; mFile; mEdit; 4} };


/************************************************************************************/
/*	Views by procedure																*/
/************************************************************************************/
resource 'WIND' (cNewWindow, purgeable) {
	{50, 20, 200, 300}, zoomDocProc, invisible, goAway, 0x0, "Window"
};


type 'SS11' as 'STR ';
resource 'SS11' (0,
#if qNames
"Signature",
#endif
	purgeable) {
	"Application created by MacApp"
};

resource 'BNDL' (128,
#if qNames
"Bundle",
#endif
	purgeable) {
	'SS11',
	0,
		{
		'ICN#',
			{
			0, 128,
			},
		'FREF',
			{
			0, 128,
			}
		}
};

include "Defaults.r.o"  'STR#' (kDefaultCredits);		// Grab the default credits

// Get the default MacApp application icon and necessary bundling rsrcs
include "Defaults.r.o"  'FREF' (128);
include "Defaults.r.o"  'ICN#' (128);

// Get the default Version resources
include "Defaults.r.o"  'vers' (1);		// Application or file specific
include "Defaults.r.o"  'vers' (2);		// Overall package
