{	This file has been processed by The THINK Pascal Source Converter, v1.03.	}

{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ Copyright  1988 - 1990 by Apple Computer, Inc. All rights reserved. }

UNIT ULinkDemo;

	INTERFACE

		USES    SysEqu,Traps,ULoMem,UMacAppUtilities,UPatch,UObject,UViewCoords,UMemory,UFailure,UMenuSetup,UList,UAssociation,UMacApp,UTEView,
UDialog,

ULinkItem;			  			  			

		TYPE

			TTestApplication	= OBJECT (TApplication)
				fItem1, fItem2: TLinkItem;
				PROCEDURE TTestApplication.ITestApplication(itsMainFileType: OSType);
				{ Initializes the application and globals. }
				FUNCTION TTestApplication.DoMenuCommand(aCmdNumber: CmdNumber): TCommand; OVERRIDE;
				PROCEDURE TTestApplication.DoSetupMenus; OVERRIDE;
				PROCEDURE TTestApplication.Fields(PROCEDURE
											 DoToField(fieldName: Str255;
													   fieldAddr: Ptr;
													   fieldType: INTEGER)); OVERRIDE;
				END;
				
	IMPLEMENTATION


{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]}
{ ULinkDemo.inc1.p }
{ Copyright  1988 - 1990 Apple Computer, Inc.	All rights reserved. }

{--------------------------------------------------------------------------------------------------}

CONST
	cMakeWindow 	= 1001;

	
{  T T e s t A p p l i c a t i o n				}
{--------------------------------------------------------------------------------------------------}

{$S AInit}
PROCEDURE TTestApplication.ITestApplication(itsMainFileType: OSType);
	VAR anItem: TLinkItem;
	BEGIN
	gAlwaysTrackCursor := TRUE;
	IApplication(itsMainFileType);
	fLaunchWithNewDocument := FALSE;		{ Suppress the creation of a new document at launch }
	NEW (anItem);
	FailNIL (anItem);
	fItem1 := anItem;
	fItem1.ILinkItem ('an Item');
	NEW (anItem);
	FailNIL (anItem);
	fItem2 := anItem;
	fItem2.ILinkItem ('another Item');
	END;

{$S ARes}

FUNCTION TTestApplication.DoMenuCommand(aCmdNumber: CmdNumber): TCommand;


	PROCEDURE MakeWindow;
		VAR
			itsLocation:		VPoint;
			itsSize:			VPoint;
			ts: 					TextStyle;
			aWindow:			TWindow;
			aDialogView:		TLinkDialogView;
			anEditView: 		TLinkEditText;
		BEGIN
		NEW(aDialogView);
		FailNIL(aDialogView);
		SetVPt(itsSize, 250, 130);
		aDialogView.IDialogView(NIL, NIL, gZeroVPt, itsSize, SizeFixed, SizeFixed,
								kNoIdentifier, kNoIdentifier);

		aWindow := NewSimpleWindow(aCmdNumber, TRUE, TRUE, NIL, aDialogView);
		aWindow.fFreeOnClosing := TRUE;
		aWindow.SimpleStagger(kStdStaggerAmount, kStdStaggerAmount, gStdStaggerCount);

		{ make two edit texts linked to item1 }
		NEW(anEditView);
		FailNIL(anEditView);
		SetVPt(itsLocation, 10, 20);
		SetVPt(itsSize, 100, 22);
		anEditView.ILinkEditText(aDialogView, itsLocation, itsSize, 255, fItem1);
		SetTextStyle(ts, applFont, [], 12, gRGBBlack);
		anEditView.InstallTextStyle(ts, kDontRedraw);
		anEditView.SetJustification(teJustSystem, kDontRedraw);

		NEW(anEditView);
		FailNIL(anEditView);
		SetVPt(itsLocation, 120, 20);
		SetVPt(itsSize, 100, 22);
		anEditView.ILinkEditText(aDialogView, itsLocation, itsSize, 255, fItem1);
		SetTextStyle(ts, applFont, [], 12, gRGBBlack);
		anEditView.InstallTextStyle(ts, kDontRedraw);
		anEditView.SetJustification(teJustRight, kDontRedraw);

		{ make an edit text linked to item2 }
		NEW(anEditView);
		FailNIL(anEditView);
		SetVPt(itsLocation, 120, 60);
		SetVPt(itsSize, 100, 22);
		anEditView.ILinkEditText(aDialogView, itsLocation, itsSize, 255, fItem2);
		SetTextStyle(ts, applFont, [], 12, gRGBBlack);
		anEditView.InstallTextStyle(ts, kDontRedraw);
		anEditView.SetJustification(teJustSystem, kDontRedraw);
		
		{ make a fourth, unlinked EditText }
		NEW(anEditView);
		FailNIL(anEditView);
		SetVPt(itsLocation, 120, 100);
		SetVPt(itsSize, 100, 22);
		anEditView.ILinkEditText(aDialogView, itsLocation, itsSize, 255, NIL);
		SetTextStyle(ts, applFont, [], 12, gRGBBlack);
		anEditView.InstallTextStyle(ts, kDontRedraw);
		anEditView.SetJustification(teJustRight, kDontRedraw);
		anEditView.SetText('unlinked', kDontRedraw);
				
		aWindow.Open;
		END { MakeWindow };


	BEGIN { DoMenuCommand }
	DoMenuCommand := NIL;
	CASE aCmdNumber OF
		cMakeWindow:	MakeWindow;
		OTHERWISE		DoMenuCommand := INHERITED DoMenuCommand(aCmdNumber);
	END { CASE };
	END { DoMenuCommand };


{$S ARes}
PROCEDURE TTestApplication.DoSetupMenus; OVERRIDE;
	BEGIN
	INHERITED DoSetupMenus;
	Enable(cMakeWindow, TRUE);
	END;

{$S AFields}
PROCEDURE TTestApplication.Fields(PROCEDURE DoToField(fieldName: Str255; fieldAddr: Ptr;
												 fieldType: INTEGER)); OVERRIDE;
	BEGIN
	DoToField('TTestApplication', NIL, bClass);
	INHERITED Fields(DoToField);
	END;



END.
