{	This file has been processed by The THINK Pascal Source Converter, v1.03.	}

{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ Copyright   1990 by Scott Steketee.	All rights reserved. }

UNIT ULinkItem;

	INTERFACE

		USES    SysEqu,Traps,ULoMem,UMacAppUtilities,UPatch,UObject,UViewCoords,UMemory,UFailure,UMenuSetup,UList,UAssociation,UMacApp,UTEView,
UDialog,UGridView 
;			   			 

		TYPE

			TLinkItem = OBJECT (TObject)
				fText:	StringHandle;	{ the data itself }
				fLinks:	TList;			{ the list of subscribers }
				fUpdating: BOOLEAN;		{ don't respond to call-backs while I'm sending }
										{ update messages to my subscribers. }
				PROCEDURE TLinkItem.ILinkItem (theText: str255);
				PROCEDURE TLinkItem.Free; OVERRIDE;
				FUNCTION  TLinkItem.UpdatedLink (theSubscriber: TObject;
																	theText: str255): BOOLEAN;
				PROCEDURE TLinkItem.SetText (theText: str255;
																	thePublisher: TObject);
				PROCEDURE TLinkItem.GetText (VAR theText: str255);
				PROCEDURE TLinkItem.AddLink (theSubscriber: TObject);
				PROCEDURE TLinkItem.RemoveLink (theSubscriber: TObject);
				PROCEDURE TLinkItem.Fields(PROCEDURE DoToField(fieldName: Str255;
									fieldAddr: Ptr; fieldType: INTEGER)); OVERRIDE;
				END;
				
			TLinkEditText = OBJECT (TEditText)
				fLink: TLinkItem;
				PROCEDURE TLinkEditText.ILinkEditText(itsSuperView: TView;
											  itsLocation, itsSize: VPoint;
											  itsMaxChars: INTEGER;
											  itsLink: TLinkItem);
				PROCEDURE TLinkEditText.Free; OVERRIDE;
				PROCEDURE TLinkEditText.SetText(theText: Str255;
												redraw: BOOLEAN); OVERRIDE;
				PROCEDURE TLinkEditText.Fields(
												PROCEDURE DoToField(fieldName: Str255;
												fieldAddr: Ptr; fieldType: INTEGER)); OVERRIDE;
				END;
				
			TLinkDialogTEView = OBJECT (TDialogTEView)
				fLink: TLinkItem;		{ the item, if any, the TEView is linked to }
				PROCEDURE TLinkDialogTEView.IDialogTEView(itsDocument: TDocument;
									itsSuperView: TView;
									itsLocation,  itsSize: VPoint; itsHDeterminer,
									itsVDeterminer: SizeDeterminer; itsInset: Rect;
									itsTextStyle: TextStyle; itsJustification: INTEGER;
									itsStyleType, itsAutoWrap: BOOLEAN); OVERRIDE;
				PROCEDURE TLinkDialogTEView.SynchView(redraw: BOOLEAN); OVERRIDE;
				PROCEDURE TLinkDialogTEView.InstallEditText(theEditText: TEditText;
														selectChars: BOOLEAN); OVERRIDE;
				PROCEDURE TLinkDialogTEView.Fields(
													PROCEDURE DoToField(fieldName: Str255;
													fieldAddr: Ptr; fieldType: INTEGER)); OVERRIDE;
				END;

			TLinkDialogView = OBJECT (TDialogView)
				FUNCTION TLinkDialogView.MakeTEView: TDialogTEView; OVERRIDE;
				PROCEDURE TLinkDialogView.Fields(
												PROCEDURE DoToField(fieldName: Str255;
												fieldAddr: Ptr; fieldType: INTEGER)); OVERRIDE;
				END;
			

	IMPLEMENTATION


{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]}
{ ULinkItem.inc1.p }
{ Copyright   1990 by Scott Steketee.	All rights reserved. }

CONST	kSizeJump = 8;	{ don't resize the handle every time
										a char is added!}


{------------------------------  T L i n k I t e m  ---------------------------------------------------------}
{$S LnkItmOpen}
PROCEDURE TLinkItem.ILinkItem (theText: str255);
	BEGIN
	fText := NewString (theText);
	fLinks := NewList;
	fUpdating := FALSE;
	END { ILinkItem };
	
{$S LnkItmClose}
PROCEDURE TLinkItem.Free; OVERRIDE;
	BEGIN
	DisposIfHandle (fText);			{ free the text }
	fLinks.Free;					{ free the list of objects to update }
	INHERITED Free;					{ and free the object itself }
	END { ILinkItem };
	
{$S LnkItmRes}
FUNCTION TLinkItem.UpdatedLink (theSubscriber: TObject;
													theText: str255): BOOLEAN;
	{ Updates the links it knows how to do & returns TRUE. }
	{ Ignores those it doesn't know about & returns FALSE. }
	{ Override this method to provide the ability to update	}
	{ other types of objects. }
	BEGIN
	UpdatedLink := TRUE;
	IF Member (theSubscriber, TStaticText) THEN
		TStaticText(theSubscriber).SetText (theText, kRedraw)
	ELSE IF Member (theSubscriber, TTEView) THEN
		WITH TTEView (theSubscriber) DO
			BEGIN
			SetText (theText);
			ForceRedraw;
			END
	ELSE UpdatedLink := FALSE;
	END { TLinkItem.AddLink };

{$S LnkItmRes}
PROCEDURE TLinkItem.SetText (theText: str255; thePublisher: TObject);
	{ Sets the text for the item and for each of the linked objects. }
	{ thePublisher is the object which originated the change; }
	{ its assumed to have updated itself. }
	VAR	newSize: INTEGER;
	
	PROCEDURE FixText (theSubscriber: TObject);
		BEGIN
		IF theSubscriber <> thePublisher THEN
			IF NOT UpdatedLink (theSubscriber, theText) THEN
				{$IFC qDebug}
				Writeln ('Nobody handled link update for ', theText);
				{$ENDC}
		END { TLinkItem.AddLink };
		
	BEGIN { TLinkItem.SetText }
	IF NOT fUpdating & (theText <> fText^^) THEN
		BEGIN
		fUpdating := TRUE;
		newSize := Length (theText) + 1;	{ need 1 extra byte for the length }
		IF Odd (newSize) 			THEN newSize := newSize + 1;
		IF GetHandleSize (Handle (fText)) < newSize 			THEN SetHandleSize (Handle (fText), newSize + kSizeJump);
		FailMemError;
		BlockMove (@theText, Ptr (fText^), newSize);
		fLinks.Each (FixText);
		fUpdating := FALSE;
		END;
	END { TLinkItem.SetText };
	
{$S LnkItmRes}
PROCEDURE TLinkItem.GetText (VAR theText: str255);
	BEGIN
	theText := fText^^;
	END { TLinkItem.AddLink };
	
{$S LnkItmRes}
PROCEDURE TLinkItem.AddLink (theSubscriber: TObject);
	{ adds the subscriber to the list, and sends the current data back. }
	VAR theIndex: ArrayIndex;
			theText: str255;
	BEGIN
	theIndex := fLinks.GetSameItemNo (theSubscriber);
	{ add it only if it's not already there! }
	IF theIndex = kEmptyIndex THEN
		BEGIN
		fLinks.InsertLast (theSubscriber);
		GetText (theText);
		IF NOT UpdatedLink (theSubscriber, theText) THEN
			{$IFC qDebug}
			Writeln ('Nobody handled link update in AddLink for ', theText);
			{$ENDC}
		END;
	END { TLinkItem.AddLink };
	
{$S LnkItmRes}
PROCEDURE TLinkItem.RemoveLink (theSubscriber: TObject);
	VAR theIndex:	ArrayIndex;
	BEGIN
	theIndex := fLinks.GetSameItemNo (theSubscriber);
	If theIndex > kEmptyIndex 		THEN fLinks.AtDelete (theIndex);
	END { TLinkItem.RemoveLink };
	
{$S AFields}
PROCEDURE TLinkItem.Fields(PROCEDURE DoToField(fieldName: Str255;
									fieldAddr: Ptr; fieldType: INTEGER)); OVERRIDE;
	BEGIN
	DoToField('TLinkItem', NIL, bClass);
	DoToField('fText', @fText, bString);
	DoToField('fLinks', @fLinks, bObject);
	INHERITED Fields(DoToField);
	END { TLinkItem.Fields };

{--------------------- TLinkEditText -----------------------------}
{$S LnkItmOpen}
PROCEDURE TLinkEditText.ILinkEditText(itsSuperView: TView;
						itsLocation, itsSize: VPoint; 
						itsMaxChars: INTEGER; itsLink: TLinkItem);
	VAR theText: str255;
	BEGIN
	IEditText (itsSuperView, itsLocation, itsSize, itsMaxChars);
	fLink := itsLink;
	IF fLink <> NIL THEN
		fLink.AddLink (SELF);
	END { TLinkEditText.ILinkEditText };

{$S LnkItmClose}
PROCEDURE TLinkEditText.Free; OVERRIDE;
	BEGIN
	{ If I'm a publisher, I'm probably also a subscriber.	}
	{ Try to remove myself from the list of subscribers. }
	IF fLink <> NIL THEN
		fLink.RemoveLink (SELF);
	INHERITED Free;
	END { TLinkEditText.Free };
	
{$S LnkItmRes}
PROCEDURE TLinkEditText.SetText(theText: Str255; redraw: BOOLEAN);
													OVERRIDE;
	VAR	currentText:		Str255;
			area:					Rect;
	BEGIN
	IF fLink <> NIL THEN
		fLink.SetText (theText, SELF);
	INHERITED SetText(theText, redraw);
	END { TLinkEditText.SetText };

{$S AFields}
PROCEDURE TLinkEditText.Fields(PROCEDURE DoToField(fieldName: Str255;
										fieldAddr: Ptr; fieldType: INTEGER)); OVERRIDE;
	BEGIN
	DoToField('TLinkEditText', NIL, bClass);
	DoToField('fLink', @fLink, bObject);
	INHERITED Fields(DoToField);
	END { TLinkEditText.Fields };

{---------------------- TLinkDialogTEView ------------------------}

{$S LnkItmOpen}
PROCEDURE TLinkDialogTEView.IDialogTEView(itsDocument: TDocument;
								itsSuperView: TView; itsLocation, itsSize: VPoint;
								itsHDeterminer, itsVDeterminer: SizeDeterminer;
								itsInset: Rect; itsTextStyle: TextStyle;
								itsJustification: INTEGER;
								itsStyleType, itsAutoWrap: BOOLEAN); OVERRIDE;
	BEGIN
	fLink := NIL;
	INHERITED IDialogTEView (itsDocument, itsSuperView, itsLocation,
						itsSize, itsHDeterminer,  itsVDeterminer, itsInset,
						itsTextStyle, itsJustification,  itsStyleType, itsAutoWrap)
	END { TLinkDialogTEView.IDialogTEView };

{$S LnkItmRes}
PROCEDURE TLinkDialogTEView.SynchView(redraw: BOOLEAN); OVERRIDE;
	{ If we're a publisher, get the text and publish it,	}
	{ so the link can update the other displays. }
	VAR theText:		str255;
			theTextHdl:	Handle;
			nChars:		INTEGER;
	BEGIN
	INHERITED SynchView (redraw);
	IF fLink <> NIL THEN
		BEGIN
		theTextHdl := ExtractText;
		nChars := Min (GetHandleSize (theTextHdl), 255);
		{$Push} {$R-}
		theText[0] := Chr (nChars);
		{$Pop}
		BlockMove (Ptr (theTextHdl^), @theText [1], nChars);
		fLink.SetText (theText, SELF);
		END;
	END { TLinkDialogTEView.SynchView };
	
{$S LnkItmRes}
PROCEDURE TLinkDialogTEView.InstallEditText(theEditText: TEditText;
										selectChars: BOOLEAN); OVERRIDE;
	VAR theText: Str255;
	BEGIN
	IF fLink <> NIL THEN
		BEGIN
		fLink.RemoveLink (SELF);
		fLink := NIL;
		END;
	IF (theEditText <> NIL) & Member (theEditText, TLinkEditText)  		THEN fLink := TLinkEditText (theEditText).fLink;
	IF fLink <> NIL THEN
		fLink.AddLink (SELF);
	INHERITED InstallEditText (theEditText, selectChars);
	END { TLinkDialogTEView.InstallEditText };

{$S AFields}
PROCEDURE TLinkDialogTEView.Fields(
									PROCEDURE DoToField(fieldName: Str255;
									fieldAddr: Ptr; fieldType: INTEGER)); OVERRIDE;
	BEGIN
	DoToField('TLinkDialogTEView', NIL, bClass);
	DoToField('fLink', @fLink, bObject);
	INHERITED Fields(DoToField);
	END { TLinkDialogTEView.Fields };

{------------------------------ TLinkDialogView ---------------------------------------------------------}

{$S LnkItmOpen}
FUNCTION TLinkDialogView.MakeTEView: TDialogTEView; OVERRIDE;
	VAR aDialogTEView:		TLinkDialogTEView;
	BEGIN
	New(aDialogTEView);
	FailNIL(aDialogTEView);
	aDialogTEView.IDialogTEView(NIL, NIL, gZeroVPt, gZeroVPt,
								sizeRelSuperView, sizeVariable, gZeroRect,
								gSystemStyle, teJustSystem, kWithoutStyle, False);
	aDialogTEView.fMinAhead := 1;
	MakeTEView := aDialogTEView;
	END { TLinkDialogView.MakeTEView };

{$S AFields}
PROCEDURE TLinkDialogView.Fields(
									PROCEDURE DoToField(fieldName: Str255;
									fieldAddr: Ptr; fieldType: INTEGER)); OVERRIDE;
	BEGIN
	DoToField('TLinkDialogView', NIL, bClass);
	INHERITED Fields(DoToField);
	END { TLinkDialogView.Fields };



END { UNIT ULinkItem }.
