#include "Types.r"
#include "MacAppTypes.r"
#include "ViewTypes.r"

/* Command number */
#define cCharacter			1503	/* see DemoText.r */

// see IM v1 p387
#define teJustLeft			0
#define teJustCenter		1
#define teJustRight		   -1

// see IM v1 p210 (p152 is WRONG)
#define	boldBit				0
#define italicBit			1
#define underlineBit		2
#define outlineBit 			3
#define shadowBit			4
#define condenseBit		 	5
#define extendBit			6

#define kEmptySet		   -1
#define kNormalSpacing		0

// strings for sample text
#define kSampleTextString	32700	// why not?  it's a good number!

/*********************************************************************************
	The following resources define the application's Character dialog.
*********************************************************************************/

resource 'view' (cCharacter, "cCharacter", purgeable) {
	{
	root, 'wind', {50, 40}, {230, 465}, sizeVariable, sizeVariable, shown, enabled, 
	Window {"TWindow", dBoxProc, noGoAwayBox, notResizable, modal, ignoreFirstClick, 
		dontFreeOnClosing, disposeOnFree, doesntCloseDocument, dontOpenWithDocument, 
		dontAdaptToScreen, dontStagger, dontForceOnScreen, center, 'size', "<<<>>>"}, 

	'wind', 'DLOG', {0, 0}, {230, 465}, sizeVariable, sizeVariable, shown, enabled, 
	DialogView {"TCharDialogView", 'ok  ', 'cncl'}, 

	'DLOG', 'sclu', {3, 155}, {132, 53}, sizeFixed, sizeFixed, shown, disabled, 
	Cluster {"TSizeCluster", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, ""}, 

	'sclu', 'size', {107, 5}, {20, 35}, sizeFixed, sizeFixed, shown, enabled, 
	NumberText {"TSizeText", adnFrame, {1, 1}, sizeable, notDimmed, notHilited, 
		doesntDismiss, {3, 3, 3, 3}, systemFont, justSystem, "12", 3,
		arrowsAndBackspace, 12, 1, 127}, 

	'sclu', 'VW28', {17, 5}, {80, 45}, sizeVariable, sizeVariable, shown, disabled, 
	Control {"TControl", adnFrame, {1, 1}, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont}, 

	'VW28', 'VW30', {1, 1}, {78, 28}, sizeRelSuperView, sizeRelSuperView, shown, disabled, 
	Scroller {"TScroller", VertScrollBar, noHorzScrollBar, 256, 256, 16, 16, noVertConstrain, 
		noHorzConstrain, noInset}, 

	'VW30', 'slst', {0, 0}, {0, 28}, sizeVariable, sizeFixed, shown, enabled, 
	TextListView {"TSizeListView", 0, 1, 0, 28, 0, 2, dontAdornRows, dontAdornCols, 
		singleSelection, systemFont}, 

	'DLOG', 'just', {5, 325}, {65, 130}, sizeFixed, sizeFixed, shown, disabled, 
	Cluster {"TJustifyCluster", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, "Justify:"}, 

	'just', 'Left', {15, 15}, {15, 50}, sizeFixed, sizeFixed, shown, enabled, 
	ValueRadio {"TValueRadio", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, on, "Left", teJustLeft}, 

	'just', 'Cntr', {30, 15}, {15, 65}, sizeFixed, sizeFixed, shown, enabled, 
	ValueRadio {"TValueRadio", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, off, "Center", teJustCenter}, 

	'just', 'Rght', {45, 15}, {15, 55}, sizeFixed, sizeFixed, shown, enabled, 
	ValueRadio {"TValueRadio", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, off, "Right", teJustRight}, 

	'DLOG', 'VW09', {145, 10}, {15, 55}, sizeFixed, sizeFixed, shown, disabled, 
	StaticText {"TStaticText", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, justSystem, "Sample:"}, 

	'DLOG', 'VW22', {140, 10}, {1, 445}, sizeVariable, sizeVariable, shown, disabled, 
	Control {"TControl", 0b1, {1, 1}, sizeable, dimmed, notHilited, 
		doesntDismiss, noInset, systemFont}, 

	'DLOG', 'VW23', {200, 295}, {22, 72}, sizeFixed, sizeFixed, shown, enabled, 
	Button {"TButton", noAdornment, sizeable, notDimmed, notHilited, 
		dismisses, noInset, systemFont, "Cancel"}, 

	'DLOG', 'VW24', {195, 375}, {30, 80}, sizeFixed, sizeFixed, shown, enabled, 
	Button {"TButton", adnRRect, {3, 3}, sizeable, notDimmed, notHilited, 
		dismisses, {4, 4, 4, 4}, systemFont, "OK"}, 

	'DLOG', 'VW25', {20, 10}, {114, 140}, sizeVariable, sizeVariable, shown, disabled, 
	Control {"TControl", adnFrame, {1, 1}, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont}, 

	'VW25', 'VW27', {1, 1}, {112, 123}, sizeRelSuperView, sizeRelSuperView, shown, disabled, 
	Scroller {"TScroller", VertScrollBar, HorzScrollBar, 256, 256, 16, 16, noVertConstrain, 
		noHorzConstrain, noInset}, 

	'VW27', 'flst', {0, 0}, {0, 123}, sizeVariable, sizeFixed, shown, enabled, 
	TextListView {"TFontListView", 0, 1, 0, 123, 0, 2, dontAdornRows, dontAdornCols, 
		singleSelection, systemFont}, 

	'DLOG', 'VW26', {5, 10}, {15, 30}, sizeFixed, sizeFixed, shown, disabled, 
	StaticText {"TStaticText", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, justSystem, "Font"}, 

	'DLOG', 'VW29', {5, 160}, {15, 30}, sizeFixed, sizeFixed, shown, disabled, 
	StaticText {"TStaticText", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, justSystem, "Size"}, 
		
	'DLOG', 'samp', {145, 65}, {45, 390}, sizeFixed, sizeFixed, shown, disabled,
	StaticText { "TSampleText", adnFrame, {1, 1}, notSizeable, notDimmed, notHilited,
		doesntDismiss, {3, 3, 3, 3}, plain, 0, {0x0, 0x0, 0x0}, "A", justSystem,
		"The quick brown fox jumped over the lazy dog."},

	'DLOG', 'face', {5, 210}, {130, 245}, sizeFixed, sizeFixed, shown, disabled, 
	Cluster {"TFaceCluster", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, ""}, 

	'face', 'styl', {0, 0}, {110, 110}, sizeFixed, sizeFixed, shown, disabled, 
	Cluster {"TStyleCluster", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, "Style:"}, 

	'styl', 'pln*', {15, 15}, {15, 55}, sizeFixed, sizeFixed, shown, enabled, 
	ValueCheckBox {"TValueCheckBox", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, on, "Plain", kEmptySet},

	'styl', 'bld0', {30, 15}, {15, 50}, sizeFixed, sizeFixed, shown, enabled, 
	ValueCheckBox {"TValueCheckBox", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, off, "Bold", boldBit}, 

	'styl', 'Itl1', {45, 15}, {15, 55}, sizeFixed, sizeFixed, shown, enabled, 
	ValueCheckBox {"TValueCheckBox", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, off, "Italic", italicBit}, 

	'styl', 'und2', {60, 15}, {15, 80}, sizeFixed, sizeFixed, shown, enabled, 
	ValueCheckBox {"TValueCheckBox", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, off, "Underline", underlineBit}, 

	'styl', 'out3', {75, 15}, {15, 65}, sizeFixed, sizeFixed, shown, enabled, 
	ValueCheckBox {"TValueCheckBox", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, off, "Outline", outlineBit}, 

	'styl', 'shd4', {90, 15}, {15, 70}, sizeFixed, sizeFixed, shown, enabled, 
	ValueCheckBox {"TValueCheckBox", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, off, "Shadow", shadowBit}, 

	'face', 'spac', {65, 115}, {65, 130}, sizeFixed, sizeFixed, shown, disabled, 
	Cluster {"TSpaceCluster", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, "Spacing:"}, 

	'spac', 'Norm', {15, 15}, {15, 75}, sizeFixed, sizeFixed, shown, enabled, 
	ValueRadio {"TValueRadio", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, on, "Normal", kNormalSpacing},

	'spac', 'Comp', {30, 15}, {15, 100}, sizeFixed, sizeFixed, shown, enabled, 
	ValueRadio {"TValueRadio", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, off, "Condensed", condenseBit}, 

	'spac', 'Expd', {45, 15}, {15, 80}, sizeFixed, sizeFixed, shown, enabled, 
	ValueRadio {"TValueRadio", noAdornment, sizeable, notDimmed, notHilited, 
		doesntDismiss, noInset, systemFont, off, "Extended", extendBit}
	}
};

resource 'STR#' (kSampleTextString,
#if qNames
	"kSampleTextString",
#endif
	purgeable) {
	{
	"The quick brown fox jumped over the lazy dog.";
	"Pack my box with five dozen liquor jugs.";
	}
};  // kSampleTextString

