/*	SetDefProc.h

	Function to patch a dummy code resource (CDEF, WDEF, etc.) to jump to 
	a definition procedure in your own program.  Useful for debugging 
	definition procedures. 
	
	See 'SetDefProc.c' for information on how to use it.  
	
	Copyright  1990 Applied Biosystems, Inc.  All rights reserved.  

	Environment:	Macintosh, MPW C 3.1, THINK C 4.0

	Edit History:
	 8/30/90	Tom Becker
	 			Created.  
  ______________________________________________________________________________
*/

#ifndef	_SetDefProc_
#define	_SetDefProc_

/*

	I N C L U D E S
*/

#ifdef THINK_C

#ifndef	_MacTypes_
#include <MacTypes.h>
#endif

#else /* applec */

#ifndef __TYPES__
#include <Types.h>
#endif

#endif THINK_C

/*

	T Y P E S
*/

void SetDefProc(
	ResType	theType, 		/* type of resource to patch */
	short	theID, 			/* ID of resource to patch */
	void *	defProc			/* address of definition procedure to use */
);

/*______________________________________________________________________________

	End of SetDefProc.h
*/

#endif _SetDefProc_
