/*------------------------------------------------------------------*/
/* VCR BUTTON CDEF Demo.c											*/
/*	This is a quick demo of using the VCR Button CDEF				*/
/*	Version 1.0														*/
/*	January, 1990													*/
/*	Chris Faigle													*/
/*																	*/
/*	 Source Debugging Routine by:									*/
/*				Tom Becker		Applied Biosystems, Inc.			*/
/*																	*/
/*	This software is now in the public domain.						*/
/*	Some Portions of the application are Copyrighted by Symantec	*/
/*	Corp. since this was developed using LightSpeed C - One of the	*/
/*	best development systems ever!									*/
/*																	*/
/* You may distribute this code, however, if you make enhancements,	*/
/*	I would like a copy.											*/
/*	Also, this source may NEVER be sold, and the only fee that can	*/
/*	be received by ANYONE is a normal copying fee or time charge on	*/
/*	a network when downloading.										*/
/*																	*/
/*	This also applies to any modifed version of this source.		*/
/*																	*/
/*																	*/
/*																	*/
/*	Mail any correspondence/bug reports/suggestions to:				*/
/*	Chris Faigle													*/
/*	c/o Performance Software										*/
/*	575 SouthLake Blvd												*/
/*	Richmond, Va  23236												*/
/* 	AppleLink:  CHRIS.FAIGLE										*/
/*------------------------------------------------------------------*/
/*
	I N C L U D E S:
*/

#ifdef THINK_C

#else /* applec */

#ifndef __MEMORY__
#include <Memory.h>
#endif
#ifndef __FONTS__
#include <Fonts.h>
#endif
#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif
#define QD qd.
#ifndef __CONTROLS__
#include <Controls.h>
#endif
#ifndef __MENUS__
#include <Menus.h>
#endif
#ifndef __DIALOGS__
#include <Dialogs.h>
#endif
#ifndef __PACKAGES__
#include <Packages.h>
#endif

#endif THINK_C

#define qUseDummyDefProc

#ifdef qUseDummyDefProc

#ifndef _VCR_BUTTON_CDEF_
#include "VCR Button CDEF Debug.h"
#endif

#ifndef	_SetDefProc_
#include "SetDefProc.h"
#endif

#endif qUseDummyDefProc

/*
	C O N S T A N T S:
*/

#define	POP_UP_MENU_DIALOG_ID		128

#define	PD_OK_BUTTON				1
#define	PD_USER_OK					2
#define	PD_POP_MENU_PICT			3
#define	PD_MENU_1					4
#define	PD_MENU_2					5
#define	PD_MENU_3					6
#define	PD_VCR_PICT					11
#define	PD_MENU_5					8
#define	PD_MENU_6					9
#define	PD_MENU_7					10

#define	DYNAMIC_MENU_ID				134

#ifndef NULL
#define	NULL				0l
#endif

#ifndef	crCode
#define	crCode				13
#endif	crCode

#ifndef	enterCode
#define	enterCode			3
#endif	enterCode


/*
	T Y P E S:
*/

pascal void bigbutton(
	DialogPtr	myDialog,
	short		itemNumber
);

/*______________________________________________________________________________

	G L O B A L S
*/

long		ticks_needed;
short		clock_on;
short		power_on;


/*
	F U N C T I O N S:
*/


pascal void bigbutton(
	DialogPtr	myDialog,
	short		itemNumber
)
{
	Rect	DisplayRect;
	short	kind;
	ProcPtr	item;

	PenSize(3,3);
	GetDItem(myDialog,itemNumber,&kind,(Handle *)&item,&DisplayRect);
	InsetRect(&DisplayRect,-4,-4);
	FrameRoundRect(&DisplayRect,16,16);
}


pascal void draw_twelve_o_clock(DialogPtr myDialog,short itemNumber)
{
	short		width;
	Rect		box;
	Handle		item;
	short		kind;
	FontInfo	my_info;
	short		h;
	short		v;
	RGBColor	save_color;
	RGBColor	save_color2;
	RGBColor	red_color;
	RGBColor	blue_color;

	GetDItem(myDialog,itemNumber,&kind,(Handle *)&item,&box);
	TextFont(systemFont);
	TextFace(0);
	TextSize(12);
	GetFontInfo(&my_info);
	width=StringWidth("\p12:00");
	h=(box.right+box.left-width)/2;
	v=(box.top+box.bottom+my_info.ascent-my_info.descent)/2;
	MoveTo(h,v);
	if(have_color())
	{
		red_color.red=0xFFFF;
		red_color.blue=0x0000;
		red_color.green=0x0000;
		blue_color.red=0x0000;
		blue_color.green=0x000;
		blue_color.blue=0xFFFF;
		GetForeColor(&save_color);
		GetBackColor(&save_color2);
		RGBForeColor(&red_color);
		RGBBackColor(&blue_color);
	}
	DrawString("\p12:00");
	if(have_color())
	{
		RGBForeColor(&save_color);
		RGBBackColor(&save_color2);
	}
}


pascal char vcr_dialog_filter(DialogPtr the_dialog,EventRecord *the_event,short *item_hit)
{
	short	result;
	short	kind;
	Handle	item;
	Rect	box;
	long	ignore_long;

	result=FALSE;
	draw_the_time(the_dialog);
	switch((*the_event).what)
	{
		case	keyDown:
		case	autoKey:
				if(((*the_event).message%256==crCode)||((*the_event).message%256==enterCode))
				{
					GetDItem(the_dialog,1,&kind,&item,&box);
					HiliteControl(item,1);
					Delay(6l,&ignore_long);
					HiliteControl(item,0);
					*item_hit=1;
					result=TRUE;
				}
				break;
	}
	return(result);
}


draw_the_time(DialogPtr the_dialog)
{
	short			kind;
	Handle			item;
	Rect			box;
	RGBColor		save_color;
	RGBColor		blue_color;

	if(TickCount()>ticks_needed)
	{
		ticks_needed=TickCount()+CaretTime;
		GetDItem(the_dialog,12,&kind,&item,&box);
		if(clock_on)
		{
			if(have_color())
			{
				blue_color.red=0x0000;
				blue_color.green=0x000;
				blue_color.blue=0xFFFF;
				GetBackColor(&save_color);
				RGBBackColor(&blue_color);
			}
			EraseRect(&box);
			if(have_color())
			{
				RGBBackColor(&save_color);
			}
		}
		else
		{
			draw_twelve_o_clock(the_dialog,12);
		}
		clock_on^=1;
	}
}


pascal void vcr_button_action_proc(ControlHandle the_control,short the_part)
{
	draw_the_time((**the_control).contrlOwner);
}


pascal void draw_vcr_pict(DialogPtr myDialog,short itemNumber)
{
	Rect		box;
	short		kind;
	ProcPtr		item;
	PicHandle	the_picture;
	RgnHandle	clip_rgn;
	RgnHandle	temp_rgn;
	RgnHandle	dont_draw_rgn;

	the_picture=GetPicture(129);
	if(the_picture!=NULL)
	{
		if(have_color())
		{
			/* If we have a color Mac, then the clipping of the picture	*/
			/*	will work correctly, otherwise, we must redraw the		*/
			/*	controls ourselves (BLEH!!)								*/
			clip_rgn=NewRgn();
			dont_draw_rgn=NewRgn();
			temp_rgn=NewRgn();
			GetClip(clip_rgn);
	
			/* Now Clip out the controls!	*/
			GetDItem(myDialog,4,&kind,&item,&box);
			RectRgn(temp_rgn,&box);
			UnionRgn(temp_rgn,dont_draw_rgn,dont_draw_rgn);
		
			GetDItem(myDialog,5,&kind,&item,&box);
			RectRgn(temp_rgn,&box);
			UnionRgn(temp_rgn,dont_draw_rgn,dont_draw_rgn);

			GetDItem(myDialog,6,&kind,&item,&box);
			RectRgn(temp_rgn,&box);
			UnionRgn(temp_rgn,dont_draw_rgn,dont_draw_rgn);

			GetDItem(myDialog,7,&kind,&item,&box);
			RectRgn(temp_rgn,&box);
			UnionRgn(temp_rgn,dont_draw_rgn,dont_draw_rgn);

			GetDItem(myDialog,8,&kind,&item,&box);
			RectRgn(temp_rgn,&box);
			UnionRgn(temp_rgn,dont_draw_rgn,dont_draw_rgn);

			GetDItem(myDialog,9,&kind,&item,&box);
			RectRgn(temp_rgn,&box);
			UnionRgn(temp_rgn,dont_draw_rgn,dont_draw_rgn);

			GetDItem(myDialog,10,&kind,&item,&box);
			RectRgn(temp_rgn,&box);
			UnionRgn(temp_rgn,dont_draw_rgn,dont_draw_rgn);

			/* Now Clip Out the Time Box:						*/
			GetDItem(myDialog,12,&kind,&item,&box);
			RectRgn(temp_rgn,&box);
			UnionRgn(temp_rgn,dont_draw_rgn,dont_draw_rgn);

			DiffRgn(clip_rgn,dont_draw_rgn,temp_rgn);
			SetClip(temp_rgn);

			GetDItem(myDialog,itemNumber,&kind,(Handle *)&item,&box);
			DrawPicture(the_picture,&box);
			SetClip(clip_rgn);
			DisposeRgn(clip_rgn);
			DisposeRgn(temp_rgn);
			DisposeRgn(dont_draw_rgn);
		}
		else
		{
			GetDItem(myDialog,itemNumber,&kind,(Handle *)&item,&box);
			DrawPicture(the_picture,&box);
			DrawControls(myDialog);
		}
	}
}


/*
*/

main()
{
	Ptr					dPtr;
	DialogPtr			the_dialog;
	/* ProcPtr			dFilteradr; */
	short				i;
	short				kind;
	Handle				item;
	Rect				box;
	MenuHandle			dynamic_menu_handle;
	/* Rect				control_rectangle;  */

	InitPack(stdFile);
	InitGraf(&thePort);
	InitWindows();
	InitFonts();
	InitMenus();
	TEInit();
	InitCursor();
	InitDialogs(0L);
	dPtr=NULL;
	
#ifdef qUseDummyDefProc
	SetDefProc('CDEF',3, VCRButtonCDEF);
#endif

	dynamic_menu_handle=GetMenu(DYNAMIC_MENU_ID);

	SetPort(the_dialog = GetNewDialog(POP_UP_MENU_DIALOG_ID,dPtr,(WindowPtr)-1));
	(*( thePort)).txFont=geneva;
	(*( thePort)).txSize=9;

	GetDItem(the_dialog,PD_USER_OK,&kind,&item,&box);
	item=(void *)bigbutton;
	SetDItem(the_dialog,PD_USER_OK,kind,item,&box);

	GetDItem(the_dialog,PD_VCR_PICT,&kind,&item,&box);
	item=(void *)draw_vcr_pict;
	SetDItem(the_dialog,PD_VCR_PICT,kind,item,&box);

	GetDItem(the_dialog,12,&kind,&item,&box);
	item=(void *)draw_twelve_o_clock;
	SetDItem(the_dialog,12,kind,item,&box);

	set_up_button_defaults(the_dialog);

	i=0;
	ticks_needed=TickCount()-1l;	/* We want to make sure the box is blued!	*/
	ShowWindow(the_dialog);
	clock_on=TRUE;
	draw_the_time(the_dialog);
	
	while(i!=PD_OK_BUTTON)
	{
		ModalDialog(vcr_dialog_filter,&i);
		if(i==9)
		{
			set_power(the_dialog,power_on^1);
		}
		if((i>3)&&(i<11))
		{
	/*		SysBeep(1);*//* This shows that you now get a "hit" from the Dialog Manager	*/
		}
	}
	DisposDialog(the_dialog);
}


set_up_button_defaults(DialogPtr the_dialog)
{
	short	kind;
	Handle	item;
	Rect	box;

	set_power(the_dialog,FALSE);

	GetDItem(the_dialog,1,&kind,&item,&box);
	SetCtlAction(item,vcr_button_action_proc);

	GetDItem(the_dialog,4,&kind,&item,&box);
	SetCtlAction(item,vcr_button_action_proc);

	GetDItem(the_dialog,5,&kind,&item,&box);
	SetCtlAction(item,vcr_button_action_proc);

	GetDItem(the_dialog,6,&kind,&item,&box);
	SetCtlAction(item,vcr_button_action_proc);

	GetDItem(the_dialog,7,&kind,&item,&box);
	SetCtlAction(item,vcr_button_action_proc);

	GetDItem(the_dialog,8,&kind,&item,&box);
	SetCtlAction(item,vcr_button_action_proc);

	GetDItem(the_dialog,9,&kind,&item,&box);
	SetCtlAction(item,vcr_button_action_proc);

	GetDItem(the_dialog,10,&kind,&item,&box);
	SetCtlAction(item,vcr_button_action_proc);

}


/*______________________________________________________________________________

	End of 'Dial CDEF Demo.c'
*/


set_power(DialogPtr the_dialog,short on)
{
	short	kind;
	Handle	item;
	Rect	box;

	GetDItem(the_dialog,4,&kind,&item,&box);
	if(on)
	{
		HiliteControl(item,0);
	}
	else
	{
		HiliteControl(item,255);
	}

	GetDItem(the_dialog,5,&kind,&item,&box);
	if(on)
	{
		HiliteControl(item,0);
	}
	else
	{
		HiliteControl(item,255);
	}

	GetDItem(the_dialog,6,&kind,&item,&box);
	if(on)
	{
		HiliteControl(item,0);
	}
	else
	{
		HiliteControl(item,255);
	}

	GetDItem(the_dialog,7,&kind,&item,&box);
	if(on)
	{
		HiliteControl(item,0);
	}
	else
	{
		HiliteControl(item,255);
	}

	GetDItem(the_dialog,8,&kind,&item,&box);
	if(on)
	{
		HiliteControl(item,0);
	}
	else
	{
		HiliteControl(item,255);
	}

	GetDItem(the_dialog,10,&kind,&item,&box);
	if(on)
	{
		HiliteControl(item,0);
	}
	else
	{
		HiliteControl(item,255);
	}

	power_on=on;
}


have_color()	/* Same as check_color in the CDEF!	*/
{
	SysEnvRec		the_environment;				/* Environment record to determine if Color QD is implemented	*/

	SysEnvirons(1,&the_environment);				/* Have machine tell us the environment							*/
	if(the_environment.hasColorQD)					/* Color QD available?											*/
	{
		return(TRUE);								/* Yup.															*/
	}
	else
	{
		return(FALSE);								/* Nope.														*/
	}
}
