/*----------------------------------------------------*/
/*                                                    */
/* Resource definition file for Masker - Rez format   */
/*                                                    */
/* Allen Stenger    July 1991                         */
/*                                                    */
/*----------------------------------------------------*/

/* This SICN appears in the About list of plug-ins. */
resource 'SICN' (16000, purgeable) {
	{	/* array: 1 elements */
		/* [1] */
		$"0780 1FE0 3870 E01C 8004 BFF4 E31C EB5C"
		$"A314 BFF4 8004 8004 8004 FFFC 1860 1860"
	}
};

/* This resource defines the interface version */
data 'PiMI' (16000, purgeable, preload) {
	$"0001"               
};

/* This menu is shown an a hierarchical menu to the */
/* Masker command. */
resource 'MENU' (16000, purgeable) {
	128,
	textMenuProc,
	0x7FFFFF01,
	enabled,
	"Masker",
	{	/* array: 8 elements */
		/* [1] */
		"Outline a Mask", noIcon, noKey, noMark, plain,
		/* [2] */
		"Remove from Mask", noIcon, noKey, noMark, plain,
		/* [3] */
		"-", noIcon, noKey, noMark, plain,
		/* [4] */
		"Capture under Mask", noIcon, noKey, noMark, plain,
		/* [5] */
		"Restore under Mask", noIcon, noKey, noMark, plain,
		/* [6] */
		"-", noIcon, noKey, noMark, plain,
		/* [7] */
		"Tint Mask", noIcon, noKey, noMark, plain,
		/* [8] */
		"Forget Mask", noIcon, noKey, noMark, plain
	}
};

/* This text is shown as the About info for Masker. */
data 'TEXT' (16000, "About", purgeable) {
"Masker Menu Command - Written by Allen "
"Stenger, July 1991\n\n"
"Use this command to protect an area from "
"being painted over. The steps are:\n"
"  1. Define the mask by selecting the "
"area to be protected with any of the " 
"selection tools, then command Outline "
"A Mask. Pieces may then be cut from the "
"mask by selecting them and commanding "
"Remove From Mask.\n"
"  2. Save the area under the mask by "
"selecting an area containing the mask " 
"and commanding Capture Under Mask.\n"
"  3. Paint as desired.\n"
"  4. Restore the area under the mask by "
"selecting an area containing the mask "
"and commanding Restore Under Mask.\n\n"
"The Tint Mask command tints the mask "
"so it can be seen. Issue Tint Mask "
"again to remove the tint. Capture "
"is disabled while Tint is on, to "
"prevent the tint from being captured too.\n\n"
"The Forget Mask command is not normally "
"needed, since Outline A Mask will clear "
"the previous mask; it may be used to "
"release the memory occupied by a mask.\n\n"
"Menu commands can only work on areas "
"within the current selection, so be sure "
"the entire area of the mask is selected "
"before Tint, Capture, or Restore."
};