;;;;;;;;;;;;;;;;;;;;;;;;;;;
; File:  bignum-tests.sch ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
(define fact 
  (lambda (n)
    (if (zero? n)
        1
        (* n (fact (- n 1))))))
;
(define time-it
  (lambda (expr)
    (display "available space:  ")
    (print (gc))
    (let* ((start-time (time))
           (value (eval expr))
           (end-time (time)))
      (display "time:  ")
      (print (/ (- end-time start-time)
                60))
      value)))
;
(time-it '(fact 120))
;
;;; big tests.
;
(define foo (time-it '(big-fact (make-big '(1 2 0)))))
;
(show-big foo)
;
(define foo 
  (time-it '(big-fact (make-big '(1 2 0) 10 
                                         *biggest-base*) 
                      *biggest-base*)))
;
(show-big foo)
;
(define foo 
  (time-it '(big-base-n->big-base-m foo *biggest-base* 
                                        10)))
;
(show-big foo)
;
(define foo (time-it '(fact 120)))
;
foo
;
(show-big (make-big '(3 2 7 6 7) 10 16))
;
(show-big (make-big '(3 2 7 6 7) 10 2))
;
(show-big (make-big '(7 15 15 15) 16 2))
;
(show-big (make-big '(7 f f f) 16 10))
;
(show-big (make-big '(7 15 15 15) 16 10))
;
(show-big 
 (make-big '(1 1 1 1 1 1 1 1 1 1 1 1 1 1 1) 2 16))
;
(show-big 
 (make-big '(1 1 1 1 1 1 1 1 1 1 1 1 1 1 1) 2 10))
;
(show-big (big-div (make-big '(1 3))
                   (make-big '(6))))
;
(show-big (big-div (make-big '(6))
                   (make-big '(1 2))))
;
;;; bignum tests.
;
(define foo 
  (time-it '(bignum-fact (make-bignum '(1 2 0)))))
;
(show-bignum foo)
;
(define foo 
  (time-it '(bignum-fact (make-bignum '(1 2 0) 
                                      10 
                                      *biggest-base*) 
                         *biggest-base*)))
;
(show-bignum foo)
;
(define foo 
  (time-it '(bignum-base-n->bignum-base-m foo 
                                          *biggest-base* 
                                          10)))
;
(show-bignum foo)
;
(show-bignum (make-bignum '(3 2 7 6 7) 10 16))
;
(show-bignum (make-bignum '(- 3 2 7 6 7) 10 16))
;
(show-bignum 
 (bignum-change-sign (make-bignum '(- 3 2 2))))
;
(show-bignum 
 (bignum-change-sign (make-bignum '(3 2 2))))
;
(show-bignum (make-bignum '(3 2 7 6 7) 10 2))
;
(show-bignum (make-bignum '(7 15 15 15) 16 2))
;
(show-bignum (make-bignum '(7 f f f) 16 10))
;
(show-bignum (make-bignum '(7 15 15 15) 16 10))
;
(show-bignum 
 (make-bignum '(1 1 1 1 1 1 1 1 1 1 1 1 1 1 1) 2 16))
;
(show-bignum 
 (make-bignum '(1 1 1 1 1 1 1 1 1 1 1 1 1 1 1) 2 10))
;
;;; bignum-object tests.
;
(define foo 
  (time-it 
   '(bignum-object-fact (make-bignum-object '(1 2 0)))))
;
(foo 'show-number)
;
(define foo 
  (time-it 
   '(bignum-object-fact 
     (make-bignum-object '(1 2 0) 
                         10
                         *biggest-base*))))
;
(foo 'show-number)
;
(define fido  
  (time-it '(bignum-object-base-n->bignum-object-base-m
             foo
             (foo 'get-base)
             10)))
;
(fido 'show-number)
;
(foo 'show-number)
;
(define foo 
  (bignum-object-mul 
   (make-bignum-object '(- 3 2 2) 10 3)
   (make-bignum-object '(7 f d c e) 16 5)))
;
(foo 'show-number)
;
(foo 'change-base 10)
; Below:  -168639772.
(foo 'show-number) 
;
(define foo (make-bignum-object '(3 2 7 6 7) 10 16))
;
(foo 'show-number)
;
(define foo (make-bignum-object '(- 3 2 7 6 7) 10 16))
;
(foo 'show-number)
;
(define foo (make-bignum-object '(- 3 2 2)))
;
(foo 'change-sign)
;
(foo 'show-number)
;
(define foo (make-bignum-object '(3 2 2)))
;
(foo 'change-sign) 
;
(foo 'show-number)
;
(define foo (make-bignum-object '(3 2 7 6 7) 10 2))
;
(foo 'show-number)
;
(define foo (make-bignum-object '(7 15 15 15) 16 2))
;
(foo 'show-number)
;
(define foo (make-bignum-object '(7 f f f) 16 10))
;
(foo 'show-number)
;
(define foo (make-bignum-object '(7 15 15 15) 16 10))
;
(foo 'show-number)
;
(define foo 
  (make-bignum-object '(1 1 1 1 1 1 1 1 1 1 1 1 1 1 1) 
                      2 16))
;
(foo 'show-number)
;
(define foo 
  (make-bignum-object '(1 1 1 1 1 1 1 1 1 1 1 1 1 1 1) 
                      2 10))
;
(foo 'show-number)
;
'tis-all