;;;;;;;;;;;;;;;;;;;;;;
; File:  bignums.sch ;
;;;;;;;;;;;;;;;;;;;;;;
;
(benchmark-mode #t)
;
(optimization 3) ; 3 = fast and dangerous, 0 = safe.
;
(define load-bignum-system
  (lambda (path)
    (let* 
      ((make-full-path (lambda (name)
                         (string-append path name)))
       (print
        (lambda (arg)
          (display arg)
          (newline)))
       (do-a-file (lambda (file)
                    (let ((file (make-full-path file)))
                      (display "--> Loading \"")
                      (display file)
                      (print "\"")
                      (load file)))))
      (do-a-file "bignums-big.sch")
      (do-a-file "bignums-bignum.sch")
      (do-a-file "bignums-object.sch"))))
;
; Below:  The user must call load-bignum-system with a 
; pathname appropriate for the user's system.
;
(load-bignum-system 
 "Mr. Disk:Applications:Word:Writing:MT/bignums:")