/*						AuxWindow.h						*/
/*
 * AuxWindow
 *	Superclass:	CDirector
 */ 
#define _H_AuxWindow
#include <CApplication.h>
#include <CDirector.h>

enum {
	kShowAuxWindow = 1,
	kHideAuxWindow
};

struct AuxWindow : CDirector {
	long				itsToggleCmd;
	short				itsMenuNames;
	Boolean				windowVisible;
	Boolean				hideOnSuspend;
	
	/*
	 * Create an auxiliary window.  The
	 * supervisor must be the application.
	 * the window id is a WIND resource.
	 * isFloating and isHiddenOnSuspend
	 * configure the window.
	 * toggleCmd and showHideRes are used
	 * to control its Show/Hide menu command.
	 */
	void    			    IAuxWindow(
		CApplication	*aSupervisor,
		short			aWindowId,
		Boolean			isFloating,
		Boolean			isHiddenOnSuspend,
		long			toggleCmd,
		short			showHideRes
	);
	/*
	 * Change the window's title string.
	 */
	void					SetTitle(
		StringPtr		aTitle
	);
	/*
	 * Override some CDirector classes to allow
	 * the window to be hidden and re-shown.
	 */
	void					Suspend(void);
	void					Resume(void);
	Boolean					Close(
		Boolean			quitting
	);
	void					CloseWind(
		CWindow			*theWindow
	);
	void					Show(void);
	void					Hide(void);
	/*
	 * The application calls Toggle to change
	 * the AuxWindow visibility.  (Show and/or
	 * Hide may also be called, of course.)
	 */
	void					Toggle(void);
};

