/*
 * HelloApp.h
 */

#define	_H_HelloApp		/* Include this file only once */
#include <CApplication.h>
#include "TextWindow.h"

/*
 * Some of these values must track values in the
 * resource file.
 */
enum {					/* Resources & Commands			*/
	WIND_Note			= 1024,
	MENU_Test			= 1024,
	MENU_MakeTextWindow	= 1025,
	STRS_Toggle			= 1024,
	CmdToggleTextWindow	= 1024,
	CmdTest,			/* Unknown command				*/
	CmdMakeNoFloatHide,
	CmdMakeNoFloatShow,
	CmdMakeIsFloatHide,
	CmdMakeIsFloatShow
};

extern struct HelloApp		*gApplication;

struct HelloApp : CApplication {
	TextWindow			*itsTextWindow;
	
	/*
	 * Create the application.
	 */
	void					IHelloApp(void);
	/*
	 * These are CApplication methods that
	 * are overridden for our purposes.
	 */
	void					MakeDesktop(void);
	void					SetUpMenus(void);
	void					UpdateMenus(void);
	void					DoCommand(
		long			theCommand
	);
	/*
	 * Create a new text window. theCommand has
	 * two purposes: it defines the particular
	 * window type and selects the show/hide
	 * command text.
	 */
	void					MakeTextWindow(
		long			theCommand
	);
	/*
	 * UnknownCommand is a utility class that
	 * logs a warning message if a command wasn't
	 * processed by the application.  Commands
	 * that are normally processed by CApplication
	 * (such as cmdQuit) are not logged.
	 */
	void					UnknownCommand(
		long			theCommand
	);
};
