/*						TextPane.h						*/
/*
 * TextBox
 *	Superclass:	AuxWindow
 */ 
#define _H_TextPane
#include <CApplication.h>
#include <CBureaucrat.h>
#include <CPane.h>
#ifndef PRIVATE
#define PRIVATE		/* reminder */
#endif

PRIVATE struct TextPane : CPane {
	short			itsLineHeight;
	short			itsNLines;
	short			hOffset;
	short			vOffset;
	StringHandle	**vectorHandle;
	
	/*
	 * Create a pane that can be used to
	 * display lines of text.  The parameters
	 * follow the definition of CPane. fontName
	 * and fontHeight define the display font
	 * and its size. These cannot be changed
	 * after the class is created.
	 */
	void					ITextPane(
		CView			*anEnclosure,
		CBureaucrat		*aSupervisor,
		short			aWidth,
		short			aHeight,
		short			aHEncl,
		short			aVEncl,
		SizingOption	aHSizing,
		SizingOption	aVSizing,
		Str255			fontName,
		short			fontHeight
	);
	void					Dispose(void);
	/*
	 * Write a line of text into the pane.
	 */
	void					SetText(
		StringPtr		someText
	);
	/*
	 * Get a text item -- this should only be
	 * called by DrawItem.
	 */
	PRIVATE StringHandle	GetText(
		short			whichItem
	);
	/*
	 * Draw the pane or its contents.
	 */
	void					Draw(
		Rect			*area
	);
	/*
	 * Draw one line of text.
	 */
	PRIVATE void			DrawItem(
		short			whichItem
	);
	/*
	 * Scroll the text pane -- called by SetText
	 * when a line of text has been added.
	 */
	PRIVATE void			ScrollPane(void);
};

