/* ---------------------------
** "GrayMatters.c"
**
** from SPLAsh Resources
** "THINKin' CaP", Winter 1991
** --------------------------- */




#include <Global.h>				/* Has declaration of "tSystem" */

#include "GrayMatters.h"

extern tSystem		gSystem;



Boolean	CurrentPortHasColor (void)		{


	// High two bits of portVersion are set for a color graf port:

	if ( (((CGrafPtr)thePort)->portVersion & 0xC000) != 0 )
		// Check if color port has a bit depth > 1:

			return ( (**((CGrafPtr)thePort)->portPixMap).pixelSize > 1 );

	else	return (false);

}	/* CurrentPortHasColor */



void	SetGrayColor (void)		{

		RGBColor	foreColor, backColor, grayColor;
	

	GetForeColor(&foreColor);
	GetBackColor(&backColor);
	
	grayColor.red	= (1L + foreColor.red	+ backColor.red)   / 2;
	grayColor.green	= (1L + foreColor.green	+ backColor.green) / 2;
	grayColor.blue	= (1L + foreColor.blue	+ backColor.blue)  / 2;
	
	RGBForeColor(&grayColor);

}	/* SetGrayColor */



void	SetGrayPen (void)	{


	if (CurrentPortHasColor())		SetGrayColor();
	else							PenPat(gray);

}	/* SetGrayPen */



void	SetBlackPen (void)	{

		RGBColor	theColor;

	
	if (CurrentPortHasColor())	{
		theColor.red   = 0;
		theColor.blue  = 0;
		theColor.green = 0;
		RGBForeColor(&theColor);
	}
	else
		PenPat(black);

}	/* SetBlackPen */



void	GrayTextBox (Ptr text, long length, Rect *box, short just)	{

		RGBColor	saveForeColor;
		PenState	savePen;


	if (CurrentPortHasColor())	{
		GetForeColor(&saveForeColor);
		SetGrayColor();
		TextBox(text, length, box, just);
		RGBForeColor(&saveForeColor);
	
	}
	else	{
		TextBox(text, length, box, just);
		GetPenState(&savePen);
		PenMode(patBic);
		PenPat(gray);
		PaintRect(box);
		SetPenState(&savePen);
	}

}	/* GrayTextBox */




/* end: GrayMatters.c */
