// "my.r"
//
// -- using "SARez"	{ v 3.2 }



// The new "Types.r" resource description file for System 7
// adds an unsigned integer field to each of the following.
// The added field pertains to window positioning:
//
//		type	'ALRT'
//		type	'DLOG'
//		type	'WIND'

#define	SystemSevenOrLater	true
#define	oldTemp	true			/* "Somin" so I do NOT have to specify */
								/*		0x0,		{ wCSeed }		   */
								/*		0,			{ wCReserved }     */
								/* for every Color Table			   */
								/* ... but I wanna !!!	So sue me !!!  */

#ifndef	_TYPES_
#include	"Types.r"
#endif

#ifndef	_MACAPPTYPES_
#include	"MacAppTypes.r"
#endif

// #ifndef	_VIEWTYPES_
// #include	"ViewTypes.r"
// #endif

#ifndef	_BALLOONTYPES.R_
#include	"BalloonTypes.r"
#endif

#include	"TCLTypes.r"

#ifndef _H_Commands
#include	"Commands.h"
#endif

#ifndef _H_Constants
#include	"Constants.h"
#define		ALRT_Assert		ALRT_ExceptionAbort+1
#endif

/* ----- standard TCL stuff ... ----- */

/* ALRTs & DITLs	(IDs: 128, 129, 150, 151, 200, 250->253, 300),
** scroll bar CNTL	(ID: 300),
** 2 Estr			(resNotFound = -192, memFullErr = -108),
** MBAR (ID = 1) which the TCL uses to form the Menu Bar &
**               which includes the 1st three MENUs below,
** MENUs: Apple(1), File(2), Edit(3), Font(10), Size(11), Style(12)
** the grow SICN	(ID: 200),
** STRs		("Save File As:"			= 150,
**			 "Mac OS Error Encountered"	= 300,
**			 "of a Mac OS Error"		= 301),
** STR#s	(Common						= 128,
**			 Memory Warnings			= 129,
**			 Task Names					= 130,
**			 Exceptions					= 131,
**			 Dlg validation				= 133)
** WINDs	(Clipboard					= 200,
**			 Starter window				= 500)						*/

include	"Starter..rsrc" not 'MENU';		// I'm gonna replace them below ...

/* ----- my stuff ... ----- */

include	"System 7";
include	"MoofSND";
include	"myPICTs";					// Contains the following:
									//		ID = 3000	( Color Mac	   )
									//		ID = 3001	( IACS Logo	   )
									//		ID = 3002	( WAP Initials )
include	"Bill (B&W)";				/* Help Manager has problems with PICTs
									**   in 'hfdr' resource that do NOT have
									**   a rect whose topLeft = (0, 0).      */
include "myCursors";				/* 1) color Hand (ID = 3004)
									** 2) acurs:
									**		a) Rotating Earth (ID = 128)
									**		a) DogCow		  (ID = 129)	 */



/* ----- Constants ----- */

#define	kVersID				0		/* Finder stuff ... */
#define	kTopStringID		2
#define	kBottomStringID		1
#define	kLocalID			0
#define	kBNDL_ID			128
#define	kFREF_ID			128
#define	kICN_ID				128
#define	mySicnRsrc			300					/* rsrc ID */
#define	mySicn				mySicnRsrc - 256	/* "About ..." Item Icon's # */
#define	myIconRsrc			400					/* rsrc ID */
#define	myIcon				myIconRsrc - 256	/* "Quit" Item Icon's # */
//
#define	kMAC				3000
#define	kWAP				3002
#define	kBragWindowID		999
#define	kSystem7			777		/* ID of "System 7" PICT */
#define	kMeter				111



type	'JAL3'	{							/* TYPE = Signature */
	pstring;
};

/* ---------- */

type	'vers'	{
	byte		defaultVersion = 1;			/* version            */
	byte		defaultRevision = 5;		/* revision           */
	byte		defaultRevStage = 128;		/* revStage           */
	byte		defaultBuildNbr = 2;		/* buildNbr           */
	integer		defaultLang = 0;			/* languageInt        */
	pstring;								/* abbreviated string */
	align	word;
	pstring;
};

/////////////////////

resource	'JAL3'	(kVersID, "Version", purgeable)	{
	"My CShell {v 1.}"
};

resource	'BNDL'	(kBNDL_ID, purgeable)	{
	'JAL3',								/* Signature  */
	kVersID,
	{ 
		'FREF',
		{
			kLocalID, kICN_ID;			/* Local, Actual ID(s) */
		};

		'ICN#',
		{
			kLocalID, kICN_ID;
		};
	};
};
	
resource	'FREF'	(kFREF_ID, "Application", purgeable)	{
	'APPL',
	kLocalID,
	"my CShell DEMO"
};

resource	'ICN#'	(kICN_ID, "IACS", purgeable)	{
	{	/* Data */
		$"00000000 00000000 6040FC7E 60E0FC7E"
		$"61B0C060 6318C060 6318C060 6318C060"
		$"6318C060 6318C060 6318C060 6318C060"
		$"63F8C07E 63F8C07E 6318C006 6318C006"
		$"6318C006 6318C006 6318C006 6318C006"
		$"6318C006 6318C006 6318C006 6318FC7E"
		$"6318FC7E 00000000 00000000 00000000"
		$"7FFFFFFE 7FFFFFFE 00000000 00000000";

		/* Mask */
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
		$"FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF";
	};
};

resource	'vers'	(kTopStringID, purgeable)	{
	defaultVersion,
	defaultRevision,
	defaultRevStage,
	defaultBuildNbr,
	defaultLang,
	"91",
	"1991   IACS Software"
};

resource	'vers'	(kBottomStringID, purgeable)	{
	defaultVersion, defaultRevision, defaultRevStage,defaultBuildNbr, defaultLang,
	"1.",
	"1. ... in color too, folks !!"
};

resource	'SIZE'	(-1, purgeable)		{
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,				/* ... when suspended */
	ignoreChildDiedEvents,
	not32BitCompatible,
	isHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	384*1024,
	224*1024
};

/////////////////////

resource    'SICN'  (mySicnRsrc, "IACS", purgeable) {
    {
        $"FFFF"
        $"FFFF"
        $"B311"
        $"AD77"
        $"AD77"
        $"AD77"
        $"AD77"
        $"AD77"
        $"A171"
        $"AD7D"
        $"AD7D"
        $"AD7D"
        $"AD7D"
        $"AD11"
        $"FFFF"
        $"FFFF"
    };
};

/////////////////////

resource	'cicn'	(myIconRsrc, "Face", purgeable)	{
	// *
	// ********** IconPMap **********
	// *
	// $00000000		/* fill long = pBaseAddr 				  */
	// unsigned bitstring[1] = 1	pRowBytes = $8000 +
	// unsigned bitstring[2] = 0
	$0010,				/* pMapRowBytes = pixelSize * rowBytes(4) */
	{ 0, 0, 32, 32 },	/* bounds 								  */
	0,					/* pmVersion 							  */
	0,					/* packType 							  */
	0,					/* packSize 							  */
	$00480000,			/* hRes 								  */
	$00480000,			/* vRes 								  */
	chunky,				/* pixelType 							  */
	4,					/* pixelSize 							  */
	1,					/* cmpCount 							  */
	4,					/* cmpSize = pixelSize 					  */
	0,					/* planeBytes 							  */
	0,					/* pmTable 								  */
	// 00000000			/* fill long = pmReserved 				  */
	// *
	// ********** IconMask **********
	// *
	// 00000000			/* fill long = mBaseAddr */
	4,					/* maskRowBytes 		 */
	{ 0, 0, 32, 32 },	/* mbounds    			 */
	// *
	// ********** IconBMap **********
	// *
	// 00000000			/* fill long = 1BaseAddr */
	4,					/* iconBMapRowBytes		 */
	{ 0, 0, 32, 32 },	/* 1bounds    			 */
	// *
	// ********** IconData **********
	// *
	// 00000000			/* fill long = Placeholder for Handle. */
	// *
	// ********** MaskData **********
	// *
	// hex string [$$Word(maskRowBytes) * ($$BitField(Bounds, 32, 16) /*bottom*/ -
	//									   $$BitField(Bounds, 0, 16)  /*top*/      ]
	$"00BFEF80 01BFBFC0 03FFFFE0 0EFFFFF0"
	$"07FFFFF8 0FFFFFF0 0FFFFFF8 1FFFFFF8"
	$"0FFFFFFC 3FFFFFFE 3FFFFFFE 1FFFFFFE"
	$"7FFFFFFE 3FFFFFFC 7FFFFFFE 3FFFFFFE"
	$"7FFFFFFE 1FFFFFFE 0FFFFFFE 1FFFFFFE"
	$"0FFFFFFF 07FFFFF8 01FFFFF0 00FFFFC0"
	$"00FFFEC0 00FFFFF8 01FFFFFF 03FFFFFF"
	$"1FFFFFFE 7FFFFFE0 FFFFFFC0 01FFFF00",
	// *
	// ********** BMapData **********
	// *
	// hex string [$$Word(iconBMapRowBytes) * ($$BitField(Bounds, 32, 16) /*bottom*/ -
	//									   	   $$BitField(Bounds, 0, 16)  /*top*/    ]
	$"0017C300 00BFAF80 01B7FFC0 06EFB7E0"
	$"03F73AF0 07D40960 05C20330 0FA00230"
	$"07800138 1D8001FC 178000DC 0F8000FC"
	$"3FBA2F6C 1BBDDC88 3B566A4C 190A1D4C"
	$"3C024054 0C8640BC 07742E3C 0F034034"
	$"058FF87A 029BECD0 009C1CA0 0043E080"
	$"0061C280 00400070 0050044E 00C80861"
	$"0783E060 18800040 20C000C0 00600300",
	// *
	// ********** PMapCTab **********
	// *
	0x0,									/* ictSeed */
	0,										/* ictFlags */
	// integer = $$Countof(ColorSpec) - 1	/* ctSize */
	// *
	// ********** startICT **********
	// *
	{
		0, $FFFF, $FFFF, $FFFF;		/* white       */
		1, $FFFF, $B95B, $AD15;		/* light flesh */
		2, $FFFF, $8978, $70E4;		/* dark flesh  */
		3, $DD6B, $08C2, $06A2;		/* red         */
		4, $7EFF, $41F2, $22FD;		/* brown       */
		5, $0000, $0000, $D400;		/* blue        */
		6, $0000, $0000, $0000;		/* black       */
	},
	// *
	// ********** endICT **********
	// *
	// ********** PMapData **********
	// *
	// hex string [$$BitField(pMapRowBytes, 0, 13) * 
	//			   ($$BitField(Bounds, 32, 16) /*bottom*/ -
	//			    $$BitField(Bounds, 0, 16)  /*top*/      ]
	$"00000000 00060666 66000066 00000000"
	$"00000000 60666666 60606666 60000000"
	$"00000006 60660666 66666666 66000000"
	$"00000660 66616666 61661666 66600000"
	$"00000066 66661666 11666161 66660000"
	$"00000666 66161611 11116116 16600000"
	$"00000606 66111161 11111166 11660000"
	$"00006666 61611111 11111161 11660000"
	$"00000666 61111111 11111116 11666000"
	$"00066606 61111111 11111116 66666600"
	$"00060666 61111111 11111111 66166600"
	$"00006666 61111111 11111111 66666600"
	$"00666666 33333131 13333331 16616600"
	$"00066163 41444313 34144413 61116000"
	$"00666163 14141321 34414143 16116600"
	$"00066113 11114321 31144413 16116600"
	$"00666613 11111321 31111113 16160600"
	$"00006611 33333121 13333331 61666600"
	$"00000666 11111211 11111111 11666600"
	$"00006666 11111122 12111111 11660600"
	$"00000606 11112222 22222111 16666060"
	$"00000060 11122122 22212211 66060000"
	$"00000000 11122211 11122211 10600000"
	$"00000000 01111122 22211111 10000000"
	$"00000000 01111112 22111121 10000000"
	$"00000000 02111111 11111211 55550000"
	$"00000000 51121111 11112111 55555550"
	$"00000005 51112111 11121111 55555550"
	$"00005555 11111222 22111111 55555500"
	$"00555555 55555555 55555555 55000000"
	$"05555555 55555555 55555555 50000000"
	$"00000000 55555555 55555550 00000000"
};

/* ---------- */

// Mac SE-&-below-version for the above:

resource	'ICON'	(myIconRsrc, "Face", purgeable)	{
	$"0017C300 00BFAF80 01B7FFC0 06EFB7E0 03F73AF0 07D40960 05C20330 0FA00230"
	$"07800138 1D8001FC 178000DC 0F8000FC 3FBA2F6C 1BBDDC88 3B566A4C 190A1D4C"
	$"3C024054 0C8640BC 07742E3C 0F034034 058FF87A 029BECD0 009C1CA0 0043E080"
	$"0061C280 00400070 0050044E 00C80861 0783E060 18800040 20C000C0 00600300"
};

/////////////////////

resource	'WIND'	(kSystem7, "System 7", purgeable)	{
	{91, 206, 251, 306},
	plainDBox,
	visible,
	nogoAway,
	0x0,
	"",								/* NO title for this type */
	centerMainScreen
};

resource	'WIND'	(kBragWindowID, "Brag", purgeable)	{
	{60, 40, 165, 415},				// Holds the "IACS" PICT.
	altDBoxProc,
	invisible,
	nogoAway,
	0x0,							/* Refcon */
	"",								/* NO title for this type */
	centerMainScreen
};

resource	'WIND'	(kWAP, "Scroll", purgeable)	{
	{60, 40, 165, 415},				// Holds the "WAP" PICT.
	noGrowDocProc,
	invisible,
	nogoAway,
	0x0,
	"Spiffy, Aint It !*?*!",
	centerMainScreen
};

resource	'WIND'	(kMeter, "Meter", purgeable)	{
	{60, 40, 130, 340},
	rDocProc,
	invisible,
	nogoAway,
	0x0,
	"",
	centerMainScreen
};

include "Windoid";				// Special WDEF for Floating Windows.
#define kWindoid	104

/* MDEF "jmp" sequence(s) for various Menus. By convention, each MDEF ID
** matches the ID of the Menu being torn off.  For this demo, we will
** tear-off ONLY one Menu and gBartender->IBartender will load it from
** my 'MBAR' resource.  Note also that for the sake of consistency I have
** made the associated WIND ID(s) also match the MENU ID(s).  After all,
** we could have more than one torn-off menu/window.					*/

#define kTearMenu	1000
#define kMDEF		kTearMenu	// Apple reserves 0 -> 127.
include "MDEFs";
/* ----- */
resource	'MENU'	(kTearMenu, "1st Floating Tearoff Menu", purgeable)	{
	kTearMenu,
	kTearMenu,		// By TCL convention, MDEF ID = Menu ID.
	0x7FFFFFFF,
	enabled,
	"Tear off this hummer !!!",
	{
		// Item(s) drawn on-the-fly by MDEFs DrawMenu method.
	}
};

resource	'WIND'	(kTearMenu, "1st Floating Tearoff Menu", purgeable)	{
	{40,  40, 110, 112},
	1668,						// = 16*kWindoid + noGrowDocProc
	invisible,
	goAway,
	0x0,
	"",
	noAutoCenter
};

/////////////////////

resource 'MBAR' (MBARapp, "MBAR", purgeable)	{
	{	/* array MenuArray: 4 elements */
		/* [1] */
		mApple,
		/* [2] */
		mFile,
		/* [3] */
		mEdit,
		/* [4] */
		kTearMenu
	}
};

resource	'MENU'	(mApple, "Apple", purgeable)	{
	mApple,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{
	/* [ 1] */ "Read all about it, folks ...#256",
			   mySicn, "\0x1E", noMark, plain;
	/* [ 2] */ "-", noIcon, noKey, noMark, plain;
	}
};

/* ----- */

resource	'MENU'	(mFile, "File", purgeable)	{
	mFile,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"File",
	{
	/* [ 1] */ "Making Progress ...#1024", noIcon, noKey, noMark, bold  ;
	/* [ 2] */ "-"                       , noIcon, noKey, noMark, plain ;
	/* [ 3] */ "Quit#1"                  , myIcon, "Q"  , noMark, italic;
	}
};

/* ----- */

resource	'MENU'	(mEdit, "Edit", purgeable)	{
	mEdit,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"Edit",
	{
	/* [ 1] */ "Undo#16" , noIcon, "Z"  , noMark, plain;
	/* [ 2] */ "-"       , noIcon, noKey, noMark, plain;
	/* [ 3] */ "Cut#18"  , noIcon, "X"  , noMark, plain;
	/* [ 4] */ "Copy#19" , noIcon, "C"  , noMark, plain;
	/* [ 5] */ "Paste#20", noIcon, "V"  , noMark, plain;
	/* [ 6] */ "Clear#21", noIcon, noKey, noMark, plain;
	}
};

/////////////////////   Balloon Help goodies ... /////////////////////

resource	'hfdr'	(kHMHelpID, "Finder help", purgeable)	{

	HelpMgrVersion,
	hmDefaultOptions,
	0,							/* balloon definition function */
	0,							/* variation code */
	{	/* HFdrArrays ... */
		HMPictItem	{
			999					// Picture Resource ID
								//		"Aint he cute?!*!?\n"
								//		"   Courtesy of:\n"
								//		"IACS Software",
		};
	};

};

/*--------*/

resource	'hmnu'	(kHMHelpMenuID, "my Help Menu item", purgeable)	{

	HelpMgrVersion,
	hmDefaultOptions,
	0,							/* balloon definition function */
	0,							/* variation code */
	HMSkipItem	{
	/* no missing items */
	},
	/* NO Menu Title items for this special case. */
	/* The Help Manager processes Balloons for    */
	/* all the standard Help Menu items.          */
	{	/* my added item */
		HMStringItem	{
			"Watch the spiffy fireworks !!!",	/* enabled */
			"Item is dimmed.",
			"Item is checked.",
			""									/* Item canNOT be otherwise marked. */
		};
	};			/* End of Menu Title + items */

};
