/***********************************************************
 "ADBLights.h"

 Routines for controlling the lights on an extended keyboard
 [ See "THINKin' CaP", Winter 1991 ]

 using Symantec's "THINK C", v 5.00
 ***********************************************************/
 

 
#define	_H_ADBLights					// #pragma once
#include <DeskBus.h>




/* +++++++++++++++++
** Our global types:
** +++++++++++++++++ */

typedef	char	ADBAddrList[16];		/* Max of 16 ADB Devices */

typedef	enum	LightSetting	{
	Light_On,
	Light_Off,
	Light_Toggle,
	Light_Same
} LightSetting;

typedef	struct	LightStruct	{
	LightSetting	numLock;
	LightSetting	capsLock;
	LightSetting	scrollLock;
} LightStruct;


/* +++++++++++++++++++++
** Our global prototypes:
** +++++++++++++++++++++ */

Boolean		hasADB (void);
Boolean		hasExtendedKybd (void);
void		FindExtKeyboards (short *numExtKbd, ADBAddrList addresses);
OSErr		Set1ADBLights (ADBAddress kbdAddress, LightStruct *lights);
void		BlinkAllADBLights (void);




/*	{ end file "ADBLights.h" }  */
