/*********************************************************
 "floatingWindow.h"

 adapted from the pioneering work by:
 
 	Don Melton & Mike Ritter [MacTutor, April, 1988]
 	... and ...
	Thomas Fruin			 [MacTutor, December 1988]
 	... and ...
	Patrick Doane			 [his "FLOATING WINDOWS", Version 1.3,]
							 [downloaded from "America OnLine"    ]

 using Symantec's "THINK C", v 5.00
 *********************************************************/
 
 
#define	_H_floatingWindow				// #pragma once


	

/* Additional result codes describing window
** kinds returned by the routine TGetWKind:	*/

#define		systemKind			-1
#define		toolKind			30000


/* Used by TFrontWindow: */
#define		anyKind				30001


/* Miscellaneous: */

#define		inFront				(WindowPtr)-1
#define		FLOAT				3004
#define		postponeCalc		true
#define		normalCalc			false


// Prototypes follow:

void			TInitWindows (void);
WindowPtr		TMakeNewTool (short windowID, Ptr wStorage, WindowPtr behind);
void			TCloseWindow (WindowPtr theWindow);
void			TSelectWindow (WindowPtr whichWindow);
void			THideWindow (WindowPtr theWindow);
void			TShowWindow (WindowPtr theWindow);
void			THideFloats (void);
void			TShowFloats (void);
WindowPtr		TFrontWindow (short wantedKind);
void			TDragWindow (WindowPtr theWindow, EventRecord *theEvent);
short			TGetWKind (WindowPeek theWindow);
void			THiliteTools (Boolean hilite);
void			TSuspend (void);
void			TResume (void);
WindowPeek		TNextVisWindow (short wantedKind, WindowPeek thePWindow);
WindowPeek		TPrevVisWindow (WindowPeek thePWindow);
void			TBringForward (WindowPeek thePWindow, WindowPeek behindWindow,
							   Boolean waitWithCalc);
void			TSendDAsBack (WindowPeek behindWindow);




/*	{ end file "floatingWindow.h" }  */
