/*********************************************************
 "globals.h"

 by John A. Love, III [ Washington Apple Pi Users' Group]

 using Symantec's "THINK C", v 5.00
 *********************************************************/


#ifndef	__GLOBALS__
#define	__GLOBALS__

#include	<Retrace.h>




/* -----------------
   Global constants:
   ----------------- */

	 /* General constants ... */
		#define	Enter	3
		#define ohFudge 1					/* Guess what ????? */

	 /* low-memory global: */
		#define	ROM85Loc	0x028E

	 /* Specific constants ... */
		#define	AppleMenuID		1
		#define	AboutItem		1
		#define	AdisabledItem	2
	 /* ----- */
		#define	FileMenuID		2
		#define	QuitItem		1
	 /* ----- */
		#define	EditMenuID		3
		#define	UndoItem		1
		#define	EdisabledItem	2
		#define	CutItem			3
		#define	CopyItem		4
		#define	PasteItem		5
		#define	ClearItem		6

	 /* Window goodies ... */
		#define	maxWindows			20			/* A # subject only to memory. */
		#define	kDefaultWindowID	1001
		#define	mainWindowID		kDefaultWindowID
		#define	frame				1			/* Window parts in Pixels ... */
		#define	shadow				1
		#define	title				18
		#define	horizScrollID		128
		#define	vertScrollID		129
		#define	scrollWidth			16
		#define	scrollHeight		scrollWidth
		#define	growBoxSize			scrollWidth - frame

	 /* Radius' stuff ... */
		#define normalSize	12
		#define chicago16	16
		
	 /* ... for Error handling in my off-screen map routine(s): */
		#define NewCOSHdlError			-10000
		#define MaxDevError				-15000
		#define NewBaseAddrPtrError		-20000
		#define CloneHdlError			-25000



/* -------------
   Global types:
   ------------- */

	 /* General stuff: */
		typedef	RgnHandle	*RgnHandlePtr;
		typedef	short		*wordPtr;
		typedef	long		*longPtr;
	 /*	typedef	BitMap		*BitMapPtr; */

		typedef	struct	{
			short	dynamicStrID;
			short	dynamicStrIndex;
			Rect	dynamicR;
		} aDynamicBalloon;		/* ... for my NEW dynamic windows. */

	 /* The BIG guys: */
	 
		typedef	struct	{
			char	Signature, CPFlags, SSDelay, VertOffset;	/* For Internal use */
			char	LargeFontEn, PluggedIn;		/* PluggedIn DontRepos */
			BitMap	*MacBits;
			Ptr		BigTicksPtr;
			long	BigTicks;
			long	Reserved1;
			Ptr		TopBigRAM, IdleHook;
			long	Reserved2;
			Ptr		CursorHook;
		} RadBWStatus, *RadBWStatPtr, **RadBWStatHdl;

		typedef	struct	{
			char	AutoCenter, AutoLower, TearOffMenus, ScreenDump;
			char	LargeMenus, ScreenSaver, SaverActive, Reserved;
			short	ScreenSaverDelay, InitVers;
			char	CardID[6];
			short	ROMVers[6];
		} RadIIStatus, *RadIIStatPtr, **RadIIStatHdl;

		typedef	struct	{
			char	flipped, command, dLogFlags, xInternal, topOffset, bottomOffset;
			short	tileFactor;
			char	reserved[5];
			char	movementFlags;
			long	parameter, result;
			Rect	resultRect;
		} PivotDataStruct, *PivotDSPtr, **PivotDSHand;

		enum	radiusType	{none, radBW, radII};

		typedef	struct	{
			PivotDSHand	PivotHdl;
			short		radType;
			union uHdl	{
				Handle			zip;
				RadBWStatHdl	BWHdl;
				RadIIStatHdl	IIHdl;
			} statHdl;	/* end union */
		} RadiusData, *RadiusDataPtr, **RadiusDataHdl;

	 /* Off Screen stuff: */
	 
		typedef struct	{
			OSErr		CreateOffScreenError;
			GDHandle	oldDevice;
			GrafPtr		origPort;
			Rect		drawingRect;
			GDHandle	myMaxDevice;
			Handle		myBits;
			GrafPort	offGrafPort;
			GrafPtr		offGrafPtr;
			CGrafPort	offCGrafPort;
			CGrafPtr	offCGrafPtr;
			CTabHandle	ourCTHandle;
			BitMapPtr	offBitMapPtr;
		} OffScreenRec, *OffScreenRecPtr, **OffScreenRecHdl;



/* -------------------------------------
   Couldn't resist adding some stuff ...
   ------------------------------------- */
   
		#define	acurWorld	128
		#define	acurDogCow	129

		typedef	struct	MyVBLType	{
			long		CurrA5;					// Lost & Found !!
			VBLTask		MyVBL;					// The actual VBL Task.
		}	MyVBLType;

		typedef	struct	acurType	{			// Poetry in motion !!
			short		nbrCursors;
			short		frameCounter;
			long		cursorIDs[];			// ... in High word.
		}	acurType, *acurPtr, **acurHandle;




#endif


/*	{ end file "globals.h" }  */
