//------------------------------------------------------------------------------
//	IconEdit.r - Resources for IconEdit
//
//	Written by K.L. Colclasure for MacTutor, Dec 3, 1989
//	Copyright  1989 MacTutor, all rights reserved.
//------------------------------------------------------------------------------

#ifndef _TYPES.R_
#include "Types.r"
#endif

#ifndef _MacAppTypes_
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif

#ifdef Debugging
include "Debug.rsrc";
#endif
include "MacApp.rsrc";

include "IconEdit" 'CODE';

//------------------------------------------------------------------------------
//	Constants
//------------------------------------------------------------------------------
#define cZoomIn			1000
#define cZoomOut			1001
#define cInvert			1002

//------------------------------------------------------------------------------
//	Menus
//------------------------------------------------------------------------------
resource 'cmnu' (mApple) {
	1,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	 {
	/* [1] */	"About IconEdit", noIcon, noKey, noMark,
			plain, cAboutApp;
	/* [2] */	"-", noIcon, noKey, noMark, plain, nocommand
	}
};

resource 'cmnu' (mFile) {
	2,
	textMenuProc,
	allEnabled,
	enabled,
	"File",
	 {
	/* [1] */	"New", noIcon, "N", noMark, plain, cNew;
	/* [2] */	"Open", noIcon, "O", noMark, plain, cOpen;
	/* [3] */	"-", noIcon, noKey, noMark, plain, nocommand;
	/* [4] */	"Close", noIcon, noKey, noMark, plain, cClose;
	/* [5] */	"Save", noIcon, noKey, noMark, plain, cSave;
	/* [6] */	"Save As", noIcon, noKey, noMark, plain,
			cSaveAs;
	/* [7] */	"Revert to Saved", noIcon, noKey, noMark,
			plain, cRevert;
	/* [8] */	"-", noIcon, noKey, noMark, plain, nocommand;
	/* [9] */	"Page Setup", noIcon, noKey, noMark, plain,
			cPageSetup;
	/* [10] */	"Print", noIcon, noKey, noMark, plain, cPrint;
	/* [11] */	"-", noIcon, noKey, noMark, plain, nocommand;
	/* [12] */	"Quit", noIcon, "Q", noMark, plain, cQuit
	}
};

resource 'cmnu' (mEdit) {
	3,
	textMenuProc,
	allEnabled,
	enabled,
	"Edit",
	 {
	/* [1] */	"Undo", noIcon, "Z", noMark, plain, cUndo;
	/* [2] */	"-", noIcon, noKey, noMark, plain, nocommand;
	/* [3] */	"Cut", noIcon, "X", noMark, plain, cCut;
	/* [4] */	"Copy", noIcon, "C", noMark, plain, cCopy;
	/* [5] */	"Paste", noIcon, "V", noMark, plain, cPaste;
	/* [6] */	"Clear", noIcon, noKey, noMark, plain, cClear;
	/* [7] */	"-", noIcon, noKey, noMark, plain, nocommand;
	/* [8] */	"Show Clipboard", noIcon, noKey, noMark,
			plain, cShowClipboard
	}
};

resource 'cmnu' (4) {
	4,
	textMenuProc,
	allEnabled,
	enabled,
	"Icon",
	 {
	/* [1] */	"Zoom In",  noIcon, "M", noMark, plain,
			cZoomIn;
	/* [2] */	"Zoom Out",  noIcon, "L", noMark, plain,
			cZoomOut;
	/* [3] */	"-", noIcon, noKey, noMark, plain, nocommand;
	/* [4] */	"Invert", noIcon, "I", noMark, plain, cInvert
	}
};

resource 'cmnu' (128) {
	128,
	textMenuProc,
	allEnabled,
	enabled,
	"Buzzwords",
	 {
	/* [1] */	"Page Setup Change", noIcon, noKey, noMark,
			plain, cChangePrinterStyle
	}
};

resource 'MBAR' (128) { {mApple; mFile; mEdit; 4} };

//------------------------------------------------------------------------------
//	Alert for default About Box
//------------------------------------------------------------------------------
resource 'DITL' (phAboutApp,
#if qNames
"phAboutApp",
#endif
	purgeable) {
	 {	/* array DITLarray: 3 elements */
		/* [1] */
		{160, 182, 180, 262},
		Button {
			enabled,
			"OK"
		};
		/* [2] */
		{10, 75, 150, 306},
		StaticText {
			disabled,
			"^0"	// The ^0 will be dynamically replaced with
				// CurApName
			"\n\nMPW C++ version for MacTutor "
			"by K.L. Colclasure"
			"\n\nThis program was written "
			"with MacApp  1985-1989 Apple Computer, "
			"Inc."
		};
		/* [3] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			1000
		}
	}
};

resource 'ALRT' (phAboutApp,
#if qNames
"phAboutApp",
#endif
	purgeable) {
	{90, 100, 280, 412},
	phAboutApp,
	{
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent
	}
};

//------------------------------------------------------------------------------
//	Views
//------------------------------------------------------------------------------
resource 'view' (1000, "IconEdit", purgeable) {
	{	/* array viewArray: 3 elements */
		/* [1] */
		root, 'wind',
		{	/* array: 1 elements */
			/* [1] */
			50, 40
		},
		{	/* array: 1 elements */
			/* [1] */
			255, 255
		}, sizeVariable, sizeVariable, shown, enabled,
		Window {
			"TWindow",
			zoomDocProc, goAwayBox, resizable,
			modeless, ignoreFirstClick, freeOnClosing,
			disposeOnFree, closesDocument,
			openWithDocument, dontAdaptToScreen,
			stagger, forceOnScreen, dontCenter,
			'VW01',
			"<<<>>>"
		},
		/* [2] */
		'wind', 'VW02',
		{	/* array: 1 elements */
			/* [1] */
			0, 0
		},
		{	/* array: 1 elements */
			/* [1] */
			240, 240
		}, sizeRelSuperView, sizeRelSuperView, shown,
			enabled,
		Scroller {
			"TScroller",
			VertScrollBar, HorzScrollBar,
			256, 256, 16, 16,
			noVertConstrain, noHorzConstrain,
			{0, 0, 0, 0}
		},
		/* [3] */
		'VW02', 'VW01',
		{	/* array: 1 elements */
			/* [1] */
			0, 0
		},
		{	/* array: 1 elements */
			/* [1] */
			240, 240
		}, sizeVariable, sizeVariable, shown, enabled,
		View {
			"TIconView"
		}
	}
};

//------------------------------------------------------------------------------
//	Seed Icon
//------------------------------------------------------------------------------
data 'ICON' (1000, purgeable) {
	$"00 00 00 00 00 02 7E 00 00 04 81 00 00 09 00 80"  
	$"00 12 60 40 00 23 90 20 00 7C FF 1E 00 C4 60 0E" 
	$"01 82 00 0E 03 01 00 0E 06 00 C0 0E 0C 00 3F CE" 
	$"18 00 00 3E 30 00 00 0E 60 00 00 00 C0 00 15 02" 
	$"60 00 40 81 30 00 00 42 18 00 10 24 0C 01 40 10" 
	$"06 0A 2A 8A 03 00 10 05 01 81 00 02 00 C0 80 05" 
	$"00 60 21 02 00 30 0A A5 00 18 00 0A 00 0C 08 05" 
	$"00 06 10 00 00 03 20 00 00 01 C0 00 00 00 80 00" 
};

