{ UCPScreenPicker		1991, Joseph R. L. Simkins }

{ DESCRIPTION:  Overrides the genegic procedures }
{ defined in UControlPanel inherits }
{ its variables from UControlPanel. }

{ USE:  Add this file to your THINK Pascal project }
{ below UControlPanel.p and above your main program file }
{ or unit which uses this unit.  In your using code, }
{ include a 'uses' clause listing UScreenSet. }

unit UCPScreenPicker;    		{ File is UCPScreenPicker.p }

interface

	uses
		UControlPanel, UFlags;

{ Here we declare the CControlPanel class; its method }
{  bodies are postponed until the implementation }
{  part below. }

	type
		cCPScreenPicker = object(CControlPanel)		{ Note heritage of this class }

				fFlags: cFlags;		{ Control Panel Flags }

				function cCPScreenPicker.DoInitDev: Longint;
				Override;
			{ initialition of cdev }

				function cCPScreenPicker.DoHitDev: Longint;
				Override;
			{ user clicked dialog item }

				procedure cCPScreenPicker.Free;
				Override;
			{ dispose of flags as well as control panel }

			end; { Class cCPScreenPicker }

		controlIndex = (skip, ShowIndex, StartupIndex, DeskIndex);

implementation
	function cCPScreenPicker.DoInitDev: Longint;
		Override;
		var
			itemType: Integer;
			itemHandle: Handle;
			itemBox: Rect;
	begin
		{ get old control panal flags }
		New(fFlags);
		fFlags.IFlags;
		{ copy flags from resource to dialog }
		GetDItem(fDlg, fNumItems + ord(ShowIndex), itemType, itemHandle, itemBox);
		SetCtlValue(ControlHandle(itemHandle), ord(fFlags.TShowFlag));
		GetDItem(fDlg, fNumItems + ord(StartupIndex), itemType, itemHandle, itemBox);
		SetCtlValue(ControlHandle(itemHandle), ord(fFlags.TStartupFlag));
		GetDItem(fDlg, fNumItems + ord(DeskIndex), itemType, itemHandle, itemBox);
		SetCtlValue(ControlHandle(itemHandle), ord(fFlags.TDeskFlag));
		DoInitDev := inherited DoInitDev;
	end;


	function cCPScreenPicker.DoHitDev: Longint;
		Override;
		var
			itemType: Integer;
			itemHandle: Handle;
			itemBox: Rect;
			boxValue: Boolean;
	begin
		GetDItem(fDlg, fItem, itemType, itemHandle, itemBox);
		boxValue := not odd(GetCtlValue(ControlHandle(itemHandle)));
		SetCtlValue(ControlHandle(itemHandle), ord(boxValue));
		case controlIndex(fItem - fNumItems) of
			ShowIndex: 
				fFlags.TSetShowFlag(boxValue);
			StartupIndex: 
				fFlags.TSetStartupFlag(boxValue);
			DeskIndex: 
				fFlags.TSetDeskFlag(boxValue);
		end;
		DoHitDev := inherited DoHitDev;
	end;

	procedure cCPScreenPicker.Free;
		Override;
	begin
		fFlags.Free;
		inherited Free;					{ dispose Control Panel data }
	end;

end.