{ UControlPanel		1991, Joseph R. L. Simkins }

{ DESCRIPTION:  Provides the data type UControlPanel, }
{ which is an object class.  UControlPanel inherits }
{ its variables from CCollaborator. }

{ USE:  Add this file to your THINK Pascal project }
{ below CCollaborator.p and above your main program file }
{ or unit which uses this unit.  In your using code, }
{ include a 'uses' clause listing UScreenSet. }

unit UControlPanel;    		{ File is UControlPanel.p }

interface

	uses
		ObjIntf;

{ Here we declare the cControlPanel class; its method }
{  bodies are postponed until the implementation }
{  part below. }

	type
		cControlPanel = object(TObject)		{ Note heritage of this class }

		{ Instance variables }
				fItem: Integer;						{ local copy of Item for this call }
				fNumItems: Integer;				{ local copy of number of cdev items }
				fCPid: Integer;						{ local copy of Base resource of Control Panel driver }
				fEventptr: ^EventRecord;	{ local pointer to event record }
				fDlg: DialogPtr;					{ local copy of Control Panal Dialog pointer }

		{ Methods }
				function cControlPanel.DoControlPanel (message, item, numItems, CPid: integer;
											var event: EventRecord;
											dlg: DialogPtr): Longint;
			{ master entry point }
				function cControlPanel.DoInitDev: Longint;
			{ initialition of cdev }
				function cControlPanel.DoHitDev: Longint;
			{ user clicked dialog item }
				function cControlPanel.DoCloseDev: Longint;
			{ user did something to deactivate control panel }
				function cControlPanel.DoNulDev: Longint;
			{ desk accessory run }
				function cControlPanel.DoUpdateDev: Longint;
			{ update event }
				function cControlPanel.DoActivateDev: Longint;
			{ activate event }
				function cControlPanel.DoDeactivateDev: Longint;
			{ deactivate event }
				function cControlPanel.DoKeyEvtDev: Longint;
			{ keydown or autokey event, automaticly decodes undo, cut, copy, paste }
				function cControlPanel.DoMacDev: Longint;
			{ check machine charistics }
				function cControlPanel.DoUndoDev: Longint;
			{ standard menu undo }
				function cControlPanel.DoCutDev: Longint;
			{ standard menu cut }
				function cControlPanel.DoCopyDev: Longint;
			{ standard menu copy }
				function cControlPanel.DoPasteDev: Longint;
			{ standard menu paste }
				function cControlPanel.DoClearDev: Longint;
			{ standard menu clear }
				function cControlPanel.DoCursorDev: Longint;
			{ custom cursor processing per TN 215 }

			end; { Class cControlPanel }

implementation

	function cControlPanel.DoInitDev: Longint;
	begin
		DoInitDev := Longint(self);
	end;

	function cControlPanel.DoHitDev: Longint;
	begin
		DoHitDev := Longint(self);
	end;

	function cControlPanel.DoCloseDev: Longint;
	begin
		self.Free;					{ minimal Control Panel has no additional data }
		DoCloseDev := Longint(nil);
	end;

	function cControlPanel.DoNulDev: Longint;
	begin
		DoNulDev := Longint(self);
	end;

	function cControlPanel.DoUpdateDev: Longint;
	begin
		DoUpdateDev := Longint(self);
	end;

	function cControlPanel.DoActivateDev: Longint;
	begin
		DoActivateDev := Longint(self);
	end;

	function cControlPanel.DoDeactivateDev: Longint;
	begin
		DoDeactivateDev := Longint(self);
	end;

	function cControlPanel.DoKeyEvtDev: Longint;
	begin
		sysBeep(1);				{ Minimal Control Panal does not support text processing }
		DoKeyEvtDev := Longint(self);
	end;

	function cControlPanel.DoMacDev: Longint;
	begin
		DoMacDev := Longint(true);				{ Minimal Control Panal runs on all machines }
	end;

	function cControlPanel.DoUndoDev: Longint;
	begin
		sysBeep(1);				{ Minimal Control Panal does not support text processing }
		DoUndoDev := Longint(self);
	end;

	function cControlPanel.DoCutDev: Longint;
	begin
		sysBeep(1);				{ Minimal Control Panal does not support text processing }
		DoCutDev := Longint(self);
	end;

	function cControlPanel.DoCopyDev: Longint;
	begin
		sysBeep(1);				{ Minimal Control Panal does not support text processing }
		DoCopyDev := Longint(self);
	end;

	function cControlPanel.DoPasteDev: Longint;
	begin
		sysBeep(1);				{ Minimal Control Panal does not support text processing }
		DoPasteDev := Longint(self);
	end;

	function cControlPanel.DoClearDev: Longint;
	begin
		sysBeep(1);				{ Minimal Control Panal does not support text processing }
		DoClearDev := Longint(self);
	end;

	function cControlPanel.DoCursorDev: Longint;
	begin
		DoCursorDev := Longint(self);
	end;

	function cControlPanel.DoControlPanel (message, item, numItems, CPid: integer;
									var event: EventRecord;
									dlg: DialogPtr): Longint;

		var
			ch: char;		{To get the character pressed}

	begin
		{ save arguments for this call }
		fItem := item;
		fNumItems := numItems;
		fCPid := CPid;
		fEventptr := @event;
		fDlg := dlg;

		case message of								{Check the message sent}
			initDev: 
				DoControlPanel := self.DoInitDev;
			hitDev: 
				DoControlPanel := self.DoHitDev;
			closeDev: 
				DoControlPanel := self.DoCloseDev;
			nulDev: 
				DoControlPanel := self.DoNulDev;
			updateDev: 
				DoControlPanel := self.DoUpdateDev;
			activDev: 
				DoControlPanel := self.DoActivateDev;
			deactivDev: 
				DoControlPanel := self.DoDeactivateDev;
			keyEvtDev:  begin
					if event.what <> autoKey then		{If its not an autoKey event}
						begin
							if BitAnd(event.modifiers, CmdKey) <> 0 then			{Is the Command Key down?}
								ch := chr(BitAnd(fEventptr^.message, charCodeMask));		{Convert to char}
							if ch in ['z', 'Z', 'x', 'X', 'c', 'C', 'v', 'V'] then
								fEventptr^.what := nullEvent; { per TN 215 }
							case ch of		{Translate the standard Edit Cmd Keys}
								'z', 'Z': 
									DoControlPanel := self.DoUndoDev;
								'x', 'X': 
									DoControlPanel := self.DoCutDev;
								'c', 'C': 
									DoControlPanel := self.DoCopyDev;
								'v', 'V': 
									DoControlPanel := self.DoPasteDev;
								otherwise
									DoControlPanel := self.DoKeyEvtDev;
							end;
						end
					else
						DoControlPanel := self.DoKeyEvtDev;
				end;
			macDev: 
				DoControlPanel := self.DoMacDev;
			undoDev: 
				DoControlPanel := self.DoUndoDev;
			cutDev: 
				DoControlPanel := self.DoCutDev;
			copyDev: 
				DoControlPanel := self.DoCopyDev;
			pasteDev: 
				DoControlPanel := self.DoPasteDev;
			clearDev: 
				DoControlPanel := self.DoClearDev;
			cursorDev: 
				DoControlPanel := self.DoCursorDev;
		end;
	end;

end.