// main.c -- project to test symbolic variable listing in Macsbug
// Copyright 1992, David T. Roach, All Rights Reserved

#include 	<stdio.h>

#ifndef 	__MEMORY__
#include 	<memory.h>
#endif  	__MEMORY__

#ifndef 	__project__
#include	"project.h"
#endif		__project__

// prototypes
void main(void);
OSErr SetupGlobals(void);
GlobStructPtr FetchGlobals(void);

void main(void)
{
	register OSErr err;
	register short i;
	register short j;
	register GlobStructPtr g;
	register unsigned char * s;
	
	if (err = SetupGlobals()) {
		printf("error in setting up globals");
	}
	else {	
		// put some values in the globals
		g = FetchGlobals();
		
		g->long_hex = 0x12345678;
		g->long_unsigned = 0x90000000;
		g->long_signed = -1L;
		g->short_hex = 0x1234;
		g->short_unsigned = 0x9000;
		g->short_signed = -1;
		g->byte_hex = 0xFF;
		g->bool = true;
		
		for (i=0;i<ArraySize1;i++) {
			g->other[i] = (OtherStructPtr)NewPtrClear(sizeof(OtherStruct));
			if (g->other[i]) {
				g->other[i]->a = false;			// Boolean
				g->other[i]->b = 0x80;			// Byte
				g->other[i]->c = 0x8000;		// short
				g->other[i]->d = 0x80000000;	// long
				s = &g->other[i]->e[0];
				*s++  =  3;			// pstring length
				*s++  = 'x';		// char in pstring
				*s++  = 'y';		// char in pstring
				*s++  = 'z';		// char in pstring
				for (j=0;j<ArraySize2;j++) {
					g->other[i]->f.m[j] = j+i;	// array of short
				}
			}
		}
		DebugStr("\p;dump");
	}
}

// intermediate layer of calls to set or get globals
// handles and checks application specific info

OSErr SetupGlobals(void)
{
	OSErr err;
	register GlobStructPtr x;
		
	x = (GlobStructPtr)NewPtrClear((long)sizeof(GlobStruct));
	
	if (err = SetGlobPtr((Ptr)x)) {
		return(err);
	}
	else {
		x->id1 = AppSignature;
		x->id2 = AppSignature;
	}
	return(noErr);
}

GlobStructPtr FetchGlobals(void)
{
	GlobStructPtr x;
	OSErr err;
	
	// returns NIL if error encountered during GetGlobPtr
	
	if(err = GetGlobPtr((Ptr *)&x)) {
		return(0L);
	}
	
	// test that our signature is at the beginning and end of our structure
	
	if ((AppSignature != x->id1) || (AppSignature != x->id2)) {
		return(0L);
	}
	
	// our structure checks out OK
	
	return(x);
}
