/*--------------------------------
#
#	Alias Meister.r
#	Version 1.0
#
#	Rez Source
#
#	Copyright  1992 Tim Swihart
#	All rights reserved.
#
#	October 10, 1992 (v.1.0)
#
----------------------------------*/

#include "Alias Meister.h"

#define SystemSevenOrLater 1

#include "Types.r"
#include "SysTypes.r"
#include "BalloonTypes.r"


/*----- menu bar & menus -----*/

// MBAR defines our menu bar 
resource 'MBAR' (rMenuBar) {
	{ mApple, mFile, mEdit }
};

resource 'MENU' (mApple) {
	mApple, textMenuProc,
	AllItems & ~MenuItem2,
	enabled, apple,
	{
		"About " AppName "",
			noicon, nokey, nomark, plain;
	}
};

resource 'MENU' (mFile) {
	mFile, textMenuProc,
	MenuItem11,				
	enabled, "File",
	{
		"Quit",
			noicon, "Q", nomark, plain;
	}
};

resource 'MENU' (mEdit) {
	mEdit, textMenuProc,
	NoItems,				
	enabled, "Edit",
	 {
		"Undo",
			noicon, "Z", nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Cut",
			noicon, "X", nomark, plain;
		"Copy",
			noicon, "C", nomark, plain;
		"Paste",
			noicon, "V", nomark, plain;
		"Clear",
			noicon, nokey, nomark, plain;
		"Select All",
			noicon, "A", nomark, plain;
	}
};


/*----- About Box & "Not System 7" alert -----*/

/* About box */
resource 'ALRT' (rAboutBox, purgeable) {
	{0, 0, 226, 290},
	rAboutBox,
	silentStages,
	alertPositionMainScreen		
};

resource 'DITL' (rAboutBox, purgeable) {
	{	/* array DITLarray: 5 elements */
		/* The OK button */
		{198, 202, 218, 282},
		Button {
			enabled,
			"OK"
		},
		/* Explanation of this program */
		{8, 8, 120, 282},
		StaticText {
			disabled,
			"Alias Meister v.1.0\n\nCreates Finder aliases for files, "
			"folders, and volumes, then moves the new aliases to a "
			"user-selected location. This allows aliases to be created "
			"and sorted in just one operation."
		},
		/* Copyright notice */
		{134, 8, 184, 282},
		StaticText {
			disabled,
			" Copyright Tim Swihart\nOctober 10, 1992\nAll Rights Reserved"
		},
		/* The "Help" item */
		{0, 0, 0, 0},	// the rect for the help item
		HelpItem {		// HelpItem defined in Types.r
			disabled,	// disable it
			HMScanhdlg {rAboutBox}	// use 'hdlg', ID = rAboutBox 
		},
	}
};


/* "Wrong System" alert box */
resource 'ALRT' (rNotSystem7, purgeable) {
	{40, 20, 140, 260},
	rNotSystem7,
	beepStages,
	noAutoCenter		
};

resource 'DITL' (rNotSystem7, purgeable) {
	{
		{70, 150, 90, 230},
		Button {
			enabled,
			"OK"
		};

		{10, 55, 50, 230},
		StaticText {
			disabled,
			AppName " requires at least System 7.0 to run."
		};

		{8, 8, 40, 40},
		Icon {
			disabled,
			StopIconID
		};
	}
};


/*----- CustomGetFile dialog -----*/

resource 'DLOG' (kMyCustomDlogID, purgeable)
{
	{0, 0, 207, 344}, dBoxProc, invisible, noGoAway, 0, kMyCustomDlogID, "", noAutoCenter
};

resource 'DITL' (kMyCustomDlogID, "CustomGetFile dialog", purgeable)
{
	{
		{150, 252, 170, 332}, Button {enabled, "Open"},
		{119, 252, 139, 332}, Button {enabled, "Cancel"},
		{0, 0, 0, 0}, HelpItem {disabled, HMScanhdlg {-6042}},
		{23, 235, 39, 337}, UserItem {enabled},
		{47, 252, 67, 332}, Button {enabled, "Eject"},
		{75, 252, 95, 332}, Button {enabled, "Desktop"},
		{44, 12, 174, 230}, UserItem {enabled},
		{21, 12, 40, 230}, UserItem {enabled},
		{106, 251, 107, 333}, Picture {disabled, 11},
		{181, 12, 201, 230}, Button {enabled, "Use Current Directory"},
		{181, 252, 201, 332}, Button {enabled, "Select"},
		{2, 69, 18, 175}, StaticText {disabled, "Select A Folder:"},
		{0, 0, 0, 0}, HelpItem {disabled, HMScanhdlg {kMyCustomDlogID}}, // add help for new items only
	}
};



/*----- BNDL, FREF, signature, vers 1, vers 2, SIZE resources -----*/

resource 'BNDL' (rBundle) {
	ApplCreator,
	rSignature,
	{	
		'FREF',
		{	
			0, rRefAPPL,
			1, rRefDoc,
			2, rRefStar,
			3, rRefDisk,
			4, rRefFold,
		},
		'ICN#',
		{	
			0, rIconAPPL,
			1, rIconDoc,
		}
	}
};

resource 'FREF' (rRefAPPL) {
	'APPL', 0, ""
};

resource 'FREF' (rRefDoc) {
	'TimS', 1, ""
};

resource 'FREF' (rRefFold) {
	'fold', 2, ""
};

resource 'FREF' (rRefDisk) {
	'disk', 3, ""
};

resource 'FREF' (rRefStar) {
	'****', 4, ""
};



type ApplCreator as 'STR ';
resource ApplCreator (rSignature) {
	AppName " " AppVers ", " CopyrightNotice                                              
};


resource 'vers' (1, purgeable) {
	0x1,
	0x0,
	final,
	0x0,
	verUS,
	AppVers,
	AppVers ", " CopyrightNotice
};

resource 'vers' (2, purgeable) {
	0x1,
	0x0,
	final,
	0x0,
	verUS,
	AppVers,
	AppName " " AppVers
};


resource 'SIZE' (-1) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,				
	doesActivateOnFGSwitch,							
	backgroundAndForeground,	
	dontGetFrontClicks,			
	acceptAppDiedEvents,						
	is32BitCompatible,			
	isHighLevelEventAware,				
	localAndRemoteHLEvents,				
	isStationeryAware,					
	useTextEditServices,
	reserved,
	reserved,
	reserved,
	kPrefSize * 1024,
	kMinSize * 1024	
};


/*---------------------- balloons ---------------------------*/

// Balloon help for the Application:

resource 'hfdr' (kHMHelpID, purgeable) {
	HelpMgrVersion, hmDefaultOptions, 0, 7,
	{
		HMStringItem {
			AppName "\n"
			AuthorCredit "\n\n"
			"Creates Finder aliases for files, folders, and volumes, then "
			"moves the new aliases to a user-selected location. This allows "
			"aliases to be created and sorted in just one operation."
		}
	}
};

/*---------------------- Balloons for menus ----------------------*/

// Balloon help for the Apple menu
// resource ID must match that of the 'Apple' menu
resource 'hmnu' (mApple, purgeable) {
	// Standard header block comes first
	HelpMgrVersion,
	hmDefaultOptions,	// use defaults
	0,					// use std balloon def function	
	0,					// use std balloon def function
	// Messages for items without messages
	HMSkipItem {		// no items will be missing, so skip this section
	},
	{
	// Use the System's messages for the menu title
	HMSkipItem {},
	// First menu item's messages
	HMStringItem {		// use embedded pstrings
		// enabled
		"Displays copyright information for this application.\n\n"
		"Alias Meister renames itself after being configured. The new name "
		"reflects the destination used by this copy of Alias Meister.",
		// disabled
		"Displays copyright information for this application. "
		"This item is unavailable until you dismiss the dialog/alert.",
		// item has check by it
		"",		// it never has a check by it, so use an empty string
		// item is marked with something besides a check
		"",		// it never is marked in this way, so use an empty string
	},
	}
};


// Balloon help for the File menu
// resource ID must match that of the 'File' menu
resource 'hmnu' (mFile, purgeable) {
	// Standard header block comes first
	HelpMgrVersion,
	hmDefaultOptions,	// use defaults
	0,					// use std balloon def function	
	0,					// use std balloon def function
	// Messages for items without messages
	HMSkipItem {		// no items will be missing, so skip this section
	},
	{
	// Messages for the menu title
	HMStringItem {		// use embedded pstrings
		// first, the message to use when the menu is enabled
		"File Menu\n\nUse the item in this menu to exit this application.",
		// then the message to use when the menu is disabled
		"", // we never disable this menu, so use a null string
		// then the message to use if the menu TITLE is dimmed due to a dialog/alert
		"This menu is unavailable until you dismiss the dialog/alert.",
		// then the message to use if the menu ITEMS are dimmed due to a dialog/alert
		"This item is unavailable until you dismiss the dialog/alert.",
	},
	// Messages for QUIT
	HMStringItem {		// use embedded pstrings
		// enabled
		"Quits this application.",
		// disabled
		"",	// you can always quit so no need for a message here.
		// item has check by it
		"",		// it never has a check by it, so use an empty string
		// item is marked with something besides a check
		"",		// it never is marked in this way, so use an empty string
	},
	}
};


// Balloon help for the Edit menu
// resource ID must match that of the 'Edit' menu
resource 'hmnu' (mEdit, purgeable) {
	// Standard header block comes first
	HelpMgrVersion,
	hmDefaultOptions,	// use defaults
	0,					// use std balloon def function	
	0,					// use std balloon def function
	// Messages for items without messages
	HMSkipItem {		// no items will be missing, so skip this section
	},
	{
	// Messages for the menu title
	HMStringItem {		// use embedded pstrings
		// first, the message to use when the menu is enabled
		"Edit Menu\n\nUse this menu to work with text, graphics, and editions, or to undo "
		"an action.",
		// then the message to use when the menu is disabled
		"Edit Menu\n\nUse this menu to work with text, graphics, and editions, or to undo "
		"an action.\n\nUnavailable right now.",
		// then the message to use if the menu TITLE is dimmed due to a dialog/alert
		"This menu is unavailable until you dismiss the dialog/alert.",
		// then the message to use if the menu ITEMS are dimmed due to a dialog/alert
		"This item is unavailable until you dismiss the dialog/alert.",
	},
	// Messages for UNDO
	HMStringItem {		// use embedded pstrings
		// first, the message to use when the item is enabled
		"",	// we never enable this item, so use a null message
		// then the message to use when the item is disabled
		"Undoes your last action if it involved cutting, clearing, pasting, or typing.\n\n"
		"Not available because your last action cannot be undone.",
		// then the message to use when the item has check by it
		"",		// it never has a check by it, so use an empty string
		// then the message to use when the item is marked with something besides a check
		"",		// it never is marked in this way, so use an empty string
	},
	// Skip over the menu's first dividing line
	HMSkipItem {},
	// Messages for CUT
	HMStringItem {		// use embedded pstrings
		// enabled
		"",	// we never enable this item, so use a null message
		// disabled
		"Removes the selected text and places it on the clipboard.\n\n"
		"Not available until some text in the front window has been selected.",
		// item has check by it
		"",		// it never has a check by it, so use an empty string
		// item is marked with something besides a check
		"",		// it never is marked in this way, so use an empty string
	},
	// Messages for COPY
	HMStringItem {		// use embedded pstrings
		// enabled
		"",	// we never enable this item, so use a null message
		// disabled
		"Puts a copy of the selected text on the clipboard.\n\n"
		"Not available until some text in the front window has been selected.",
		// item has check by it
		"",		// it never has a check by it, so use an empty string
		// item is marked with something besides a check
		"",		// it never is marked in this way, so use an empty string
	},
	// Messages for PASTE
	HMStringItem {		// use embedded pstrings
		// enabled
		"",	// we never enable this item, so use a null message
		// disabled
		"Inserts a copy of the text from the clipboard into the document at the current "
		"insertion point. If a range of text is selected, all of that text will be replaced "
		"by text from the clipboard.\n\n"
		"Not available until the clipboard contains some text.",
		// item has check by it
		"",		// it never has a check by it, so use an empty string
		// item is marked with something besides a check
		"",		// it never is marked in this way, so use an empty string
	},
	// Messages for CLEAR
	HMStringItem {		// use embedded pstrings
		// enabled
		"",	// we never enable this item, so use a null message
		// disabled
		"Deletes the currently selected text without copying it to the clipboard.\n\n"
		"Not available until some text in the front window has been selected.",
		// item has check by it
		"",		// it never has a check by it, so use an empty string
		// item is marked with something besides a check
		"",		// it never is marked in this way, so use an empty string
	},
	// Messages for SELECT ALL
	HMStringItem {		// use embedded pstrings
		// enabled
		"",	// we never enable this item, so use a null message
		// disabled
		"Selects all of the text in the front window.\n\n"
		"Not available until some text has been entered in the front window.",
		// item has check by it
		"",		// it never has a check by it, so use an empty string
		// item is marked with something besides a check
		"",		// it never is marked in this way, so use an empty string
	},
	}
};

//---------------------- Balloons for dialogs

// Balloon help for the items we added to the CustomGetFile dialog
resource 'hdlg' (kMyCustomDlogID, purgeable) {
	HelpMgrVersion,
	kUseBtnID - 1,		// provide help starting with first new item 
	hmDefaultOptions,	// use default
	0,					// use std balloon def function
	0,					// use std balloon position
	HMSkipItem {		// no message for skipped items
		},
	// Messages for the items
	{
		// the "Use " button comes first
		HMStringItem {
			{0,0},			// tip at default location
			{0, 0, 0, 0},	// alternate rect same as item's rect
			"Selects the folder named in the popup at the top of "
			"this dialog to be used as the destination for aliases "
			"created by this application.", // the enabled OK button
			"",				// button never disabled
			"",				// OK btn never has a check mark
			"",				// or any other marking
		},
		// the "Select" button is second
		HMStringItem {
			{0,0},			// tip at default location
			{0, 0, 0, 0},	// alternate rect same as item's rect
			"Use the selected folder or volume as the destination for " 
			"aliases created by this application.", // the enabled OK button
			"Use the selected folder or volume as the destination for " 
			"aliases created by this application. The button is not "
			"available because nothing is selected.",	// button never disabled
			"",				// OK btn never has a check mark
			"",				// or any other marking
		},
	}
};

// Balloon help for the About Box
resource 'hdlg' (rAboutBox, purgeable) {
	HelpMgrVersion,
	0,					// provide help starting with first item 
	hmSaveBitsNoWindow,	// makes Alert look cleaner
	0,					// use std balloon def function
	0,					// use std balloon position
	HMSkipItem {		// no message for skipped items
		},
	// Messages for the items
	{
		// the OK button comes first in our DITL
		HMStringItem {
			{0,0},					// tip at default location
			{0, 0, 0, 0},	// alternate rect same as item's rect
			"Click this button to dismiss the About box.",	// the enabled OK button
			"",						// OK button always enabled
			"",						// OK btn never has a check mark
			"",						// or any other marking
		},
		// ignore all other parts of the About Box, they're just text and don't 
		// need further explanations
	}
};


//----------------------- icon family for application
resource 'ICN#' (rIconAPPL, purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0001 0000 1C02 8000 1C04 4000 1C08 2000"
		$"1C10 1000 7F20 0800 3E40 0400 1C80 0200"
		$"0900 0100 0200 0080 0400 0040 0800 0020"
		$"108C 8010 2084 0008 4145 98E4 8244 8502"
		$"43C8 B881 2449 4842 1449 3B84 0800 0008"
		$"0400 0010 0200 0020 0100 0040 0080 00B8"
		$"0040 0138 0020 0238 0010 0438 0008 08FE"
		$"0004 107C 0002 2038 0001 4010 0000 8000",
		/* [2] */
		$"0001 0000 1C03 8000 1C07 C000 1C0F E000"
		$"1C1F F000 7F3F F800 3E7F FC00 1CFF FE00"
		$"09FF FF00 03FF FF80 07FF FFC0 0FFF FFE0"
		$"1FFF FFF0 3FFF FFF8 7FFF FFFC FFFF FFFE"
		$"7FFF FFFF 3FFF FFFE 1FFF FFFC 0FFF FFF8"
		$"07FF FFF0 03FF FFE0 01FF FFC0 00FF FFB8"
		$"007F FF38 003F FE38 001F FC38 000F F8FE"
		$"0007 F07C 0003 E038 0001 C010 0000 8000"
	}
};

resource 'ics#' (rIconAPPL, purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"6180 6240 F420 6810 1008 2004 4A82 9BFD"
		$"BBE9 4B7A 2004 1008 0816 0426 024F 0186",
		/* [2] */
		$"6180 63C0 F7E0 7FF0 1FF8 3FFC 7FFE FFFF"
		$"FFFF 7FFE 3FFC 1FF8 0FF6 07E6 03CF 0186"
	}
};

resource 'icl8' (rIconAPPL, purgeable) {
	$"0000 0000 0000 0000 0000 0000 0000 00FF"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 00FF FFFF 0000 0000 0000 0000 FFF5"
	$"FF00 0000 0000 0000 0000 0000 0000 0000"
	$"0000 00FF FFFF 0000 0000 0000 00FF F5F5"
	$"F5FF 0000 0000 0000 0000 0000 0000 0000"
	$"0000 00FF FFFF 0000 0000 0000 FFF5 F5F5"
	$"F5F5 FF00 0000 0000 0000 0000 0000 0000"
	$"0000 00FF FFFF 0000 0000 00FF F5F5 F5F5"
	$"F5F5 F5FF 0000 0000 0000 0000 0000 0000"
	$"00FF FFFF FFFF FFFF 0000 FFF5 F5F5 F5F5"
	$"F5F5 F5F5 FF00 0000 0000 0000 0000 0000"
	$"0000 FFFF FFFF FF00 00FF F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5FF 0000 0000 0000 0000 0000"
	$"0000 00FF FFFF 0000 FFF5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 FF00 0000 0000 0000 0000"
	$"0000 0000 FF00 00FF F5F5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5FF 0000 0000 0000 0000"
	$"0000 0000 0000 FFF5 F5F5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5F5 FF00 0000 0000 0000"
	$"0000 0000 00FF F5F5 F5F5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5F5 F5FF 0000 0000 0000"
	$"0000 0000 FFF5 F5F5 F5F5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5F5 F5F5 FF00 0000 0000"
	$"0000 00FF F5F5 F5F5 FFF5 F5F5 FFFF F5F5"
	$"FFF5 F5F5 F5F5 F5F5 F5F5 F5FF 0000 0000"
	$"0000 FFF5 F5F5 F5F5 FFF5 F5F5 F5FF F5F5"
	$"F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 FF00 0000"
	$"00FF F5F5 F5F5 F5FF F5FF F5F5 F5FF F5FF"
	$"FFF5 F5FF FFF5 F5F5 FFFF FFF5 F5FF 0000"
	$"FFF5 F5F5 F5F5 FFF5 F5FF F5F5 F5FF F5F5"
	$"FFF5 F5F5 F5FF F5FF F5F5 F5F5 F5F5 FF00"
	$"00FF F5F5 F5F5 FFFF FFFF F5F5 FFF5 F5F5"
	$"FFF5 FFFF FFF5 F5F5 FFF5 F5F5 F5F5 F5FF"
	$"0000 FFF5 F5FF F5F5 F5FF F5F5 FFF5 F5FF"
	$"F5FF F5F5 FFF5 F5F5 F5FF F5F5 F5F5 FF00"
	$"0000 00FF F5FF F5F5 F5FF F5F5 FFF5 F5FF"
	$"F5F5 FFFF FFF5 FFFF FFF5 F5F5 F5FF 0000"
	$"0000 0000 FFF5 F5F5 F5F5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 FF00 0000"
	$"0000 0000 00FF F5F5 F5F5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5F5 F5F5 F5FF 0000 0000"
	$"0000 0000 0000 FFF5 F5F5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5F5 F5F5 FF00 0000 0000"
	$"0000 0000 0000 00FF F5F5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5F5 F5FF 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5F5 FF00 FFFF FF00 0000"
	$"0000 0000 0000 0000 00FF F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5FF 0000 FFFF FF00 0000"
	$"0000 0000 0000 0000 0000 FFF5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 FF00 0000 FFFF FF00 0000"
	$"0000 0000 0000 0000 0000 00FF F5F5 F5F5"
	$"F5F5 F5F5 F5FF 0000 0000 FFFF FF00 0000"
	$"0000 0000 0000 0000 0000 0000 FFF5 F5F5"
	$"F5F5 F5F5 FF00 0000 FFFF FFFF FFFF FF00"
	$"0000 0000 0000 0000 0000 0000 00FF F5F5"
	$"F5F5 F5FF 0000 0000 00FF FFFF FFFF 0000"
	$"0000 0000 0000 0000 0000 0000 0000 FFF5"
	$"F5F5 FF00 0000 0000 0000 FFFF FF00 0000"
	$"0000 0000 0000 0000 0000 0000 0000 00FF"
	$"F5FF 0000 0000 0000 0000 00FF 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"FF00 0000 0000 0000 0000 0000 0000 0000"
};

resource 'icl4' (rIconAPPL, purgeable) {
	$"0000 0000 0000 000F 0000 0000 0000 0000"
	$"000F FF00 0000 00FC F000 0000 0000 0000"
	$"000F FF00 0000 0FC0 CF00 0000 0000 0000"
	$"000F FF00 0000 FC0C 0CF0 0000 0000 0000"
	$"000F FF00 000F C0C0 C0CF 0000 0000 0000"
	$"0FFF FFFF 00FC 0C0C 0C0C F000 0000 0000"
	$"00FF FFF0 0FC0 C0C0 C0C0 CF00 0000 0000"
	$"000F FF00 FC0C 0C0C 0C0C 0CF0 0000 0000"
	$"0000 F00F C0C0 C0C0 C0C0 C0CF 0000 0000"
	$"0000 00FC 0C0C 0C0C 0C0C 0C0C F000 0000"
	$"0000 0FC0 C0C0 C0C0 C0C0 C0C0 CF00 0000"
	$"0000 FC0C 0C0C 0C0C 0C0C 0C0C 0CF0 0000"
	$"000F C0C0 F0C0 FFC0 F0C0 C0C0 C0CF 0000"
	$"00FC 0C0C FC0C 0F0C 0C0C 0C0C 0C0C F000"
	$"0FC0 C0CF 0FC0 CFCF F0CF F0C0 FFF0 CF00"
	$"FC0C 0CF0 0F0C 0F0C FC0C 0F0F 0C0C 0CF0"
	$"0FC0 C0FF FFC0 F0C0 F0FF F0C0 F0C0 C0CF"
	$"00FC 0F0C 0F0C FC0F 0F00 FC0C 0F0C 0CF0"
	$"000F CFC0 CFC0 F0CF C0FF F0FF F0C0 CF00"
	$"0000 FC0C 0C0C 0C0C 0C0C 0C0C 0C0C F000"
	$"0000 0FC0 C0C0 C0C0 C0C0 C0C0 C0CF 0000"
	$"0000 00FC 0C0C 0C0C 0C0C 0C0C 0CF0 0000"
	$"0000 000F C0C0 C0C0 C0C0 C0C0 CF00 0000"
	$"0000 0000 FC0C 0C0C 0C0C 0C0C F0FF F000"
	$"0000 0000 0FC0 C0C0 C0C0 C0CF 00FF F000"
	$"0000 0000 00FC 0C0C 0C0C 0CF0 00FF F000"
	$"0000 0000 000F C0C0 C0C0 CF00 00FF F000"
	$"0000 0000 0000 FC0C 0C0C F000 FFFF FFF0"
	$"0000 0000 0000 0FC0 C0CF 0000 0FFF FF00"
	$"0000 0000 0000 00FC 0CF0 0000 00FF F000"
	$"0000 0000 0000 000F CF00 0000 000F 0000"
	$"0000 0000 0000 0000 F000 0000 0000 0000"
};

resource 'ics8' (rIconAPPL, purgeable) {
	$"00FF FF00 0000 00FF FF00 0000 0000 0000"
	$"00FF FF00 0000 FFF5 F5FF 0000 0000 0000"
	$"FFFF FFFF 00FF F5F5 F5F5 FF00 0000 0000"
	$"00FF FF00 FFF5 F5F5 F5F5 F5FF 0000 0000"
	$"0000 00FF F5F5 F5F5 F5F5 F5F5 FF00 0000"
	$"0000 FFF5 F5F5 F5F5 F5F5 F5F5 F5FF 0000"
	$"00FF F5F5 FFF5 FFF5 FFF5 F5F5 F5F5 FF00"
	$"FFF5 F5FF FFF5 FFFF FFFF FFFF FFFF F5FF"
	$"FFF5 FFFF FFF5 FFFF FFFF FFF5 FFF5 F5FF"
	$"00FF F5F5 FFF5 FFFF F5FF FFFF FFF5 FF00"
	$"0000 FFF5 F5F5 F5F5 F5F5 F5F5 F5FF 0000"
	$"0000 00FF F5F5 F5F5 F5F5 F5F5 FF00 0000"
	$"0000 0000 FFF5 F5F5 F5F5 F5FF 00FF FF00"
	$"0000 0000 00FF F5F5 F5F5 FF00 00FF FF00"
	$"0000 0000 0000 FFF5 F5FF 0000 FFFF FFFF"
	$"0000 0000 0000 00FF FF00 0000 00FF FF00"
};

resource 'ics4' (rIconAPPL, purgeable) {
	$"0FF0 000F F000 0000 0FF0 00FC 0F00 0000"
	$"FFFF 0FC0 C0F0 0000 0FF0 FC0C 0C0F 0000"
	$"000F C0C0 C0C0 F000 00FC 0C0C 0C0C 0F00"
	$"0FC0 F0F0 F0C0 C0F0 FC0F FCFF FFFF FF0F"
	$"F0FF F0FF FFF0 F0CF 0F0C FCFF 0FFF FCF0"
	$"00F0 C0C0 C0C0 CF00 000F 0C0C 0C0C F000"
	$"0000 F0C0 C0CF 0FF0 0000 0F0C 0CF0 0FF0"
	$"0000 00F0 CF00 FFFF 0000 000F F000 0FF0"
};

//----------------------- icon family for document
resource 'ics#' (129, purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 3FFC 2006 250E 2DFA 36FA 2002 3FFE"
		$"0AA8 0B50 0820 09C0 0900 0F00 0F00 0F00",
		/* [2] */
		$"0000 3FFC 3FFE 3FFE 3FFE 3FFE 3FFE 3FFE"
		$"0FF8 0FF0 0FE0 0FC0 0F00 0F00 0F00 0F00"
	}
};

resource 'ICN#' (129, purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 0000 0000 0000 0000 0000 3FFF FFF0"
		$"2000 0028 2000 0024 208C 803C 2084 0004"
		$"2145 98E4 2244 8504 23C8 B884 2449 4844"
		$"2449 3B84 2000 0004 2000 0004 FFFF FFFF"
		$"4000 0002 3FFF FFFC 00A0 5480 00A0 5500"
		$"00A0 D500 00BB A600 00EC 4400 0090 9800"
		$"00A0 3000 00C0 C000 0083 0000 0084 0000"
		$"0084 0000 01FE 0000 01FE 0000 01FE 0000",
		/* [2] */
		$"0000 0000 0000 0000 0000 0000 3FFF FFF0"
		$"3FFF FFF8 3FFF FFFC 3FFF FFFC 3FFF FFFC"
		$"3FFF FFFC 3FFF FFFC 3FFF FFFC 3FFF FFFC"
		$"3FFF FFFC 3FFF FFFC 3FFF FFFC FFFF FFFF"
		$"7FFF FFFE 3FFF FFFC 00E0 7F80 00E0 7F00"
		$"00E0 FF00 00FB FE00 00FF FC00 00FF F800"
		$"00FF F000 00FF C000 00FF 0000 00FC 0000"
		$"00FC 0000 01FE 0000 01FE 0000 01FE 0000"
	}
};

resource 'icl8' (129, purgeable) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF 0000 0000"
	$"0000 FFF5 F5F5 F5F5 F5F5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5F5 F5F5 FF2B FF00 0000"
	$"0000 FFF5 F5F5 F5F5 F5F5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5F5 F5F5 FF2B 2BFF 0000"
	$"0000 FFF5 F5F5 F5F5 FFF5 F5F5 FFFF F5F5"
	$"FFF5 F5F5 F5F5 F5F5 F5F5 FFFF FFFF 0000"
	$"0000 FFF5 F5F5 F5F5 FFF5 F5F5 F5FF F5F5"
	$"F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 F5FF 0000"
	$"0000 FFF5 F5F5 F5FF F5FF F5F5 F5FF F5FF"
	$"FFF5 F5FF FFF5 F5F5 FFFF FFF5 F5FF 0000"
	$"0000 FFF5 F5F5 FFF5 F5FF F5F5 F5FF F5F5"
	$"FFF5 F5F5 F5FF F5FF F5F5 F5F5 F5FF 0000"
	$"0000 FFF5 F5F5 FFFF FFFF F5F5 FFF5 F5F5"
	$"FFF5 FFFF FFF5 F5F5 FFF5 F5F5 F5FF 0000"
	$"0000 FFF5 F5FF F5F5 F5FF F5F5 FFF5 F5FF"
	$"F5FF F5F5 FFF5 F5F5 F5FF F5F5 F5FF 0000"
	$"0000 FFF5 F5FF F5F5 F5FF F5F5 FFF5 F5FF"
	$"F5F5 FFFF FFF5 FFFF FFF5 F5F5 F5FF 0000"
	$"0000 FFF5 F5F5 F5F5 F5F5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 F5FF 0000"
	$"0000 FFF5 F5F5 F5F5 F5F5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 F5FF 0000"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"00FF F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 F5F5"
	$"F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 FF00"
	$"0000 FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF 0000"
	$"0000 0000 0000 0000 FFF5 FF00 0000 0000"
	$"00FF F5FF F5FF F5F5 FF00 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 FF00 0000 0000"
	$"00FF F5FF F5FF F5FF 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 FF00 0000 0000"
	$"FFFF F5FF F5FF F5FF 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 FFFF FF00 FFFF"
	$"FFF5 FFF5 F5FF FF00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFFF FFF5 FFFF F5F5"
	$"F5FF F5F5 F5FF 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 F5FF F5F5 F5F5"
	$"FFF5 F5FF FF00 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 FFF5 F5F5 F5F5"
	$"F5F5 FFFF 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFFF F5F5 F5F5 F5F5"
	$"FFFF 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 F5F5 F5F5 FFFF"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 F5F5 F5FF 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFF5 F5F5 F5FF 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 00FF FFFF FFFF FFFF FF00"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 00FF FFFF FFFF FFFF FF00"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 00FF FFFF FFFF FFFF FF00"
};

resource 'icl4' (129, purgeable) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"00FF FFFF FFFF FFFF FFFF FFFF FFFF 0000"
	$"00F0 C0C0 C0C0 C0C0 C0C0 C0C0 C0F0 F000"
	$"00FC 0C0C 0C0C 0C0C 0C0C 0C0C 0CF0 0F00"
	$"00F0 C0C0 F0C0 FFC0 F0C0 C0C0 C0FF FF00"
	$"00FC 0C0C FC0C 0F0C 0C0C 0C0C 0C0C 0F00"
	$"00F0 C0CF CFC0 CFCF F0CF F0C0 FFF0 CF00"
	$"00FC 0CFC 0F0C 0F0C FC0C 0F0F 0C0C 0F00"
	$"00F0 C0FF FFC0 F0C0 F0FF F0C0 F0C0 CF00"
	$"00FC 0F0C 0F0C FC0F 0F0C FC0C 0F0C 0F00"
	$"00F0 CFC0 CFC0 F0CF C0FF F0FF F0C0 CF00"
	$"00FC 0C0C 0C0C 0C0C 0C0C 0C0C 0C0C 0F00"
	$"00F0 C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 CF00"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"0FC0 C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0F0"
	$"00FF FFFF FFFF FFFF FFFF FFFF FFFF FF00"
	$"0000 0000 F0F0 0000 0FCF CFC0 F000 0000"
	$"0000 0000 FCF0 0000 0F0F 0F0F 0000 0000"
	$"0000 0000 F0F0 0000 FFCF CFCF 0000 0000"
	$"0000 0000 FCFF F0FF FCFC 0FF0 0000 0000"
	$"0000 0000 FFF0 FFC0 CFC0 CF00 0000 0000"
	$"0000 0000 FC0F 0C0C FC0F F000 0000 0000"
	$"0000 0000 F0F0 C0C0 C0FF 0000 0000 0000"
	$"0000 0000 FF0C 0C0C FF00 0000 0000 0000"
	$"0000 0000 F0C0 C0FF 0000 0000 0000 0000"
	$"0000 0000 FC0C 0F00 0000 0000 0000 0000"
	$"0000 0000 F0C0 CF00 0000 0000 0000 0000"
	$"0000 000F FFFF FFF0 0000 0000 0000 0000"
	$"0000 000F FFFF FFF0 0000 0000 0000 0000"
	$"0000 000F FFFF FFF0 0000 0000 0000 0000"
};

resource 'ics8' (129, purgeable) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 FFFF FFFF FFFF FFFF FFFF FFFF 0000"
	$"0000 FFF5 F5F5 F5F5 F5F5 F5F5 F5FF FF00"
	$"0000 FFF5 F5FF F5FF F5F5 F5F5 FFFF FF00"
	$"0000 FFF5 FFFF F5FF FFFF FFFF FFF5 FF00"
	$"0000 FFFF F5FF FFF5 FFFF FFFF FFF5 FF00"
	$"0000 FFF5 F5F5 F5F5 F5F5 F5F5 F5F5 FF00"
	$"0000 FFFF FFFF FFFF FFFF FFFF FFFF FF00"
	$"0000 0000 FFF5 FF00 FFF5 FFF5 FF00 0000"
	$"0000 0000 FFF5 FFFF F5FF F5FF 0000 0000"
	$"0000 0000 FFF5 F5F5 F5F5 FF00 0000 0000"
	$"0000 0000 FFF5 F5FF FFFF 0000 0000 0000"
	$"0000 0000 FFF5 F5FF 0000 0000 0000 0000"
	$"0000 0000 FFFF FFFF 0000 0000 0000 0000"
	$"0000 0000 FFFF FFFF 0000 0000 0000 0000"
	$"0000 0000 FFFF FFFF 0000 0000 0000 0000"
};

resource 'ics4' (129, purgeable) {
	$"0000 0000 0000 0000 00FF FFFF FFFF FF00"
	$"00F0 C0C0 C0C0 CFF0 00FC 0F0F 0C0C FFF0"
	$"00F0 FFCF FFFF F0F0 00FF 0FFC FFFF FCF0"
	$"00F0 C0C0 C0C0 C0F0 00FF FFFF FFFF FFF0"
	$"0000 F0F0 F0F0 F000 0000 FCFF 0F0F 0000"
	$"0000 F0C0 C0F0 0000 0000 FC0F FF00 0000"
	$"0000 F0CF 0000 0000 0000 FFFF 0000 0000"
	$"0000 FFFF 0000 0000 0000 FFFF 0000 0000"
};
