/*
	MenuStuff.c
	Version 1.0
	 
	Copyright  1992 Tim Swihart
	All Rights Reserved

	October 17, 1992 (v.1.0)
*/

#pragma load "AliasMeisterDump"

#pragma segment MenuStuff

// External globals:
extern Boolean	gQuitting;

// Function prototypes:
void AdjustMenus(void);
void DoMenuCommand(long menuResult);
static pascal Boolean doKeepCircleDrawn(DialogPtr theDialog, EventRecord *er, short *itemHit);


// The following routines enables & disables our menu items as needed.
void AdjustMenus(void)
{
	MenuHandle	fileMenu, editMenu;

	fileMenu = GetMHandle(mFile);
	editMenu = GetMHandle(mEdit);

	EnableItem(fileMenu, iQuit);

	DisableItem(editMenu, iCut);
	DisableItem(editMenu, iCopy);
	DisableItem(editMenu, iPaste);
	DisableItem(editMenu, iClear);
	DisableItem(editMenu, iUndo);
	DisableItem(editMenu, iSelectAll);
}


// The following routine is responsible for determining which menu item the user selected and what
// should be done about it.  I moved it to its own segment so it wouldn't have to be loaded if we
/// are just creating aliases (i.e.: files were dropped on us to launch us, so this code doesn't
// get called at all).
void DoMenuCommand(long menuResult)
{
	short				menuID;
	short				menuItem;
	Str255				daName;

	menuID = menuResult >> 16;
	menuItem = menuResult & 0x0000ffff;

	switch (menuID) {
		case mApple:
			switch (menuItem) {
				case iAbout:		// display the About box
					//Alert(rAboutBox, 0L);
					Alert(rAboutBox, (ModalFilterProcPtr) doKeepCircleDrawn);
					break;
				default:			// handle DA selection
					GetItem(GetMHandle(mApple), menuItem, daName);
					OpenDeskAcc(daName);
					break;
			}
			break;
		case mFile:
			switch (menuItem) {
				case iQuit:
					gQuitting = true;
					break;
			}
			break;
		case mEdit:
			break;
	}
	HiliteMenu(0);
}


// The following routine is a filter proc for our alerts.  Its sole purpose is to redraw the
// bold circle around the default button during update events.
pascal Boolean doKeepCircleDrawn(DialogPtr theDialog, EventRecord *theEvent, short *itemHit)
{
	short			itemType;
	Boolean			handledEvt = false;
	char			key;
	Handle			itemHndl;
	Rect			itemRect;
	long			curTickCount;
	
	switch (theEvent->what) {
		case updateEvt:
			GetDItem(theDialog, ok, &itemType, &itemHndl, &itemRect);	// get 'OK' btn's rect
			PenSize(3,3);												// use a fat pen tip
			InsetRect(&itemRect, -4, -4 );								// widen rect a little
			FrameRoundRect(&itemRect,16,16);							// draw the stupid outline
			break;
		case keyDown:
			key = theEvent->message & charCodeMask;
			if ((key == 13) || (key ==3)) {	// map RETURN and ENTER into hits on default btn
				// hilite the default btn so the user knows why the alert suddenly goes away
				GetDItem(theDialog, ok, &itemType, &itemHndl, &itemRect);	// get 'OK' btn's hndl
				HiliteControl((ControlHandle)itemHndl,inButton);	// hilite the OK btn
				Delay(5L, &curTickCount);	// make sure user sees the hilited btn
				HiliteControl((ControlHandle)itemHndl,0);	// unhilite the OK btn
				handledEvt = true;	// makes Alert go away
			}
			break;
	} // end of: switch (theEvent->what)
	return(handledEvt);
}
