/*--------------------------------
#
#	TouchDirectory.c
#	Version 1.0
#
----------------------------------*/

// Function prototypes:
OSErr TouchDirectory(short vRefNum, long dirID);

// The following routine sets the date/time stamp of the selected folder to
// the current date/time.  This was originally done as part of an attempt to force the Finder
// into re-reading the BNDL information for the banged application, but it didn't work (the
// Finder ignores the fact that the folder's date/time stamp changed and continues to use
// stale data

    OSErr TouchDirectory(short vRefNum, long dirID)
    {
        CInfoPBRec  info;
        Str63       name;
        OSErr       err;
    
        info.dirInfo.ioDrDirID = dirID;
        info.dirInfo.ioVRefNum = vRefNum;
        info.dirInfo.ioNamePtr = name;
        info.dirInfo.ioFDirIndex = -1;
     
        err = PBGetCatInfoSync(&info);
        if (err == noErr) {
            info.dirInfo.ioCompletion = 0;
            info.dirInfo.ioDrDirID = info.dirInfo.ioDrParID;
            info.dirInfo.ioFDirIndex = 0;
            GetDateTime(&info.dirInfo.ioDrMdDat);
            err = PBSetCatInfoSync(&info);
        }
    
        return (err);
    }



