/* PSDSetup.c */
/* Copyright 1992, Gary D. McGath */



extern pascal void psdRectProc(GrafVerb verb, Rect *theRect);
extern pascal psdTextProc(short byteCount, Ptr textBuf, Point numer, Point denom);
extern pascal psdLineProc(Point newPt);
extern pascal psdOvalProc(GrafVerb verb, Rect *theRect);
extern pascal psdrRectProc(GrafVerb verb, Rect *theRect, short ovalwidth, 
				short ovalheight);
extern pascal psdArcProc(GrafVerb verb, Rect *theRect, short startAngle, short arcAngle);
extern pascal psdPolyProc(GrafVerb verb, PolyHandle thePoly);
extern pascal psdBitsProc(BitMap *srcBits, Rect *srcRect, Rect *dstRect, short mode,
				RgnHandle maskRgn);

void psdSetupProcs(GrafPtr itsPort);
pascal psdCommentProc(short kind, short dataSize, Handle dataHandle);
pascal psdRgnProc(GrafVerb verb, RgnHandle theRgn);

/* Create a CGrafPort to draw to, and set up the bottleneck procedures */
void psdSetupProcs(GrafPtr itsPort)
{
	QDProcsPtr psdProcs;
	psdProcs = (QDProcsPtr) NewPtr(sizeof(QDProcs));
	itsPort->grafProcs = psdProcs;
	SetStdProcs(psdProcs);
	psdProcs->textProc = (Ptr) psdTextProc;
	psdProcs->lineProc = (Ptr) psdLineProc;
	psdProcs->rectProc = (Ptr) psdRectProc;
	psdProcs->rRectProc = (Ptr) psdrRectProc;
	psdProcs->ovalProc = (Ptr) psdOvalProc;
	psdProcs->arcProc = (Ptr) psdArcProc;
	psdProcs->polyProc = (Ptr) psdPolyProc;
	psdProcs->rgnProc = (Ptr) psdRgnProc;
	psdProcs->bitsProc = (Ptr) psdBitsProc;
	psdProcs->commentProc = (Ptr) psdCommentProc;
}


/* PicComments aren't handled in this program */
pascal psdCommentProc(short kind, short dataSize, Handle dataHandle)
{
}

/* Neither are regions */
pascal psdRgnProc(GrafVerb verb, RgnHandle theRgn) 
{
}
