	program PublishDemo
	integer*2	Error,F_SendEvent
	external	F_SendEvent
	external	doPublish,doExit
	
	call moveoutwindow(20,40,300,300)
	call addmenuitem('Publish','Publish Sine',doSine)
	call addmenuitem('Publish','Publish Exp',doExp)

	write(*,*)
	write(*,*) 'Opening Application  Excel'
	write(*,*)
	write(*,*) 'Opening SinExpTable'
	Error = F_SendEvent('odoc','Microsoft Excel','SinExpTable')
	call checkError(Error)

	write(*,*)
	write(*,*) 'Opening SinExpChart'
	Error = F_SendEvent('odoc','Microsoft Excel','SinExpChart')
	call checkError(Error)

	write(*,*)
	write(*,*) 'Use the Publish menu to update the Excel chart.'
	
	call SetExitProc(doExit)
	end
	
	
	subroutine checkError(Error)
	integer*2	Error
	character*5	ch5
	if (Error <> 0) then
		write(ch5,'(i5)') Error
		call alertbox('Error '//ch5//' occurred.')
		write(*,*) 'Error '//ch5//' occurred.'
		stop
	end if
	end
	
!!mp inlines.f
	subroutine doSine
	real		sintab(100),period
	parameter (twopi = 6.283185)
	
	type *,"Enter period of sine in steps: "
	accept *,period
	do j = 1,100
		sintab(j) = sin(twopi*j/period)
	end do
	
	open(10,file='SinData')
	write(10,100) sintab
	close(10,status='Publish')
	
100	format(x,f10.2)
	end

	subroutine doExp
	real		exptab(100),period
	
	type *,"Enter decay period in steps: "
	accept *,period
	do j = 1,100
		exptab(j) = exp(-j/period)
	end do
	
	open(10,file='expData')
	write(10,100) exptab
	close(10,status='Publish')
	
100	format(x,f10.2)
	end

	subroutine doExit()
	integer*2	Error,F_SendEvent
	external	F_SendEvent

	Error = F_SendEvent('quit','Microsoft Excel','')
	call checkError(Error)
	end
	