unit PictPack;

interface

	uses
		SANE, Access0, Palettes, PictUtil;

	procedure main (ProcNum: Longint; PtrList: PackageVariablesPtr; var Data: handle; var FuncPtr: PackRetParam);


implementation
	procedure readPict (var thePic: Handle; var theerr: integer);
	FORWARD;
	procedure savePict (var pic: PicHandle; var creator: str255; var err: integer);
	FORWARD;
	procedure ReturnPictInfo (var thePictHandle: PicHandle; var length, width, depth: integer; var colors, size: longint);
	FORWARD;

	procedure main (ProcNum: Longint; PtrList: PackageVariablesPtr; var Data: handle; var FuncPtr: PackRetParam);
		var
			thePic: Handle;
			Blk4D: ParmBlock;
			staticResNum: integer;
			theerr: OSErr;
			myVarRec: VarRec;

	begin
		case ProcNum of
			-1: 
				begin	{ Init - I'm not allocating any memory}
				end;

			-2: 
				begin	{ deInit }
				end;

			1: {read a Pict}
				begin
					PtrList^[2].I^ := noErr;
					thePic := nil;
					ReadPict(thePic, PtrList^[2].I^);
					if PtrList^[2].I^ = noErr then  {save the picture into a 4D field}
						begin
							myVarRec.varKind := PICT;
							myVarRec.picSize := GetHandleSize(thePic);
							myVarRec.PP := PicHandle(thePic);
							Blk4D.Name := PtrList^[1].S^;
							Blk4D.HH := @myVarRec;
							Blk4D.ClearOldVariable := true;
							Call4D(EX_PUT_VARIABLE, Blk4D);
							PtrList^[2].I^ := Blk4D.error;
						end;
				end;

			2: {save a Pict}
				begin
					if GetHandleSize(handle(PtrList^[1].P^)) <= 0 then
						PtrList^[4].I^ := -1
					else
						SavePict(PtrList^[1].P^, PtrList^[2].S^, PtrList^[3].I^);
				end;

			3: 
				ReturnPictInfo(PtrList^[1].P^, PtrList^[2].I^, PtrList^[3].I^, PtrList^[4].I^, PtrList^[5].L^, PtrList^[6].L^);

		end;	{case ProcNum}
	end;

	procedure readPict (var thePic: Handle; var theErr: integer);
		var
			reply: StandardFileReply;
			theTypeList: SFTypeList;
			thePicFile: integer;
			bytes, t: longint;
			myPicEnd: PicEnd;
			err: integer;

	begin
		theTypeList[0] := 'PICT';
		StandardGetFile(nil, 1, theTypeList, reply);
		if not (reply.sfGood) then
			theErr := -1
		else
			begin
				theErr := FSPOpenDF(reply.sfFile, fsCurPerm, thePicFile);
				if theErr = noErr then
					begin
						theErr := GetEOF(thePicFile, bytes);
						bytes := bytes - 512;
						t := compactMem(bytes + 6);{need to leave 6 bytes for 4D's PicEnd}
						thePic := NewHandle(bytes + 6);
						if thePic = nil then
							theErr := memError
						else
							begin
								Hlock(thePic);
								theErr := SetFPos(thePicFile, 1, 512);
								theErr := FSRead(thePicFile, bytes, thePic^);
								with myPicEnd do  {put on the 4D picEnd record}
									begin
										origin.h := 0;
										origin.v := 0;
										transfer := srcCopy;
									end;
								BlockMove(@myPicEnd, Ptr(ord(thePic^) + GetHandleSize(thePic) - 6), 6);
								HUnLock(thePic);
							end;
						err := FSClose(thePicFile);
					end;
			end;
	end;

	procedure savePict (var pic: PicHandle; var creator: str255; var err: integer);
		var
			theErr: OSErr;
			p: PTR;
			newFileRefNum: integer;
			picSize: longint;
			c: OSType;

			count: longint;
			reply: StandardFileReply;
	begin
		if pic <> nil then
			begin
				StandardPutFile('Save a PICT file', 'PICT from 4D', reply);
				if (reply.sfGood) then
					begin
						theErr := FSpDelete(reply.sfFile); {If the file already exists, replace it}
						if length(creator) = 4 then
							begin
								BlockMove(@creator[1], @c, 4);
								err := FSpCreate(reply.sfFile, c, 'PICT', reply.sfScript);
							end
						else
							err := FSpCreate(reply.sfFile, 'SPNT', 'PICT', reply.sfScript);
						if err = noErr then
							begin
								err := FSpOpenDF(reply.sfFile, fsRdWrPerm, newFileRefNum);
								if err = noErr then
									begin
										p := NewPtrClear(512);
										if p = nil then
											err := MemError
										else
											begin
												count := 512;
												err := FSWrite(newFileRefNum, count, p);
												if err = noErr then
													begin
														count := GetHandleSize(Handle(pic)) - 6; {Take off 6 bytes for the picEnd}
														err := FSWrite(newFileRefNum, count, ptr(ord(pic^)));
													end;
												DisposPtr(p);
											end;
										err := FSClose(newFileRefNum);
									end;
							end; {NoErr on FSpCreate}
					end;
			end;
	end;

	procedure ReturnPictInfo (var thePictHandle: PicHandle; var length, width, depth: integer; var colors, size: longint);
		var
			thePictInfo: PictInfo;
			saveHandleState: integer;
			theErr: OSErr;
	begin
		saveHandleState := HGetState(Handle(thePictHandle));  {save the original state}

		HLock(Handle(thePictHandle));  {GetPictInfo can move memory}
		theErr := GetPictInfo(thePictHandle, thePictInfo, returnColorTable, 1, systemMethod, 0);

		if theErr = noErr then
			begin
				if thePictInfo.theColorTable <> nil then
					DisposHandle(Handle(thePictInfo.theColorTable));
				width := thePictInfo.sourceRect.right - thePictInfo.sourceRect.left;
				length := thePictInfo.sourceRect.bottom - thePictInfo.sourceRect.top;
				depth := thePictInfo.depth;
				colors := thePictInfo.uniqueColors;
			end;
		size := GetHandleSize(handle(thePictHandle));
		HSetState(Handle(thePictHandle), saveHandleState);
	end;

end.