      Program JLDemo
      External CreatePlot
      INTEGER maxContourX, maxContourY
      REAL XYZdata(31,31)
      integer contourColors(128)
      Common /theData/ XYZdata, contourcolors 

!	Initialize TSI Graphics
      Call InitGraphicsPackage()

!	Create data and load into XYZdata array
      CALL createData(XYZdata)

!	Change Output window 
	  Call SetOutputGraphWindowSize (20,20,600,300)
	  
!	Create a graphics window and hook up our subroutine
      Call DrawInNewWindow(CreatePlot)

!	Move the FORTRAN text window off-screen
      Call MoveOutWindow(10,800,200,900)

!	Exit and let the FORTRAN menus take over
      End
	  
	  

      Subroutine CreatePlot
	  include 'tsiconstants.fi'
      INTEGER i
      REAL XYZdata(31,31)
      integer contourColors(128)
      Common /theData/ XYZdata, contourcolors 

!	Set the contour colors
      DO i = 1, 128
        contourColors(i) = mod(i, 7)
      END DO


!	Define two plot windows for the contour plot and the 3D plot
      CALL SetPercentPlotRegion(1, 0.02,0.05, 0.48,0.95)
      CALL SetPercentPlotRegion(2, 0.52,0.05, 0.97,0.95)

!	3D mesh plot
      CALL ChangePlotRegion(1)
      CALL SetPlotRatio(1, 0.1, 0.1, 0.1, 0.1)

!	Set the size of the viewing rectangle
      Call Set3DViewingRect(-10.0,-10.0,10.0,10.0)

!	Set the view point location
      Call Set3DEyePosition(15.0, 7.5, -10.0)

!	Create the plot using a blue outline and yellow fill
      Call SetColor(blue)
      Call MeshPlot(XYZdata, 31, 31, -15., -15., 1.0, 1.0, yellow)

!       Switch to black and label the mesh using 18pt Palatino Bold-Italic
      Call SetColor(black)
      Call SetTextStyle('Palatino', 1+2, 0, 12)
      Call LabelGraph(500.0, 900.0, 'exp(r/5)sin(r/2)cos(2*phi)', 1, 0)

!	Select region for the contour plot
      CALL ChangePlotRegion(2)
      CALL SetPlotRatio(2, 0.1, 0.1, 0.1, 0.1)

!	Set plotting range scale 
      CALL SetXYPlottingRange( -15.0, -15.0, 15.0, 15.0)

!	Change to black and draw axes
      CALL SetColor(black)

!	Manually draw and label the lower pair of axes
      CALL SetXYIntercepts(-15.0,-15.0)
      CALL DrawYAxis(0.5,1)
      CALL LabelYAxis(10, 1)
      CALL DrawXAxis(0.5,1)
      CALL LabelXAxis(10,1)

!	Manually draw and label the upper pair of axes
      CALL SetXYIntercepts(15.0,15.0)
      CALL DrawYAxis(0.5,0)
      CALL LabelYAxis(10,0)
      CALL DrawXAxis(0.5,0)
      CALL LabelXAxis(10,0)

!	Border the plot area
      CALL BorderPlotRegion(black)
	  
!	Plot the data
      CALL ContourPlot(XYZdata,31,31,-15.0,-15.0, 1.0,1.0, 1.0,contourColors)

      Return
      END


      SUBROUTINE CreateData(XYZdata)
      INTEGER i,j
      REAL x,y,z,r
      REAL XYZdata(31,31)

!	The subroutine for creating the data
      DO i = 1, 31
         x = REAL(i-16)
         DO j = 1, 31
             y = REAL(j-16)
			 r = sqrt(x*x+y*y)
             z = 10.0 * exp (-r/5.) * sin(r/2.) *  cos(2.*atan2(x,y)) 
             XYZdata(i,j) = z
         END DO
      END DO
      END

