//----------------------------------------------------------------------------------------
// Demo.r 
// Copyright  1992 by William L. Colsher  All rights reserved.
//----------------------------------------------------------------------------------------


// Standard Includes 

#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __SYSTYPES.R__
#include "SysTypes.r"
#endif

#ifndef __BalloonTypes__
#include "BalloonTypes.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif

#if qDebug
include "Debug.rsrc" not 'ckid';
#endif

include "MacApp.rsrc" not 'ckid';

// Includes for Building Blocks

include "Dialog.rsrc" not 'ckid';

// Include Code Resources

include $$Shell("ObjApp")$$Shell("XAppName") 'CODE';

//--------------------------------------------------------------------------------------------------
// CONSTANTS 
//--------------------------------------------------------------------------------------------------

// Finder Information
// ------------------

#define kApplicationName	$$Shell("XAppName")
#define kSignature			'DEMO'			// Application signature 
#define kFileType			'PROJ'			// Data file type 


// Bundle Constants
// ------------------

#define kBundleID						128
#define kApplicationID					128
#define kDocumentID						129


// Text styles
// --------------

#define kSystemTextStyle				1000

// 'View' resources
// --------------

include "DemoViews.rsrc" not 'ckid';

// Memory Management Resources
// ---------------------------

#define kDemoSeg	1000
#define kDemoMem	1000
#define kDemoRes	1000

//--------------------------------------------------------------------------------------------------
// RESOURCES FOR MENUS 
//--------------------------------------------------------------------------------------------------

include "Defaults.rsrc" 'CMNU' (mApple);	// Grab the default Apple menus
include "Defaults.rsrc" 'CMNU' (mFile);
include "Defaults.rsrc" 'CMNU' (mEdit);


//--------------------------------------------------------------------------------------------------
// Menu Bars 
//--------------------------------------------------------------------------------------------------

resource 'MBAR' (kMBarDisplayed,
#if qNames
kApplicationName,
#endif
	purgeable) {
	{ mApple; mFile; mEdit; }
};


//--------------------------------------------------------------------------------------------------
// About Box
//--------------------------------------------------------------------------------------------------
 
resource 'DITL' (phAboutApp,
#if qNames
"phAboutApp",
#endif
	purgeable) {
	 {	/* array DITLarray: 3 elements */
		/* [1] */
		{160, 182, 180, 262},
		Button {
			enabled,
			"OK"
		};
		/* [2] */
		{10, 75, 150, 316},
		StaticText {
			disabled,
			"TReportPrinter Demo Application."
			"\n\nThis program was written "
			"with MacApp  1985-1991 Apple Computer, Inc."
		};
		/* [3] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			1
		}
	}
};

include "Defaults.rsrc"  'ALRT' (phAboutApp);	// Grab the default about box

//--------------------------------------------------------------------------------------------------
// MultiFinder information
//--------------------------------------------------------------------------------------------------

resource 'SIZE' (-1) {
	saveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	doesActivateOnFGSwitch,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreAppDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,				
	reserved,
	reserved,
	reserved,
	reserved,
#if qModelFarCode
	575 * 1024,
	550 * 1024,
#elif qDebug
	500 * 1024,
	475 * 1024
#else
	350 * 1024,
	325 * 1024
#endif
};

//--------------------------------------------------------------------------------------------------
//  Version resources
//--------------------------------------------------------------------------------------------------

// The revision of this particular file

RESOURCE 'vers' (1,
#if qNames
"File Version",
#endif
	purgeable) {
	0x01,
	0x00,
	beta,
	0x0A,
	verUs,
	"1.0",
	"TReportPrinter Demo Application, William L. Colsher 1992"
};
include "Defaults.rsrc"  'vers' (2);		// Overall package

resource 'mem!' (kDemoMem,
#if qNames
	"Additional Memory Requirements",
#endif
	purgeable) {
	16 * 1024,				// Add to temporary reserve
	32 * 1024,				// Add to permanent reserve
	0						// Add to stack space
};
