#ifndef __REPORTPRINTER__
#define __REPORTPRINTER__ 1
#include <Printing.h>

const	short	kStatusWindowView = 2000;
const	IDType	kDocumentNameID = 'VW08';

class TReportStatusWindow;

class TReportPrinter: public TObject {
  private:
  	Boolean	fPrintManagerIsOpen;
  public:
  	CStr255	fCurrentFontName;
	short	fCurrentFontNumber;
	
	long	fMaxSpoolLines;
	long	fPrintedLines;

	
	short	fCurrentFace;
	short	fCurrentSize;
	short	fLeftMargin;
	short	fBottomOfPage;
	Boolean	fAutoFormFeed;
	Boolean	fUserAborted;
	
  	TPPrPort	fPrintingPort;	// a pointer
	THPrint		fPrintRecord;	// a handle
	
	TReportStatusWindow 	*fMyStatusWindow;
  
  	short		fCurrentPage;
	CStr255		fReportTitle;

  	virtual pascal void 	IReportPrinter(CStr255 theFont, short theFace, short theSize, 
											short leftMargin, short bottomOfPage,
											Boolean autoFormFeed);
	virtual pascal void		DoPrOpen(void);
	virtual pascal void		DoPrClose(void);
	virtual pascal void		SetFont(CStr255 theFont);
	virtual pascal void		SetFace(short theFace);
	virtual pascal void		SetSize(short theSize);
	virtual pascal Boolean 	StartReport(CommandNumber aCmdNumber);
	virtual pascal Boolean 	PrintALine(const CStr255 theLine, Boolean doLineFeed);
	virtual pascal void 	DoFormFeed(void);
	virtual pascal Boolean	DoOpenPage(void);
	virtual pascal void		DoClosePage(void);
	virtual pascal void		VerticalTab(short pixels);
	virtual pascal void		EndReport(void);
	virtual pascal Boolean	HandlePageSetup(void);
	virtual pascal void		PrintHeader(void);
	virtual pascal void		PrintFooter(void);
 	virtual pascal void		Free(void);
	virtual pascal unsigned long GetFreeSpaceOnDisk(int theVolume);
	virtual pascal void		UserAbort(void);
	virtual pascal void		SetDocumentName(CStr255 docName);
};

class	TReportStatusWindow: public TWindow {
  public:
	virtual pascal void IReportStatusWindow(TReportPrinter *myPrinter);
	virtual pascal void DoCommandKeyEvent(TToolboxEvent* event);
	virtual pascal void SetMessage(CStr255 theMessage);
  private:
  	TReportPrinter *fMyPrinter;
};

#endif