/**************************************************************
 "CQuickTime.h"

 by:	Apple Inc.,
 		as distributed on their "QuickTime" CD ROM disk
 
 converted to OOP by:		John A. Love, III
 							using Symantec's "THINK C", v 5.0.2
 **************************************************************/




#define _H_CQuickTime

#include <Commands.h>
#include <CClipboard.h>
#include <CDLOGDirector.h>
#include <CDocument.h>
#include <CFWDesktop.h>
#include <CIconPane.h>
#include <CPane.h>
#include <CResFile.h>
#include <CTask.h>
#include <Movies.h>


// General stuff:
#define mcHandledEvent					1
#define specifiedByRefNumAndFileName	0
#define maxMilliSecToUse				0
#define noMoovFile						0		// IResFile sets CResFile::refNum = 0.
#define noMoovResource					0		// An added instance variable.
#define kGeneralQuickTimeMemoryError	-9999
#define KeyShift						0x38

// File Menu:
#define cmdCloseMovie					cmdClose
#define cmdSaveMovie					cmdSave
#define cmdSaveAsMovie					cmdSaveAs

// Movie Menu:
#define cmdPlayForward					1026
#define cmdPlayBackward					1027
#define cmdGoToBeginning				1028
#define cmdGoToEnd						1029
#define cmdGoToFrameNumber				1030
#define cmdSelectFrames					1031
#define cmdDeselectFrames				1032
/* ----- */
#define	kSelectFrames					3000	/* My DLOGs */
#define	kGoToFrame						3001



class CMovie;				// Circular references to follow ...
class CMovieFile;
class CMovieEditTask;


class CMovieDesktop : public CFWDesktop		{

public:

			void				IMovieDesktop (CBureaucrat *aSupervisor);
	virtual void				DispatchCursor (Point where, RgnHandle mouseRgn);

};	/* CMovieDesktop */


class CMovieClip : public CClipboard	{

public:

	virtual void				DeactivateWind (CWindow *theWindow);

};	/* CMovieClip */


class CMovieDLOGDir : public CDLOGDirector		{

public:

			void				IMovieDLOGDir (short dlogID);
	virtual void				DoKeyDown (char theChar, Byte keyCode,
										   EventRecord *macEvent);
	virtual void				DoCommand (long aCmd);
	
};	/* CMovieDLOGDir */


class CQuickTime : public CDocument		{

public:

	 // CMovieFile		*itsMovieFile;  =  CDocument::itsFile
		CMovie			*itsMovie;
		Movie			savedMovie;


			void				INoQuickTime (short DLOGid,
											  CApplication *itsSupervisor);
	virtual void				DisplayNoQuickTime (void);
	
			void				IQuickTime (CApplication *itsSupervisor);
			void				INewQuickTime (CApplication *itsSupervisor);
	virtual void				DisplayQuickTime (void);
	
	virtual void				ClearQuickTime (void);
	virtual void				Dispose (void);

	virtual void				UpdateMenus (void);
	
	virtual void				DoCommand (long theCommand);
	virtual Boolean				DoSave (void);
	virtual Boolean				DoSaveAs (SFReply *macSFReply);
	virtual void				PickFileName (SFReply *macSFReply);
	virtual Boolean				ConfirmClose (Boolean quitting);
		
	virtual void				NewFile (void);
	virtual void				OpenMoovFile (SFReply *macSFReply);
	virtual void				SetMovieFile (CMovieFile *movieFile);
	virtual CMovieFile			*GetMovieFile (void);
	
	virtual void				DoRevert (void);

};	/* CQuickTime */


class CMovie : public CPane		{

public:

		Movie				moov;
		MovieController		mc;
		CMovieEditTask		*lastMovieEditTask;				// CDocument::lastTask
		static short		cFirstMovieEditTaskIndex;
		
		
			void				IMovie (CView *anEnclosure, CBureaucrat *aSupervisor);
	
	virtual void				NeewMovie (void);
	virtual void				OpenMovie (SFReply *macSFReply);
	virtual Movie				GetMovie (void);
	
	virtual void				NeewController (void);
	virtual void				OpenController (void);
	virtual MovieController		GetController (void);
	
	virtual short				GetMoovRefNum (void);

	virtual void				PrepCombinedMovieAndController (void);
	
	virtual void				PlayMovie (void);
	
	virtual void				DisposMoovie (void);
	virtual void				DisposController (void);
	
	virtual ComponentResult		SetUpFilter (Boolean which);
	virtual ComponentResult		ShowBadge (Boolean doShow);
	virtual ComponentResult		EnableKeys (Boolean doEnable);

	virtual void				Activate (void);
	virtual void				Deactivate (void);
	virtual void				Draw (Rect *area);
	virtual void				DoClick (Point hitPt, short modifierKeys, long when);
	virtual void				DoKeyDown (char theChar, Byte keyCode,
										   EventRecord *macEvent);
										   
	virtual void				Dawdle (long *maxSleep);
	virtual void				DispatchCursor (Point where, RgnHandle mouseRgn);
	virtual void				AdjustCursor (Point where, RgnHandle mouseRgn);
	
	virtual void				UpdateMenus (void);

	virtual void				SetSelection (long theCommand);
	virtual void				ClearSelection (void);
	virtual void				DoCommand (long theCommand);
	
	virtual void				MakeMovieEditTask (long theCommand);
	
};	/* CMovie */


class CMovieFile : public CResFile		{

public:

	 // short		moovRefNum;		=  CResFile::refNum
		short		resID;			/* ID of Movie resource 'moov' */
		CMovie		*theMovie;		/* Used by CreateNew and Update */
		
		
			void	IMovieFile (void);
			
	virtual void	CreateNew (OSType creator, OSType fType);
	
	virtual void	Open (SignedByte permission);
	virtual void	Close (void);
	virtual void	ThrowOut (void);
	
	virtual void	ChangeName (Str63 newName);

	virtual void	Update (void);
	
	virtual void	ResolveFileAlias (void);

};	/* CMovieFile */


class CMovieEditTask : public CTask		{

protected:

		Movie		originalMoov, newMoov, originalScrap, newScrap;
	 /*
	 ** It turns out that MCUndo interchanges
	 ** the old and the new Movie Selections.
	 	
		TimeValue	originalTime, originalDuration;
	 */
		CMovie		*editedMoviePane;
		long		editCmd;

public:
		
			void	IMovieEditTask (CMovie *thisMoviePane, long theCommand,
									short firstTaskIndex);
	virtual void	Do (void);
	virtual void	Undo (void);
 // virtual void	Redo (void);	--		just calls Undo
 
	virtual void	Dispose (void);
	
};	/* CMovieEditTask */


/****************************************************************

 adapted from procedural C code by:
 
	Edgar Lee [Developer Technical Support, Apple Computer, Inc.]
	as distributed on the "QuickTime" CD ROM disk

 ****************************************************************/
 
 
enum					// IDs of 'ICON' & 'cicn' resources that depict the "Buttons":
{
	kDimLight = 815,	// The two states ...
	kLightLight,
	kEject = 801,
	kLoad,
	kPower,
	kPause,
	kStop,
	kPlayBackward,
	kPlayForward,
	kGoToStart,
	kStepBackward,
	kStepForward,
	kGoToEnd,
	kVolumeDown,
	kVolumeUp,
	kLogo
};


class CRemote : public CDocument	{

public:

			void	IRemote (CApplication *itsSupervisor);
	virtual void	Dispose (void);
	virtual void	DoCommand (long theCommand);
	
};	/* CRemote */


class CRemoteMainPane : public CPane	{			/* = CRemote->itsMainPane */

public:

	/* Blackens the window's portRect and draws the titles of all the
	** "Buttons" as well as my QuickTime icon + a string at the bottom: */
	
	virtual void	Draw (Rect *area);

	/* See comments within the Method: */
	
	virtual void	ShowHelpBalloon (struct HMMessageRecord *helpData, Point tip,
									 RectPtr altRect, Ptr tipProc, short theProc,
									 short variant, short method);
	
};	/* CRemoteMainPane */


/* Most of the "Button" sub-panes are of class = CIconPane.
** As such, drawing these panes is handled by the TCL.
** Therefore, no overriding is required for drawing.
** However, because I wish to light up a "Light" every time
** I click on one of the other panes, I need to override
** the "DoClick" method.  In addition, there are four(4)
** panes which should execute their associated commands
** continuously while the mouse is down.  For these, I also
** override the "Track" method.								*/

class CRemoteIconPane : public CIconPane	{

public:

			CIconHandle		GetCICN (void);		// To access the protected variable.
			void			SetCICN (CIconHandle theCICN);
	virtual void			DoClick (Point hitPt, short modifierKeys, long when);

};	/* CRemoteIconPane */


class CRemoteScrollPane : public CRemoteIconPane	{

public:

	virtual Boolean		Track (void);
	
};	/* CRemoteScrollPane */


/* Speaking of a light, normally you'd call SetWantsClicks(FALSE)
** for its CPane.  However, then the TCL will not display a Help
** Balloon.  Furthermore, CView::FindSubView and CView::FindViewByID
** will then return NULL.  I consider this a big-time deficiency.
** The work-around is to declare a special CIconPane class with an
** empty DoClick method:											*/

class CRemoteNullClickPane : public CRemoteIconPane		{

public:

	virtual void	DoClick (Point hitPt, short modifierKeys, long when);

};	/* CRemoteNullClickPane */


// Save NON-Class routines for last:

	   Boolean		QuickTimeIsInstalled (void);
	   void			ConvertOldToNew (SFReply *oldSF, StandardFileReply *newSF);




/*	{ end file "CQuickTime.h" }  */
