/*********************************************************
 "CSpinner.h"

 by John A. Love, III [Washington Apple Pi Users' Group]

 using Symantec's "THINK C", v 5.0.2
 ... as derived from Gregory H. Dow's CSpinner Class
 ... [THINKin' CaP, Winter 1991]
 *********************************************************/




#define	_H_CSpinner


#include <CObject.h>		/* Superclass */
#include <Global.h>
#include <Retrace.h>


#define	acurWorld	128
#define	acurDogCow	129

typedef	struct	MyVBLType	{
	long			CurrA5;				// Lost & Found !!
	VBLTask			MyVBLTask;			// The actual VBL Task.
}	MyVBLType;

typedef	struct	acurType	{			// Poetry in motion !!
	short			nbrCursors;
	short			frameCounter;
	long			cursorIDs[];		// ... in High word.
}	acurType, *acurPtr, **acurHandle;


struct CSpinner : CObject {

	acurHandle		acurHdl;			/* Handle to 'acur' resource. */
	MyVBLType		myVBLRec;
	short			interval;			/* Tick delay between spins.  */
	short			whichCursor;

	void			ISpinner (short acurID, short delay);
	void			Dispose (void);
};




/* end: "CSpinner.h" */
