/**************************************************
 "dissMask.h"

 by:	Michael S. Morton [MacTutor, December 1990]
 **************************************************/




typedef struct		{
	BitMap			maskMap;			// passed to _CopyMask ...
	Rect			maskRect;
	unsigned long	pixLeft;			// # of bits remaining to copy.
	unsigned long	seqElement;			// current element of sequence.
	unsigned long	seqMask;			// mask used to generate sequence.
} dissMaskInfo;


// Prototypes:

Boolean		dissMaskInit (Rect *srcRect, register dissMaskInfo *info);
void		dissMaskNext (register dissMaskInfo *info, unsigned long steps);
void		dissMaskFinish (register dissMaskInfo *info);
void		dissolve (BitMap *srcBits, BitMap *dstBits,
					  Rect *srcRect, Rect *dstRect, unsigned short steps);



/*	{ end file "dissMask.h" }  */
