/*********************************************************
 "help.c"

 by John A. Love, III [Washington Apple Pi Users' Group]

 using Symantec's "THINK C", v 5.0.2
 *********************************************************/


#include <GestaltEqu.h>
#include <OSChecks.h>
#include <Traps.h>

#include "CmyGlobals.h"
#include "help.h"


		
Boolean HelpManagerActive (void)	{
 /* Do we have a machine on which the Help Manager exists ??? */

		short		_Gestalt = 0xA1AD;
		long		myFeature;
		Boolean		result;


	result = false;
	;
	if (TrapAvailable(_Gestalt))	{
		if (Gestalt(gestaltHelpMgrAttr, &myFeature) == noErr)	{
			if (BitTst(&myFeature, 31 - gestaltHelpMgrPresent))	result = true;
		}
	}

	return(result);
	
}	/* HelpManagerActive */



Boolean BalloonsOn (void)	{
/* Has the user selected "Show Balloons" ??? */

	return(HelpManagerActive() && HMGetBalloons());

}	/* BalloonsOn */



Boolean BalloonShowing (void)	{
/* Is a Balloon currently showing ??? */

	return(HelpManagerActive() && HMIsBalloon());

}	/* BalloonShowing */



void HideBalloons (Boolean balloonsUp)	{

		OSErr	soWhat;


	if (balloonsUp)	{
		/* Get the daggum monster out of the way !! */
		/* Used "hmSaveBitsNoWindow option" so bits */
		/* are restored withOUT an update Event.    */
		if (BalloonShowing())	soWhat = HMRemoveBalloon();
				
		/* Okay, I've restored the bits.  However, now   */
		/* I've got to temporarily disable Balloon Help  */
		/* until I leave with a Mouse Up Event or finish */
		/* with whatever:                                */
		soWhat = HMSetBalloons(false);
		;
		gLastBalloon = -1;
	}	/* "Show Balloons" active */

}	/* HideBalloons */


void ShowBalloons (Boolean balloonsUp)	{
/* NOW !!! I can safely re-enable Balloon Help: */

		OSErr	soWhat;


	if (balloonsUp)	soWhat = HMSetBalloons(true);

}	/* ShowBalloons */



void ResetBalloons (Boolean balloonsUp)	{

	if (balloonsUp)	ShowBalloons(true);
	else			HideBalloons(HelpManagerActive());

}	/* ResetBalloons */




/*	{ end file "help.c" }  */
