	prtr	"/E/$45"		; ImageWriter set to Elite.
	name	rotAsmLib
 	title	"$"			; Date in Page's Header.
	terse				; Optional.
         	 
	 
; "rotAsm.asm"
; -- contains two external routines for my "rotAsm.Lib":
;
; #1) "RotateBits.asm"
;     -- a routine originally designed to rotate text 90-degrees CCW on the screen
;
;     Written in 68000 Code by John D. Olsen [MacTutor (Feb 88)]
;     and optimized by Mike Morton [MacTutor (Nov 88)]
;
; ********************
;
; #2) "DissBits.asm"
;     -- a routine to create a Dissolve-effect on the screen
;     -- alias "My kingdom for another Register !!"
;
;    I know this blasted routine works, but ...
;    ... in 3 novels or less, PLEASE tell me WHY ?*!!?
;    ... { "just because" is NOT an acceptable reply }
;
;    Written in 68000 Code by Mike Morton [MacTutor (Dec 85)]
;
; ********************
;
; Converted to color (we hope!!) by
; John A. Love, III [Washington Apple Pi Users' Group]
;
; [ using "McAssembly" (v7.8) from Signature Software ]


;****************************************************************
; The parts of my HFS Path Names:

volName		define	"HD"
asmFolder	define	"HD:McAsm Folder"
interfaceFolder	define	"HD:McAsm Folder:Interface Folder"

;****************************************************************


; INCLUDE files : RegisterTraps.PSM
;		  ToolEqu.PSM
;		  QuickEqu.PSM
;		  SysEqu.PSM
;		  SysErr.PSM
;		  RegisterTrapMacros.asm
;		  PushPop.asm
;		  StackMacros.asm
;
;   with LISTing turned off.


	LIST	0		  ; OFF.
	
	ipath	"{interfaceFolder}:Boot EQUates :"
	incl	"RegisterTraps.PSM"
	incl	"ToolEqu.PSM"
	incl	"QuickEqu.PSM"
	incl	"SysEqu.PSM"
	incl	"SysErr.PSM"
	
	ipath	"{interfaceFolder}:Boot MACROs Folder:"
	incl	"RegisterTrapMacros.asm"
; 	PAGE			  ; Eliminated in final version.
	incl	"PushPop.asm"
; 	PAGE			  ; Eliminated in final version.
	incl	"StackMacros.asm"
; 	PAGE			  ; Eliminated in final version.
		
	LIST	1		  ; Back ON.


	TCOMP				; Turn on the Trap Compiler.

	page

	XDEF	RotateBits,DissBits
;	XREF	TestForColor		; Included here for historical reasons.

	
		
; OSErr	     RotateBits (const BitMap *srcBits, BitMap *dstBits);
; FUNCTION   RotateBits (srcBits, dstBits: BitMap) : OSErr;
;
;   Assumes mode = srcCopy + NO masking:

RotateBits	func	integer
.srcBits	pointer			; --> BitMaps or PixMaps ...
.dstBits	pointer
		endParms
; ~~~~~~~~~~~~~
		locals
.lowLeftAddr	pointer
.rowCount	integer
.byteCount	integer
.srcBaseAddr	pointer
.srcBoundsBits	integer			; Bits across rect.
.srcBounds	rect
.colorExists	boolean			; Color stuff ...
.pixelSize	integer
.pixelBit	integer
		endLocals
; ~~~~~~~~~~~~~
; Our Working Registers:

.srcPtr		requ	a2		; Passed parameters ...
.dstPtr		requ	a3
; -----
.currWordAddr	requ	a4		; Other worker bees ...
.width2		requ	d0		; Width/2 of Source.
.height2	requ	d1		; Height/2 of Source.
.centerV	requ	d2
.centerH	requ	d3
.topLeft	requ	d4
.botRight	requ	d5
.rowBytesDest	requ	d6		; ... of rotated Destination's BitMap.
; -----
.rowBitCounter	requ	d0
.wordBitCntr	requ	d1
.rowCounter	requ	d2
.colBitCounter	requ	d3
.currWordSrc	requ	d4
.pixelCounter	requ	d5
.srcRowBytes	requ	d7		; Keep D6 safe ( = .rowBytesDest ).

		page

		enter
		
		
		movem.l	a0-a5/d0-d7,-(sp)	; Deposit your life savings.
		; ==========

		; Create an off-screen BitMap Record
		; wherein the text will be saved:

		; ----------
		; First convert to BitMap in case we passed a PixMap:
		; ----------

		clr.l	-(sp)
		push.l	.srcBits
		bsr	GetBitMap
		pop.l	.srcPtr
		;
		move.l	.dstBits,.dstPtr	; We roll our own ...
		
		; ----------
		; Do some preliminary setup for Color:
		; ----------
		
		clr.w	-(sp)
		bsr	TestForColor
		pop.w	.colorExists
		
		move.w	#1,.pixelSize		; Assume black-and-white.
		tst.b	.colorExists
		beq.s	.bW
		;
.color		GetGDevice	=a1		; Handle -->
		move.l	(a1),a1			;   Pointer.
		move.l	gdPMap(a1),a0		; Ditto ...
		move.l	(a0),a0
		move.w	pmPixelSize(a0),.pixelSize
		;
.bW		move.l	baseAddr(.srcPtr),.srcBaseAddr
		move.w	rowBytes(.srcPtr),.srcRowBytes
		andi.w	#$3FFF,.srcRowBytes	; Strip top 2 bits for Color.
						;   ( already 0 for B&W )
		move.l	bounds+topLeft(.srcPtr),.srcBounds+topLeft
		move.l	bounds+botRight(.srcPtr),.srcBounds+botRight
		
		; ----------
		; Height of Source becomes width of Destination:
		; ----------
		
		move.w	.srcBounds+bottom,.rowBytesDest	; Bottom - Top.
		sub.w	.srcBounds+top,.rowBytesDest
		push.w	.rowBytesDest
		mulu	.pixelSize,.rowBytesDest
		addi.w	#15,.rowBytesDest		; + some slop for rounding.
		
		; Divide by 16 to convert to word-count in order
		; to make "rowBytes" a multiple of four(4) bytes:
		
		lsr.w	#4,.rowBytesDest
		btst	#0,.rowBytesDest	; Round-up to even #.
		beq.s	.1			; Already an even #.
		addq.w	#1,.rowBytesDest
.1		lsl.w	#1,.rowBytesDest

		; ----------
		; Now, compute the dstRect by rotating the srcRect 90-degrees CCW
		; about the source's center.  No big deal here -- but, a BIG deal does
		; come later when we compute the baseAddr of the rotated bit image.
		;
		; This OH-OH can be illustrated best by looking at the worst case
		; wherein:
		;
		;    srcRowBytes*8 = (srcBounds.right - srcBounds.left) + 15
		;
		; This is because of the requirement that rowBytes be an even # of
		; bytes and, preferably, an even # of words.  For this worst case,
		; AFTER rotation, the top 15 rows are blank, thus effectively pushing
		; the rotated image DOWN.  This problem is compounded further in that
		; what I rotate next is the just-rotated image with its top 15 rows
		; blank ... thus, with the 2nd rotation, the image is also pushed 
		; RIGHT.  In short, only after four(4) 90-degree rotations, are we 
		; square, so-to-speak.
		;
		; One solution is simply to push DOWN the baseAddr of dstBits so these
		; blank rows do NOT appear.  More on this sleight-of-hand later:
		; ----------
		
		pop.w	.height2			; = (bottom - top) from above.
		lsr.w	#1,.height2
		move.w	.srcBounds+top,.centerV
		add.w	.height2,.centerV		; = top + height/2.
		;
		move.w	.srcBounds+right,.width2
		sub.w	.srcBounds+left,.width2
		lsr.w	#1,.width2
		move.w	.srcBounds+left,.centerH
		add.w	.width2,.centerH		; = left + width/2.
		;
		move.w	.centerV,.topLeft
		sub.w	.width2,.topLeft
		swap	.topLeft			; High word = top.
		move.w	.centerH,.topLeft
		sub.w	.height2,.topLeft		; Low word = left.
		;
		move.w	.centerV,.botRight
		add.w	.width2,.botRight
		swap	.botRight			; High word = bottom.
		move.w	.centerH,.botRight
		add.w	.height2,.botRight		; Low word = right.

		; ----------
		; Assign data to dstBits directly.  Rather than push the
		; baseAddr down as described above, why not avoid the problem
		; altogether by rotating ONLY those bits in the width of
		; srcBounds and NOT the number of bits in srcRowBytes ??
		; ----------
		
		move.w	.srcBounds+right,d0		; height pixels ...
		sub.w	.srcBounds+left,d0
		;
		mulu	.pixelSize,d0			; --> height bits.
		move.w	.srcRowBytes,d1
		lsl.w	#3,d1
		cmp.w	d0,d1				; Arrgh !!
		bhi.s	.2
		move.w	d1,d0				; I lied !!
.2		move.w	d0,.srcBoundsBits
		divu	.pixelSize,d0			; ... back to height pixels.
		;
		mulu	.rowBytesDest,d0		; X  width of destination.
		push.l	d0				; Save for later ...
		_NewHandle,clear
		move.w	#noErr,.result			; Assume everything's cool !!
		tst.w	d0
		beq.s	.3
		move.w	#memFullErr,.result
		bra	.end
.3		_MoveHHi
		_HLock
		move.l	(a0),baseAddr(.dstPtr)
		move.w	.rowBytesDest,rowBytes(.dstPtr)
		tst.b	.colorExists
		beq.s	.blackWhite
		;
		ori.w	#$8000,rowBytes(.dstPtr)
		;
.blackWhite	move.l	.topLeft,bounds+topLeft(.dstPtr)
		move.l	.botRight,bounds+botRight(.dstPtr)

		; ----------
		; Start the actual text rotation by first computing
		; the address of the lower left corner of .dstBits.
		; This maps from the upper left corner of .srcBits:
		; ----------
		
		pop.l	d0				; Total BitMap size ...
		sub.l	.rowBytesDest,d0		; Minus last row's worth.
		add.l	(a0),d0
		move.l	d0,.lowLeftAddr
		
		; Initialize 2nd outermost loop counter:
		
		move.w	.srcBounds+bottom,d0
		sub.w	.srcBounds+top,d0
		move.w	d0,.rowCount			; = total Source rows.
		;
		clr.w	.rowCounter
		
		move.l	.srcBaseAddr,.srcPtr		; --> Source's Bit Image.
	;	_Debugger				; Yuck !!
		
.colLoop	move.w	#16-1,.colBitCounter
		; //////////
.colBitLoop	move.l	.lowLeftAddr,.currWordAddr
		cmpi.w	#7,.colBitCounter
		bhi.s	.hiByte
		;
.loByte		addq.l	#1,.currWordAddr
		;
.hiByte		move.w	#0,.byteCount
		clr.w	.rowBitCounter
		
		; ~~~~~~~~~~
.rowLoop	move.w	(.srcPtr)+,.currWordSrc
		addq.w	#2,.byteCount			; = an even #.
		move.w	#16-1,.wordBitCntr
		
		; ----------
		move.w	.colBitCounter,.pixelCounter	; Initialize ...
		move.w	.pixelSize,.pixelBit
		
.wordLoop	addq.w	#1,.rowBitCounter
		cmp.w	.srcBoundsBits,.rowBitCounter
		bhi.s	.doneWithSrcWord
		;
.nextBit	add.w	.currWordSrc,.currWordSrc
		bcc.s	.noBitToChange			; Looks @ left-most bit.
		;
		bset	.pixelCounter,(.currWordAddr)	; MOD 8.
		;
.noBitToChange	subq.w	#1,.pixelBit
		beq.s	.upOneRow
		subq.w	#1,.pixelCounter
		bra.s	.sameRow
.upOneRow	move.w	.colBitCounter,.pixelCounter	; Re-initialize ...
		move.w	.pixelSize,.pixelBit
		sub.l	.rowBytesDest,.currWordAddr	; Up one row and
.sameRow	dbra	.wordBitCntr,.wordLoop		;   over one Bit/Pixel.
		; ----------
		
.doneWithSrcWord
		cmp.w	.byteCount,.srcRowBytes
		bhi.s	.rowLoop
		; ~~~~~~~~~~
		
.doneWithSrcRow
		addq.w	#1,.rowCounter
		cmp.w	.rowCount,.rowCounter
		beq.s	.end
		;
		sub.w	.pixelSize,.colBitCounter
		bcc.s	.colBitLoop
		; //////////
.doneWithDestWord
		addq.l	#2,.lowLeftAddr
		bra.s	.colLoop

		; ==========
.end		movem.l	(sp)+,a0-a5/d0-d7	; Withdraw all your savings.		

		exit

		page

; ======================================
; void	      DissBits (const BitMap *srcBits, const BitMap *dstBits,
;			const Rect *srcRect, const Rect *dstRect);
; PROCEDURE   DissBits (srcBits, dstBits: BitMap; srcRect, dstRect: Rect);
;
;   Assumes mode = srcCopy + NO masking:

Dissbits	proc
.srcBits	long			; --> BitMaps or PixMaps ...
.dstbits	long
.srcRect	pointer			; to Rectangles ...
.dstRect	pointer
		endParms
; ~~~~~~~~~~~~~
		dsec	0		; Our special Record.
.ourRows	word			; Last row# and column# of inner
.ourCols	word			;   Rectangle [normalized to 0].
.ourLbits	word			; Ignored Bits in 1st Byte of Rect.
.ourStride	word			; rowBits in bitMap.
.ourBase	pointer			; ... to 1st Byte in inner Rect.
		dend	.ourSize
; ~~~~~~~~~~~~~
		locals
.srcOurs	byte	.ourSize
.dstOurs	byte	.ourSize
		endLocals
; ~~~~~~~~~~~~~
; Our Working Registers:

convertOK	requ	d0		; Result from calling Convert.
strideWidth	requ	d0		; Result from calling BitWidth.
; ----------
widthSrc	requ	d1		; Bit-widths ...
heightSrc	requ	d0
totalWidth	requ	d0		; Total Bit-width = rows + columns.
pixWide		requ	a2
; ----------
MaskByte	requ	d3		; Masks ...
cyMaskByte	requ	d0
bitMask		requ	d5
; ----------
temp		requ	d2		; Just temporary, folks !!
; ----------
srcAdr1Bit	requ	a0		; Address of 1st set Bit ...
dstAdr1Bit	requ	a1
srcAdr1Byte	requ	a0		; Address of 1st Byte ...
dstAdr1Byte	requ	a1
; ----------
srcLOGstride	requ	d0		; LOG, Base 2 ...
dstLOGstride	requ	d1

		page

		enter
		
		
		movem.l	d1-d7/a0-a5,-(sp)	; Deposit your life savings.
		; ----------
		HideCursor		; Do our "magic" with Cursor hidden.

		; ----------
		; Convert input parms to our special format:

		clr.w	-(sp)		; FUNCTIONal result.
		push.l	.srcBits
		push.l	.srcRect
		pea	.srcOurs	; VAR.
		bsr	Convert
		pop.w	convertOK
		beq	.end		; Height or Width of Rectangle = 0.
		;
		clr.w	-(sp)
		push.l	.dstBits
		push.l	.dstRect
		pea	.dstOurs	; VAR.
		bsr	Convert
		pop.w	convertOK
		beq	.end		; Oh-Oh !!
		
		; ----------
		; Check that the two rectangles match in size:

		move.w	.srcOurs+.ourRows,d0	; First, the height ...
		cmp.w	.dstOurs+.ourRows,d0
		bne	.end
		move.w	.srcOurs+.ourCols,d1	; ... then, the width.
		cmp.w	.dstOurs+.ourCols,d1
		bne	.end
		
		; ----------
		; Determine bit-width needed to span rows & columns:
		
		clr.w	-(sp)		; FUNCTIONal result.
		move.w	.srcOurs+.ourCols,d0
		ext.l	d0
		push.l	d0
		bsr	BitWidth
		pop.w	widthSrc	; Keep this sucker safe !!
		bne.s	.1		; Falls thru if tiny width.
		CopyBits   .srcBits,.dstBits,.srcRect,.dstRect,#srcCopy,#0
		bra	.end
		; ----------
.1		clr.w	-(sp)		; FUNCTIONal result.
		move.w	.srcOurs+.ourRows,d0
		ext.l	d0
		push.l	d0
		bsr	BitWidth
		pop.w	heightSrc
		bne.s	.2		; Falls thru if very small height.
		CopyBits   .srcBits,.dstBits,.srcRect,.dstRect,#srcCopy,#0
		bra	.end
		
		; ----------
		; Setup some constants we'll need later:
		
.2		ext.l	widthSrc
		move.l	#1,bitMask
		lsl.l	widthSrc,bitMask
		subq.l	#1,bitMask		; All Bits are SET.
		; ----------
		add.w	widthSrc,heightSrc
		move.w	heightSrc,totalWidth
		; ----------
		lea	MaskTable,a0
		clr.l	MaskByte
		move.b	0(a0,totalWidth),MaskByte
		
		; ----------
		; The MaskTable is saved compactly since none of the
		; Masks are wider than one Byte.  We have to un-pack
		; each Table entry so the high-order Bit of the
		; totalWidth-bit-wide field is set:
		
.UnPack		add.l	MaskByte,MaskByte
		bpl.s	.UnPack
		
		; ----------
		; Top Bit is now set.  Now, swing the top totalWidth
		; Bits around to the bottom totalWidth Bits.  The
		; first sequence element is now the Mask itself:
		
		rol.l	totalWidth,MaskByte
		move.l	MaskByte,cyMaskByte
		
		; ----------
		; Do all sorts of preparation:
		
		move.l	.srcOurs+.ourBase,temp	; Setup base address:
		lsl.l	#3,temp			;   Byte --> Bit address.
		move.l	temp,srcAdr1Bit
		; ----------
		move.w	.srcOurs+.ourLbits,temp	; Skip the Left margin.
		ext.l	temp
		add.l	temp,srcAdr1Bit
		; ~~~~~~~~~~
		move.l	.dstOurs+.ourBase,temp	; Ditto for destination.
		lsl.l	#3,temp
		move.l	temp,dstAdr1Bit
		; ----------
		move.w	.dstOurs+.ourLbits,temp
		ext.l	temp
		add.l	temp,dstAdr1Bit
		; ~~~~~~~~~~
		move.w	.srcOurs+.ourCols,pixWide
		move.w	.srcOurs+.ourRows,temp	; Normalized -->
		addq.w	#1,temp			;   un-Normalized.
		ext.l	temp
		lsl.l	widthSrc,temp
		move.l	temp,a4
		move.w	widthSrc,d2

		; ----------
		; Try to reduce the amount we shift down D2.  This 
		; process involves halving the Strides as long as 
		; each is even, decrementing D2 as we go & masking the
		; the bottom bits off D4 when we extract the row count:
		
		move.w	.srcOurs+.ourStride,d4
		move.w	.dstOurs+.ourStride,d7
		move.w	.srcOurs+.ourRows,d1
		tst.w	d2
		beq.s	.HalfDone
		
.HalfLoop	btst	#0,d4
		bne.s	.HalfDone
		btst	#0,d7
		bne.s	.HalfDone
		lsl.w	#1,d1
		bcs.s	.HalfDone
		lsr.w	#1,d4
		lsr.w	#1,d7
		subq.w	#1,d2
		bne.s	.HalfLoop
		
.HalfDone	move.w	d4,.srcOurs+.ourStride
		move.w	d7,.dstOurs+.ourStride
		clr.l	d6
		
		; ----------
		; Make some stuff faster to access -- use the fact
		; that (An) is faster to access than d(An):
		
		push.l	srcAdr1Bit		; Exit MACRO destroys A0.
		clr.w	-(sp)			; FUNCTIONal result.
		pea	.srcOurs+.ourStride	; VARs ...
		pea	.dstOurs+.ourStride
		bsr	MulChk
		tst.w	(sp)+
		beq	.Main
		
		; ----------
.NoMul		pop.l	srcAdr1Bit
		push.l	cyMaskByte
		move.w	.srcOurs+.ourStride,srcLOGstride   ; Replaced by
		move.w	.dstOurs+.ourStride,dstLOGstride   ;   their LOGs.
		
.MulLoop	tst.w	d2
		beq.s	.NoMul2
		cmpi.w	#0,srcLOGstride
		beq.s	.NoMul2
		cmpi.w	#0,dstLOGstride
		beq.s	.NoMul2
		; ----------
		subq.w	#1,d2
		subq.w	#1,srcLOGstride
		subq.w	#1,dstLOGstride
		bra.s	.MulLoop
		
.NoMul2		tst.w	d2
		bne.s	.Nloop
		cmpi.w	#0,srcLOGstride
		bne.s	.Nloop
		cmpi.w	#0,dstLOGstride
		bne.s	.Nloop
		cmp.w	pixWide,bitMask
		bne.s	.Nloop
		move.w	srcAdr1Bit,d6
		andi.b	#7,d6
		bne.s	.Nloop
		move.w	dstAdr1Bit,d6
		andi.b	#7,d6
		beq.s	.Screen
		
		; ----------
		; This loop is used when both source & destination
		; BitMaps have Strides that are powers of 2:
		
.Nloop		move.w	srcLOGstride,.srcOurs+.ourStride
		move.w	dstLOGstride,.dstOurs+.ourStride
		pop.l	cyMaskByte
		
.Nloop2		cmp.l	a4,cyMaskByte
		bge.s	.Nnext
		
.NloopRow	move.w	cyMaskByte,d6
		and.w	bitMask,d6
		cmp.w	pixWide,d6
		bgt.s	.Nnext
		move.l	cyMaskByte,d4
		sub.w	d6,d4
		lsr.l	d2,d4
		move.w	.srcOurs+.ourStride,d7
		move.l	d4,d1
		lsl.l	d7,d1
		add.l	d6,d1
		add.l	srcAdr1Bit,d1
		move.b	d1,d7
		lsr.l	#3,d1
		move.l	d1,a3
		not.b	d7
		; ----------
		move.w	.dstOurs+.ourStride,d1
		lsl.l	d1,d4
		add.l	d6,d4
		add.l	dstAdr1Bit,d4
		move.b	d4,d6
		lsr.l	#3,d4
		not.b	d6
		btst	d7,(a3)
		move.l	d4,a3
		bne.s	.NsetON
		bclr	d6,(a3)
		
.Nnext		lsr.l	#1,cyMaskByte
		bhi.s	.NloopRow
		eor.l	d3,cyMaskByte
		cmp.l	d3,cyMaskByte
		bne.s	.Nloop2
		bra	.Done
		
.NsetON		bset	d6,(a3)
		lsr.l	#1,cyMaskByte
		bhi.s	.NloopRow
		eor.l	d3,cyMaskByte
		cmp.l	d3,cyMaskByte
		bne.s	.Nloop2
		bra	.Done
		
		; ----------
		; Super-special case that holds for the entire screen:

.Screen		move.w	srcLOGstride,.srcOurs+.ourStride
		move.w	dstLOGstride,.dstOurs+.ourStride
		pop.l	cyMaskByte
		move.l	srcAdr1Bit,d6
		lsr.l	#3,d6
		move.l	d6,srcAdr1Byte
		move.l	dstAdr1Bit,d6
		lsr.l	#3,d6
		move.l	d6,dstAdr1Byte
		bra.s	.N2Loop
		
.N2Head		eor.l	MaskByte,cyMaskByte
		
.N2Loop		cmp.l	a4,cyMaskByte
		bge.s	.N2Next
		
.N2LoopRow	move.l	cyMaskByte,d1
		lsr.l	#3,d1
		btst	cyMaskByte,0(srcAdr1Byte,d1)
		bne.s	.N2setON
		bclr	cyMaskByte,0(dstAdr1Byte,d1)
		
.N2Next		lsr.l	#1,cyMaskByte
		bhi.s	.N2LoopRow
		bne.s	.N2Head
		bra.s	.N2Done
		
.N2setON	bset	cyMaskByte,0(dstAdr1Byte,d1)
		lsr.l	#1,cyMaskByte
		bhi.s	.N2LoopRow
		bne.s	.N2Head
		
.N2Done		move.w	.srcOurs+.ourLbits,d0
		move.w	.dstOurs+.ourLbits,d1
		bra	.DoneA			; Alternate finish entry.
		
		; ----------
		; Main Loop:
		;   Map the sequence element into rows & columns.
		;   Check if it's in bounds and skip on if not.
		;   Generate next element until finished.

.Main		pop.l	srcAdr1Bit
.MainLoop	cmp.l	a4,cyMaskByte		; Is row in bounds ??
		bge.s	.Next
		
		; ----------
		; Map it into the column.  Then check bounds:
		
.LoopRow	move.w	cyMaskByte,d6
		and.w	bitMask,d6
		cmp.w	pixWide,d6
		bgt.s	.Next
		move.l	cyMaskByte,d4
		sub.w	d6,d4
		lsr.l	d2,d4
		
		; ----------
		; Get the Source Byte & Bit offset:
		
		move.w	.srcOurs+.ourStride,d1
		mulu	d4,d1
		add.l	d6,d1
		add.l	srcAdr1Bit,d1
		move.b	d1,d7
		lsr.l	#3,d1			; --> Byte address.
		move.l	d1,a3
		not.b	d7
		
		; ----------
		; Find Destination Bit address & Bit offset:
		
		move.w	.dstOurs+.ourStride,d1
		mulu	d1,d4
		add.l	d6,d4
		add.l	dstAdr1Bit,d4
		move.b	d4,d6
		lsr.l	#3,d4			; --> Byte address.
		not.b	d6
		btst	d7,(a3)
		move.l	d4,a3
		bne.s	.setON
		bclr	d6,(a3)
		
		; ----------
		; Find next sequence element:
		
.Next		lsr.l	#1,cyMaskByte
		bhi.s	.LoopRow
		eor.l	MaskByte,cyMaskByte
		cmp.l	MaskByte,cyMaskByte
		bne.s	.MainLoop
		bra	.Done
		
.setON		bset	d6,(a3)
		lsr.l	#1,cyMaskByte
		bhi.s	.LoopRow
		eor.l	MaskByte,cyMaskByte
		cmp.l	MaskByte,cyMaskByte
		bne.s	.MainLoop
		
		; ----------
		; When we're finished:
		
.Done		move.w	.srcOurs+.ourLbits,d0
		move.w	.dstOurs+.ourLbits,d1
		not.b	d0
		not.b	d1
		
		; Alternate finish entry:
		
.DoneA		move.l	.srcOurs+.ourBase,a0
		move.l	.dstOurs+.ourBase,a1
		bset	d1,(a1)
		btst	d0,(a0)
		bne.s	.end		
		bclr	d1,(a1)
		; ----------
.end		ShowCursor			; It's show time, folks !!
		movem.l	(sp)+,d1-d7/a0-a5	; Withdraw all your savings.

		exit
		
		page
		
;****************************************************************
; Boolean   Convert (const BitMap *srcMap, const Rect *innerRect, Record *ourRecord);
; FUNCTION  Convert (srcMap: BitMap; innerRect: Rect;
;		     VAR ourRecord: Record) : BOOLEAN;
;
; Convert a rectangle and an enclosing BitMap to our internal format:

Convert		func	boolean			; Successful ??
.srcMap		long				; --> enclosing BitMap or PixMap.
.innerRect	pointer				; Inner Rectangle.
.ourRecord	var				; Our internal structure.
		endParms
		
		locals
.colorExists	boolean
.onScreen	pointer
.pixelSize	integer
.srcRowBytes	integer
		endLocals
		
		dsec	0			; Our special Record.
.ourRows	word				; Last row# and column# of inner
.ourCols	word				;   Rectangle [normalized to 0].
.ourLbits	word				; Ignored Bits in 1st Byte of Rect.
.ourStride	word				; rowBits in bitMap.
.ourBase	pointer				; ... to 1st Byte in inner Rect.
		dend	.ourSize
		
		
		enter
		
		movem.l	d0-d2/a1-a5,-(sp)	; Your life preserver.
		clr.w	.result			; Assume NOT okay !!
		
		; ----------
		; Color stuff:
		
.getMapInfo	clr.w	-(sp)			; FUNCTIONal result.
		bsr	TestForColor
		pop.w	.colorExists
		
		tst.b	.colorExists
		beq.s	.blackWhite
		; ----------
.color		GetCWMgrPort	!.onScreen	; The WHOLE thing !!
		move.l	.onScreen,a0		; A Pointer.
		move.l	portPixMap(a0),a1	; Handle -->
		move.l	(a1),a1			;   Pointer.
		move.w	pmPixelSize(a1),.pixelSize
		bra.s	.setup
		; ----------
.blackWhite	move.w	#1,.pixelSize

		; ----------
		; Setup Registers and zero-out our returned Record
		; ... but first convert passed parm to BitMap:

.setup		clr.l	-(sp)
		push.l	.srcMap
		bsr	GetBitMap
		pop.l	a1

	;	move.l	.srcMap,a1
		move.w	rowBytes(a1),.srcRowBytes
		andi.w	#$3FFF,.srcRowBytes	; ... just for color.
		move.l	.innerRect,a2
		move.l	.ourRecord,a3
		move.l	#.ourSize-1,d0
.clear		clr.b	(a3)+
		dbra	d0,.clear
		move.l	.ourRecord,a3		; Reset to passed Pointer.
		
		; ----------
		; Now, fill-in our returned Record:
		;
		;   First, calculate address of the 1st Byte in 1st
		;   row of BitMap occupied by the inner Rectangle.
		
		clr.l	d0
		clr.l	d1
		;
		move.w	top(a2),d0
		sub.w	bounds+top(a1),d0	; How many rows down = dv.
		mulu	.srcRowBytes,d0		; Bytes down from (0,0).
		add.l	baseAddr(a1),d0
		; ----------
		move.w	left(a2),d1
		sub.w	bounds+left(a1),d1	; Then, Bits across to Rect.
		mulu	.pixelSize,d1
		; ----------
		move.w	d1,d2
		andi.w	#7,d2			; MOD 8.
		move.w	d2,.ourLbits(a3)	; # of Bits to skip.
		; ----------
		lsr.w	#3,d1			; Bytes across to Rectangle.
		add.l	d1,d0			; Address of 1st Byte in Rect.
		move.l	d0,.ourBase(a3)
		; ----------
		move.w	.srcRowBytes,d0
		lsl.w	#3,d0			; Bytes --> Bits.
		move.w	d0,.ourStride(a3)
		; ----------
		move.w	bottom(a2),d0
		sub.w	top(a2),d0		; Height of Rectangle.
		subq.w	#1,d0			; Normalized to 0.
		bmi.s	.end			; Zero height to begin with.
		move.w	d0,.ourRows(a3)
		; ----------
		move.w	right(a2),d1
		sub.w	left(a2),d1		; Width.
		mulu	.pixelSize,d1
		subq.w	#1,d1			; Normalized to 0.
		bmi.s	.end			; Zero width to begin with.
		move.w	d1,.ourCols(a3)
		
		st	.result			; Everything's okay !!
		; ----------
.end		movem.l	(sp)+,d0-d2/a1-a5	; Withdraw all your savings.		

		exit

		page
		
;****************************************************************
; Boolean   MulChk (short *srcStride, short *dstStride);
; FUNCTION  MulChk (VAR srcStride, dstStride: INTEGER) : BOOLEAN;
;
; See if we can do without multiply instructions:

MulChk		func	boolean			; Can we ??
.srcStride	var				; Pointers.
.dstStride	var
		endParms
		
		noLocals
		
.strideWidth	requ	d0
.one		requ	d1
.saveSrcWidth	requ	d2
		
		
		enter
		
		movem.l	d0-d2/a1-a2,-(sp)	; Save your pennies.
		; ----------
		clr.w	.result			; Assume NO !!
		
		move.l	.srcStride,a1
		move.w	(a1),d0
		ext.l	d0
		subq.l	#1,d0
		clr.w	-(sp)			; FUNCTIONal result.
		push.l	d0
		bsr	BitWidth
		pop.w	.strideWidth
		move.w	#1,.one			; Can we reproduce it ??
		lsl.w	.strideWidth,.one
		cmp.w	(a1),.one
		bne.s	.end			; Nope, so bag it !!
		move.w	.strideWidth,.saveSrcWidth
		; ----------
		move.l	.dstStride,a2
		move.w	(a2),d0
		ext.l	d0
		subq.l	#1,d0
		clr.w	-(sp)
		push.l	d0
		bsr	BitWidth
		pop.w	.strideWidth
		move.w	#1,.one
		lsl.w	.strideWidth,.one
		cmp.w	(a2),.one
		bne.s	.end			; Bag it !!
		
		move.w	.saveSrcWidth,(a1)	; ... source
		move.w	.strideWidth,(a2)	; ... destination	
		st	.result			; Good News, folks !!
		; ----------
.end		movem.l	(sp)+,d0-d2/a1-a2

		exit
		
		page
		
;****************************************************************
; short	    BitWidth (long number);
; FUNCTION  BitWidth (number: LONGINT) : INTEGER;
;
; Find the number of Bits in a number:

BitWidth	func	integer
.number		longint
		endParms
		
		noLocals
		
		
		enter

		movem.l	d0-d1,-(sp)		; Your life preserver.
		; ----------
		clr.w	.result			; Initialize to 0.
		move.l	.number,d0
		beq.s	.end
		; ----------
		move.w	#32,d1			; e.g., width of #3 = 2.
.loop		lsl.l	#1,d0
		dbcs	d1,.loop		; ... until a 1 falls off.
		move.w	d1,.result
		; ----------
.end		movem.l	(sp)+,d0-d1		; To the rescue.
		
		exit
		
		page
		
;****************************************************************
; Table of longword Masks to XOR in Knuthian algorithm.  The first
; table entry > 0 is for a bit-width of two, so the table actually
; starts two bytes before that.  The scheme used is that of a 
; "maximum-length sequence generator":

MaskTable	dc.b	0			; Bit-width = 0 ...
		dc.b	0,3,3,3,5,3,3,23
		dc.b	17,9,5,101,27,53,3,45
		dc.b	9,129,57,9,5,3,33,27
		dc.b	9,113,57,9,5,101,9,163	; ... Bit-width = 32.
		
		align

		page

; ======================================
; BitMap    *GetBitMap (long *passedMap);
; FUNCTION  GetBitMap (Ptr: passedMap) : BitMapPtr;
;
; Passed parm(s) may be a BitMapPtr, a PixMapPtr or a pointer to a PixMapHandle

GetBitMap	func	pointer
.passedMap	pointer
		endParms
; ~~~~~~~~~~~~~		
		noLocals
; ~~~~~~~~~~~~~		
; Our working Registers:

.mapPtr		requ	a0
.pixMapPtr	requ	a0
		
		enter
		
		
		move.l	.passedMap,.result	; Assume we got a BitMapPtr.

		move.l	.passedMap,.mapPtr
		move.w	rowBytes(.mapPtr),d0	; = thePort->portVersion.
		bpl.s	.end			; = a BitMapPtr.
		;
.notBitMap	btst	#14,d0
		beq.s	.end			; = a PixMapPtr.
		;
.aPixMapHdl	move.l	(.mapPtr),.pixMapPtr	; = thePort->portPixMap.
		move.l	(.pixMapPtr),.result


.end		exit

		page

; ======================================
; Boolean    TestForColor (void);
; FUNCTION   TestForColor () : BOOLEAN;
;
; Test for the presence of a Mac with Color QuickDraw AND a Color
; Monitor that the user has set to Color via the Control Panel:

TestForColor	func	boolean
		noParms
		
		locals
.theWorld	byte	sysEnv1Size		; Mac II stuff.
		endLocals
		
		
		enter
		
		
		movem.l	d1-d7/a0-a5,-(sp)	; Save all your pennies !!
		; ==========
		
		clr.w	.result			; Assume NO color = B&W.
		
		move.w	#1,d0			; Version #1.
		lea	.theWorld,a0
		_SysEnvirons
		tst.w	d0
		bne.s	.notColor
		; ----------
.noError	tst.b	hasColorQD(a0)		; A0 --> theWorld.
		beq.s	.notColor
		; ----------
		GetGDevice	=a1		; Handle -->
		move.l	(a1),a1			;   Pointer.
		move.l	gdPMap(a1),a0		; Ditto ...
		move.l	(a0),a0
		cmpi.w	#1,pmPixelSize(a0)
		beq.s	.notColor

.color		st	.result
		; ----------
.notColor

		; ==========
.end		movem.l	(sp)+,d1-d7/a0-a5	; Withdraw your life savings !!
		
		
		exit
