#if !defined(BRWINPTL_H) && !defined(__BEDRC__)
#define BRWINPTL_H
//========================================================================================
//
//     File:			BRWinPtL.h
//     Release Version:	$ 1.0d1 $
//
//     Creation Date:	November 30, 1990
//
//     COPYRIGHT 1990-1993 SYMANTEC CORPORATION. ALL RIGHTS RESERVED. UNPUBLISHED -- RIGHTS
//     RESERVED UNDER THE COPYRIGHT LAWS OF THE UNITED STATES. USE OF COPYRIGHT NOTICE IS
//     PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION OR DISCLOSURE.
//
//     THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF SYMANTEC
//     CORPORATION. USE, DISCLOSURE, OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
//     EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
//
//     RESTRICTED RIGHTS LEGEND
//     Use, duplication, or disclosure by the Government is subject to restrictions as set
//     forth in subparagraph (c)(l)(ii) of the Rights in Technical Data and Computer
//     Software clause at DFARS 252.227-7013. Symantec Corporation, 10201 Torre Avenue,
//     Cupertino, CA 95014.
//
//========================================================================================

#ifdef BR_BUILD_WIN

#ifndef BCCOLL_H
#include "BCColl.h"
#endif

#ifndef BRSTDDEF_H
#include "BRStdDef.h"
#endif

#ifndef BRRECT_H
#include "BRRect.h"
#endif

#if !defined(__INC_WINDOWS)
#include <windows.h>
#endif

#ifndef BREXCLIB_H
#include "BRExcLib.h"
#endif


//========================================================================================
//	Forward class declaration
//========================================================================================
class BR_CView;
class BR_CPen;


//========================================================================================
//	BR_CBedWinPointList
//========================================================================================
class BR_CBedWinPointList : _BR_CAutoDestructObject
{
public:
	enum TranslateOptions
	{
		kDoNotTranslate, kTranslateLPtoDP
	};

	BR_CBedWinPointList(BR_CView* pane,
				  		const BC_TCollection<BR_CPoint>* pointList,
				  		const BR_CPen *pen,
				  		TranslateOptions translateOptions);

	~BR_CBedWinPointList();

	LPPOINT GetPointList();

private:
	LPPOINT fPoints;
};

#endif

#endif


