/*========================================================================================
/ 
/      File:		BRMIntli.h
/      Release Version:	$ 1.0d1 $
/ 
/      Creation Date:	1/23/91
/ 
/      COPYRIGHT 1991-93 SYMANTEC CORPORATION. ALL RIGHTS RESERVED. UNPUBLISHED -- RIGHTS
/      RESERVED UNDER THE COPYRIGHT LAWS OF THE UNITED STATES. USE OF COPYRIGHT NOTICE IS
/      PRECAUTIONARY ONLY AND DOES NOT IMPLY PUBLICATION OR DISCLOSURE.
/ 
/      THIS SOFTWARE CONTAINS PROPRIETARY AND CONFIDENTIAL INFORMATION OF SYMANTEC
/      CORPORATION. USE, DISCLOSURE, OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
/      EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
/ 
/      RESTRICTED RIGHTS LEGEND
/      Use, duplication, or disclosure by the Government is subject to restrictions as Set
/      forth in subparagraph (c)(l)(ii) of the Rights in Technical Data and Computer
/      Software clause at DFARS 252.227-7013. Symantec Corporation, 10201 Torre Avenue,
/      Cupertino, CA 95014.
/ 
/=======================================================================================*/

/*--------------------------------------------------------------------------------------
//	This file is part of the old international implementation.
//	The Bedrock team is in the process of designing a totally new approach.
//	For more details on the new approach please look in the 
//	":BEDROCK:INTL:INCLUDES:" folder.
//	The new approach departs from the close tie to characters and characterSets.
//	Instead it bases all internationalization efforts on locale based
//	characters, and character sets, with Unicode as the central set.
/--------------------------------------------------------------------------------------*/


#ifndef BRMINTLI_H
#define BRMINTLI_H

#ifndef BRSUPDEF_H
#include "BRSupDef.h"
#endif

#define BR_INTL_DECIMAL 			    1
#define BR_INTL_CURDECIMAL			    2
#define BR_INTL_CURRENCYSYM			    3
#define BR_INTL_THOUSANDSEP			    4
#define BR_INTL_CURTHOUSANDSEP			5
#define BR_INTL_OVERFLOW			    6
#define BR_INTL_CUROVERFLOW			    7
#define BR_INTL_FILLER				    8
#define BR_INTL_CURFILLER			    9
#define BR_INTL_LISTSEP 		       10
#define BR_INTL_FLOATPATTERN1		   11
#define BR_INTL_FLOATPATTERN2		   12
#define BR_INTL_INTPATTERN1		       13
#define BR_INTL_INTPATTERN2		       14
#define BR_INTL_ACCTZERO		       15

#define BR_INTL_TIMESEP 		       16
#define BR_INTL_TIMESEP2		       17
#define BR_INTL_TIMEFORMAT12		   18
#define BR_INTL_TIMEFORMAT24		   19
#define BR_INTL_TIMEFORMATFS		   20

#define BR_INTL_SHORTDATE		       21
#define BR_INTL_LONGDATE		       22

#define BR_INTL_DAYSOFWEEK		       BR_INTL_DAYSOFWEEK0
#define BR_INTL_DAYSOFWEEK0		       23
#define BR_INTL_DAYSOFWEEK1		       24
#define BR_INTL_DAYSOFWEEK2		       25
#define BR_INTL_DAYSOFWEEK3		       26
#define BR_INTL_DAYSOFWEEK4		       27
#define BR_INTL_DAYSOFWEEK5		       28
#define BR_INTL_DAYSOFWEEK6		       29
#define BR_INTL_DAYSOFWEEK7		       30
#define BR_INTL_DAYSOFWEEK8		       31
#define BR_INTL_DAYSOFWEEK9		       32

#define BR_INTL_ABBRDAYSOFWEEK		   BR_INTL_ABBRDAYSOFWEEK0
#define BR_INTL_ABBRDAYSOFWEEK0 	   33
#define BR_INTL_ABBRDAYSOFWEEK1 	   34
#define BR_INTL_ABBRDAYSOFWEEK2 	   35
#define BR_INTL_ABBRDAYSOFWEEK3 	   36
#define BR_INTL_ABBRDAYSOFWEEK4 	   37
#define BR_INTL_ABBRDAYSOFWEEK5 	   38
#define BR_INTL_ABBRDAYSOFWEEK6 	   39
#define BR_INTL_ABBRDAYSOFWEEK7 	   40
#define BR_INTL_ABBRDAYSOFWEEK8 	   41
#define BR_INTL_ABBRDAYSOFWEEK9 	   42

#define BR_INTL_YEARNAMES		       BR_INTL_YEARNAMES0
#define BR_INTL_YEARNAMES0		       43
#define BR_INTL_YEARNAMES1		       44
#define BR_INTL_YEARNAMES2		       45
#define BR_INTL_YEARNAMES3		       46
#define BR_INTL_YEARNAMES4		       47
#define BR_INTL_YEARNAMES5		       48
#define BR_INTL_YEARNAMES6		       49
#define BR_INTL_YEARNAMES7		       50
#define BR_INTL_YEARNAMES8		       51
#define BR_INTL_YEARNAMES9		       52
#define BR_INTL_YEARNAMES10		       53
#define BR_INTL_YEARNAMES11		       54

#define BR_INTL_MONTHNAMES		       BR_INTL_MONTHNAMES0
#define BR_INTL_MONTHNAMES0		       55
#define BR_INTL_MONTHNAMES1		       56
#define BR_INTL_MONTHNAMES2		       57
#define BR_INTL_MONTHNAMES3		       58
#define BR_INTL_MONTHNAMES4		       59
#define BR_INTL_MONTHNAMES5		       60
#define BR_INTL_MONTHNAMES6		       61
#define BR_INTL_MONTHNAMES7		       62
#define BR_INTL_MONTHNAMES8		       63
#define BR_INTL_MONTHNAMES9		       64
#define BR_INTL_MONTHNAMES10		   65
#define BR_INTL_MONTHNAMES11		   66
#define BR_INTL_MONTHNAMES12		   67
#define BR_INTL_MONTHNAMES13		   68

#define BR_INTL_ABBRMONTHNAMES		   BR_INTL_ABBRMONTHNAMES0
#define BR_INTL_ABBRMONTHNAMES0 	   69
#define BR_INTL_ABBRMONTHNAMES1 	   70
#define BR_INTL_ABBRMONTHNAMES2 	   71
#define BR_INTL_ABBRMONTHNAMES3 	   72
#define BR_INTL_ABBRMONTHNAMES4 	   73
#define BR_INTL_ABBRMONTHNAMES5 	   74
#define BR_INTL_ABBRMONTHNAMES6 	   75
#define BR_INTL_ABBRMONTHNAMES7 	   76
#define BR_INTL_ABBRMONTHNAMES8 	   77
#define BR_INTL_ABBRMONTHNAMES9 	   78
#define BR_INTL_ABBRMONTHNAMES10	   79
#define BR_INTL_ABBRMONTHNAMES11	   80
#define BR_INTL_ABBRMONTHNAMES12	   81
#define BR_INTL_ABBRMONTHNAMES13	   82

#define BR_INTL_MORNING 		       83
#define BR_INTL_EVENING 		       84
#define BR_INTL_24HOURCLOCK		       85

#define BR_INTL_USECURSYM		       86
#define BR_INTL_CURINCLUDEDECIMAL	   87
#define BR_INTL_THOUSEPPOS		       88
#define BR_INTL_CURTHOUSEPPOS		   89
#define BR_INTL_LEADINGZERO		       90
#define BR_INTL_CURLEADINGZERO		   91
#define BR_INTL_RADIX			       92
#define BR_INTL_FORCEDIGIT		       93
#define BR_INTL_MINDECDIGITS		   94
#define BR_INTL_MAXDECDIGITS		   95
#define BR_INTL_CURMINDECDIGITS 	   96
#define BR_INTL_CURMAXDECDIGITS 	   97
#define BR_INTL_POSCURIDX		       98
#define BR_INTL_NEGCURIDX		       99

#define BR_INTL_TIMEZEROONHOUR12	  100
#define BR_INTL_TIMEZEROONMIN12 	  101
#define BR_INTL_TIMEZEROONSEC12 	  102
#define BR_INTL_TIMEZEROONHOUR24	  103
#define BR_INTL_TIMEZEROONMIN24 	  104
#define BR_INTL_TIMEZEROONSEC24 	  105
#define BR_INTL_TIMEZEROONHOURFS	  106
#define BR_INTL_TIMEZEROONMINFS 	  107
#define BR_INTL_TIMEZEROONSECFS 	  108
#define BR_INTL_DEFTIMEFMT		      109


#define BR_INTL_SDATEINCCEN		      110
#define BR_INTL_SDATEMNABBR		      111
#define BR_INTL_SDATEDYABBR		      112
#define BR_INTL_SDATE0ONDAY		      113
#define BR_INTL_SDATE0ONMONTH		  114
#define BR_INTL_SDATE0ONYEAR		  115
#define BR_INTL_LDATEINCCEN		      116
#define BR_INTL_LDATEMNABBR		      117
#define BR_INTL_LDATEDYABBR		      118
#define BR_INTL_LDATE0ONDAY		      119
#define BR_INTL_LDATE0ONMONTH		  120
#define BR_INTL_LDATE0ONYEAR		  121

#define BR_INTL_SPACEHI 		      122
#define BR_INTL_SPACELO 		      123
#define BR_INTL_TABHI			      124
#define BR_INTL_TABLO			      125



#define BR_INTL_POSCURWSYMPATTERN	      BR_INTL_POSCURWSYMPATTERN0
#define BR_INTL_POSCURWSYMPATTERN0	      130
#define BR_INTL_POSCURWSYMPATTERN1	      131
#define BR_INTL_POSCURWSYMPATTERN2	      132
#define BR_INTL_POSCURWSYMPATTERN3	      133

#define BR_INTL_POSCURNOSYMPATTERN	      BR_INTL_POSCURNOSYMPATTERN0
#define BR_INTL_POSCURNOSYMPATTERN0	      150
#define BR_INTL_POSCURNOSYMPATTERN1	      151
#define BR_INTL_POSCURNOSYMPATTERN2	      152
#define BR_INTL_POSCURNOSYMPATTERN3	      153

#define BR_INTL_NEGCURWSYMPATTERN	      BR_INTL_NEGCURWSYMPATTERN0
#define BR_INTL_NEGCURWSYMPATTERN0	      170
#define BR_INTL_NEGCURWSYMPATTERN1	      171
#define BR_INTL_NEGCURWSYMPATTERN2	      172
#define BR_INTL_NEGCURWSYMPATTERN3	      173
#define BR_INTL_NEGCURWSYMPATTERN4	      174
#define BR_INTL_NEGCURWSYMPATTERN5	      175
#define BR_INTL_NEGCURWSYMPATTERN6	      176
#define BR_INTL_NEGCURWSYMPATTERN7	      177
#define BR_INTL_NEGCURWSYMPATTERN8	      178
#define BR_INTL_NEGCURWSYMPATTERN9	      179
#define BR_INTL_NEGCURWSYMPATTERN10	      180

#define BR_INTL_NEGCURNOSYMPATTERN	      BR_INTL_NEGCURNOSYMPATTERN0
#define BR_INTL_NEGCURNOSYMPATTERN0	      190
#define BR_INTL_NEGCURNOSYMPATTERN1	      191
#define BR_INTL_NEGCURNOSYMPATTERN2	      192
#define BR_INTL_NEGCURNOSYMPATTERN3	      193
#define BR_INTL_NEGCURNOSYMPATTERN4	      194
#define BR_INTL_NEGCURNOSYMPATTERN5	      195
#define BR_INTL_NEGCURNOSYMPATTERN6	      196
#define BR_INTL_NEGCURNOSYMPATTERN7	      197
#define BR_INTL_NEGCURNOSYMPATTERN8	      198
#define BR_INTL_NEGCURNOSYMPATTERN9	      199
#define BR_INTL_NEGCURNOSYMPATTERN10	  200


#define BR_INTL_COLLATE1			  210
#define BR_INTL_COLLATE2			  211
#define BR_INTL_LCASEMAP			  212
#define BR_INTL_UCASEMAP			  213

#define BR_INTL_CHARTYPE			  214

#endif
