#   File:       EKG.make
#   Target:     EKG
#   Sources:    LowMemDataAndCode.a EKGmain.c

CCFLAGS = -r -sym on,novars,notypes -d _NOT_SIMULATING_

ASMFLAGS = -sym on

LDFLAGS = -t APPL -c '????' -sym on -mf

OBJS1 = EKGmain.c.o A5Init.a.o

OBJS2 = LowMemDataAndCode.a.o 

EKG  EKG.make {OBJS1} {OBJS2}
	Link {LDFLAGS} 
		 {OBJS1} 
		"{Libraries}"Runtime.o 
		"{Libraries}"Interface.o 
		-o EKG
		
# load main program at 1024 decimal, 0400 hex
	Hex EKG -a $0400 -h s1 > 
		'A/UX:Comm:WhiteKnight:EKG'
		
# produce assy/C listing useful for debug
	DumpObj EKGmain.c.o > CSymbols
	UltraSlimFast CSymbols > EKGSrcAssy
		
# load the vector table and exception processing code at 0 
	Link -t APPL -c '????' -mf 
		{OBJS2} -o LowMemDataAndCode
	Hex LowMemDataAndCode -a $0000 -h s1 > 
		'A/UX:Comm:WhiteKnight:LowMemDataAndCode' 

# dependencies/rules for embedded code

LowMemDataAndCode.a.o  EKG.make LowMemDataAndCode.a
	 Asm {ASMFLAGS} LowMemDataAndCode.a

A5Init.a.o  EKG.make A5Init.a
	 Asm {ASMFLAGS} A5Init.a
	 
EKGmain.c.o  EKG.make EKGmain.c
	 C  {CCFLAGS} EKGmain.c
