      GLOBAL DEFINE
        INCLUDE 'Events.inc'
        INCLUDE 'Quickdraw.inc'
        INCLUDE 'OSUtils.inc'
        INCLUDE 'Sound.inc'
        INCLUDE 'Resources.inc'
        INCLUDE 'Files.inc'
        INCLUDE 'Windows.inc'
        INCLUDE 'Dialogs.inc'
	INCLUDE 'MRWE.inc'

        EXTERNAL Startup
	EXTERNAL OdocList
	EXTERNAL pdocnull
	EXTERNAL Read_Data
	EXTERNAL Draw_Curve
	EXTERNAL Set_Pars
	EXTERNAL Idle
	EXTERNAL Goodbye
	RECORD /Str255/  mrwe_PasSTR
	EXTERNAL mrwe_PasSTR
      END

	program display
	
c	reads data (x,y) from file and displays it
c	superimposes theoretical curve whose parameters 
c	are entered into a dialog box
c
c	f(x) = a + b*exp(-c*x)
c
c	J. Langowski/MacTutor May 1993
c
	implicit none
      integer*4 ReadID, DrawID, ParsID
c	integer*4 AEresult

	INTEGER*4 window, unit
	COMMON /flags/ window,unit
	data unit /10/ ! initial unit # of windows to be opened

	! note which window was in front at startup
	window = FrontWindow()
	
	! move main window 
	call MoveWindow(VAL4(window),VAL2(20),VAL2(50),VAL2(0))
	call SizeWindow(VAL4(window),VAL2(300),VAL2(200),VAL2(-1))
	
	! Prepare to handle AppleEvents.
c	AEresult = mrwe_AddAppleEvent('aevt','oapp', signalAE, Startup)
c	AEresult = mrwe_AddAppleEvent('aevt','odoc', docAE, OdocList)
c	AEresult = mrwe_AddAppleEvent('aevt','pdoc', docAE, pdocnull)
	
	! Set up the menus
	ReadID  = mrwe_AddMenu('Display', 'Read Data /R', Read_Data)
	DrawID  = mrwe_AddMenu('Display', 'Draw curve/D', Draw_Curve)
	ParsID  = mrwe_AddMenu('Display', 'Set Params/O', Set_Pars)
	
	write (*,*) 'Hello World'
	
	! Pass control to MRWE "forever" (or until told to quit)
	
	CALL mrwe_EventLoop(0,0) ! should never return
	
	END
	

	integer function Read_Data(itemID)	
	IMPLICIT NONE
	CHARACTER filename*256
	INTEGER*4 status, Lister
	OPEN(1, FILE='', FILETYPE='TEXT',
	1	ACTION='READ', IOSTAT=status, STATUS='OLD')
	IF (status == 0) THEN
	  INQUIRE (1, NAME=filename)
	  Read_Data = Lister(TRIM(filename))
	ELSE
          Read_Data = status
	END IF
	
	return
	end

! List a file with line numbers + open publisher

	INTEGER*4 FUNCTION Lister(filename)
	IMPLICIT NONE
	CHARACTER*(*) filename
	CHARACTER*132 line
	INTEGER*4 status, num
	real x,y
	
	OPEN(2, FILE=TRIM(filename)//' Listing', 
	1	ACCESS='WINDOW,200,300,50,20', STATUS='UNKNOWN')
	WRITE(2,10) TRIM(filename)
	
	open (3, FILE='data.ed',ACTION='PUBLISH',STATUS='UNKNOWN')
	
	num = 0
	DO
	  READ (1,20,IOSTAT=status) line
          IF (status <> 0) EXIT
          num = num + 1
          WRITE(2,30) num, TRIM(line)
	  read (line,*) x,y
	  write(3,35) x,char(9),y
	END DO
	close(3)

	WRITE(2,40)
	READ(2,*)
	CLOSE(2)
	Lister=0
	return
	
 10	FORMAT ('*** Listing and publishing: "', a, '" ***', //)
 20	FORMAT (a)
 30	FORMAT (i4.4, ': ', a)
 35	format (1xg15.5,1a,g15.5)
 40	FORMAT (//,'*** End of listing ***',
 	1	/,'To close window, press return')
	END

	integer function Draw_Curve(itemID)
	implicit none
	integer status
	real a,b,c,x,y
	common /params/ a,b,c
	
	open (2, FILE='data.ed',ACTION='READ',STATUS='OLD')
	open (3, FILE='curve.ed',ACTION='PUBLISH',STATUS='UNKNOWN')
	
	DO
	  READ (2,*,IOSTAT=status) x,y
          IF (status <> 0) EXIT
	  y = a*exp(-b*x) + c
        WRITE(3,35) x,char(9),y
	END DO
	
	close(2)
	close(3)
	
	Draw_Curve = 0
	return
	
35	format (1xg15.5,1a,g15.5)
	end
	

	integer function Set_Pars(itemID)
	implicit none
	real a,b,c
	common /params/ a,b,c
	
	integer*2 paramsDLOG,atext,btext,ctext
	parameter(paramsDLOG=2000,atext=3,btext=4,ctext=5)

	INTEGER*4 savePort

	! Dialog variables

	INTEGER*4	    theDialog,itemType,hItem,Box
	INTEGER*2	    itemHit
	RECORD /Str255/     itemaText,itembText,itemcText


	CALL GetPort(savePort)
	theDialog = GetNewDialog(VAL2(paramsDLOG),VAL4(0),VAL4(-1))
	CALL SetPort(VAL4(theDialog))
	itemHit = 0
	
	DO 
	   CALL ModalDialog(VAL4(0), itemHit)
	   select case 	(itemHit)
	  	case (ok)
			CALL GetDItem(VAL4(theDialog),VAL2(btext),itemType,hItem,Box)
			CALL GetIText(VAL4(hItem),itembText)
			CALL GetDItem(VAL4(theDialog),VAL2(ctext),itemType,hItem,Box)
			CALL GetIText(VAL4(hItem),itemcText)
			CALL GetDItem(VAL4(theDialog),VAL2(atext),itemType,hItem,Box)
			CALL GetIText(VAL4(hItem),itemaText)
			
			read (itemaText.chars(1:INT(itemaText.len)),*) a
			read (itembText.chars(1:INT(itembText.len)),*) b
			read (itemcText.chars(1:INT(itemcText.len)),*) c
			exit
		case (cancel)
			exit
		case default
	   end select
	END DO
	
	CALL DisposDialog(VAL4(theDialog))

	CALL SetPort(VAL4(savePort))
	Set_Pars = 0
	
	write (*,*) a,b,c

	return
	end

	
	
