/* pXFCN.c
   A template program for running XCMD's and XFCN's as
   part of regular applications.
   
   Written by Gerry H. Kenner, Ph.D.
 */
 
#include	"pXFCN.h"
#include	"string.h"
#include	"stdlib.h"
#include	"stdio.h"
 
XCmdPtr	ParamPtr;

Handle LoadXCMD(short Count, ...)
{
	void		*ListPtr;
	char		*CharPtr;
	Handle		CodeAddr, TempHdl;
	short		i, Err;
	size_t		Size;
	
	Count = Count - 1;
	ListPtr = &Count + 1;
	CharPtr = *(*(char***)&ListPtr)++;
	CtoPstr(CharPtr);
	CodeAddr = GetNamedResource('XFCN', CharPtr);
	MoveHHi(CodeAddr);
	HLock(CodeAddr);

	//ParamPtr = (XCmdPtr)NewPtr(sizeof(XCmdBlock));
	ParamPtr = (XCmdPtr)NewPtr(128L);
	ParamPtr->entryPoint = (Ptr)SwitchXCMD;

	ParamPtr->paramCount = Count;
	for (i = 0; i < ParamPtr->paramCount; ++i)
	{
		ParamPtr->params[i] = NewHandle(256);
		HLock(ParamPtr->params[i]);
		CharPtr = *(*(char***)&ListPtr)++;
		strcpy((char*)*(ParamPtr->params[i]), CharPtr);
	}
	
	JumpToXCMD(ParamPtr, CodeAddr);
	Size = strlen(*(ParamPtr->returnValue));
	TempHdl = NewHandle((long)Size);
	strcpy((char*)*TempHdl, (char*)*(ParamPtr->returnValue));
	HLock(TempHdl);
	
	for (i = 0; i < ParamPtr->paramCount; ++i)
	{
		HUnlock(ParamPtr->params[i]);
		DisposHandle(ParamPtr->params[i]);
	}
	HUnlock(CodeAddr);
	HUnlock(ParamPtr->returnValue);
	
	DisposHandle(ParamPtr->returnValue);
	DisposPtr((XCmdPtr)ParamPtr);
	ReleaseResource(CodeAddr);
	
	return(TempHdl);
}

char *StrCpy(char *s1, char *s2)
{
	asm {
		movea.l	8(sp),a0		;  A0 = s1
		movea.l	12(sp),a1		;  A1 = s2
		move.l	a0,d0			;  D0.L = result
@1		move.b	(a1)+,(a0)+
		bne.s	@1
	}
}

void JumpToXCMD(XCmdPtr ParamPtr, Handle CodeAddr)
{
	asm
	{
		move.l	ParamPtr(a6), -(a7)
		move.l	CodeAddr(a6), a0
		move.l	(a0), a0
		jsr		(a0)
	}
}

void SwitchXCMD(void)
{
	WindowPtr	TempWindow, OldPort;
	Handle		TempHandle;
	long		TempLong;
	Str255		TempStr;
	Rect		TempRect;
	
	switch (ParamPtr->request)
	{
		case xreqZeroToPas:
			strcpy((char*)ParamPtr->inArgs[1], (char*)ParamPtr->inArgs[0]);
			CtoPstr((char*)ParamPtr->inArgs[1]);
			break;
			
		case xreqPasToZero:
			TempHandle = NewHandle(256);
			HLock(TempHandle);
			PtoCstr((char*)ParamPtr->inArgs[0]);
			strcpy((char*)(*TempHandle), (char*)ParamPtr->inArgs[0]);
			CtoPstr((char*)ParamPtr->inArgs[0]);
			ParamPtr->outArgs[0] = (long)TempHandle;
			break;
			
		case xreqSendHCMessage:
			GetPort(&OldPort);
			SetRect(&TempRect, 20, screenBits.bounds.bottom - 80, 480, screenBits.bounds.bottom - 20);
			TempWindow = NewWindow(0L, &TempRect, "\pHC Message", TRUE, 
					plainDBox, (WindowPtr)-1L, TRUE, 0L);
			SetPort(TempWindow);
			MoveTo(10, 30);
			DrawString((char*)ParamPtr->inArgs[0]);
			Delay(90L, &TempLong);
			DisposeWindow(TempWindow);
			SetPort(OldPort);
			break;
			
		case xreqNumToStr:
			NumToString(ParamPtr->inArgs[0], (char*)ParamPtr->inArgs[1]);
			if (ParamPtr->inArgs[0] < 0)
				ParamPtr->inArgs[1] = (long)strcat((char*)"-", (char*)ParamPtr->inArgs[1]);
			break;
		
		case xreqExtToStr:
			sprintf((char*)TempStr, "%f", *((double*)ParamPtr->inArgs[0]));
			strcpy((char*)ParamPtr->inArgs[1], (char*)&TempStr);
			CtoPstr((char*)ParamPtr->inArgs[1]);
			break;
			
		case xreqStrToExt:
			PtoCstr((char*)ParamPtr->inArgs[0]);
			*(double*)(ParamPtr->inArgs[1]) = atof((char*)ParamPtr->inArgs[0]);
			break;
			
		case xreqScanToReturn:
			while (**(Handle)(ParamPtr->inArgs[0]) != 0x0D)
				(**(Handle)(ParamPtr->inArgs[0]))++;
			break;
			
		case xreqScanToZero:
			DebugStr("\pScanToZero");
			break;
			
		default:
			GetPort(&OldPort);
			SetRect(&TempRect, 20, screenBits.bounds.bottom - 80, 480, screenBits.bounds.bottom - 20);
			TempWindow = NewWindow(0L, &TempRect, "\pDefault", TRUE, 
					plainDBox, (WindowPtr)-1L, TRUE, 0L);
			SetPort(TempWindow);
			MoveTo(10, 30);
			DrawString((char*)"\pRequested function not available");
			Delay(90L, &TempLong);
			DisposeWindow(TempWindow);
			SetPort(OldPort);
			break;
	}
}

