/*
  	SAPlayMovie.r written by Donald O. Olson
 	A simple QuickTime Scripting Addition written
	to illustrate writing Scripting Additions.

 	Copyright 1993 Donald O. Olson
	All rights reserved.
*/


#include "Types.r"
#include "SysTypes.r"
#include "AEUserTermTypes.r"

#define typeMyRectangle 'RECT'

resource 'vers' (1) {
	0x1,
	0x0,
	final,
	0x0,
	verUS,
	"1.0",
	"1.0, Copyright  1993 Donald Olson"
	". All rights reserved."
};

resource 'vers' (2) {
	0x1,
	0x0,
	final,
	0x0,
	verUS,
	"1.0",
	"(by Donald Olson)"
};

/* This string gets displayed if the user double clicks on us. */

resource 'STR ' (-16397) {
	"This document can not be opened or printed."
	" It extends the functionality of AppleScript"
	"and should be placed in the Scripting Additions"
	"folder found in the Extensions folder of your"
	" System Folder."
};

resource 'aete' (0, "play movie") {
	/* 	
		The major and minor version fields refer to the
		'aete' definition. 
	*/
	0x1,		/* major version in BCD	*/
	0x0,		/* minor version in BCD	*/
	english,	/* language code */
	roman,		/* script code */
	{	/* array Suites: 1 elements */
		/* [1] */
		"The Olson OSAX Suite.", 	/* suite name */
		/* Suite Description */
		"A collection of fine Scripting Additions"
		" for work and play.",	/* suite description */
		'OLIE',					/* suite ID */
		1,						/* suite level */
		1,						/* suite version */
		{	/* array Events: 1 elements */
			/* [1] */
			"play movie",		/* event name */
			/* event description */
			"Play a QuickTime movie in a modal dialog.",	
			'OLIE',				/* Our Class */
			'QTIM',				/* Our ID */
			noReply,			/* No Reply */
			/* Reply comment. */
			"No reply is returned by this event.", 
			replyOptional,		/* Reply not required. */
			singleItem,			/* Reply is a single item. */
			notEnumerated,		/* Reply is not enumerated */
			reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved,
			'alis',				/* Direct param is alias. */
			/* Comment for direct parameter. */
			"Pass in path to the QuickTime movie to play.",
			directParamRequired,
			singleItem,
			notEnumerated,
			doesntChangeState,
			reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 2 elements */
				/* [1] */
				"at",			/* Optional parameter */
				'LOCA',			/* It's keyword. */
				'list',			/* It's type. */
				/* Comment for optional parameter. */
				"Point to use to position movie or rectangle"
				" to play move in. Must be in order 'left,"
				" top, right, bottom.",
				optional,		/* Optional parameter */
				listOfItems,	/* Must be a list. */
				notEnumerated,	/* is not enumerated */
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved,
				reserved,
				/* [2] */
				/*
					We define our optional parameter
					twice so that we can allow two
					different data types.
				*/
				"at",				/* Optional parameter */
				'LOCA',				/* It's keyword. */
				typeMyRectangle, 	/* It's type. */
				/* Comment for optional parameter. */
				"List of containing the top left corner"
				" or the entire rectange to display"
				" the QuickTime movie in.",
				optional,			/* Optional parameter */
				listOfItems,		/* Must be a list. */
				notEnumerated,		/* is not enumerated */
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved,
				reserved
			}
		},
		{	/* array Classes: 1 elements */
			/* [1] */
			/*
				This is how we define our custom
				record. We define a class 'rectangle'
				with the custom keyword typeMyRectangle.
				We then define properties of this class
				for each of our records labels.
			*/
			"rectangle",			/* Name of our class. */
			typeMyRectangle,		/* Type of our class. */
			/* Comment for optional parameter. */
			"This is a custom class definition used to "
			"define the record we use to position our "
			"movie's window.",
			{/* array Properties: 4 elements */
			/* [1] */
				"qttop",			/* Name of property. */
				'TOP ',				/* Keyword */
				typeMyRectangle,	/* It's type. */
				"Top of rectangle.",/* Comment field. */
				reserved,
				singleItem,
				notEnumerated,
				readOnly, 
				reserved, reserved, reserved, reserved, 
				reserved, reserved, reserved, reserved, 
				reserved, reserved, reserved, reserved,
				/* [2] */
				"qtright",			/* Name of property. */
				'RGHT',				/* Keyword */
				typeMyRectangle,	/* It's type. */
				/* Comment field. */
				"Right side of rectangle.",	
				reserved,
				singleItem,
				notEnumerated,
				readOnly, 
				reserved, reserved, reserved, reserved, 
				reserved, reserved, reserved, reserved, 
				reserved, reserved, reserved, reserved,
				/* [3] */
				"qtleft",			/* Name of property. */
				'LEFT',				/* Keyword */
				typeMyRectangle,	/* It's type. */
				/* Comment field. */
				"Left side of rectangle.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly, 
				reserved, reserved, reserved, reserved, 
				reserved, reserved, reserved, reserved, 
				reserved, reserved, reserved, reserved,
				/* [4] */
				"qtbottom",			/* Name of property. */
				'BOTM',				/* Keyword */
				typeMyRectangle,	/* It's type. */
				/* Comment field. */
				"Bottom of rectangle.", 
				reserved,
				singleItem,
				notEnumerated,
				readOnly, 
				reserved, reserved, reserved, reserved, 
				reserved, reserved, reserved, reserved, 
				reserved, reserved, reserved, reserved
			},
			{	/* array Elements: 0 elements */
			}
		},
		{	/* array ComparisonOps: 0 elements */
		},
		{	/* array Enumerations: 0 elements */
		}
	}
};

