unit MoireXMOD;

interface
	uses
		XModuleGlue;
	procedure main (theXmPtr: xmPtr);

implementation

	const
		areqDrawMoire = 8001;			{ our module-specific commands }
		areqCalcFactorial = 8002;

	procedure main (theXmPtr: xmPtr);

		{ ---------- required ----------- }

		procedure OpenXModule;
		begin
			{ One-time call.  Create any menus }
			{ and custom data structures here. }
		end;

		{ --------------------- }

		procedure CloseXModule;
		begin
			{ Release any memory and clean up. }
		end;

		{ --------------------- }

		procedure DoXmEvent;
		begin
			{ Respond to Mac events }
		end;

		{ --------------------- }

		procedure GetXmInfo;
			var
				nameStr, authorStr: str255;
		begin
			nameStr := 'Moir Module';
			authorStr := 'Rob Spencer  1993';
			theXmPtr^.param[1] := longint(NewString(nameStr));
			theXmPtr^.param[2] := longint(NewString(authorStr));
		end;

		{ ----------- unique ---------- }

		procedure DrawMoire;
		{ This was the entire external procedure in Experiment 3 }
			var
				tempRect: rect;
				tempStr: str255;
				tempLong: longint;
				theWindow: WindowPtr;
				i: integer;
				oldPort: GrafPtr;
		begin
			tempStr := 'External Module Window';
			SetRect(tempRect, 100, 100, 300, 300);
			theWindow := NewXMWindow(theXmPtr, tempRect, tempStr, noGrowDocProc);
			if theXmPtr^.result = xmSuccess then
				begin
					GetPort(oldPort);
					SetPort(theWindow);
					SetRect(tempRect, 99, 99, 100, 100);
					for i := 1 to 100 do
						begin
							InsetRect(tempRect, -2, -2);
							FrameOval(tempRect);
						end;
					DoBeep(theXmPtr, 3);
					Delay(60, tempLong);
					CloseXMWindow(theXmPtr, theWindow);
					SetPort(oldPort);
				end;
		end;

		{ --------------------- }

		procedure CalculateFactorial;
		{ Calculate the factorial of param[1], put the result in param[2]. }
			var
				n: integer;
				factorial: longint;
				tempStr: str255;
				tempStrHandle: StringHandle;
		begin
			n := theXmPtr^.param[1];
			if (n < 0) or (n > 12) then
				begin
					{ Error! return a readable message }
					{ so the app may inform the user.  }
					theXmPtr^.result := xmFail;
					tempStr := 'factorial input out-of-range';
					tempStrHandle := NewString(tempStr);
					Hlock(handle(tempStrHandle));
					theXmPtr^.param[1] := longint(handle(tempStrHandle));
				end
			else
				begin
					factorial := 1;
					while n > 1 do
						begin
							factorial := factorial * n;
							n := n - 1;
						end;
					theXmPtr^.param[2] := factorial;
				end;
		end;

		{ ---------- xmMain ---------- }

	begin
		if theXmPtr <> nil then				{ Dispatch the app's request }
			begin
				theXmPtr^.result := xmSuccess;	{ be optimistic }
				case theXmPtr^.request of
					areqOpen: 
						OpenXModule;
					areqClose: 
						CloseXModule;
					areqDoEvent: 
						DoXmEvent;
					areqGetInfo: 
						GetXmInfo;
					areqDrawMoire: 
						DrawMoire;
					areqCalcFactorial: 
						CalculateFactorial;
					otherwise
						theXmPtr^.result := xmUnknownAppRequest;
				end;
			end;
	end;

end.