unit XModuleGlue;

interface

	type
		xmPtr = ^xmBlock;
		xmBlock = record
				request: integer;
				result: integer;
				param: array[1..8] of longint;
				callbackAddr: ProcPtr;
			end;

	const
		xmSuccess = 0;
		xmFail = -1;
		xmUnknownAppRequest = -2;

		xreqNewXMWindow = 5001;
		xreqCloseXMWindow = 5002;
		xreqSysBeep = 5003;

		areqOpen = 7000;					{ required commands }
		areqClose = 7001;
		areqDoEvent = 7002;
		areqGetInfo = 7003;

	function NewXMWindow (theXmPtr: xmPtr; wBounds: rect; wTitle: str255; wType: integer): WindowPtr;
	procedure CloseXMWindow (theXmPtr: xmPtr; window: WindowPtr);
	procedure DoBeep (theXmPtr: xmPtr; numBeeps: integer);

implementation

	{ ------- glue routines -------- }

	procedure DoCallback (theXmPtr: xmPtr; addr: ProcPtr);
	inline
		$205F, $4E90;

	{ ------------------------------- }

	function NewXMWindow (theXmPtr: xmPtr; wBounds: rect; wTitle: str255; wType: integer): WindowPtr;
	begin
		with theXmPtr^ do
			begin
				request := xreqNewXMWindow;
				param[1] := longint(wBounds.topLeft);
				param[2] := longint(wBounds.botRight);
				param[3] := longint(@wTitle);
				param[4] := longint(wType);
				DoCallback(theXmPtr, callbackAddr);
				NewXMWindow := WindowPtr(param[5]);
				if param[5] = 0 then
					result := xmFail
				else
					result := xmSuccess;
			end;
	end;

	{ ------------------------------- }

	procedure CloseXMWindow (theXmPtr: xmPtr; window: WindowPtr);
	begin
		with theXmPtr^ do
			begin
				request := xreqCloseXMWindow;
				param[1] := longint(window);
				DoCallback(theXmPtr, callbackAddr);
			end;
	end;

	{ ------------------------------- }

	procedure DoBeep (theXmPtr: xmPtr; numBeeps: integer);
	begin
		with theXmPtr^ do
			begin
				request := xreqSysBeep;
				param[1] := longint(numBeeps);
				DoCallback(theXmPtr, callbackAddr);
			end;
	end;

	{ ------------------------------- }

end.