program ExperimentSixMain;
	{ A minimal but 'real' application to demonstate the }
	{ use of external code modules with callbacks.       }
	{ Application shell based on Apple's "Sample"        }
	{ Rob Spencer   1993 }

	uses
		Globals, AppUtils, XMGlobals, XMUtils, XMCallback;

{ ===== minimal Mac application code ===== }

	procedure Initialize;
		var
			ignoreError: OSErr;
			theWorld: SysEnvRec;
			menuBar: handle;
	begin
		MoreMasters;
		InitGraf(@thePort);
		InitFonts;
		InitWindows;
		InitMenus;
		TEInit;
		InitDialogs(nil);
		InitCursor;

		ignoreError := SysEnvirons(kSysEnvironsVersion, theWorld);
		if (theWorld.machineType < 0) or (theWorld.systemVersion < $604) then
			SimpleAlert(kEarlyMac, true);

		menuBar := GetNewMBar(rMenuBar);
		if menuBar = nil then
			SimpleAlert(kOutOfMemory, true);
		SetMenuBar(menuBar);
		DisposHandle(menuBar);
		AddResMenu(GetMHandle(mApple), 'DRVR');
		DrawMenuBar;
		gInBackground := false;
	end;

{ ------------------------------------------- }

	procedure DoMenuCommand (menuResult: longint);
		var
			menuID, menuItem, itemHit: integer;
			daName: str255;
			daRefNum: integer;
			handledByDA: boolean;
	begin
		menuID := HiWrd(menuResult);
		menuItem := LoWrd(menuResult);
		case menuID of
			mApple: 
				case menuItem of
					iAbout: 
						itemHit := Alert(rAboutAlert, nil);
					otherwise
						begin
							GetItem(GetMHandle(mApple), menuItem, daName);
							daRefNum := OpenDeskAcc(daName);
						end;
				end;
			mFile: 
				case menuItem of
					iQuit: 
						gAllDone := true;
					otherwise
				end;
			mEdit: 
				handledByDA := SystemEdit(menuItem - 1);

			otherwise
		end;
		HiliteMenu(0);
	end;

{ ------------------------------------------- }

	procedure DrawWindow (window: WindowPtr);
	begin
	end;

{ ------------------------------------------- }

	procedure DoContentClick (window: WindowPtr; event: EventRecord);
	begin
	end;

{ ------------------------------------------- }

	procedure DoUpdate (window: WindowPtr);
	begin
		if IsAppWindow(window) then
			begin
				BeginUpdate(window);
				if not EmptyRgn(window^.visRgn) then
					DrawWindow(window);
				EndUpdate(window);
			end;
	end;

{ ------------------------------------------- }

	procedure DoActivate (window: WindowPtr; becomingActive: boolean);
	begin
		if IsAppWindow(window) then
			if becomingActive then
			else
	end;

{ ------------------------------------------- }

	procedure DoAppEvent (event: EventRecord; menuResult: longint);
		var
			part, err: integer;
			window: WindowPtr;
			key: char;
	begin
		case event.what of
			mouseDown: 
				begin
					part := FindWindow(event.where, window);
					case part of
						inMenuBar: 
							DoMenuCommand(menuResult);
						inSysWindow: 
							SystemClick(event, window);
						inContent: 
							if window <> FrontWindow then
								SelectWindow(window)
							else
								DoContentClick(window, event);
						inDrag: 
							DragWindow(window, event.where, screenBits.bounds);
						inGrow: 
							;
						inZoomIn, inZoomOut: 
							;
						otherwise
					end;
				end;
			keyDown, autoKey: 
				begin
					key := chr(BAnd(event.message, charCodeMask));
					if (BAnd(event.modifiers, cmdKey) <> 0) and (event.what = keyDown) then
						DoMenuCommand(MenuKey(key));
				end;
			activateEvt: 
				DoActivate(WindowPtr(event.message), BAnd(event.modifiers, activeFlag) <> 0);
			updateEvt: 
				DoUpdate(WindowPtr(event.message));
			diskEvt: 
				if HiWrd(event.message) <> noErr then
					err := DIBadMount(point($00500070), event.message);
			kOSEvent: 
				case BAnd(BRotL(event.message, 8), $FF) of
					kSuspendResumeMessage: 
						begin
							gInBackground := BAnd(event.message, kResumeMask) = 0;
							DoActivate(FrontWindow, not gInBackground);
						end;
				end;
			otherwise
		end;
	end;

{ ================= main ================== }

	var
		event: EventRecord;
		menuResult: longint;
begin
	MaxApplZone;
	Initialize;
	gAllDone := false;

	gDebugMode := true;		{ *** note *** }
	gCallbackAddress := @CallbackDispatcher;
	InitXModules;

	repeat
		if WaitNextEvent(everyEvent, event, kSleepTime, nil) then
			if not DoExternalEvent(event, menuResult) then
				DoAppEvent(event, menuResult);
	until gAllDone;

	CloseXModules;
	Terminate;
end.