unit XMCallback;
	{ This unit stays in the parent application, in the main segment }
interface
	uses
		Globals, XMGlobals, XMUtils, AppUtils;

	procedure CallbackDispatcher (theXmPtr: xmPtr);

implementation

	{ ====== private to this unit ====== }

	procedure DoXreqGetMenu (theXmPtr: xmPtr);
		var
			i: integer;
			found: boolean;
			theMenu: MenuHandle;
			newMenuName, curMenuName: str255;
			tempXDRec: XmDataRecord;
	begin
		{	Look for the menu by name; if it already }
		{ exists, return its handle in param[2].   }

		found := false;
		i := mEdit + 1;
		newMenuName := StringPtr(theXmPtr^.param[1])^;
		repeat
			theMenu := GetMHandle(i);
			if theMenu <> nil then
				begin
					curMenuName := theMenu^^.menuData;
					found := EqualString(newMenuName, curMenuName, false, false);
				end;
			i := i + 1;
		until found or (theMenu = nil) or (i = mMaxMenuId);

		if found then
			begin
				theXmPtr^.param[2] := longint(theMenu);
				exit(DoXreqGetMenu);
			end;

		if i > mMaxMenuId then
			begin
				theXmPtr^.param[2] := 0;
				theXmPtr^.result := xmTooManyMenus;
				exit(DoXreqGetMenu);
			end;

		{ Otherwise create and name a new one. }
		{ Note that we don't draw it; the XMOD }
		{ will addd items and then draw it.    }

		theMenu := NewMenu(i - 1, newMenuName);
		theXmPtr^.param[2] := longint(theMenu);
		InsertMenu(theMenu, 0);

		{ Finally, register the new menu in the database. }

		tempXDRec := BlankXDRecord;
		with tempXDRec do
			begin
				xmResName := theXmPtr^.XMODResName;
				xmDataType := tMenuId;
				xmData := i - 1;
			end;

		if AddXmRecord(tempXDRec) <> noErr then
			SimpleAlert(kOutOFMemory, true);
	end;

	{ ------------------------------- }

	procedure DoXreqSetGlobal (theXmPtr: xmPtr);
	begin
	end;

	{ ------------------------------- }

	procedure DoXreqGetGlobal (theXmPtr: xmPtr);
	begin
	end;

	{ ------------------------------- }

	procedure DoXreqCountWindows (theXmPtr: xmPtr);
		var
			window: windowPtr;
			callingXMOD: OSType;
			justCallingXMODs: boolean;
			lenRec, numRecs, numFound: integer;
			offset: longint;
			tempXDRec: XmDataRecord;
	begin
		numFound := 0;
		with theXmPtr^ do
			begin
				justCallingXMODs := (param[1] = 1);

				{ search whole database }

				tempXDRec := BlankXDRecord;
				if gXmDatabase <> nil then
					begin
						lenRec := sizeOf(XmDataRecord);
						numRecs := GetHandleSize(gXmDatabase) div lenRec;
						offset := 0;
						repeat
							BlockMove(ptr(ord4(gXmDatabase^) + offset), @tempXDRec, lenRec);
							if (tempXDRec.xmDataType = tWindowPtr) then
								if not justCallingXMODs or (tempXDRec.xmResName = XMODResName) then
									numFound := numFound + 1;
							offset := offset + lenRec;
						until offset >= numRecs * lenRec;
					end;

				param[2] := numFound;
			end;
	end;

	{ ------------------------------- }

	procedure DoXreqGetIndWindow (theXmPtr: xmPtr);
		var
			window: windowPtr;
			callingXMOD: OSType;
			justCallingXMODs, isMatch, done: boolean;
			lenRec, numRecs, whichOne, numFound: integer;
			offset: longint;
			tempXDRec: XmDataRecord;
	begin
		numFound := 0;
		with theXmPtr^ do
			begin
				done := false;
				whichOne := param[1];
				justCallingXMODs := (param[2] = 1);

				{ search whole database }

				tempXDRec := BlankXDRecord;
				if gXmDatabase <> nil then
					begin
						lenRec := sizeOf(XmDataRecord);
						numRecs := GetHandleSize(gXmDatabase) div lenRec;
						offset := 0;
						repeat
							BlockMove(ptr(ord4(gXmDatabase^) + offset), @tempXDRec, lenRec);
							isMatch := false;
							if (tempXDRec.xmDataType = tWindowPtr) then
								isMatch := not justCallingXMODs or (tempXDRec.xmResName = XMODResName);
							if isMatch then
								begin
									numFound := numFound + 1;
									if whichOne = numFound then
										begin
											done := true;
											param[3] := tempXDRec.xmData;
											param[4] := longint(tempXDRec.xmResName);
										end;
								end;
							offset := offset + lenRec;
						until done or (offset >= numRecs * lenRec);
					end;
			end;
	end;

	{ ====== the only re-entry point for external callbacks (xreq's) ====== }

	procedure CallbackDispatcher (theXmPtr: xmPtr);
	{ Must be in the main segment; don't let this move or be purged! }
		var
			tempRect: rect;
			tempStr: str255;
			tempInt: integer;
			tempXDRec: XmDataRecord;
	begin
		if theXmPtr <> nil then
			with theXmPtr^ do
				case request of

					xreqNewXMWindow: 
						begin
							tempRect.topLeft := point(param[1]);
							tempRect.botRight := point(param[2]);
							tempStr := StringPtr(param[3])^;			{ window title }
							tempInt := param[4];									{ window type  }
							param[5] := longint(NewWindow(nil, tempRect, tempStr, false, tempInt, windowPtr(-1), true, 0));

							{ Now add this window to the database.}
							tempXDRec := BlankXDRecord;
							tempXDRec.xmResName := theXmPtr^.XMODResName;
							tempXDRec.xmData := param[5];
							tempXDRec.xmDataType := tWindowPtr;
							if AddXmRecord(tempXDRec) <> noErr then
								SimpleAlert(kOutOfMemory, true);
						end;

					xreqCloseXMWindow: 
						begin
							if param[1] <> 0 then
								DisposeWindow(windowPtr(param[1]));
						end;

					xreqGetMenu: 
						DoXreqGetMenu(theXmPtr);
					xreqCountWindows: 
						DoXreqCountWindows(theXmPtr);
					xreqGetIndWindow: 
						DoXreqGetIndWindow(theXmPtr);
					xreqSimpleAlert: 
						begin
							tempStr := StringPtr(param[1])^;
							SimpleAlert(tempStr, false);
						end;

					{ *** Not done *** }

					xreqSetGlobal: 
						DoXreqSetGlobal(theXmPtr);
					xreqGetGlobal: 
						DoXreqGetGlobal(theXmPtr);

					otherwise
					{ unknown callback request }
				end;
	end;

	{ ------------------------------- }

end.