unit appUtils;
interface
	uses
		Globals;

	procedure SimpleAlert (message: str255; isFatal: boolean);
	function IsDAWindow (window: WindowPtr): boolean;
	function IsAppWindow (window: WindowPtr): boolean;
	procedure CloseOneWindow (window: WindowPtr);
	procedure Terminate;

implementation

 { ------------------------------------------- }

	procedure SimpleAlert (message: str255; isFatal: boolean);
		var
			itemHit: integer;
	begin
		ParamText(message, '', '', '');
		InitCursor;
		itemHit := CautionAlert(rUserAlert, nil);
		if isFatal then
			ExitToShell;
	end;

 { ------------------------------------------- }

	function IsDAWindow (window: WindowPtr): boolean;
	begin
		if window = nil then
			IsDAWindow := false
		else
			IsDAWindow := WindowPeek(window)^.windowKind < 0;
	end;

 { ------------------------------------------- }

	function IsAppWindow (window: WindowPtr): boolean;
	begin
		if window = nil then
			IsAppWindow := false
		else
			with WindowPeek(window)^ do
				IsAppWindow := (windowKind = userKind);
	end;

 { ------------------------------------------- }

	procedure CloseOneWindow (window: WindowPtr);
	begin
		if IsDAWindow(window) then
			CloseDeskAcc(WindowPeek(window)^.windowKind);
		if IsAppWindow(window) then
			CloseWindow(window);
	end;

 { ------------------------------------------- }

	procedure Terminate;
	{ ** Don't close THINK's windows during development! ** }
		var
			window, nextW: WindowPtr;
	begin
		window := FrontWindow;
{   while window <> nil do }
{    begin }
{     nextW := WindowPtr(WindowPeek(window)^.nextWindow); }
{       if window = myKnownWindow then  }
{        CloseOneWindow(window)  }
{       else  }
{        nextW := nil; }
{     window := nextW; }
{    end; }

	end;

 { ------------------------------------------- }

 { ------------------------------------------- }

end.