/* Header file to accompany simple 2D graphics 
 * J. M. Anderson, September 1991
 */


#ifndef _2DGRAPHICS
#define _2DGRAPHICS

typedef struct
{
	float x, y;
} FPOINT;

typedef struct
{
	float left, bottom, right, top;
} FRECT;

/* **********  GLOBAL VARIABLES ************* */
extern FRECT world;
extern Rect  vp;

extern void view_window(float x0, float y0, float x1, float y1);
extern void view_port(short x0, short y0, short x1, short y1);
extern Point world_to_vp(FPOINT z);
extern FPOINT vp_to_world(Point z);
extern void wLineTo(float x, float y);
extern void wMoveTo(float x, float y);
extern void wFrameRect(FRECT *box);
extern void wDrawPoly(FPOINT vertexList[], int nVertices, Pattern pat);
extern void wFramePoly(FPOINT vertexList[], int nVertices);
extern void wDrawPoint(FPOINT z, Boolean open);

#endif