/* Main_Shooter */

/* Program name:  Main_Shooter   
 Function:  This is the main module for this program.  
History: 5/6/93 Original by Jay Anderson
   */

#include "PComUtil_Shooter.h"	/* Common */

#include "PD_About.h"	/* Modal Dialog */
#include "PMD_Set_Up_Problem.h"	/* Modeless Dialog */
#include "PW_Particle_in_a_B.h"	/* Window */
#include "PMenu_Shooter.h"	/* Menus */

Boolean		DoIt;
short		code;
WindowPtr	whichWindow;
long		mResult;
short		theMenu,theItem;
Boolean		Is_A_Dialog;
short		charCode, itemHit;
char		ch;
Boolean		DoTheModelessEvent, CmdDown;
WindowPeek	thePeeked;

/* Handle key strokes */
static void DoKeyEvent(void);

/* Handle a diskette inserted */
static void DoDiskEvent(void);

/* Handle a window being resized */
static void DoGrow(WindowPtr whichWindow);

/* Handle a window being dragged */
static void DoDrag(WindowPtr whichWindow);

/* Handle a window goaway box */
static void DoGoAway(WindowPtr whichWindow);

/* Handle an update to the window */
static void DoUpdate(void);


/* MAIN entry point */
void main(void);

/* Handle the OS event */
void DoOSEvent(EventRecord *myEvent);


/* Routine: DoOSEvent */
/* Purpose: Handle DoOSEvents */

void DoOSEvent(EventRecord *myEvent)
{

	if (((myEvent->message & osEvtMessageMask) >> 24) == suspendResumeMessage)
	{
		if ((myEvent->message & resumeFlag) == 0)
		{
			InTheForeground = FALSE;
		}
		else
		{
			InTheForeground = TRUE;
		}
	}
}

/* ======================================================= */

/* ======================================================= */

/* Routine: WNEIsImplemented */
/* Purpose: See if the MultiFinder trap, WaitNextEvent, is available */

Boolean IsWNEIsImplemented()
{
	#define	WNETrapNumber	0xA860
	#define	kGestaltTrapID	0xA1AD

	SysEnvRec	theWorld;
	OSErr	discardError;
	Boolean	theWNEIsImplemented;
	long	result;

	Black_ForeColor.red = 0x0000;  Black_ForeColor.green = 0x0000;  Black_ForeColor.blue = 0x0000;  
	White_BackColor.red = 0xFFFF;  White_BackColor.green = 0xFFFF;  White_BackColor.blue = 0xFFFF;  

	HasColorQD = FALSE;
	HasFPU = FALSE;
	HasAppleEvents = FALSE;
	HasAliasMgr = FALSE;
	HasEditionMgr = FALSE;
	HasGestalt = FALSE;
	HasNewStdFile = FALSE;
	HasPPCToolbox = FALSE;
	Has32BitQuickDraw = FALSE;
	InTheForeground = TRUE;
	discardError = SysEnvirons(1, &theWorld);
	if (theWorld.machineType < 0)
	{
		theWNEIsImplemented = FALSE;
	}
	else
	{
		theWNEIsImplemented = CheckTrapAvailable(WNETrapNumber, ToolTrap);
		HasColorQD = theWorld.hasColorQD;
		HasFPU = theWorld.hasFPU;
			HasGestalt = CheckTrapAvailable(kGestaltTrapID, ToolTrap);
			if (HasGestalt)
			{
				discardError = Gestalt(gestaltAliasMgrAttr,&result);
				if ((discardError == 0) && ((result & (0x00000001 << gestaltAliasMgrPresent)) != 0))
					HasAliasMgr = TRUE;

				discardError = Gestalt(gestaltEditionMgrAttr,&result);
				if ((discardError == 0) && ((result & (0x00000001 << gestaltEditionMgrPresent)) != 0))
					HasEditionMgr = TRUE;

				discardError = Gestalt(gestaltAppleEventsAttr,&result);
				if ((discardError == 0) && ((result & (0x00000001 << gestaltAppleEventsPresent)) != 0))
					HasAppleEvents = TRUE;

				discardError = Gestalt(gestaltPPCToolboxAttr,&result);
				if ((discardError == 0) && ((result & (0x00000001 << gestaltPPCToolboxPresent)) != 0))
					HasPPCToolbox = TRUE;

				discardError = Gestalt(gestaltQuickdrawVersion,&result);
				if ((discardError == 0) && ((result & gestalt32BitQD) != 0))
					Has32BitQuickDraw = TRUE;

				discardError = Gestalt(gestaltStandardFileAttr,&result);
				if ((discardError == 0) && ((result & (0x00000001 << gestaltStandardFile58)) != 0))
					HasNewStdFile = TRUE;
			}
		}
		return(theWNEIsImplemented);
}

/* ======================================================= */

/* Routine: Handle_User_Event */
/* Purpose: Check for user events */

void Handle_User_Event()
{
	UserEventRec	TheUserEvent;

	GetUserEvent(&TheUserEvent);
	if (TheUserEvent.ID != UserEvent_None)
	{

		switch (TheUserEvent.ID)
		{
			case UserEvent_Open_Window: 
				switch (TheUserEvent.ID2)
				{
					case Res_D_About:
						MPD_About();
						break;
					case Res_W_Particle_in_a_B: 
						Open_Particle_in_a_B();
						break;
					case Res_MD_Set_Up_Problem:
						Open_Set_Up_Problem();
						break;
					default:
						break;
				}
				break;

			case UserEvent_Close_Window: 
				switch (TheUserEvent.ID2) {
					case Res_W_Particle_in_a_B:
						Close_Particle_in_a_B(WPtr_Particle_in_a_B);
						break;
					case Res_MD_Set_Up_Problem:
						Close_Set_Up_Problem(WPtr_Set_Up_Problem);
						break;
					default:
						break;
				}

				break;
			default:
				break;
		}
	}
}

/* ======================================================= */

/* Routine: DoKeyEvent */
/* Purpose: Handle a key pressed */

static void DoKeyEvent()
{
	short	charCode;
	char	ch;
	long	mResult;
	short	theMenu,theItem;

	charCode = myEvent.message & charCodeMask;
	ch = (char)charCode;

	if ((myEvent.modifiers & cmdKey) != 0)
	{
		mResult = MenuKey(ch);
		theMenu = HiWord(mResult);
		theItem = LoWord(mResult);
		if (theMenu != 0)
			Handle_My_Menu(theMenu, theItem);

		if (((ch == 'x') || (ch == 'X')) && (theInput != NIL))
			TECut(theInput);
		if (((ch == 'c') || (ch == 'C')) && (theInput != NIL))
			TECopy(theInput);
		if (((ch == 'v')  ||  (ch == 'V')) && (theInput != NIL))
			TEPaste(theInput);
	}
	else if (theInput != NIL)
		TEKey(ch,theInput);

}

/* ======================================================= */

/* Routine: DoDiskEvent */
/* Purpose: Handle a diskette inserted */

static void DoDiskEvent()
{
	short	theError;

	if (HiWord(myEvent.message) != noErr)
	{
		myEvent.where.h = ((screenBits.bounds.right - screenBits.bounds.left) / 2) - (304 / 2);
		myEvent.where.v = ((screenBits.bounds.bottom - screenBits.bounds.top) / 3) - (104 / 2);
		InitCursor();
		theError = DIBadMount(myEvent.where, myEvent.message);
	}

}

/* ======================================================= */

/* Routine: DoGrow */
/* Purpose: Handle a window resize */

static void DoGrow(WindowPtr whichWindow)
{
	Rect	OldRect;
	Point	myPt;
	Rect	GrowRect;
	long	mResult;
	long	theRefCon;

	if (whichWindow != nil)
	{
		SetPort(whichWindow);

		myPt = myEvent.where;
		GlobalToLocal(&myPt);

		OldRect = whichWindow->portRect;

		SetRect(&GrowRect, 4, 4, (screenBits.bounds.right - screenBits.bounds.left)-4,  (screenBits.bounds.bottom - screenBits.bounds.top) - 4);
		mResult = GrowWindow(whichWindow, myEvent.where, &GrowRect);
		SizeWindow(whichWindow, LoWord(mResult), HiWord(mResult), true);


		SetPort(whichWindow);

		myPt.h = whichWindow->portRect.right - whichWindow->portRect.left;
		myPt.v = whichWindow->portRect.bottom - whichWindow->portRect.top;

		SetRect(&GrowRect, 0, OldRect.bottom - 15, OldRect.right + 15, OldRect.bottom + 15);
		EraseRect(&GrowRect);
		InvalRect(&GrowRect);

		SetRect(&GrowRect, OldRect.right - 15, 0, OldRect.right + 15, OldRect.bottom + 15);
		EraseRect(&GrowRect);
		InvalRect(&GrowRect);

		DrawGrowIcon(whichWindow);
	}
}

/* ======================================================= */

/* Routine: DoDrag */
/* Purpose: Drag a window around */

static void DoDrag(WindowPtr whichWindow)
{
	Rect	OldRect;
	Rect	tempRect;
	long	theRefCon;

	OldRect = whichWindow->portRect;

	tempRect = screenBits.bounds;
	SetRect(&tempRect,tempRect.left+4,tempRect.top+4,tempRect.right-4,tempRect.bottom - 4);
	DragWindow(whichWindow, myEvent.where, &tempRect);

	theRefCon = GetWRefCon(whichWindow);
	switch (theRefCon)
	{
		case Res_W_Particle_in_a_B:
			Moved_Particle_in_a_B(&OldRect, whichWindow);
			break;
		case Res_MD_Set_Up_Problem:
			Moved_Set_Up_Problem(&OldRect, whichWindow);
			break;
		default:
			break;
	}
}

/* ======================================================= */

/* Routine: DoGoAway */
/* Purpose: Close a window */

static void DoGoAway(WindowPtr whichWindow)
{
	long	theRefCon;

	if (TrackGoAway(whichWindow,myEvent.where))
	{
		theRefCon = GetWRefCon(whichWindow);
		switch (theRefCon)
		{
			case Res_W_Particle_in_a_B:
				Close_Particle_in_a_B(whichWindow);
				break;
			case Res_MD_Set_Up_Problem:
				Close_Set_Up_Problem(whichWindow);
				break;
			default:
				break;
		}
	}
}

/* ======================================================= */

/* Routine: DoInContent */
/* Purpose: Pressed in the content area */

static void DoInContent(WindowPtr whichWindow,EventRecord *myEvent)
{
	long	theRefCon;

	if (whichWindow != FrontWindow())
	{
		SelectWindow(whichWindow);
	}
	else
	{
		SetPort(whichWindow);
		theRefCon = GetWRefCon(whichWindow);
		switch (theRefCon)
		{
			case Res_W_Particle_in_a_B:
				Do_Particle_in_a_B(myEvent);
				break;
			default:
				break;
		}
	}
}

/* ======================================================= */

/* Routine: DoUpdate */
/* Purpose: Got an update event */

static void DoUpdate()
{
	WindowPtr	whichWindow;
	long	theRefCon;

	whichWindow = (WindowPtr)myEvent.message;

	BeginUpdate(whichWindow);
	theRefCon = GetWRefCon(whichWindow);
	switch (theRefCon)
	{
		case Res_W_Particle_in_a_B:
			Update_Particle_in_a_B(whichWindow);
			break;
		default:
			break;
	}
	EndUpdate(whichWindow);
}

/* ======================================================= */

/* Routine: DoActivate */
/* Purpose: Got an activate or deactivate event */

void DoActivate()
{
	WindowPtr	whichWindow;
	Boolean	Do_An_Activate;
	long	theRefCon;

	whichWindow = (WindowPtr)myEvent.message;

	Do_An_Activate =  ((myEvent.modifiers & 0x0001) != 0);
	theRefCon = GetWRefCon(whichWindow);
	switch (theRefCon)
	{
		case Res_W_Particle_in_a_B:
			Activate_Particle_in_a_B(whichWindow,Do_An_Activate);
			break;
		default:
			break;
	}
}

/* ======================================================= */

/* ======================================================= */
/* ======================================================= */

 void main()
{

	MoreMasters();
	MaxApplZone();
	InitGraf(&thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);

	FlushEvents(everyEvent , 0);
	InitCursor();

	/* THE FOLLOWING WAS TAKEN FROM "MOVIE CONSTRUCTION" PROVIDED
	 * BY THE QUICKTIME FOLKS AT APPLE
	 * *************** */
	ErrorCode = EnterMovies();	
	/* Don't forget this.  Real men use Alert Dialogs */
	if (ErrorCode) 
	{
		canMakeMovie = FALSE;
		DebugStr((StringPtr) "\pEnterMovies Failed");
	}
	else
		canMakeMovie = TRUE;

	doneFlag = FALSE;
	readyToRun = FALSE;

	Init_My_Menus();

	theInput = nil;

	SleepValue = 40;
	WNE = IsWNEIsImplemented();

	UserEventList = nil;

	cursorRgn = NewRgn();

	I_PD_About();
	Init_Particle_in_a_B();
	Init_Set_Up_Problem();

	Open_Set_Up_Problem();

	do
	{

		Handle_User_Event();

		if (theInput != NIL)
		{
			TEIdle(theInput);
		}

		if (WNE)
		{
			DoIt = WaitNextEvent(everyEvent, &myEvent, SleepValue, cursorRgn);
		}
		else
		{
			SystemTask();
			DoIt = GetNextEvent(everyEvent, &myEvent);
		}

		if (DoIt)
		{

			Is_A_Dialog = IsDialogEvent(&myEvent);
			if (Is_A_Dialog == TRUE)
			{
				 if (myEvent.what == updateEvt)
				{
					whichWindow = (WindowPtr)myEvent.message; 
					BeginUpdate(whichWindow);
					Update_Set_Up_Problem(whichWindow);
					EndUpdate(whichWindow);
				}
				else
				{
					DoTheModelessEvent = TRUE;

					if (myEvent.what == keyDown) 
					{
						CmdDown = ((myEvent.modifiers / cmdKey) & 1);
						charCode = myEvent.message & charCodeMask;
						ch = (char)charCode;

						if ((charCode == 13) || (charCode == 0x03))
							DoTheModelessEvent = TRUE;

						if (CmdDown != 0)
						{
							mResult = MenuKey(ch);
							theMenu = HiWord(mResult);
							theItem = LoWord(mResult);
							if (theMenu != 0)  
								Handle_My_Menu(theMenu, theItem); 

							whichWindow = FrontWindow(); 
							if ((ch == 'x') || (ch == 'X'))
								DlgCut(whichWindow);
							if ((ch == 'c') || (ch == 'C'))
								DlgCopy(whichWindow);
							if ((ch == 'v') || (ch == 'V'))
								DlgPaste(whichWindow);

							DoTheModelessEvent = FALSE;
						}
					}

					if (DoTheModelessEvent == TRUE) 
					{
						if ((DialogSelect(&myEvent, &whichWindow, &itemHit)) || (myEvent.what == mouseDown) || (myEvent.what == keyDown)) 
						{

							Do_Set_Up_Problem(&myEvent,whichWindow,itemHit);
						}
					}
				}
			}
			else
			{

				switch (myEvent.what)
				{
					case mouseDown :
						code = FindWindow(myEvent.where, &whichWindow);

						switch (code)
						{
							case inMenuBar :
								mResult = MenuSelect(myEvent.where);
								theMenu = HiWord(mResult);
								theItem = LoWord(mResult);
								Handle_My_Menu( theMenu, theItem);
								break;

							case inDrag :
								DoDrag(whichWindow);
								break;

							case inGrow :
								DoGrow(whichWindow);
								break;

							case inGoAway :
								DoGoAway(whichWindow);
								break;

							case inContent :
								DoInContent(whichWindow,&myEvent);
								break;

							case inSysWindow :
								SystemClick(&myEvent, whichWindow);
								break;

							default:
								break;
						}
						break;

					case keyDown:
					case autoKey:
						DoKeyEvent();
						break;

					case updateEvt :
						DoUpdate();
						break;

					case diskEvt :
						DoDiskEvent();
						break;

					case activateEvt :
						DoActivate();
						break;

					case osEvt:
						DoOSEvent(&myEvent);
						break;

					default:
						break;

				}

			}
	}
	else
	{
		whichWindow = FrontWindow();
		if (whichWindow != NIL)
		{
			thePeeked = (WindowPeek)whichWindow;
			if (thePeeked->windowKind == dialogKind)
			{
				if (DialogSelect(&myEvent, &whichWindow, &itemHit))
				{
				}
			}
		}
	}
}
while (doneFlag == FALSE);


}
