/*   PComUtil_Shooter

/* Name:  PComUtil_Shooter.c */
/* Function:  Common for the Marksman specific code. */
/* History: 5/6/93 Original by Jay Anderson */


#include "PComUtil_Shooter.h"	/* Common */
/* ======================================================= */

UserEventHRec	UserEventList;
EventRecord	myEvent;
Boolean	WNE;
short	SleepValue;
Boolean	doneFlag;
TEHandle	theInput;
Rect	tempRect;
Str255	sTemp;
Boolean		HasColorQD;
Boolean		HasFPU;
Boolean		HoldOffUserEvents;
Boolean		InTheForeground;
short		tempChar;
long		LTemp;
RGBColor		Black_ForeColor,White_BackColor;

SFTypeList	typeList;
OSErr		ErrorCode;
SFReply	Reply;
StandardFileReply	theStandardFileReply;
short	inputRefNum;
short	outputRefNum;
Str255 inputFileName;
Str255 outputFileName;

RgnHandle	cursorRgn;
Boolean		HasAppleEvents;
Boolean		HasAliasMgr;
Boolean		HasEditionMgr;
short		ReplyMode;
Boolean		HasNewStdFile;
Boolean		HasPPCToolbox;
Boolean		Has32BitQuickDraw;
Boolean		HasGestalt;

THPrint	hPrint;
Boolean	PrinterIsOpen;
short	PageCount;
short	LineCount;
short	PrinterVRes,PrinterHRes;
short	MaxPrintCharacters;
short	MaxLines;
TPPrPort		pPrPort;
TPrStatus		prStatus;
short	CopyCount;

MenuHandle	Menu_Apple;
MenuHandle	Menu_File;
MenuHandle	Menu_Edit;

/* Variables for the modal dialog titled  "About" */

/* Window variables for the window titled  "Particle in a Box" */
WindowPtr	WPtr_Particle_in_a_B;
ControlHandle	Ctrl_EVals;
Rect	HotRect_EVals;
ControlHandle	Ctrl_RectA;
Rect	HotRect_RectA;
ControlHandle	Ctrl_RectPsi;
Rect	HotRect_RectPsi;
ControlHandle	Ctrl_RectE;
Rect	HotRect_RectE;

/* Variables for the modeless dialog titled  "Set Up Problem" */
WindowPtr	WPtr_Set_Up_Problem;
short	DRSelected_G1_Set_Up_Problem;
Rect	DTE_Rect_TestValue;
Rect	DTE_Rect_Avalue;
Rect	DHotRect_Rect_hotspot1;

/* Variables for the Particle in a Box Problem */
double	energyA;				/* potential barrier */
double	energyE;				/* trial eigenvalue */
double 	eigenvalues[5];			/* eigenvalues found */
Boolean	justOne;				/* looking for just one? */
Boolean readyToRun;				/* finished set up, want to run */
double	energyENear;			/* energy eigenvalue near to ? */
GWorldPtr	offPort1, offPort2;
Rect	offRect;
RGBColor	bkgdColor, forbidColor, allowColor;

/* Variables for making movies */
/* most are copied from Movie Construction */
Boolean				canMakeMovie, makingMovie;
Movie				gMovie;
Track				gTrack;
Media				gMedia;
GWorldPtr			myGWorld, oldGWorld;
GDHandle			oldGDevice;
Rect				offGRect;
PixMap				*pm, **pmH;
char				**compressedFrameBitsH;
long				maxCompressedFrameSize;
long				compressedFrameSize;
CodecType			codecType;
CompressorComponent	codecID;
short				theDepth;
CodecQ				theQuality, mQuality;
ImageDescription	**imageDescriptionH;
ImageSequence		seqID;
unsigned char		similarity;
long				keyFrameRate;
TimeValue			sampTime;

 

/* Prototypes */

/* Handle an activate of the window */
void DoActivate(void);

/* See if WaitNextEvent is available */
Boolean IsWNEIsImplemented(void);

/* Check for user events */
void Handle_User_Event(void);

/* Handle a hit in the window */
void DoInContent(WindowPtr whichWindow,EventRecord *myEvent);


/* Routine: Close_The_Output_File */
/* Purpose: Close the output file */

void Close_The_Output_File()
{
	short resID = 1;
	
	/* copied from "Movie Construction" */
	ErrorCode = CDSequenceEnd(seqID);
	if (ErrorCode) DebugStr((StringPtr) "\pCDSequenceEnd Failed");
	ErrorCode = EndMediaEdits(gMedia);
	if (ErrorCode) DebugStr((StringPtr) "\pEndMediaEdits Failed");
	ErrorCode = InsertMediaIntoTrack(gTrack, 0L, 0L, GetMediaDuration(gMedia), x1Rate);
	if (ErrorCode) DebugStr((StringPtr) "\pInsertMediaIntoTrack Failed");
	ErrorCode = AddMovieResource(gMovie, outputRefNum, &resID, outputFileName);
	if (ErrorCode) DebugStr((StringPtr) "\pAddMovieResource Failed");
	ErrorCode = MakeFilePreview(outputRefNum, (ProgressProcRecordPtr)-1);
	ErrorCode = CloseMovieFile(outputRefNum);
	if (ErrorCode) DebugStr((StringPtr) "\pCloseMovieFile Failed");

	outputRefNum = 0;
	
	/* throw out everything else */
	DisposeMovie(gMovie);
	DisposHandle(compressedFrameBitsH);
	DisposHandle((Handle)imageDescriptionH);
	DisposeGWorld(myGWorld);
}

/* ======================================================= */

/* Routine: Save_The_File */
/* Purpose: Save the file */

void Save_The_File()
{
	short	theVolRefNum;
	short	theRefNum;
	
	if (Do_The_Save_File((Str255 *)"\pSave Movie as:",(Str255 *)"\pUntitled.qt",
		&theVolRefNum,&theRefNum))
	{
		/* copied from Movie Construction kit */
		ClearMoviesStickyError();
		gTrack = NewMovieTrack
			(gMovie, 
			 (long)(318)<<16,		/* width & height copied from resource */ 
			 (long)(219)<<16,
			 0);
		ErrorCode = GetMoviesError();
		if (ErrorCode) DebugStr((StringPtr) "\pNewMovieTrack Failed");
		gMedia = NewTrackMedia(gTrack, VideoMediaType, myTimeScale, 
				 nil, (OSType)nil);
		ErrorCode = GetMoviesError();
		if (ErrorCode) DebugStr((StringPtr)"\pNewTrackMedia Failed");
		ErrorCode = BeginMediaEdits(gMedia);
		if (ErrorCode) DebugStr((StringPtr)"\pBeginMediaEdits Failed");
		
		/* Make a new GWorld into which to draw frames to be compressed */
		SetRect(&offGRect, 0, 0, 318, 219);	/* copied from resource */
		GetGWorld(&oldGWorld, &oldGDevice);
		ErrorCode = NewGWorld(&myGWorld, 8, &offGRect, nil, nil, 0);
		if (ErrorCode) DebugStr((StringPtr)"\pNewGWorld Failed");
		pmH = myGWorld->portPixMap;
		LockPixels(pmH);
		HLock((Handle)pmH);
		pm = *pmH;
		
		/* Make Buffers & stuff for the compressor */
		codecID = anyCodec;
		codecType = (CodecType)'rpza';
		theDepth = 1;
		theQuality = 0x300;
		mQuality = 0x300;
		keyFrameRate = 10;
		imageDescriptionH = (ImageDescription **)NewHandle(4);
		ErrorCode = GetMaxCompressionSize(&pm, &offGRect, theDepth, theQuality,
			codecType, codecID, &maxCompressedFrameSize);
		if (ErrorCode) DebugStr((StringPtr)"\pGetMaxCompressionSize Failed");
		compressedFrameBitsH = NewHandle(maxCompressedFrameSize);
		if (!compressedFrameBitsH) 
			DebugStr((StringPtr)"\pUnable to allocate compression buffer");
		HLock(compressedFrameBitsH);
		
		/* Tell codec manager we are about to start a sequence */
		ErrorCode = CompressSequenceBegin
			(&seqID, &pm, nil, &offGRect, nil, theDepth, codecType,
			 codecID, theQuality, mQuality, keyFrameRate, nil, 
			 codecFlagUpdatePrevious, imageDescriptionH);
		if (ErrorCode) DebugStr((StringPtr)"\pCompressSequenceBegin Failed");
		
		/* now, back in the mainstream, we can put the movie together one frame
		 * at a time *****/
		SetGWorld(oldGWorld, oldGDevice);
		makingMovie = TRUE;
	}
}

/* ======================================================= */
/* ======================================================= */


/* Routine: PStrCopy */
/* Purpose: Copy Pascal strings */

void PStrCopy(Str255 *SourceString, Str255 *DestString)
{

	*DestString[0] = *SourceString[0];
	if (*DestString[0] != 0)
		BlockMove(SourceString,DestString,*DestString[0]+1);
}

/* ======================================================= */

/* Routine: PStrCat */
/* Purpose: Concat Pascal strings */

void PStrCat(Str255 *SourceString, Str255 *DestString)
{
	short	OldDestLength,NewDestLength,SizeFromSource;

	OldDestLength = *DestString[0];
	SizeFromSource = *SourceString[0];
	NewDestLength = OldDestLength + SizeFromSource;
	if (NewDestLength > 255)
	{
		NewDestLength = 255;
		SizeFromSource = 255 - OldDestLength;
	}
	*DestString[0] = NewDestLength;
	if (SizeFromSource > 0)
		BlockMove((Ptr)((long)SourceString + 1L),(Ptr)((long)DestString+OldDestLength+1L),SizeFromSource);
}

/* ======================================================= */

/* Routine: PStrCmp */
/* Purpose: Compare Pascal strings for exact match, case sensitive */

Boolean PStrCmp(StringPtr Source1String,StringPtr Source2String)
{
	short		theLength,Index;
	Boolean		theSame;

	theSame = false;
	theLength = *Source1String++;
	if (theLength == *Source2String++)
	{
		theSame = true;
		for (Index=1; Index <= theLength; Index++)
		{
			if (*Source1String++ != *Source2String++)
			{
				theSame = false;
			}
		}
	}
}

/* ======================================================= */

/* Routine: CheckTrapAvailable */
/* Purpose: See if trap is available, non-available traps all have a unique address */

Boolean CheckTrapAvailable (short trapNumber,short tType)
{
	#define UnimplementedTrapNumber 	0xA89F
	Boolean	theResult;

	theResult = (NGetTrapAddress(trapNumber, tType) != GetTrapAddress(UnimplementedTrapNumber));
	return(theResult);
}

/* ======================================================= */

/* Routine: GetUserEvent */
/* Purpose: See if any user events are available */

void GetUserEvent(UserEventPRec TheUserEvent)
{ 
	UserEventHRec	NextUserEvent;

	TheUserEvent->ID = UserEvent_None;
	if (UserEventList != NIL)
	{
		HLock((Handle)UserEventList);
		TheUserEvent->ID = (*UserEventList)->ID;
		TheUserEvent->ID2 = (*UserEventList)->ID2;
		TheUserEvent->Data1 = (*UserEventList)->Data1;
		TheUserEvent->Data2 = (*UserEventList)->Data2;
		TheUserEvent->theHandle = (*UserEventList)->theHandle;
		NextUserEvent = (*UserEventList)->Next;

		DisposHandle((Handle)UserEventList);
		UserEventList = NextUserEvent;
	}
}

/* ======================================================= */

/* Routine: Add_UserEvent */
/* Purpose: Add a user event */

void Add_UserEvent(short ID1,short  ID2,long Data1,long Data2,Handle  theHandle)
{ 
	UserEventHRec	NewUserEvent;
	UserEventHRec	theUserEvent;

	NewUserEvent = (UserEventHRec)NewHandle(sizeof(UserEventRec));
	if (NewUserEvent != NIL)
	{
		HLock((Handle)NewUserEvent);
		(*NewUserEvent)->ID = ID1;
		(*NewUserEvent)->ID2 = ID2;
		(*NewUserEvent)->Data1 = Data1;
		(*NewUserEvent)->Data2 = Data2;
		(*NewUserEvent)->theHandle = theHandle;
		(*NewUserEvent)->Next = NIL;

		if (UserEventList == NIL)
		{
			UserEventList = NewUserEvent;
		}
		else
		{
			theUserEvent = UserEventList;
			while ((*theUserEvent)->Next != NIL)
			{
				theUserEvent = (*theUserEvent)->Next;
			}
			(*theUserEvent)->Next = NewUserEvent;
		}
	}
}

/* ======================================================= */

/* Routine: Get_TE_String */
/* Purpose: This is a routine used to get a string from a TE area, limited to 250 characters */

void Get_TE_String(TEHandle theTEArea,Str255 *theString)
{ 
	short Index;
	short TitleLength;
	CharsHandle theCharsHandle;
	Ptr theStringPtr;
	Ptr theTECharPtr;

	theCharsHandle = TEGetText(theTEArea);
	HLock ( ( Handle ) theCharsHandle );
	theTECharPtr = (Ptr)*theCharsHandle;
	TitleLength = (*theTEArea)->teLength;
	*theString[0] = 0;
	if (TitleLength > 0) 
	{
		theStringPtr = (Ptr)((long)theString + (long)1);
		if (TitleLength > 250) 
			TitleLength = 250;
		for (Index = 0; Index < TitleLength; Index++)
			*theStringPtr++ = (char)(*theTECharPtr++);
		*theString[0] = TitleLength;
	}
}

/* ======================================================= */

/* Routine: Make_TE_Area */
/* Purpose: This is a routine used to create a TE area */

void Make_TE_Area(TEHandle *theTEArea,Rect *Position,short theFontSize,short theFont,short DefaultStringID)
{
	FontInfo	ThisFontInfo;

	TextSize(theFontSize);
	TextFont(theFont);
	GetFontInfo(&ThisFontInfo);
	TextSize(12);
	TextFont(applFont);

	tempRect = *Position;
	FrameRect(&tempRect);
	InsetRect(&tempRect, 3, 3);
	*theTEArea = TENew(&tempRect, &tempRect);
	if (theInput != NIL)
		TEDeactivate(theInput);

	theInput = *theTEArea;
	HLock((Handle)*theTEArea);
	(**theTEArea)->txFont = theFont;
	(**theTEArea)->fontAscent = ThisFontInfo.ascent;
	(**theTEArea)->lineHeight = ThisFontInfo.ascent + ThisFontInfo.descent + ThisFontInfo.leading;
	HUnlock((Handle)*theTEArea);
	GetIndString(sTemp, DefaultStringID, 1);
	TESetText(&sTemp[1], sTemp[0], theInput);
	TEActivate(theInput);
}

/* ======================================================= */

/* Routine: Do_The_Save_File */
/* Purpose: This is a routine used to save a user selected file */
/* Return TRUE for opened the file OK, else return FALSE */

Boolean Do_The_Save_File (Str255 *Prompt, Str255 *DefaultName,
	short *theVolRefNum, short *theRefNum)
{
	StandardFileReply Reply;
	Boolean	OpenedOK;

	InitCursor();
	StandardPutFile(*Prompt, *DefaultName, &Reply);

	if (Reply.sfGood)
	{
		BlockMove((Ptr)&theStandardFileReply.sfFile.name, &outputFileName,
			theStandardFileReply.sfFile.name[0]+1);
		ErrorCode = CreateMovieFile(&Reply.sfFile, 'TVOD', 0, 
			createMovieFileDeleteCurFile, &outputRefNum, &gMovie);

		if (ErrorCode == 0)
		{
			ErrorCode = SetFPos(outputRefNum, fsFromStart, 0);
			ErrorCode = SetVol(nil, theStandardFileReply.sfFile.vRefNum);
			*theRefNum = outputRefNum;
			*theVolRefNum = theStandardFileReply.sfFile.vRefNum;
			OpenedOK = true;
		}
		else
		{
			DebugStr((StringPtr) "\pCreateMovieFile Failed");
			ErrorCode = FSClose(outputRefNum);
			SysBeep(20);
			outputRefNum = 0;
			*theRefNum = 0;
			OpenedOK = false;
		}
	}
	return(OpenedOK);
}

/* ======================================================= */

/* Routine: SetupTheItem */
/* Purpose: Setup a dialog or alert item */

void SetupTheItem(DialogPtr theDialog,short ItemID,Boolean SizeIt,Boolean ShowIt,
Boolean EnableIt,Boolean SetTheMax,Rect *thePosition,long ExtraData,short StringID)
{
	Rect		tempRect;
	short	DType;
	Handle	DItem;
	ControlHandle	CItem;

	GetDItem(theDialog,ItemID,&DType,&DItem,&tempRect);
	CItem = (ControlHandle)DItem;
	if (SizeIt)
		SizeControl(CItem, tempRect.right-tempRect.left, tempRect.bottom-tempRect.top);
	*thePosition = tempRect;
	if (ExtraData != NIL)
		(*CItem)->contrlData = (Handle)ExtraData;
	if (StringID != 0)
	{
		GetIndString(sTemp,StringID,1);
		SetCTitle(CItem,sTemp);
	}
	if (EnableIt)
		HiliteControl (CItem,0);
	else
		HiliteControl (CItem,255);
	if (SetTheMax)
		SetCtlMax(CItem,12345);
	if (ShowIt)
		ShowControl(CItem);
}

/* ======================================================= */

/* Routine: CenterOnColorScreen */
/* Purpose: Center a window onto the deepest color screen */

void CenterOnColorScreen (WindowPtr theWindow )
{
	Rect		tempRect,gdRect,temp2Rect;
	GDHandle	theDevice;

	if ((theWindow != NIL) && (HasColorQD == TRUE))
	{
		SetRect(&tempRect,-32000,-32000,32000,32000);
		theDevice = GetMaxDevice(&tempRect);

		if (theDevice != NIL)
		{
			gdRect = (*theDevice)->gdRect;
			temp2Rect = theWindow->portRect;

			tempRect.top = gdRect.top + ((gdRect.bottom-gdRect.top)/2) - ((temp2Rect.bottom-temp2Rect.top)/2);
			tempRect.left = gdRect.left + ((gdRect.right-gdRect.left)/2) - ((temp2Rect.right-temp2Rect.left)/2);
			MoveWindow(theWindow, tempRect.left, tempRect.top, TRUE);
			SetPort(theWindow); 
		}
	}
}

/* ======================================================= */

/* Routine: GetDeepestColorScreenRect */
/* Purpose: Get the deepest color screen rect */

void GetDeepestColorScreenRect (Rect *DeepRect )
{
	Rect		tempRect;
	GDHandle	theDevice;

	*DeepRect = screenBits.bounds;
	theDevice = NIL;
	if (HasColorQD == TRUE)
	{
		SetRect(&tempRect,-32000,-32000,32000,32000);
		theDevice = GetMaxDevice(&tempRect);

		if (theDevice != NIL)
		{
			*DeepRect = (*theDevice)->gdRect;
		}
	}
}

/* ======================================================= */
/* ======================================================= */
