/*   PComUtil_Shooter

Name:  PComUtil_Shooter.h  
Function:  Common for the Marksman specific code.
History: 5/6/93 Original by Jay Anderson
   */

#include <AppleEvents.h> /* AppleEvent routines */
#include <Packages.h>  /* General routines */
#include <GestaltEqu.h>  /* Gestalt definitions */
#include <Printing.h>  /* Printing routines */
#include <QDOffscreen.h>

/* the following copied from "Movie Construction" */
#include "Movies.h"
#include "QuickTimeComponents.h"

/* ======================================================= */


/* Basic definitions */
#define NIL		0L

/* User event definitions */
#define UserEvent_None 	0
#define UserEvent_Open_Window 	1
#define UserEvent_Close_Window 	2
#define UserEvent_Activate_Window 	3
#define UserEvent_Deactivate_Window 	4
/* IDs 0 to 999 reserved for Marksman, all others available for special use */

/* Menu list resource IDs */
#define Res_Menu_Apple 	256
#define MItem_About_Particle 	1

#define Res_Menu_File 	257
#define MItem_Save_Movie_As 	1
#define MItem_Quit 	3

#define Res_Menu_Edit 	258
#define MItem_Cut 	1
#define MItem_Copy 	2
#define MItem_Paste 	3


/* Window resource IDs, also controls grouped with the appropiate window */

#define Res_D_About 	256
#define Res_Dlg_OK 	1
#define Res_Dlg_title 	517
#define Res_Dlg_byline 	516
#define Res_Dlg_About1 	515

#define Res_MD_Set_Up_Problem 	257
#define Res_Dlg_OK2 	1
#define Res_Dlg_Quit 	2
#define Res_Dlg_Search_for_firs 	3
#define Res_Dlg_Search_for_eige 	4
#define Res_Dlg_label_A 	5
#define Res_Dlg_label_1 	6
#define Res_Dlg_label1 	7
#define Res_Dlg_labelA 	8
#define Res_Dlg_About2 	520
#define strRes_Dlg_TestValue 	536
#define Res_Dlg_TestValue 	9
#define strRes_Dlg_Avalue 	531
#define Res_Dlg_Avalue 	10
#define Res_Dlg_Rect_hotspot1 	11

#define Res_W_Particle_in_a_B 	258
#define Res_Ctrl_found 	557
#define Res_Ctrl_labelA 	556
#define Res_Ctrl_Evalue 	537
#define Res_Ctrl_EVals 	558
#define Res_Ctrl_RectA 	546
#define Res_Ctrl_RectPsi 	539
#define Res_Ctrl_RectE 	538

#define x1Rate (Fixed)1<<16	/* the fixed point number for 1.00 * moov */
#define myTimeScale 10		/* time scale, frames per sec */
#define trailerTime 2.6		/* elapsed time in secs to hold last frame */

/* ======================================================= */


typedef struct UserEventRec{
	short	ID;
	short	ID2;
	long	Data1;
	long	Data2;
	Handle	theHandle;
	struct UserEventRec	**Next;
}UserEventRec,*UserEventPRec,**UserEventHRec;

extern UserEventHRec	UserEventList;
extern EventRecord	myEvent;
extern Boolean	WNE;
extern short	SleepValue;
extern Boolean	doneFlag;
extern TEHandle	theInput;
extern Rect	tempRect;
extern Str255	sTemp;
extern Boolean		HasColorQD;
extern Boolean		HasFPU;
extern Boolean		HoldOffUserEvents;
extern Boolean		InTheForeground;
extern short		tempChar;
extern long		LTemp;
extern RGBColor		Black_ForeColor,White_BackColor;

extern SFTypeList	typeList;
extern OSErr		ErrorCode;
extern SFReply	Reply;
extern StandardFileReply	theStandardFileReply;
extern short	inputRefNum;
extern short	outputRefNum;
extern Str255 inputFileName;
extern Str255 outputFileName;

extern RgnHandle	cursorRgn;
extern Boolean		HasAppleEvents;
extern Boolean		HasAliasMgr;
extern Boolean		HasEditionMgr;
extern short		ReplyMode;
extern Boolean		HasNewStdFile;
extern Boolean		HasPPCToolbox;
extern Boolean		Has32BitQuickDraw;
extern Boolean		HasGestalt;

extern THPrint	hPrint;
extern Boolean	PrinterIsOpen;
extern short	PageCount;
extern short	LineCount;
extern short	PrinterVRes,PrinterHRes;
extern short	MaxPrintCharacters;
extern short	MaxLines;
extern TPPrPort		pPrPort;
extern TPrStatus		prStatus;
extern short	CopyCount;

extern MenuHandle	Menu_Apple;
extern MenuHandle	Menu_File;
extern MenuHandle	Menu_Edit;

/* Variables for the modal dialog titled  "About" */

/* Window variables for the window titled  "Particle in a Box" */
extern WindowPtr	WPtr_Particle_in_a_B;
extern ControlHandle	Ctrl_EVals;
extern Rect	HotRect_EVals;
extern ControlHandle	Ctrl_RectA;
extern Rect	HotRect_RectA;
extern ControlHandle	Ctrl_RectPsi;
extern Rect	HotRect_RectPsi;
extern ControlHandle	Ctrl_RectE;
extern Rect	HotRect_RectE;

/* Variables for the modeless dialog titled  "Set Up Problem" */
extern WindowPtr	WPtr_Set_Up_Problem;
extern short	DRSelected_G1_Set_Up_Problem;
extern Rect	DTE_Rect_TestValue;
extern Rect	DTE_Rect_Avalue;
extern Rect	DHotRect_Rect_hotspot1;

/* Variables for the Particle in a Box Problem */
extern double	energyA;				/* potential barrier */
extern double	energyE;				/* trial eigenvalue */
extern double 	eigenvalues[5];			/* eigenvalues found */
extern Boolean	justOne;				/* looking for just one? */
extern Boolean	readyToRun;				/* finished setup, ready to run */
extern double	energyENear;			/* energy eigenvalue near to ? */
extern GWorldPtr	offPort1, offPort2;
extern Rect		offRect;
extern RGBColor	bkgdColor, forbidColor, allowColor; 

/* Variables for making movies */
extern Boolean			canMakeMovie, makingMovie;
extern Movie			gMovie;
extern Track	    	gTrack;
extern Media			gMedia;
extern GWorldPtr		myGWorld, oldGWorld;
extern GDHandle			oldGDevice;
extern Rect		 		offGRect;
extern PixMap			*pm, **pmH;
extern char				**compressedFrameBitsH;
extern long				maxCompressedFrameSize;
extern long				compressedFrameSize;
extern CodecType		codecType;
extern CompressorComponent	
						codecID;
extern short			theDepth;
extern CodecQ			theQuality, mQuality;
extern ImageDescription	**imageDescriptionH;
extern ImageSequence	seqID;
extern unsigned char	similarity;
extern long				keyFrameRate;
extern TimeValue		sampTime;

/* Prototypes */

/* Handle an activate of the window */
void DoActivate(void);

/* See if WaitNextEvent is available */
Boolean IsWNEIsImplemented(void);

/* Check for user events */
void Handle_User_Event(void);

/* Handle a hit in the window */
void DoInContent(WindowPtr whichWindow,EventRecord *myEvent);

/* ======================================================= */

/* Copy Pascal strings */
void PStrCopy(Str255 *SourceString, Str255 *DestString);

/* Concat Pascal strings */
void PStrCat(Str255 *SourceString, Str255 *DestString);

/* Compare Pascal strings for exact match, case sensitive */
Boolean PStrCmp(StringPtr Source1String,StringPtr Source2String);

Boolean CheckTrapAvailable (short trapNumber, short tType);

void GetUserEvent(UserEventPRec TheUserEvent);

void Add_UserEvent(short ID, short ID2, long  Data1, long Data2, Handle  theHandle);

/* This is a routine used to get a string from a TE area, limited to 250 characters */
void Get_TE_String(TEHandle theTEArea, Str255 *theString);

/* This is a routine used to create a TE area */
void Make_TE_Area(TEHandle *theTEArea, Rect *Position, short theFontSize, short theFont, short DefaultStringID);

Boolean Do_The_Save_File (Str255 *Prompt, Str255 *DefaultName,
	short *theVolRefNum, short *theRefNum);

void SetupTheItem (DialogPtr theDialog, short ItemID, Boolean SizeIt, Boolean ShowIt, Boolean EnableIt,
Boolean SetTheMax,Rect * thePosition , long ExtraData , short StringID );

void CenterOnColorScreen ( WindowPtr theWindow );

void GetDeepestColorScreenRect (Rect *DeepRect);


void Close_The_Output_File(void);
void Save_The_File(void);
