/* PD_About.c 

File name: About 
Function: Handle a modal dialog 
History: 5/6/93 Original by Jay Anderson
   */

#include "PComUtil_Shooter.h"	/* Common */

#include "PD_About.h"	/* This file */

/* ======================================================= */

static Boolean		ExitDialog; 
static Point	MyPt;
static OSErr	MyErr;
static DialogPtr	GetSelection;
	static CWindowPtr cAbout;
static GrafPtr		SavedPort;

/* Prototypes */
/* Filter routine for modal dialog routine */
static pascal Boolean MyFilter (DialogPtr theDialog ,EventRecord *theEvent,short *itemHit);

/* This is an update routine for non-controls in the dialog */
/* This is executed after the dialog is uncovered by an alert */
static void Refresh_Dialog(void);

/* ======================================================= */

/* Routine: I_PD_About */
/* Purpose: Initialize the modal dialog, globals and call users routine */

void I_PD_About()
{
	Rect	tempRect;
	short	DType;
	short	Index;
	Handle	DItem;
	ControlHandle	CItem;
	ControlHandle	CTempItem;
	Str255	sTemp;
	short	itemHit;
	short	temp;


}

/* ======================================================= */

/* Routine: MyFilter */
/* Purpose: Filter routine for dialog events */

static pascal Boolean MyFilter (DialogPtr theDialog ,EventRecord *theEvent,short *itemHit)
{
	Point	MyPt;
	Rect	tempRect;
	short	DType;
	Handle	DItem;
	ControlHandle	CItem;
	short	chCode;
	short	code;
	long	LTemp;
	char	MyCmdKey;
	Boolean	CmdDown;
	Boolean	valMyFilter;

	valMyFilter = FALSE;

	if ((theEvent->what == updateEvt)  && ((WindowPtr)theEvent->message == theDialog))
	{
		BeginUpdate(theDialog);
		DrawDialog(theDialog);
		valMyFilter = TRUE;
		*itemHit = 32000;
	}
	if (theEvent->what == mouseDown)
	{
		MyPt = theEvent->where;
		GlobalToLocal(&MyPt);


	}
	if (theEvent->what == keyDown)
	{
		chCode =  (short)theEvent->message & charCodeMask;
		MyCmdKey = (char)chCode;	
		CmdDown = ((theEvent->modifiers & cmdKey) != 0);
		if (CmdDown == TRUE)
		{
			if ((MyCmdKey == 'x') || (MyCmdKey == 'X'))
			{
				DlgCut(theDialog);
				valMyFilter = TRUE;
			}
			else if ((MyCmdKey =='c') || (MyCmdKey == 'C')) 
			{
				DlgCopy(theDialog);
				valMyFilter = TRUE;
			}
			else if ((MyCmdKey =='v') || (MyCmdKey == 'V'))
			{
				DlgPaste(theDialog);
				valMyFilter = TRUE;
			}
		}
		else if ((chCode == 13) || (chCode == 3))
		{
			valMyFilter = TRUE;
			*itemHit = 1;
			GetDItem (theDialog ,*itemHit, &DType, &DItem, &tempRect);
			if (DType == (ctrlItem + btnCtrl))
			{
				CItem = (ControlHandle)DItem;
				HiliteControl(CItem, 10);
				LTemp = TickCount() + 15;
				do
				{}
				while (LTemp > TickCount());
				HiliteControl(CItem, 0);
			}
		}
	}

	return(valMyFilter);
}

/* ======================================================= */

/* Routine: Refresh_Dialog */
/* Purpose: Refresh the dialogs non-controls */

static void Refresh_Dialog()
{
	Rect	rTempRect;
	short	DType;
	Handle	DItem;
	ControlHandle	CItem;
	RGBColor	Saved_ForeColor;
	RGBColor	Saved_BackColor;
	RGBColor	DrawingColor;

	SetPort(GetSelection);
	if (HasColorQD)
	{
		GetForeColor(&Saved_ForeColor);
		GetBackColor(&Saved_BackColor);

		RGBForeColor(&Black_ForeColor);
		RGBBackColor(&White_BackColor);
	}

	GetDItem(GetSelection,Res_Dlg_OK,&DType,&DItem,&tempRect);
	PenSize(3, 3);
	InsetRect(&tempRect, -4, -4);
	FrameRoundRect(&tempRect, 16, 16);
	PenSize(1, 1); 

	TextFont(16);
	TextFace(bold);
	/* Draw a string of text, title */
	SetRect(&rTempRect, 5,5,285,20);
	GetIndString(sTemp,Res_Dlg_title,1);
	TextBox(&sTemp[1], sTemp[0], &rTempRect,teJustCenter);

	TextSize(10);
	TextFace(0);
	/* Draw a string of text, byline */
	SetRect(&rTempRect, 5,75,285,140);
	GetIndString(sTemp,Res_Dlg_byline,1);
	TextBox(&sTemp[1], sTemp[0], &rTempRect,teJustCenter);

	TextSize(12);
	/* Draw a string of text, About1 */
	SetRect(&rTempRect, 5,25,285,70);
	GetIndString(sTemp,Res_Dlg_About1,1);
	TextBox(&sTemp[1], sTemp[0], &rTempRect,teJustLeft);

	TextSize(12);
	TextFont(systemFont);
	TextFace(0);

	if (HasColorQD)
	{
		RGBForeColor(&Saved_ForeColor);
		RGBBackColor(&Saved_BackColor);
	}

}

/* ======================================================= */

/* Routine: PD_About */
/* Purpose: Modal dialog */

void MPD_About()
{
	Rect	tempRect;
	short	DType;
	short	Index;
	Handle	DItem;
	ControlHandle	CItem;
	ControlHandle	CTempItem;
	Str255	sTemp;
	short	itemHit;
	short	temp;
	long	theLong;

	GetPort(&SavedPort);
	HoldOffUserEvents = true;

	GetSelection = GetNewDialog(Res_D_About, nil, (WindowPtr)-1);
	SetPort(GetSelection);

/* Setup initial conditions */

ExitDialog = false;

ShowWindow(GetSelection);
SelectWindow(GetSelection);

do
{
	ModalDialog( (ProcPtr)&MyFilter, &itemHit);

	if (itemHit == 32000)
	{
		Refresh_Dialog();
		EndUpdate(GetSelection); 
	}
	else
	{
		GetDItem(GetSelection, itemHit, &DType, &DItem, &tempRect);
		CItem = (ControlHandle)DItem;
	}

	/* Handle it real time */
	if (itemHit ==Res_Dlg_OK)
	{
		ExitDialog = true;

		Add_UserEvent(UserEvent_Open_Window,Res_MD_Set_Up_Problem,0,0,nil);

	}


}
while (ExitDialog == false);

/* Get results after dialog */

SetPort(SavedPort);
DisposDialog(GetSelection);

HoldOffUserEvents = false;

}

/* ======================================================= */
