/* PMD_Set_Up_Problem */

/* File name: Set_Up_Problem */
/* Function: Handle a modeless dialog */
/*            This dialog operates like a window, it is not modal. */
/*           Opened by:    */
/*           Closed by:     */
/*           Purpose:       
History: 5/6/93 Original by Jay Anderson
   */


#include "PComUtil_Shooter.h"	/* Common */

#include "PD_About.h"	/* Modal Dialog */
#include "PMD_Set_Up_Problem.h"	/* This modeless dialog */

#include <stdlib.h>
#include <Picker.h>

static Boolean		ExitDialog;

/* ======================================================= */

static void Clear1RadioGroup(void);


/* ======================================================= */

/* Routine: Init_Set_Up_Problem */
/* Purpose: This procedures purpose is to set the window pointer to nil, */
/* this is used to tell the other routines */

void Init_Set_Up_Problem()
{
	Rect	tempRect;
	short	DType;
	short	Index;
	Handle	DItem;
	ControlHandle	CItem, CTempItem;
	Str255	sTemp;
	short	itemHit;
	short	temp;

	WPtr_Set_Up_Problem = NIL;

	DRSelected_G1_Set_Up_Problem= Res_Dlg_Search_for_eige;

}

/* ======================================================= */

/* Routine: Moved_Set_Up_Problem */
/* Purpose: We were moved, possibly to another screen and screen depth */

void Moved_Set_Up_Problem(Rect *OldRect,WindowPtr theWindow)
{
	WindowPtr	SavePort;

	if (WPtr_Set_Up_Problem == theWindow)
	{
		GetPort(&SavePort);
		SetPort(theWindow);

		SetPort(SavePort);
	}
}

/* ======================================================= */

/* Routine: Update_Set_Up_Problem */
/* Purpose: This procedures purpose is to refresh this window, update it, */
/* when we are uncovered by another window.  */

void Update_Set_Up_Problem(WindowPtr theWindow)
{
	GrafPtr	SavedPort;
	Rect	tempRect;
	Rect	rTempRect;
	short	DType;
	Handle	DItem;
	ControlHandle	CItem;
	RGBColor	Saved_ForeColor;
	RGBColor	Saved_BackColor;
	RGBColor	DrawingColor;

	if ((WPtr_Set_Up_Problem != nil) && (theWindow == WPtr_Set_Up_Problem))
	{
		GetPort(&SavedPort);
		SetPort(theWindow);
		if (HasColorQD)
		{
			GetForeColor(&Saved_ForeColor);
			GetBackColor(&Saved_BackColor);

			RGBForeColor(&Black_ForeColor);
			RGBBackColor(&White_BackColor);
		}


		GetDItem(theWindow,Res_Dlg_OK2,&DType,&DItem,&tempRect);
		PenSize(3, 3);
		InsetRect(&tempRect, -4, -4);
		FrameRoundRect(&tempRect, 16, 16);
		PenSize(1, 1); 

		/* Draw a line, Drawn line5 */
		MoveTo(50,135);
		LineTo(50,144);

		/* Draw a line, Drawn line2 */
		MoveTo(30,140);
		LineTo(269,140);

		/* Draw a line, Drawn line1 */
		MoveTo(150,75);
		LineTo(150,199);
		
		/* Fill rectangle; not done in Marksman */
		/* not sure how to get color 6/1/93 - jma */
		tempRect = DHotRect_Rect_hotspot1;
		DrawingColor.red = 0xCCCC;
		DrawingColor.green = 0xFFFF;
		DrawingColor.blue = 0xCCCC;
		RGBForeColor(&DrawingColor);
		FillRect(&tempRect, ltGray); 
		RGBForeColor(&Black_ForeColor);
		

		TextFont(16);
		TextSize(10);
		/* Draw a string of text, About2 */
		SetRect(&rTempRect, 5,10,290,60);
		GetIndString(sTemp,Res_Dlg_About2,1);
		TextBox(&sTemp[1], sTemp[0], &rTempRect,teJustLeft);

		TextSize(12);
		TextFace(0);

		if (HasColorQD)
		{
			RGBForeColor(&Saved_ForeColor);
			RGBBackColor(&Saved_BackColor);
		}

		DrawDialog(theWindow);
		SetPort(SavedPort);
	}
}

/* ======================================================= */

/* Routine: Open_Set_Up_Problem */
/* Purpose: This procedures purpose is to open this window and set all */
/* of the initial conditions, such as default edit text. */

void Open_Set_Up_Problem()
{
	TEHandle	ThisEditText; 
	DialogPeek		TheDialogPtr;
	Rect	tempRect;
	short	DType;
	Handle	DItem;
	ControlHandle	CItem;
	long	LTemp,theLong;
	CWindowPtr cSet_Up_Problem;

	if (WPtr_Set_Up_Problem == NIL)
	{
		WPtr_Set_Up_Problem = GetNewDialog(Res_MD_Set_Up_Problem, NIL,  (WindowPtr)-1 );
		SetPort(WPtr_Set_Up_Problem);
		TheDialogPtr = (DialogPeek)WPtr_Set_Up_Problem;
		ThisEditText = TheDialogPtr->textH;
		HLock((Handle)ThisEditText);
		(*ThisEditText)->txSize = 12;
		TextSize(12);
		(*ThisEditText)->txFont = systemFont;
		TextFont(systemFont);
		(*ThisEditText)->txFont = 0;
		(*ThisEditText)->fontAscent = 12;
		(*ThisEditText)->lineHeight = 12 + 3 + 1;
		HUnlock((Handle)ThisEditText);


		/* Setup initial conditions */
		LTemp = 0x00000000;
		LTemp = LTemp + ((0x00FF & 1) * 0x00000100);
		SetupTheItem(WPtr_Set_Up_Problem,Res_Dlg_Rect_hotspot1,true,true,false,false,&DHotRect_Rect_hotspot1,LTemp,0);

		GetDItem(WPtr_Set_Up_Problem,Res_Dlg_Search_for_eige,&DType,&DItem,&tempRect);
		CItem = (ControlHandle)DItem;
		SetCtlValue(CItem, 1);
		justOne = TRUE;

		GetDItem(WPtr_Set_Up_Problem,Res_Dlg_TestValue,&DType,&DItem,&tempRect);
		GetIndString(sTemp, strRes_Dlg_TestValue,1);
		SetIText(DItem,sTemp);

		GetDItem(WPtr_Set_Up_Problem,Res_Dlg_Avalue,&DType,&DItem,&tempRect);
		GetIndString(sTemp, strRes_Dlg_Avalue,1);
		SetIText(DItem,sTemp);

		SelIText(WPtr_Set_Up_Problem,Res_Dlg_TestValue,0,300);



		ShowWindow(WPtr_Set_Up_Problem);
		SelectWindow(WPtr_Set_Up_Problem);

	}
	else
		SelectWindow(WPtr_Set_Up_Problem);
}

/* ======================================================= */

/* Routine: Close_Set_Up_Problem */
/* Purpose: This procedures purpose is to close this window and clear */
/* the window pointer variable */

void Close_Set_Up_Problem(WindowPtr theWindow)
{
	Rect	tempRect;
	short	DType;
	Handle	DItem;

	if ((WPtr_Set_Up_Problem != NIL) && (theWindow == WPtr_Set_Up_Problem))
	{

		DisposDialog(theWindow);
		WPtr_Set_Up_Problem = nil;

	}
}

/* ======================================================= */

/* Routine to clear radios in group 1 */
static void Clear1RadioGroup()
{
	Rect	tempRect;
	short	DType;
	Handle	DItem;
	ControlHandle	CItem;

	GetDItem(WPtr_Set_Up_Problem, Res_Dlg_Search_for_firs, &DType, &DItem, &tempRect);
	CItem = (ControlHandle)DItem;
	SetCtlValue(CItem,0);
	GetDItem(WPtr_Set_Up_Problem, Res_Dlg_Search_for_eige, &DType, &DItem, &tempRect);
	CItem = (ControlHandle)DItem;
	SetCtlValue(CItem,0);
}

/* ======================================================= */


/* Routine: Do_Set_Up_Problem */
/* Purpose: This procedures purpose is to handle all actions, such as buttons being pressed. */
/* This is the real meat of this unit and is where the code is for acting upon the users actions. */

void Do_Set_Up_Problem(EventRecord *theEvent,WindowPtr theWindow,short itemHit)
{
	short	Index;
	Point	myPt;
	Boolean	ExitDialog;
	short	DType;
	Handle	DItem;
	Rect	tempRect;
	ControlHandle	CItem;
	short	temp;
	short	code;
	
	Point	whereColor;
	RGBColor outColor;

	ExitDialog = false;
	if ((theEvent->what == mouseDown) && (WPtr_Set_Up_Problem != nil))
	{
		SetPort(WPtr_Set_Up_Problem);
		myPt = theEvent->where;
		GlobalToLocal(&myPt);

	}

	if ((WPtr_Set_Up_Problem != nil)  && (WPtr_Set_Up_Problem  == theWindow))
	{
		if (theEvent->what == keyDown)
		{
			itemHit = 0;
			temp = (short)theEvent->message & charCodeMask;
			if ((temp == 13) || (temp == 3))
			{
				itemHit = 1;
			}
		}


		if ((WPtr_Set_Up_Problem != NIL)  && (WPtr_Set_Up_Problem  == theWindow))
		{
			myPt = theEvent->where;
			GlobalToLocal(&myPt);

			GetDItem(theWindow, itemHit,&DType,&DItem,&tempRect);
			CItem = (ControlHandle)DItem;

			/* Handle it real time */
			if (itemHit ==Res_Dlg_OK2)
			{
				Add_UserEvent(UserEvent_Open_Window,Res_W_Particle_in_a_B,0,0,nil);
				/* read input values from field here:  A, trial E */
				GetDItem(theWindow, Res_Dlg_Avalue, &DType, &DItem, &tempRect);
				GetIText(DItem, sTemp);
				PtoCstr(sTemp);
				energyA = (float)atof((char *)sTemp);

				GetDItem(theWindow, Res_Dlg_TestValue, &DType, &DItem, &tempRect);
				GetIText(DItem, sTemp);
				PtoCstr(sTemp);
				energyENear = (float)atof((char *)sTemp);

				/* "Hidden" feature:  if option is held down when OK is clicked,
				 * then present color-picker dialog box three times:  for bkgd,
				 * for forbidden, and for allowed. **************************** */
				/* first, the defaults */
				bkgdColor.red =     0x6666;
				bkgdColor.green =   0xFFFF;
				bkgdColor.blue =    0xFFFF;
				forbidColor.red =   0xFFFF;
				forbidColor.green = 0x0CCC;
				forbidColor.blue =  0x0CCC;
				allowColor.red =    0x0CCC;
				allowColor.green =  0xFFFF;
				allowColor.blue =   0x0CCC;
				whereColor.h = -1, whereColor.v = -1;
				if (theEvent->modifiers & optionKey)
				{
					if (GetColor(whereColor, "\pBackground color?", &bkgdColor,
						&outColor))
						bkgdColor = outColor;
					if (GetColor(whereColor, "\pForbidden solution color?", &forbidColor,
						&outColor))
						forbidColor = outColor;
					if (GetColor(whereColor, "\pAllowed solution color?", &allowColor,
						&outColor))
						allowColor = outColor;					
				} 
				readyToRun = TRUE;
			}

			if (itemHit ==Res_Dlg_Quit)
			{
				Add_UserEvent(UserEvent_Close_Window,Res_MD_Set_Up_Problem,0,0,nil);
				doneFlag = TRUE;

			}

			if (itemHit ==Res_Dlg_Search_for_firs)
			{
				Clear1RadioGroup();
				SetCtlValue(CItem, 1);
				DRSelected_G1_Set_Up_Problem=  Res_Dlg_Search_for_firs;
				EnableItem(Menu_File,MItem_Save_Movie_As);
				justOne = FALSE;

			}

			if (itemHit ==Res_Dlg_Search_for_eige)
			{
				Clear1RadioGroup();
				SetCtlValue(CItem, 1);
				DRSelected_G1_Set_Up_Problem=  Res_Dlg_Search_for_eige;
				DisableItem(Menu_File,MItem_Save_Movie_As);
				justOne = TRUE;

			}


		}
	}

	if (ExitDialog)
	{
		Close_Set_Up_Problem(WPtr_Set_Up_Problem);
		WPtr_Set_Up_Problem = nil;
	}
}

/* ======================================================= */
