/*  PMenu_Shooter

/* File name:  PMenu_Shooter.c   
 Function:  This module calls the appropiate menu list 
      handler routine. 
History: 5/6/93 Original by Jay Anderson
   */


#include "PComUtil_Shooter.h"	/* Common */

#include "PD_About.h"	/* Modal Dialog */
#include "PMD_Set_Up_Problem.h"	/* Modeless Dialog */
#include "PW_Particle_in_a_B.h"	/* Window */
#include "PMenu_Shooter.h"	/* This file */




/* Routine: Init_My_Menus */
/* Purpose: Load in the menu lists and initialize the menubar */

void Init_My_Menus()
{

	ClearMenuBar();
	/* This menu is the APPLE menu, used for About and desk accessories */
	Menu_Apple = GetMenu(Res_Menu_Apple);
	InsertMenu(Menu_Apple,0);

	AddResMenu(Menu_Apple,'DRVR');

	/* This menu is  File */
	Menu_File = GetMenu(Res_Menu_File);
	InsertMenu(Menu_File,0);

	/* This menu is  Edit */
	Menu_Edit = GetMenu(Res_Menu_Edit);
	InsertMenu(Menu_Edit,0);


	DrawMenuBar();
}

/* ======================================================= */
void DoMenuApple(short theItem);
void DoMenuFile(short theItem);
void DoMenuEdit(short theItem);
/* ======================================================= */

/* Routine: Pre_Do_MenuListApple */
/* Purpose: Handle all menu items in this list */

void DoMenuApple(short theItem)
{
	Boolean	SkipProcessing;
	short	DNA;
	Str255	DAName;
	GrafPtr	SavePort;

	SkipProcessing = false;

	if (SkipProcessing == false)
	{

		switch (theItem)
		{
			case MItem_About_Particle:
				MPD_About();
				break;
			default:
				GetPort(&SavePort);
				GetItem(Menu_Apple, theItem, DAName);
				DNA = OpenDeskAcc(DAName);
				SetPort(SavePort);
				break;
		}

	}

}

/* ======================================================= */

/* Routine: Pre_Do_MenuListFile */
/* Purpose: Handle all menu items in this list */

void DoMenuFile(short theItem)
{
	Boolean	SkipProcessing;

	SkipProcessing = false;

	if (SkipProcessing == false)
	{

		switch (theItem)
		{
			case MItem_Save_Movie_As:
				Save_The_File();
				break;
			case MItem_Quit:
				doneFlag = true;
				break;
			default:
				break;
		}

	}

}

/* ======================================================= */

/* Routine: Pre_Do_MenuListEdit */
/* Purpose: Handle all menu items in this list */

void DoMenuEdit(short theItem)
{
	Boolean	SkipProcessing;
	Boolean	BoolHolder;

	SkipProcessing = false;

	if (SkipProcessing == false)
	{

		BoolHolder = SystemEdit(theItem - 1);

		if  (BoolHolder == false)
		{

			switch (theItem)
			{
				case MItem_Cut:
					break;
				case MItem_Copy:
					break;
				case MItem_Paste:
					break;
				default:
					break;
			}
		}

	}

}

/* ======================================================= */

/* Routine: Handle_My_Menu */
/* Purpose: Vector off to the appropiate menu list handler */

void Handle_My_Menu(short theMenu,short theItem)
{

	switch (theMenu)
	{
		case Res_Menu_Apple:
			DoMenuApple(theItem);
			break;
		case Res_Menu_File:
			DoMenuFile(theItem);
			break;
		case Res_Menu_Edit:
			DoMenuEdit(theItem);
			break;
		default:
			break;
	}

	HiliteMenu(0);
}

/* ======================================================= */

