/*  PW_Particle_in_a_B

File name: Particle_in_a_B
Function: Handle a Window
History: 5/7/93 Original by Jay Anderson
   */

#include "PComUtil_Shooter.h"	/* Common */

#include "PD_About.h"	/* Modal Dialog */

#include "PW_Particle_in_a_B.h"	/* This file */
#include <stdio.h>
#include <math.h>
#include "2Dgraphics.h"
#include <Sound.h>

/* ======================================================= */
static ControlHandle	ScrollHHandle;
static ControlHandle	ScrollVHandle;
static RGBColor	WindowBackColor;

static void Do_A_Button(ControlHandle theControl);
static void shootAWave(void);
static void shoot5Waves(void);
static void buildBitMap(void);
/* ======================================================= */

/* Routine: Init_Particle_in_a_B */
/* Purpose: Initialize our window data to not in use yet */

void Init_Particle_in_a_B()
{

	WPtr_Particle_in_a_B = nil;

	ScrollHHandle = nil;
	ScrollVHandle = nil;

	WindowBackColor.red  = 0xFFFF;  WindowBackColor.green  = 0xFFFF;  WindowBackColor.blue  = 0xFFFF;

}

/* ======================================================= */

/* Routine: Close_Particle_in_a_B */
/* Purpose: Close out the window */

void Close_Particle_in_a_B(WindowPtr whichWindow)
{

	if ((WPtr_Particle_in_a_B != NIL) && ((WPtr_Particle_in_a_B == whichWindow) || (whichWindow == (WindowPtr)-1))) 
	{

		DisposeWindow(WPtr_Particle_in_a_B);
		WPtr_Particle_in_a_B = nil;
	}
}

/* ======================================================= */

/* Routine: Resized_Particle_in_a_B */
/* Purpose: We were resized or zoomed, update the scrolling scrollbars */

void Resized_Particle_in_a_B(Rect *OldRect,WindowPtr whichWindow)
{
	WindowPtr	SavePort;
	Rect	temp2Rect;
	short	Index;

	if (WPtr_Particle_in_a_B == whichWindow)
	{
		GetPort(&SavePort);
		SetPort(WPtr_Particle_in_a_B);

		temp2Rect = WPtr_Particle_in_a_B->portRect;
		EraseRect(&temp2Rect);
		InvalRect(&temp2Rect);

		SetPort(SavePort);
	}
}

/* ======================================================= */

/* Routine: Moved_Particle_in_a_B */
/* Purpose: We were moved, possibly to another screen and screen depth */

void Moved_Particle_in_a_B(Rect *OldRect,WindowPtr whichWindow)
{
	WindowPtr	SavePort;
	Rect	temp2Rect;
	short	Index;

	if (WPtr_Particle_in_a_B == whichWindow)
	{
		GetPort(&SavePort);
		SetPort(WPtr_Particle_in_a_B);

		SetPort(SavePort);
	}
}

/* ======================================================= */

/* Routine: Update_Particle_in_a_B */
/* Purpose: Update our window */

void Update_Particle_in_a_B(WindowPtr whichWindow)
{
	WindowPtr	SavePort;
	RGBColor	Saved_ForeColor;
	RGBColor	Saved_BackColor;
	RGBColor	DrawingColor;

	if ((WPtr_Particle_in_a_B != NIL) && (WPtr_Particle_in_a_B == whichWindow))
	{
		GetPort(&SavePort);
		SetPort(WPtr_Particle_in_a_B );

		if (HasColorQD)
		{
			GetForeColor(&Saved_ForeColor);
			GetBackColor(&Saved_BackColor);

			RGBForeColor(&Black_ForeColor);
			RGBBackColor(&White_BackColor);
		}

		TextSize(10);
		TextFont(16);
		/* Draw a string of text, found */
		SetRect(&tempRect, 220,50,250,60);
		GetIndString(sTemp,Res_Ctrl_found,1);
		TextBox(&sTemp[1], sTemp[0], &tempRect, teJustLeft);

		/* Draw a string of text, labelA */
		SetRect(&tempRect, 220,10,255,20);
		GetIndString(sTemp,Res_Ctrl_labelA,1);
		TextBox(&sTemp[1], sTemp[0], &tempRect, teJustLeft);

		/* Draw a string of text, Evalue */
		SetRect(&tempRect, 220,30,270,45);
		GetIndString(sTemp,Res_Ctrl_Evalue,1);
		TextBox(&sTemp[1], sTemp[0], &tempRect, teJustLeft);

		/* Fill rectangle -- not in Marksman */
		/* not sure how to get these colors -- jma 6/1/93 */
		tempRect = HotRect_RectPsi;
		RGBForeColor(&bkgdColor);
		FillRect(&tempRect, black); 
		RGBForeColor(&Black_ForeColor);		

		/* Draw a line, Drawn line9 */
		MoveTo(110,10);
		LineTo ( 110,209);

		/* Draw a line, Drawn line8 */
		MoveTo(10,110);
		LineTo ( 209,110);

		if (HasColorQD)
		{
			RGBForeColor(&Saved_ForeColor);
			RGBBackColor(&Saved_BackColor);
		}

		TextSize(12);
		TextFont(applFont);

		/* post A value in box */		
		TextSize(9);
		sprintf((char *)sTemp, "%.3f", energyA);
		tempRect = HotRect_RectA;
		InsetRect(&tempRect, 1, 1);
		TextBox((Ptr)&sTemp, strlen(sTemp), &tempRect, teJustLeft);
		TextSize(12);
		
		DrawControls(WPtr_Particle_in_a_B);
		
		/* GO SOLVE THE PROBLEM HERE!! */
		if (readyToRun)
		{
			if (justOne)
				shootAWave();
			else
				shoot5Waves();
		}
		
		
		SetPort(SavePort);
	}
}

/* ======================================================= */

/* Routine: Open_Particle_in_a_B */
/* Purpose: Open our window */

void Open_Particle_in_a_B()
{
	long	theLong;
	CWindowPtr	cWPtr_Particle_in_a_B;

	if (WPtr_Particle_in_a_B == NIL)
	{

		if (HasColorQD)
		{
			WPtr_Particle_in_a_B = GetNewCWindow(Res_W_Particle_in_a_B,nil, (WindowPtr)-1);
		}
		else
		{
			WPtr_Particle_in_a_B = GetNewWindow(Res_W_Particle_in_a_B,nil, (WindowPtr)-1);
		}
		SetPort(WPtr_Particle_in_a_B);

		/* Make a Rect, EVals */
		Ctrl_EVals = GetNewControl( Res_Ctrl_EVals, WPtr_Particle_in_a_B);
		HideControl(Ctrl_EVals);
		theLong = 0x00000000;
		theLong = theLong + (long)((0x00FF & 1) * 0x00000100);
		(*Ctrl_EVals)->contrlData = (Handle)theLong;
		HotRect_EVals = (*Ctrl_EVals)->contrlRect;
		ShowControl(Ctrl_EVals);
		/* Make a Rect, RectA */
		Ctrl_RectA = GetNewControl( Res_Ctrl_RectA, WPtr_Particle_in_a_B);
		HideControl(Ctrl_RectA);
		theLong = 0x00000000;
		theLong = theLong + (long)((0x00FF & 1) * 0x00000100);
		(*Ctrl_RectA)->contrlData = (Handle)theLong;
		HotRect_RectA = (*Ctrl_RectA)->contrlRect;
		ShowControl(Ctrl_RectA);
		/* Make a Rect, RectPsi */
		Ctrl_RectPsi = GetNewControl( Res_Ctrl_RectPsi, WPtr_Particle_in_a_B);
		HideControl(Ctrl_RectPsi);
		theLong = 0x00000000;
		theLong = theLong + (long)((0x00FF & 1) * 0x00000100);
		(*Ctrl_RectPsi)->contrlData = (Handle)theLong;
		HotRect_RectPsi = (*Ctrl_RectPsi)->contrlRect;
		ShowControl(Ctrl_RectPsi);
		/* Make a Rect, RectE */
		Ctrl_RectE = GetNewControl( Res_Ctrl_RectE, WPtr_Particle_in_a_B);
		HideControl(Ctrl_RectE);
		theLong = 0x00000000;
		theLong = theLong + (long)((0x00FF & 1) * 0x00000100);
		(*Ctrl_RectE)->contrlData = (Handle)theLong;
		HotRect_RectE = (*Ctrl_RectE)->contrlRect;
		ShowControl(Ctrl_RectE);


		ShowWindow(WPtr_Particle_in_a_B);
		
		buildBitMap();
	}
	else
	{
	}
	SelectWindow(WPtr_Particle_in_a_B);
}

/* ======================================================= */

/* Routine: Activate_Particle_in_a_B */
/* Purpose: We activated or deactivated */

void Activate_Particle_in_a_B(WindowPtr whichWindow,Boolean Do_An_Activate)
{
	WindowPtr	SavePort;

	if (WPtr_Particle_in_a_B == whichWindow)
	{
		GetPort(&SavePort);
		SetPort(whichWindow);

		if (Do_An_Activate)
		{
			EraseRect(&HotRect_RectPsi);
			InvalRect(&WPtr_Particle_in_a_B->portRect);
		}
		else
		{
			if (theInput != nil)
			{
				TEDeactivate(theInput);
			}
			theInput = nil;
		}

		SetPort(SavePort);
	}
}

/* ======================================================= */

/* Routine: Do_A_Button */
/* Purpose: Handle a button pressed */

static void Do_A_Button(ControlHandle theControl)
{
	long	RefCon;
	short	UnHiliteValue;

	HiliteControl(theControl, 10);
	UnHiliteValue = 0;
	RefCon = GetCRefCon(theControl);

	switch (RefCon)
	{
		case 0:
			break;
		default:
			break;
	}

	HiliteControl(theControl, UnHiliteValue);
}


/* Routine: Do_Particle_in_a_B */
/* Purpose: Handle action to our window, like controls */

void Do_Particle_in_a_B(EventRecord *myEvent)
{
	short	code;
	WindowPtr	whichWindow;
	Point	myPt;
	ControlHandle	theControl;
code = FindWindow(myEvent->where, &whichWindow);

if (WPtr_Particle_in_a_B == whichWindow)
{
	code = FindWindow(myEvent->where, &whichWindow);

	if ((myEvent->what == mouseDown) && (WPtr_Particle_in_a_B == whichWindow))
	{
		myPt = myEvent->where;
		GlobalToLocal(&myPt);

	}

	if ((WPtr_Particle_in_a_B == whichWindow) && (code == inContent))
	{

		code = FindControl(myPt, whichWindow, &theControl);

		if (code != 0)
			code = TrackControl(theControl,myPt, (ProcPtr)-1);
		if (code == inButton)
			Do_A_Button(theControl);

	}
}
}

/* ======================================================= */

/* Here follows MAT 338 code for this problem, spring semester 1992-93 */
/*
 * DEMONSTRATION PROGRAM FOR SHOOTING METHOD SOLUTION OF
 * SECOND-DEGREE DIFFERENTIAL EQUATION WITH TWO BOUNDARY
 * VALUES, USING RUNGE-KUTTA TRIAL SOLUTIONS.
 *
 * J. M. ANDERSON  APRIL 1993  F&M MAT 338
 ************************************************************ */

#define TOLERANCE 1.0E-6

typedef double vector[2];

/* FOLLOWING ARE THE FUNCTIONS TO CALCULATE THE FIRST
 * VECTOR DERIVATIVE REQUIRED FOR A FOURTH-ORDER
 * RUNGE-KUTTA SOLUTION.  YOU SHOULD MODIFY THIS
 * FUNCTIONS FOR A PARTICULAR PROBLEM.
 *
 *************************************************** */
void sysf1(double t, double *x, double *x1)
{
	x1[0] = x[1];
	x1[1] = (t <= 0.0) ? -energyE*x[0] : (energyA - energyE)*x[0];
}

/* FOLLOWING IS THE FOURTH-ORDER RUNGE-KUTTA METHOD FOR 
 * A SYSTEM OF ODES.  YOU SHOULD NOT NEED TO MAKE MODIFICATIONS
 * BELOW THIS POINT IN THE PROGRAM.
 ********************************************************** */
  
void sysRK4(double t, double h, double *x, int size)
{
	/* returns the state of the system at t+h given
	 * the state of the system at t
	 */
	
	vector y, x0, x1, x2, x3, x4;
	int i;
	
	/* get the RK functions first */
	for (i = 0; i < size; i++) x0[i] = x[i];
	sysf1(t, x0, x1);
	for (i = 0; i < size; i++) x0[i] += h*x1[i]/2;
	sysf1(t+h/2, x0, x2);
	for (i = 0; i < size; i++) x0[i] += h*(x2[i] - x1[i])/2;
	sysf1(t+h/2, x0, x3);
	for (i = 0; i < size; i++) x0[i] += h*(x3[i] - x2[i]/2);
	sysf1(t+h, x0, x4);
	
	/* now step forward by h */
	for (i = 0; i < size; i++)
		y[i] = x[i] + h*(x1[i] + 2*x2[i] + 2*x3[i] + x4[i])/6;
	for (i = 0; i < size; i++) x[i] = y[i];
	
}

void shootAWave(void)
{
	int nint = 128, i, k, ntrial;
	double a = -1.0, b = 1.0, h, t, v1, v2, v, s = 0.0;
	double beta = 0.0, beta1, beta2, z1 = 1.0, z2;
	vector x;
	long dontCare;
	RgnHandle oldClipRgn;
	
	oldClipRgn = NewRgn();
	/* set up 2D graphics in our window */
	view_window(-1.0, -0.8, 1.0, 0.8);
	view_port(HotRect_RectPsi.left, HotRect_RectPsi.bottom, 
		HotRect_RectPsi.right, HotRect_RectPsi.top);

	/* For our initial trials, we take 25% above and below the user's suggestion */
	v1 = 0.75*energyENear;
	v2 = 1.25*energyENear;
	ntrial = 1;
	
	do {
		h = (b - a)/nint;
		t = a;
		x[0] = s;
		x[1] = z1;
		
		switch (ntrial)
		{
			case 1 :  v = v1;
					  break;
			case 2 :  v = v2;
				      break;
			default : v = v2 + (beta - beta2)*(v2 - v1)/(beta2 - beta1);
					  v1 = v2;
					  v2 = v;
					  break;
		}
		
		energyE = v;
		/* post this value in window */
		TextSize(9);
		sprintf((char *)sTemp, "%.3f", energyE);
		tempRect = HotRect_RectE;
		InsetRect(&tempRect, 1, 1);
		TextBox((Ptr)&sTemp, strlen(sTemp), &tempRect, teJustLeft);
		
		/* erase the "results" box */
		tempRect = HotRect_EVals;
		InsetRect(&tempRect, 1, 1);
		EraseRect(&tempRect);
				
		/* Take  Runge-Kutta steps */
		GetClip(oldClipRgn);
		ClipRect(&HotRect_RectPsi);
		wMoveTo(t, x[0]);
		for (k = 1; k < nint; k++)
		{
			sysRK4(t, h, x, 2);
			t += h;
			wLineTo(t, x[0]);
		}
		SetClip(oldClipRgn);
		
		switch (ntrial)
		{
			case 1 :  beta1 = x[0];
					  break;
			case 2 :  beta2 = x[0];
				      break;
			default : beta1 = beta2;
					  beta2 = x[0];
					  break; 
		}
		
		
		ntrial++;
		Delay(120, &dontCare);	
	} while ((ntrial < 3) || (fabs(beta - beta2) > TOLERANCE));
	
	/* post final results */
	sprintf((char *)sTemp, "in %d shots", ntrial-1);
	tempRect = HotRect_EVals;
	InsetRect(&tempRect, 1, 1);
	TextBox((Ptr)&sTemp, strlen(sTemp), &tempRect, teJustLeft);
	sprintf((char *)sTemp, "E = %.3f", energyE);
	InsetRect(&tempRect, 1, 5);
	OffsetRect(&tempRect, 0, 5);
	TextBox((Ptr)&sTemp, strlen(sTemp), &tempRect, teJustLeft);
	
	TextSize(12);
}

void shoot5Waves(void)
{
	int nint = 128, i, k, ntrial, nroots;
	double a = -1.0, b = 1.0, h, t, step = 0.25, v, s = 0.0;
	double beta = 0.0, beta1, beta2, z1 = 1.0, z2;
	vector x;
	long dontCare;
	GWorldPtr oldGWorld;
	GDHandle  oldGDev;
	Handle mySound;
	short	neededFrames, nFrames;
	
	/* set up 2D graphics in our offscreen rectangle */
	view_window(-1.0, -0.8, 1.0, 0.8);
	view_port(offRect.left, offRect.bottom, 
		offRect.right, offRect.top);
	
	/* set up two off-screen bitmaps; one will contain the permanent contents
	 * of the onscreen window; the other will contain an individual "shot"
	 * at the function
	 */

	ntrial = 1;
	nroots = 0;
	
	/* erase the "results" box */
	tempRect = HotRect_EVals;
	InsetRect(&tempRect, 1, 1);
	EraseRect(&tempRect);
	
	/* draw the background */ 
	GetGWorld(&oldGWorld, &oldGDev);
	SetGWorld(offPort1, NULL);
	LockPixels(offPort1->portPixMap);
	EraseRect(&offRect);
	RGBForeColor(&bkgdColor);
	FillRect(&offRect, black); 
	RGBForeColor(&Black_ForeColor);		

	MoveTo(100, 0);
	LineTo (100, 199);
	MoveTo(0, 100);
	LineTo (199, 100);
	FrameRect(&offRect);
	UnlockPixels(offPort1->portPixMap);
	SetGWorld(oldGWorld, oldGDev);
			
	do {
		h = (b - a)/nint;
		t = a;
		x[0] = s;
		x[1] = z1;
		
		v = ntrial * step;
		energyE = v;
		/* post this value in window */
		TextSize(9);
		sprintf((char *)sTemp, "%.3f", energyE);
		tempRect = HotRect_RectE;
		InsetRect(&tempRect, 1, 1);
		TextBox((Ptr)&sTemp, strlen(sTemp), &tempRect, teJustLeft);
		
		/* Take  Runge-Kutta steps */
		/* Draw function in offscreen world #2 */
		GetGWorld(&oldGWorld, &oldGDev);
		SetGWorld(offPort2, NULL);
		LockPixels(offPort2->portPixMap);
		EraseRect(&offRect);
		wMoveTo(-1.0, 0.0);
		for (k = 1; k < nint; k++)
		{
			sysRK4(t, h, x, 2);
			t += h;
			wLineTo(t, x[0]);
		}
		UnlockPixels(offPort2->portPixMap);
		SetGWorld(oldGWorld, oldGDev);
		
		/* copy background from offscreen port #1 to offscreen port #2 */
		CopyBits((BitMap *) &offPort1->portPixMap, (BitMap *) &offPort2->portPixMap,  
			&offRect, &offRect, srcOr, NULL);
		/* copy picture from off screen port #2 to onscreen port */
		CopyBits((BitMap *) &offPort2->portPixMap, &(WPtr_Particle_in_a_B->portBits),  
			&offRect, &HotRect_RectPsi, srcCopy, NULL);

		switch (ntrial)
		{
			case 1 :  beta1 = x[0];
					  break;
			case 2 :  beta2 = x[0];
				      break;
			default : beta1 = beta2;
					  beta2 = x[0];
					  break; 
		}
		
		/* look for crossing zero:  beta1 and beta2 are opposite sign */
		if (beta1*beta2 < 0.0)
		{
			nroots++;
			/* quick interpolation for energy eigenvalue */
			energyE = v + step*beta2/(beta1-beta2);
			sprintf((char *)sTemp, "#%d at %7.3lf", nroots, energyE);
			CtoPstr((char *)sTemp);
			MoveTo(HotRect_EVals.left+2, HotRect_EVals.top+(nroots*12));
			TextSize(9);
			DrawString(sTemp);
			/* draw this function into the offscreen bitmap #1 permanently */
			GetGWorld(&oldGWorld, &oldGDev);
			SetGWorld(offPort1, NULL);
			LockPixels(offPort2->portPixMap);
			/* if allowed, use green; if forbidden, use red */
			if (energyE < energyA)
				RGBForeColor(&forbidColor);
			else
				RGBForeColor(&allowColor);	
			wMoveTo(-1.0, 0.0);
			h = (b - a)/nint;
			t = a;
			x[0] = s;
			x[1] = z1;
			for (k = 1; k < nint; k++)
			{
				sysRK4(t, h, x, 2);
				t += h;
				wLineTo(t, x[0]);
			}
			RGBForeColor(&Black_ForeColor);
			UnlockPixels(offPort2->portPixMap);
			SetGWorld(oldGWorld, oldGDev);
			/* play the sound */
			mySound = GetResource('snd ', 6);
			SndPlay(NIL, mySound, FALSE);
		}
		ntrial++;
		
		/* ATTENTION!  HERE, IF WE ARE MAKING A MOVIE, WE MAKE A FRAME *
		 * THIS IS COPIED FROM "Movie Construction" ******************* */
		if (makingMovie)
		{
			GetGWorld(&oldGWorld, &oldGDevice);
			SetGWorld(myGWorld, nil);
			EraseRect(&offGRect);
			CopyBits(&(WPtr_Particle_in_a_B->portBits),
					 (BitMap *)pm,
					 &(WPtr_Particle_in_a_B->portRect),
					 &offGRect,
					 srcCopy, NULL);
			
			/* compress the frame */
			ErrorCode = CompressSequenceFrame(seqID, &pm, &offGRect,
				codecFlagUpdatePrevious, StripAddress(*compressedFrameBitsH),
				&compressedFrameSize, &similarity, nil);
			if (ErrorCode) DebugStr((StringPtr)"\pCompressSequenceFrame Failed");
			
			/* add it to the media */
			ErrorCode = AddMediaSample(gMedia, compressedFrameBitsH,
				0L, compressedFrameSize, (TimeValue)1,
				(SampleDescriptionHandle) imageDescriptionH, 1L,
				similarity ? mediaSampleNotSync : 0, &sampTime);
			if (ErrorCode)DebugStr((StringPtr)"\pAddMediaSample Failed");
			SetGWorld(oldGWorld, oldGDevice);
		}

	} while (nroots < 5);
	
	/* remove the last black curve at the end */
	GetGWorld(&oldGWorld, &oldGDev);
	SetGWorld(offPort2, NULL);
	LockPixels(offPort2->portPixMap);
	EraseRect(&offRect);
	SetGWorld(oldGWorld, oldGDev);
	CopyBits((BitMap *) &offPort1->portPixMap, (BitMap *) &offPort2->portPixMap,  
		&offRect, &offRect, srcOr, NULL);
	CopyBits((BitMap *) &offPort2->portPixMap, &(WPtr_Particle_in_a_B->portBits),  
		&offRect, &HotRect_RectPsi, srcCopy, NULL);
	if (makingMovie)
	{
		GetGWorld(&oldGWorld, &oldGDevice);
		SetGWorld(myGWorld, nil);
		EraseRect(&offGRect);
		CopyBits(&(WPtr_Particle_in_a_B->portBits),
				 (BitMap *)pm,
				 &(WPtr_Particle_in_a_B->portRect),
				 &offGRect,
				 srcCopy, NULL);
		
		/* compress the frame */
		ErrorCode = CompressSequenceFrame(seqID, &pm, &offGRect,
			codecFlagUpdatePrevious, StripAddress(*compressedFrameBitsH),
			&compressedFrameSize, &similarity, nil);
		if (ErrorCode) DebugStr((StringPtr)"\pCompressSequenceFrame Failed");
		
		/* add it to the media; add it enough for trailerTime secs elapsed time */
		neededFrames = trailerTime*myTimeScale;
		nFrames = 0;
		do
		{
			ErrorCode = AddMediaSample(gMedia, compressedFrameBitsH,
				0L, compressedFrameSize, (TimeValue)1,
				(SampleDescriptionHandle) imageDescriptionH, 1L,
				similarity ? mediaSampleNotSync : 0, &sampTime);
			if (ErrorCode)DebugStr((StringPtr)"\pAddMediaSample Failed");
		} while (nFrames++ < neededFrames);
		SetGWorld(oldGWorld, oldGDevice);
	}
	
	readyToRun = FALSE;
	if (makingMovie)
	{
		Close_The_Output_File();
		makingMovie = FALSE;
	}

	TextSize(12);
}

void buildBitMap()
{
	GDHandle	currDev;
	CGrafPtr	currPort;
	QDErr		myGoof;
	
	/* Builds two BitMaps which match the "wave function" rectangle pixels */
	/* The following establishes offscreen GWorlds
	 * borrowed from "Braving Offscreen Worlds," G. Ortiz, develop, Jan 90, pg 28. 
	 */
	GetGWorld(&currPort, &currDev);
	
	SetRect(&offRect, 0, 0, 
		HotRect_RectPsi.right - HotRect_RectPsi.left,
		HotRect_RectPsi.bottom - HotRect_RectPsi.top);
	myGoof = NewGWorld(&offPort1, 8, &offRect, NULL, NULL, (GWorldFlags)0); 
	/* if we didn't goof, we've got an offscreen world */
	if (!myGoof) 
	{
		SetGWorld(offPort1, NULL);
		LockPixels(offPort1->portPixMap);
		EraseRect(&offRect);
		/* Fill rectangle -- not in Marksman */
		/* not sure how to get these colors -- jma 6/1/93 */
		RGBForeColor(&bkgdColor);
		FillRect(&offRect, black); 
		RGBForeColor(&Black_ForeColor);		

		MoveTo(100, 0);
		LineTo (100, 199);
		MoveTo(0, 100);
		LineTo (199, 100);
		FrameRect(&offRect);
		UnlockPixels(offPort1->portPixMap);
	}
	else 
	{
		SysBeep(10);
	}
	
	myGoof = NewGWorld(&offPort2, 8, &offRect, NULL, NULL, (GWorldFlags)0); 
	/* if we didn't goof, we've got an offscreen world */
	if (!myGoof) 
	{
		SetGWorld(offPort2, NULL);
		LockPixels(offPort2->portPixMap);
		EraseRect(&offRect);
		UnlockPixels(offPort2->portPixMap);
	}
	else 
	{
		SysBeep(10);
	}
	SetGWorld(currPort, currDev);
}