/*
 	CAboutBoxDirector
 	Written and copyright by Malcolm H. Teas 1991-2. All rights reserved.
 
 	Use this class to make an about box from a PICT.  Call IAboutBoxDirector() to
 	initialize the about box.  Then, call Flash() or About() to either flash the
 	box (as in a splash screen), or implement the usual about box.  Disposal is 
 	handled automatically as suicide when the box closes.
*/

#define	_H_CAboutBoxDirector		/* Include this file only once */

#include <CDirector.h>
#include <CPane.h>


class CAboutBoxDirector : public CDirector  {
	private:
		CPane		*itsDefaultPane;	//	The default picture pane.
	
	public:
		void IAboutBoxDirector (CDirectorOwner *aSupervisor, short resourceID);
		
		void Flash (long ticks);		// 	Flash the initialized about box for "ticks".
		void About (void);				// 	Show the initialized about box until key or mouse.
	
	private:
		void Dispose (void);
		void DoKeyDown (char c, Byte code, EventRecord *event);
};
