/****
 * CAppPiDoc.h
 *
 *	Document class for a typical application.
 *
 ****/

#define	_H_CAppPiDoc			/* Include this file only once */
#include "CDocument.h"
#include "CApplication.h"
#include "CPiChore.h"

struct CAppPiDoc : CDocument {
	long		numDigits;
	Boolean		timeCalc;
	Boolean		running;
	long		tickCount;
	Boolean		fastCalc;
	CPiChore	*piChore;

									/** Construction/Destruction **/
                                    
    
    void        IAppPiDoc(CApplication *aSupervisor, Boolean printable);
    void        Dispose(void);

	void		DoCommand(long theCommand);
	void		PiDone (char *result);
	void		Dawdle (long *maxSleep);

    void        UpdateMenus(void);  

	void		NewFile(void);
	void		OpenFile(SFReply *macSFReply);
	void		BuildWindow(Handle theData);
	
									/** Filing **/
	Boolean		DoSave(void);
	Boolean		DoSaveAs(SFReply *macSFReply);
	void		DoRevert(void);
};