/*
	CPiChore
	Written and copyright by Malcolm H. Teas 1993.  All rights reserved.
	
*/


#include "CAppPiDoc.h"


/*
 * Global variables
 */
int 	Sign, 
	Zero, 
	Digits, 
 	Pass,	/* two passes */
	Exp,	/* exponent for divide */
	Divide;
static int constant[3]={0,25,239};


CAppPiDoc	*document;
 
/*
 * These character arrays represent the digits for extended
 * precision arithmatic. (These may need to be int on some machines).
 */
#define DIGIT char
DIGIT *Power, *Term, *Result;

void copy (void);
void init(void);
void divi(register DIGIT *array);
void sub (void);
void add (void);


void CPiChore::Perform (long *maxSleep)
{
	long	start;
	
	if (timeCalc)
		start = TickCount ();
	
	do  {
		switch (stage)  {
			case 0:
				init ();
				stage++;
				break;
			
			case 1:
				copy();
				Divide = Exp;
				divi(Term);
				if ( Sign > 0 ) 
					add();
				if ( Sign < 0 ) 
					sub();
				Exp = Exp + 2;
				Sign *= -1;
				Divide = constant[Pass];
				divi(Power);
				if (Pass == 2) 
					divi(Power);
				if (Zero == 0)
					stage++;
				break;
			
			case 2:
				Pass++;
				init ();
				stage++;
				break;
			
			case 3:
				copy();
				Divide = Exp;
				divi(Term);
				if ( Sign > 0 ) 
					add();
				if ( Sign < 0 ) 
					sub();
				Exp = Exp + 2;
				Sign *= -1;
				Divide = constant[Pass];
				divi(Power);
				if (Pass == 2) 
					divi(Power);
				if (Zero == 0)
					stage++;
				break;
			
			case 4:
				if (timeCalc)  {
					ticks += TickCount() - start;
					timeCalc = false;
				}
				document->PiDone (Result);
				stage++;
				break;
			
			case 5:
				break;
		}
	}  while (faster && stage != 5);
	
	if (timeCalc)
		ticks += TickCount() - start;
}


void CPiChore::InitChore (long numDigits, CDocument *doc, Boolean timeIt, Boolean faster)
{
	stage = 0;
	Pass = 1;
	document = (CAppPiDoc *) doc;
	timeCalc = timeIt;
	ticks = 0;
	this->faster = faster;
	
	Digits = numDigits;
	FailNIL (Power = (char *) NewPtr (numDigits + 1));
	FailNIL (Term = (char *) NewPtr (numDigits + 1));
	FailNIL (Result = (char *) NewPtr (numDigits + 1));
}


long CPiChore::GetTicks (void)
{
	return ticks;
}


void CPiChore::Dispose (void)
{
	DisposPtr (Power);
	DisposPtr (Term);

	inherited::Dispose ();	
}

void add (void)
{
	register DIGIT *r, *t;
	register int sum, carry = 0;
    
	r = Result + Digits;
	t = Term + Digits;
 
	while( r >= Result )
	{
		sum = *r + *t + carry;
		carry = 0;
		if( sum >= 10 )
		{
			sum -= 10;
			carry++;
		}
		*r-- = sum;
		--t;
	}
}
 
void sub (void)
{
	register DIGIT *r, *t;
	register int diff, loan = 0;		
	
	r = Result + Digits;
	t = Term + Digits;
 
	while( r >= Result )
	{
		diff = *r - *t - loan;
		loan = 0;
		if( diff < 0 )
		{
			diff += 10;
			loan++;
		}
		*r-- = diff;
		--t;
	}
}
 
void divi(register DIGIT *array)
{
	register DIGIT *end;
	register int quotient, residue, digit = 0;
 
	Zero = 0;
 
	for( end = array + Digits; array <= end; )
	{
		digit    += *array;
		quotient =  digit / Divide;
		residue  =  digit % Divide;
 
		if((Zero !=0) || ((quotient+residue) != 0)) 
			Zero = 1;
		else 
			Zero = 0;
 
		*array++ = quotient;
		digit = 10 * residue;
	}
}
		
void init(void)
{
	register DIGIT *p, *t, *r, *end;
 
	p = Power;
	t = Term;
	r = Result;
	end = Power+Digits;
 
	while( p <= end )
	{
		*p++ = 0;
		*t++ = 0;
 
		if (Pass == 1) 
			*r++ = 0;
	}
 
	*Power = 16 / (Pass * Pass);
 
	if( Pass == 1 ) 
	{
		Divide = 5;
	}
	else
	{
		Divide = 239;
	}
 
	divi(Power);
	Exp = 1;
	Sign = 3 - (2 * Pass);
}
 
void copy (void)
{
	register DIGIT *t, *p, *end;
 
	t = Term;
	p = Power;
	end = Term + Digits;
	
	while (t <= end)
	{
		*t++ = *p++;
	}
}
