/* Hiccup.h - interface and struct for Hiccup.c routines to
grow handles in large steps while adding small bits to them.
Usage: see Hiccup.h
*/

#pragma once

/* A separate HH is passed for each handle being hiccuped.
All positions and sizes are in bytes. */
typedef struct HicHandle // hiccup handle(r)
	{
	Handle	h;
	long	realSize; 	// >= used size
	long	inc;		// increment, > 0.
	long	freePos;	// used size, = next free position
	long	dataSize;	// of one entry. May be 0.
	void	*dataPtr; 	// locked! May be NULL.
	} HicHandle, *HHPtr;

#ifndef HH
#define HH HicHandle
#endif

/* Hiccup.c functions */
Boolean HicNew(HHPtr hP, long startSize, long increment);
Boolean HicAdd(HHPtr hP);
Boolean HicAddPtr(HHPtr hP, void *dataPtr);
Boolean HicAddPtrSize(HHPtr hP, void *dataPtr,
	long dataSize);
void HicClose(HHPtr hP);
void HicDispose(HHPtr hP);
