/*****
 * 
 * BitMaps.c
 * Operations on BitMaps
 * Abridged version for MacTech
 *
 * Alexei Lebedev, April 10, 1992
 *
 *****/

#include "BitMaps.h"

GrafPtr OffscreenPort(BitMap *theBitMap)
{
	register GrafPtr newPort;
	GrafPtr oldPort;

	newPort = (GrafPtr) NewPtr(sizeof(GrafPort));
	if (!newPort) return nil;
	GetPort(&oldPort);
	OpenPort(newPort);
	newPort->portBits = *theBitMap;
	newPort->portRect = theBitMap->bounds;
	RectRgn(newPort->visRgn, &newPort->portRect);
	ClipRect(&newPort->portRect);
	EraseRect(&newPort->portRect);
	SetPort(oldPort);
	return newPort;
}

/* ------------------- */

Boolean NewBitMap(BitMap *theBitMap, Rect *theRect)
{
	theBitMap->rowBytes = (((theRect->right - theRect->left)+15)/16)*2;
	theBitMap->baseAddr = NewPtr((long)(theRect->bottom - theRect->top) 
											* theBitMap->rowBytes);
	theBitMap->bounds = *theRect;
	return (!MemErr);
}