/*****
 * 
 * Cube.c
 * Demonstration program for MacTech
 * 
 * Alexei Lebedev, September 23, 1993
 *
 *****/
 
#include "BitMaps.h"
#include "InitToolbox.c"
#include "Transformations.h"
#include "Projection.h"
#include "Defs3D.h"
#include "SineTable.h"

/* -------------------------- */

enum { fbr, ftr, ftl, fbl, btr, btl, bbl, bbr };

Point cube2D[8];
Vector3D cube[8] = {{ 65536,-65536, 65536},{ 65536, 65536, 65536},
					{-65536, 65536, 65536},{-65536,-65536, 65536},
					{ 65536, 65536,-65536},{-65536, 65536,-65536},
					{-65536,-65536,-65536},{ 65536,-65536,-65536}};

short sides[6][4] ={{fbl,fbr,ftr,ftl},	// front
					{ftl,ftr,btr,btl},	// top
					{bbl,fbl,ftl,btl},	// left
					{fbr,bbr,btr,ftr},	// right
					{fbr,fbl,bbl,bbr},	// bottom
					{bbr,bbl,btl,btr}};	// back
WindowPtr win;

/* -------------------------- */

static short visi(Point p1, Point p2, Point p3)
{
	return (long)((p2.v - p1.v) * (p3.h - p1.h)) - 
		   (long)((p2.h - p1.h) * (p3.v - p1.v));
}

/* -------------------------- */

static void DrawFace(short x[])
{
	short i;
	Point p[4];
	PolyHandle poly;
	
	for (i = 0; i < 4; i++) p[i] = cube2D[x[i]];
	if (visi(p[0], p[1], p[2]) < 0) return;

	poly = OpenPoly();
		
	asm {
		move.l	p[0], -(sp)
		_MoveTo
		move.l	p[1], -(sp)
		_LineTo
		move.l	p[2], -(sp)
		_LineTo
		move.l	p[3], -(sp)
		_LineTo
		move.l	p[0], -(sp)
		_LineTo
	}
	
	ClosePoly();
	FillPoly(poly, gray);
	FramePoly(poly);
	KillPoly(poly);
}

/* -------------------------- */

void main()
{
	BitMap offmap;
	GrafPtr offport;
	Rect winr = {90, 50, 90 + 256, 50 + 256};
	short i;
	
	InitToolbox();
	FlushEvents(everyEvent, 0);
	
	win = NewWindow(nil, &winr, "\pCube", 1, 0, (WindowPtr)-1, 0, 0);
	if (!win) return;
	
	((long*)&winr)[0] -= (90 * 65536 + 50);
	((long*)&winr)[1] -= (90 * 65536 + 50);
	
	if (!NewBitMap(&offmap, &winr)) return;
	if (!(offport = OffscreenPort(&offmap))) return;
	
	HideCursor();
	InitSineTable();
	SetSpaceSize(3, 3);
	SetViewAngle(25, 25);

	ViewPort(&winr);
	
	while (!Button()) {
				
		SetPort(offport);
		EraseRect(&winr);
		
		for (i = 0; i < 8; i++) {
			YawPoint(&cube[i], -3);
			PitchPoint(&cube[i], 5);
			RollPoint(&cube[i], -7);
			D3toD2(&cube[i], &cube2D[i]);
		}

		for (i = 0; i < 6; i++) DrawFace(sides[i]);
		
		SetPort(win);
		CopyBits(&offport->portBits, &win->portBits, 
					&winr, &winr, srcCopy, nil);
	}
	
	ShowCursor();
	FlushEvents(everyEvent, 0);
}
	