/* ConnectTheDots.com -------------------------------------
 *
 * The part of the line drawing algorithm common to
 * all three depths.
 *
 * This is an unusual, but very useful way to use
 * #include directive.
 *
 * Treat this file like a .h file, though it contains
 * code instead of interface info.  That means, like
 * a .h file, you do not directly compile or link this
 * file.  If using Think C, don't put it in your project.
 * It automatically becomes part of the .c file at
 * compile time.
 */

// start --------------------------------------------------

	register Ptr		rowBytes;
	register short		*pnt;
	register short		dh, dv, h_Sum, v_Cnt;
	Ptr					savedRowBytes;
	short				*savedPnt;
	short				pad;
	
	--nDots;
	
	pnt = (short*)dot;
	savedRowBytes = (Ptr)(pm->rowBytes & 0x7fff);

	do {
		
		// find this seg's dimensions {dv,dh} and
		// endpoints in bounds coordinate system-
		// ends are (v,h) and (v+dv,h+dh).
		
		// point to pixels, and restore rowBytes,
		// which are altered in loop.

		dv       = *pnt++;
		dh       = *pnt++;
		v_Cnt    = *pnt;
		h_Sum    = pnt[1];
		dv      -= v_Cnt;
		dh      -= h_Sum;
		v_Cnt   -= pm->bounds.top;
		h_Sum   -= pm->bounds.left;
		at       = pm->baseAddr;
		rowBytes = savedRowBytes;
		
		if( !dh ) {
		
			// do vertical line
			
			if( dv < 0 ) {
				v_Cnt += dv;
				dv = -dv;
			}

			at = (Ptr)at + (long)v_Cnt*(short)rowBytes;
			at += h_Sum;
			
			v_Cnt = dv + 1;
			
doVert:
			do {
				*at = pixel;
				at = (Ptr)at + (long)rowBytes;
			} while( --v_Cnt );
		}
		else if( !dv ) {
		
			// do horizontal line
			
			if( dh < 0 ) {
				h_Sum += dh;
				dh = -dh;
			}
			
			at = (Ptr)at + (long)v_Cnt*(short)rowBytes;
			at += h_Sum;
			
			++dh;
			
			do {
				*at++ = pixel;
			} while( --dh );
		}
		else if( Abs( dv ) >= Abs( dh ) ) {
		
			// more vertical or diagonal
		
			if( dv < 0 ) {
				v_Cnt += dv;
				h_Sum += dh;
				dv = -dv;
				dh = -dh;
			}
			
			at = (Ptr)at + (long)v_Cnt*(short)rowBytes;
			at += h_Sum;
			
			v_Cnt = dv + 1;
			
			if( dh == dv ) {
				rowBytes += sizeof(pixel);
				goto doVert;
			}
			else if( -dh == dv ) {
				rowBytes -= sizeof(pixel);
				goto doVert;
			}
			else {

				h_Sum = 0;
				
				savedPnt = pnt;
				pnt = (short*)sizeof(pixel);
				
				if( dh < 0 ) {
					dh = -dh;
					pnt = (short*)-sizeof(pixel);
				}

				do {
					*at = pixel;
					at = (Ptr)at + (long)rowBytes;
					
					h_Sum += dh;
					
					if( h_Sum >= dv ) {
						h_Sum -= dv;
						at = (Ptr)at + (long)pnt;
					}
				} while( --v_Cnt );
				
				pnt = savedPnt;
			}
		}
		else {
		
			// more horizontal
		
			if( dh < 0 ) {
				v_Cnt += dv;
				h_Sum += dh;
				dv = -dv;
				dh = -dh;
			}
			
			at = (Ptr)at + (long)v_Cnt*(short)rowBytes;
			at += h_Sum;
			
			v_Cnt = dh + 1;
			h_Sum = 0;

			if( dv < 0 ) {
				dv = -dv;
				rowBytes = (Ptr)(-(short)rowBytes);
			}
			
			do {
				*at++ = pixel;
				
				h_Sum += dv;
				
				if( h_Sum >= dh ) {
					h_Sum -= dh;
					at = (Ptr)at + (long)rowBytes;
				}
			} while( --v_Cnt );
		}
	} while( --nDots );
	
// end ----------------------------------------------------
