/* TStats.h ------------------------------------------------------
 *
 * Accumulate, calculate and display timing data.
 *
 * Copyright (c) 1993 Bill Karsh.
 * All rights reserved.
 *
 */

 
#pragma once


typedef struct {
	long	*data;
	long	N,
			min, max;
} TSArray;


typedef struct {
	
	WindowPtr	w;
	Rect		plotR1,		plotR2,
				statsR1, 	statsR2;
				
	TSArray		raw1,		raw2,
				work1,		work2,
				bins1,		bins2;
	
	long		*acc1,		*acc2;
	long		maxRaw;
				
	double		combRawSd;
				
} TSRec, *pTS;


#define		kRaw	0	// sourceTypes
#define		kWork	1



void	TSInit( Rect *rGlobal, long nData, long nBins );
void	TSDispose( void );

void	TSAccumulate( long time1, long time2 );

void	TSRawPlots( void );
void	TSStats( long sourceType );

void	TSRawHistos( void );
Boolean	TSFilterMode( long sourceType );
