// This describes the interface between the library code and the native application 

#include <Types.h>
#include <ConditionalMacros.h>
#include <MixedMode.h>

typedef void (*CallbackPtr)(void); // A pointer which is fed to the library

typedef pascal OSErr (*Routine1ProcPtr)(CallbackPtr callbackRoutine);

enum {
	uppRoutine1ProcInfo = kPascalStackBased
		 | RESULT_SIZE (SIZE_CODE(sizeof(OSErr)))
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(CallbackPtr)))
};

#if USESROUTINEDESCRIPTORS
// Use these definitions if we're compiling for Power Macintosh or another
// Macintosh system which supports Mixed Mode
typedef UniversalProcPtr Routine1UPP;

#define CallRoutine1Proc(userRoutine, longValue)		\
		CallUniversalProc((UniversalProcPtr)(userRoutine),\
			uppRoutine1ProcInfo, longValue)
#define NewRoutine1Proc(userRoutine)		\
		(RoutineUPP) NewRoutineDescriptor((ProcPtr)userRoutine, \
					   uppRoutine1ProcInfo, GetCurrentISA())
#else
// Use these definitions if we're compiling for a 68K-based Macintosh
typedef Routine1ProcPtr Routine1UPP;

#define CallRoutine1Proc(userRoutine, longValue)		\
		(*((Routine1ProcPtr)userRoutine))(longValue)
#define NewRoutine1Proc(userRoutine)		\
		(Routine1UPP)(userRoutine)
#endif

	
// Here's the list of Universal Procedure Pointers
struct JumpTable {
	Routine1UPP	routine1;
};

typedef struct JumpTable JumpTable, *JumpTablePtr;

// === Information on calling the 68K setup functions
typedef pascal OSErr (*SetupProcPtr)(JumpTablePtr);

enum {
	uppSetupProcInfo = kPascalStackBased
		 | RESULT_SIZE (SIZE_CODE(sizeof(OSErr)))
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(JumpTablePtr)))
};

#if USESROUTINEDESCRIPTORS
// Use these definitions if we're compiling for Power Macintosh or another
// Macintosh system which supports Mixed Mode
typedef UniversalProcPtr SetupUPP;

#define CallSetupProc(userRoutine, jumpTableAddr)		\
		CallUniversalProc((UniversalProcPtr)(userRoutine),\
			uppSetupProcInfo, jumpTableAddr)
#define NewSetupProc(userRoutine)		\
		(SetupUPP) NewRoutineDescriptor((ProcPtr)userRoutine, \
					   uppSetupProcInfo, GetCurrentISA())
#else
// Use these definitions if we're compiling for a 68K-based Macintosh
typedef SetupProcPtr SetupUPP;

#define CallSetupProc(userRoutine, jumpTableAddr)		\
		(*((SetupProcPtr)userRoutine))(jumpTableAddr)
#define NewSetupProc(userRoutine)		\
		(SetupUPP)(userRoutine)
#endif

