#===========================================================================
# Debug a Tcl procedure.
#===========================================================================

# Alpha TCL programming mode
proc traceTclProc {} {
	if {[llength [traceFunc status]]>2} {
		traceFunc off
		markMenuItem Tcl traceTclProc off
		dumpTraces
		return
	}
	set func [listpick -p {Func Name:} [lsort [info procs]]]
	if {![string length $func]} return
	traceFunc on $func ""
	catch {markMenuItem Tcl traceTclProc on}
}

proc setTclMode {} {
	changeMode "Tcl"
	uplevel #0 {
		set elecLBrace 0
		set elecRBrace 0
		set electricSemi 0
		set wordWrap 0
		set funcExpr {^proc *([+-a-zA-Z0-9]+)}
		set wordBreakPreface {[^a-zA-Z0-9_\$]}
		set wordBreak {(\$)?[a-zA-Z0-9_]+}
		set funcPar 1
		set sortedIsDefault 1
		set prefixString "# "
	}
	insertMenu Tcl
}

