/*
 *	Main.h
 *
 *	General interface definitions for the main application
 */

/* Useful macros */

#define NIL ((void *)0)
#define MAXWINDOWS 16
#define WIDGETHEIGHT	64
#define WIDGETWIDTH		64
#define SCROLLBARWIDTH	16
#define TITLEBARHEIGHT	21

/* Useful types and IDs */

#define fezHatColorIconID	128
#define fezHatSelectedID	129

#define aboutBoxAlertID		129
#define BWaboutBoxAlertID	130

#define appleMenuID	128
enum {
		AM_About = 1
	};

#define fileMenuID	129
enum {
		FM_New = 1,
		FM_Open,
		FM_Close,
		FM_CloseAll,
		FM_______5,
		FM_Quit
	};

#define editMenuID	132
enum {
		EM_Undo = 1,
		EM_____2,
		EM_Cut,
		EM_Copy,
		EM_Clear,
		EM_Paste,
		EM_____7,
		EM_SelectAll,
		EM_SendBehind
	};

#define demoMenuID 130
enum {
		DM_SaveDemo = 1,
		DM____2,
		DM_None
	};

#define optionsMenuID 131
enum {
		OM_SetLine = 1,
		OM_SetSpeed,
		OM_SetQueue,
		OM________4,
		OM_NoZooms,
		OM_StandardZooms,
		OM_OneWindowDive,
		OM_FrameEvading
	};

#define windowMenuID	133
#define openWindowMenuID 134
#define closeWindowMenuID 135

// items created dynamically

typedef struct {

	Rect		position;					// Local window coords of openable widget
	WindowPtr	openWindow;					// The window it got opened into
	WindowPtr	itsWindow;					// The window it is within
	short		isSelected;					// Needs selection highlight
	
	} Widget, *WidgetPtr, **WidgetHandle;


// Structure of each entry in the 'DEMO' setup resource.  The i'th entry corresponds
// to the i'th Fez window to open at a given position.  The order field says what
// order to select the windows after their opened so that we can create and store a
// window list ordering different from the order they were opened in.

typedef struct {
	Rect	position;				// Window position in global coordinates
	Rect	fezBounds;				// Where to place Fez in window
	short	finalOrdering;			// Index of window in final window list
	short	closeOrdering;			// Index of window to close (or -1)
	
	} StartWindow;

typedef struct {
	short numWins;
	StartWindow win[1];
	} **StartWindowHandle;

// Prototypes
short GetLineThickOrSpeed(short oldVal, int doSpeed);
