// Source container: movie-player.dylan

define class <movie-player-behavior> (<behavior>)
end class;

define method behavior-setup-menus (behavior :: <movie-player-behavior>, 
                                    next :: <list>,
                                    main-handler :: <main-handler>)
  ignore(behavior, next, main-handler);
  next-method();
end method;

// callback for Quit menu item
define method behavior-event (behavior :: <movie-player-behavior>, 
                              next :: <list>, 
                              main-handler :: <main-handler>,
                              event :: <menu-event>, 
                              id == #"quit")
  ignore(behavior, next, main-handler, event, id);
  exit-quicktime();
  next-method();
end method;    

define method init-movie ()

// initalizes the Framework and QuickTime
  init-framework();
  init-quicktime();
  
  // Set up the menus.
  
  make(<menu>,
       title: "File",
       install: #t,
       items: list(make(<menu-item>,
                        title: "New",
                        identifier: #"new",
                        command-key: 'N'),
                   make(<menu-item>,
                        title: "Open",
                        identifier: #"open",
                        command-key: 'O'),
                   make(<separator-item>),
                   make(<menu-item>,
                        title: "Save",
                        identifier: #"save",
                        command-key: 'S'),
                   make(<menu-item>,
                        title: "Save As",
                        identifier: #"save-as"),
                   make(<separator-item>),
                   make(<menu-item>,
                        title: "Close",
                        identifier: #"close",
                        command-key: 'W'),
                   make(<separator-item>),
                   make(<menu-item>,
                        title: "Quit",
                        identifier: #"quit",
                        command-key: 'Q')));
  *edit-menu* :=
     make-edit-menu(install: #t);

  make(<menu>,
       title: "Movie",
       install: #t,
       items: list( 
                   make(<menu-item>,
                        title: "Go To Poster Frame",
                        identifier: #"show-poster"),
                   make(<menu-item>,
                        title: "Set Poster Frame",
                        identifier: #"set-poster")
                        ));

  
  add-behavior(*main-handler*, make(<movie-player-behavior>));
  
  add-document-type(*main-handler*, $MovieFileType, <movie-document>);
  
  #t;
end method;

// this method is called to actually run the application 
define method run-movie ()
  init-movie();
  run();
end method;


