// source container:  movie-utils.dylan

define variable *controller-list* = #();
define variable *edit-menu* = #();

// this is the event hook called from the event loop to filter out movie 
//controller events
define constant controller-event-hook =
     method (event-rec :: <EventRecord>)
       block(exit)
         for (mc in *controller-list*)
           if(MCIsPlayerEvent(mc, event-rec) ~= 0)
             exit(#t);
           end if;
         end for;
         #f;
       end block; 
end method;

// this must be called to intialize QuickTime!
define constant init-quicktime =
     method ()
       fail-os-error(EnterMovies());
       *controller-list* := #();
       *event-hooks* := add(*event-hooks*, controller-event-hook); 
     end method;

// recommended to call this upon exiting QuickTime
define constant exit-quicktime =
     method()
       ExitMovies();
     end method;

// opens a movie file
define method open-movie-file (file :: <file>)
  with-stack-structure(spec(<FSSpec>),
                       begin
                         set-fs-spec(file, spec);
                         let (err, ref-num) = 
                              OpenMovieFile(spec, file.data-permission);
                         fail-os-error(err);
                         file.data-ref-num := ref-num;
                       end);
   end method;

// closes a movie file
define method close-movie-file (file :: <file>)
  unless (~(file.data-ref-num))
    CloseMovieFile(file.data-ref-num);
    file.data-ref-num := 0;
  end unless;
end method;
