// Source container: toolbox-interface.dylan

// Interface to C files

// Files.h

define interface
  #include "Files.h",
     	import: {"fsWrPerm"};
end interface;

             
// Quickdraw.h

define interface
  #include "Quickdraw.h",
     	import:  { "CGrafPort",  "GDHandle"},
     
     type: {"CQDProcsPtr" => <machine-pointer>};
  
  end interface;

// Movies.h

define interface
  // import everything from Movies.h, 
  // and just a few necessary types from some other files.
  
  #include "TextEdit.h",
     define: {"SystemSevenOrLater" => 1},
     import: {"ScrpSTElement"};
  
  #include "Components.h",
     define: {"SystemSevenOrLater" => 1},
     import: {"Component", "ComponentInstance"};
  
  #include "ImageCompression.h",
     import: {"MatrixRecord"};
  
  #include "Movies.h",
define: {"SystemSevenOrLater" => 1};
                                   
  function "PreflightMovie", output-argument: outFlags;
  function "GetMovieGWorld", output-argument: port, output-argument: gdh;
  function "GetMoviePreviewTime", output-argument: previewTime, output-
argument: previewDuration;
  function "GetMovieSelection", output-argument: selectionTime, output-
argument: selectionDuration;
  function "GetMovieActiveSegment", output-argument: startTime, output-
argument: duration;
  function "GetTrackDimensions", output-argument: width, output-argument: 
height;
  function "GetMediaHandlerDescription", output-argument: mediaType, 
output-argument: creatorManufacturer;
  
  function "SampleNumToMediaTime", output-argument: sampleTime, 
output-argument: sampleDuration;
  function "MediaTimeToSampleNum", output-argument: sampleNum, output-
argument: sampleTime,
     output-argument: sampleDuration;
  function "AddMediaSample", output-argument: sampleTime;
  function "AddMediaSampleReference", output-argument: sampleTime;
  function "GetMediaSample", output-argument: size, output-argument: 
sampleTime, 
     output-argument: durationPerSample,output-argument: 
sampleDescriptionIndex, 
     output-argument: numberOfSamples, output-argument: sampleFlags;
  function "GetMediaSampleReference", 
     output-argument: dataOffset, output-argument: size, output-argument: 
sampleTime, 
     output-argument: durationPerSample, output-argument: 
sampleDescriptionIndex, 
     output-argument: numberOfSamples, output-argument: sampleFlags;
  function "GetMediaShadowSync", output-argument: syncSampleNum;
  function "ConvertFileToMovieFile", output-argument: resID;
  function "ConvertMovieToFile", output-argument: resID;
  function "GetTrackDimensions", output-argument: height;
  function "GetMediaHandlerDescription", output-argument: mediaType, 
output-argument: creatorManufacturer;
  function "GetMediaDataHandlerDescription", output-argument: dhType, 
output-argument: creatorManufacturer;
  function "SampleNumToMediaTime", output-argument: sampleTime, 
output-argument: sampleDuration;
  function "MediaTimeToSampleNum", output-argument: *sampleNum, 
output-argument: sampleTime, output-argument: sampleDuration;
  function "AddMediaSample", output-argument: sampleTime;
  function "AddMediaSampleReference", output-argument: sampleTime;
  function "GetMediaSample", output-argument: size, output-argument: 
sampleTime, 
     output-argument: durationPerSample, output-argument: 
sampleDescriptionIndex, output-argument: numberOfSamples,
     output-argument: sampleFlags;
  function "GetMediaSampleReference", output-argument: dataOffset, output-
argument: size, 
     output-argument: sampleTime, output-argument: durationPerSample, 
output-argument: sampleDescriptionIndex,
     output-argument: numberOfSamples, output-argument: sampleFlags;
  function "GetMediaShadowSync", output-argument: syncSampleNum;
  function "ConvertFileToMovieFile", output-argument: resID;
  function "ConvertMovieToFile", output-argument: resID;
  function "GetMediaNextInterestingTime", output-argument: 
interestingTime, output-argument: interestingDuration;
  function "GetTrackNextInterestingTime", output-argument: interestingTime, 
output-argument: interestingDuration;
  function "GetMovieNextInterestingTime", output-argument: 
whichMediaTypes, output-argument: interestingTime,
     output-argument: interestingDuration;
  function "CreateMovieFile", output-argument: resRefNum, output-argument: 
newmovie;
  function "OpenMovieFile", output-argument: resRefNum;
  
  function "NewMovieFromFile", output-argument: theMovie, output-
argument: resId, output-argument: dataRefWasChanged;
  function "NewMovieFromHandle", output-argument: theMovie, output-
argument: dataRefWasChanged;
  function "NewMovieFromDataFork", output-argument: theMovie, output-
argument: dataRefWasChanged;
  function "AddMovieResource", output-argument: resId;
  function "GetMovieDefaultDataRef", output-argument: dataRef, output-
argument: dataRefType;
  function "FlattenMovie", output-argument: resId;
  function "GetVideoMediaGraphicsMode", output-argument: graphicsMode;
  function "GetSoundMediaBalance", output-argument: balance;
  function "AddTextSample", output-argument: sampleTime;
  function "AddTESample", output-argument: sampleTime;
  function "AddHiliteSample", output-argument: sampleTime;
  function "FindNextText", output-argument: foundTime, output-argument: 
foundDuration, output-argument: offset;
  function "GetMovieCoverProcs", output-argument: uncoverProc, output-
argument: coverProc, output-argument: refcon;
  function "GetMovieStatus", output-argument: firstProblemTrack;
  function "GetMediaDataRef", output-argument: dataRef, output-argument: 
dataRefType, output-argument: dataRefAttributes;
  function "AddMediaDataRef", output-argument: index;
  function "GetMediaDataRefCount", output-argument: count;
  function "MCGetCurrentTime", output-argument: scale;
  function "MCGetControllerInfo", output-argument: someFlags;
  function "MCGetClip", output-argument: theClip, output-argument: 
movieClip;
  function "MCDrawBadge", output-argument: badgeRgn;
  
end interface;


// Events.h

define interface
  #include "Events.h",
     import: {"GetMouse",  "TickCount"};
end interface;

// Menus.h

define interface
  #include "Menus.h",
     import: {"MenuHandle"};
end interface;