/*
	RGBtoYUV.h - Header for RGBtoYUV routine.
	
	MacTech Magazine Programmers' Challenge
	July, 1994
	Written by Robert A. Noll
	
	Copyright (c) 1994 Robert A. Noll
*/

#define NegToZero 1

typedef struct {
	unsigned long	sig;
	unsigned long*	rp;
	unsigned long*	gbp;
	unsigned char*	up;
	unsigned char*	vp;
	unsigned long	r[256];
	unsigned long	gb[65536];
	unsigned char	u[65536];
	unsigned char	v[65536];
	} PrivateBlock;

void *RGBtoYUVInit(void);

void RGBtoYUV(unsigned char *rPtr,	/* Red buffer */
			  unsigned char *gPtr,	/* Green buffer */
			  unsigned char *bPtr,	/* Blue buffer */
			  unsigned char *yPtr,	/* Luminance buffer */
			  signed char *uPtr,	/* U Chrominance buff */
			  signed char *vPtr,	/* V Chrominance buff */
			  unsigned long numPixels,/* Number of Pixels */
			  void *privateDataPtr);/* My private data */
