/* This is our combined header/body resource for playing music with */
/* QuickTime 2.0's tune player component */

type 'Musi' {
	/* First the length of the header & MusicDescription record */
	/* The MusicDescription record isn't actually used by us */
	/* or passed as a parameter, but I kept this information */
	/* just so it would be easy to convert QuickTime music tracks */
	/* to 'Musi' resources. */
	
start:	longint = $$CountOf(header) * $17 * 4 + 20 + 4;
	/* next, the media handler type used by QuickTime */
	longint = 'musi';
	longint = 0; /* Reserved 1 */
	integer = 0; /* Reserved 2 */
	integer = 1; /* dataRefIndex */
	longint = 0; /* music flags */
/* and here is the actual start of the music header - we just */
/* currently define NoteRequest general events */
	array header {
		bitstring[4] = $F; /* general event */
		bitstring[12];	/* What instrument */
		bitstring[16] = $0017; /* length of note request general event */
		/* here is the noteRequest record */
		longint; /* Polyphony, usually 1 */
		hex longint; /* TypicalPolyphony, fixed, usually $10000 */
		longint kAnyComponentType = 0; /* OSType of synth component */
		pstring[31]; /* Synthesizer name such as "Any Synthesizer" */
		pstring[31]; /* Preferred Instrument name for human use*/
		longint;	/* instrument number if synth-type matches */
		longint;	/* gm number - best matching general MIDI number */
		longint = $C0010017; /* this was a note request */
	};
	longint = $60000000; /* The marker at the end of the header */
/* Here are the body of the music */
bodystart:
	array {
		switch {
		case restCommand:
			key bitstring[3] = $0;
			bitstring[5] = 0; /* unused */
			bitstring[24]; /* duration */
		case noteCommand:
			key bitstring[3] = $1;
			unsigned bitstring[5]; /* instrument */
			unsigned bitstring[6]; /* pitch */
			unsigned bitstring[7]; /* volume */
			unsigned bitstring[11]; /* duration */
		case markerCommand:
			key bitstring[3] = $3;
			bitstring[5] = 0; /* unused */
			unsigned bitstring[8]; /* subtype */
			bitstring[16]; /* value */
		case controlCommand:
			key bitstring[3] = $2;
			unsigned bitstring[5]; /* instrument */
			unsigned bitstring[8]; /* control number */
			bitstring[16]; /* value */
		};
	};
};
