// Copyright  1986-1992 Apple Computer, Inc.  All rights reserved.
// Default resource file.

//  Auto-Include the requirements for this source
#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif

// Get the application's CODE.  Note that this is done this way so that the application can
// be linked and/or rezzed separately.  Also, Rez currently (MPW 3.0) does not support
// -align longword simultaneously with the -append option (but it only tells you if you're
// getting -p progress indication).
include $$Shell("ObjApp")$$Shell("XAppName") 'CODE';

// Basic resources for various purposes.
// Self evident from their names!
include "MacApp.rsrc" not 'ckid';
include "Printing.rsrc" not 'ckid';

#if qDebug | qPerform
include "Debug.rsrc" not 'ckid';
include "Dialog.rsrc" not 'ckid';
#endif


// Now include the "default" resources
// Note: you can pick and choose to selectively replace defaults in your own Rez source.
#if qTemplateViews
include "Defaults.rsrc"  'STR#' (kDefaultWindowTitle);
#else
include "Defaults.rsrc"  'WIND' (kDefaultWindowID);
#endif

include "Defaults.rsrc"  'ALRT' (phAboutApp);
include "Defaults.rsrc"  'CMNU' (mBuzzwords);
include "Defaults.rsrc"  'CMNU' (mApple);
include "Defaults.rsrc"  'CMNU' (mEdit);
include "Defaults.rsrc"  'CMNU' (mFile);
include "Defaults.rsrc"  'DITL' (phAboutApp);
include "Defaults.rsrc"  'MBAR' (kMBarDisplayed);
include "Defaults.rsrc"  'STR#' (kDefaultCredits);
include "Defaults.rsrc"  'seg!' (kDefaultSegResource);

// Get the default MacApp application icon and necessary bundling rsrcs
include "Defaults.rsrc"  'SS01' (0);
include "Defaults.rsrc"  'FREF' (128);
include "Defaults.rsrc"  'FREF' (129);
include "Defaults.rsrc"  'FREF' (130);
include "Defaults.rsrc"  'BNDL' (128);
include "Defaults.rsrc"  'ICN#' (128);		// Application B&W icon
include "Defaults.rsrc"  'ics#' (128);		// Application B&W small icon
include "Defaults.rsrc"  'ics4' (128);		// Application 8 bit smaller color icon
include "Defaults.rsrc"  'ics8' (128);		// Application 8 bit small color icon
include "Defaults.rsrc"  'icl4' (128);		// Application 8 bit medium color icon
include "Defaults.rsrc"  'icl8' (128);		// Application 8 bit color icon
include "Defaults.rsrc"  'ICN#' (129);		// Document B&W icon
include "Defaults.rsrc"  'ics#' (129);		// Document B&W small icon
include "Defaults.rsrc"  'ics4' (129);		// Document 8 bit smaller color icon
include "Defaults.rsrc"  'ics8' (129);		// Document 8 bit small color icon
include "Defaults.rsrc"  'icl4' (129);		// Document 8 bit medium color icon
include "Defaults.rsrc"  'icl8' (129);		// Document 8 bit color icon
include "Defaults.rsrc"  'ICN#' (130);		// Stationery B&W icon
include "Defaults.rsrc"  'ics#' (130);		// Stationery B&W small icon
include "Defaults.rsrc"  'ics4' (130);		// Stationery 8 bit smaller color icon
include "Defaults.rsrc"  'ics8' (130);		// Stationery 8 bit small color icon
include "Defaults.rsrc"  'icl4' (130);		// Stationery 8 bit medium color icon
include "Defaults.rsrc"  'icl8' (130);		// Stationery 8 bit color icon

// Get the default Version resources
include "Defaults.rsrc"  'vers' (1);		// Application or file specific
include "Defaults.rsrc"  'vers' (2);		// Overall package

resource 'SIZE' (-1) {
	1,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	isStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	768000,
	768000
};

resource 'View' (1001, "kDefaultWindowID", purgeable) {
	MAThreeOh,
	{	/* array ViewArray: 5 elements */
		/* [1] */
		ViewSignatureAndClassname {
			'wind',
			531,
			"",
			'WIND',
			enabled,
			noIdle,
			{	/* array BehaviorArray: 0 elements */
			},
			MAThreeOh,
			{	/* array: 2 elements */
				/* [1] */
				50,
				/* [2] */
				20
			},
			{	/* array: 2 elements */
				/* [1] */
				260,
				/* [2] */
				530
			},
			sizeVariable,
			sizeVariable,
			shown,
			doesntWantToBeTarget,
			handlesCursor,
			letsSubViewsHandleCursor,
			noCursorID,
			handlesHelp,
			letsSubViewsHandleHelp,
			noHelpID,
			1,
			NoDrawingEnvironment {

			},
			AdornerListSignatureAndClassname {
				NoIdentifier,
				AdornerList,
				AdornerElementSize,
				AdornerElementSizeShift,
				DynamicArrayAllocationIncrement,
				{	/* array AdornerElementArray: 3 elements */
					/* [1] */
					AdornFirst,
					AdornerLocalObject {
						EraseAdorner
					},
					/* [2] */
					DrawView,
					AdornerLocalObject {
						DrawAdorner
					},
					/* [3] */
					AdornLast,
					AdornerLocalObject {
						ResizeIconAdorner
					}
				}
			},
			emptyUserArea,
			Window {
				zoomDocProc,
				'DFLT',
				goAwayBox,
				resizable,
				ignoreFirstClick,
				freeOnClosing,
				disposeOnFree,
				closesDocument,
				openWithDocument,
				dontAdaptToScreen,
				stagger,
				forceOnScreen,
				dontCenter,
				doesntFloat,
				doesntHideOnSuspend,
				generateActivates,
				filler,
				1006,
				1
			},
			3
		},
		/* [2] */
		ViewSignatureAndClassname {
			'scrl',
			183,
			"",
			'SCLR',
			enabled,
			noIdle,
			{	/* array BehaviorArray: 0 elements */
			},
			MAThreeOh,
			{	/* array: 2 elements */
				/* [1] */
				0,
				/* [2] */
				0
			},
			{	/* array: 2 elements */
				/* [1] */
				245,
				/* [2] */
				515
			},
			sizeRelSuperView,
			sizeRelSuperView,
			shown,
			doesntWantToBeTarget,
			handlesCursor,
			letsSubViewsHandleCursor,
			noCursorID,
			handlesHelp,
			letsSubViewsHandleHelp,
			noHelpID,
			1,
			NoDrawingEnvironment {

			},
			NoAdorners {

			},
			emptyUserArea,
			Scroller {
				'vCLR',
				'hCLR',
				{	/* array: 2 elements */
					/* [1] */
					134,
					/* [2] */
					414
				},
				{	/* array: 2 elements */
					/* [1] */
					16,
					/* [2] */
					16
				},
				VertConstrain,
				HorzConstrain,
				{	/* array: 4 elements */
					/* [1] */
					0,
					/* [2] */
					0,
					/* [3] */
					0,
					/* [4] */
					0
				},
				respondsToFKeys
			},
			1
		},
		/* [3] */
		ViewSignatureAndClassname {
			'inc@',
			72,
			"",
			noID,
			enabled,
			noIdle,
			{	/* array BehaviorArray: 0 elements */
			},
			MAThreeOh,
			{	/* array: 2 elements */
				/* [1] */
				0,
				/* [2] */
				0
			},
			{	/* array: 2 elements */
				/* [1] */
				134,
				/* [2] */
				414
			},
			sizeFixed,
			sizeFixed,
			shown,
			doesntWantToBeTarget,
			handlesCursor,
			letsSubViewsHandleCursor,
			noCursorID,
			handlesHelp,
			letsSubViewsHandleHelp,
			noHelpID,
			1,
			NoDrawingEnvironment {

			},
			NoAdorners {

			},
			emptyUserArea,
			IncludeAt {
				1002,
				{	/* array: 2 elements */
					/* [1] */
					0,
					/* [2] */
					0
				}
			},
			NoSubviews
		},
		/* [4] */
		ViewSignatureAndClassname {
			'ssbr',
			101,
			"",
			'hCLR',
			enabled,
			noIdle,
			{	/* array BehaviorArray: 0 elements */
			},
			MAThreeOh,
			{	/* array: 2 elements */
				/* [1] */
				245,
				/* [2] */
				-1
			},
			{	/* array: 2 elements */
				/* [1] */
				16,
				/* [2] */
				417
			},
			sizeVariable,
			sizeVariable,
			shown,
			doesntWantToBeTarget,
			handlesCursor,
			letsSubViewsHandleCursor,
			noCursorID,
			handlesHelp,
			letsSubViewsHandleHelp,
			noHelpID,
			1,
			NoDrawingEnvironment {

			},
			NoAdorners {

			},
			emptyUserArea,
			ScrollerScrollBar {
				mVScrollBarHit,
				notHilited,
				notDimmed,
				sizeable,
				{	/* array: 4 elements */
					/* [1] */
					0,
					/* [2] */
					0,
					/* [3] */
					0,
					/* [4] */
					0
				},
				128,
				dontPreferOutline,
				h,
				0,
				0,
				0
			},
			NoSubviews
		},
		/* [5] */
		ViewSignatureAndClassname {
			'ssbr',
			101,
			"",
			'vCLR',
			enabled,
			noIdle,
			{	/* array BehaviorArray: 0 elements */
			},
			MAThreeOh,
			{	/* array: 2 elements */
				/* [1] */
				-1,
				/* [2] */
				415
			},
			{	/* array: 2 elements */
				/* [1] */
				247,
				/* [2] */
				16
			},
			sizeVariable,
			sizeVariable,
			shown,
			doesntWantToBeTarget,
			handlesCursor,
			letsSubViewsHandleCursor,
			noCursorID,
			handlesHelp,
			letsSubViewsHandleHelp,
			noHelpID,
			1,
			NoDrawingEnvironment {

			},
			NoAdorners {

			},
			emptyUserArea,
			ScrollerScrollBar {
				mVScrollBarHit,
				notHilited,
				notDimmed,
				sizeable,
				{	/* array: 4 elements */
					/* [1] */
					0,
					/* [2] */
					0,
					/* [3] */
					0,
					/* [4] */
					0
				},
				128,
				dontPreferOutline,
				v,
				0,
				0,
				0
			},
			NoSubviews
		}
	}
};

resource 'View' (1002, "kDefaultViewID", purgeable) {
	MAThreeOh,
	{	/* array ViewArray: 1 elements */
		/* [1] */
		ViewSignatureAndClassname {
			'dflt',
			62,
			"",
			'DFLT',
			enabled,
			noIdle,
			{	/* array BehaviorArray: 0 elements */
			},
			MAThreeOh,
			{	/* array: 2 elements */
				/* [1] */
				0,
				/* [2] */
				0
			},
			{	/* array: 2 elements */
				/* [1] */
				134,
				/* [2] */
				489
			},
			sizeVariable,
			sizeVariable,
			shown,
			doesntWantToBeTarget,
			handlesCursor,
			letsSubViewsHandleCursor,
			noCursorID,
			handlesHelp,
			letsSubViewsHandleHelp,
			noHelpID,
			1,
			NoDrawingEnvironment {

			},
			NoAdorners {

			},
			emptyUserArea,
			View {

			},
			NoSubviews
		}
	}
};

