/*
	File:		App.cp

	Contains:	Boilerplate application-specific code.
				
	Written by: Dave Falkenburg

	Copyright:	 1993-94 by Dave Falkenburg, all rights reserved.

	Change History (most recent first):
	 
 */

#include <Windows.h>
#include <Dialogs.h>
#include <Menus.h>
#include <Desk.h>
#include <Errors.h>
#include <Resources.h>
#include <StandardFile.h>
#include <Devices.h>		//	was <Desk.h>

#include "App.h"
#include "FuturesDemo.h"
#include "AppLib.h"
#include "Window.h"
#include "StandardMenus.h"
#include "SplashWindow.h"

#include "ToolWindow.h"
#include "DocWindow.h"
#include "PreferencesDialogWindow.h"
#include "MailableDocWindow.h"

#include "Preferences.h"

AppPreferences	gPreferences;

//	Function Prototypes:

void	AboutBox(void);
void	OpenExistingDocument(void);


OSErr
SetupApplication(void)
	{	
	InsertMenu(GetMenu(mDebug),0);				//	Add Debug Menu

	if (gHasAOCE)
		EnableItem(GetMHandle(mDebug),1);

	TToolWindow	* someTools = new TToolWindow(1025);

	gPreferences.fMailPreferences.fCreateMailerForNewDocuments = true;

	InitCursor();
	InitFuturesDemo();
	return (noErr);
	}

void
TearDownApplication(void)
	{
		CleanupFuturesDemo();
	}
	
void
HandleMenu(TWindow * topWindowObj, long menuCode)
	{
	short	menu = (short) (menuCode >> 16);
	short	item = (short) (menuCode & 0xffff);
	Str255	deskAccName;
	
	switch (menu)
		{
		case	mApple:
			switch (item)
				{
				case	iAbout:
					AboutBox();
					break;
					
				default:
					GetItem(GetMHandle(mApple),item,deskAccName);
					(void) OpenDeskAcc(deskAccName);
					break;
				}
			break;
			
		case	mFile:
			switch (item)
				{
				case	iNew:
					OpenNewDocument();
					break;
				
				case	iOpen:
					OpenExistingDocument();
					break;
				
				case	iClose:
					HandleClose(FrontNonFloatingWindow());
					break;
					
				case	iPreferences:
					TPreferencesDialogWindow * prefsDialog = new TPreferencesDialogWindow;
					break;

				case	iQuit:
					gDone = true;
					break;
					
				default:
					break;
				}
			break;
		
		case	mEdit:
			switch (item)
				{
				case	iShowOrHideClipboard:
					break;
					
				default:
					if ((!SystemEdit(item-1)) && (topWindowObj != nil))
						topWindowObj->DoEditMenu(item);
					break;
				}
		
		case	mDebug:
			switch(item)
				{
				case	iNewMailableWindow:
					TMailableDocWindow *aWackyThing = new TMailableDocWindow;
					break;
				case	iPing:
					SendSimpleAEvt(kSillyEventClass, kPing1Event);
					break;
				case	iPing2:
					SendSimpleAEvt(kSillyEventClass, kPing2Event);
					break;
				default:
					break;
				}
			break;
			
		default:
			break;
		}
		
	HiliteMenu(0);
	}


void
AboutBox(void)
	{
	Handle			versionHandle;
	StringPtr		nullStr = (StringPtr) "\p";
	StringPtr		shortVersionString = nullStr;
	short			itemHit;
	
	versionHandle = GetResource('vers',1);
	if (versionHandle)
		shortVersionString = (StringPtr) ((char *) *versionHandle + 6);
	ParamText(shortVersionString,nullStr,nullStr,nullStr);
	ReleaseResource(versionHandle);

#ifndef	powerc
	itemHit = StandardAlert(kAboutBoxFor68K);
#else
	itemHit = StandardAlert(kAboutBoxForPowerPC);
#endif

	if (itemHit == iCreditsButton)
		StandardAlert(kCreditsBox);
	}


void
OpenExistingDocument(void)
	{
	StandardFileReply	reply;
	SFTypeList			ourTypes;
	
	Point	where = { -1, -1 };
	
	HiliteWindowsForModalDialog(false);
	CustomGetFile((FileFilterYDUPP) nil, -1, ourTypes, &reply, 0, where,
				  (DlgHookYDUPP) nil,StandardDialogFilterYD, nil,nil,nil);
	HiliteWindowsForModalDialog(true);
	}


void
ConvertClipboard(void)
	{
	}


OSErr
OpenNewDocument(void)
	{
	TDocWindow	*aNewWindow = new TDocWindow();
	
	if (aNewWindow)
		return noErr;
	else
		return memFullErr;
	}


OSErr
OpenDocument(LetterDescriptor * /* theDocument */, void * /*unused*/)
	{
	return OpenNewDocument();	//	cheat for now
	}


OSErr
PrintDocument(LetterDescriptor * /* theDocument */, void * /*unused*/)
	{
	return noErr;
	}


Boolean
QuitApplication(void)
	{
	return true;
	}
