/*
	File:		DocWindow.h

	Contains:	A simple document window
				
	Written by: Dave Falkenburg
	
	Copyright:	 1993-94 by Dave Falkenburg, all rights reserved.

	Change History (most recent first):
	 
 */

#ifndef		_DOCWINDOW_
#define		_DOCWINDOW_

#ifndef		_WINDOW_
#include	"Window.h"
#endif

#ifndef		__THREADS__
#include	<Threads.h>
#endif

class	TDocWindow	:	public TWindow
	{
public:
							TDocWindow();
	virtual 				~TDocWindow();

	virtual WindowPtr		MakeNewWindow(WindowPtr behindWindow);

	virtual	void			AdjustCursor(EventRecord * anEvent);

	virtual void			Activate(Boolean activating);
	virtual void			Draw(void);
	virtual void			Click(EventRecord * anEvent);

	virtual void			AdjustForNewWindowSize(Rect * oldRect,Rect * newRect);

	virtual	Boolean			Close(void);
	
	virtual	OSErr			DragEnterWindow(DragReference theDrag);
	virtual	OSErr			DragInWindow(DragReference theDrag);
	virtual	OSErr			DragLeaveWindow(DragReference theDrag);
	virtual	OSErr			HandleDrop(DragReference theDrag);

protected:
	static	unsigned long	fgUntitledTagCount;
	ThreadID				fSpinnerThreadID;
	short					fCurrentSpinningArrowIconID;

public:
	virtual void			SpinHeaderArrows();
	};

#endif
