/*
	File:		MailableWindow.h

	Contains:	An abstract class for AOCE-mailable windows
				
	Written by: Dave Falkenburg
	
	Copyright:	 1993-94 by Dave Falkenburg, all rights reserved.

	Change History (most recent first):
	 
		 <2>	 8/26/94	DRF		Added AdjustPerfectWindowSizeForMailer.
 */

#ifndef	_MAILABLEWINDOW_
#define	_MAILABLEWINDOW_

#include "Window.h"


#define	kCanContract			true
#define	kInitiallyExpanded		true
#define	kDefaultAuthIdentity	((AuthIdentity) 0)


class	TMailableWindow : public TWindow
	{
public:
						TMailableWindow();
	virtual				~TMailableWindow();

	//	Overriden methods of TWindow
	
	virtual	Boolean		EventFilter(EventRecord * theEvent);
	virtual void		CreateWindow(WindowType typeOfWindowToCreate = kNormalWindow);
	virtual	void		Draw(void);
	virtual void		AdjustForNewWindowSize(Rect * oldRect,Rect * newRect);
	virtual	Boolean		Close(void);

	//	AOCE-specific methods
	
	virtual OSErr		AttachMailerToWindow(Boolean createExpanded);
	virtual OSErr		RemoveMailerFromWindow(void);

	virtual void		ExpandOrContractMailer(Boolean doExpand);
	
	virtual void		AdjustPerfectWindowSizeForMailer(Rect * perfectSize);

	virtual void		AdjustForNewContentRect(Rect * prevContentRect,Rect * newContentRect);
	virtual void		DrawContents(void);
	
protected:
	Boolean				fMailerIsAttached;
	Boolean				fMailerIsExpanded;

	Rect				fContentRect;

	//	AOCE-related data structures in here
	};

pascal	WindowPtr	FrontWindowProcForAOCE(long /* unusedParam */);


#endif