#pragma once

/*=======================================================================*/
/* This file contains a set of utilities for manipulating pascal strings */
/*=======================================================================*/

#include <BDC.h>		// for number to string & vv conversion

#ifdef __cplusplus
extern "C" {
#endif

	StringPtr	String2String (StringPtr InString);
	/* return a copy of the passed string */

	void	CopyString (Str255 String1, Str255 String2);
	/* copy the entire contents of String1 into String2 */

	void PStrCpy (StringPtr Source, StringPtr Dest, short numToCopy);
	/* Given two pascal strings, this routine replaces the contents of */
	/* the second string with numToCopy characters of the first string */

	short PStrLen (StringPtr TheString);
	/* return the length of the string; 0 if TheString is NULL */
	
	Boolean PStringCmp (StringPtr String1, StringPtr String2);
	/* return TRUE if String1 is identical to String2 */

	short PStrCmp (StringPtr String1, StringPtr String2);
	/* if String1 is > String2, return 1; if String1 is equal to String2, return 0; */
	/* if String1 is < String2, return -1 */

	StringPtr PStrCat (short maxLen, Str255 Dest, short numArgs,...);
	/* concatenate a variable number of StringPtr's and store the result in */
	/* Dest; Dest will receive no more than maxLen characters, no matter how many */
	/* StringPtr's are passed in */

#ifdef __cplusplus
}
#endif