/********************************************************* DEFINITION
	DATE:	9/17/93
	AUTHOR: Eric R. Ros
	
	CLASS:  CPPConfirmTask
	
	SUPERCLASS: CPPPeriodicTask
	
		This class lets you asynchronously confirm the address of
		a node on the network
	
********************************************************************/

#pragma once

#include <CPPPeriodicTask.h>
#include <Appletalk.h>

class CPPPTaskManager;
class CPPNodeInfo;

class CPPConfirmTask : public CPPPeriodicTask {

public:
	CPPNodeInfo		*NodeToConfirm;
	
					CPPConfirmTask (CPPTaskManager *TaskManager,
									long minPeriod = 120,
							  	  	Boolean deleteWhenDone = TRUE);
					~CPPConfirmTask (void);

	virtual	char *ClassName (void);
	
	virtual	void	DoPeriodicAction (void);
	virtual void	DoCompletedAction (void);
	
	Boolean			NodeExists (Boolean *isDone);
	
	void			StartNodeConfirm (CPPNodeInfo *TheNode,
									  CompletionProc DoProc);
		
private:
	MPPParamBlock	 	*confirmRec;
	AddrBlock			*confirmAddr;
	NamesTableEntry		*NTE;
	Boolean				foundIt;
	
	void				SetupConfirmCall (CPPNodeInfo *TheNode);
};
