/********************************************************* DEFINITION
	DATE:	9/17/93
	AUTHOR: Eric R. Ros
	
	CLASS:  CPPMaBell
	
	SUPERCLASS: CPPObject
	
		This C++ class handles general AppleTalk maintenance.
	
********************************************************************/

#pragma once

#include <CPPObject.h>
#include <PPCToolBox.h>

#define		kSelectMPP	1
#define		kSelectADSP	2
#define		kSelectXPP	4
#define		kAll		7

#define		kDriverNotOpen	99

class CPPMaBell : public CPPObject {

public:
			CPPMaBell (Boolean AllowSelfSend = TRUE);
			~CPPMaBell (void);
	
	virtual	char 	*ClassName (void);

	OSErr	OpenATalkDriver (short whichDrivers);
	short	GetDriverNumber(short whichDriver);
	short	GetAtalkVersion (void);

	OSErr	OpenCommunicationPort (StringPtr OurName,
								   StringPtr PortType,
								   PPCPortRefNum *newRefNum);
	OSErr	CloseCommunicationPort (PPCPortRefNum portRefNum);
	
	OSErr	EndSession (PPCSessRefNum	sessionID);
	
	Boolean	EnableSelfSend (void);
	Boolean DisableSelfSend (void);
	Boolean	SelfSendEnabled (void);
	OSErr	InitPPCToolbox (void);
	
	Boolean	HasPhase2ATalk (void);
		
private:
	short	XPPRefNum,
			MPPRefNum,
			ADSPRefNum;
	short	AtalkVersionNumber;
	Boolean	SelfSendState;
	
};
