/********************************************************* DEFINITION
	DATE:	9/17/93
	AUTHOR: Eric R. Ros
	
	CLASS:  CPPNode411
	
	SUPERCLASS: CPPPeriodicTask
	
		This C++ class lets you look up nodes on the network.
	
********************************************************************/

#pragma once

#include  <CPPPeriodicTask.h>
#include  <AppleTalk.h>

typedef	NamesTableEntry	*NTEPtr;

class CPPTaskManager;
class CPPNodeInfo;
class CPPObjectList;

class CPPNode411 : public CPPPeriodicTask {

public:
					CPPNode411 (CPPTaskManager *TaskManager, 
								long minPeriod = 120, 
								Boolean deleteWhenDone = TRUE);
					~CPPNode411 (void);
	
	virtual	char *ClassName (void);

	virtual	void	DoPeriodicAction (void);
	virtual void	DoCompletedAction (void);
	
	CPPNodeInfo 	*NthNode (long whichItem, Boolean getCopy);
	long			NumNodesFound (Boolean *isDone);
	
	void			StartNodeLookup (StringPtr ObjectName,
									 StringPtr TypeName, 
									 StringPtr ZoneName,
									 short maxNumResponses,
									 CompletionProc DoProc);

	CPPObjectList	*GetFoundList (void);

protected:
	CPPObjectList	*FoundList;
	
private:
	MPPPBPtr		lookupRec;
	Ptr				returnBuffer;
	NTEPtr			NTE;
	
	void			SetupNBPCall (StringPtr ObjectName, StringPtr TypeName, 
								  StringPtr ZoneName, short maxNumBack);
	void			ProcessNodes (short NumGotten);
};
