/********************************************************* DEFINITION
	DATE:	9/17/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPNodeInfo
	
	SUPERCLASS: CPPObject
	
		This class stores a network name and address and allows
		lookups, confirms, etc. on that address.
	
********************************************************************/

#pragma once

#include <CPPObject.h>
#include <Appletalk.h>

class CPPNodeInfo : CPPObject {

public:
				CPPNodeInfo (void);
				~CPPNodeInfo (void);
	
	virtual		char	*ClassName (void);

	void		SetNodeName (StringPtr ObjectStr, StringPtr TypeStr, 
							 StringPtr ZoneStr);
	void		SetNodeAddress (short SocketNum, short NodeNum, 
								short ZoneNum);
	
	void		GetNodeName	(StringPtr *ObjectStr, StringPtr *TypeStr, 
							 StringPtr *ZoneStr);
	void		GetNodeAddress (short *SocketNum, short *NodeNum, 
								short *ZoneNum);
	
	StringPtr	ReturnNameString (void);
	StringPtr 	ReturnShortNameString (void);
	
	Boolean		ConfirmNodeAddress (OSErr *ErrCode);
	
	Boolean		RegisterNodeAddress (OSErr *ErrCode);

	Boolean		DeregisterNodeAddress (OSErr *ErrCode);
	
	Boolean		Equals (CPPNodeInfo *TestNA);
	
	CPPObject	*Clone (void);
		
	Ptr			InfoToStream (void);
	
private:
	NamesTableEntry	*NTE;	// only defined if registration succeeds
	StringPtr		objectString,
					typeString,
					zoneString;
	unsigned char	socketNumber,
					nodeNumber;
	short			zoneNumber;
	Boolean			isRegistered;
};

CPPNodeInfo *StreamToInfo (Ptr Buffer, Ptr *BufferEnd);
