/***************************************************** IMPLEMENTATION
	DATE:	9/15/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPList
	
	SUPERCLASS: CPPDArray
	
		This C++ class manages a list of pointers
	
********************************************************************/

#pragma once

#include <CPPDArray.h>

class CPPList : public CPPDArray{
public:
			CPPList (void);
			~CPPList (void);
			
	virtual	char *ClassName (void);
		
	virtual	void	InsertItem (Ptr NewItem, long insertAt);
	virtual	void	AppendItem (Ptr NewItem);
	
	virtual	void	DeleteItem (long deleteWhich, Boolean doDispose);
	void	DeleteItems (Boolean doDispose);

			Ptr		operator[](long getWhich);
	virtual	void	SetItem (Ptr NewItem, long setWhich, Boolean deleteOld);
	
	virtual void	Swap (long Index1, long Index2);
	
	long	GetNumItems (void);
	long	FindIndex	(Ptr ItemToFind);
				
protected:
	virtual	void	ClearItem (long clearWhich);
	virtual	void	ClearItems (void);
	
};
