/********************************************************* DEFINITION
	DATE:	9/27/93
	AUTHOR: Eric R. Ros
	
	CLASS:  CPPRadioCluster
	
	SUPERCLASS: CPPObjectList
	
		This C++ class manages a group of radio buttons
	
********************************************************************/

#include <CPPRadioCluster.h>
#include <CPPRadioButton.h>

/*-----------------------------------------------------------------*/
/*------------------------ PUBLIC METHODS -------------------------*/
/*-----------------------------------------------------------------*/

	CPPRadioCluster::CPPRadioCluster (void)
	{
		this->currentButton = 0;
	}
	
/*-----------------------------------------------------------------*/

	CPPRadioCluster::~CPPRadioCluster (void)
	{
		// remove all of the radio buttons we manage from our
		// list; do not dispose of them - that's the window's job
		DeleteItems (FALSE);
	}

/*-----------------------------------------------------------------*/

	char	*CPPRadioCluster::ClassName (void)
	{
		return "CPPRadioCluster";
	}

/*-----------------------------------------------------------------*/

	void	CPPRadioCluster::TurnOn (CPPRadioButton *whichButton)
	/* turn off the currently selected radio button, and turn on */
	/* the one which was passed in */
	{
		long	buttonIndex = FindIndex((CPPObject *)whichButton);
		CPPRadioButton	*rTemp = NULL;
		
		if (buttonIndex)
		  {
		  	if (currentButton)
		  	  ((CPPRadioButton *)((*this)[currentButton]))->SetValue (0);
		  	this->currentButton = buttonIndex;
		  	whichButton->SetValue(1);
		  }
	}

/*-----------------------------------------------------------------*/
