/********************************************************* DEFINITION
	DATE:	9/2/93
	AUTHOR: Eric R. Ros
	
	CLASS:  CPPSound
	
	SUPERCLASS: CPPObject
	
		This C++ class manages the loading, playing, and disposing 
		of snd resources
	
********************************************************************/

#include <CPPSound.h>
#include <ToolboxTools.h>

/*-----------------------------------------------------------------*/
/*------------------------ PUBLIC METHODS -------------------------*/
/*-----------------------------------------------------------------*/

	CPPSound::CPPSound (short ResID)
	{
		OSErr	ErrCode;
		
		this->theSoundChannel = NULL;
		
		this->theSoundID = ResID;
		this->theSound = Get1Resource ('snd ', ResID);
		ErrCode = SndNewChannel (&this->theSoundChannel, 5, 32, NULL);
	}

/*-----------------------------------------------------------------*/

	CPPSound::~CPPSound (void)
	{
		// close the sound channel
		if (this->theSoundChannel)
		  SndDisposeChannel(this->theSoundChannel, 1);
		
		// dispose of the sound resource
		ReleaseResource(this->theSound);
	}

/*-----------------------------------------------------------------*/

	char	*CPPSound::ClassName (void)
	{
		return "CPPSound";
	}

/*-----------------------------------------------------------------*/

	void	CPPSound::PlaySound (Boolean PlayAsync)
	{
		OSErr	ErrCode;
		
		// make sure the sound is loaded
		if (!this->theSound)
		  {
		  	this->theSound = Get1Resource ('snd ', this->theSoundID);
		  	if (!this->theSound)
		  	  {
		  	  	ErrorAlert (ResError(), "\pCould not load a sound resource");
		  	  	return;
		  	  }
		  }
		
		// make sure the channel exists, so we can play the sound
		if (!this->theSoundChannel)
		  {
			ErrCode = SndNewChannel (&this->theSoundChannel, 5, 32, NULL);
			if (ErrCode != noErr)
			  {
		  	  	ErrorAlert (ErrCode, "\pCould not load allocate a sound channel");
			  	return;
			  }
		  }
		
		// go ahead and play it!
		ErrCode = SndPlay (this->theSoundChannel, theSound, PlayAsync);
		if (ErrCode != noErr)
		  ErrorAlert (ErrCode, "\pCould not play the sound");
	}
	
/*-----------------------------------------------------------------*/
