/***************************************************** IMPLEMENTATION
	DATE:	9/21/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPTextWindow
	
	SUPERCLASS: CPPWindow, CPPText
	
		This C++ class manages a text editing window
	
********************************************************************/

#pragma once

#include <CPPWindow.h>
#include <CPPFilterText.h>

class CPPTEWindow : public CPPWindow, public CPPFilterText {
public:
			CPPTEWindow (CPPWindowManager *theManager, int ResID, 
						 Boolean HScroll = TRUE, Boolean VScroll = TRUE,
						 int Font = geneva, int FSize = 9);
			CPPTEWindow (CPPWindowManager *theManager,
					     Rect *bounds, StringPtr title, Boolean isVisible,
					     int windowKind, Boolean hasGoAway, int RefCon,
					     Boolean HScroll = TRUE, Boolean VScroll = TRUE,
						 int Font = geneva, int FSize = 9);
			~CPPTEWindow (void);
			
	virtual	char	*ClassName (void);

	virtual	Boolean	DoCommand (short commandID);

protected:
	virtual	void	Activate (void);
	virtual	void	Deactivate (void);
	virtual void	DoUserClick (EventRecord *theEvent);
	virtual void	DoUserUpdate (void);
	virtual void	DoUserIdle (void);
	virtual Boolean	DoUserKey (EventRecord *theEvent);
	virtual	void	DoUserChangeSize (short newWidth, short newHeight);

};