/********************************************************* DEFINITION
	DATE:	9/22/93
	AUTHOR: Eric R. Ros
	
	CLASS:  CPPVisualList
	
	SUPERCLASS: CPPVisualObject 
	
		This C++ class lets you manage a scrolling list of data
	
********************************************************************/

#pragma once

#include <CPPVisualObject.h>

class CPPDArray;

class CPPVisualList : public CPPVisualObject {
public:
					CPPVisualList (CPPWindow *theWindow, Rect *boundsRect,
									CPPDArray *coreData, Boolean ownsCoreData,
									Boolean canBeTarget = TRUE,
									short selectionFlags = lOnlyOne + lNoNilHilite,
									short cellHeight = 20);
					~CPPVisualList (void);
			
	virtual	char	*ClassName (void);

			void	AttachList (CPPDArray *coreData, Boolean ownsCoreData);
		CPPDArray	*GetItsData (void);
		
	// methods for managing the visual list
	virtual	Boolean	DoClick (EventRecord *TheEvent);
	virtual	Boolean	DoKey (char theKey, short modifiers, short what);
	virtual void	Draw (void);
	
	virtual	Rect	*GetBounds (void);

	virtual	void	MakeVisible (Boolean nowVisible);
	virtual	void	Activate (Boolean nowActive);
	virtual	void	TargetHilite (Boolean makeTarget);
				
			void	SetSelect (long whichCell, Boolean isSelected,
									 Boolean doUpdate);
			Boolean	FirstSelectedCell (long *whichCell);
			Boolean	NextSelectedCell (long *whichCell);
			Boolean	PrevSelectedCell (long *whichCell);
			long	NumSelectedCells (void);
			Boolean	CellSelected (long whichCell);
			void	GetCellRect (long whichCell, Rect *cRect);
			long	BottomCell (void);
			long	TopCell (void);

			long	GetNumItems (void);

			void	SelectAll (Boolean doSelect);

	virtual	void ReceiveMessage(CPPGossipMonger *toldBy, 
								short reason, void* info);
			
			void 	DoLDEF (short message, Boolean isSelect, 
							Rect *cRect, Cell theCell, short lDataOffset, 
							short lDataLen, ListHandle aList);
	
protected:
	CPPDArray		*coreData;
	Boolean			ownsData;
	ListHandle		vList;
	Rect			listRect, saveListRect;
	
	virtual	void	MoveContent (short newH, short newV);
	virtual	void	ResizeContent (short newWidth, short newHeight);

	virtual	void	DoSingleClick (long hitCell);
	virtual	void	DoDoubleClick (long hitCell);

			void	AdjustList (long theCell);
			void	MoveUp1 (void);
			void	MoveDown1 (void);
			void	DrawCell (long whichCell, Rect *itsFrame, Boolean selected);
	virtual	void	DrawCellContents (long whichCell, Rect *itsFrame, Boolean selected);
	virtual	void	EraseHilite (void);
	virtual	void	DrawHilite (void);
			long	Point2Cell (Point thePoint);
			long	LinesInList (void);
	
private:
	short			resID;
	Handle			LDEFStub;

	static pascal void CallLDEF (short message, Boolean isSelect, 
							     Rect *cRect, Cell theCell, short lDataOffset, 
							     short lDataLen, ListHandle aList);

};