/********************************************************* DEFINITION
	DATE:	10/4/93
	AUTHOR: Eric R. Ros
	
	CLASS:  CPPVisualObjectList
	
	SUPERCLASS: CPPVisualList
	
		This C++ class lets you manage a scrolling list of strings
	
********************************************************************/

#include <CPPVisualObjectList.h>
#include <CPPObjectList.h>
#include <CPPDArray.h>
#include <string.h>

/*-----------------------------------------------------------------*/
/*--------------------------- GLOBALS -----------------------------*/
/*-----------------------------------------------------------------*/

	extern	RGBColor	RGBWhite;
	
/*-----------------------------------------------------------------*/
/*------------------------ PUBLIC METHODS -------------------------*/
/*-----------------------------------------------------------------*/

	CPPVisualObjectList::CPPVisualObjectList (CPPWindow *theWindow, 
										Rect *boundsRect,
										CPPDArray *coreData, 
										Boolean ownsCoreData,
										Boolean canBeTarget,
										short selectionFlags,
										short cellHeight) :
						CPPVisualList (theWindow, boundsRect,
									   coreData, ownsCoreData,
									   canBeTarget, selectionFlags,
									   cellHeight)
	{
	
	}
	
/*-----------------------------------------------------------------*/
	
	CPPVisualObjectList::~CPPVisualObjectList (void)
	{
	
	}
	
/*-----------------------------------------------------------------*/
			
	char	*CPPVisualObjectList::ClassName (void)
	{
		return "CPPVisualObjectList";
	}

/*-----------------------------------------------------------------*/

	void	CPPVisualObjectList::DrawCellContents (long whichCell, 
												   Rect *itsFrame, 
												   Boolean selected)
	{
		CPPObject	*TempObject = NULL;
		short		mode = notPatOr;
		GVarHandle	CG = (GVarHandle)((CWindowPeek)
						  (this->owningWindow))->port.grafVars;
		CPPObjectList	*theList = (CPPObjectList *)this->coreData;
			
		if (theList)
		  TempObject = (*theList)[whichCell];
		
		if (this->InColorWindow() && selected)
		  RGBBackColor ((&(**CG).rgbHiliteColor));
		
		if (TempObject)
		  TextBox (TempObject->ClassName(), strlen(TempObject->ClassName()), 
		  		   itsFrame, teJustLeft);
		else
		  EraseRect (itsFrame);
		
		if (selected)
		  if (InColorWindow())
		    RGBBackColor (&RGBWhite);
		  else
		    InvertRect (itsFrame);
	}


