/********************************************************* DEFINITION
	DATE:	10/4/93
	AUTHOR: Eric R. Ros
	
	CLASS:  CPPVisualStringList
	
	SUPERCLASS: CPPVisualList
	
		This C++ class lets you manage a scrolling list of strings
	
********************************************************************/

#include <CPPVisualStringList.h>
#include <CPPStringList.h>
#include <CPPDArray.h>

/*-----------------------------------------------------------------*/
/*----------------------- GLOBAL VARIABLES ------------------------*/
/*-----------------------------------------------------------------*/

	extern	RGBColor	RGBWhite;

/*-----------------------------------------------------------------*/
/*------------------------ PUBLIC METHODS -------------------------*/
/*-----------------------------------------------------------------*/

	CPPVisualStringList::CPPVisualStringList (CPPWindow *theWindow, 
										Rect *boundsRect,
										CPPDArray *coreData, 
										Boolean ownsCoreData,
										Boolean canBeTarget,
										short selectionFlags,
										short cellHeight) :
						CPPVisualList (theWindow, boundsRect,
									   coreData, ownsCoreData,
									   canBeTarget, selectionFlags,
									   cellHeight)
	{
	
	}
	
/*-----------------------------------------------------------------*/
	
	CPPVisualStringList::~CPPVisualStringList (void)
	{
	
	}
	
/*-----------------------------------------------------------------*/
			
	char	*CPPVisualStringList::ClassName (void)
	{
		return "CPPVisualStringList";
	}

/*-----------------------------------------------------------------*/

	void	CPPVisualStringList::DrawCellContents (long whichCell, Rect *itsFrame, 
												   Boolean selected)
	/* Draw the actual contents of the specified cell in the */
	/* specified frame */
	/* SUBCLASS MUST OVERRIDE */
	{
		StringPtr	STemp;
		short		mode = notPatOr;
		GVarHandle	CG = (GVarHandle)((CWindowPeek)
						  (this->owningWindow))->port.grafVars;
		CPPStringList	*theList = (CPPStringList *)this->coreData;
			
		if (theList)
		  STemp = (*theList)[whichCell];
		
		if (this->InColorWindow() && selected)
		  RGBBackColor ((&(**CG).rgbHiliteColor));
		
		if (STemp)
		  TextBox (STemp+1, *STemp, itsFrame, teJustLeft);
		else
		  EraseRect (itsFrame);
		
		if (selected)
		  if (InColorWindow())
		    RGBBackColor (&RGBWhite);
		  else
		    InvertRect (itsFrame);
	}
