/********************************************************* DEFINITION
	DATE:	9/21/93
	AUTHOR: Eric R. Ros
	
	CLASS:  CPPWindowManager
	
	SUPERCLASS: CPPObject
	
		This C++ class keeps track of the windows our application uses
	
********************************************************************/

#pragma once

#include <CPPObjectList.h>
#include <CPPWindow.h>

class CPPWindowManager : public CPPObjectList {
public:
			CPPWindowManager(void);
			~CPPWindowManager(void);
					
	virtual	char 	*ClassName (void);
	
	CPPWindow	*FrontWindowObject (void);
	CPPWindow	*FindWindowObject (WindowPtr theWindow);
	
	void		ActivateWindowObject (CPPWindow *theWindow);
	void		DeactivateWindowObject (CPPWindow *theWindow);
	
	void		StartManagingWindow (CPPWindow *theWindow);
	void		StopManagingWindow (CPPWindow *theWindow);

private:
	CPPWindow	*frontWindowObject;
};