/********************************************************* DEFINITION
	DATE:	10/20/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPConnectTask
	
	SUPERCLASS: CPPPeriodicTask
	
		This C++ class lets you open a connection with another 
		network entity
	
********************************************************************/

#pragma once

#include <PPCToolBox.h>
#include <CPPPeriodicTask.h>

class CPPNodeInfo;
class CPPTaskManager;

class CPPConnectTask : CPPPeriodicTask {

public:
					CPPConnectTask (CPPTaskManager *TaskManager, 
								    long minPeriod = 120, 
								    Boolean deleteWhenDone = TRUE);
					~CPPConnectTask (void);
	
	virtual	char 	*ClassName (void);

	virtual	void	DoPeriodicAction (void);
	virtual void	DoCompletedAction (void);
	
	PPCSessRefNum			GetSessionID (Boolean *isDone);
	
	void 			StartConnectTask (PPCPortRefNum SourcePortRefNum,
									  CPPNodeInfo *ConnectTo,
									  CompletionProc DoProc);
protected:
	PPCSessRefNum	sessionID;						   
private:
	CPPNodeInfo		*connectTo;
	PPCStartPBPtr	startRec;
	PortInfoRec		*portRec;
	LocationNamePtr	location;
};
