/********************************************************* DEFINITION
	DATE:	9/17/93
	AUTHOR: Eric R. Ros
	
	CLASS:  CPPListenTask
	
	SUPERCLASS: CPPPeriodicTask
	
		This C++ class lets you accept connection requests received
		on a particular PPC Port
	
********************************************************************/

#pragma once

#include <PPCToolBox.h>
#include <CPPPeriodicTask.h>

class CPPTaskManager;

class CPPListenTask : public CPPPeriodicTask {

public:
					CPPListenTask (CPPTaskManager *TaskManager,
									long minPeriod = 120,
									Boolean deleteWhenDone = TRUE);
					~CPPListenTask (void);
	virtual	char *ClassName (void);
	
	PPCSessRefNum	GetNewSessionID (void);
	void			GetConnectedToInfo (Boolean *hasConnected,
										LocationNamePtr *Location,
										PPCPortPtr *PortRec);
	
	virtual	void	DoPeriodicAction (void);
	virtual void	DoCompletedAction (void);
	
	void			StartListenTask (PPCPortRefNum PortID, CompletionProc DoProc);
	
protected:
	PPCSessRefNum		sessionID;

private:
	Str32				userName;
	LocationNamePtr		locationRecPtr;
	PPCPortPtr			portRecPtr;
	PPCParamBlockPtr	listenRecPtr;
};
