/********************************************************* DEFINITION
	DATE:	9/17/93
	AUTHOR: Eric R. Ros

	CLASS:  CReadTask
	
	SUPERCLASS: CPeriodicTask
	
		This C++ class lets you read data asynchronously through a 
		PPC connection.
	
********************************************************************/

#pragma once

#include <PPCToolBox.h>
#include <CPPPeriodicTask.h>

class CPPTaskManager;

class CPPReadTask : public CPPPeriodicTask {

public:
					CPPReadTask (CPPTaskManager *TaskManager,
								 long minPeriod = 120,
								 Boolean deleteWhenDone = TRUE);
					~CPPReadTask (void);
	virtual	char *ClassName (void);
	
	void			GetDataInfo (long *dataLen, OSType *type, OSType *creator);
	Handle			GetData (Boolean BecomeOwner, Boolean *AmITheOwner);
	
	virtual	void	DoPeriodicAction (void);
	virtual	void	DoCompletedAction (void);
		
	void			StartReadTask (PPCSessRefNum ConnectionID, short blockSize,
								   CompletionProc DoProc);
protected:
	PPCSessRefNum	sessionID;
	
private:
	short			blockSize;
	Ptr				readBuffer;
	Handle			returnData;
	short			totalSize;
	Boolean			ownsData;
	PPCReadPBPtr	readPBPtr;
	OSType			blockCreator,
					blockType;
};
