/********************************************************* DEFINITION
	DATE:	9/17/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPWriteTask
	
	SUPERCLASS: CPPPeriodicTask
	
		This C++ class lets you write data asynchronously through a  
		PPC connection.
	
********************************************************************/

#pragma once

#include <PPCToolBox.h>
#include <CPPPeriodicTask.h>

class CPPTaskManager;
class CPPNodeInfo;

class CPPWriteTask : CPPPeriodicTask {

public:
					CPPWriteTask (CPPTaskManager *TaskManager, 
								  long minPeriod = 120, 
								  Boolean deleteWhenDone = TRUE);
					~CPPWriteTask (void);
	
	virtual	char 	*ClassName (void);

	virtual	void	DoPeriodicAction (void);
	virtual void	DoCompletedAction (void);
	
	void 			StartWriteTask (PPCPortRefNum SourcePortRefNum,
									CPPNodeInfo *SendTo,
									Ptr DataToWrite, 
									Boolean OwnsData,
									CompletionProc DoProc,
									OSType DataType = "????",
									OSType DataCreator = "????");
									   
	void			StartWriteTask (Ptr DataToWrite, Boolean OwnsData,
									PPCSessRefNum ConnectionID,
									CompletionProc DoProc,
									OSType DataType = "????",
									OSType DataCreator = "????");
		
private:
	Ptr				data;
	short			dataLen;
	Boolean			ownsData;
	PPCSessRefNum	sessionID;
	PPCWritePBPtr	writePBPtr;
};
