/********************************************************* DEFINITION
	DATE:	9/16/93
	AUTHOR: Eric R. Ros
	
	CLASS:  CPPTaskManager
	
	SUPERCLASS: CPPObjectList
	
		This C++ class is an abstract class for keeping track of 
		periodic tasks.
	
********************************************************************/

#pragma once

#include <CPPObjectList.h>

enum {
	kTaskActivated	=	5,
	kTaskDeactivated=	6
};


class CPPPeriodicTask;

class CPPTaskManager : public CPPObjectList {

public:
			CPPTaskManager (void);
			~CPPTaskManager (void);
	
	virtual	char 	*ClassName (void);

	Boolean AddPeriodicTask (CPPPeriodicTask *TheTask);
	Boolean RemovePeriodicTask (CPPPeriodicTask *TheTask,
								Boolean disposeOfTask);
	
	long	HowManyTasksOfType (char *ClassName);
	
	void 	RunPeriodicTasks (void);
	
	short	HowManyPeriodicTasks (void);
};
