/***************************************************** IMPLEMENTATION
	DATE:	10/15/93

	CLASS:  CPPTaskWindow
	
	SUPERCLASS: CPPWindow
	
		This C++ class manages a window which displays a list of
		periodic tasks
	
********************************************************************/

#include <CPPTaskWindow.h>
#include <CPPTaskList.h>
#include <CPPTaskManager.h>
#include <CPPDArray.h>
#include <CPPWindowManager.h>


/*-----------------------------------------------------------------*/
/*------------------------ PUBLIC METHODS -------------------------*/
/*-----------------------------------------------------------------*/

	CPPTaskWindow::CPPTaskWindow (CPPWindowManager *theManager,
						   		  CPPTaskManager *theTaskQ) :
				   CPPWindow (theManager, 1313, FALSE, TRUE)
	{
		Rect	tempRect = this->theWindow->portRect;
		
		SetMinMaxSize (170, 64, 300, 480);
		
		InsetRect (&tempRect, -1, -1);
		tempRect.bottom -= 15;
		
		this->theTaskList = new CPPTaskList (this, &tempRect,
											 theTaskQ, FALSE, FALSE);
	}

	
/*-----------------------------------------------------------------*/

	CPPTaskWindow::~CPPTaskWindow ()
	{
		if (this->theTaskList)
		  delete this->theTaskList;
	}

/*-----------------------------------------------------------------*/

	char	*CPPTaskWindow::ClassName (void)
	{
		return "CPPTaskWindow";
	}
	
/*-----------------------------------------------------------------*/

	void	CPPTaskWindow::DoUserChangeSize (short newWidth, short newHeight)
	/* change the size of the list based on a change in the window size */
	{
		if (this->theTaskList)
		  this->theTaskList->Resize(newWidth, newHeight);
	}

/*-----------------------------------------------------------------*/

