/********************************************************* DEFINITION
	DATE:	9/17/93
	AUTHOR: Eric R. Ros
	
	CLASS:  CPPConfirmUsers
	
	SUPERCLASS: CPPPeriodicTask
	
		This C++ class goes through our list of nodes, checking to
		make sure that they are all still on the network.  If 
		they are not, it deletes them from the list.
	
********************************************************************/

#pragma once

#include <CPPPeriodicTask.h>

class	CPPPTaskManager;
class	CPPConfirmTask;
class	CPPObjectList;

class CPPConfirmUsers : public CPPPeriodicTask {

public:
					CPPConfirmUsers (CPPTaskManager *TaskManager, 
									 long minPeriod = 120, 
									 Boolean deleteWhenDone = TRUE);
	
					~CPPConfirmUsers (void);
		
	virtual	char 	*ClassName (void);

	virtual	void	DoPeriodicAction (void);
	virtual	void	DoCompletedAction (void);
		
	void			StartConfirmUsers (CompletionProc DoProc);
		
private:
	CPPObjectList	*nodeList;
	CPPConfirmTask	*confirmTask;
	long			whichNode;
};
