/********************************************************* DEFINITION
	DATE:	9/17/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPYListenTask
	
	SUPERCLASS: CPPListenTask
	
		This C++ class subclasses the CPPConnect task to add 
		completion behavior specific to the Yenta application
	
********************************************************************/

#include "CPPYListenTask.h"
#include "CPPYReadTask.h"

/*-----------------------------------------------------------------*/
/*------------------------ PUBLIC METHODS -------------------------*/
/*-----------------------------------------------------------------*/

	CPPYListenTask::CPPYListenTask (CPPTaskManager *TaskManager, 
									 long minPeriod, 
									 Boolean deleteWhenDone) :
								  	 CPPListenTask (TaskManager, minPeriod,
								  				     deleteWhenDone)
	{
	
	}
		
/*-----------------------------------------------------------------*/

	char	*CPPYListenTask::ClassName (void)
	{
		return "CPPYListenTask";
	}

/*-----------------------------------------------------------------*/

	void	CPPYListenTask::DoCompletedAction (void)
	/* when a connection has been made, create & post a 'read' task */
	{
		CPPYReadTask	*DoRead = NULL;
		
		CPPListenTask::DoCompletedAction();

		if (this->callResult == noErr)
		  {
		  	DoRead = new CPPYReadTask (this->ourManager, 15, TRUE);
		  	DoRead->StartReadTask(this->sessionID, 100, NULL);
		  }
	}

