/********************************************************* DEFINITION
	DATE:	9/17/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPYReadTask
	
	SUPERCLASS: CPPReadTask
	
		This C++ class subclasses CReadTask to define specific 
		completion behavior for the Yenta Application
	
********************************************************************/

#include "CPPTaskManager.h"
#include "CPPYListenTask.h"
#include "CPPYReadTask.h"
#include "CPPList.h"
#include <MemoryTools.h>

extern  CPPList			*gTalkText;
extern	PPCPortRefNum	gOurPort;

/*-----------------------------------------------------------------*/
/*------------------------ PUBLIC METHODS -------------------------*/
/*-----------------------------------------------------------------*/

	CPPYReadTask::CPPYReadTask (CPPTaskManager *TaskManager, 
								long minPeriod, 
								Boolean deleteWhenDone) :
							  	CPPReadTask (TaskManager, minPeriod,
							  				 deleteWhenDone)
	{
	
	}
	
/*-----------------------------------------------------------------*/

	CPPYReadTask::~CPPYReadTask (void)
	{
	
	}

/*-----------------------------------------------------------------*/

	char	*CPPYReadTask::ClassName (void)
	{
		return "CPPYReadTask";
	}

/*-----------------------------------------------------------------*/

	void	CPPYReadTask::DoCompletedAction (void)
	// when the task has completed, close the connection from our end
	// and queue up another connection task
	{
		PPCEndPBRec			EndRec;
		Boolean				AmITheOwner;
		CPPYListenTask		*LTask = NULL;
		
		Handle	TempHandle = this->GetData (FALSE, &AmITheOwner);
		
		CPPReadTask::DoCompletedAction();
		
		// store a pointer to the text in a list where the Send dialog
		//  can get it
		gTalkText->AppendItem(Hand2Ptr(TempHandle));
		
		// Close the connection from our end
		EndRec.sessRefNum = this->sessionID;
		this->callResult = PPCEnd (&EndRec, FALSE);
		
		// make a new task to listen for other people trying to connect
  	  	LTask = new CPPYListenTask (this->ourManager, 60, TRUE);
  	  	LTask->StartListenTask(gOurPort, NULL);
	}

