/***************************************************** IMPLEMENTATION
	DATE:	9/26/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPSendWindow
	
	SUPERCLASS: CPPWindow
	
		This C++ class manages the NetApp Send window
	
********************************************************************/

#pragma once

#include <CPPWindow.h>

class 	CPPText;
class 	CPPPictButton;
class 	CPPButton;
class 	CPPCheckBox;
class 	CPPUserList;
class 	CPPZoneList;
class 	CPPStaticText;
class	CPPZone411;
class	CPPNode411;
class	CPPNodeInfo;
class	CPPStringList;

class CPPSendWindow : public CPPWindow {
public:
	CPPObjectList	*UserListData;
	CPPUserList		*UserList;
	CPPZoneList		*ZoneList;
	CPPZone411		*ZoneLookup;
	CPPNode411		*NodeLookup;
	
			CPPSendWindow (CPPWindowManager *theManager);
			~CPPSendWindow (void);

	virtual	char	*ClassName (void);
	virtual	void	RefreshItemStates(void);
	virtual	Boolean DoCommand (short commandID);
			void	ProcessMessageQ (void);
			void	SetStatusMessage (StringPtr newMessage, 
									  Boolean makeCopy);
			
protected:	
	CPPText			*SendText;
	CPPCheckBox		*CBEcho;
	CPPPictButton	*PBLoadZones;
	CPPButton		*SendButton;
	CPPStaticText	*ARWarning;
	CPPStaticText	*Status;

	virtual Boolean	DoUserKey (EventRecord *theEvent);
	
private:
	void	SendToUser(Ptr Text, Boolean OwnsData, CPPNodeInfo *SendTo);
	void	GotNewMessage (CPPNodeInfo *FromWhom);
	void	DoSendButton(void);

};