/* 
January Solution -Poker-
Kevin M. Cutts 
*/

#include <stdlib.h>
#include <stdio.h>

typedef unsigned char Card;

typedef struct SevenCardHand 
{
	Card cards[7];
} SevenCardHand;

typedef struct FiveCardHand
{
	Card cards[5];
} FiveCardHand;

short ComparePokerHands(
	SevenCardHand *, 
	SevenCardHand *,
	FiveCardHand *,
	FiveCardHand *,
	Boolean,
	Card,
	Boolean,
	void *); 

/* Used to remove the suit information and leave 
only the count from the card */
unsigned char theValue[] = {
0,1,2,3,4,5,6,7,8,9,10,11,12,
0,1,2,3,4,5,6,7,8,9,10,11,12,
0,1,2,3,4,5,6,7,8,9,10,11,12,
0,1,2,3,4,5,6,7,8,9,10,11,12,
};

/* Used to remove card value and leave the suit indicator */
unsigned char theSuit[] = {
0,0,0,0,0,0,0,0,0,0,0,0,0,
1,1,1,1,1,1,1,1,1,1,1,1,1,
2,2,2,2,2,2,2,2,2,2,2,2,2,
3,3,3,3,3,3,3,3,3,3,3,3,3,
};

/* A bit for each card value (aces have two bits) */
unsigned short theValueBit[] = {
0x1000,0x800,0x400,0x200,0x100,0x80,0x40,
	0x20,0x10,0x8,0x4,0x2,0x2001,
0x1000,0x800,0x400,0x200,0x100,0x80,0x40,
	0x20,0x10,0x8,0x4,0x2,0x2001,
0x1000,0x800,0x400,0x200,0x100,0x80,0x40,
	0x20,0x10,0x8,0x4,0x2,0x2001,
0x1000,0x800,0x400,0x200,0x100,0x80,0x40,
	0x20,0x10,0x8,0x4,0x2,0x2001,
};

#define fiveAlike		0xa000
#define straightFlush	0x9000
#define fourAlike		0x8000
#define fullHouse		0x7000
#define flush			0x6000
#define straight		0x5000
#define threeAlike		0x4000
#define twoPair			0x3000
#define pair			0x2000

#define nonCard 0xff
/* These four functions are custom 
to handle the four bools wild and flush */
unsigned int BestHandNoWild(SevenCardHand *theHand, 
	FiveCardHand *theBest);
unsigned int BestHand(SevenCardHand *theHand, 
	FiveCardHand *theBest, Card wildCard);
unsigned int BestHandNoFlush(SevenCardHand *theHand, 
	FiveCardHand *theBest, Card wildCard);
unsigned int BestHandNoFlushNoWild(SevenCardHand *theHand, 
	FiveCardHand *theBest);

/***********************************************************/
unsigned int BestHandNoWild(SevenCardHand *theHand, 
	FiveCardHand *theBest)
{
	/* How many of each card value encountered */
	unsigned char handValues[13];
	/* How many of each suit encountered */ 
	unsigned char handSuits[4];
	/* Bit field describing on a suit by suit basis 
		how populated the hand is */ 
	short handRuns[4]; 
	register short i;
	short j;
	Card bestCard, bestPair, goodPair, bestTri, bestQuad;
	Card *cardPtr;
	short runSweep, runResult, runCount;

	/* Zero out all of the counts */
	*(long *)&handValues[0] = 
		*(long *)&handValues[4] = 
		*(long *)&handValues[8] = 
		handValues[12] = 0;
	*(long *)&handSuits[0] = 0;
	*(long *)&handRuns[0] = *(long *)&handRuns[2] = 0;
	/* Now accumulate the values */
	/* Now accumulate the values */
	for (i=0, cardPtr=theHand->cards; i<7; i++, cardPtr++)
	{
		handValues[theValue[*cardPtr]]++;
		handSuits[theSuit[*cardPtr]]++;
		handRuns[theSuit[*cardPtr]] |= 
			theValueBit[*cardPtr];
	}
	/* First count the pairs, tris, quads and penta */
	bestCard = bestPair = goodPair = 
		bestTri = bestQuad = nonCard;
	for (i = 12; i >= 0; i--)
	{
		if (!(j = handValues[i])) continue;
		if (j == 4)
		{
			bestQuad = i;
			break;
		}
		if (j == 3 && bestTri == nonCard)
		{
			bestTri = i;
			if (bestPair != nonCard)
			{
				/* Full house */
				break;
			}
		}
		else if (j == 2 && bestPair == nonCard)
		{
			bestPair = i;
			if (bestTri != nonCard)
			{
				/* Full house */
				break;
			}
		}
		else if (j == 2 && goodPair == nonCard)
		{
			goodPair = i;
		}
		else if (bestCard == nonCard)
		{
			bestCard = i;
		}
	}
	/* Now check for a straight flush */
#define CHK_SUIT_NOWILD(suit) \
	if (handSuits[suit] >= 5) \
	{ \
		for (runSweep=0x1f;runSweep<0x1fff;runSweep<<= 1) \
		{ \
			runResult = handRuns[suit] & runSweep; \
			if (runResult == runSweep) \
			{ \
				/* Transfer the five cards */ \
				for (i=0, j=0; j < 5;i++) \
				{ \
					if ((theValueBit[theHand->cards[i]] & \
						runSweep && suit == \
						theSuit[theHand->cards[i]])) \
					{ \
						theBest->cards[j++] = \
							theHand->cards[i]; \
					} \
				} \
				return straightFlush; \
			} \
		} \
	}
	CHK_SUIT_NOWILD(0);
	CHK_SUIT_NOWILD(1);
	CHK_SUIT_NOWILD(2);
	CHK_SUIT_NOWILD(3);
	/* Next comes four of a kind */
	if (bestQuad != nonCard)
	{
		/* Transfer the five cards */
		runSweep = 1;
		for (i=0, j=0; j < 5;i++)
		{
			if (theValue[theHand->cards[i]] == bestQuad)
			{
				theBest->cards[j++] = theHand->cards[i];
			}
			else if (runSweep)
			{
				theBest->cards[j++] = theHand->cards[i];
				runSweep--;
			}
		}
		return fourAlike | bestQuad;
	}
	/* Next is the full house */
	if (bestTri != nonCard && bestPair != nonCard)
	{
		/* Transfer the five cards */
		for (i=0, j=0; j < 5;i++)
		{
			if (theValue[theHand->cards[i]] == bestTri || 
				theValue[theHand->cards[i]] == bestPair)
			{
				theBest->cards[j++] = theHand->cards[i];
			}
		}
		return fullHouse | (bestTri<<8) | (bestPair);
	}
	/* Now the flush */
#define CHK_FLUSH_NOWILD(suit) \
	if (handSuits[suit] >= 5) \
	{ \
		/* Transfer the five cards */ \
		for (i=0, j=0; j < 5;i++) \
		{ \
			if (theSuit[theHand->cards[i]] == suit) \
			{ \
				theBest->cards[j++] = theHand->cards[i]; \
			} \
		} \
		return flush | bestCard; \
	}
	CHK_FLUSH_NOWILD(0);
	CHK_FLUSH_NOWILD(1);
	CHK_FLUSH_NOWILD(2);
	CHK_FLUSH_NOWILD(3);
	/* Next the straight */
	j = handRuns[0]|handRuns[1]|handRuns[2] | handRuns[3];
	for (runSweep=0x1f; runSweep < 0x1fff; runSweep <<= 1)
	{
		runResult = j & runSweep;
		if (runResult == runSweep)
		{
			/* Transfer the five cards */
			for (i=0, j=0; j < 5;i++)
			{
				if ((theValueBit[theHand->cards[i]] 
					& runSweep))
				{
					theBest->cards[j++] = 
						theHand->cards[i];
				}
			}
			return straight;
		}
	}
	/* and the three of a kind */
	if (bestTri != nonCard)
	{
		/* Transfer the five cards */
		runSweep = 2;
		for (i=0, j=0; j < 5;i++)
		{
			if (theValue[theHand->cards[i]] == bestTri)
			{
				theBest->cards[j++] = theHand->cards[i];
			}
			else if (runSweep)
			{
				theBest->cards[j++] = theHand->cards[i];
				runSweep--;
			}
		}
		return threeAlike | bestTri;
	}
	/* Now two pair */
	if (bestPair != nonCard && goodPair != nonCard)
	{
		/* Transfer the five cards */
		runSweep = 1;
		for (i=0, j=0; j < 5;i++)
		{
			if (theValue[theHand->cards[i]] == bestPair ||
				theValue[theHand->cards[i]] == goodPair)
			{
				theBest->cards[j++] = theHand->cards[i];
			}
			else if (runSweep)
			{
				theBest->cards[j++] = theHand->cards[i];
				runSweep--;
			}
		}
		return twoPair | (bestPair << 8) | goodPair;
	}
	/* And finally a single pair */
	if (bestPair != nonCard)
	{
		/* Transfer the five cards */
		runSweep = 3;
		for (i=0, j=0; j < 5;i++)
		{
			if (theValue[theHand->cards[i]] == bestPair)
			{
				theBest->cards[j++] = theHand->cards[i];
			}
			else if (runSweep)
			{
				theBest->cards[j++] = theHand->cards[i];
				runSweep--;
			}
		}
		return pair | bestPair;
	}
	/* Transfer the five cards */
	runSweep = 4;
	for (i=0, j=0; j < 5;i++)
	{
		if (theValue[theHand->cards[i]] == bestCard)
		{
			theBest->cards[j++] = theHand->cards[i];
		}
		else if (runSweep)
		{
			theBest->cards[j++] = theHand->cards[i];
			runSweep--;
		}
	}
	return bestCard;
}

/***********************************************************/
short ComparePokerHands(
	SevenCardHand *hand1Ptr, 
	SevenCardHand *hand2Ptr,
	FiveCardHand *best1Ptr,
	FiveCardHand *best2Ptr,
	Boolean wildCardAllowed,
	Card wildCard,
	Boolean straightsdAndFlushesValid,
	void *privateDataPtr)
{
	unsigned int hand1Value, hand2Value;
	if (wildCardAllowed && straightsdAndFlushesValid)
	{
		hand1Value = BestHand(hand1Ptr, best1Ptr, wildCard);
		hand2Value = BestHand(hand2Ptr, best2Ptr, wildCard);
	}
	else if (wildCardAllowed)
	{
		hand1Value = BestHandNoFlush(hand1Ptr, 
			best1Ptr, wildCard);
		hand2Value = BestHandNoFlush(hand2Ptr, 
			best2Ptr, wildCard);
	}
	else if (straightsdAndFlushesValid)
	{
		hand1Value = BestHandNoWild(hand1Ptr, best1Ptr);
		hand2Value = BestHandNoWild(hand2Ptr, best2Ptr);
	}
	else
	{
		hand1Value = BestHandNoFlushNoWild(hand1Ptr, 
			best1Ptr);
		hand2Value = BestHandNoFlushNoWild(hand2Ptr, 
			best2Ptr);
	}
	if (hand1Value > hand2Value) return -1;
	if (hand1Value < hand2Value) return 1;
	return 0;
} 
