/***************************************************** IMPLEMENTATION
	DATE:	11/30/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPTreeAppAboutBox
	
	SUPERCLASS: CPPWindow
	
		This C++ class manages the Yenta about box dialog
	
********************************************************************/

#include "CPPTreeAppAboutBox.h"
#include <CPPWindowManager.h>
#include <CPPButton.h>
#include <CPPStaticText.h>
#include <ToolboxTools.h>


extern	CPPWindowManager	*gWindowManager;
extern	void DoStdOKButton (CPPWindow *theWindow);
extern	void DoStdCancelButton (CPPWindow *theWindow);

Rect	AboutRect = {42, 20, 139, 195};

/*-----------------------------------------------------------------*/
/*------------------------ PUBLIC METHODS -------------------------*/
/*-----------------------------------------------------------------*/
						  
	CPPTreeAppAboutBox::CPPTreeAppAboutBox (CPPWindowManager *theManager) :
					  CPPWindow (theManager, &AboutRect, "\pAbout", TRUE,
					  			 altDBoxProc, FALSE, 13, TRUE, FALSE, systemFont, 12)
	{
		GrafPtr	SavePort;
		Rect	tempRect;
		
		GetPort(&SavePort);
		SetPort(this->theWindow);
		
	//	create static text item
		SetRect (&tempRect, 10, 10, 170, 50);
		aboutText = new CPPStaticText ((CPPWindow *)this, &tempRect, 
			"\pTreeApp v1.0\rwritten by Eric Ros", 
			systemFont, 12, teJustCenter);

	// create the dialog buttons
		SetRect (&tempRect, 44, 63, 124, 83);
		okButton = new CPPButton ((CPPWindow *)this, &tempRect, "\pOK", TRUE);
		okButton->SetDoClickProc (DoStdOKButton);
		
		SetPort(SavePort);
	}
	
/*-----------------------------------------------------------------*/

	CPPTreeAppAboutBox::~CPPTreeAppAboutBox ()
	{
		
	}

/*-----------------------------------------------------------------*/

	char	*CPPTreeAppAboutBox::ClassName (void)
	{
		return "CPPTreeAppAboutBox";
	}
	
/*-----------------------------------------------------------------*/

	Boolean	CPPTreeAppAboutBox::DoUserKey (EventRecord *theEvent)
	{
		char theKey;
		CPPList	*TempList;

		theKey = theEvent->message & charCodeMask;
	  	switch (theKey) {
		  	case kEnter :
		  	case kReturn :
		  		if (okButton)
		  		  okButton->SimulateClick();
	  		default:
	      		return TRUE;
	      		break;
	    } // switch

	}

/*-----------------------------------------------------------------*/
	
	Boolean	DoAboutBox (void)
	{
		CPPTreeAppAboutBox	*theWindow;
		Boolean			theResult;
		
		theWindow = new CPPTreeAppAboutBox (gWindowManager);
		  
		if (theWindow)
		  {
		  	theWindow->DoModalWindow ();
		  	delete theWindow;
		  	return theResult;
		  }
		else
		  SysBeep(1);
	}