/***************************************************** IMPLEMENTATION
	DATE:	9/20/93

	CLASS:  CPPTreeAppMenuBar
	
	SUPERCLASS: CPPMenuBar
	
		This C++ class manages the menu bar for our application
	
********************************************************************/

#pragma once

#include "CPPTreeAppMenuBar.h"
#include "CPPTreeAppMenuBar.h"
#include "MyCommands.h"
#include <Commands.h>

extern	Boolean				gQuitApp;

/*-----------------------------------------------------------------*/

#define	kAppleMenu		1028
#define		kAbout		1

#define	kFileMenu		1029
#define		kQuit		1

#define	kTreeMenu		1030
#define		kLength		4
#define		kAdd		6
#define		kInsert		7
#define		kDeleteNode	8
#define		kDeleteFamily	9
#define		kChangeNode	10
#define		kCopyTree	12

#define	kOrientMenu		128
#define		kTopDown	1
#define		kBottomUp	2
#define		kLeft2Right	4
#define		kRight2Left	5

#define	kJustMenu		129
#define		kRightJust	1
#define		kLeftJust	2
#define		kCenterJust	3

#define	kJoinMenu		130
#define		kJoinNone	1
#define		kJoinAngle	2
#define		kJoinPoint	3

/*-----------------------------------------------------------------*/
/*------------------------ PUBLIC METHODS -------------------------*/
/*-----------------------------------------------------------------*/

	CPPTreeAppMenuBar::CPPTreeAppMenuBar (void) : CPPMenuBar (128, 1028)
	/* create a menu bar based on the passed-in resource template */
	{
		AddDAs (kAppleMenu);
		SetUpHierMenus (128, 130);
		SetCommandBindings();
	}

/*-----------------------------------------------------------------*/

	CPPTreeAppMenuBar::~CPPTreeAppMenuBar (void)
	{
	}

/*-----------------------------------------------------------------*/

	Boolean	CPPTreeAppMenuBar::Member (char *className)
	{
		if (strcmp(className, CPPTreeAppMenuBar::ClassName()) == 0)
		  return TRUE;
		else
		  return CPPMenuBar::Member(className);
	}

/*-----------------------------------------------------------------*/

	char	*CPPTreeAppMenuBar::ClassName (void)
	{
		return "CPPTreeAppMenuBar";
	}

/*-----------------------------------------------------------------*/

	void	CPPTreeAppMenuBar::SetCommandBindings (void)
	{
		BindCommand(kAppleMenu, kAbout, kCmdAbout);

		BindCommand(kFileMenu, kQuit, kCmdQuit);
		
		BindCommand (kTreeMenu, kAdd, kCmdAdd);
		BindCommand (kTreeMenu, kInsert, kCmdInsert);
		BindCommand (kTreeMenu, kDeleteNode, kCmdDeleteNode);
		BindCommand (kTreeMenu, kDeleteFamily, kCmdDeleteFamily);
		BindCommand (kTreeMenu, kChangeNode, kCmdChangeNode);
		BindCommand (kTreeMenu, kLength, kCmdLength);
		BindCommand (kTreeMenu, kCopyTree, kCmdCopy);
		
		BindCommand (kOrientMenu, kTopDown, kCmdTopDown);
		BindCommand (kOrientMenu, kBottomUp, kCmdBottomUp);
		BindCommand (kOrientMenu, kLeft2Right, kCmdLeft2Right);
		BindCommand (kOrientMenu, kRight2Left, kCmdRight2Left);

		BindCommand (kJustMenu, kRightJust, kCmdRightJust);
		BindCommand (kJustMenu, kLeftJust, kCmdLeftJust);
		BindCommand (kJustMenu, kCenterJust, kCmdCenterJust);

		BindCommand (kJoinMenu, kJoinNone, kCmdJoinNone);
		BindCommand (kJoinMenu, kJoinAngle, kCmdJoinAngle);
		BindCommand (kJoinMenu, kJoinPoint, kCmdJoinPoint);
	}
