/***************************************************** IMPLEMENTATION
	DATE:	9/26/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPApplication
	
	SUPERCLASS: CPPObject
	
		This C++ class manages a very basic application
	
********************************************************************/

#pragma once

#include <CPPObject.h>

class	CPPWindowManager;
class	CPPMenuBar;
class	CPPApplication;

/*-----------------------------------------------------------------*/

class CPPApplication : public CPPObject {
public:
			CPPApplication (void);
			~CPPApplication (void);
	
	void	Initialize (void);
	void	ShutDown (void);
	
	virtual	Boolean	Member (char *className);
	virtual	char	*ClassName (void);
	
	void	Go (void);
	virtual	Boolean	DoCommand (short commandID);

protected:
	short	idleTime;
	
	virtual void	AllocateMemory (void);
	virtual	void	BuildMenuBar (void);
	virtual	void	BuildWindowManager (void);
	virtual	void	DoApplicationSetup (void);
	virtual	void	DoApplicationShutDown (void);
	virtual	void	DoAppPeriodicTask (void);
	
	void	DoEvent(EventRecord *theEvent);
};