/***************************************************** IMPLEMENTATION
	DATE:	10/4/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPDArray
	
	SUPERCLASS: CPPGossipMonger
	
		This C++ class manages a dynamic array of arbitrarily
		sized objects
	
********************************************************************/

#pragma once

#include <CPPGossipMonger.h>


enum {
	kItemAdded 	 = 	1,
	kItemDeleted =	2,
	kItemChanged =	3,
	kAllChanged	 =	4
};


class CPPDArray : public CPPGossipMonger{
public:
			CPPDArray (short objectSize);
			~CPPDArray (void);
			
	virtual	Boolean	Member (char *className);
	virtual	char *ClassName (void);
		
	virtual	void	AppendItem (Ptr NewItem);
	virtual	void	InsertItem (Ptr NewItem, long insertAt);
	virtual	void	SetItem (Ptr NewItem, long setWhich, Boolean deleteOld);
	virtual	void	DeleteItem (long deleteWhich, Boolean doDispose);
	virtual	void	DeleteItems (Boolean doDispose);
	
	virtual	void	Get (void *dataPtr, long getWhich);
		
	virtual void	Swap (long Index1, long Index2);
			void 	*operator[] (long getWhich);
	
	long	GetNumItems (void);
	long	FindIndex	(Ptr ItemToFind);
				
protected:
	long	numItems;
	Handle	listItems;
	short	itemSize;

	virtual	void	Clear (long clearWhich);
	
private:
	long	numSlots;
	
	void	Resize (long newNumSlots);
};
