/***************************************************** IMPLEMENTATION
	DATE:	10/13/93

	CLASS:  CPPGossipMonger
	
	SUPERCLASS: CPPObject
	
		This C++ class lets objects talk to each other.
		Its architecture is based on that of the TCL CCollaborator class.
	
********************************************************************/

#pragma once

#include <CPPObject.h>

class CPPObjectList;

class CPPGossipMonger : public CPPObject
{

public:	
			CPPGossipMonger (void);
			~CPPGossipMonger (void);

	virtual	char	*ClassName (void);
	virtual	Boolean	Member (char *className);
	
	virtual void	ListenTo( CPPGossipMonger *newTalker);
	virtual void	StopListeningTo( CPPGossipMonger *theTalker);

protected:

	CPPObjectList *Talkers;		// the objects a collaborator listens to
	CPPObjectList *Listeners;	// the objects that listen to it

	virtual void BroadcastMessage( short reason, void* info);
	virtual void ReceiveMessage( CPPGossipMonger *toldBy, short reason, void* info);

private:	

	virtual void AddListener( CPPGossipMonger *newListener);
	virtual void RemoveListener( CPPGossipMonger *theListener);
	
	virtual void AddTalker( CPPGossipMonger *newTalker);
	virtual void RemoveTalker( CPPGossipMonger *theTalker);

};
