/***************************************************** IMPLEMENTATION
	DATE:	9/15/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPObjectList
	
	SUPERCLASS: CPPList
	
		This C++ class manages a list of objects
	
********************************************************************/

#include "CPPObjectList.h"
#include <MathTools.h>

/*-----------------------------------------------------------------*/
/*---------------------------- MACROS -----------------------------*/
/*-----------------------------------------------------------------*/

	#define	ITEMPTR(i) ((Ptr)((*listItems) + ((i-1) * sizeof(Ptr))))

/*-----------------------------------------------------------------*/
/*------------------------ PUBLIC METHODS -------------------------*/
/*-----------------------------------------------------------------*/

	CPPObjectList::CPPObjectList (void)
	/* No class-specific initialization */
	{
	}

/*-----------------------------------------------------------------*/

	CPPObjectList::~CPPObjectList (void)
	/* No class-specific destruction */
	{
	}
			
/*-----------------------------------------------------------------*/

	Boolean	CPPObjectList::Member (char *className)
	{
		if (strcmp(className, CPPObjectList::ClassName()) == 0)
		  return TRUE;
		else
		  return CPPList::Member(className);
	}

/*-----------------------------------------------------------------*/

	char *CPPObjectList::ClassName (void)
	{
		return "CPPObjectList";
	}
		
/*-----------------------------------------------------------------*/

	void	CPPObjectList::InsertItem (CPPObject *NewItem, long insertAt)
	/* Call the superclass to perform the insertion */
	{
		CPPList::InsertItem ((Ptr)NewItem, insertAt);
	}

/*-----------------------------------------------------------------*/

	void	CPPObjectList::DeleteItem (CPPObject *theItem, Boolean doDispose)
	/* Call the superclass to perform the insertion */
	{	
		if (theItem)
		  CPPList::DeleteItem (FindIndex (theItem), doDispose);
	}

/*-----------------------------------------------------------------*/

	void	CPPObjectList::AppendItem (CPPObject *NewItem)
	/* Call the superclass to perform the append */
	{
		CPPList::InsertItem ((Ptr)NewItem, this->numItems+1);
	}

/*-----------------------------------------------------------------*/

	CPPObject	*CPPObjectList::operator[] (long getWhich)
	{
		return (CPPObject *)(CPPList::operator[](getWhich));
	}
	
/*-----------------------------------------------------------------*/

	void	CPPObjectList::SetItem (CPPObject *NewItem, long setWhich, Boolean deleteOld)
	{
		CPPList::SetItem((Ptr)NewItem, setWhich, deleteOld);
	}

/*-----------------------------------------------------------------*/

	long	CPPObjectList::FindIndex (CPPObject *ObjectToFind)
	{
		return CPPList::FindIndex((Ptr)ObjectToFind);
	}

/*-----------------------------------------------------------------*/
/*---------------------- PROTECTED METHODS ------------------------*/
/*-----------------------------------------------------------------*/

	void	CPPObjectList::ClearItem (long clearWhich)
	/* Dispose of the object in the list at position */
	/* clearWhich without resizing the list */
	{
		CPPObject	*TempObject = NULL;
		long		Nada = 0L;
		
		if (IN_RANGE (clearWhich, 1, this->numItems))
		  {
	  	    TempObject = (*this)[clearWhich];
	  	    if (TempObject)
	  	      {
				BlockMove (&Nada, ITEMPTR(clearWhich), sizeof(Ptr));
	  	      	delete TempObject;
	 	      }
		  }
	}
