/***************************************************** IMPLEMENTATION
	DATE:	10/24/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPTree
	
	SUPERCLASS: CPPGossipMonger
	
		This C++ class manages the common data (root) for a 
		hierarchical tree.  It is meant to be used in conjunction
		with CPPTreeNode
	
********************************************************************/

#pragma once

#include <CPPGossipMonger.h>

class CPPTreeNode;

class CPPTree : public CPPGossipMonger {
public:
			CPPTree (void);
			~CPPTree (void);
			
	virtual	Boolean	Member (char *className);
	virtual	char *ClassName (void);
		
			void	SetTopMostNode (CPPTreeNode *theNode);
	inline	CPPTreeNode	*GetTopMostNode (void) {return this->topNode;}

	virtual	void	ReceiveMessage (CPPGossipMonger *toldBy, 
									short reason, void* info);

			short	Depth (void);

	CPPTreeNode	*topNode;
};