/***************************************************** IMPLEMENTATION
	DATE:	11/12/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPPackedTreeNode
	
	SUPERCLASS: CPPVisualTreeNode
	
		This C++ class manages the visual representation of a node
		in a packed hierarchical tree
	
********************************************************************/

#pragma once

#include <CPPVisualTreeNode.h>

class CPPVisualTree;

class CPPPackedTreeNode : public CPPVisualTreeNode {
		friend	class CPPVisualTree;
public:
	
			CPPPackedTreeNode (CPPObject *NodeData, CPPTree *BelongsTo, 
							   Boolean becomeOwner, Boolean selected);
			~CPPPackedTreeNode (void);
			
	virtual	char *ClassName (void);
	virtual	Boolean	Member (char *className);
		
	virtual CPPObject *Clone(void);

	virtual	void	EraseNode (Boolean wholeFamily);
				
	virtual	void	ReceiveMessage (CPPGossipMonger *toldBy, 
									short reason, void* info);
				
protected:
	Point	estTopLeft;

	virtual	void 		DoCalcFamilySize(void);
	virtual	void 		DoCalcFamilyBounds (Point TopLeftCorner);
			void		CPBRightTraverse (short level, short levelOffset);
			void		CPBLeftTraverse (short level, short levelOffset);
			void		CPBTopTraverse (short level, short levelOffset);
			void		CPBBottomTraverse (short level, short levelOffset);
			void		PostProcess (Boolean isVertical);

private:
			void		ShiftNode (Point newTopLeft);

};

