/***************************************************** IMPLEMENTATION
	DATE:	10/19/93

	CLASS:  CPPScrollWindow
	
	SUPERCLASS: CPPWindow, CPPScrollArea
	
		This C++ class manages a window which has a scrolling area
		inside of it
	
********************************************************************/

#pragma once

#include <CPPWindow.h>
#include <CPPScrollArea.h>

class CPPScrollWindow : public CPPWindow, public CPPScrollArea {
public:
			CPPScrollWindow (CPPWindowManager *theManager, int ResID, 
							 Boolean HScroll = TRUE, Boolean VScroll = TRUE,
							 short hStep = 10, short vStep = 10);
			CPPScrollWindow (CPPWindowManager *theManager,
						     Rect *bounds, StringPtr title, Boolean isVisible,
						     int windowKind, Boolean hasGoAway, int RefCon,
						     Boolean HScroll = TRUE, Boolean VScroll = TRUE,
						     short hStep = 10, short vStep = 10);
			~CPPScrollWindow (void);
			
	virtual	char	*ClassName (void);
	virtual	Boolean	Member (char *className);

	virtual	Boolean	DoCommand (short commandID);

protected:
	virtual void	DoUserClick (EventRecord *theEvent);
	virtual void	DoUserUpdate (void);
	virtual void	DoUserIdle (void);
	virtual	void	DoUserChangeSize (short newWidth, short newHeight);
};