/***************************************************** IMPLEMENTATION
	DATE:	11/7/93
	AUTHOR: Eric R. Ros

	CLASS:  CPPTreeArea
	
	SUPERCLASS: CPPScrollArea, CPPVisualTree
	
		This C++ class manages a tree which lives inside a scrolling
		area.
	
********************************************************************/

#pragma once

#include <CPPScrollArea.h>
#include <CPPVisualTree.h>


class CPPTreeArea : public CPPVisualTree, CPPScrollArea {
public:	
			CPPTreeArea (CPPWindow *OurWindow,
						  Rect *ViewArea,
						  Rect *DestArea,
						  Boolean UseHScroll = TRUE,
						  Boolean UseVScroll = TRUE,
						  short hStep = 10, 
						  short vStep = 10,
						  orientStyle orientation = kTopDown,
						  justStyle justification = kJustCenter,
						  joinTypes join = kRightAngle,
						  short branchLength = 25);
			CPPTreeArea (CPPWindow *OurWindow,
						  Boolean UseHScroll = TRUE,
						  Boolean UseVScroll = TRUE,
						  short hStep = 10, 
						  short vStep = 10,
						  orientStyle orientation = kTopDown,
						  justStyle justification = kJustCenter,
						  joinTypes join = kRightAngle,
						  short branchLength = 25);
			~CPPTreeArea (void);
			
	virtual	char *ClassName (void);
	virtual	Boolean	Member (char *className);
	
	virtual	Boolean	DoScrollAreaClick (Point clickPt, 
									   short modifiers, 
									   Rect *selRect);
		
	virtual	Boolean	DoCommand (short commandID);
	virtual	void	Draw (void);
	virtual	void	DrawContents (void);


protected:
			void	UserSpecificPrepare (void);
			void	UserSpecificRestore (void);

};
