// ===========================================================================
// SCDoc.h
// ===========================================================================
//  1995 James Kaput, Jeremy Roschelle SimCalc Project

#pragma once

class SCPage;

class SCDoc : LDocument {
	public:
		SCDoc(LCommander	*inSuper);
		virtual ~SCDoc();
		virtual StringPtr	GetDescriptor(Str255 outDescriptor) const;
		virtual void		SetSelection(SCPage *inPage);
		virtual void		DoSort(Boolean inAscending = true);
		
		virtual void		AddSubModel(LModelObject *inSubModel);
		virtual void		RemoveSubModel(LModelObject *inSubModel);
		virtual Int32		CountSubModels(DescType inModelID) const;
		virtual void		GetSubModelByPosition(
									DescType		inModelID,
									Int32			inPosition,
									AEDesc			&outToken) const;
									
		virtual void		GetSubModelByName(
									DescType		inModelID,
									Str255			inName,
									AEDesc			&outToken) const;
									
		virtual void		GetSubModelByUniqueID(
									DescType		inModelID,
									const AEDesc	&inKeyData,
									AEDesc			&outToken) const;
		virtual Int32		GetPositionOfSubModel(
									DescType			inModelID,
									const LModelObject	*inSubModel) const;
		virtual void		GetAEProperty(
								DescType		inProperty,
								const AEDesc	&inRequestedType,
								AEDesc			&outPropertyDesc) const;
		virtual void		HandleAppleEvent(
									const AppleEvent	&inAppleEvent,
									AppleEvent			&outAEReply,
									AEDesc				&outResult,
									Int32				inAENumber);
		virtual void		HandleCountEvent(const AppleEvent	&inAppleEvent,
									AppleEvent		&outAEReply,
									AEDesc			&outResult);
		virtual void		MakeSelfSpecifier(
										AEDesc	&inSuperSpecifier,
										AEDesc	&outSelfSpecifier) const;
	protected:
		LList		mPageList;
		SCPage	*mSelection;
};