// ===========================================================================
// SCPage.h -- the page class 
// ===========================================================================
//  1995 James Kaput, Jeremy Roschelle SimCalc Project

#pragma once

class SCDoc;

class SCPage : public LModelObject {
	public:
		enum		{modelKind = 'page'};
	
		SCPage(SCDoc *inDoc);
		virtual ~SCPage();
		
		virtual DescType		GetModelKind() const
							{return SCPage::modelKind;};
		virtual LModelProperty*	GetModelProperty(DescType inProperty);

		virtual void	GetDescriptor(Str255 outName) const;
		virtual Int32 	GetID() const;
		
		
		virtual void	HandleAppleEvent(const AppleEvent	&inAppleEvent,
								AppleEvent			&outAEReply,
								AEDesc				&outResult,
								Int32				inAENumber);
		virtual void	GetAEProperty(
								DescType		inProperty,
								const AEDesc	&inRequestedType,
								AEDesc			&outPropertyDesc) const;
		virtual void	SetAEProperty(
								DescType		inProperty,
								const AEDesc	&inValue,
								AEDesc			&outAEReply);
	protected:
		Str255	mName;
		long		mID;
};