/*
	File:		PictureWindow.cp

	Contains:	A window designed to hold a PICT, no scroll bars...
	Written by: Dave Mark
	Copyright:	1995 by Dave Mark, all rights reserved.
 */

#ifndef		_PICTUREWINDOW_
#define		_PICTUREWINDOW_

#ifndef		_WINDOW_
#include	"Window.h"
#endif


enum
{
	mPicture			= 1001,
	cCentered			= 1002,
	cUpperLeft			= 1003
};


class	TPictureWindow : public TWindow
{
  public:
							TPictureWindow();
	virtual 				~TPictureWindow();

	virtual WindowPtr		MakeNewWindow( WindowPtr behindWindow );

	virtual void			Draw(void);
	
	virtual void			Activate( Boolean activating );
	
	virtual void			Click( EventRecord * anEvent );
	
	virtual void			ClickAndDrag( EventRecord *eventPtr );
	
	virtual	OSErr			DragEnterWindow( DragReference dragRef );
	virtual	OSErr			DragInWindow( DragReference dragRef );
	virtual	OSErr			DragLeaveWindow( DragReference dragRef );
	virtual	OSErr			HandleDrop( DragReference dragRef );
	
//	Non-TWindow methods...
	virtual PicHandle		LoadDefaultPicture();
	virtual void			CenterPict( PicHandle picture, Rect *destRectPtr );
	virtual Boolean			IsPictFlavorAvailable( DragReference dragRef );
	virtual Boolean			IsMouseInContentRgn( DragReference dragRef );
	static void				SetUpStaticMenu( void );

protected:
	static	MenuHandle		fgMenu;
	static	unsigned long	fgWindowTitleCount;

	Boolean					fCanAcceptDrag;
	PicHandle				fDraggedPicHandle;
	Boolean					fIsWindowHighlighted;
};

#endif
