/*
	File:		Preferences.h

	Contains:	Application-specific preferences format.
				
	Written by: Dave Falkenburg

	Copyright:	 1993-94 by Dave Falkenburg, all rights reserved.

	Change History (most recent first):
	 
 */

#ifndef	_PREFERENCES_
#define	_PREFERENCES_

#define	kCurrentPrefsTag		'drf '
#define	kCurrentPrefsVersion	0

#define	kPrefResType			'pref'
#define	kPrefsResID				0


#ifndef	__OCESTANDARDMAIL__
#include <OCEStandardMail.h>
#endif

//	AOCE-specific preferences.
//	TMailableWindow makes use of this structure, and it must be accessible
//	via gPreferences.fMailPreferences

typedef struct MailPreferences	MailPreferences;
struct MailPreferences
	{
	SMPCloseOptions fSMPCloseOptions;
	SMPSendOptions	fSMPSendOptions;
	SMPSendFormat	fSMPSendFormat;
	Boolean			fCreateMailerForNewDocuments;
	Boolean			fExpandMailerForNewLetter;
	Boolean			fExpandMailerForOpenedLetter;
	Boolean			fUseCloseOptionsDialog;
	Boolean			fCloseLetterAfterSend;
	};


//	Application specific preferences structure.
//	NOTE: gPreferences.fMailPreferences is required to exist if MailableWindows are used

typedef struct AppPreferences	AppPreferences;
struct AppPreferences
	{
	OSType				fPreferencesTag;
	unsigned long		fPreferencesVersion;
	
	MailPreferences		fMailPreferences;		//	required if MailableWindow is used
	};

extern AppPreferences	gPreferences;

#endif
