/*
	File:		TextWindow.cp

	Contains:	A window designed to hold some TEXT no scroll bars...
	Written by: Dave Mark
	Copyright:	1995 by Dave Mark, all rights reserved.
 */

#ifndef		_TEXTWINDOW_
#define		_TEXTWINDOW_

#ifndef		_WINDOW_
#include	"Window.h"
#endif
	
enum
{
	mText				= 1002,
	cFont				= 1004,
	cSize				= 1005,
	cStyle				= 1006
};


class	TTextWindow : public TWindow
{
  public:
							TTextWindow();
	virtual 				~TTextWindow();

	virtual WindowPtr		MakeNewWindow( WindowPtr behindWindow );

	virtual void			Draw(void);
	
	virtual void			Activate( Boolean activating );
	
	virtual void			Click( EventRecord * anEvent );
	
	virtual void			ClickAndDrag( EventRecord *eventPtr );
	
	virtual	OSErr			DragEnterWindow( DragReference dragRef );
	virtual	OSErr			DragInWindow( DragReference dragRef );
	virtual	OSErr			DragLeaveWindow( DragReference dragRef );
	virtual	OSErr			HandleDrop( DragReference dragRef );
	
//	Non-TWindow methods...
	virtual void			SetTextFont( short newFont );
	virtual Boolean			IsTextFlavorAvailable( DragReference dragRef );
	virtual Boolean			IsMouseInContentRgn( DragReference dragRef );
	static void				SetUpStaticMenu( void );

protected:
	static	MenuHandle		fgMenu;
	static	unsigned long	fgWindowTitleCount;

	Boolean					fCanAcceptDrag;
	Handle					fDraggedTextHandle;
	Boolean					fIsWindowHighlighted;
};

#endif
