/*
	File:		TextWindow.cp

	Contains:	A window designed to hold some TEXT no scroll bars...
	Written by: Dave Mark
	Copyright:	1995 by Dave Mark, all rights reserved.
 */

#ifndef		_TEXTWINDOW_
#define		_TEXTWINDOW_

#ifndef		_WINDOW_
#include	"Window.h"
#endif
	
enum
{
	mText				= 1002,
	cFont				= 1004,
	cSize				= 1005,
	cStyle				= 1006,
	
	mTextFont			= 131,
	
	mTextFontSize		= 132,
	cFontSize9			= 1007,
	cFontSize10			= 1008,
	cFontSize12			= 1009,
	cFontSize18			= 1010,
	cFontSize24			= 1011,
	cFontSize36			= 1012,
	cFontSizeLarger		= 1013,
	cFontSizeSmaller	= 1014,
	cFontSizeOther		= 1015,
	
	mTextFontStyle		= 133,
	cFontStylePlain		= 1016,
	cFontStyleBold		= 1017,
	cFontStyleItalic	= 1018,
	cFontStyleUnderline	= 1019,
	cFontStyleOutline	= 1020,
	cFontStyleShadow	= 1021
};


class	TTextWindow : public TWindow
{
  public:
							TTextWindow();
	virtual 				~TTextWindow();

	virtual WindowPtr		MakeNewWindow( WindowPtr behindWindow );

	virtual void			Draw(void);
	
	virtual void			Activate( Boolean activating );
	
	virtual void			Click( EventRecord * anEvent );

	virtual void			AdjustMenusBeforeMenuSelection( void );
	virtual Boolean			DoMenuCommand( unsigned long menuCommand );
	
	virtual void			ClickAndDrag( EventRecord *eventPtr );
	
	virtual	OSErr			DragEnterWindow( DragReference dragRef );
	virtual	OSErr			DragInWindow( DragReference dragRef );
	virtual	OSErr			DragLeaveWindow( DragReference dragRef );
	virtual	OSErr			HandleDrop( DragReference dragRef );
	
//	Non-TWindow methods...
	virtual void			AdjustSizeMenu( void );	
	virtual void			SetNewTextSize( short newSize );
	
	virtual void			AdjustStyleMenu( void );
	virtual void			DoStyleCommand( unsigned long menuCommand );
	
	virtual Boolean			IsTextFlavorAvailable( DragReference dragRef );
	virtual Boolean			IsMouseInContentRgn( DragReference dragRef );
	static void				SetUpStaticMenu( void );

protected:
	static	MenuHandle		fgMenu;
	static	MenuHandle		fgFontSubMenu;
	static	MenuHandle		fgSizeSubMenu;
	static	MenuHandle		fgStyleSubMenu;
	
	static	unsigned long	fgWindowTitleCount;

	Boolean					fCanAcceptDrag;
	Handle					fDraggedTextHandle;
	Boolean					fIsWindowHighlighted;
	
	short					fCurrentFontSize;
	short					fCurrentFontStyle;
};

#endif
