/*
	File:		Link.h

	Contains:	An individual link from a linked list
	Written by: Dave Mark
	Copyright:	 1994 by Dave Mark, all rights reserved.
 */

#ifndef		_LINK_
#define		_LINK_


#include <types.h>


const short kLink_BadLinkErr = -1;


class	TLink
{
  public:
					TLink( void *objectPtr );
	virtual 		~TLink();
	virtual void	SetPrevLink( TLink *prevLinkPtr )
						{ fPrevLinkPtr = prevLinkPtr; }
	virtual void	SetNextLink( TLink *nextLinkPtr )
						{ fNextLinkPtr = nextLinkPtr; }
	virtual TLink	*GetPrevLink()
						{ return fPrevLinkPtr; }
	virtual TLink	*GetNextLink()
						{ return fNextLinkPtr; }
	virtual void	*GetObjectPtr()
						{ return fObjectPtr; }

  protected:
  	TLink			*fPrevLinkPtr;
  	TLink			*fNextLinkPtr;
  	void			*fObjectPtr;
};

#endif
