/**********************************************************************/
/*                              Responder                             */
/* Written by John O'Fallon                                           */
/* Placed in the public domain by Maxum Development Corp.             */
/*                                                                    */
/* Responder is a MacHTTP cgi application that is intended to be used */
/* as a shell for your own cgi applications.  I made it do something  */
/* real so that it will serve as an example for full cgi apps.        */
/*                                                                    */
/* This program was originally developed in Metrowerks CodeWarrior 5. */
/* CW 5 is the only environment I have tried compiling the program in.*/
/*                                                                    */
/*                          REVISION HISTORY                          */
/* 1.0b1 01/27/95 Initial clean release                               */
/*                                                                    */
/**********************************************************************/

// INCLUDES
#include <AppleEvents.h>

// DEFINES
#define NIL 0L
#define APPLE_EVENT_CLASS 'WWW'
#define APPLE_EVENT_ID 'sdoc'
#define MENU_DEF_APPLE 128
#define MENU_DEF_FILE 129
#define ITEM_DEF_QUIT 1
#define BUFFER_SIZE 32768
#define DELIM_STRING ""
#define DELIM_CHAR ''

// FUNCTION DECLARATIONS (See Procedure Headers for information on what each proc does)
void main ();
void HandleKeyDown (int, int);
void HandleMouseDown (Point);
void HandleMenuChoice (long);
void InstallAllEvents ();
pascal OSErr HandOpenApp (AppleEvent *TheRequest, AppleEvent *TheReply, long Reference);
pascal OSErr HandOpenDoc (AppleEvent *TheRequest, AppleEvent *TheReply, long Reference);
pascal OSErr HandPrintDoc (AppleEvent *TheRequest, AppleEvent *TheReply, long Reference);
pascal OSErr HandQuitApp (AppleEvent *TheRequest, AppleEvent *TheReply, long Reference);
pascal OSErr HandClientRequest (AppleEvent *TheRequest, AppleEvent *TheReply, long Reference);
void StatusSetUp ();
void UpdateScreen ();
void AboutBox ();
void ReplaceSpecialChars (char *);
int GetFieldData (char *, char *, int, char *);
void ProcessPOST ();

// GLOBAL VARIABLES
int QuitApp;					// Boolean for "Should we quit"?
MenuHandle MenuApple;			// Handle to the Apple Menu (for finding DA names)
WindowPtr MyWindow;				// Handle to our window
WindowRecord MyWindArea;		// A window record for the status screen
PicHandle MyPic;				// A handle to the window background PICT
char PostArg_AEVT[10];			// The AppleEvent Class and ID
char *PostArg_Post;				// The POST arguement
Handle PostArg_PostHand;		// Also allocate a handle, because POSTs can be BIG
char PostArg_Direct[256];		// The Direct Arguement 
char PostArg_Search[256];		// Arguments to the URL after a ?
char PostArg_Method[256];		// GET, POST, etc. Used to tell if post_args are valid
char PostArg_Address[256];		// The client address 
char PostArg_EMail[256];		// non-standard. e-mail address of remote user
char PostArg_Username[256];		// Authenticated user name
char PostArg_Password[256];		// Authenticated password
char PostArg_ServerName[256];	// Name or IP address of this server
char PostArg_ServerPort[256];	// TCP/IP port number being used by this server
char PostArg_ScriptName[256];	// URL name of this script
char PostArg_Referer[256];		// The URL of the page referencing this document
char PostArg_Client[256];		// the name and version of the WWW client software being used 
char PostArg_ContentType[256];	// MIME content type of post_args
char PostArg_ActName[256];
char PostArg_ActPath[256];
char PostArg_IPAddress[256];
char PostArg_FullReq[2048];
char *PostArg_Response;			// The response buffer
Handle PostArg_ResponseHand;	// Also allocate a handle, because the response can be BIG


/****************************************************************/
/* MAIN sets up the environment and executes the event loop.	*/
/****************************************************************/

void main ()
{
OSErr MyErr;
Handle MenuBar;								
MenuHandle MenuFile;
EventRecord Action;

QuitApp=FALSE;								// Initialize our 'quit' global
InitGraf(&qd.thePort);						// Now do all the right Mac things (See Inside Mac)
InitFonts();
FlushEvents(everyEvent,0);
InitWindows();
InitMenus();
TEInit();
InitDialogs(NIL);
InitCursor();
MenuBar = GetNewMBar (MENU_DEF_APPLE);		// Menu Bar set-up, see Inside Mac for details
SetMenuBar (MenuBar);
MenuApple = GetMHandle (MENU_DEF_APPLE);
MenuFile = GetMenu (MENU_DEF_FILE);
AddResMenu (MenuApple, 'DRVR');	
DrawMenuBar ();
InstallAllEvents ();						// Let the Event Manager know we want AppleEvents
StatusSetUp ();
PostArg_PostHand = NewHandle (BUFFER_SIZE);	// Set aside room for our big POST arguement
PostArg_ResponseHand = NewHandle (BUFFER_SIZE);	// Set aside room for our big response

while (QuitApp==FALSE) {					// Go through the event loop as long as we aren't supposed to quit
	WaitNextEvent (everyEvent, &Action, 0L, 0L);	// Ask the OS for an event
	switch (Action.what) {
		case mouseDown:						// They clicked the mouse...
			HandleMouseDown (Action.where);
			break;
		case keyDown:						// They pressed a key...
			HandleKeyDown ((int)Action.message,(int)Action.modifiers);
			break;
		case updateEvt:						// Our window needs to be re-painted...
			if ((WindowPtr)Action.message == MyWindow) {
				BeginUpdate (MyWindow);
				UpdateScreen ();
				EndUpdate (MyWindow);
				}
			break;
		case kHighLevelEvent:				// We have an AppleEvent... so let the OS...
			*(long *)PostArg_AEVT = Action.message;
			*(Point *)(PostArg_AEVT + 4) = Action.where;
			PostArg_AEVT[8] = '\0';
			MyErr = AEProcessAppleEvent (&Action);	// dispatch it (see Inside Mac).
			if (MyErr != noErr) {
				SysBeep (2);				// Well behaved apps would do more than beep!
				}
			break;
		}
	}
}


/****************************************************************/
/* When a key is pressed, this routine processes it.			*/
/****************************************************************/

void HandleKeyDown (int KeyPress, int Modifiers)
{
char Key;
int Modifier;
long int MenuChoice;

Key = KeyPress & charCodeMask;
Modifier = Modifiers & cmdKey;

if (Modifier > 0) {					// We pay attention only to Command keys.
	MenuChoice = MenuKey (Key);		// If the user hit a shortcut key,
	HandleMenuChoice (MenuChoice);	// see if there's a menu option to execute.
	}
}


/****************************************************************/
/* When the mouse button gets pressed, this routine handles it.	*/
/****************************************************************/

void HandleMouseDown (Point Where)
{
WindowPtr WhichWind;
short int WhichPart;
long int MenuChoice;
Rect DragRect;			// Used to define dragable area for our window

WhichPart = FindWindow (Where, &WhichWind);	// Find out where they clicked
switch (WhichPart) {
	case inMenuBar:							// clicking in the menu bar is interesting...
		MenuChoice = MenuSelect (Where);	// tell the OS to handle it
		HandleMenuChoice (MenuChoice);		// and process any option they may have chosen
		break;
	case inDrag:
		DragRect.top = -32767;				// set-up the drag area
		DragRect.bottom = 32767;
		DragRect.left = -32767;
		DragRect.right = 32767;
		DragWindow ( WhichWind, Where, &DragRect );		// let the OS do the dragging
		break;
	}
}


/****************************************************************/
/* When the user selects a menu option, either by mouse or 		*/
/* shortcut key, this routine handles it.				 		*/
/****************************************************************/

void HandleMenuChoice (long MenuChoice)
{
int TheMenu;
int TheItem;
Str255 DAName;
int DANumber;

if (MenuChoice != 0) {					// Ignore NULL selections
	TheMenu = HiWord (MenuChoice);		// find the menu number
	TheItem = LoWord (MenuChoice);		// find the item number
	switch (TheMenu) {
		case MENU_DEF_APPLE:			
			if (TheItem == 1) {
				AboutBox ();
				}
			else {
				GetItem (MenuApple,TheItem,DAName);
				DANumber = OpenDeskAcc (DAName);
				}
			break;
		case MENU_DEF_FILE:
			switch (TheItem) {
				case ITEM_DEF_QUIT:
					QuitApp=TRUE;
					break;
				}
			break;
		}
	HiliteMenu (0);
	}
}


/****************************************************************/
/* INSTALLALLEVENTS registers the event handlers with the Event	*/
/* Manager.														*/
/****************************************************************/

void InstallAllEvents ()
{
OSErr MyErr;
AEEventHandlerUPP MyUPP;
											// get the Universal Proc Pointer (required for PPC calls)
MyUPP = NewAEEventHandlerProc(HandOpenApp);	// and install the handler
MyErr = AEInstallEventHandler (kCoreEventClass,kAEOpenApplication,MyUPP,0,FALSE);
MyUPP = NewAEEventHandlerProc(HandOpenDoc);
MyErr = AEInstallEventHandler (kCoreEventClass,kAEOpenDocuments,MyUPP,0,FALSE);
MyUPP = NewAEEventHandlerProc(HandPrintDoc);
MyErr = AEInstallEventHandler (kCoreEventClass,kAEPrintDocuments,MyUPP,0,FALSE);
MyUPP = NewAEEventHandlerProc(HandQuitApp);
MyErr = AEInstallEventHandler (kCoreEventClass,kAEQuitApplication,MyUPP,0,FALSE);
MyUPP = NewAEEventHandlerProc(HandClientRequest);
MyErr = AEInstallEventHandler (APPLE_EVENT_CLASS,APPLE_EVENT_ID,MyUPP,0,FALSE);
if (MyErr != noErr) {
	SysBeep (2);				// Well behaved apps would do more than beep!
	}
}


/**************************************************************/
/* APPLE EVENT ROUTINES: Handlers, Installers, and Processors */
/**************************************************************/

pascal OSErr HandOpenApp (AppleEvent *TheRequest, AppleEvent *TheReply, long Reference)
{
UpdateScreen ();

return (noErr);
}

pascal OSErr HandOpenDoc (AppleEvent *TheRequest, AppleEvent *TheReply, long Reference)
{
UpdateScreen ();

return (noErr);
}

pascal OSErr HandPrintDoc (AppleEvent *TheRequest, AppleEvent *TheReply, long Reference)
{
UpdateScreen ();

return (noErr);
}

pascal OSErr HandQuitApp (AppleEvent *TheRequest, AppleEvent *TheReply, long Reference)
{
UpdateScreen ();
QuitApp = TRUE;

return (noErr);
}


/****************************************************************/
/* HANDLECLIENTREQUEST is the routine that gets activated by	*/
/* the AppleEvent coming from MacHTTP.  It reads the arguments	*/
/* from the Event into buffers and calls the processing proc.	*/
/****************************************************************/

pascal OSErr HandClientRequest (AppleEvent *TheRequest, AppleEvent *TheReply, long Reference)
{
OSErr MyErr;
DescType ReqType;
Size ReqSize;

HLock (PostArg_PostHand);		// First, lock down our POST memory
PostArg_Post = *(char **)PostArg_PostHand;	// And assign the pointer
HLock (PostArg_ResponseHand);		// Also, lock down our response memory
PostArg_Response = *(char **)PostArg_ResponseHand;

			// '----' - direct parameter : post_args - arguments to the URL after a $
MyErr=AEGetParamPtr (TheRequest,'----',typeChar,&ReqType,(Ptr)PostArg_Direct,1024,&ReqSize);
PostArg_Direct[ReqSize] = '\0';
			// 'addr' - client address   : client_address - IP address or domain name of remote client's host
MyErr=AEGetParamPtr (TheRequest,'addr',typeChar,&ReqType,(Ptr)PostArg_Address,256,&ReqSize);
PostArg_Address[ReqSize] = '\0';
			// 'Agnt' - user agent       : user_agent - the name and version of the WWW client software being used
MyErr=AEGetParamPtr (TheRequest,'Agnt',typeChar,&ReqType,(Ptr)PostArg_Client,256,&ReqSize);
PostArg_Client[ReqSize] = '\0';
			// 'post' - post arguments
MyErr=AEGetParamPtr (TheRequest,'post',typeChar,&ReqType,(Ptr)PostArg_Post,BUFFER_SIZE,&ReqSize);
PostArg_Post[ReqSize] = '\0';
			// 'kfor' - search arguments : http_search_args - arguments to the URL after a ?
MyErr=AEGetParamPtr (TheRequest,'kfor',typeChar,&ReqType,(Ptr)PostArg_Search,256,&ReqSize);
PostArg_Search[ReqSize] = '\0';
			// 'meth' - HTTP method      : method - GET, POST, etc. Used to tell if post_args are valid
MyErr=AEGetParamPtr (TheRequest,'meth',typeChar,&ReqType,(Ptr)PostArg_Method,256,&ReqSize);
PostArg_Method[ReqSize] = '\0';
			// 'frmu' - from user        : from_user - non-standard. e-mail address of remote user
MyErr=AEGetParamPtr (TheRequest,'frmu',typeChar,&ReqType,(Ptr)PostArg_EMail,256,&ReqSize);
PostArg_EMail[ReqSize] = '\0';
			// 'user' - user name        : username - authenticated user name
MyErr=AEGetParamPtr (TheRequest,'user',typeChar,&ReqType,(Ptr)PostArg_Username,256,&ReqSize);
PostArg_Username[ReqSize] = '\0';
			// 'pass' - password         : password - authenticated password
MyErr=AEGetParamPtr (TheRequest,'pass',typeChar,&ReqType,(Ptr)PostArg_Password,256,&ReqSize);
PostArg_Password[ReqSize] = '\0';
			// 'svnm' - server name      : server_name - name or IP address of this server
MyErr=AEGetParamPtr (TheRequest,'svnm',typeChar,&ReqType,(Ptr)PostArg_ServerName,256,&ReqSize);
PostArg_ServerName[ReqSize] = '\0';
			// 'svpt' - server port      : server_port - TCP/IP port number being used by this server
MyErr=AEGetParamPtr (TheRequest,'svpt',typeChar,&ReqType,(Ptr)PostArg_ServerPort,256,&ReqSize);
PostArg_ServerPort[ReqSize] = '\0';
			// 'scnm' - script name      : script_name - URL name of this script
MyErr=AEGetParamPtr (TheRequest,'scnm',typeChar,&ReqType,(Ptr)PostArg_ScriptName,256,&ReqSize);
PostArg_ScriptName[ReqSize] = '\0';
			// 'refr' - referer          : referer - the URL of the page referencing this document
MyErr=AEGetParamPtr (TheRequest,'refr',typeChar,&ReqType,(Ptr)PostArg_Referer,256,&ReqSize);
PostArg_Referer[ReqSize] = '\0';
			// 'ctyp' - content type     : content_type - MIME content type of post_args
MyErr=AEGetParamPtr (TheRequest,'ctyp',typeChar,&ReqType,(Ptr)PostArg_ContentType,256,&ReqSize);
PostArg_ContentType[ReqSize] = '\0';
			// 'Kact' - Action Name      : Action Name
MyErr=AEGetParamPtr (TheRequest,'Kact',typeChar,&ReqType,(Ptr)PostArg_ActName,256,&ReqSize);
PostArg_ActName[ReqSize] = '\0';
			// 'Kapt' - Action Path      : Action Path
MyErr=AEGetParamPtr (TheRequest,'Kapt',typeChar,&ReqType,(Ptr)PostArg_ActPath,256,&ReqSize);
PostArg_ActPath[ReqSize] = '\0';
			// 'Kcip' - Client IP Address: Client IP Address
MyErr=AEGetParamPtr (TheRequest,'Kcip',typeChar,&ReqType,(Ptr)PostArg_IPAddress,256,&ReqSize);
PostArg_IPAddress[ReqSize] = '\0';
			// 'Kfrq' - Full CLient Req  : Full Client Request
MyErr=AEGetParamPtr (TheRequest,'Kfrq',typeChar,&ReqType,(Ptr)PostArg_FullReq,2047,&ReqSize);
PostArg_FullReq[ReqSize] = '\0';
               
if (!MyErr) {
	ProcessPOST ();
	ReqSize = 0;							// Count the number of chars in the response string
	while ((PostArg_Response[ReqSize] != '\0') && (ReqSize < BUFFER_SIZE)) ReqSize++;
	MyErr=AEPutParamPtr (TheReply,keyDirectObject,typeChar,(Ptr)PostArg_Response,ReqSize);
	}
else {
	SysBeep (2);				// Well behaved apps would do more than beep!
	}
UpdateScreen ();
HUnlock (PostArg_PostHand);
HUnlock (PostArg_ResponseHand);

return (MyErr);
}


/****************************************************************/
/* STATUSSETUP creates our status window and paints the			*/
/* background.													*/
/****************************************************************/

void StatusSetUp ()
{
Rect WindowRect;
Rect PicRect;

WindowRect.top=40;
WindowRect.bottom=178;
WindowRect.left=20;
WindowRect.right=322;
MyWindow=NewWindow(&MyWindArea,&WindowRect,"\pResponder",TRUE,(int)0,(WindowPtr)(-1),FALSE,(long)5);
ShowWindow(MyWindow);				// Open and Show a status window
SetPort (MyWindow);

MyPic = GetPicture (128);			// Load the background of the window from a PICT resource
if (MyPic != 0) {					// Make sure we got it
	PicRect = (*MyPic)->picFrame;	// size the rect
	DrawPicture (MyPic, &PicRect);	// and display it
	}
}


/****************************************************************/
/* UPDATESCREEN updates each field on the status screen.		*/
/****************************************************************/

void UpdateScreen ()
{
Rect PicRect;

if (MyPic != 0) {					// As long as we still have a hold of the PICT
	PicRect = (*MyPic)->picFrame;	// get it's rect
	DrawPicture (MyPic, &PicRect);	// and display it
	}
}


/******************************************************/
/* ABOUTBOX - Displays a window with the about        */
/*		box as a PICT resource, this proc             */
/*		automatically displays a centered window with */
/*		the PICT in it and waits for the user to 	  */
/*		click the mouse button.						  */
/******************************************************/

void AboutBox ()
{
Rect WindowRect;
int Continue;
EventRecord Action;
PicHandle MyPic;
Rect PicRect;
int Height,Width;
WindowPtr DLGWindow;
WindowRecord DLGWindArea;

MyPic = GetPicture (129);
if (MyPic != 0) {
	PicRect = (*MyPic)->picFrame;
	Height = PicRect.bottom - PicRect.top;
	Width = PicRect.right - PicRect.left;
	WindowRect.top=qd.screenBits.bounds.top + ((qd.screenBits.bounds.bottom - qd.screenBits.bounds.top) / 2) - (Height / 2);
	WindowRect.bottom=WindowRect.top + Height;
	WindowRect.left=qd.screenBits.bounds.left + ((qd.screenBits.bounds.right - qd.screenBits.bounds.left) / 2) - (Width / 2);
	WindowRect.right=WindowRect.left + Width;
	DLGWindow=NewWindow(&DLGWindArea,&WindowRect,"\pAbout",false,2,(WindowPtr)(-1),false,5);
	SetPort (DLGWindow);
	SetRect (&PicRect,0,0,Width,Height);
	ShowWindow(DLGWindow);
	Continue=FALSE;
	while (Continue==FALSE) {
		WaitNextEvent (everyEvent, &Action, 0L, 0L);
		switch (Action.what) {
			case mouseDown:
				Continue = TRUE;
				break;
			case keyDown:
				Continue = TRUE;
				break;
			case updateEvt:
				if ((WindowPtr)Action.message == DLGWindow) {
					BeginUpdate (DLGWindow);
					DrawPicture (MyPic, &PicRect);
					EndUpdate (DLGWindow);
					}
				break;
			}
		}
	CloseWindow (DLGWindow);
	SetPort (MyWindow);
	ReleaseResource((Handle)MyPic);
	UpdateScreen ();
	}
}


/****************************************************************/
/* REPLACESPECIALCHARS replaces instances of percent signs (%)	*/
/* followed by an ASCII char value with the actual character.	*/
/****************************************************************/

void ReplaceSpecialChars (char *TheText)
{
int i;
int j;
int AsciiChar;

i = 0;
j = 0;
while (TheText[i] != '\0') {					// Search the entire text block
	switch (TheText[i]) {
		case '%':								// if the char is a percent sign, look at the next char
			if ((TheText[i+1] >= 'A') && (TheText[i+1] <= 'F')) {
				AsciiChar = TheText[i+1] - 'A' + 10;		// convert A thru F to 10 thru 15
				}
			else {
				AsciiChar = TheText[i+1] - '0';				// Convert all others to 0 to 9
				}
			AsciiChar = AsciiChar * 16;						// That was the high order of a hex number, so mult by 16 to find the decimal value.
															// Now do the low order char...
			if ((TheText[i+2] >= 'A') && (TheText[i+2] <= 'F')) {
				AsciiChar += (TheText[i+2] - 'A' + 10);		// Convert A thru F to 10 thru 15 (and add it to the high order value)
				}
			else {
				AsciiChar += (TheText[i+2] - '0');			// Convert all others to 0 to 9 (and add it to the high order value)
				}
			if ((AsciiChar >= 0) && (AsciiChar < 256)) {	// if we got a valid value, replace the ASCII char
				if (AsciiChar == 10) {
					j--;
					}
				else {
					TheText[j] = AsciiChar;					// Copy the char into the string
					}
				i += 2;							// Now that we have converted them, skip the extra characters
				}
			else {
				TheText[j] = TheText[i];		// False alarm, nothing to convert, just copy the char (shouldn't happen)
				}
			break;
		case '+':
			TheText[j] = ' ';					// Spaces are coded as plus signs
			break;
		case '&':
			TheText[j] = DELIM_CHAR;			// Replace the default delimiter with something more uncommon
			break;
		case 10:
			j--;								// Strip out linefeeds, Macs don't use them
			break;
		default:
			TheText[j] = TheText[i];			// A normal character, just copy it
			break;
		}		
	i++;
	j++;
	}
TheText[j] = '\0';										// make sure the string is capped
}


/****************************************************************/
/* GETFIELDDATA searches PostArg_Post for the specified field	*/
/* name and returns the text entered by the user.           	*/
/****************************************************************/

int GetFieldData (char *PostString, char *FieldName, int MaxLength, char *TextBuff)
{
int i,StrLen,Found,Position;

StrLen = 0;											// First, find out how long the field name is
while (FieldName[StrLen] != '\0') StrLen++;
Found = FALSE;										// Assume we haven't found anything
Position = 0;
while ((Found == FALSE) && (PostString[Position] != '\0')) {	// look til we find something or we hit the end
	Found = TRUE;												// We can hope, can't we?
	for (i = 0 ; i < StrLen ; i++)								// if any character at all doesn't match
		if (PostString[Position+i] != FieldName[i]) {
			Found = FALSE;										// then no deal, and stop trying
			i = StrLen;
			}
	Position++;
	}
if (Found) {										// OK... Great... We found our field
	Position += (i - 1);							// Start looking for the delimitting '='
	while (PostString[Position] != '=') Position++;	// This probably isn't necessary, but I'm paranoid, so we'll be robust
	Position++;										// Skip over the '='
	i = 0;											// Almost done, just copy the string
	while ((PostString[Position+i] != '\0') && (PostString[Position+i] != DELIM_CHAR) && (i < MaxLength)) {
		TextBuff[i] = PostString[Position+i];		// Copy the user entered text into the buffer
		i++;
		}
	TextBuff[i] = '\0';								// Cap the C string
	return (TRUE);
	}
else {
	return (FALSE);
	}
}


//================================================================================//
//   ABOVE THIS POINT IS THE RELATIVELY STATIC CODE MOST CGI APPLICATIONS NEED.   //
//        BELOW THIS POINT ARE THE PROCEDURES THAT ACTUALLY DO THE CGI JOB        //
//================================================================================//


/****************************************************************/
/* PROCESSPOST is where your process starts.  All the POSTARG	*/
/* global variables have been filled in for you and you are		*/
/* ready to go!  Use the Global 'PostArg' variables for your	*/
/* input and put your html response into 'PostArg_Response'.	*/
/****************************************************************/

void ProcessPOST ()
{
char Field1[1024];
char Field2[1024];
char Field3[1024];

ReplaceSpecialChars (PostArg_Post);						// Replace plus signs (+), ampersands (&), and special characters
GetFieldData (PostArg_Post, "Field1", 1024, Field1);	// Load the data entered by the user in the form into strings
GetFieldData (PostArg_Post, "Field2", 1024, Field2);
GetFieldData (PostArg_Post, "Field3", 1024, Field3);

														// All this app does is generate an HTML string and send it back
sprintf (PostArg_Response,"<HTML><TITLE>CGI RESPONSE</TITLE><BODY><H1>CGI Response</H1>Apple Event: %s<BR>Field 1: %s<BR>Field 2: %s<BR>Field 3: %s<BR>Direct: %s<BR>Search: %s<BR>Method: %s<BR>Address: %s<BR>e-mail: %s<BR>User Name: %s<BR>Password: %s<BR>Server Name: %s<BR>Server Port: %s<BR>Script Name: %s<BR>Referee: %s<BR>Browser: %s<BR>Content Type: %s<BR>Action Name: %s<BR>Action Path: %s<BR>Client IP Address: %s<BR>Full Client Request: %s<P>Thanks for using Responder!</HTML>",
	PostArg_AEVT, Field1, Field2, Field3, PostArg_Direct, PostArg_Search, PostArg_Method,
	PostArg_Address, PostArg_EMail, PostArg_Username, PostArg_Password,
	PostArg_ServerName, PostArg_ServerPort, PostArg_ScriptName, PostArg_Referer,
	PostArg_Client, PostArg_ContentType,PostArg_ActName,PostArg_ActPath,PostArg_IPAddress,
	PostArg_FullReq);
}


