/*
*	TRunOSA.h
*
*	Declaration for 'TRunOSA', a C++
*	class to manipulate AppleScripts
*
*	azn@nemeng.mpx.com.au
*
*	 Andrew Nemeth  Warrimoo  Australia  1995
*/

#pragma once

class  TRunOSA
{
	private:
		static 		ComponentInstance	scriptComponent;
	
	public:
		TRunOSA ();
		~TRunOSA ();
	
		OSAError		initOSA ( void );
		OSAError		initOSA ( const FSSpec & );
	
		OSAError		runScript ( void );
		OSAError		runScript ( const AEEventClass, const AEEventID );
		OSAError		runScript ( const AEEventClass, const AEEventID, Str255 );
	
		OSAError		getResultDesc ( AEDesc *, long * );
	
	private:
		AEDesc			f_aedescScript;
		OSAID			f_osaidOriginal,
						f_osaidResult;
	
		OSAError		myInitOSA ( Handle );
		OSAError		myRunScript ( const AEEventClass, const AEEventID, AEDesc * );
	
	private:
		TRunOSA ( const TRunOSA & );
		TRunOSA  		&  operator= ( const TRunOSA & );
};
	

inline OSAError	TRunOSA::runScript ( const AEEventClass aeclassSuite, 
									const AEEventID aesuiteKind )
{
	return( myRunScript ( aeclassSuite, aesuiteKind, NULL ) );
}

