
/*==========================================================================

								StartupStub.c
		
		This file contains compiles into a small emergency stub with
		just enough of the initialization code to be able to put up a
		warning alert saying that rest of the 68K code has been stripped
		from the application and you're trying to run it on a 680x0
		Macintosh.
		
		After building the project that this file is part of, copy the two
		CODE resources in the resulting file into "SlimApp.rsrc" while
		changing their types to 'CoDe'.  Also copy the 'DATA' resource
		changing its type to 'DaTa'.
		
		Copyright 1995 by Blake Ward.

		Permission granted for unrestricted use provided credit is given to
		the author. 
		
  ==========================================================================*/

// The alert resource ID (Note that the alert is actually
// stored in SlimApp.rsrc
#define kNo68KCodeErrorDialog			9998


/*============================================================================
  Main Program:

   When run on a 680x0 Macintosh, this routine simply puts up a warning
   dialog and then exits to the Finder.
 
  ============================================================================*/
void
main(void)
{

	// Initialize Toolbox Managers so we can get the alert up
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);
	InitCursor();
		
	// Warn the user that this version of the application only runs on a
	// Power Macintosh.  You can customize this alert to list a phone number
	// for your company so that the user can inquire about getting a new
	// unstripped copy of the application.
	StopAlert(kNo68KCodeErrorDialog, 0L);

}





