/******************************************************************************
 x_CMain.cp

				CMain Document Class
	
	Copyright  1995 My Software Inc. All rights reserved.

	Generated by Visual Architect 4:55 PM Tue, Sep 26, 1995

	This file is rewritten each time you generate code. You should not
	make changes to this file; changes should go in the My.cp
	file, instead.

	If you want to change how Visual Architect generates this file, you can
	change the template for this file. It is "_Doc_cp" in the Visual Architect
	Templates folder.

 ******************************************************************************/

#include "x_CMain.h"

#include "CMain.h"

#include "MainItems.h"

#include "ViewUtilities.h"
#include "CBeeperDialog.h"
#include "CApp.h"

#include <CApplication.h>
#include <CBartender.h>
#include <Commands.h>
#include <Constants.h>
#include <CDecorator.h>
#include <CDesktop.h>
#include <CFile.h>
#include <TBUtilities.h>
#include <CWindow.h>

extern	CApplication *gApplication;		/* The application					*/
extern CDecorator	*gDecorator;		/* Decorator for arranging windows	*/
extern CDesktop		*gDesktop;			/* The visible Desktop				*/
extern CBartender	*gBartender;		/* Manages all menus				*/

#include "CPicture.h"
#include "CStaticText.h"
#include "CButton.h"

	// Define symbols for commands handled by this class
	// Prevents a recompile every time any command changed.

#define cmdBeeperDialog 513


TCL_DEFINE_CLASS_M1(x_CMain, x_CMain_super);

/**** C O N S T R U C T I O N / D E S T R U C T I O N   M E T H O D S ****/


/******************************************************************************
 Ix_CMain

	Initialize the document
 ******************************************************************************/

void x_CMain::Ix_CMain()

{
	IDocument(gApplication, TRUE);

		// Initialize data members below.
}


/******************************************************************************
 MakeNewWindow

	Create a new, empty window.  Subclass may override to populate
	the new window.
 ******************************************************************************/

void x_CMain::MakeNewWindow(void)

{
	itsWindow = TCLGetNamedWindow("\pMain", this);
	
	itsMainPane = (CPane*) TCLGetItemPointer(itsWindow, 0);

		// Initialize pointers to the subpanes in the window

  fMain_Pict1 = (CPicture*) itsWindow->FindViewByID(kMain_Pict1ID);
  ASSERT(member(fMain_Pict1, CPicture));

  fMain_Stat2 = (CStaticText*) itsWindow->FindViewByID(kMain_Stat2ID);
  ASSERT(member(fMain_Stat2, CStaticText));

  fMain_Butn5 = (CButton*) itsWindow->FindViewByID(kMain_Butn5ID);
  ASSERT(member(fMain_Butn5, CButton));

}


/******************************************************************************
 FailOpen {OVERRIDE}

		Fail if file already open in this application.
		
		This function calls the application's FileAlreadyOpen function
		and fails quietly if the file is open.

		Note that open may also fail if the file is open in
		another application. This will cause a failure in open,
		but you may wish to override this function to detect this
		case and provide a more meaningful error message than -49.
 ******************************************************************************/

void	x_CMain::FailOpen(FSSpec *spec)
{
										/* Only the application knows		*/
	if (((CApp*)gApplication)->FileAlreadyOpen(spec))
		Failure(kSilentErr, 0);
}


/******************************************************************************
 PositionWindow

	The default method in CSaver calls the the decorator, which
	staggers and resizes the window. Since the window has already
	been positioned when it is initialized from the view resource,
	we don't want to do this twice.
 ******************************************************************************/

void	x_CMain::PositionWindow()

{
}




/******************************************************************************
 DoCommand {OVERRIDE}

		Dispatch Visual Architect-specified actions.
 ******************************************************************************/

void x_CMain::DoCommand(long theCommand)

{
	switch (theCommand)
	{
		case cmdBeeperDialog:
			DoCmdBeeperDialog();
			break;
		default:
			CDocument::DoCommand(theCommand);
	}
}


/******************************************************************************
 UpdateMenus {OVERRIDE}

		Enable menus which generate commands handled by this class.
 ******************************************************************************/

void x_CMain::UpdateMenus()

{
	CDocument::UpdateMenus();
	gBartender->EnableCmd(cmdBeeperDialog);
}


/******************************************************************************
 DoCmdBeeperDialog

		Respond to cmdBeeperDialog command.
 ******************************************************************************/

void x_CMain::DoCmdBeeperDialog()

{
	CBeeperDialog		*alert;
	
  		// Respond to command by opening a alert

	alert = TCL_NEW(CBeeperDialog,());
	alert->ICBeeperDialog(this);

	alert->DoModalDialog(cmdNull);	/* cmdNull because dialog already knows	*/
	TCLForgetObject(alert);
}


