//==========================================================
//
//	File:				BeeperSel.h
//	Release Version:	$ 1.0d9 $
//
//	Author:				M.Boetcher
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//==========================================================

#ifndef BEEPERSEL_H
#define BEEPERSEL_H

// ----- FrameWork Includes -----

#ifndef FWSELECT_H
#include "FWSelect.h"
#endif

//==========================================================
//	Forward Declarations
//==========================================================

#if FW_LIB_EXPORT_PRAGMAS
#pragma import on
#endif
class FW_CLASS_ATTR FW_CCloneInfo;
#if FW_LIB_EXPORT_PRAGMAS
#pragma import off
#endif

class FW_CLASS_ATTR CBeeperPart;

//==========================================================
//	class CBeeperSelection
//==========================================================

class FW_CLASS_ATTR CBeeperSelection : public FW_CSelection
{
//----------------------------------------------------------
//	Initialization/Destruction
//
public:
	CBeeperSelection(Environment* ev,
					 CBeeperPart* beeperPart);
	virtual ~CBeeperSelection();
	
//----------------------------------------------------------
//	Inherited API
//
public:
	virtual void CloseSelection(Environment* ev);
	virtual FW_Boolean ClearSelection(Environment* ev, 
							FW_ClearSelection clearAfter);
	virtual FW_Boolean IsEmpty(Environment* ev) const;
	virtual void SelectAll(Environment* ev);

	virtual void DoExternalizeSelection(Environment* ev, 
							   ODStorageUnit* storage, 
							   FW_CCloneInfo* cloneInfo);

	virtual FW_Boolean DoInternalizeSelection(Environment* ev, 
							   ODStorageUnit* storage, 
							   FW_CCloneInfo* cloneInfo);
						
//----------------------------------------------------------
//	Data Members
//
private:
	CBeeperPart* fBeeperPart;
};

//==========================================================
//	CBeeperSelection Inlines
//==========================================================


#endif