//========================================================================================
//
//	File:				BeeperPart.r
//	Release Version:	$ 1.0d9 $
//
//	Author:				Henri Lamiraux
//
//	Copyright:	(c) 1993-95 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#include "Types.r"
#include "SysTypes.r"
#include "CodeFragmentTypes.r"

#ifndef __ODTYPES_R__
#include "ODTypes.r"
#endif

#ifndef BEEPERDEF_H
	#include "BeeperDef.h"
#endif

//-------------------------------------------------------------------------------------
// cfrg Resource
//-------------------------------------------------------------------------------------

resource 'cfrg' (0) {
	{	/* array memberArray: 2 elements */
		/* [1] */
#ifdef FW_BUILD_MAC68K
		kMotorola,
#else
		kPowerPC,
#endif
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		kODFBeeperEditor,
		/* [2] */
#ifdef FW_BUILD_MAC68K
		kMotorola,
#else
		kPowerPC,
#endif
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		"ODFBeeper"
	}
};

//-------------------------------------------------------------------------------------
// NMAP Resources
//-------------------------------------------------------------------------------------

resource kODNameMappings (kKindCategoryMapId) {
	kODKind,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFBeeperKind,
		kODIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kODFBeeperCategory
			}
		}
	}
};

resource kODNameMappings (kEditorKindMapId) {
	kODEditorKinds,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFBeeperEditor,
		kODIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kODFBeeperKind
			}
		}
	}
};

resource kODNameMappings (kEditorUserStringMapId) {
	kODEditorUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFBeeperEditor,
		kODIsINTLText
		{
			smRoman,
			langEnglish,
			kODFBeeperEditorUserString
		}
	}
};

resource kODNameMappings (kKindUserStringMapId) {
	kODKindUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFBeeperKind,
		kODIsINTLText
		{
			smRoman,
			langEnglish,
			kODFBeeperKindUserString
		}
	}
};

resource kODNameMappings (kCategoryUserStringMapId) {
	kODCategoryUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFBeeperCategory,
		kODIsINTLText
		{
			smRoman,
			langEnglish,
			kODFBeeperCategoryUserString
		}
	}
};

resource kODNameMappings (kOldMacOSTypeMapId) {
	kODKindOldMacOSType,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kODFBeeperKind,
		kODIsMacOSType {
			kODFBeeperOSType
		}
	}
};

//-------------------------------------------------------------------------------------
// Other Resources
//-------------------------------------------------------------------------------------

include "MacIcons.rsrc" not 'ckid';
