#pragma once
/*
*	AZN_TAELaunch.h
*
*	Class declaration for 'TAELaunch' class
*	A class to locate, launch and manipulate
*	processes & their associated files
*	HEIRARCHY:	BASE CLASS
*	( Based on Pascal code by Peter Lewis, [ peter@kagi.com ] )
*	( Converted to C++ by Gilles Dignard [ gdignard@hookup.net ] )
*	This version by Andrew Nemeth [ aznemeng@zeta.org.au ]
*
*	File Created:		21 Feb 95
*	File Ammended:		21 Feb;
*					4, 68, 13, 1419, 28 Mar;
*					18 Apr;
*					15 May 95.
*/


class TAELaunch
{
	public:

		static  OSErr		findApplication		( ConstStr63Param, OSType, FSSpecPtr );
		static  OSErr		findFile				( ConstStr63Param, OSType, OSType, FSSpecPtr );

		static  Boolean	openItemInFinder		( const FSSpec &, Boolean );
		static  Boolean	openDocInApp			( OSType, const FSSpec &, Boolean );
		
		static  Boolean	findProcess			( OSType, OSType, ProcessSerialNumber *, FSSpecPtr );

		static  Boolean	isFrontProcess			( OSType );
		static  void		makeCurrentProcessFront	( void );

		static  void		hideProcess			( OSType );
		static  void		showProcess			( OSType );
		static  void		killProcess			( OSType );

		static  Boolean	openControlPanel		( OSType );

	private:
//														static class, never instantiate!
		TAELaunch(){};
		~TAELaunch(){};
};
