#pragma once
/*
*	AZN_DBUG.H
*
*	Decl's for utility 'C' functions for debugging apps
*	 Andrew Nemeth, Warrimoo Australia, 1995
*	aznemeng@zeta.org.au
*
*	File Created:		6 Mar 95
*	File Ammended:		6, 7, 11, 12 Mar;
*					3 Jun;
*					7, 23 Oct 95.
*/

//														uncomment for RUNTIME version
//#define	NDEBUG


#ifdef	NDEBUG
//														all debug stuff become no-op's
	#define		ASSERT(f)					NULL

	#define		INIT_DEBUG()				NULL
	#define		SALT_MEMORY(a,b)			NULL
	#define		DEBUG_TRAP()				NULL
	#define		MY_DEBUG_FILESTRING( s )		NULL

#else

	void			myAlert					( char *, unsigned );
	#define		ASSERT(f)					if (f)		\
											NULL;	\
										else			\
											myAlert( __FILE__, __LINE__ )

	void			INIT_DEBUG				( void );
	void			SALT_MEMORY				( void *, long );

	#define		DEBUG_TRAP()				Debugger()

	void			myDBG_FileString			( char *, char *, unsigned );
	#define		MY_DEBUG_FILESTRING( s )		myDBG_FileString( s, __FILE__, __LINE__ )

#endif