/*
	File:		MovieShell.c

	Contains:	Simple test shell for testing Digitizers.

	Written by:	DTS

	Copyright:	 1994-1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

	   <1>	 	4/25/95	khs		first file
	   
*/


// INCLUDES
#include <stdio.h>

#ifdef __MWERKS__
#include <sioux.h>
#endif // __MWERKS__

#include "DTSQTUtilities.h"
#include "MacFramework.h"


// MAIN
// ______________________________________________________________________
void main(void)
{
	OSErr anErr = noErr;

// This is for controlling the sioux window under Metrowerks (5.0 forward)
#ifdef USESIOUX	
	SIOUXSettings.initializeTB = false;
	SIOUXSettings.setupmenus = false;
	SIOUXSettings.standalone = false;
	SIOUXSettings.asktosaveonclose = true;
#endif // USESIOUX	

	InitStack(10*1024L);						// Add 10k more to the stack, for possible QD and Sound Manager needs
	InitMacEnvironment(10L);					// 10 * MoreMasters
	InitMenubar();
	
	if( !QTUIsQuickTimeInstalled() )
	{
		ShowWarning("\pQuickTime is not installed on this system -- we will exit!", 0);
		ExitToShell();
	}
#if powerc	
	if( !QTUIsQuickTimeCFMInstalled() )
	{
		ShowWarning("\pThe QuickTime PowerPlug file is not available -- we will exit!", 0);
		ExitToShell();								// I could disable features as well.
	}
#endif // powerc

	anErr = EnterMovies(); DebugAssert(anErr == noErr);
	if(anErr != noErr)
	{
		ShowWarning("\pWe have problems initializing the QuickTime environment (exit): ", anErr);
		ExitToShell();
	}

	printf("Digitizer Shell -- for testing of Quicktime Digitizer functionality.\n");

	MainEventLoop();
}
