// ===========================================================================
// SCScriptsMenu.h -- handle the scripts menu
// ===========================================================================
//  1995 James Kaput, Jeremy Roschelle SimCalc Project

// This source code may be compiled into a commercial or non-commercial application
// providing that the hmnu resource 140 is included and the following help balloon appears
// when the user points at the script menu with Balloon help enabled:

//ScriptMenu
//Copyright  1995 
//By Jeremy Roschelle
//Use this menu to run scripts.

#pragma once

#include <OSA.h>

class SCScriptsMenuHandler : public LAttachment
{
	public:
			SCScriptsMenuHandler(ResIDT inMenuID, 
							 short inVRefNum = 0, 
							 long inParId = 0, 
							 Int16 inMax = 32 );
				
			
			virtual ~SCScriptsMenuHandler();
								
			// attach script from open file dialog
			void AttachScriptDialog();
			
			void AppendScript(FSSpec &inScriptFile);
			void RemoveScript(Int16 inIndex);
			
			// releases memory occupied by scripts, forces reloading from disk
			void PurgeScripts();
			
	protected:
		virtual void	ExecuteSelf(MessageT inMessage, void *ioParam);
		void			AttachBalloonHelp(FSSpec &inScriptFile, Int16 inIndex);
		void			RemoveBalloonHelp(Int16 inIndex);
		void			MakeBalloonData(Str255 inHelp, char *ioBuffer);
		void			InsertBalloonData(Int16 inIndex, char *inBuffer);
		
		ResIDT	mMenuID;
		LList	mScripts;
};

class SCScriptsMenuItem	{
	public:
		SCScriptsMenuItem(FSSpec &inScriptFile)
			: mFileSpec(inScriptFile), mScriptID(kOSANullScript) {};
			
		virtual ~SCScriptsMenuItem();
		
		virtual OSErr	OpenScript();
		virtual OSErr	RunScript();
		virtual void	PurgeScript();
	
	protected:
		OSAID	mScriptID;
		FSSpec	mFileSpec;	
};