/* Copyright 1996 by Dave Mark, All Rights Reserved */

import java.applet.*;
import java.awt.*;
import java.net.*;

public class popup extends Applet
{
	private Choice	urlChoices;
	
	public void	init()
	{
		int		numURLs = 0;
		
		this.setBackground( Color.yellow );//java.awt.Color
		this.setForeground( Color.red );//java.awt.Color
		
		urlChoices = new Choice();
			
		urlChoices.setForeground( Color.green );
		urlChoices.setBackground( Color.blue );
		
		String numURLsString = this.getParameter( "numURLs" );
		
		if ( numURLsString == null )
		{
			this.showStatus( "null or missing numURLs Parameter!" );
		}
		else
		{
			try
			{
				numURLs = Integer.parseInt( numURLsString );
			}
			catch( NumberFormatException err )
			{
				numURLs = 0;
				this.showStatus( "Bad numURLs Parameter: " + numURLsString );
			}
		
			String		urlString;
			
			for ( int i=1; i<=numURLs; i++ )
			{
				urlString = this.getParameter( Integer.toString( i ) );
				
				if ( urlString == null )
					this.showStatus( "Missing Parameter: " + i );
				else
					urlChoices.addItem( urlString );
			}
		}
		
		this.add( new Label( "Select URL: " ) );
		this.add( urlChoices );
	}
	
	public boolean action( Event e, Object obj )
	{
		URL		url;
		
		if ( e.target == urlChoices )
		{
			try
			{
				url = new URL( obj.toString() );
			}
			catch( MalformedURLException err )
			{
				// Could print error message here.
				return true;
			}
			/* If a method throws an exception, you must be prepared to catch it,
				even if you ignore the result. See java.net.URL().
				If I throw an exception, I'll create a new java.lang.exception
				object (or some class that extends throwable). But if I catch an
				exception, the exception object will be passed to me, just like err was here.
				Take a look at Throwable to see what you can do with err (especially getMessage()).
				
			*/
			this.getAppletContext().showDocument( url );
			return true;
		}
		else
			return super.action( e, obj );
	}
}