/*
	 1995 Tangent Systems
	All Rights Reserved.
	
	example.c
	This is an example source file for building a shared library. It is being written to
	demonstrate how CPX can access shared libraries.
	
	The only limitation when writing code for a shared library to be used by our CPX
	interface code is that only one argument is allowed in calling the function from within
	CPX.
	
	***
	07/07/95
	Note 1: If you want to add a function to be "shared" by external users you must edit
	the .exp file when compiling the shared library and include the symbol name for the
	new function. See the CodeWarrior Manual for instructions on how to do this.
	
	Note 2: You can use the CodeWarrior debugger to debug the shared library while being
	called - see the #define DEBUG_TEST line.
	
	John H. Shackelford
	Tangent Systems		
*/

#include <MixedMode.h>
#include <stdlib.h>
#include <stdio.h>

#include "example.h"
#include "TanLibStructs.h"

/*
	#define DEBUG_TEST 1 	enable debugging
	#define DEBUG_TEST 0	no debugging
	
	Note: When debugging is enable make sure your debugger is running
	or else you'll drop into your low-level debugger (probably MacsBug) when
	the call is made into this code from your CPX application.

*/
#define DEBUG_TEST 0

#if DEBUG_TEST == 1
#define TestDebug Debugger()
#else
#define TestDebug NULL
#endif

/*
Pass in a pointer to data_cache, calculates the average value and returns
the answer in data_cache->result.
*/
void get_average(data_cache *theData)
{

	int i;
	int dataLength;
	double myresult = 0.00;
	
	TestDebug;
	theData->success = 0;	
	dataLength = theData->length;
	if(dataLength < 0) return;
	
	for(i = 0; i < dataLength; i++)
	{
		myresult += theData->data[i];
	}

	if(i != 0) myresult = myresult/i;
	theData->result = myresult;
	theData->success = 1;
}

/*
 Pass in a pointer to data_cache, calculates the maximum value and returns
 the answer in data_cache->result.
*/
void get_maximum(data_cache *theData)
{
	int i;
	double myresult;
	TestDebug;
	theData->success = 0;
	if(theData->length < 0) return;
	
	myresult = theData->data[0];
	for(i = 1; i < theData->length; i++)
	{
		if(myresult < theData->data[i]) myresult = theData->data[i];
	}
	theData->result = myresult;
	theData->success = 1;
}

/*
 Pass in a pointer to data_cache, calculates the minimum value and returns
 the answer in data_cache->result.
*/
void get_minimum(data_cache *theData)
{
	int i;
	double myresult;
	TestDebug;
	theData->success = 0;
	if(theData->length < 0) return;
	
	myresult = theData->data[0];
	for(i = 1; i < theData->length; i++)
	{
		if(myresult > theData->data[i]) myresult = theData->data[i];
	}
	theData->result = myresult;
	theData->success = 1;
}

/*
 Pass in a pointer to data_cache, calculates the sum value.
*/
void get_sum(data_cache *theData)
{

	int i;
	double myresult = 0.00;
	TestDebug;
	theData->success = 0;
	
	if(theData->length < 1 ) return;
		
	for(i = 0; i < theData->length; i++)
	{
		myresult += theData->data[i];
	}
	theData->result = myresult;
	theData->success = 1;
}

/*
 Pass in a pointer to data_cache, calculates the variance.
 variance of (x1....xn) = (1/n)*(SUM of { (x_j - x_average)*(x_j - x_average) }
*/
void get_variance(data_cache *theData)
{
	int i;
	double average = 0;
	double variance = 0.00;
	
	if(theData->length < 1) return; /* make sure we have array length > 0 */
	
	get_average(theData);
	if(theData->success == 0) return; /*Bail if average did not work */
	average = theData->result;
	theData->success = 0;
	
	for(i=0;i<theData->length;i++)
	{
		variance += (theData->data[i] - average)*(theData->data[i] - average);
	}
	theData->result = variance/(theData->length);
	theData->success = 1;
}


