/*
	 1995 Tangent Systems
	All Rights Reserved.
	
	OOSharedLib.c
		
	John H. Shackelford
	Tangent Systems		
*/


#include "Tvector.h"
#include "OOSharedLib.h"
#include "OOSharedLibStructs.h"


/*
	#define DEBUG_TEST 1 	enable debugging
	#define DEBUG_TEST 0	no debugging
	
	Note: When debugging is enable make sure your debugger is running
	or else you'll drop into your low-level debugger (probably MacsBug) when
	the call is made into this code from your CPX application.

*/
#define DEBUG_TEST 0

#if DEBUG_TEST == 1
#define TestDebug Debugger()
#else
#define TestDebug NULL
#endif

/*
Pass in a pointer to data_cache, calculates the average value and returns
the answer in data_cache->result.
*/
void get_average(data_cache *theData)
{
	Tvector *aVector;
	double average = 0;
	TestDebug;
	
	aVector = new Tvector(theData->length, theData->data);

	theData->success = aVector->calc_average(&average);
	theData->result = average;
	delete(aVector);

}

/*
Pass in a pointer to data_cache, calculates the maximum value and returns
the answer in data_cache->result.
*/
void get_maximum(data_cache *theData)
{
	Tvector* aVector;
	double maximum = 0;
	TestDebug;
	
	aVector = new Tvector(theData->length, theData->data);
	theData->success = aVector->calc_maximum(&maximum);

	theData->result = maximum;
	delete(aVector);
}

/*
Pass in a pointer to data_cache, calculates the minimum value and returns
the answer in data_cache->result.
*/
void get_minimum(data_cache *theData)
{
	Tvector* aVector;
	double minimum = 0;
	TestDebug;
	
	aVector = new Tvector(theData->length, theData->data);
	theData->success = aVector->calc_minimum(&minimum);

	theData->result = minimum;
	delete(aVector);
}

/*
Pass in a pointer to data_cache, calculates the sum value and returns
the answer in data_cache->result.
*/
void get_sum(data_cache *theData)
{
	Tvector* aVector;
	double sum = 0;
	TestDebug;
	
	aVector = new Tvector(theData->length, theData->data);
	theData->success = aVector->calc_sum(&sum);

	theData->result = sum;
	delete(aVector);
}

/*
Pass in a pointer to data_cache, calculates the variance value and returns
the answer in data_cache->result.
*/
void get_variance(data_cache *theData)
{
	Tvector* aVector;
	double variance = 0;
	TestDebug;
	
	aVector = new Tvector(theData->length, theData->data);
	theData->success = aVector->calc_variance(&variance);

	theData->result = variance;
	delete(aVector);
}



