#include <FragLoad.h>
#include <MixedMode.h>
#include <stdio.h>
#include <string.h>
#include "OOSharedLib.h"


void main()
{
	OSErr	err = noErr;
	ConnectionID	connID = kNoConnectionID;
	Ptr	mainAddr = nil;
	Str255	errName;
	char	str[80];
	
	/*
		The following union is being used in order to use aSymbol
		as the variable to get the address of the function out of the 
		shared library and then to use *p as a function pointer
		later on. Casting aSymbol to a function pointer with an
		argument of data_cache* is not allowed. Using a union seems to
		work.
	*/
	union	function_pointer
	{
		Ptr aSymbol;
		void (*p)(data_cache* cache);
	} functionPtr;
	
	data_cache*	theCache;
	double data[10] = {1, 2, 3, .4, 6, 87, -902, 0, 3.5, 10};
	double answer = 0;
	double sum = 0;
	double variance = 0;
	int success = 0;
	int	loadedLib = 0;
	
	err = GetSharedLibrary("\pOOSharedLib", kPowerPCArch,
							kLoadNewCopy, &connID, &mainAddr,
							errName);
	if(err == noErr)  loadedLib = 1;
	
	while(err == noErr)
	{		
		if(err == noErr)
		{
			printf("Prepare to run get_average\n");
			gets(str);
			SymClass	symClass;
			err = FindSymbol(connID, "\pget_average", &(functionPtr.aSymbol), &symClass);
			if(err == noErr)
			{
				theCache = new data_cache;
				theCache->data = data;
				theCache->length = 10;
				theCache->result = answer;
				theCache->success = success;

				(*functionPtr.p)(theCache);
				if(theCache->success)
				{
					printf("The average = %f\n", theCache->result);
				}
				else
				{
					printf("The get_average function failed\n");
				}
				delete(theCache);
			}
			else
			{
				printf("The symbol did not load properly\n");
			}
			//CloseConnection(&connID);
		}
		else
		{
			printf("The shared library did not load properly\n");
		}
	}
	if(loadedLib == 1)
	{
		CloseConnection(&connID);
	}
}
	