/*
	File:		DigitalMeterDef.h

	Contains:	Common definitions used by DigitalMeter.cpp & .r files.

	Written by:	Steve Smith

	Copyright:	 1994-95 by Apple Computer, Inc., all rights reserved.
	
	-------------------------------------------------------------------
	
	Note:		This file will need to be modified for any derivitive
				work based on DigitalMeter. The areas marked with (CH)
				should be considered when making those changes.
*/


#ifndef _DIGITALMETERDEF_
#define _DIGITALMETERDEF_

// -- OpenDoc Includes --

#ifndef SOM_Module_OpenDoc_StdDefs_defined
#include <StdDefs.xh>
#endif

//=====================================================================

// Class / Editor ID (CH)
#define kPartClassName					"som_DigitalMeter"
#define kDigitalMeterID					"PartCo::"kPartClassName

// Editor User String (CH)
#define kDigitalMeterEditorUserString 	"DigitalMeter 1.0.1"

// Kind (CH)
#define kDigitalMeterKind					kODISOPrefix "Apple:Kind:DigitalMeter"

// Kind User String (CH)
#define kDigitalMeterKindUserString		"DigitalMeter"

// Category (CH)
#define kDigitalMeterCategory				kODISOPrefix "Apple:Category:Sample Code"

// Category User String (CH)
#define kDigitalMeterCategoryUserString 	"Sample Code"

// DigitalMeter OSTypes (CH)
#define kDigitalMeterEditorOSType			'SPED'
#define kDigitalMeterViewerOSType			'SPVW'
#define kDigitalMeterDocumentOSType		'SPDC'
#define kDigitalMeterStationeryOSType		'sPDC'

// ISO Strings (CH)
#define kMainPresentation  				kODISOPrefix "DigitalMeter:Presentation:Main"
#define kDigitalMeterInfo					kODISOPrefix "DigitalMeter:Display Frame Info"

// DigitalMeter defines
#define	kBaseResourceID					20001

// NMAP Resource IDs
#define kKindCategoryMapId				kBaseResourceID+1
#define kEditorKindMapId				kBaseResourceID+2
#define kEditorUserStringMapId			kBaseResourceID+3
#define kKindUserStringMapId			kBaseResourceID+4
#define kCategoryUserStringMapId		kBaseResourceID+5
#define kOldMacOSTypeMapId				kBaseResourceID+6

// Text Items
#define	kMenuStringResID				kBaseResourceID
#define	kAboutTextID        			1
#define	kDefaultContent1ID				2
#define	kDefaultContent2ID				3

// Error Messages
#define kErrorStringResID				kMenuStringResID+1
#define kErrStrFieldID					3
#define kErrCantInitializePart			1
#define kErrCantOpenDocWindow			2
#define kErrCantOpenPartWindow			3
#define kErrRemoveFrame					4
#define kErrWindowGone					5
#define kErrExternalizeFailed			6

// Bundles/FREFs
#define kDocumentBundle					kBaseResourceID
#define kEditorBundle					kBaseResourceID+1
#define kViewerBundle					kBaseResourceID+2
#define kDocumentFREF					kBaseResourceID
#define kStationeryFREF					kBaseResourceID+1
#define kEditorFREF						kBaseResourceID+2
#define kViewerFREF						kBaseResourceID+3

// Icons
#define	kLargeIcons						1
#define	kSmallIcons						2
#define	kDocumentIcons					kBaseResourceID
#define	kStationeryIcons				kBaseResourceID+1
#define	kEditorIcons					kBaseResourceID+2
#define	kViewerIcons					kBaseResourceID+3

// Pictures
#define kEditorIconPicture				kBaseResourceID
#define	kThumbnailPicture				kBaseResourceID+1

// Dialogs & Windows
#define	kAboutBoxID  					kBaseResourceID
#define	kErrorBoxID  					kBaseResourceID+1
#define	kMacWindowTitleBarHeight		20
#define	kALittleNudge					4
#define kMinVertVisPortion				10
#define kMinHorzVisPortion				16
#define kWindowOpening					1
#define kWindowClosing					0

// Display Frames
#define kFrameRemoved					1
#define kFrameClosed					0

// Geometry
#define kMinImagingResolution			72 // dpi

#endif

