/*

Listing 5: NewButtonFrame.java

NewButtonFrame.java
Define and create our "New Button" dialog.

*/

// Import the generic Java classes.
import java.applet.*;
import java.awt.*;
import java.io.*;
import java.lang.*;

//	Our class definition.
public	class NewButtonFrame extends Frame
{
	Button					bCancel, bOK;
	Demo						myDemo;
	Label						theTextLabel = new Label( "Enter button 
											text: " );
	MenuBar					theButtonMenuBar;
	NewButtonFrame		theNewButtonFrame;
	Panel						pButtonPalette;
	Panel						pTextPalette;
	TextField				theTextField;


	//	The constructor for our class.
	public NewButtonFrame( Demo thisDemo )
	{
		//	Variables we need for initialization.
		int				defaultX = 20, defaultY = 280;
		int				defaultWidth = 300, defaultHeight = 80;

		myDemo = thisDemo;
		theNewButtonFrame = this;

		theTextField = new TextField( 32 );
		theTextField.setEditable( true );

		pTextPalette = new Panel();
		pTextPalette.setLayout( new GridLayout( 1, 2 ) );
		pTextPalette.add( theTextLabel );
		pTextPalette.add( theTextField );

		pButtonPalette = new Panel();
		pButtonPalette.setLayout( new GridLayout( 1, 5 ) );

		bCancel = new Button();
		bOK = new Button();

		bCancel.setLabel( "Cancel" );
		bOK.setLabel( "OK" );

		pButtonPalette.add( new Label() );
		pButtonPalette.add( bCancel );
		pButtonPalette.add( new Label() );
		pButtonPalette.add( bOK );
		pButtonPalette.add( new Label() );

		setBackground( Color.lightGray );
		setMenuBar( theButtonMenuBar );
		setResizable( false );
		setTitle( "Add Button..." );
		reshape( defaultX, defaultY, defaultWidth, 
				defaultHeight );
		add( "South", pButtonPalette );
		add( "North", pTextPalette );

		hide();
	}
	
	//	Override the action() method of our parent class.
	public boolean action( Event evt, Object arg )
	{
		boolean		eventHandled = false;
		Object		theTarget;
		String		theString = new String();

		theTarget = ( Button )evt.target;

		if ( theTarget == bCancel )
			theNewButtonFrame.hide();

		if ( theTarget == bOK )
		{
			theString = theTextField.getText();
			eventHandled = myDemo.doAddButton( theString );
			theNewButtonFrame.hide();
		}

		if ( eventHandled )
			return true;
		else
			return false;
	}

	public boolean doSetupDefaults()
	{
		theTextField.setText( "" );

		return true;
	}

}
