/*________________________________________________________________________________
	DebugTrapsOff.h
________________________________________________________________________________*/


#pragma once

#if USE_DEBUG_TRAPS	// [

/*
This file defeats the debugging traps mechanism for all debugging traps.
To turn off debugging traps in an individual file, #include this file
after #including DebugTraps.h (which is typically #included in a global prefix file).

This may be necessary in a few rare circumstances where mutual recursion
between DebugTraps and other debugging code occurs.

You can also #undef an individual routine if it's a single routine that's a problem.

How to generate this file:
	This file is derived from DebugTraps.h. If you change DebugTraps.h, do not
	edit this file. Instead, generate a new file as follows:
	1. Copy all #defines from DebugTraps.h to a scratch window
	2. globally replace all #define with #undef
	3. using grep, strip text after the #undef'd symbol
	3. strip any other extraneous stuff from this file
	4. save
*/


// _____________________________ Memory Manager _________________________________

#undef BlockMove				
#undef BlockMoveData			
#undef NewPtr
#undef NewPtrClear
#undef NewPtrSys			
#undef NewPtrSysClear
#undef GetPtrSize				
#undef SetPtrSize				
#undef PtrZone					
#undef DisposePtr				
#undef PtrToHand
#undef NewHandle
#undef NewHandleClear
#undef NewHandleSys
#undef NewHandleSysClear
#undef GetHandleSize			
#undef SetHandleSize			
#undef ReallocateHandle		
#undef DisposeHandle			
#undef HLock					
#undef HUnlock					
#undef HGetState				
#undef HSetState				
#undef HandAndHand				
#undef HandToHand
#undef HPurge					
#undef HNoPurge				
#undef EmptyHandle				
#undef HandleZone				
#undef RecoverHandle			
#undef RecoverHandleSys		
#undef SetZone					
#undef GetZone					
#undef TempNewHandle
#undef TempDisposeHandle		
#undef MoveHHi					
#undef PtrAndHand				


// _____________________________ Others _________________________________


#endif	// ]
