// File: LMProtos.h

void Error(char* message, char *buffer, short index, char* fileName);
void Warning(char* message, char *buffer, short index, char* fileName);
int GetOrMakeDirectory(char *path);
FILE* GetOrMakeFile(char* fileName, char *path);
FILE* CopyFile(char* sourceFileName, char *sourcePath, char* copyPath);

static char *MakeLower(char* buffer);

int ProcessOneFile(char *filename);
void ProcessLine(char *buffer, int *inComment, char* filename);
Command FindCommand(char *possibleCommand);
short FindLab(char* labName);
char *GetKeyword(char* keyword, char* buffer, short *index, char* result);
char *GetNextSubstring(char* buffer, short *index, char *result, short allowQuotes, short labList);
char *GetLabName(char* buffer, short *index, char *result);
char *GetDirectoryName(char* buffer, short *index, char *result);
char *FindCommentStart(char *buffer, short *index, short *startOffset, short *commentKind);
char *FindCommentEnd(char *buffer, short *index, short *endOffset, short commentKind);
char *SkipWhitespace(char *buffer, short *index);
void DistributeLine(char *buffer);

void DoComment(char *buffer, short index, char* filename);
void DoCreate(char *buffer, short index, char* filename);
void DoInclude(char *buffer, short index, char* filename);
void DoCopy(char *buffer, short index, char* filename);
void DoSkip(char *buffer, short index, char* filename);
void DoInsert(char *buffer, short index, char* filename);
void DoPush(char *buffer, short index, char* filename);
void DoPop(char *buffer, short index, char* filename);
void DoSuffix(char *buffer, short index, char* filename);
void DoDelimiter(char *buffer, short index, char* filename);
void DoReset(char *buffer, short index, char* filename);
