// CMain.cp -- window methods
// Created 20/3/96 12:28 by AppMaker

#include "CMain.h"

#include <UReanimator.h>
#include <URegistrar.h>
#include <LStream.h>
#include <LStdControl.h>
#include "CSoundAttachment.h"
#include "CSoundsDemoData.h"
#include "CmdCodes.h"

#define PPob_MainID	200
#define RidL_MainID	200

Boolean		CMain::sIsRegistered = false;

//----------
void
CMain::RegisterClass ()
{
	URegistrar::RegisterClass ('Main', (ClassCreatorFunc)CMain::CreateMainStream);

	// register the pane classes we use

	sIsRegistered = true;
}

//----------
CMain*
CMain::CreateMain(
	LCommander			*inSuperCommander,
	CSoundsDemoData		*inData)
{
	if (!sIsRegistered) {
		RegisterClass ();
	}

	CMain		*window;

	window = (CMain *)LWindow::CreateWindow(PPob_MainID, inSuperCommander);
	window->ConnectToData (inData);

	return window;
}

//----------
//	This is the function you register with URegistrar to create a
//	CMain from a resource

CMain*
CMain::CreateMainStream(
	LStream	*inStream)
{
	return (new CMain(inStream));
}

//----------
CMain::CMain()
{
}

//----------
CMain::CMain(
	LStream	*inStream)
		: LWindow(inStream)
{
}

//----------
CMain::~CMain()
{
}

//----------
//	This member function gets called once the containment hierarchy that contains
//	this pane has been built. It gives us a chance to get data members for
//	interesting subviews, and to do other operations now that our subviews exist.
void
CMain::FinishCreateSelf()
{
	mPlayButton = (LStdButton *)FindPaneByID ('Play');
 	mPlayButton->AddAttachment(new CSoundAttachment("Click", msg_Click));

	UReanimator::LinkListenerToControls(this, this, RidL_MainID);
		// the purpose is to "connect" self to whatever controls
		// that we want to "listen" to

// any additional initialization for your window:

}

//----------
void
CMain::ConnectToData	(CSoundsDemoData		*inData)
{
	mData = inData;
	inData->AddListener (this);
}

//----------
void
CMain::ListenToMessage(
	MessageT	inMessage,
	void		*ioParam)
{
	switch (inMessage) {

	default:
		break;
	}
}

//----------
Boolean
CMain::ObeyCommand(
	CommandT	inCommand,
	void		*ioParam)
{
	Boolean		cmdHandled = true;

	switch (inCommand) {

	// +++ Add cases here for the commands you handle
	//		Remember to add same cases to FindCommandStatus below
	//		to enable/disable the commands

	default:
			cmdHandled = LWindow::ObeyCommand(inCommand, ioParam);
		break;
	}

	return cmdHandled;
}

//----------
void
CMain::FindCommandStatus(
	CommandT	inCommand,
	Boolean		&outEnabled,
	Boolean		&outUsesMark,
	Char16		&outMark,
	Str255		outName)
{
	outUsesMark = false;

	switch (inCommand) {

	// +++ Add cases here for the commands you handle

	default:
			LWindow::FindCommandStatus(inCommand, outEnabled,
										outUsesMark, outMark, outName);
		break;
	}
}

//----------
Boolean
CMain::FocusDraw()
{
	Boolean		focused = LView::FocusDraw();

	if (focused) {
		AuxWinHandle	awHndl;
		CTabHandle		awCTable;
		ColorSpec		contentSpec;

		GetAuxWin(GetMacPort(), &awHndl);
		awCTable = (**awHndl).awCTable;
		contentSpec = (**awCTable).ctTable [wContentColor];		// should search vs. index
		::RGBBackColor(&contentSpec.rgb);
	}

	return focused;
}
