// CSoundsDemoApp.cp -- application methods
// Created 20/3/96 12:28 by AppMaker

#include "CSoundsDemoApp.h"

#include "CSoundsDemoDoc.h"
#include "CSoundsDemoData.h"
#include "CmdCodes.h"

#include <UDesktop.h>
#include <URegistrar.h>
#include <UScreenPort.h>
#include <PPobClasses.h>
#include <PP_Messages.h>

// ---------------------------------------------------------------------------
//		 CSoundsDemoApp
// ---------------------------------------------------------------------------
//	Default constructor

CSoundsDemoApp::CSoundsDemoApp()
	:LDocApplication()
{
	UScreenPort::Initialize();

	RegisterClasses();

	SetUpMenus();

	// initialize app's data:

}


// ---------------------------------------------------------------------------
//		 ~CSoundsDemoApp
// ---------------------------------------------------------------------------
//	Destructor
//

CSoundsDemoApp::~CSoundsDemoApp()
{
}

// ---------------------------------------------------------------------------
//		 RegisterClasses
// ---------------------------------------------------------------------------
//

void
CSoundsDemoApp::RegisterClasses()
{
	RegisterAllPPClasses();
			// replace to register only classes that we use.
			// windows know what classes they use
			// so call static functions in each window/dialog,
}

// ---------------------------------------------------------------------------
//		 SetUpMenus
// ---------------------------------------------------------------------------
//

void
CSoundsDemoApp::SetUpMenus()
{

}

// ---------------------------------------------------------------------------
//		 StartUp
// ---------------------------------------------------------------------------
//	The application calls this member function automatically when the application
//	is opened

void
CSoundsDemoApp::StartUp()
{
	ObeyCommand(cmd_New, nil);
}

//----------
LModelObject*
CSoundsDemoApp::MakeNewDocument()
{
	CSoundsDemoDoc	*theDoc = new CSoundsDemoDoc(this);

	theDoc->newFile();

	return theDoc;
}

//----------
// called from SendAEOpenDoc in response to Open command

void
CSoundsDemoApp::OpenDocument(
	FSSpec	*inMacFSSpec)
{
	CSoundsDemoDoc	*theDoc = new CSoundsDemoDoc(this);

	theDoc->openFile (inMacFSSpec);
}

//----------
// called from LDocApplication in response to Open command

void
CSoundsDemoApp::ChooseDocument()
{
	SFTypeList			typeList;
	short				numTypes;
	StandardFileReply	macFileReply;

	typeList[0] = kFileType;
	numTypes = 1;

	UDesktop::Deactivate();
	::StandardGetFile(nil, numTypes, typeList, &macFileReply);
	UDesktop::Activate();

	if (macFileReply.sfGood) {
		SendAEOpenDoc(macFileReply.sfFile);
	}
}

// ---------------------------------------------------------------------------
//		 ObeyCommand
// ---------------------------------------------------------------------------
//	Respond to commands

Boolean
CSoundsDemoApp::ObeyCommand(
	CommandT	inCommand,
	void		*ioParam)
{
	Boolean	cmdHandled = true;

	switch (inCommand) {

	// +++ Add cases here for the commands you handle
	//		Remember to add same cases to FindCommandStatus below
	//		to enable/disable the menu items for the commands


	default:
			cmdHandled = LDocApplication::ObeyCommand(inCommand, ioParam);
		break;
	}

	return cmdHandled;
}


// ---------------------------------------------------------------------------
//		 FindCommandStatus
// ---------------------------------------------------------------------------
//	Pass back status of a (menu) command

void
CSoundsDemoApp::FindCommandStatus(
	CommandT	inCommand,
	Boolean		&outEnabled,
	Boolean		&outUsesMark,
	Char16		&outMark,
	Str255		outName)
{
	outUsesMark = false;

	switch (inCommand) {

	// +++ Add cases here for the commands you handle


	default:
			LDocApplication::FindCommandStatus(inCommand, outEnabled, outUsesMark,
												outMark, outName);
		break;
	}
}
