#include	<PLStringFuncs.h>

#define 	DEBUG_DEMO			0 // set to 1 for debugging


#define 	NIL					0L			
#define 	kExtremeNeg			-32700
#define 	kExtremePos			32700

#define		WINDOWID			2000
#define		PUTINFRONT			(WindowPtr) -1L
#define		ABOUTID				5000
#define		APPLEMENU			5001
#define		appleABOUT			1
#define		FILEMENU			5002
#define		clearDataFork		1
#define		fileQUIT			3

#define		MAXMENUS			2
#define		FIRSTMENUID			5001

#define		TESTALERTID			6000
#define		BADSYSTEMID			6001
#define		BADQUICKDRAWID		6002
#define		NOAPPLEEVENTS		6003

/*****     Prototypes      *****/
void		main(void);
void 		initApp(void);
Boolean		checkGestaltFeatures(void);
Boolean 	installAEHandlers();
void 		setUpMenus(void);
void 		setUpWindow(void);
void 		setUpMenus(void);
void 		doHighLevel(EventRecord *eventRec);
void 		doMousedown(EventRecord *eventRec);
void 		doKey(EventRecord *eventRec);
void		doUpdate(EventRecord *eventRec);
void 		dispatch(long menuResult);
void 		doAppleCmds (short theItem);
void 		doFileCmds (short theItem);

OSErr		checkforSelfContained(short	*vRefNumToSearch);
OSErr 		processFile( FSSpecPtr fsspec,short refNum,long fileLength);
OSErr 		appendTextFileToApp(short destRefNum);
void		exitApp(void);
void		ClearDataFork(void);
void 		reverseFile(short refNum);
OSErr 		checkForProductRegistrationInfo(short refNum);
static		OSErr GetCFRGInfo(Byte *fragmentType, Byte *fragmentLocation,
						 long *fragmentOffset, long *fragmentLength);

pascal OSErr	DoOpenAppAE(AppleEvent theAppleEvent, AppleEvent reply, long refCon);
pascal OSErr	DoOpenDocAE(AppleEvent theAppleEvent, AppleEvent reply, long refCon);
pascal OSErr	DoPrintDocAE(AppleEvent theAppleEvent, AppleEvent reply, long refCon);
pascal OSErr	DoQuitAppAE(AppleEvent theAppleEvent, AppleEvent reply, long refCon);

/*****  globals *****/
Boolean			gQuitTheApp = false;			// true = quit program 
Ptr	   			gBufferPtr;						// global buffer
FSSpec			gApplicationProcessInfo;		// fsspec of the current Application

// The format of the 'cfrg' on disk. This is defined in <CodeFragmentTypes.r>
#ifdef powerc
	#pragma options align=mac68k
#endif

typedef		struct	fragDescriptors
{
		long		CodeType;
		long		UpdateLevel;
		long		CurrentVersion;
		long		OldestDefVersion;
		long		AppStackSize;
		short		AppLibDirectory;
		Byte		TypeOfFrag;
		Byte		LocationOfFrag;
		long		OffsetToFrag;
		long		LengthOfFrag;
		long		Reserved1;
		long		Reserved2;
		short		itemSize; 
		Str255		Fragname;
}fragDescriptors;

#ifdef powerc
	#pragma options align=reset
#endif


typedef	struct fragDescriptors  fragDescriptors;

typedef fragDescriptors FragArray[1];

typedef	struct codeFragRecord
{
		long			Reserved1;
		long			Reserved2;
		long			Version;
		long			Reserved3;
		long			Reserved4;
		long			Reserved5;
		long			Reserved6;
		long			NumberofFrags;
		FragArray		fragArray; 		// array[0..0] of fragDescriptors;		
}codeFragRecord;

typedef struct codeFragRecord *codeFragRecPtr, **codeFragRecHandle;

typedef struct	ProductRegistrationInfo
{
		long		startOfData;
		short		versionNumber;
		Boolean		demoVersion;
		char		creditRating;
		Str255		subliminalMessage;
		long		endOfData;
}ProductRegistrationInfo;


/*****	main() *****/

void main()
{
	short			sleepTime  =  60;
	EventRecord		myEvent;
	short			vRefNum;
	OSErr			err;



#if DEBUG_DEMO

	#ifdef powerc
		DebugStr("\p Running PowerPC Demo");
	#else
		DebugStr("\p Running 68K Demo");
	#endif
	
#endif

	initApp();								/* call initialization routine */
	setUpMenus();

	err = checkforSelfContained(&vRefNum);

	do
	{
		if (WaitNextEvent(everyEvent, &myEvent, sleepTime, NIL))
			switch (myEvent.what)
			{
				case mouseDown:
					doMousedown(&myEvent);
					break;
					
				case keyDown:
				case autoKey:
					doKey(&myEvent);
					break;

				case kHighLevelEvent:
					doHighLevel(&myEvent);
					break;

				case activateEvt:
					break;
				
				case updateEvt:
					doUpdate(&myEvent);
					break; 
				
				case diskEvt:
					break;
			
				case osEvt:				
					break;
			}
	}  while (!gQuitTheApp);		
	
	exitApp();

} 				/* end of main */


/*****	initApp() *****/

void initApp()
{
	
	/* Memory specific initializations. */
	
	MaxApplZone();				/* grow the heap to its maximum size */
	MoreMasters();		   		/* create more master pointers		 */
	MoreMasters();
	MoreMasters();
	MoreMasters();
	MoreMasters();

	/* Initializing the ROM Managers */
	
	InitGraf((Ptr) &qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	FlushEvents(everyEvent,0);
	TEInit();
	InitDialogs(NIL);
	InitCursor();
	
	if (!checkGestaltFeatures())
		ExitToShell();
	
	if (!installAEHandlers())
		ExitToShell();
}				


Boolean checkGestaltFeatures()
{
	long		gestaltFeature;
	OSErr		myErr;

	myErr = Gestalt(gestaltSystemVersion, &gestaltFeature); 	/* which SysVersion present? */
	if (myErr == noErr)
	{
		gestaltFeature = (gestaltFeature >> 8) & 0xf; 
										/* shift result over & mask out major version number */
		if (gestaltFeature < 7) 		/* This is a System 7+ shell.  We quit otherwise. */
		{
			StopAlert(BADSYSTEMID, nil);
			return(false);
		}
	}
	
	if (myErr == noErr)
	{
		myErr = Gestalt(gestaltQuickdrawVersion, &gestaltFeature);
													/* we want color QD cuz we're spoiled */
		if (myErr == noErr)
		{
			if(gestaltFeature < gestalt32BitQD)
			{
				StopAlert(BADQUICKDRAWID, nil);
				return(false);
			}
		}
	}
	
	
	
	if (myErr == noErr)
	{
		myErr = Gestalt(gestaltAppleEventsAttr, &gestaltFeature);
		if (myErr == noErr)
		{
			if (!(gestaltFeature & 0xf))
			{
				StopAlert(NOAPPLEEVENTS, nil);
				return(false);
			}
		}
	}
	if (!myErr)		
		return(true);		
	else
		return(false);		
}

Boolean installAEHandlers()
{
	OSErr		myErr;
	
	myErr = AEInstallEventHandler ( kCoreEventClass, 
					kAEOpenApplication, NewAEEventHandlerProc(DoOpenAppAE), 0L, false );
	if (myErr == noErr)
		myErr = AEInstallEventHandler ( kCoreEventClass,
					kAEOpenDocuments, NewAEEventHandlerProc(DoOpenDocAE), 0L, false );
	if (myErr == noErr)
		myErr = AEInstallEventHandler ( kCoreEventClass,
					kAEPrintDocuments, NewAEEventHandlerProc(DoPrintDocAE), 0L, false );
	if (myErr == noErr)
		myErr = AEInstallEventHandler ( kCoreEventClass,
					kAEQuitApplication, NewAEEventHandlerProc(DoQuitAppAE), 0L, false );
	if (myErr)
		return(false);
	else
		return(true);
}

void setUpMenus()
{
	short			n;
	MenuHandle		theMenu;
	
	for (n = 0; n < MAXMENUS; n++)
	{
		theMenu = GetMenu(FIRSTMENUID + n);
		if (theMenu)  				
			InsertMenu(theMenu, 0);
	}

	theMenu = GetMHandle(APPLEMENU);
	if (theMenu)
		AddResMenu(theMenu, 'DRVR');

	theMenu = GetMHandle(FILEMENU);
	DisableItem(theMenu,clearDataFork);		//disable clearing of the data fork
	
	DrawMenuBar();
	return;
}					/* end of setUpMenus()  */

/*****	setUpWindow() *****/

void setUpWindow( void )
{
	WindowPtr	myWind;

	myWind = GetNewCWindow(WINDOWID, nil, PUTINFRONT);

	if (myWind != nil)
	{
		ShowWindow(myWind);
	}

	SelectWindow(myWind);
}

void doMousedown(EventRecord *eventRec)
{
	short		windPart;
	WindowPtr	myWind;
	long		menuResult;
	
	windPart = FindWindow(eventRec->where, &myWind);
	
	switch(windPart)
	{
		case inContent:
			SelectWindow(myWind);
			break;

		case inDrag:
			DragWindow( myWind, eventRec->where, &qd.screenBits.bounds );
			break;

		case inMenuBar:
			menuResult = MenuSelect(eventRec->where);
			dispatch(menuResult);
			break;

		case inSysWindow:
			SystemClick( eventRec, myWind );
			break;
			
		case inGoAway:
			gQuitTheApp = true;
			break;
			
		default:
			break;
	}
	return;
} 				


void doKey(EventRecord *eventRec)
{
	char	keyPressed;
	long	menuResult;
	
	keyPressed = (char) (eventRec->message & charCodeMask);
	
	if((eventRec->modifiers & cmdKey) != 0)
	{
		menuResult = MenuKey(keyPressed);
		dispatch(menuResult);	
	}
	return;
} 		


void doHighLevel(EventRecord *eventRec)
{
	OSErr myErr;
	myErr = AEProcessAppleEvent(eventRec);
}


pascal OSErr	DoOpenAppAE(AppleEvent theAppleEvent, AppleEvent reply, long refCon)
{
	setUpWindow();
	return(noErr);
}
pascal OSErr	DoOpenDocAE(AppleEvent theAppleEvent, AppleEvent reply, long refCon)
{
	return(noErr);
}
pascal OSErr	DoPrintDocAE(AppleEvent theAppleEvent, AppleEvent reply, long refCon)
{
	return(noErr);
}
pascal OSErr	DoQuitAppAE(AppleEvent theAppleEvent, AppleEvent reply, long refCon)
{
	gQuitTheApp = true;
	return(noErr);
}


void	doUpdate(EventRecord *eventRec)
{
	GrafPtr		savedPort;
	WindowPtr	theWindow;
	Rect		windowRect;
	long		bufferSize;

	theWindow = (WindowPtr) eventRec->message;
	
	GetPort(&savedPort);
	SetPort((GrafPtr) theWindow);

	windowRect = theWindow->portRect;
	InsetRect(&windowRect,2,2);
	BeginUpdate(theWindow);
	bufferSize = GetPtrSize(gBufferPtr);
	
	if (bufferSize > kExtremePos)	//Take only first 32K otherwise bad Karma
		bufferSize = kExtremePos;
	
	TETextBox(gBufferPtr,bufferSize,&windowRect,teFlushDefault);
	EndUpdate(theWindow);
	SetPort(savedPort);
}


void dispatch(long menuResult)
{
	short		theMenu;			
	short		theItem;			
	
	theMenu = HiWord (menuResult);		
	theItem = LoWord (menuResult);	
	
	switch (theMenu)
	{
		case APPLEMENU:
			doAppleCmds(theItem);
			break;

		case FILEMENU:
			doFileCmds(theItem);
			break;
	}
	HiliteMenu(0);
}			


void doAppleCmds(short theItem)
{	
	MenuHandle		myMenu;
	Str255			name;
	short			dummy;
	
	if(theItem == appleABOUT)
	{
		Alert(ABOUTID, (ModalFilterUPP) NIL);
	}
	else
	{
		myMenu = GetMHandle (APPLEMENU);
		if (myMenu)
		{
			GetItem(myMenu, theItem, name);
			dummy = OpenDeskAcc(name);
		}
	}
	return;
} 	



void doFileCmds (short theItem)
{
	switch (theItem)
	{			
		case clearDataFork:
			ClearDataFork();
			break;

		case fileQUIT:
			gQuitTheApp = true;
			break;
	}
	return;
} 


//checks the data fork of the current application to see if 
//empty. First obtain an FSSpec for the current Application
//then use File Manager routines to get the necessary file Info.
OSErr	checkforSelfContained(short	*vRefNumToSearch)
{

	OSErr					theError;
	ProcessSerialNumber		theCurrentProcess;
	ProcessInfoRec			theInfo;
	long					fileLength;
	short					refNum = 0;
	MenuHandle				theMenu;

	theInfo.processName = NULL;		
	theInfo.processInfoLength = sizeof(ProcessInfoRec);
	theInfo.processAppSpec = &gApplicationProcessInfo;
	
	theCurrentProcess.highLongOfPSN = 0;	
	theCurrentProcess.lowLongOfPSN = kCurrentProcess;	
	
	theError = GetProcessInformation(&theCurrentProcess,&theInfo);
	if (theError != noErr)
		return theError;
		

	theError = FSpOpenDF(&gApplicationProcessInfo, fsRdWrPerm,&refNum);

	if (theError == noErr)
		 theError = GetEOF(refNum, &fileLength);

	if (fileLength != 0)
	{
		theMenu = GetMHandle(FILEMENU);
		EnableItem(theMenu,clearDataFork);		//enable clearing of the data fork
		theError = processFile(&gApplicationProcessInfo,refNum,fileLength);
		
		if (!theError)
				reverseFile(refNum);
	}
	else
	{
		theError = appendTextFileToApp(refNum);
	}

	theError = FSClose(refNum);

	*vRefNumToSearch = refNum;

	return theError;
}

OSErr checkForProductRegistrationInfo(short refNum)
{
	ProductRegistrationInfo myInfo;
	OSErr	theError;
	long	tagInfo;
	long	dataSize = sizeof(long);
	Byte	fragType,fragLocation;
	long	fragOffset,fragLength;

	Str255	msg1,msg2,msg3,msg4;
	
	long	number;

	GetCFRGInfo(&fragType,&fragLocation,&fragOffset,&fragLength);

	theError = FSRead(refNum, &dataSize, &tagInfo);
	
	if (tagInfo == 'DATA' && !theError)
	{
		theError = SetFPos(refNum,fsFromStart,0);			//reset the fileposition, and read the data in one fell swoop
		dataSize = sizeof(myInfo);							//Size of data to read

		if (!theError)
		{
			theError = FSRead(refNum, &dataSize, &myInfo);	//

			NumToString((long)myInfo.versionNumber, msg1);
			if(myInfo.demoVersion)
				PLstrcpy(msg2,"\pTRUE");
			else
				PLstrcpy(msg2,"\pFALSE");

			msg3[0] = 1;
			msg3[1] = myInfo.creditRating;
			PLstrcpy(msg4,myInfo.subliminalMessage);
			ParamText(msg1, msg2,msg3, msg4);
			CautionAlert(5002,NULL);
		}
//Same code as above, however we Seek to the end of the PowePC code to look for our Data
	dataSize = sizeof(myInfo);							//Size of data to read
	theError = SetFPos(refNum,fsFromLEOF,-dataSize);
	if (!theError)
	{
		dataSize = sizeof(long);							//Size of the "start of Data" indicator.
		theError = FSRead(refNum, &dataSize, &tagInfo);
	}

	if (tagInfo == 'DATA' && !theError)
	{
		dataSize = sizeof(myInfo);							//Size of data to read
		theError = SetFPos(refNum,fsFromLEOF,-dataSize);	//reset the fileposition, and read the data in one fell swoop

		if (!theError)
		{
			theError = FSRead(refNum, &dataSize, &myInfo);	//

			NumToString((long)myInfo.versionNumber, msg1);
			if(myInfo.demoVersion)
				PLstrcpy(msg2,"\pTRUE");
			else
				PLstrcpy(msg2,"\pFALSE");

			msg3[0] = 1;
			msg3[1] = myInfo.creditRating;

			PLstrcpy(msg4,myInfo.subliminalMessage);
			ParamText(msg1, msg2,msg3, msg4);
			CautionAlert(5002,NULL);
		}
	 }

	return 1;
  }

	theError = SetFPos(refNum,fsFromStart,0);
	
	return noErr;
}



//Read data out of Data Fork, from the file referenced by refNum.
//store it in a global buffer.
OSErr processFile( FSSpecPtr fsspec,short refNum,long fileLength)
{
	OSErr 		theError;

	if (checkForProductRegistrationInfo(refNum))
		return 1;		// For illustration purposes, don't do anything with the data fork

	if (fileLength > kExtremePos)
		return memFullErr;

	gBufferPtr = NewPtrClear(fileLength);

	if (!gBufferPtr)
		return MemError();

	theError = FSRead(refNum, &fileLength, gBufferPtr);	//read stuff from Data Fork

	return theError;
}


//reverse the contents of the data fork of the file
//pointed to by refNum. Allocates a temporary buffer
//equal in size to the global buffer. In practice the max size
//will be at most kExtremePos.
void reverseFile(short refNum)
{	
	Ptr	 		tempBuffer;				//this will hold a copy of the data to
	long		bufferSize;				//be written to disk
	OSErr 		theError;
	short		index;
	
	if (gBufferPtr == NULL)
		return;

	bufferSize	= GetPtrSize(gBufferPtr);

	if (bufferSize == 0)
		return;

	tempBuffer = NewPtrClear(bufferSize);

	if (tempBuffer == NULL)
		return;

	index = bufferSize;

	while (index >= 0)
	{
		tempBuffer[bufferSize - index] = gBufferPtr[index - 1];
		index--;
	} 

	theError = SetFPos(refNum,fsFromStart,0);		//reset file position pointer
	theError = FSWrite(refNum, &bufferSize, tempBuffer);

	if (tempBuffer)
		DisposePtr(tempBuffer);

}

void	exitApp(void)
{
	if (gBufferPtr)
	{
		DisposePtr(gBufferPtr);
	}
}

//This function is called If the data fork of the
//application is empty. It presents a standard file open
//dialog that allows user to pick a text file which will then be
//copied into the data fork of the running Application. 
//It will only copy the 1st 32K of text if the file is bigger
//than 32K.
OSErr appendTextFileToApp(short destRefNum)
{
	OSErr				theError = noErr;
	StandardFileReply	sfReply;
	short				numTypes = 1;
	SFTypeList			typeList = {'TEXT'};
	short				sourceRefNum;
	long				fileLength;

	StandardGetFile(NULL,numTypes,typeList,&sfReply);

	if (sfReply.sfGood)
	{
		theError = FSpOpenDF(&sfReply.sfFile, fsRdWrPerm,&sourceRefNum);
	
		if (theError == noErr)
			 theError = GetEOF(sourceRefNum, &fileLength);

		if (fileLength > kExtremePos)
			fileLength = kExtremePos;	//don't read more than 32k of text
	
		if (theError == noErr)
			gBufferPtr = NewPtrClear(fileLength);
	
		if (gBufferPtr)
			theError = FSRead(sourceRefNum, &fileLength, gBufferPtr);
	
		if (theError == noErr)
			theError = FSWrite(destRefNum, &fileLength, gBufferPtr);
	
		if (theError == noErr)
			 reverseFile(destRefNum);
			
	}

	return theError;
}


//Call This routine to clear the data fork of the current application.
void ClearDataFork(void)
{
	OSErr 		theError;
	short 		refNum;
	MenuHandle	theMenu;

	theError = FSpOpenDF(&gApplicationProcessInfo, fsRdWrPerm,&refNum);

	if (!theError) 
		theError = SetEOF(refNum,0);	//clear data fork

	if (!theError)
	{
		theMenu = GetMHandle(FILEMENU);
		DisableItem(theMenu,clearDataFork);		//disable clearing of the data fork
	}

}


static	OSErr GetCFRGInfo(Byte *fragmentType, Byte *fragmentLocation,
						 long *fragmentOffset, long *fragmentLength)
{
	codeFragRecHandle	cfrgHndl;
	codeFragRecPtr		cfrgRecPtr;
	
	OSErr	theError = -1;
	
	cfrgHndl = (codeFragRecHandle) Get1Resource('cfrg',0);
	
	if (cfrgHndl != NULL)
	{
		HLock((Handle) cfrgHndl);
		*fragmentType    	= (**cfrgHndl).fragArray[0].TypeOfFrag;
		*fragmentLocation 	= (**cfrgHndl).fragArray[0].LocationOfFrag;
		*fragmentOffset		= (**cfrgHndl).fragArray[0].OffsetToFrag;
		*fragmentLength		= (**cfrgHndl).fragArray[0].LengthOfFrag;
		HUnlock((Handle) cfrgHndl);
		ReleaseResource((Handle) cfrgHndl);
		return noErr;
	}
	return theError;
}






