/******************************************************************************
**
**  Project Name:	DropShell
**     File Name:	DSGlobals.h
**
**   Description:	Globals used by DropShell
**
*******************************************************************************
**                       A U T H O R   I D E N T I T Y
*******************************************************************************
**
**	Initials	Name
**	--------	-----------------------------------------------
**	LDR			Leonard Rosenthol
**	MTC			Marshall Clow
**	SCS			Stephan Somogyi
**
*******************************************************************************
**                      R E V I S I O N   H I S T O R Y
*******************************************************************************
**
**	  Date		Time	Author	Description
**	--------	-----	------	---------------------------------------------
**	02/20/94			LDR		Added commenting for Metrowerks
**	12/09/91			LDR		Added gSplashScreen
**	11/24/91			LDR		Added some new #defs & a #inc for DSUtils
**	10/29/91			SCS		Changes for THINK C 5
**	10/28/91			LDR		Officially renamed DropShell (from QuickShell)
**	10/06/91	00:02	MTC		Converted to MPW C
**	04/09/91	00:03	LDR		Added to Projector
**
******************************************************************************/

#ifndef	__DSGLOBALS_H__
#define	__DSGLOBALS_H__


#ifndef __MWERKS__
#include <Types.h>
#include <Memory.h>
#include <QuickDraw.h>
#include <OSUtils.h>
#include <ToolUtils.h>
#include <Menus.h>
#include <Packages.h>
#include <Traps.h>
#include <Files.h>
#endif

#include <Aliases.h>
#include <AppleEvents.h>
#include <GestaltEqu.h>
#include <Processes.h>


#define	kAppleNum	128
#define	kFileNum	129
		
#define	kErrStringID	100
#define	kCantRunErr		1
#define	kAEVTErr		2

// ------------------------------------------------------------------
#define		qWalkFolders 		FALSE
#define		kMaxResourceSize 	16 * 1024 * 1024	// resources cannot be bigger than 16 MB
#define		kPowerPCCode		'PCOD'				// resource type to store the data in
#define		kPowerPCID			0       			// resource id for Power PC code
	
#define		kMemErrorID			201
#define		kTooBigID			202
#define		kCantOpenRes		203
#define		kDataForkError		204
#define		kNoDataFork			205

#define		kFragmentInRom		0
#define		kFragmentInDataFork	1
#define		kFragmentInResource	2
// These are the different types of code fragments
#define		kUsageIsLibrary		0
#define		kUsageIsApplication	1
#define		kUsageIsExtension	2

#define		kWholeFork			 0
#define		kOnDiskFlat 		 1
#define		kWholeFork 		 	 0
#define		kBeginningOfFragment 0	
#define		kOptionKeyScanCode	0x3A
#define		kControlKeyScanCode	0x3B

// ------------------------------------------------------------------

// The format of the 'cfrg' on disk. This is defined in <CodeFragmentTypes.r>
#ifdef powerc
	#pragma options align=mac68k
#endif

typedef		struct	fragDescriptors
{
		long		CodeType;
		long		UpdateLevel;
		long		CurrentVersion;
		long		OldestDefVersion;
		long		AppStackSize;
		short		AppLibDirectory;
		Byte		TypeOfFrag;
		Byte		LocationOfFrag;
		long		OffsetToFrag;
		long		LengthOfFrag;
		long		Reserved1;
		long		Reserved2;
		short		itemSize; 
		Str255		Fragname;
}fragDescriptors;

#ifdef powerc
	#pragma options align=reset
#endif


typedef	struct fragDescriptors  fragDescriptors;

typedef fragDescriptors FragArray[1];

typedef	struct codeFragRecord
{
		long			Reserved1;
		long			Reserved2;
		long			Version;
		long			Reserved3;
		long			Reserved4;
		long			Reserved5;
		long			Reserved6;
		long			NumberofFrags;
		FragArray		fragArray; 		// array[0..0] of fragDescriptors;		
}codeFragRecord;

typedef struct codeFragRecord *codeFragRecPtr, **codeFragRecHandle;


typedef struct	ProductRegistrationInfo
{
		long		startOfData;
		short		versionNumber;
		Boolean		demoVersion;
		char		creditRating;
		Str255		subliminalMessage;
		long		endOfData;
}ProductRegistrationInfo;

extern Handle		gMessage;

//rs ------------------------------------------------------------------		
		
extern Boolean		gDone,gReverseOperation, gOApped, gHasAppleEvents, gWasEvent,gAddRegistrationInfoOnly;
extern EventRecord	gEvent;
extern MenuHandle	gAppleMenu, gFileMenu;
extern WindowPtr	gSplashScreen;




#endif
