// BTreeProtos

// B-Tree HELPER -  1985-90, 1993-5 (M)agreeable software, inc.

// Version 2.2

// 22 May 1995

#pragma once

// Prototypes of B-Tree HELPER functions to be called externally
						
// Key_Mgr

#ifdef __cplusplus
extern "C"
{
#endif

OSErr Insert_Key (short							treeNr,
		 							Boolean						duplicateKeys,
		 							FileControlHandle	fileControlH,
									Ptr								searchKeyP,
									FileAddr					recordAddr, 
		 							CompareProcPtr		Compare);
			
OSErr Delete_Key (short							treeNr,
									Boolean						duplicateKeys,
									FileControlHandle	fileControlH,
									Ptr								searchKeyP,
									FileAddr					*recordAddrP, 
		 							CompareProcPtr		Compare);

// FileMgr

OSErr Open_BTreeFile(SFReply						*replyP, 		
											FileControlHandle	*fileControlHP);		

OSErr FSpOpen_BTreeFile (StandardFileReply *replyP,
													short							permission,
													FileControlHandle *fileControlHP);
						
OSErr HOpen_BTreeFile (SFReply					*replyP,
											short							permission,
											FileControlHandle *fileControlHP);
						
OSErr Create_BTreeFile(SFReply						*replyP,		
											FileControlHandle		*fileControlHP, 		
											OSType							creator, 		
											long								fileBlockSize, 		
											long								spareBlocks, 		
											TreeListHandle			newTreeH);		

OSErr FSpCreate_BTreeFile (StandardFileReply	*replyP,		
													FileControlHandle		*fileControlHP, 		
													OSType					 		creator, 		
													long						 		fileBlockSize, 		
													long								spareBlocks, 		
													TreeListHandle			newTreeH);
						
OSErr Write_FileControl(FileControlHandle fileControlH);		

OSErr Close_BTreeFile(FileControlHandle *fileControlHP);

// MapMgr

OSErr Read_Map(FileControlHandle fileControlH, 		
								FileAddr					newMapAddr);

OSErr Get_Bytes(FileControlHandle	fileControlH, 		
				 				FileAddr					*recordAddrP, 		
				 				long							nrBytes);		

OSErr Release_Bytes(FileControlHandle	fileControlH,
										FileAddr					recordAddr, 		
							 			long							nrBytes);

// PageMgr

OSErr Read_Page(FileControlHandle	fileControlH, 		
				 				long							pageSize, 		
				 				FileAddr					pageAddr, 		
				 				PageHandle				*pageHP);

#if qDebug
void Print_Page(char						*title,
								PageHandle			pageH,
								FileAddr				pageAddr,
								CompareProcPtr	Compare);
#endif

// RecordMgr

OSErr Read_Data (FileControlHandle	fileControlH,
									long							recordSize,
									FileAddr					recordAddr,
									Ptr								recordP);


OSErr Write_Data (FileControlHandle	fileControlH,
									long							recordSize,
									FileAddr					recordAddr, 
									Ptr								recordP);

OSErr Read_Ptr (FileControlHandle	fileControlH,
								FileAddr					recordAddr, 
								Ptr								recordP);


OSErr Write_Ptr (FileControlHandle		fileControlH,
									FileAddr						recordAddr, 
									Ptr									recordP);

OSErr Read_Handle (FileControlHandle	fileControlH,
										FileAddr					recordAddr, 
										Handle						recordH);


OSErr Write_Handle (FileControlHandle		fileControlH,
										FileAddr						recordAddr,
										Handle							recordH);

OSErr Create_Buffers (short							bufferCount,
											short							factor,
											FileControlHandle fileControlH);

OSErr Flush_Buffers (FileControlHandle fileControlH);

OSErr Close_Buffers (FileControlHandle fileControlH);

// SearchMgr

OSErr Change_Address (short							treeNr,
											FileControlHandle	fileControlH,
											Ptr								searchKeyP,
											FileAddr					oldAddr,
											FileAddr					newAddr,
											CompareProcPtr		Compare);

void Edit_RecordList (FoundListHandle foundListH);

OSErr Find_Equal (short							treeNr,
									FileControlHandle	fileControlH,
									Ptr								searchKeyP,
									Ptr								foundKeyP,
									FileAddr					*foundAddrP,
									CompareProcPtr		Compare);

OSErr Find_Greater (short							treeNr,
										FileControlHandle	fileControlH,
										Ptr								searchKeyP,
										Ptr								foundKeyP,
										FileAddr					*foundAddrP,
										CompareProcPtr		Compare);

OSErr Find_Less (short							treeNr,
									FileControlHandle	fileControlH,
									Ptr								searchKeyP,
									Ptr								foundKeyP,
									FileAddr					*foundAddrP,
									CompareProcPtr		Compare);
				
OSErr Find_ListAll (short							treeNr,
										short							passType, 
										FileControlHandle	fileControlH,
										FoundListHandle		foundListH);
				
OSErr Find_ListEqual (short							treeNr,
											short							passType,
											FileControlHandle	fileControlH,
											Ptr								searchKeyP,
											FoundListHandle		foundListH,
											CompareProcPtr		Compare);
		 		
OSErr Find_ListGreater (short							treeNr,
												short							passType,
												FileControlHandle	fileControlH,
												Ptr								searchKeyP,
												FoundListHandle		foundListH,
												CompareProcPtr		Compare);
		 		
OSErr Find_ListGreaterEqual (short							treeNr,
															short							passType,
															FileControlHandle	fileControlH,
															Ptr								searchKeyP,
															FoundListHandle		foundListH,
															CompareProcPtr		Compare);
		 		
OSErr Find_ListLess (short							treeNr,
											short							passType,
											FileControlHandle	fileControlH,
											Ptr								searchKeyP,
											FoundListHandle		foundListH,
											CompareProcPtr		Compare);
		 		
OSErr Find_ListLessEqual (short							treeNr,
													short							passType,
													FileControlHandle	fileControlH,
													Ptr								searchKeyP,
													FoundListHandle		foundListH,
													CompareProcPtr		Compare);

OSErr Find_Next (short							treeNr,
									FileControlHandle	fileControlH,
									Ptr								searchKeyP,
									FileAddr					previousAddr,
									Ptr								foundKeyP,
									FileAddr					*foundAddrP,
									CompareProcPtr		Compare);

OSErr Find_Previous (short							treeNr,
											FileControlHandle	fileControlH,
											Ptr								searchKeyP,
											FileAddr					previousAddr,
											Ptr								foundKeyP,
											FileAddr					*foundAddrP,
											CompareProcPtr		Compare);

OSErr Find_ListInRange (short							treeNr,
												short							passType,
												FileControlHandle	fileControlH,
												Ptr								lowKeyP,
												Ptr								highKeyP,
												FoundListHandle		foundListH,
												CompareProcPtr		Compare);

void Reset_RecordList (FoundListHandle foundListH);

// TreeMgr

OSErr Add_Tree(TreeControlRecord		*newTree,
								FileControlHandle		fileControlH);

OSErr Delete_Tree(short							treeNr,
									FileControlHandle	fileControlH);

OSErr Clear_Tree(short							treeNr,
									FileControlHandle	fileControlH);

#ifdef __cplusplus
}
#endif

// BTreeProtos.h