// creates a data file that contains a picture and some text in the data fork
// very primitive, but avoids a lot of clipboard calls and shows how to handle
//the data fork side of the problem, which is what the article is about
// copyright Edward Ringel, 1996.  All rights reserved.

#include "BTreeDef.h"
#include "BTreeProtos.h"
#include "StandardFile.h"



 #define kBlockSize		100L
 #define kSpareBlocks	10L
 #define kType			'IExP'
 #define kCreator		'IExA'
 
 // thus structure is placed in the file as a pointer to further information
 // about the two chunks of data.
 struct DataInfoType {
 		long PicSize;
 		long PicAddr;
 		long StrSize;
 		long StrAddr;
 		};
 typedef struct DataInfoType DataInfoType;
 
 
 // These are variables that will be used by B-Tree Helper 
 TreeListHandle 		gPictureTrees;
  FileControlHandle		gPictureFCH;
 long					gBlockSize;
 long					gSpareBlocks;
 StandardFileReply		gFileReply;
 SFTypeList				gTypeList;
 short					gNumTypes;
 short					gPermission;
 short					PicError;
 long					DataSize;
 FileAddr				DataAddr;
 DataInfoType			DataInfo;
 FileAddr				DataInfoAddr;

 
 
 void main() {
 	Handle				DataHandle;
 // init the toolbox
	MaxApplZone();
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);
	InitCursor();
	FlushEvents(0,everyEvent);
// make a new Tree List with no members	
	gPictureTrees = (TreeListHandle)NewHandle(2);
	(**gPictureTrees).nrTrees = 0;
// standard file stuff
	StandardPutFile("\pCreate New Picture File", "\puntitled", &gFileReply);
	gFileReply.sfType = kType;
// create the file
	PicError = FSpCreate_BTreeFile(&gFileReply,&gPictureFCH,kCreator,kBlockSize,kSpareBlocks,gPictureTrees);
// allocate space for the "pointer" record
	PicError = Get_Bytes(gPictureFCH,&DataInfoAddr,16);
// rather than handling opening a resource file, 
// I simply made the file part of the app-- I know, I know;  sloppy
//  don't care if it's a PICT or not, just get the data and data size
	DataHandle = GetResource('PICT',129);
	DataSize = GetHandleSize(DataHandle);
	DataInfo.PicSize = DataSize;
// allocate the space for the PICT info in the data fork
	PicError = Get_Bytes(gPictureFCH,&DataAddr,DataSize);
	DataInfo.PicAddr = DataAddr;
// use B-Tree Helper call to write the info
	PicError = Write_Handle(gPictureFCH,DataAddr,DataHandle);
// embed the file address of the DataInfo struct into the file control record.
// the way BTH is made, the file control record survives across file opens/closes
// the address of DataInfo will be instantly available as soon as the file is open
	(**gPictureFCH).application1 = DataInfoAddr;
// now do the same for the TEXT stuff
	DataHandle = GetResource('TEXT',128);
	DataSize = GetHandleSize(DataHandle);
	DataInfo.StrSize = DataSize;
	PicError = Get_Bytes(gPictureFCH,&DataAddr,DataSize);
	DataInfo.StrAddr = DataAddr;
	PicError = Write_Handle(gPictureFCH,DataAddr,DataHandle);
// now write in the DataInfo into the file
	PicError = Write_Data(gPictureFCH,16,DataInfoAddr,(Ptr)&DataInfo);
// close the file and terminate execution by stepping out of main()
	PicError = Close_BTreeFile(&gPictureFCH);

 }

