                        /*  1995 by Mesa Graphics 	*/
                        /*	   411 Cheryl Ave		*/
                        /*	   Los Alamos, NM 87544 */

#include "register.h"


void PrintRegForm(DialogPtr theDialog)
{ 
	short		index, which, xpos, ypos, theType;
    Handle 		theTextHdl;
    Rect 		itemBox;
    GrafPtr 	thePort;
    Str255 		thestr, pbuf;
	TPPrPort 	PPort;
	THPrint 	prh;
	Boolean 	tmpb;
	TPrStatus	status;
	Point		pos;
	
 	if (regFrstPrtItem <= regLastPrtItem)        /*there is something to print*/
 	{
	 	GetPort(&thePort);
		prh = (THPrint) NewHandle(sizeof(TPrint));
		PrOpen();
		PrintDefault(prh);
		tmpb = PrValidate(prh);
		tmpb = PrStlDialog(prh);
		if (PrJobDialog(prh))
		{
			PPort = PrOpenDoc(prh,nil,nil);
			TextFont(times);
			TextSize(12);
			if (PrError() == noErr)  PrOpenPage(PPort,nil);
			  
		 	for ( index = regFrstPrtItem; index <= regLastPrtItem; index++)
		 	{
			  GetDialogItem (theDialog, index, &theType, &theTextHdl, &itemBox);
			  GetDialogItemText (theTextHdl, thestr);
			  if ( StrLength(thestr) > 0)
			  {
			  	xpos = itemBox.left;
			  	ypos = itemBox.top + 12;
			  	MoveTo(xpos,ypos);
			  	for ( which = 1; which <= StrLength(thestr); which++)
			  	{
			  		if ( thestr[which] < ' ')
			  		{
			  			ypos= ypos +12;
			  			MoveTo(xpos,ypos);
			  		} else DrawChar(thestr[which]);
			  		if ( thestr[which] == ' ')
			  		{
			  			GetPen(&pos);
			  			if ( pos.h >= itemBox.right)
			  			{	
			  				ypos= ypos +12;
			  				MoveTo(xpos,ypos);
			  			}
			  		}

			  	}
			  }
		 	}
		 	if (PrError() == noErr)
		 	{
		 		PrClosePage(PPort);
				PrCloseDoc(PPort);
				if ( (**prh).prJob.bJDocLoop == bSpoolLoop) PrPicFile(prh,nil,nil,nil, &status);
			}
				
			PrClose();
			DisposeHandle((Handle) prh);
			SetPort(thePort);
		}
	 } 
}

long ComputeRegistration(Str255 name)
{
	long 	regnum;
	short	i;

	if (StrLength(name) == 0)  regnum = -1; else regnum = regNumSeedValue;
	for (i = 1; i<= StrLength(name); i++)  regnum = regnum + name[i];
	return (regnum);
}
	
void MakeRegistration(void)
{
	DialogPtr	theDialog;
    Handle	theTextHdl;
    Rect	itemBox;
    short	itemHit, theType;
    GrafPtr	thePort;
    Str255	tmpstr;
    long	regwordL;


    FlushEvents (everyEvent, 0); /*this throws out leftover clicks, keys*/
    theDialog = GetNewDialog (registerDLog, nil, (WindowPtr) -1);
    if (theDialog != nil)
    {
    	ShowDialogItem(theDialog,regMkPwdItem); /*Shows the Make Password button*/
    	GetPort(&thePort);
		SetPort (theDialog);
     	ShowWindow (theDialog);
      	do
      	{
      		ModalDialog (nil, &itemHit); 
      		if (itemHit == regMkPwdItem)
      		{
      			GetDialogItem (theDialog, regNameItem, &theType, &theTextHdl, &itemBox);
           		GetDialogItemText (theTextHdl,tmpstr);
          	 	regwordL = ComputeRegistration(tmpstr);
           		NumToString(regwordL,tmpstr);
           		GetDialogItem (theDialog, regNumberItem, &theType, &theTextHdl, &itemBox);
           		SetDialogItemText (theTextHdl,tmpstr);
      		} else if (itemHit == regPrintItem) PrintRegForm(theDialog);
       	}while (itemHit > cancel);
     	
     	DisposeDialog(theDialog);
     	SetPort(thePort);
    	SetCursor(&qd.arrow);
   	}
}
	
void UnRegister(void)
{
	Handle	tmpHan;
	short	index;
	do
	{
		tmpHan = GetResource(regDataResType, regNameItem);
		if (tmpHan != nil)
		{	RemoveResource(tmpHan);
			DisposeHandle(tmpHan);
			UpdateResFile(CurResFile());
		}
	} while  (tmpHan != nil);
	
	do
	{
		tmpHan = GetResource(regDataResType, regNumberItem);
		if (tmpHan != nil)
		{	RemoveResource(tmpHan);
			DisposeHandle(tmpHan);
			UpdateResFile(CurResFile());
		}
	} while (tmpHan != nil);

	for (index = regFrstOtherSaveItem; index <= regLastOtherSaveItem; index++)
	do
	{	tmpHan = GetResource(regDataResType, index);
		if (tmpHan != nil)
		{	RemoveResource(tmpHan);
			DisposeHandle(tmpHan);
			UpdateResFile(CurResFile());
		}
	} while (tmpHan != nil);
}

void Register(void)
{
	DialogPtr	theDialog;
    Handle	theTextHdl;
    Rect	itemBox;
    short	itemHit, theType, index;
    GrafPtr	thePort;
    Str255	namestr, regstr;
    long	regwordL;
    StringHandle	nameHan, strHan;
    longhan	regsHan;


    FlushEvents (everyEvent, 0); /*this throws out leftover clicks, keys*/
    if ( Alert(shareSplashAlert, nil) == ok )
    {
	    FlushEvents (everyEvent, 0); /*this throws out leftover clicks, keys*/  
	    theDialog = GetNewDialog (registerDLog, nil, (WindowPtr) -1);
	    if (theDialog != nil)
	    {
	    	HideDialogItem(theDialog,regMkPwdItem);  /*Hides the Make Reg Number button*/
	    											/*fill in text fields from save values*/
			strHan = (StringHandle) GetResource(regDataResType, regNameItem);
			if ( strHan != nil) 
			{
  				GetDialogItem (theDialog, regNameItem, &theType, &theTextHdl, &itemBox);
      			SetDialogItemText (theTextHdl, *strHan);
      			ReleaseResource((Handle) strHan);
      		}

			for ( index = regFrstOtherSaveItem; index <= regLastOtherSaveItem; index ++)
			{
				strHan = (StringHandle) GetResource(regDataResType, index);
				if (strHan != nil)
				{
  					GetDialogItem (theDialog, index, &theType, &theTextHdl, &itemBox);
      				SetDialogItemText (theTextHdl, *strHan);
      				ReleaseResource((Handle) strHan);
      			}
      		}
	    	
	    	GetPort(&thePort);
			SetPort (theDialog);	    /*this makes later GlobalToLocal calls work right*/
	      	ShowWindow (theDialog);    	
	     	do
	     	{
	      		ModalDialog (nil, &itemHit); 
	      		if ( itemHit == regPrintItem ) PrintRegForm(theDialog);	     	
	        }	while (itemHit > cancel);
	        
	      if (itemHit == ok)
	      {
	      	GetDialogItem (theDialog, regNameItem, &theType, &theTextHdl, &itemBox);
	      	GetDialogItemText (theTextHdl, namestr);
	      	GetDialogItem (theDialog, regNumberItem, &theType, &theTextHdl, &itemBox);
	      	GetDialogItemText (theTextHdl,regstr);
	      	StringToNum(regstr, &regwordL);
	      	if ( Length(namestr) > 0)
	      	{
				UnRegister();
				regsHan = (longhan) NewHandle(4);
	      		nameHan = NewString(namestr);
	      		**regsHan = regwordL;
	      		AddResource( (Handle) nameHan, regDataResType, regNameItem , "\p");
				if ( ResError() != noErr) {	itemHit = StopAlert(lockedAlert,nil);}
				WriteResource( (Handle) nameHan);
	      		AddResource( (Handle) regsHan,regDataResType, regNumberItem , "\p");
				if ( ResError() != noErr) { itemHit = StopAlert(lockedAlert,nil); }
				WriteResource( (Handle) regsHan);
				UpdateResFile(CurResFile());
				for ( index = regFrstOtherSaveItem; index <= regLastOtherSaveItem; index++)
				{
	      			GetDialogItem (theDialog, index, &theType, &theTextHdl, &itemBox);
	      			GetDialogItemText (theTextHdl,namestr);
	      			nameHan = NewString(namestr);
	      			AddResource( (Handle) nameHan,regDataResType, index , "\p");
					if ( ResError() != noErr) { itemHit = StopAlert(lockedAlert,nil); }
					WriteResource( (Handle) nameHan);
					UpdateResFile(CurResFile());
				}
			}
	 	}						/* itemHit == ok */
	      
	    DisposeDialog(theDialog);
	    SetPort(thePort);
	   	SetCursor(&qd.arrow);
	   }
	}
}

void CheckRegistration(void)
{
	StringHandle	namehan;
	longhan		regwdhan;
	long		inregwdnum, computeregwdnum;


	namehan = (StringHandle) GetResource(regDataResType, regNameItem);
	regwdhan = (longhan) GetResource(regDataResType, regNumberItem);
	if ( (namehan != nil) && (regwdhan != nil) )
	{
		if ( (GetHandleSize((Handle) namehan) > 1) && (GetHandleSize((Handle) regwdhan) == 4)  )
		{
			HLock( (Handle) namehan);
			HLock( (Handle) regwdhan);
			computeregwdnum = ComputeRegistration(*namehan);
			inregwdnum = **regwdhan;
			HUnlock( (Handle) namehan);
			HUnlock( (Handle) regwdhan);
			if ( namehan != nil) ReleaseResource( (Handle) namehan);
			if ( regwdhan != nil) ReleaseResource( (Handle) regwdhan);
			regwdhan = nil;
			namehan = nil;
			if ( inregwdnum != computeregwdnum)  Register();
		}
		} else 
		{
			if ( namehan != nil )  ReleaseResource( (Handle) namehan);
			if ( regwdhan != nil ) ReleaseResource( (Handle) regwdhan);
			Register();
	}
}

