/*************************************************************************************
#
#		SprocketInit.c
#
#		Initialize the sprockets.
#
#		Author(s): 	Michael Marinkovich
#					marink@apple.com
#
#		Modification History: 
#
#			12/05/96		MWM 	Initial coding					 
#
#		Copyright  1992-96 Apple Computer, Inc., All Rights Reserved
#
#
#		You may incorporate this sample code into your applications without
#		restriction, though the sample code has been provided "AS IS" and the
#		responsibility for its operation is 100% yours.  However, what you are
#		not permitted to do is to redistribute the source as "Apple Sample Code"
#		after having made changes. If you're going to re-distribute the source,
#		we require that you make it clear in the source that the code was
#		descended from Apple Sample Code, but that you've made changes.
#
*************************************************************************************/

#include <CodeFragments.h>
#include <ToolUtils.h>

#include "DrawSprocket.h"
#include "NetSprocket.h"
#include "InputSprocket.h"
#include "SoundSprocket.h"

#include "App.h"
#include "Proto.h"

extern Boolean 			gHasDrawSprocket;
extern Boolean			gHasNetSprocket;
extern Boolean			gHasInputSprocket;
extern Boolean			gHasSoundSprocket;


//----------------------------------------------------------------------
//
//	SprocketsAvailable - determine which sprockets are available.
//
//
//----------------------------------------------------------------------

void SprocketsAvailable(void)
{

	// All the libs have been *fully* weak linked so we need to 
	// check each sprocket and determine if the fragment is available
	gHasDrawSprocket = !((Ptr)DSpStartup == (Ptr)kUnresolvedCFragSymbolAddress);
	gHasNetSprocket = !((Ptr)NSpInitialize == (Ptr)kUnresolvedCFragSymbolAddress);
	gHasInputSprocket = !((Ptr)ISpInit == (Ptr)kUnresolvedCFragSymbolAddress);
	gHasSoundSprocket = !((Ptr)SSpListener_New == (Ptr)kUnresolvedCFragSymbolAddress);
	

}			
			
			
			
			
			
			
			
			
			