//	------------------------------------------------------------------------------------------	
//
//	Copyright  1996 Apple Computer, Inc., All Rights Reserved
//
//
//		You may incorporate this sample code into your applications without
//		restriction, though the sample code has been provided "AS IS" and the
//		responsibility for its operation is 100% yours.  However, what you are
//		not permitted to do is to redistribute the source as "DSC Sample Code"
//		after having made changes. If you're going to re-distribute the source,
//		we require that you make it clear in the source that the code was
//		descended from Apple Sample Code, but that you've made changes.
//
//		Authors:
//			Chris De Salvo
//
//	------------------------------------------------------------------------------------------	

//	------------------------------	Includes

#include <Dialogs.h>
#include <Processes.h>
#include <TextUtils.h>

#include <string.h>

#include "InputSprocket.h"

#include "ErrorHandler.h"
#include "SIResources.h"

//	------------------------------	Private Definitions
//	------------------------------	Private Constants
//	------------------------------	Private Types
//	------------------------------	Private Structs
//	------------------------------	Private Variables
//	------------------------------	Private Functions
//	------------------------------	Public Variables

//	------------------------------	FatalError

void
FatalError(char *error)
{
Str255	errorHeader;
UInt8	errorString[256];

	strcpy((char *) errorString + 1, error);
	errorString[0] = strlen((char *) errorString + 1);
	GetIndString(errorHeader, kSTRMessageStrings, kSTRiFatal);

	ISpSuspend();
	
	ParamText(errorHeader, errorString, "\p", "\p");
	if (Alert(kALRTFatal, nil) == cancel)
		Debugger();
	
	ExitToShell();
}

//	------------------------------	NonFatalError

void
NonFatalError(char *error)
{
Str255	errorHeader;
UInt8	errorString[256];

	strcpy((char *) errorString + 1, error);
	errorString[0] = strlen((char *) errorString + 1);
	GetIndString(errorHeader, kSTRMessageStrings, kSTRiNonFatal);

	ISpSuspend();
	
	ParamText(errorHeader, errorString, "\p", "\p");
	Alert(kALRTNonFatal, nil);
}
