//	------------------------------------------------------------------------------------------	
//
//	Copyright  1996 Apple Computer, Inc., All Rights Reserved
//
//
//		You may incorporate this sample code into your applications without
//		restriction, though the sample code has been provided "AS IS" and the
//		responsibility for its operation is 100% yours.  However, what you are
//		not permitted to do is to redistribute the source as "DSC Sample Code"
//		after having made changes. If you're going to re-distribute the source,
//		we require that you make it clear in the source that the code was
//		descended from Apple Sample Code, but that you've made changes.
//
//		Authors:
//			Chris De Salvo
//			Michael Evans
//
//	------------------------------------------------------------------------------------------	

#ifndef __EVENT_HANDLER__
#define __EVENT_HANDLER__

//	------------------------------	Includes

#include <Events.h>
#include "InputSprocket.h"

//	------------------------------	Public Definitions
//	------------------------------	Public Types

enum
{
	greenMovement,
	greenFire,
	redMovement,
	redFire,
	abort,
	numInputs
};

typedef Boolean (*EventHandlerProc)(EventRecord *theEvent);

typedef struct EventHandlerSet
{
	EventHandlerProc keyHandler;
	EventHandlerProc autoKeyHandler;
	EventHandlerProc clickHandler;
	EventHandlerProc updateHandler;
	EventHandlerProc diskHandler;
	EventHandlerProc idleHandler;
} EventHandlerSet;

typedef struct GameKeys
{
	Boolean	greenLeft;
	Boolean	greenRight;
	Boolean	greenFire;
	Boolean	redLeft;
	Boolean	redRight;
	Boolean	redFire;
	float	greenMove;
	float	redMove;
} GameKeys, *GameKeysPtr;

//	------------------------------	Public Variables

extern Boolean gDone;
extern SInt32 gDeltaTime;
extern EventHandlerSet gEventHandlers;
extern ISpElementReference gInputElements[];
extern GameKeys gGameKeys;

//	------------------------------	Public Functions

#ifdef __cplusplus
extern "C" {
#endif

extern short EventInit(void);
extern void EventLoop(void);
extern void RegisterEventHandlers(EventHandlerProc keyDown, EventHandlerProc autoKey, EventHandlerProc mouseDown,
							EventHandlerProc update, EventHandlerProc idle);
extern void ModifyEventHandlers(EventHandlerProc keyDown, EventHandlerProc autoKey, EventHandlerProc mouseDown,
							EventHandlerProc update, EventHandlerProc idle);

#ifdef __cplusplus
}
#endif

#endif