//	------------------------------------------------------------------------------------------	
//
//	Copyright  1996 Apple Computer, Inc., All Rights Reserved
//
//
//		You may incorporate this sample code into your applications without
//		restriction, though the sample code has been provided "AS IS" and the
//		responsibility for its operation is 100% yours.  However, what you are
//		not permitted to do is to redistribute the source as "DSC Sample Code"
//		after having made changes. If you're going to re-distribute the source,
//		we require that you make it clear in the source that the code was
//		descended from Apple Sample Code, but that you've made changes.
//
//		Authors:
//			Chris De Salvo
//
//	------------------------------------------------------------------------------------------	

#ifndef __OBJECTACTIONS__
#define __OBJECTACTIONS__

//	------------------------------	Includes

#include "GameObject.h"

//	------------------------------	Public Definitions

#define kPlayerDeathDelay			120L	//	This controls how long a player is frozen after dying

//	------------------------------	Public Types
//	------------------------------	Public Variables
//	------------------------------	Public Functions

#ifdef __cplusplus
extern "C" {
#endif

extern void ObjectIdle(GameObjectPtr theObject);
extern void ObjectBounce(GameObjectPtr theObject);
extern void GreenPlayerAction(GameObjectPtr theObject);
extern void RedPlayerAction(GameObjectPtr theObject);
extern void PlayerShotAction(GameObjectPtr theObject);
extern void PlayerShotAction(GameObjectPtr theObject);
extern void PlayerShotDestroy(GameObjectPtr theObject);
extern void EnemyDestroy(GameObjectPtr theObject);
extern void PointsDestroy(GameObjectPtr theObject);
extern void PointsAction(GameObjectPtr theObject);
extern void EnemyAction(GameObjectPtr theObject);
extern void EnemyShotAction(GameObjectPtr theObject);
extern void EnemyShotDestroy(GameObjectPtr theObject);
extern void PlayerDestroy(GameObjectPtr theObject);

#ifdef __cplusplus
}
#endif

#endif