//	------------------------------------------------------------------------------------------	
//
//		Copyright 1995, Chris De Salvo
//		Not to be distributed without expressed consent
//
//		Written by Chris De Salvo
//
//	------------------------------------------------------------------------------------------	

#ifndef __SPACEINVADERS__
#define __SPACEINVADERS__

//	------------------------------	Includes

#include "GameObject.h"

//	------------------------------	Public Definitions

#define kNumEnemyRows				5
#define kNumEnemyColumns			11

#define kNumEnemies				(kNumEnemyRows * kNumEnemyColumns)

#define kEnemyMovingRight			1
#define kEnemyMovingLeft			2
#define kEnemyDropping				3

//	------------------------------	Public Types
//	------------------------------	Public Variables

extern Boolean gGameInProgress;
extern Boolean	gTwoPlayers;

extern GameObjectPtr gEnemyList;
extern GameObjectPtr gEnemyShotList;
extern GameObjectPtr gPlayerList;
extern GameObjectPtr gGreenPlayerShotList;
extern GameObjectPtr gRedPlayerShotList;
extern GameObjectPtr gMiscObjectList;
extern int gEnemyTask;
extern int gEnemiesChangeDirection;
extern short gEnemyVelocity;
extern short gNumEnemies;
extern unsigned long gEnemyLevel;
extern unsigned long gNumEnemiesProcessed;
extern int gNumRedPlayerLives;
extern int gNumGreenPlayerLives;

//	------------------------------	Public Functions

#ifdef __cplusplus
extern "C" {
#endif

extern void InitNewGame(short wave);
extern void GameLoop(void);
extern void PlayerShoot(GameObjectPtr whichPlayer);
extern void EnemyShoot(GameObjectPtr go);

#ifdef __cplusplus
}
#endif

#endif