// CTB.h - Contains public declarations for Comm Toolbox

// Useful Literals
#define kDoInitCTB		true
#define kDontInitCTB	false
#define kDoPrompt 		true
#define kDontPrompt 	false
#define kAsync			true
#define kSync			false
#define kDoCreate		true
#define kDontCreate		false

// Connection menu items
#define rConnMenuID		259
#define rConnMItem		1
#define rDiscMItem		2
#define rListenMItem	3
#define rSettingsMItem	5

// OSErr codes - I decided to use 1001 - 19999, 
//		since they appear to be unused by Apple
#define kNoConnToolErr		1001
	// No connection tool was found
#define kNothingChosenErr	1002
	// No connection tool was chosen
#define kCMNewErr			1003
	// CMNew failed to return a handle
#define kAlreadyInitErr		1004
	// Already current ctb init
#define kToolNotAvailErr	1005
	// Selected tool was not available
#define kNoConnectionErr	1006
	// Attempted to operate w/o a connection
#define kGetConfigErr		1007
	// Attempt to GetConfig failed

// Function Prototypes
OSErr NewConn(Boolean async, Boolean initCTB, Boolean prompt);
OSErr DisposeConn(void);
Boolean ConnEvent(EventRecord *theEvent);
void ConnActivate(WindowPtr theWindow, Boolean becomingActive);
void ConnResume(WindowPtr theWindow, Boolean resuming);
OSErr putc(unsigned char *c);
OSErr getc(unsigned char *c);
OSErr IdleConn(Boolean *onLine);
void DoConnMenu(short itemNumber);