/* TPiece Class Methods */

#include "Tangrams.h"

void TPiece::IPiece (MyPolygon *theData[], long i)
{
	IShape (theData[i]);
	index = i;
	firstOrigin = *this;
	firstDirection = *firstDefinedSide;
}

void TPiece::getTransform (MyTransform *theTransform[])
{
	MyVertex	v;
	MyTransform	*tf = theTransform[index];

	firstOrigin.getHV (&v);
	tf->doFlip = flipped;
	if (flipped)
	{
		tf->flipH = v.h;		
		firstDirection.flip(pi/2);
		firstOrigin -= firstDirection;
	}
	else
		tf->flipH = 0;

	firstOrigin.getHV (&v);
	tf->rotateCenterH = v.h;
	tf->rotateCenterV = v.v;

	tf->rotateClockwise = firstDefinedSide->getAngle() - firstDirection.getAngle();
	
	TVector offset = getOrigin();
	offset -= firstOrigin;
	TVector *side = firstSide();
	while (side != firstDefinedSide)
	{
		offset += *side;
		side = nextSide (side);
	}
	offset.getHV (&v);
	tf->translateH = v.h;
	tf->translateV = v.v;
	
}
