/*	TShape Class methods */

#include "Tangrams.h"
#include "Debug.h"

TShape::TShape()
{
	flipped = false;
}

void TShape::IShape (MyPolygon *theData)
{
	IPolygon (theData);
	flipped = 0;
	firstDefinedSide = firstSide();
}

Boolean TShape::flip(void)
{
	Boolean result = false;
	
	if (canFlip())
	{
		TVector	*firstSide;
		
		firstSide = sides.first();
		if (firstSide)
		{
			float	base = firstSide->getAngle();
			TVector	*theSide, *nextSide;
			theSide = sides.next(firstSide);
			while (theSide) {
				theSide->flip(base); /* Flip each subsequent side round the first */
				nextSide = sides.next(theSide);
				sides.remove(theSide);	/* and reverse its order */
				sides.insert(theSide, firstSide);
				theSide = nextSide;
			}
		}
		result = flipped = !flipped;
	}
	return result;
}
	
Boolean	TShape::turn ()
{
	TVector *s1 = sides.first();
	sides.remove(s1);
	sides.insert(s1);
	TVector *s2 = sides.first();
	rotate (s1->getAngle() - s2->getAngle());
	return (s2 != firstDefinedSide);
}

void TShape::getTransform (MyTransform *theTransform[])
{
	theTransform = theTransform;
}