/* Class TTangram methods	*/

#include "Tangrams.h"
#include "Debug.h"

TTangram::TTangram ()
{
	xForms = 0;
}

TTangram::TTangram (TTangram& aShape)
{
	unplaced = aShape.unplaced;
	placed = aShape.placed;
	xForms = aShape.xForms;
}


void	TTangram::ITangram (MyPolygon *theShape,
						long numHoles, MyPolygon *theHoles[],
						long numPieces, MyPolygon *thePieces[],
						MyTransform	*theXForms[])
{
	long	i;
	TPiece	*aPiece;
	TShape	*aHole;
	
	IPolygon (theShape);
	
	for (i = 0; i < numPieces; i++)
	{
		aPiece = new TPiece;
		if (aPiece)
		{
			aPiece->IPiece (thePieces, i);
			unplaced.insert (aPiece);
		}
		else
			MyError("\pCan't make a Piece");
	}

	for (i = 0; i < numHoles; i++)
	{
		aHole = new TShape;
		if (aHole)
		{
			aHole->IShape (theHoles[i]);
			unplaced.insert (aHole);
		}
		else
			MyError("\pCan't make a Hole");
	}
	
	xForms = theXForms;
}

void	TTangram::solve (void)
{
	fill (&unplaced, &placed);
	
/*	Get the transform for each piece */
	TShape *aPiece = (TShape *)placed.first();
	while (aPiece)
	{
	/*	Leave out the Holes */
		if (aPiece->canFlip())
			 aPiece->getTransform (xForms);
		aPiece = (TShape *)placed.next(aPiece);
	}
}





