#
#	File:		OSAPlugIn.make
#
#	Contains:	Makefile for OSAPlugIn part
#
#	Written by:	Sue Dumont
#
#	Copyright:	 1994-1995 by Apple Computer, Inc., all rights reserved.
#				

#---------------------------------------------------------------------------	
# PROJECT VARIABLES
#---------------------------------------------------------------------------	

TargetName			= OSAPlugIn
TargetNameILink		= {TargetName} (68k)
TargetNamePPCLink	= {TargetName} (PPC)
TargetNameFat		= {TargetName} (fat)

TargetCreatorType	= PUNR

SourceDir 			= {TargetDir}OSAPlugIn:
SelectPartDir		= {TargetDir}Source:

AdditionalIncludes	= 	-i "{SourceDir}"	-i "{SelectPartDir}"


#---------------------------------------------------------------------------	
# CFM/PEF Version Numbers
#---------------------------------------------------------------------------	
# For detailed instructions on proper CFM/PEF version numbering, see
# Code Fragment Chapter (pg 3-7), Inside Macintosh: PowerPC System Software
#---------------------------------------------------------------------------	

CurrentLibraryVersion =		0x01048000		# 1.0.4 Final
LibraryExportsVersion =		0x00000000		# 0.0
LibraryCodeVersion =		0x00000000		# 0.0

#---------------------------------------------------------------------------	
# DIRECTORY DEPENDENCIES
#---------------------------------------------------------------------------	

"{TargetDir}"   "{SourceDir}"
"{ObjectsDir}"  "{SourceDir}"
"{ObjectsDir}"  "{ODUtilsImplDir}"

#---------------------------------------------------------------------------	
# ROOT TARGET
#---------------------------------------------------------------------------	

BUILDPPCLINK 	 
	"{CppPrecompiledHeaders}"					
	"{TargetDir}{TargetNamePPCLink}"			
	"{SourceDir}SelectPartAgent.exp"

BUILDILINK  
	"{CppPrecompiledHeaders}"					
	"{TargetDir}{TargetNameILink}"				
	"{SourceDir}SelectPartAgent.exp"

BUILDREZ  
	"{ObjectsDir}{TargetName}.PPC.rsrc"			
	"{ObjectsDir}{TargetName}.68k.rsrc"

BUILDIDL  
	"{SourceDir}SelectPartAgent.xih"			
	"{SourceDir}SelectPartAgent.xh"			
	"{SourceDir}SelectPartAgent.exp"
	
#---------------------------------------------------------------------------	
# FILE LIST VARIABLES
#---------------------------------------------------------------------------	

OSAPlugInOBJECTS = 				
	"{ObjectsDir}OSAPlugIn.cpp.o"				
	"{ObjectsDir}SelectPartAgent.cpp.o"		
	"{ObjectsDir}SelectPartAgentInit.cpp.o"
	
OpenDocUtilityOBJECTS = 			
	"{ObjectsDir}Except.cpp.o" 					
	"{ObjectsDir}Crawl.cpp.o" 					
	"{ObjectsDir}IText.cpp.o" 					
	"{ObjectsDir}ISOStr.cpp.o" 					
	"{ObjectsDir}ODDebug.cpp.o" 				
	"{ObjectsDir}ODMemory.cpp.o"				
	"{ObjectsDir}ODNew.cpp.o"					
	"{ObjectsDir}ODNewObj.cpp.o"					
	"{ObjectsDir}ODUtils.cpp.o"					
	"{ObjectsDir}PlfmFile.cpp.o" 				
	"{ObjectsDir}PasclStr.cpp.o"				
	"{ObjectsDir}StdTypIO.cpp.o"				
	"{ObjectsDir}TempObj.cpp.o"					
	"{ObjectsDir}UseRsrcM.cpp.o"

#---------------------------------------------------------------------------	
# DEPENDENCIES
#---------------------------------------------------------------------------	

# IDL	

"{SourceDir}"SelectPartAgent.cpp  			
	"{SourceDir}"SelectPartAgent.idl
	
"{SourceDir}"SelectPartAgent.xih 			
	"{SourceDir}"SelectPartAgent.xh			
	"{SourceDir}"SelectPartAgent.idl
	
"{SourceDir}"SelectPartAgent.xh 				
	"{SourceDir}"SelectPartAgent.idl


# SOURCE/OBJECT CODE

"{ObjectsDir}OSAPlugIn.cpp.o"				
	"{SourceDir}OSAPlugIn.cpp"						

"{ObjectsDir}SelectPartAgent.cpp.o"			
	"{SourceDir}SelectPartAgent.cpp" 			
	"{SourceDir}SelectPartAgent.xih" 					

"{ObjectsDir}SelectPartAgentInit.cpp.o"		
	"{SourceDir}SelectPartAgentInit.cpp"

#---------------------------------------------------------------------------	
# BUILD LIBRARIES
#---------------------------------------------------------------------------	

# --- 68k Link ---

"{TargetDir}{TargetNameILink}"  	{OSAPlugInOBJECTS}					
									{OpenDocUtilityOBJECTS}				
									"{SourceDir}SelectPartAgent.exp"
	Echo Linking: {TargetNameILink}
	{LinkTool}	
		-export `ConvertExportList "{SourceDir}SelectPartAgent.exp"`,ODShellPlugInInstall 
		{ILinkOptions}										
		{ILinkShLibOptions}									
		-init SelectPartAgentCFMInit						
		-term SelectPartAgentCFMTerminate					
		-vercur {CurrentLibraryVersion}						
		-verdef {LibraryExportsVersion}						
		-verimp {LibraryCodeVersion}						
		{ShLibPreLibraries}									
		{OSAPlugInOBJECTS}									
		{OpenDocUtilityOBJECTS}								
		"{ODCFMLibrariesDir}OpenDoc Core.stub"				
		"{ODCFMLibrariesDir}OpenDoc User Interface.stub"	
		"{ODCFMLibrariesDir}OpenDoc Layout.stub"			
		"{ODCFMLibrariesDir}OpenDoc Storage.stub"			
		"{ODCFMLibrariesDir}Memory Manager.stub"			
		{ShLibPostLibraries}								
		-o "{ObjectsDir}{TargetNameILink}".seg
	If !{Status}
		Echo Building: {TargetNameILink}.SYM
		{SymTool} "{ObjectsDir}{TargetNameILink}".seg.NJ	
				-o "{TargetDir}{TargetNameILink}".SYM -sym 3.2
		Echo Building: {TargetNameILink}'s code/data fragment
		MakeFlat "{ObjectsDir}{TargetNameILink}".seg -o "{TargetDir}{TargetNameILink}"
		Echo Copying: {TargetNameILink}'s resources
		Echo "include "{RsrcObjectsDir}{TargetName}.68k.rsrc";" | Rez -a -o "{TargetDir}{TargetNameILink}"
		Echo "delete 'ckid';"  | Rez -a -o "{TargetDir}{TargetNameILink}"
		SetFile -a Bi -c "{TargetCreatorType}" {Targ}
	End


# --- PowerPC Link ---

"{TargetDir}{TargetNamePPCLink}" 		{OSAPlugInOBJECTS}					
										{OpenDocUtilityOBJECTS}				
										"{SourceDir}SelectPartAgent.exp"
	Echo Linking: {TargetNamePPCLink}
	{LinkTool}	
		-export `ConvertExportList "{SourceDir}SelectPartAgent.exp"`,ODShellPlugInInstall 
		{PPCLinkOptions}									
		{PPCLinkShLibOptions}								
		-init SelectPartAgentCFMInit						
		-term SelectPartAgentCFMTerminate					
		-vercur {CurrentLibraryVersion}						
		-verdef {LibraryExportsVersion}						
		-verimp {LibraryCodeVersion}						
		{PPCShLibPreLibraries}								
		{OSAPlugInOBJECTS}									
		{OpenDocUtilityOBJECTS}								
		"{ODCFMLibrariesDir}OpenDoc Core.stub"				
		"{ODCFMLibrariesDir}OpenDoc User Interface.stub"	
		"{ODCFMLibrariesDir}OpenDoc Storage.stub"			
		"{ODCFMLibrariesDir}OpenDoc Layout.stub"			
		"{ODCFMLibrariesDir}Memory Manager.stub"			
		{PPCShLibPostLibraries}								
		-o "{ObjectsDir}{TargetNamePPCLink}"
	If !{Status}
		Move "{ObjectsDir}{TargetNamePPCLink}" "{TargetDir}"
		if ( `exists "{ObjectsDir}{TargetNamePPCLink}".xcoff != ""` )
			Echo Building: {TargetNamePPCLink}.xSYM
			{SymTool} "{ObjectsDir}{TargetNamePPCLink}".xcoff			
					{AdditionalIncludes} -i "{ODUtilsImplDir}"			
					-sym on,3.2 -o "{TargetDir}{TargetNamePPCLink}".xSYM
		end
		Echo Copying: {TargetNamePPCLink}'s resources
		Echo "include "{RsrcObjectsDir}{TargetName}.PPC.rsrc";" | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
		Echo "delete 'ckid';"  | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
		SetFile -a Bi -c "{TargetCreatorType}" {Targ}
	End

#---------------------------------------------------------------------------	
# REZ STEPS
#---------------------------------------------------------------------------	

"{RsrcObjectsDir}{TargetName}.PPC.rsrc"									
										"{SourceDir}OSAPlugIn.r"		
										"{SourceDir}OSAPlugInDef.h"		
										"{SourceDir}OSAPlugInVers.h"	
										"{SourceDir}ScriptingPlugIn.rsrc"
	Echo Rezzing: {TargetName}.r (for PPC)
	Rez {RezOptions} {ODRezIntf} "{SourceDir}{TargetName}.r" -o {targ}
	Echo "delete 'ckid';"  | Rez -a -o {Targ}
	SetFile -a i -c "{ResEditCreator}" -t "{ResEditFileType}" {Targ}
	if ( `exists "{TargetDir}{TargetNamePPCLink}" != ""` )
		Echo Copying: {TargetNamePPCLink}'s resources
		Echo "include ""{Targ}"";" | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
	end	

"{RsrcObjectsDir}{TargetName}.68k.rsrc"									
										"{SourceDir}OSAPlugIn.r"		
										"{SourceDir}OSAPlugInDef.h"		
										"{SourceDir}OSAPlugInVers.h"	
										"{SourceDir}ScriptingPlugIn.rsrc"
	Echo Rezzing: {TargetName}.r (for 68k)
	Rez -d _68KBUILD_ {RezOptions} {ODRezIntf} "{SourceDir}{TargetName}.r" -o {Targ} 
	Echo "delete 'ckid';"  | Rez -a -o {Targ}
	SetFile -a i -c "{ResEditCreator}" -t "{ResEditFileType}" {Targ}
	if ( `exists "{TargetDir}{TargetNameILink}" != ""` )
		Echo Copying: {TargetNameILink}'s resources
		Echo "include ""{Targ}"";" | Rez -a -o "{TargetDir}{TargetNameILink}"
	end


