/*-------------------------------------------------------------------------------------
	File:		OSAPlugIn.r

	Contains:	OSAPlugIn Resources

	Written by:	Sue Dumont

	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
-------------------------------------------------------------------------------------*/

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

// -- MPW Rez Includes --

#include "Types.r"
#include "SysTypes.r"
#include "CodeFragmentTypes.r"

// -- OpenDoc Includes --

#ifndef __ODTYPES_R__
#include "ODTypes.r"
#endif

#ifndef SOM_Module_OpenDoc_StdDefs_defined
#include "StdDefs.r"
#endif

// -- OSAPlugIn Includes --

#ifndef _OSAPLUGINDEF_
#include "OSAPlugInDef.h"
#endif

#ifndef _OSAPLUGINVERS_
#include "OSAPlugInVers.h"
#endif

//-------------------------------------------------------------------------------------
// Other resources
//-------------------------------------------------------------------------------------

// This file accesses the resources from the .rsrc file (PICT's and Icons)
include "ScriptingPlugIn.rsrc";

//-------------------------------------------------------------------------------------
// Finder Version Resources
//-------------------------------------------------------------------------------------

// Part's Finder Version Resource

resource 'vers' (1) {
	currentMajorVersion,
	finderMinorVersion,
	developmentStage,
	preReleaseNumber,
	verUS,
	shortVersionStr,
	shortVersionStr",  Apple Computer, Inc. 1994-1995"
};

resource 'vers' (2) {
	currentMajorVersion,
	finderMinorVersion,
	developmentStage,
	preReleaseNumber,
	verUS,
	shortVersionStr,
	"OpenDoc Sample Code"
};

//-------------------------------------------------------------------------------------
// Code Fragment Resource
//-------------------------------------------------------------------------------------

resource 'cfrg' (0) {
	{	/* [1] */
#ifdef _68KBUILD_
		kMotorola,
#else
		kPowerPC,
#endif
		kFullLib,
		currentVersion,
		compatibleVersion,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		kAgentID,				/* this must be the part class ID */
		/* [2] */
#ifdef _68KBUILD_
		kMotorola,
#else
		kPowerPC,
#endif
		kFullLib,
		currentVersion,
		compatibleVersion,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		kAgentPartClassName		/* this must be the part class name */
	}
};

//-------------------------------------------------------------------------------------
// Finder Bundle Information
//-------------------------------------------------------------------------------------

resource 'BNDL' (kPlugInBundle, "PlugIn BNDL") {
	kOSAPlugInOSType,
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'FREF',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, kPlugInFREF,
			/* [2] */
			1, kDocumentFREF
		},
		/* [2] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, kPlugInIcons
		}
	}
};


resource 'FREF' (kPlugInFREF) {
	'shlb', 0, ""
};

resource 'FREF' (kDocumentFREF) {
	kOSAPlugInOSType, 0, ""
};

data 'PUNR' (0, "Owner resource") {
	$"00"
};
