#
#	File:		SelectPart.make
#
#	Contains:	Makefile for OpenDoc SelectPart part
#
#	Written by:	Sue Dumont
#
#	Copyright:	 1994-1995 by Apple Computer, Inc., all rights reserved.
#				

#---------------------------------------------------------------------------	
# PROJECT VARIABLES
#---------------------------------------------------------------------------	

TargetName			= SelectPart
TargetNameILink		= {TargetName} (68k)
TargetNamePPCLink	= {TargetName} (PPC)
TargetNameFat		= {TargetName} (fat)

TargetCreatorType	= RUNR

DataTransferDir			= {TargetDir}DataTransferExt:
SelectPartIncludes	= {TargetDir}Interfaces:CPlusPlus

AdditionalIncludes	= 	-i "{SourceDir}"	-i "{DataTransferDir}"
#						-i "{SelectPartIncludes}"

#---------------------------------------------------------------------------	
# CFM/PEF Version Numbers
#---------------------------------------------------------------------------	
# For detailed instructions on proper CFM/PEF version numbering, see
# Code Fragment Chapter (pg 3-7), Inside Macintosh: PowerPC System Software
#---------------------------------------------------------------------------	

CurrentLibraryVersion =		0x01048000		# 1.0.4 Final
LibraryExportsVersion =		0x00000000		# 0.0
LibraryCodeVersion =		0x00000000		# 0.0

#---------------------------------------------------------------------------	
# DIRECTORY DEPENDENCIES
#---------------------------------------------------------------------------	

"{TargetDir}"   "{SourceDir}"
"{ObjectsDir}"  "{SourceDir}"
"{ObjectsDir}"  "{DataTransferDir}"
"{ObjectsDir}"  "{SourceDir}"
"{ObjectsDir}"  "{ODUtilsImplDir}"

#---------------------------------------------------------------------------	
# ROOT TARGET
#---------------------------------------------------------------------------	

BUILDPPCLINK 	 
	"{CppPrecompiledHeaders}"					
	"{TargetDir}{TargetNamePPCLink}"			
	"{SourceDir}SelectPart.exp"

BUILDILINK  
	"{CppPrecompiledHeaders}"					
	"{TargetDir}{TargetNameILink}"				
	"{SourceDir}SelectPart.exp"

BUILDREZ  
	"{ObjectsDir}{TargetName}.PPC.rsrc"			
	"{ObjectsDir}{TargetName}.68k.rsrc"

BUILDIDL  
	"{SourceDir}SelectPart.xih"				
	"{SourceDir}SelectPart.xh"				
	"{SourceDir}SelectPart.exp"				
	"{DataTransferDir}DataTransferExt.xih"		
	"{DataTransferDir}DataTransferExt.xh"		
	"{DataTransferDir}DataTransferExt.exp"		
	"{DataTransferDir}TextTransferExt.xih"		
	"{DataTransferDir}TextTransferExt.xh"		
	"{DataTransferDir}TextTransferExt.exp"		
	"{SourceDir}PaletteExt.xih"					
	"{SourceDir}PaletteExt.xh"					
	"{SourceDir}PaletteExt.exp"

BUILDPUBIDL 	
	"{SourceDir}SelectPart.xh"				
	"{SourceDir}PaletteExt.xh"
	
#---------------------------------------------------------------------------	
# FILE LIST VARIABLES
#---------------------------------------------------------------------------	

SelectPartOBJECTS = 				
	"{ObjectsDir}SelectPart.cpp.o"			
	"{ObjectsDir}SelectPartUtils.cpp.o"		
	"{ObjectsDir}SelectPartGlobals.cpp.o"		
	"{ObjectsDir}SelectPartInit.cpp.o"		
	"{ObjectsDir}CScripter.cpp.o"				
	"{ObjectsDir}DataTransferExt.cpp.o"			
	"{ObjectsDir}TextTransferExt.cpp.o"			
	"{ObjectsDir}PaletteExt.cpp.o"
	
OpenDocUtilityOBJECTS = 			
	"{ObjectsDir}AltPoint.cpp.o" 				
	"{ObjectsDir}AltPoly.cpp.o" 				
	"{ObjectsDir}BArray.cpp.o" 					
	"{ObjectsDir}Crawl.cpp.o"	 				
	"{ObjectsDir}Except.cpp.o" 					
	"{ObjectsDir}FlipEnd.cpp.o" 				
	"{ObjectsDir}FocusLib.cpp.o" 				
	"{ObjectsDir}IText.cpp.o" 					
	"{ObjectsDir}ISOStr.cpp.o" 					
	"{ObjectsDir}ODDebug.cpp.o" 				
	"{ObjectsDir}ODDesUtl.cpp.o" 				
	"{ObjectsDir}ODMemory.cpp.o"				
	"{ObjectsDir}ODNew.cpp.o"					
	"{ObjectsDir}ODUtils.cpp.o"					
	"{ObjectsDir}PlfmFile.cpp.o" 				
	"{ObjectsDir}PasclStr.cpp.o"				
	"{ObjectsDir}StorUtil.cpp.o"				
	"{ObjectsDir}StdTypIO.cpp.o"				
	"{ObjectsDir}TempObj.cpp.o" 				
	"{ObjectsDir}UseRsrcM.cpp.o" 				
	"{ObjectsDir}WinUtils.cpp.o"

#---------------------------------------------------------------------------	
# DEPENDENCIES
#---------------------------------------------------------------------------	

# IDL

"{SourceDir}"SelectPart.cpp  			
	"{SourceDir}"SelectPart.idl 			
	"{ODIDLIntfDir}"Part.idl
	
"{SourceDir}"SelectPart.xih 				
	"{SourceDir}"SelectPart.xh			
	"{SourceDir}"SelectPart.idl 			
	"{ODIDLIntfDir}"Part.idl
	
"{SourceDir}"SelectPart.xh 				
	"{SourceDir}"SelectPart.idl			
	"{ODIDLIntfDir}"Part.idl

"{DataTransferDir}"DataTransferExt.cpp  	
	"{DataTransferDir}"DataTransferExt.idl 	
	"{ODIDLIntfDir}"Extensn.idl
	
"{DataTransferDir}"DataTransferExt.xih 	
	"{DataTransferDir}"DataTransferExt.xh	
	"{DataTransferDir}"DataTransferExt.idl 	
	"{ODIDLIntfDir}"Extensn.idl
	
"{DataTransferDir}"DataTransferExt.xh 		
	"{DataTransferDir}"DataTransferExt.idl	
	"{ODIDLIntfDir}"Extensn.idl

"{DataTransferDir}"TextTransferExt.cpp  	
	"{DataTransferDir}"TextTransferExt.idl 	
	"{DataTransferDir}"DataTransferExt.idl
	
"{DataTransferDir}"TextTransferExt.xih 	
	"{DataTransferDir}"TextTransferExt.xh	
	"{DataTransferDir}"TextTransferExt.idl 	
	"{DataTransferDir}"DataTransferExt.idl
	
"{DataTransferDir}"TextTransferExt.xh 		
	"{DataTransferDir}"TextTransferExt.idl	
	"{DataTransferDir}"DataTransferExt.idl
	
"{SourceDir}"PaletteExt.cpp  				
	"{SourceDir}"PaletteExt.idl 			
	"{ODIDLIntfDir}"Extensn.idl
	
"{SourceDir}"PaletteExt.xih 				
	"{SourceDir}"PaletteExt.xh				
	"{SourceDir}"PaletteExt.idl 			
	"{ODIDLIntfDir}"Extensn.idl
	
"{SourceDir}"PaletteExt.xh 				
	"{SourceDir}"PaletteExt.idl				
	"{ODIDLIntfDir}"Extensn.idl

# SOURCE/OBJECT CODE

"{ObjectsDir}SelectPartInit.cpp.o"				
	"{CppPrecompiledHeaders}"						
	"{SourceDir}SelectPartInit.cpp"				
	"{SourceDir}SelectPart.xh"

"{ObjectsDir}SelectPart.cpp.o"					
	"{SourceDir}SelectPart.cpp" 					
	"{SourceDir}SelectPart.xih" 					
	"{SourceDir}SelectPartDef.h"					
	"{SourceDir}SelectPartUtils.h"				
	"{SourceDir}CScripter.h"

"{ObjectsDir}SelectPartUtils.cpp.o"				
	"{SourceDir}SelectPartUtils.cpp"				
	"{SourceDir}SelectPartUtils.h"				

"{ObjectsDir}DataTransferExt.cpp.o"					
	"{DataTransferDir}DataTransferExt.cpp" 			
	"{DataTransferDir}DataTransferExt.xih" 					

"{ObjectsDir}TextTransferExt.cpp.o"					
	"{DataTransferDir}TextTransferExt.cpp" 			
	"{DataTransferDir}TextTransferExt.xih" 					

"{ObjectsDir}CScripter.cpp.o"						
	"{SourceDir}CScripter.cpp" 					
	"{SourceDir}CScripter.h" 				

"{ObjectsDir}PaletteExt.cpp.o"						
	"{SourceDir}PaletteExt.cpp" 					
	"{SourceDir}PaletteExt.xih" 					

#---------------------------------------------------------------------------	
# BUILD LIBRARIES
#---------------------------------------------------------------------------	

# --- 68k Link ---

"{TargetDir}{TargetNameILink}"  	{SelectPartOBJECTS}			
									{OpenDocUtilityOBJECTS}			
									"{SourceDir}SelectPart.exp"
	Echo Linking: {TargetNameILink}
	{LinkTool}	
		-export `ConvertExportList "{SourceDir}SelectPart.exp"`,`ConvertExportList "{SourceDir}PaletteExt.exp"`,`ConvertExportList "{DataTransferDir}DataTransferExt.exp"`,`ConvertExportList "{DataTransferDir}TextTransferExt.exp"`	
		{ILinkOptions}										
		{ILinkShLibOptions}									
		-init SelectPartCFMInit							
		-term SelectPartCFMTerminate						
		-vercur {CurrentLibraryVersion}						
		-verdef {LibraryExportsVersion}						
		-verimp {LibraryCodeVersion}						
		{ShLibPreLibraries}									
		{SelectPartOBJECTS}								
		{OpenDocUtilityOBJECTS}								
		"{ODCFMLibrariesDir}OpenDoc Core.stub"				
		"{ODCFMLibrariesDir}OpenDoc User Interface.stub"	
		"{ODCFMLibrariesDir}OpenDoc Storage.stub"			
		"{ODCFMLibrariesDir}OpenDoc Imaging.stub"			
		"{ODCFMLibrariesDir}OpenDoc Layout.stub"			
		"{ODCFMLibrariesDir}Memory Manager.stub"			
		"{ODCFMLibrariesDir}OpenDoc Messaging.stub"			
		"{SharedLIbraries}AppleScriptLib"					
		{ShLibPostLibraries}								
		-o "{ObjectsDir}{TargetNameILink}".seg
	If !{Status}
		Echo Building: {TargetNameILink}.SYM
		{SymTool} "{ObjectsDir}{TargetNameILink}".seg.NJ	
				-o "{TargetDir}{TargetNameILink}".SYM -sym 3.2
		Echo Building: {TargetNameILink}'s code/data fragment
		MakeFlat "{ObjectsDir}{TargetNameILink}".seg -o "{TargetDir}{TargetNameILink}"
		Echo Copying: {TargetNameILink}'s resources
		Echo "include "{RsrcObjectsDir}{TargetName}.68k.rsrc";" | Rez -a -o "{TargetDir}{TargetNameILink}"
		Echo "delete 'ckid';"  | Rez -a -o "{TargetDir}{TargetNameILink}"
		SetFile -a Bi -c "{TargetCreatorType}" {Targ}
	End

# --- PowerPC Link ---

"{TargetDir}{TargetNamePPCLink}" 		{SelectPartOBJECTS}			
										{OpenDocUtilityOBJECTS}			
										"{SourceDir}SelectPart.exp"	
										"{DataTransferDir}TextTransferExt.exp"
	Echo Linking: {TargetNamePPCLink}
	{LinkTool}	
		-export `ConvertExportList "{SourceDir}SelectPart.exp"`,`ConvertExportList "{SourceDir}PaletteExt.exp"`,`ConvertExportList "{DataTransferDir}DataTransferExt.exp"`,`ConvertExportList "{DataTransferDir}TextTransferExt.exp"`	
		{PPCLinkOptions}									
		{PPCLinkShLibOptions}								
		-init SelectPartCFMInit							
		-term SelectPartCFMTerminate						
		-vercur {CurrentLibraryVersion}						
		-verdef {LibraryExportsVersion}						
		-verimp {LibraryCodeVersion}						
		{PPCShLibPreLibraries}								
		{SelectPartOBJECTS}								
		{OpenDocUtilityOBJECTS}								
		"{ODCFMLibrariesDir}OpenDoc Core.stub"				
		"{ODCFMLibrariesDir}OpenDoc User Interface.stub"	
		"{ODCFMLibrariesDir}OpenDoc Storage.stub"			
		"{ODCFMLibrariesDir}OpenDoc Imaging.stub"			
		"{ODCFMLibrariesDir}OpenDoc Layout.stub"			
		"{ODCFMLibrariesDir}Memory Manager.stub"			
		"{ODCFMLibrariesDir}OpenDoc Messaging.stub"			
		{PPCShLibPostLibraries}								
		-o "{ObjectsDir}{TargetNamePPCLink}"
	If !{Status}
		Move "{ObjectsDir}{TargetNamePPCLink}" "{TargetDir}"
		if ( `exists "{ObjectsDir}{TargetNamePPCLink}".xcoff != ""` )
			Echo Building: {TargetNamePPCLink}.xSYM
			{SymTool} "{ObjectsDir}{TargetNamePPCLink}".xcoff			
					{AdditionalIncludes} -i "{ODUtilsImplDir}"			
					-sym on,3.2 -o "{TargetDir}{TargetNamePPCLink}".xSYM
		end
		Echo Copying: {TargetNamePPCLink}'s resources
		Echo "include "{RsrcObjectsDir}{TargetName}.PPC.rsrc";" | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
		Echo "delete 'ckid';"  | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
		SetFile -a Bi -c "{TargetCreatorType}" {Targ}
	End

#---------------------------------------------------------------------------	
# REZ STEPS
#---------------------------------------------------------------------------	

"{RsrcObjectsDir}{TargetName}.PPC.rsrc"									
										"{SourceDir}SelectPart.r"		
										"{SourceDir}SelectPartDef.h"	
										"{SourceDir}SelectPartVers.h"	
										"{SourceDir}SelectPartOtherResources.rsrc"
	Echo Rezzing: {TargetName}.r (for PPC)
	Rez {RezOptions} {ODRezIntf} "{SourceDir}{TargetName}.r" -o {targ}
	Echo "delete 'ckid';"  | Rez -a -o {Targ}
	SetFile -a i -c "{ResEditCreator}" -t "{ResEditFileType}" {Targ}
	if ( `exists "{TargetDir}{TargetNamePPCLink}" != ""` )
		Echo Copying: {TargetNamePPCLink}'s resources
		Echo "include ""{Targ}"";" | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
	end	

"{RsrcObjectsDir}{TargetName}.68k.rsrc"									
										"{SourceDir}SelectPart.r"		
										"{SourceDir}SelectPartDef.h"	
										"{SourceDir}SelectPartVers.h"	
										"{SourceDir}SelectPartOtherResources.rsrc"
	Echo Rezzing: {TargetName}.r (for 68k)
	Rez -d _68KBUILD_ {RezOptions} {ODRezIntf} "{SourceDir}{TargetName}.r" -o {Targ} 
	Echo "delete 'ckid';"  | Rez -a -o {Targ}
	SetFile -a i -c "{ResEditCreator}" -t "{ResEditFileType}" {Targ}
	if ( `exists "{TargetDir}{TargetNameILink}" != ""` )
		Echo Copying: {TargetNameILink}'s resources
		Echo "include ""{Targ}"";" | Rez -a -o "{TargetDir}{TargetNameILink}"
	end


