/*------------------------------------------------------------------------------
	File:		GetNameExt.cpp

	Contains:	Palette Extension implementation

	Written by:	Sue Dumont, Andrey Dolgachev
	
	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
------------------------------------------------------------------------------*/

#ifndef _EXCEPT_
#include <Except.h>
#endif

#ifndef _ODNEW_
#include <ODNew.h>
#endif 

#ifndef _ODNEWOBJ_
#include <ODNewObj.h>
#endif

// Notification that this is a SOM source file
#define KSS_GetNameExt_Class_Source

// define underscore field names (ie. _fSelf)
#define VARIABLE_MACROS

// -- GetNameExt Includes --

#ifndef SOM_KSS_GetNameExt_xih
#include "GetNameExt.xih"
#endif

// Needs to be customized for the specific owner part.
#ifndef SOM_KSS_SelectPart_xh
#include "SelectPart.xh"
#endif

// -- OpenDoc Includes --

#ifndef SOM_ODExtension_xh
#include <Extensn.xh>
#endif


#pragma segment GetNameExt

//====================================================================
// GetNameExt - Common extension methods
//====================================================================

//------------------------------------------------------------------------------
// Method:		somInit
//------------------------------------------------------------------------------
SOM_Scope	void
SOMLINK		GetNameExt__somInit(KSS_GetNameExt *somSelf)
{
    KSS_GetNameExtMethodDebug("GetNameExt","somInit");

	// somInit and somUninit methods behave like C++ constructors in that the
	// inherited methods are called automatically.
	// Thus, there is no need to call the parent class' somInit or somUninit.
	
	// There is also no need to set instance variables to zero/NULL
	// since SOM guarantees that a newly constructed object is zeroed.
}

//------------------------------------------------------------------------------
// Method:		somUninit
//------------------------------------------------------------------------------
SOM_Scope	void
SOMLINK		GetNameExt__somUninit(KSS_GetNameExt *somSelf)
{
    KSS_GetNameExtMethodDebug("GetNameExt","somUninit");
}

//------------------------------------------------------------------------------
// Method:		Acquire
//------------------------------------------------------------------------------
SOM_Scope	void
SOMLINK		GetNameExt__Acquire(KSS_GetNameExt *somSelf, Environment *ev)
{
    KSS_GetNameExtMethodDebug("GetNameExt","GetNameExt__Acquire");

	SOM_TRY
		KSS_GetNameExt_parent_ODExtension_Acquire(somSelf, ev);
	SOM_CATCH_ALL
	SOM_ENDTRY
}

//------------------------------------------------------------------------------
// Method:		Release
//------------------------------------------------------------------------------
SOM_Scope	void
SOMLINK		GetNameExt__Release(KSS_GetNameExt *somSelf, Environment *ev)
{
    KSS_GetNameExtMethodDebug("GetNameExt","Release");

	SOM_TRY
		KSS_GetNameExt_parent_ODExtension_Release(somSelf, ev);
	SOM_CATCH_ALL
	SOM_ENDTRY
}

//------------------------------------------------------------------------------
// Method:		InitExtension
//------------------------------------------------------------------------------
SOM_Scope 	void
SOMLINK 	GetNameExt__InitExtension(KSS_GetNameExt *somSelf,
								Environment *ev, ODObject* base)
{
    KSS_GetNameExtData *somThis = KSS_GetNameExtGetData(somSelf);
    KSS_GetNameExtMethodDebug("GetNameExt","InitExtension");

	SOM_TRY
		KSS_GetNameExt_parent_ODExtension_InitExtension(somSelf, ev, base);

		_fOwner = (KSS_SelectPart*) ((ODPart*)base)->GetRealPart(ev);
		((ODPart*)base)->ReleaseRealPart(ev);
	SOM_CATCH_ALL
	SOM_ENDTRY
}

//------------------------------------------------------------------------------
// Method:		GetName
//
// Description:	Get a file name.
//------------------------------------------------------------------------------

SOM_Scope void  SOMLINK GetNameExt__GetName(KSS_GetNameExt *somSelf, Environment *ev)
{
    KSS_GetNameExtData *somThis = KSS_GetNameExtGetData(somSelf);
    KSS_GetNameExtMethodDebug("KSS_GetNameExt","GetNameExt__GetName");

   	SOM_TRY
   		_fOwner->GetName(ev);
	SOM_CATCH_ALL
	SOM_ENDTRY
}

