/*------------------------------------------------------------------------------
	File:		SelectPartGlobals.idl

	Contains:	SelectPart globals

	Written by:	Sue Dumont

	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
------------------------------------------------------------------------------*/

#ifndef _SELECTPARTGLOBALS_
#define _SELECTPARTGLOBALS_

#ifndef SOM_Module_OpenDoc_Global_TypesB_defined
#include <ODTypesB.xh>
#endif

#ifndef SOM_ODExtension_xh
#include <Extensn.xh>
#endif

#ifndef SOM_ODWindow_xh
#include <Window.xh>
#endif

#ifndef SOM_KSS_GetNameExt_xh
#include "GetNameExt.xh"
#endif

#ifndef SOM_TextTransferExt_xh
#include "TextTransferExt.xh"
#endif

#ifndef _CSCRIPTER_
#include "CScripter.h"
#endif

//==============================================================================
// Globals
//==============================================================================

struct SelectPartGlobals; 	// forward

extern	ODUShort				gGlobalsUsageCount;
extern	SelectPartGlobals*	gGlobals;


struct SelectPartGlobals {
	public:
	SelectPartGlobals();
	~SelectPartGlobals() {}
				
	ODTypeToken				fModalFocus;
	ODTypeToken				fFrameView;
	ODTypeToken				fPalettePresentation;
	ODTypeToken				fResultPresentation;
	ODValueType				fTextKind;

	ODPart*					fClient;
	CScripter*				fOSAScripter;
	ODExtension*			fGetNameExtension;
	TextTransferExt*		fTextTransferExt;
	
	ODID					fPaletteID;
	ODID					fResultID;
	ODISOStr				fResultValue;
	ODHandle				fPalette;
	ODHandle				fFloatWindowProc;
	ODHandle				fDisabledRecButton;
	ODHandle				fRecordingOnButton;
	
	ODBoolean				fPaletteVisible;
	ODBoolean				fResultWindowVisible;
	ODBoolean				fResultHidden;
	
	Rect					fPaletteBounds;
	Rect					fResultBounds;
};



inline SelectPartGlobals::SelectPartGlobals()
{
	fModalFocus				= kODNullTypeToken;
	fFrameView				= kODNullTypeToken;
	fPalettePresentation	= kODNullTypeToken;
	fResultPresentation		= kODNullTypeToken;
	fTextKind				= kODNullTypeToken;
	
	fClient					= kODNULL;
	fOSAScripter			= kODNULL;
	fGetNameExtension		= kODNULL;
	fTextTransferExt		= kODNULL;
	fPaletteID				= kODNULLID;
	fResultID				= kODNULLID;
	
	fResultValue			= kODNULL;
	
	fPalette				= kODNULL;	
	fFloatWindowProc		= kODNULL;
	fDisabledRecButton		= kODNULL;
	fRecordingOnButton		= kODNULL;
	
	fPaletteVisible			= kODFalse;
	fResultWindowVisible	= kODFalse;
	
	// This flag is used by the palette to hide
	// the result window when it is being hidden,
	// and then show it again when it is shown. 
	fResultHidden			= kODFalse;
};

#endif
