//
//	BaseWindow.c
//
//	by Edward Voas, Apple Computer, Inc.
//
//	Copyright  1997 Edward Voas, All rights reserved.
//
//	Our base class for windows.
//

#include "BaseWindow.h"

BaseWindow::BaseWindow()
{
	fWindow = nil;
	fMenu = nil;
}

BaseWindow::BaseWindow( SInt16 resID )
{
	fWindow = GetNewCWindow( resID, NULL, (WindowRef)-1L );
	((WindowPeek)fWindow)->windowKind = 2000;
	SetWRefCon( fWindow, (long)this );
	fMenu = nil;
}

BaseWindow::BaseWindow( SInt16 resID, SInt16 menuID )
{
	fWindow = GetNewCWindow( resID, NULL, (WindowRef)-1L );
	((WindowPeek)fWindow)->windowKind = 2000;
	SetWRefCon( fWindow, (long)this );
	fMenu = GetMenu( menuID );
}

BaseWindow::~BaseWindow()
{
	if ( fWindow ) DisposeWindow( fWindow );
	if ( fMenu )
	{
		DeleteMenu( (**fMenu).menuID );
		DisposeMenu( fMenu );
	}
	
}

void
BaseWindow::Idle()
{
}

void
BaseWindow::AdjustMenus()
{
}

void
BaseWindow::HandleMenuSelection( SInt16 menuID, SInt16 itemNo )
{
#pragma unused( menuID, itemNo )
}

void
BaseWindow::Activate( EventRecord& )
{
	if ( fMenu )
	{
		InsertMenu( fMenu, 0 );
		DrawMenuBar();
	}
}

void
BaseWindow::Deactivate( EventRecord& )
{
	if ( fMenu )
	{
		DeleteMenu( (**fMenu).menuID );
		DrawMenuBar();
	}
}

void
BaseWindow::Update( EventRecord& )
{
	BeginUpdate( fWindow );
	Draw();
	EndUpdate( fWindow );
}

void
BaseWindow::Draw()
{
}

void
BaseWindow::HandleKeyDown( EventRecord& )
{
}

void
BaseWindow::Resize( SInt16 width, SInt16 height )
{
	SizeWindow( fWindow, width, height, true );
}

void
BaseWindow::HandleClick( EventRecord& event )
{
#pragma unused( event )
}