//
//	BaseWindow.h
//
//	by Edward Voas, Apple Computer, Inc.
//
//	Copyright  1997 Edward Voas, All rights reserved.
//
//	Our base class for windows.
//

#pragma once

enum
{
	kBaseWindowKind		= 2000
};

class BaseWindow
{
	public:
			BaseWindow();
			BaseWindow( SInt16 resID );
			BaseWindow( SInt16 resID, SInt16 menuID );
		virtual ~BaseWindow();
		
		virtual void		Activate( EventRecord& event );
		virtual void		Deactivate( EventRecord& event );
		virtual void		Update( EventRecord& event );
		virtual void		Draw();
		virtual void		Resize( SInt16 width, SInt16 height );
		virtual void		HandleClick( EventRecord& event );
		virtual void		AdjustMenus();
		virtual void		HandleMenuSelection( SInt16 menuID, SInt16 itemNo );
		virtual void		Idle();
		virtual void		HandleKeyDown( EventRecord& event );
		
	protected:
		WindowRef			fWindow;
		MenuHandle			fMenu;
};
