/*
	File:		ColorPenState.h

	Contains:	Helper routines to save/restore color and pen state.

	Version:	Appearance 1.0

	Author:		Edward Voas

	Copyright:	 1996-1997 by Apple Computer, Inc., all rights reserved.
*/

#ifndef __COLORPENSTATE__
#define __COLORPENSTATE__

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif

struct ColorPenState
{
	RGBColor		foreColor;
	RGBColor		backColor;
	PenState		pen;
	SInt16			textMode;
	PixPatHandle	pnPixPat;
	PixPatHandle	bkPixPat;
	Pattern			bkPat;
	UInt32			fgColor;
	UInt32			bkColor;
};
typedef struct ColorPenState ColorPenState;

#ifdef __cplusplus
extern "C" {
#endif

//	NOTE: The hasColor parameter is going away! Be warned...

extern void		GetColorAndPenState( ColorPenState* state );
extern void		SetColorAndPenState( ColorPenState* state );
extern void		NormalizeColorAndPen();

#ifdef __cplusplus
}
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif

#endif // __COLORPENSTATE__
