
#import "LunchView.h"
#import "LunchObject.h"
#import "LunchChoice.h"

#define	kWidthPerColumn	200.0
#define	kOffset			10.0

@implementation LunchView

- initFrame:(const NXRect *)frm;
{
	[super initFrame:frm];
	choices = [[List alloc] init];
	return self;
}

- free
{
	[choices free];
	return [super free];
}

- (LunchChoice *)getChoice:(const char *)location
{
			int			count;
	const	char		*thisLocation;
			LunchChoice	*thisChoice;
	
	for ( count = [choices count] - 1; count >= 0; count-- )
		{
		thisChoice		= [choices objectAt:count];
		thisLocation 	= [[thisChoice location] cString];
		if ( !strcmp( thisLocation, location ) )
			break;
		}
	if ( count < 0 )
		{
		thisChoice 		= [[LunchChoice alloc] initLocation:location];
		[choices addObject:thisChoice];
		}
	return thisChoice;
}

- updateFrameSize:(int)numberOfColumns
{
	NXRect			theFrame, visibleBounds;
	
	[self getFrame:&theFrame];
	[superview getVisibleRect:&visibleBounds];
	
	if (visibleBounds.size.width < numberOfColumns * kWidthPerColumn)
		theFrame.size.width = numberOfColumns * kWidthPerColumn;
	else
		theFrame.size.width = visibleBounds.size.width;
	[self setFrame:&theFrame];
	return self;
}

- updateLunchList:lunchList;
{
	int				count;
	NSString		*thisLocation;
	LunchObject		*thisHandler;
	LunchChoice		*thisChoice;
	
	[choices freeObjects];
	[LunchChoice ResetMaxValue];
	for (count = [lunchList count] - 1; count >= 0; count--)
		{
		thisHandler 	= [lunchList objectAt:count];
		thisLocation	= [thisHandler wantToEatWhere];
		thisChoice		= [self getChoice:[thisLocation cString]];
		[thisChoice incrementValue];			
		}

	[self updateFrameSize:[choices count]];
	[self display];
	return self;
}

- drawSelf:(const NXRect *)rects :(int)rectCount;
{
	int		count;
	NXRect	thisRect;
	
	PSsetgray( NX_BLACK );
	[[[Font newFont:"Helvetica" size:10.0 matrix:NX_IDENTITYMATRIX] screenFont] set];
	thisRect.origin.y = bounds.origin.y + kOffset*2;
	thisRect.origin.x = bounds.origin.x + kOffset;
	thisRect.size.width = thisRect.size.width + kWidthPerColumn - kOffset*2;
	
	NXEraseRect( rects );
	for ( count = [choices count] - 1; count >= 0; count-- )
		{
			LunchChoice	*thisChoice = [choices objectAt:count];
			
			PSmoveto( 	thisRect.origin.x + kOffset,
						bounds.origin.y + kOffset );
			PSshow( [[thisChoice location] cString] );
			thisRect.size.height = 
					(bounds.size.height - kOffset*3)*
						((float)[thisChoice value])/((float)[LunchChoice MaxValue]);
			NXRectFill( &thisRect );
			thisRect.origin.x += kWidthPerColumn;
		}
	
	return self;
}

@end
