//----------------------------------------------------------------------------------------
// CTidyHeapList_AC.cp
// Copyright  1984-97 by Apple Computer, Inc. All rights reserved.
//----------------------------------------------------------------------------------------

#ifndef __CTidyHeap_AC__
#include "CTidyHeap_AC.h"
#endif

#if qTidyHeap

#ifndef __CTidyHeapList_AC__
#include "CTidyHeapList_AC.h"
#endif
#ifndef __CTidyHeapListItem_AC__
#include "CTidyHeapListItem_AC.h"
#endif

//========================================================================================
// class CTidyHeapList_AC
//========================================================================================

//----------------------------------------------------------------------------------------
// CTidyHeapList_AC constructor
//----------------------------------------------------------------------------------------

CTidyHeapList_AC::CTidyHeapList_AC() : 
fCount(0), 
fHead(NULL), 
fTail(NULL) 
{
}

//----------------------------------------------------------------------------------------
// CTidyHeapList_AC destructor
//----------------------------------------------------------------------------------------

CTidyHeapList_AC::~CTidyHeapList_AC() 
{
}

//----------------------------------------------------------------------------------------
// CTidyHeapList_AC::Push
//----------------------------------------------------------------------------------------

void CTidyHeapList_AC::Push(CTidyHeapListItem_AC* block)
{
	fCount++;
	block->fNext = fHead;
	block->fPrev = NULL;
	
	if( fHead )
		fHead->fPrev = block;
	
	fHead = block;	
	
	if( !fTail )
		fTail = fHead;
		
	block->fList = this;
}

//----------------------------------------------------------------------------------------
// CTidyHeapList_AC::Append
//----------------------------------------------------------------------------------------

void CTidyHeapList_AC::Append(CTidyHeapListItem_AC* block)
{
	fCount++;
	block->fPrev = fTail;
	block->fNext = NULL;
	
	if( fTail )
		fTail->fNext = block;

	fTail = block;
	
	if(!fHead) 
		fHead = fTail;

	block->fList = this;
}

//----------------------------------------------------------------------------------------
// CTidyHeapList_AC::Remove
//----------------------------------------------------------------------------------------

void CTidyHeapList_AC::Remove(CTidyHeapListItem_AC* block)
{
	if(block->InList(this))
	{
		fCount--;
		
		if(block == fHead)
		{
			fHead = fHead->fNext;
				// move head ptr up the chain
			
			if(fHead) fHead->fPrev = NULL;
			else fTail = NULL; // empty list

		}
		else
		if(block == fTail)
		{
			fTail = fTail->fPrev;
				// move tail up chain
				
			if(fTail) fTail->fNext = NULL; 
			else fHead = NULL; // empty list
		}
		else
		{
			block->fPrev->fNext = block->fNext;
			block->fNext->fPrev = block->fPrev;
		}
		
		block->fNext = NULL;
		block->fPrev = NULL;
		block->fList = NULL;
	}
}

#endif