//----------------------------------------------------------------------------------------
// MTidyHeapAllocator_AC.h
// Copyright  1984-97 by Apple Computer, Inc. All rights reserved.
//----------------------------------------------------------------------------------------

#ifndef __CTidyHeap_AC__
#include "CTidyHeap_AC.h"
#endif

#if qTidyHeap

#ifndef __MTidyHeapAllocator_AC__
#include "MTidyHeapAllocator_AC.h"
#endif

//========================================================================================
// class MTidyHeapAllocator_AC
//========================================================================================

//----------------------------------------------------------------------------------------
// MTidyHeapAllocator_AC::operator new
//----------------------------------------------------------------------------------------

#if qDebugTidyHeap
long MTidyHeapAllocator_AC::fgAllocationCounter;
#endif

void* MTidyHeapAllocator_AC::operator new(size_t inSize)
{

	static Boolean firstTime = true;
	if(firstTime)
	{
		firstTime = false;	

		CTidyHeap_AC::Instance(); 
				// Make sure TidyHeap is created.

#if qDebugTidyHeap
		fgAllocationCounter = 1;
#endif		
	}
#if qDebugTidyHeap
	else
		fgAllocationCounter++;
#endif	
	
	return CTidyHeap_AC::GlobalNew(inSize);
}

//----------------------------------------------------------------------------------------
// MTidyHeapAllocator_AC::operator delete
//----------------------------------------------------------------------------------------

void MTidyHeapAllocator_AC::operator delete(void* inPtr)
{
#if qDebugTidyHeap
	fgAllocationCounter--;
#endif
	CTidyHeap_AC::GlobalDelete(inPtr);
}

#endif