//----------------------------------------------------------------------------------------
// TidyHeap Shared Lib
//----------------------------------------------------------------------------------------

#ifndef __CODEFRAGMENTS__
#include <CodeFragments.h>
#endif
#ifndef __TIDYHEAPLIB__
#include "TidyHeapSharedLib.h"
#endif

//========================================================================================
// Prototypes
//========================================================================================

short __initialize(void);
void __terminate(void);

pascal OSErr TIDYHEAPLIB_INIT(CFragInitBlockPtr ibp);
pascal void TIDYHEAPLIB_TERMINATE(void);

//========================================================================================
// Initialization methods
//========================================================================================

TidyHeap_Callback gCallback;

//----------------------------------------------------------------------------------------
// TIDYHEAPLIB_INIT
//----------------------------------------------------------------------------------------

pascal OSErr TIDYHEAPLIB_INIT(CFragInitBlockPtr ibp)
{
	
	gCallback = NULL;
	
	// Shared libraries don't get their static objects initialized correctly without
	// calling __initialize or __CPlusInit for MetroWerks or MrC respectively.
	__initialize();

	return noErr;
}

//----------------------------------------------------------------------------------------
// TIDYHEAPLIB_TERMINATE
//----------------------------------------------------------------------------------------

pascal void TIDYHEAPLIB_TERMINATE(void)
{
	if(gCallback) gCallback();

	__terminate();
}

//----------------------------------------------------------------------------------------
// TIDYHEAPLIB_SETCALLBACK
//----------------------------------------------------------------------------------------

void TIDYHEAPSHAREDLIB_SETCALLBACK(TidyHeap_Callback inCallback)
{
	gCallback = inCallback;
}
