//----------------------------------------------------------------------------------------
// CActionIncrementalNewFailer_AC.h
// Copyright  1984-97 by Apple Computer, Inc. All rights reserved.
//----------------------------------------------------------------------------------------

#ifndef __CActIncrementalNewFailer_AC__
#define __CActIncrementalNewFailer_AC__

#ifndef __CTidyHeapAction_AC__
#include "CTidyHeapAction_AC.h"
#endif
#ifndef __CTidyHeapActions_AC__
#include "CTidyHeapActions_AC.h"
#endif
#ifndef __CTidyHeapPersistantObject_AC__
#include "CTidyHeapPersistantObject_AC.h"
#endif
#ifndef __CTidyHeapFile_AC__
#include "CTidyHeapFile_AC.h"
#endif


//========================================================================================
// class CActionIncrementalNewFailer_AC
//
// This action causes new to fail incrementally. Each time a CActionIncrementalNewFailer_AC is
// instantiated, it saves its current fFailNum out to a file in the root directory of 
// your application. The next time the application is run, this value is read back in
// and the fFailNum is incremented by one so that the next next new will fail.
//
// This should be a global new action.
//
//========================================================================================

class CActionIncrementalNewFailer_AC: 	public MTidyHeapPersistantObject_AC, 
									public CActionMakeNewFail_AC
{
public:
	CActionIncrementalNewFailer_AC();
	
	CActionIncrementalNewFailer_AC(long whenToFail);
	
	virtual ~CActionIncrementalNewFailer_AC();
	
	void Reset(); 
		// Saves 1 out to the file.
	
	virtual void SetFailNum(long inCount);
		// Sets current fail in inCount, Saves out inCount
		
	OSErr GetErr();
		// holds any err from reading/writing to file
	
private:
	
	virtual void Write( CTidyHeapFile_AC * );
	
	virtual void Read( CTidyHeapFile_AC *);
		
	void FetchLastAndIncrement();
		// Called by constructor. Should only call once per app run.
		
private:
	CTidyHeapFile_AC 	fFile;
	OSErr 			fErr;
};

#endif