//----------------------------------------------------------------------------------------
// CTidyHeapBitFlags_AC.h
// Copyright  1984-97 by Apple Computer, Inc. All rights reserved.
//----------------------------------------------------------------------------------------

#ifndef	__CTidyHeapBitFlags_AC__
#define __CTidyHeapBitFlags_AC__

#ifndef __CTidyHeapPersistantObject_AC__
#include "CTidyHeapPersistantObject_AC.h"
#endif

//----------------------------------------------------------------------------------------
// class CTidyHeapBitFlags_AC
//----------------------------------------------------------------------------------------

class CTidyHeapBitFlags_AC : public MTidyHeapPersistantObject_AC
{
public:
	CTidyHeapBitFlags_AC() : fFlags(0) {}

	CTidyHeapBitFlags_AC(long inMask) : fFlags(inMask) {}

	CTidyHeapBitFlags_AC(const CTidyHeapBitFlags_AC& inFlags) : fFlags( inFlags.fFlags ) {}

	virtual ~CTidyHeapBitFlags_AC() {}
	
	
	void SetAllFlags(long inMask) { fFlags = inMask; }

	long GetAllFlags() const { return fFlags; }
	
	
	Boolean TestFlag(unsigned char inFlagNum) const 
		{ return ( fFlags &  (1L << (unsigned long) inFlagNum) ) 
			== (1L << (unsigned long)inFlagNum); }
		// flags are numbered 0-31

	void SetFlag(unsigned char inFlagNum, Boolean toTrue);
	
protected:
	
	virtual void Write( CTidyHeapFile_AC* );
	
	virtual void Read( CTidyHeapFile_AC* );
	
private:
	unsigned long fFlags;
	
};

#endif