//----------------------------------------------------------------------------------------
// CTidyHeapListItem_AC.h
// Copyright  1984-97 by Apple Computer, Inc. All rights reserved.
//----------------------------------------------------------------------------------------

#ifndef __CTidyHeapListItem_AC__
#define __CTidyHeapListItem_AC__


#include "MTidyHeapAllocator_AC.h"

//----------------------------------------------------------------------------------------
// class CTidyHeapListItem_AC
//----------------------------------------------------------------------------------------

class CTidyHeapList_AC;
class CTidyHeapListItem_AC : public MTidyHeapAllocator_AC
{
public:
	CTidyHeapListItem_AC();

	virtual ~CTidyHeapListItem_AC();
	
	CTidyHeapListItem_AC* Next();
	
	Boolean InList(CTidyHeapList_AC*) const;
	
	Boolean InList() const;
	
	CTidyHeapList_AC* GetList() const;
	
private:
	CTidyHeapListItem_AC* 	fNext,
					 * 	fPrev;
					 
	CTidyHeapList_AC* 		fList;
	
	CTidyHeapListItem_AC(const CTidyHeapListItem_AC&);
	CTidyHeapListItem_AC& operator = (const CTidyHeapListItem_AC&);

	friend class CTidyHeapList_AC;
};

//----------------------------------------------------------------------------------------
// inlines
//----------------------------------------------------------------------------------------

inline CTidyHeapListItem_AC::CTidyHeapListItem_AC() 
: 	fNext(NULL), 
	fPrev(NULL), 
	fList(NULL) 
{
}
inline CTidyHeapListItem_AC* CTidyHeapListItem_AC::Next() 
{ 
	return fNext; 
}
inline Boolean CTidyHeapListItem_AC::InList(CTidyHeapList_AC* inList) const 
{ 
	return fList != NULL && fList == inList; 
}
inline Boolean CTidyHeapListItem_AC::InList() const
{
	return fList != NULL;
}
inline CTidyHeapList_AC* CTidyHeapListItem_AC::GetList() const
{
	return fList;
}
inline CTidyHeapListItem_AC::~CTidyHeapListItem_AC() 
{
	if(InList()) fList->Remove(this);
}

#endif