//----------------------------------------------------------------------------------------
// CTidyHeapPrivate_AC.h
// Copyright  1984-97 by Apple Computer, Inc. All rights reserved.
//----------------------------------------------------------------------------------------

#ifndef __CTidyHeap_ACPRIVATE__
#define __CTidyHeap_ACPRIVATE__

class CTidyHeapAction_AC;
class CTidyHeapBlock_AC;

//----------------------------------------------------------------------------------------
// struct BlockHeader
//----------------------------------------------------------------------------------------

typedef struct BlockHeader
{
	CTidyHeapMarker_AC 	fMarker1;
	CTidyHeapBlock_AC* 	fBlockPtr;
	CTidyHeapMarker_AC 	fMarker2;
	long 				fData;	

	BlockHeader() : 
		fMarker1(CTidyHeap_AC::kMarker1), 
		fMarker2(CTidyHeap_AC::kMarker2),
		fBlockPtr(NULL)
		{
		}
} BlockHeader;

//----------------------------------------------------------------------------------------
// struct BlockTrailer
//----------------------------------------------------------------------------------------

typedef struct BlockTrailer
{
	CTidyHeapMarker_AC fMarker3;
	
	BlockTrailer() : fMarker3(CTidyHeap_AC::kMarker3) {}
	
} BlockTrailer;

//----------------------------------------------------------------------------------------
// class TMarker
//----------------------------------------------------------------------------------------

class TMarker
{
public:
	TMarker() { fData = CTidyHeap_AC::kStateData; }
	~TMarker() {}
	
private:
	long fData;
};

//----------------------------------------------------------------------------------------
// inlines
//----------------------------------------------------------------------------------------

inline long CharPtrToLong(char*p)
{
	return *((long*)p);
}	

#endif
