//----------------------------------------------------------------------------------------
// CActionIncrementalNewFailer_AC.cp
// Copyright  1984-97 by Apple Computer, Inc. All rights reserved.
//----------------------------------------------------------------------------------------

#ifndef __CTidyHeap_AC__
#include "CTidyHeap_AC.h"
#endif

#if qTidyHeap

#ifndef __CActIncrementalNewFailer_AC__
#include "CActIncrementalNewFailer_AC.h"
#endif

//========================================================================================
// class CActionIncrementalNewFailer_AC
//========================================================================================

//----------------------------------------------------------------------------------------
// 	CActionIncrementalNewFailer_AC constructor
//----------------------------------------------------------------------------------------

CActionIncrementalNewFailer_AC::CActionIncrementalNewFailer_AC() :
CActionMakeNewFail_AC(0),
fErr(0)
{
	FetchLastAndIncrement();
}

//----------------------------------------------------------------------------------------
// 	CActionIncrementalNewFailer_AC constructor
//----------------------------------------------------------------------------------------

CActionIncrementalNewFailer_AC::CActionIncrementalNewFailer_AC(long whenToFail) :
CActionMakeNewFail_AC(whenToFail),
fErr(0)
{
	SetFailNum(whenToFail);
}

//----------------------------------------------------------------------------------------
// 	CActionIncrementalNewFailer_AC destructor
//----------------------------------------------------------------------------------------

CActionIncrementalNewFailer_AC::~CActionIncrementalNewFailer_AC()
{
}

//----------------------------------------------------------------------------------------
// 	CActionIncrementalNewFailer_AC::Reset
//----------------------------------------------------------------------------------------

void CActionIncrementalNewFailer_AC::Reset()
{
	fNewTally = 0;
	SetFailNum(1);
}

//----------------------------------------------------------------------------------------
// 	CActionIncrementalNewFailer_AC::SetNewCount
//----------------------------------------------------------------------------------------

void CActionIncrementalNewFailer_AC::SetFailNum(long inCount)
{
	fFailNum = inCount;
	
	CTidyHeapFile_AC file;
	file.AppendExtension(".cnt");
	file.WriteObject( *this );
		// write out current fFailNum.
		
}

//----------------------------------------------------------------------------------------
// 	CActionIncrementalNewFailer_AC::FetchLastAndIncrement
//----------------------------------------------------------------------------------------

void CActionIncrementalNewFailer_AC::FetchLastAndIncrement()
{
	fNewTally = 0;
	fFailNum = 0;
	
	CTidyHeapFile_AC file;
	file.AppendExtension(".cnt");
	
	file.ReadObject( *this );
		// read in current value of fFailNum, if it exists.

	fFailNum++;

	file.WriteObject( *this );
		// write out current value of fFailNum
	
}

//----------------------------------------------------------------------------------------
// 	CActionIncrementalNewFailer_AC::Write
//----------------------------------------------------------------------------------------

void CActionIncrementalNewFailer_AC::Write( CTidyHeapFile_AC *inFile )
{
	Str255 str;

	::NumToString( fFailNum, str);
	short len = *str;
	::p2cstr(str);
	
	inFile->Write( (char*) str, len);
	fErr = inFile->GetErr();
}

//----------------------------------------------------------------------------------------
// IsNum
//----------------------------------------------------------------------------------------

inline Boolean IsNum(char inChar)
{
	return inChar >= '0' && inChar <= '9';
}

//----------------------------------------------------------------------------------------
// 	CActionIncrementalNewFailer_AC::Read
//----------------------------------------------------------------------------------------

void CActionIncrementalNewFailer_AC::Read( CTidyHeapFile_AC *inFile)
{
	Str255 str;
	short len = inFile->GetSize();
	inFile->Read( (char*) str, len);
	fErr = inFile->GetErr();
	
	if(!fErr)
	{
		str[len] = '\0';
		
		short count = 0;
		while( str[count] != '\0' )
		{
			if( !IsNum(str[count++]) )
				break;
		}
		
		str[count] = '\0';

		::c2pstr((char*) str);
		::StringToNum( str, &fFailNum );
	}
}

#endif