
//----------------------------------------------------------------------------------------
// CTidyHeapActionsMore_AC.cp
// Copyright  1984-97 by Apple Computer, Inc. All rights reserved.
//----------------------------------------------------------------------------------------

// tidyheap

#ifndef __CTidyHeap_AC__
#include "CTidyHeap_AC.h"
#endif

#if qTidyHeap

#ifndef __CTidyHeapActionsMore_AC__
#include "CTidyHeapActionsMore_AC.h"
#endif
#ifndef __CTidyHeapBlock_AC__
#include "CTidyHeapBlock_AC.h"
#endif

//========================================================================================
// class CActionExcemptUnknownBlocks_AC
//========================================================================================

//----------------------------------------------------------------------------------------
// 	CActionExcemptUnknownBlocks_AC::DoAction
//----------------------------------------------------------------------------------------

void CActionExcemptUnknownBlocks_AC::DoAction(CTidyHeapBlock_AC* inBlock)
{
	if(inBlock->GetLineNum() == 0)
	{
		inBlock->SetExempt(true); 
	}
}

//========================================================================================
// class CActionGarbageIn_AC
//========================================================================================

//----------------------------------------------------------------------------------------
// 	CActionGarbageIn_AC::DoAction
//----------------------------------------------------------------------------------------

void CActionGarbageIn_AC::DoAction(CTidyHeapBlock_AC* inBlock)
{
	char* walker = (char*) inBlock->GetAddress();
	for(long i = 0; i < inBlock->GetSize(); i++)
		*walker++ = kGarbageInValue;
}

//========================================================================================
// class CActionGarbageOut_AC
//========================================================================================

//----------------------------------------------------------------------------------------
// 	CActionGarbageOut_AC::DoAction
//----------------------------------------------------------------------------------------

void CActionGarbageOut_AC::DoAction(CTidyHeapBlock_AC* inBlock)
{
	char* walker = (char*) inBlock->GetAddress();
	for(long i = 0; i < inBlock->GetSize(); i++)
		*walker++ = kGarbageOutValue;
}

//========================================================================================
// class CActionBreakOnUnknownBlock_AC
//========================================================================================

//----------------------------------------------------------------------------------------
// 	CActionBreakOnUnknownBlock_AC::DoAction
//----------------------------------------------------------------------------------------

void CActionBreakOnUnknownBlock_AC::DoAction(CTidyHeapBlock_AC* inBlock)
{
	if(inBlock->GetLineNum() == 0)
		::DebugStr("\pTidyHeap: Breaking on Unknown Block in new or delete.");
}


#endif