//----------------------------------------------------------------------------------------
// CTidyHeapState_AC.cp
// Copyright  1984-97 by Apple Computer, Inc. All rights reserved.
//----------------------------------------------------------------------------------------

#ifndef __CTidyHeap_AC__
#include "CTidyHeap_AC.h"
#endif

#if qTidyHeap

#ifndef __CTidyHeap_ACPRIVATE__
#include "CTidyHeapPrivate_AC.h"
#endif
#ifndef __CTidyHeap_ACSNAPSHOT__
#include "CTidyHeapState_AC.h"
#endif

//========================================================================================
// class CTidyHeapState_AC
//========================================================================================

//----------------------------------------------------------------------------------------
// CTidyHeapAction_AC constructor
//----------------------------------------------------------------------------------------

CTidyHeapState_AC::CTidyHeapState_AC() 
{
	fMarker = new TMarker;
}

//----------------------------------------------------------------------------------------
// CTidyHeapAction_AC destructor
//----------------------------------------------------------------------------------------

CTidyHeapState_AC::~CTidyHeapState_AC()
{
	Verify();
	if(fMarker) delete fMarker;
}

//----------------------------------------------------------------------------------------
// CTidyHeapAction_AC::Verify
//----------------------------------------------------------------------------------------

long CTidyHeapState_AC::Verify()
{
	long outLong = 0;
	
	if(CTidyHeap_AC::Instance() && fMarker) 
	{
		outLong = CTidyHeap_AC::Instance()->VerifyState( *this );
		
		delete fMarker;
		fMarker = NULL;	
	}
	
	return outLong;
}

#endif