/*
 *  BWit.h
 *	Linda McLennan

	COPYRIGHT  1989 Silicon Beach Software, Inc.
	Permission is hereby granted to the purchaser
	to use this source code for the limited
	purpose of producing and distributing compiled
	object files and applications.  The source
	code is and shall remain the sole property of
	Silicon Beach Software, Inc., and except as
	expressly provided, purchaser obtains no
	right, title or interest in the source code.
	Distribution of the un-compiled or text
	versions of this source code is prohibited.
 */

/* interface version number */
#define	verNum				1

/* paint mode constants */
#define paintOpaque			patCopy
#define	paintTransparent	patOr
#define	paintOnBlack		notPatBic
#define	paintInvert			patXor

/* toolAbout return codes */
#define	noAbout			1
#define	textAbout		2

/* values for CursorType */
#define	defaultCursor	0
#define	resourceCursor	1
#define	lineWidthCursor	2
#define	brushCursor		3
#define	passedCursor	4
	
/* values for type of symmetry support */
#define	noSymmetry		0
#define	autoSymmetry	1
#define	passSymmetryPts	2	

/* values for autoPaint */
#define	noAutoPaint		0
#define	autoPaintPt		1
#define	autoPaintLine	2	

/* values for requestCode field */
#define	editBrushes		1
#define	editSICNs		2

/* call selector codes */
#define toolAbout			0

#define	toolSelected		11
#define	toolDblClick		12
#define	toolKeyDown			13
#define	toolMouseDown		14
#define	toolStillDown		15
#define	toolMouseUp			16
#define	toolMenuEvent		17
#define	toolMenuInsert		18
#define	toolMenuDelete		19
#define	toolIdle			20
#define	toolDeselected		21
#define	toolRequestComp		22

typedef	struct
{
	short			toolID;	
	short			spare1;
	short			spare2;
	short			spare3;
	short			spare4;
	short			spare5;
	short			spare6;
	short			spare7;

	Point			newPoint;
	Point			oldPoint;
	Rect			updateRect;
	
	Boolean			mouseIsDown;
	Boolean			shiftIsDown;
	Boolean			cmdIsDown;
	Boolean			optIsDown;
	Boolean			dblClick;
	Boolean			paintMultiple;
	Boolean			fillPatNone;
	Boolean			linePatNone;
	Boolean			changeCursor;
	Boolean			toolActive;
	Boolean			paintCenter;
	Boolean			usesScratch;
	Boolean			usesConstrain;
	Boolean			changeFillPat;
	
	Cursor			newCursor;
	Bits16			curBrush;
	Pattern			curFillPat;
	Handle			curPatList;
	EventRecord		*evntRecPtr;

	short			autoPaint;
	short			cursorType;
	short			symmetry;
	short			spare8;
	short			menuID;
	short			menuItem;

	short			numPts;
	Point			(*mirrorPts)[9][2];

	BitMap			scratchBits;
	BitMap			undoBits;
	Handle			sicnListHdl;
	short			sicnIndex;
	short			requestCode;	
} ToolDataRec, *ToolDataPtr;
